/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var we=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/network","vs/base/common/types","vs/platform/log/common/log","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/map","vs/base/common/platform","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/severity","vs/base/common/extpath","vs/base/common/uuid","vs/platform/registry/common/platform","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostTestingPrivateApi","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testCollection","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/languageSelector","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/configuration/common/configuration","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/editor/common/languages","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/progress/common/progress","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/output/common/output","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/prefixSumComputer","vs/base/common/linkedList","vs/editor/common/core/position","vs/base/common/lazy","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],be=function(Z){for(var e=[],o=0,k=Z.length;o<k;o++)e[o]=we[Z[o]];return e};define(we[42],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function o(k,w){if(!k)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}e.ok=o}),define(we[70],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const o=Object.prototype.hasOwnProperty;function k(N){const b=[];for(let c in N)o.call(N,c)&&b.push(N[c]);return b}e.values=k;function w(N,b){for(let c in N)if(o.call(N,c)&&b({key:c,value:N[c]},function(){delete N[c]})===!1)return}e.forEach=w;function B(N,b){const c=Object.create(null);for(const g of N){const s=b(g);let n=c[s];n||(n=c[s]=[]),n.push(g)}return c}e.groupBy=B;function C(N){const b=Object.create(null);return N&&N.forEach((c,g)=>{b[g]=c}),b}e.fromMap=C;function A(N,b){const c=[],g=[];for(let s of N)b.has(s)||c.push(s);for(let s of b)N.has(s)||g.push(s);return{removed:c,added:g}}e.diffSets=A;function D(N,b){const c=[],g=[];for(let[s,n]of N)b.has(s)||c.push(n);for(let[s,n]of b)N.has(s)||g.push(n);return{removed:c,added:g}}e.diffMaps=D;class F{constructor(){this.map=new Map}add(b,c){let g=this.map.get(b);g||(g=new Set,this.map.set(b,g)),g.add(c)}delete(b,c){const g=this.map.get(b);!g||(g.delete(c),g.size===0&&this.map.delete(b))}forEach(b,c){const g=this.map.get(b);!g||g.forEach(c)}}e.SetMap=F}),define(we[52],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function o(C){return(A,D,F)=>{let N=null,b=null;if(typeof F.value=="function"?(N="value",b=F.value):typeof F.get=="function"&&(N="get",b=F.get),!b)throw new Error("not supported");F[N]=C(b,D)}}e.createDecorator=o;function k(C,A,D){let F=null,N=null;if(typeof D.value=="function"?(F="value",N=D.value,N.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(F="get",N=D.get),!N)throw new Error("not supported");const b=`$memoize$${A}`;D[F]=function(...c){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:N.apply(this,c)}),this[b]}}e.memoize=k;function w(C,A,D){return o((F,N)=>{const b=`$debounce$${N}`,c=`$debounce$result$${N}`;return function(...g){this[c]||(this[c]=D?D():void 0),clearTimeout(this[b]),A&&(this[c]=A(this[c],...g),g=[this[c]]),this[b]=setTimeout(()=>{F.apply(this,g),this[c]=D?D():void 0},C)}})}e.debounce=w;function B(C,A,D){return o((F,N)=>{const b=`$throttle$timer$${N}`,c=`$throttle$result$${N}`,g=`$throttle$lastRun$${N}`,s=`$throttle$pending$${N}`;return function(...n){if(this[c]||(this[c]=D?D():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),A&&(this[c]=A(this[c],...n)),this[s])return;const h=this[g]+C;h<=Date.now()?(this[g]=Date.now(),F.apply(this,[this[c]]),this[c]=D?D():void 0):(this[s]=!0,this[b]=setTimeout(()=>{this[s]=!1,this[g]=Date.now(),F.apply(this,[this[c]]),this[c]=D?D():void 0},h-Date.now()))}})}e.throttle=B}),define(we[53],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(w){this._prefix=w,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(we[100],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(a){a[a.None=0]="None",a[a.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=2]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",a[a.InvalidUnicode=4]="InvalidUnicode",a[a.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",a[a.InvalidCharacter=6]="InvalidCharacter"})(o=e.ScanError||(e.ScanError={}));var k;(function(a){a[a.OpenBraceToken=1]="OpenBraceToken",a[a.CloseBraceToken=2]="CloseBraceToken",a[a.OpenBracketToken=3]="OpenBracketToken",a[a.CloseBracketToken=4]="CloseBracketToken",a[a.CommaToken=5]="CommaToken",a[a.ColonToken=6]="ColonToken",a[a.NullKeyword=7]="NullKeyword",a[a.TrueKeyword=8]="TrueKeyword",a[a.FalseKeyword=9]="FalseKeyword",a[a.StringLiteral=10]="StringLiteral",a[a.NumericLiteral=11]="NumericLiteral",a[a.LineCommentTrivia=12]="LineCommentTrivia",a[a.BlockCommentTrivia=13]="BlockCommentTrivia",a[a.LineBreakTrivia=14]="LineBreakTrivia",a[a.Trivia=15]="Trivia",a[a.Unknown=16]="Unknown",a[a.EOF=17]="EOF"})(k=e.SyntaxKind||(e.SyntaxKind={}));var w;(function(a){a[a.InvalidSymbol=1]="InvalidSymbol",a[a.InvalidNumberFormat=2]="InvalidNumberFormat",a[a.PropertyNameExpected=3]="PropertyNameExpected",a[a.ValueExpected=4]="ValueExpected",a[a.ColonExpected=5]="ColonExpected",a[a.CommaExpected=6]="CommaExpected",a[a.CloseBraceExpected=7]="CloseBraceExpected",a[a.CloseBracketExpected=8]="CloseBracketExpected",a[a.EndOfFileExpected=9]="EndOfFileExpected",a[a.InvalidCommentToken=10]="InvalidCommentToken",a[a.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",a[a.UnexpectedEndOfString=12]="UnexpectedEndOfString",a[a.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",a[a.InvalidUnicode=14]="InvalidUnicode",a[a.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",a[a.InvalidCharacter=16]="InvalidCharacter"})(w=e.ParseErrorCode||(e.ParseErrorCode={}));var B;(function(a){a.DEFAULT={allowTrailingComma:!0}})(B=e.ParseOptions||(e.ParseOptions={}));function C(a,T=!1){let r=0,i=a.length,u="",t=0,l=16,m=0;function f(W){let q=0,K=0;for(;q<W;){const V=a.charCodeAt(r);if(V>=48&&V<=57)K=K*16+V-48;else if(V>=65&&V<=70)K=K*16+V-65+10;else if(V>=97&&V<=102)K=K*16+V-97+10;else break;r++,q++}return q<W&&(K=-1),K}function S(W){r=W,u="",t=0,l=16,m=0}function P(){const W=r;if(a.charCodeAt(r)===48)r++;else for(r++;r<a.length&&F(a.charCodeAt(r));)r++;if(r<a.length&&a.charCodeAt(r)===46)if(r++,r<a.length&&F(a.charCodeAt(r)))for(r++;r<a.length&&F(a.charCodeAt(r));)r++;else return m=3,a.substring(W,r);let q=r;if(r<a.length&&(a.charCodeAt(r)===69||a.charCodeAt(r)===101))if(r++,(r<a.length&&a.charCodeAt(r)===43||a.charCodeAt(r)===45)&&r++,r<a.length&&F(a.charCodeAt(r))){for(r++;r<a.length&&F(a.charCodeAt(r));)r++;q=r}else m=3;return a.substring(W,q)}function $(){let W="",q=r;for(;;){if(r>=i){W+=a.substring(q,r),m=2;break}const K=a.charCodeAt(r);if(K===34){W+=a.substring(q,r),r++;break}if(K===92){if(W+=a.substring(q,r),r++,r>=i){m=2;break}switch(a.charCodeAt(r++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const z=f(4);z>=0?W+=String.fromCharCode(z):m=4;break}default:m=5}q=r;continue}if(K>=0&&K<=31)if(D(K)){W+=a.substring(q,r),m=2;break}else m=6;r++}return W}function L(){if(u="",m=0,t=r,r>=i)return t=i,l=17;let W=a.charCodeAt(r);if(A(W)){do r++,u+=String.fromCharCode(W),W=a.charCodeAt(r);while(A(W));return l=15}if(D(W))return r++,u+=String.fromCharCode(W),W===13&&a.charCodeAt(r)===10&&(r++,u+=`
`),l=14;switch(W){case 123:return r++,l=1;case 125:return r++,l=2;case 91:return r++,l=3;case 93:return r++,l=4;case 58:return r++,l=6;case 44:return r++,l=5;case 34:return r++,u=$(),l=10;case 47:{const q=r-1;if(a.charCodeAt(r+1)===47){for(r+=2;r<i&&!D(a.charCodeAt(r));)r++;return u=a.substring(q,r),l=12}if(a.charCodeAt(r+1)===42){r+=2;const K=i-1;let V=!1;for(;r<K;){if(a.charCodeAt(r)===42&&a.charCodeAt(r+1)===47){r+=2,V=!0;break}r++}return V||(r++,m=1),u=a.substring(q,r),l=13}return u+=String.fromCharCode(W),r++,l=16}case 45:if(u+=String.fromCharCode(W),r++,r===i||!F(a.charCodeAt(r)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=P(),l=11;default:for(;r<i&&v(W);)r++,W=a.charCodeAt(r);if(t!==r){switch(u=a.substring(t,r),u){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return u+=String.fromCharCode(W),r++,l=16}}function v(W){if(A(W)||D(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function H(){let W;do W=L();while(W>=12&&W<=15);return W}return{setPosition:S,getPosition:()=>r,scan:T?H:L,getToken:()=>l,getTokenValue:()=>u,getTokenOffset:()=>t,getTokenLength:()=>r-t,getTokenError:()=>m}}e.createScanner=C;function A(a){return a===32||a===9||a===11||a===12||a===160||a===5760||a>=8192&&a<=8203||a===8239||a===8287||a===12288||a===65279}function D(a){return a===10||a===13||a===8232||a===8233}function F(a){return a>=48&&a<=57}var N;(function(a){a[a.nullCharacter=0]="nullCharacter",a[a.maxAsciiCharacter=127]="maxAsciiCharacter",a[a.lineFeed=10]="lineFeed",a[a.carriageReturn=13]="carriageReturn",a[a.lineSeparator=8232]="lineSeparator",a[a.paragraphSeparator=8233]="paragraphSeparator",a[a.nextLine=133]="nextLine",a[a.space=32]="space",a[a.nonBreakingSpace=160]="nonBreakingSpace",a[a.enQuad=8192]="enQuad",a[a.emQuad=8193]="emQuad",a[a.enSpace=8194]="enSpace",a[a.emSpace=8195]="emSpace",a[a.threePerEmSpace=8196]="threePerEmSpace",a[a.fourPerEmSpace=8197]="fourPerEmSpace",a[a.sixPerEmSpace=8198]="sixPerEmSpace",a[a.figureSpace=8199]="figureSpace",a[a.punctuationSpace=8200]="punctuationSpace",a[a.thinSpace=8201]="thinSpace",a[a.hairSpace=8202]="hairSpace",a[a.zeroWidthSpace=8203]="zeroWidthSpace",a[a.narrowNoBreakSpace=8239]="narrowNoBreakSpace",a[a.ideographicSpace=12288]="ideographicSpace",a[a.mathematicalSpace=8287]="mathematicalSpace",a[a.ogham=5760]="ogham",a[a._=95]="_",a[a.$=36]="$",a[a._0=48]="_0",a[a._1=49]="_1",a[a._2=50]="_2",a[a._3=51]="_3",a[a._4=52]="_4",a[a._5=53]="_5",a[a._6=54]="_6",a[a._7=55]="_7",a[a._8=56]="_8",a[a._9=57]="_9",a[a.a=97]="a",a[a.b=98]="b",a[a.c=99]="c",a[a.d=100]="d",a[a.e=101]="e",a[a.f=102]="f",a[a.g=103]="g",a[a.h=104]="h",a[a.i=105]="i",a[a.j=106]="j",a[a.k=107]="k",a[a.l=108]="l",a[a.m=109]="m",a[a.n=110]="n",a[a.o=111]="o",a[a.p=112]="p",a[a.q=113]="q",a[a.r=114]="r",a[a.s=115]="s",a[a.t=116]="t",a[a.u=117]="u",a[a.v=118]="v",a[a.w=119]="w",a[a.x=120]="x",a[a.y=121]="y",a[a.z=122]="z",a[a.A=65]="A",a[a.B=66]="B",a[a.C=67]="C",a[a.D=68]="D",a[a.E=69]="E",a[a.F=70]="F",a[a.G=71]="G",a[a.H=72]="H",a[a.I=73]="I",a[a.J=74]="J",a[a.K=75]="K",a[a.L=76]="L",a[a.M=77]="M",a[a.N=78]="N",a[a.O=79]="O",a[a.P=80]="P",a[a.Q=81]="Q",a[a.R=82]="R",a[a.S=83]="S",a[a.T=84]="T",a[a.U=85]="U",a[a.V=86]="V",a[a.W=87]="W",a[a.X=88]="X",a[a.Y=89]="Y",a[a.Z=90]="Z",a[a.ampersand=38]="ampersand",a[a.asterisk=42]="asterisk",a[a.at=64]="at",a[a.backslash=92]="backslash",a[a.bar=124]="bar",a[a.caret=94]="caret",a[a.closeBrace=125]="closeBrace",a[a.closeBracket=93]="closeBracket",a[a.closeParen=41]="closeParen",a[a.colon=58]="colon",a[a.comma=44]="comma",a[a.dot=46]="dot",a[a.doubleQuote=34]="doubleQuote",a[a.equals=61]="equals",a[a.exclamation=33]="exclamation",a[a.greaterThan=62]="greaterThan",a[a.lessThan=60]="lessThan",a[a.minus=45]="minus",a[a.openBrace=123]="openBrace",a[a.openBracket=91]="openBracket",a[a.openParen=40]="openParen",a[a.percent=37]="percent",a[a.plus=43]="plus",a[a.question=63]="question",a[a.semicolon=59]="semicolon",a[a.singleQuote=39]="singleQuote",a[a.slash=47]="slash",a[a.tilde=126]="tilde",a[a.backspace=8]="backspace",a[a.formFeed=12]="formFeed",a[a.byteOrderMark=65279]="byteOrderMark",a[a.tab=9]="tab",a[a.verticalTab=11]="verticalTab"})(N||(N={}));function b(a,T){const r=[],i=new Object;let u;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let l=!1;function m(f,S,P,$){t.value=f,t.offset=S,t.length=P,t.type=$,t.colonOffset=void 0,u=t}try{d(a,{onObjectBegin:(f,S)=>{if(T<=f)throw i;u=void 0,l=T>f,r.push("")},onObjectProperty:(f,S,P)=>{if(T<S||(m(f,S,P,"property"),r[r.length-1]=f,T<=S+P))throw i},onObjectEnd:(f,S)=>{if(T<=f)throw i;u=void 0,r.pop()},onArrayBegin:(f,S)=>{if(T<=f)throw i;u=void 0,r.push(0)},onArrayEnd:(f,S)=>{if(T<=f)throw i;u=void 0,r.pop()},onLiteralValue:(f,S,P)=>{if(T<S||(m(f,S,P,E(f)),T<=S+P))throw i},onSeparator:(f,S,P)=>{if(T<=S)throw i;if(f===":"&&u&&u.type==="property")u.colonOffset=S,l=!1,u=void 0;else if(f===","){const $=r[r.length-1];typeof $=="number"?r[r.length-1]=$+1:(l=!0,r[r.length-1]=""),u=void 0}}})}catch(f){if(f!==i)throw f}return{path:r,previousNode:u,isAtPropertyKey:l,matches:f=>{let S=0;for(let P=0;S<f.length&&P<r.length;P++)if(f[S]===r[P]||f[S]==="*")S++;else if(f[S]!=="**")return!1;return S===f.length}}}e.getLocation=b;function c(a,T=[],r=B.DEFAULT){let i=null,u=[];const t=[];function l(f){Array.isArray(u)?u.push(f):i!==null&&(u[i]=f)}return d(a,{onObjectBegin:()=>{const f={};l(f),t.push(u),u=f,i=null},onObjectProperty:f=>{i=f},onObjectEnd:()=>{u=t.pop()},onArrayBegin:()=>{const f=[];l(f),t.push(u),u=f,i=null},onArrayEnd:()=>{u=t.pop()},onLiteralValue:l,onError:(f,S,P)=>{T.push({error:f,offset:S,length:P})}},r),u[0]}e.parse=c;function g(a,T=[],r=B.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(f){i.type==="property"&&(i.length=f-i.offset,i=i.parent)}function t(f){return i.children.push(f),f}d(a,{onObjectBegin:f=>{i=t({type:"object",offset:f,length:-1,parent:i,children:[]})},onObjectProperty:(f,S,P)=>{i=t({type:"property",offset:S,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:f,offset:S,length:P,parent:i})},onObjectEnd:(f,S)=>{i.length=f+S-i.offset,i=i.parent,u(f+S)},onArrayBegin:(f,S)=>{i=t({type:"array",offset:f,length:-1,parent:i,children:[]})},onArrayEnd:(f,S)=>{i.length=f+S-i.offset,i=i.parent,u(f+S)},onLiteralValue:(f,S,P)=>{t({type:E(f),offset:S,length:P,parent:i,value:f}),u(S+P)},onSeparator:(f,S,P)=>{i.type==="property"&&(f===":"?i.colonOffset=S:f===","&&u(S))},onError:(f,S,P)=>{T.push({error:f,offset:S,length:P})}},r);const m=i.children[0];return m&&delete m.parent,m}e.parseTree=g;function s(a,T){if(!a)return;let r=a;for(let i of T)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let u=!1;for(const t of r.children)if(Array.isArray(t.children)&&t.children[0].value===i){r=t.children[1],u=!0;break}if(!u)return}else{const u=i;if(r.type!=="array"||u<0||!Array.isArray(r.children)||u>=r.children.length)return;r=r.children[u]}return r}e.findNodeAtLocation=s;function n(a){if(!a.parent||!a.parent.children)return[];const T=n(a.parent);if(a.parent.type==="property"){const r=a.parent.children[0].value;T.push(r)}else if(a.parent.type==="array"){const r=a.parent.children.indexOf(a);r!==-1&&T.push(r)}return T}e.getNodePath=n;function h(a){switch(a.type){case"array":return a.children.map(h);case"object":{const T=Object.create(null);for(let r of a.children){const i=r.children[1];i&&(T[r.children[0].value]=h(i))}return T}case"null":case"string":case"number":case"boolean":return a.value;default:return}}e.getNodeValue=h;function _(a,T,r=!1){return T>=a.offset&&T<a.offset+a.length||r&&T===a.offset+a.length}e.contains=_;function y(a,T,r=!1){if(_(a,T,r)){const i=a.children;if(Array.isArray(i))for(let u=0;u<i.length&&i[u].offset<=T;u++){const t=y(i[u],T,r);if(t)return t}return a}}e.findNodeAtOffset=y;function d(a,T,r=B.DEFAULT){const i=C(a,!1);function u(he){return he?()=>he(i.getTokenOffset(),i.getTokenLength()):()=>!0}function t(he){return he?ue=>he(ue,i.getTokenOffset(),i.getTokenLength()):()=>!0}const l=u(T.onObjectBegin),m=t(T.onObjectProperty),f=u(T.onObjectEnd),S=u(T.onArrayBegin),P=u(T.onArrayEnd),$=t(T.onLiteralValue),L=t(T.onSeparator),v=u(T.onComment),H=t(T.onError),W=r&&r.disallowComments,q=r&&r.allowTrailingComma;function K(){for(;;){const he=i.scan();switch(i.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:W||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(he){case 12:case 13:W?V(10):v();break;case 16:V(1);break;case 15:case 14:break;default:return he}}}function V(he,ue=[],se=[]){if(H(he),ue.length+se.length>0){let ge=i.getToken();for(;ge!==17;){if(ue.indexOf(ge)!==-1){K();break}else if(se.indexOf(ge)!==-1)break;ge=K()}}}function z(he){const ue=i.getTokenValue();return he?$(ue):m(ue),K(),!0}function ae(){switch(i.getToken()){case 11:{let he=0;try{he=JSON.parse(i.getTokenValue()),typeof he!="number"&&(V(2),he=0)}catch{V(2)}$(he);break}case 7:$(null);break;case 8:$(!0);break;case 9:$(!1);break;default:return!1}return K(),!0}function de(){return i.getToken()!==10?(V(3,[],[2,5]),!1):(z(!1),i.getToken()===6?(L(":"),K(),ce()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function Y(){l(),K();let he=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(he||V(4,[],[]),L(","),K(),i.getToken()===2&&q)break}else he&&V(6,[],[]);de()||V(4,[],[2,5]),he=!0}return f(),i.getToken()!==2?V(7,[2],[]):K(),!0}function ie(){S(),K();let he=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(he||V(4,[],[]),L(","),K(),i.getToken()===4&&q)break}else he&&V(6,[],[]);ce()||V(4,[],[4,5]),he=!0}return P(),i.getToken()!==4?V(8,[4],[]):K(),!0}function ce(){switch(i.getToken()){case 3:return ie();case 1:return Y();case 10:return z(!0);default:return ae()}}return K(),i.getToken()===17?r.allowEmptyContent?!0:(V(4,[],[]),!1):ce()?(i.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=d;function p(a,T){let r=C(a),i=[],u,t=0,l;do switch(l=r.getPosition(),u=r.scan(),u){case 12:case 13:case 17:t!==l&&i.push(a.substring(t,l)),T!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,T)),t=r.getPosition();break}while(u!==17);return i.join("")}e.stripComments=p;function E(a){switch(typeof a){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(a){if(Array.isArray(a))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=E}),function(Z,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(we[101],be([0]),e):(Z=typeof globalThis!="undefined"?globalThis:Z||self,e(Z.marked={}))}(this,function(Z){"use strict";function e(ve,fe){for(var M=0;M<fe.length;M++){var O=fe[M];O.enumerable=O.enumerable||!1,O.configurable=!0,"value"in O&&(O.writable=!0),Object.defineProperty(ve,O.key,O)}}function o(ve,fe,M){return fe&&e(ve.prototype,fe),M&&e(ve,M),Object.defineProperty(ve,"prototype",{writable:!1}),ve}function k(ve,fe){if(!!ve){if(typeof ve=="string")return w(ve,fe);var M=Object.prototype.toString.call(ve).slice(8,-1);if(M==="Object"&&ve.constructor&&(M=ve.constructor.name),M==="Map"||M==="Set")return Array.from(ve);if(M==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(M))return w(ve,fe)}}function w(ve,fe){(fe==null||fe>ve.length)&&(fe=ve.length);for(var M=0,O=new Array(fe);M<fe;M++)O[M]=ve[M];return O}function B(ve,fe){var M=typeof Symbol!="undefined"&&ve[Symbol.iterator]||ve["@@iterator"];if(M)return(M=M.call(ve)).next.bind(M);if(Array.isArray(ve)||(M=k(ve))||fe&&ve&&typeof ve.length=="number"){M&&(ve=M);var O=0;return function(){return O>=ve.length?{done:!0}:{done:!1,value:ve[O++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function C(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=C();function A(ve){Z.defaults=ve}var D=/[&<>"']/,F=/[&<>"']/g,N=/[<>"']|&(?!#?\w+;)/,b=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},g=function(fe){return c[fe]};function s(ve,fe){if(fe){if(D.test(ve))return ve.replace(F,g)}else if(N.test(ve))return ve.replace(b,g);return ve}var n=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function h(ve){return ve.replace(n,function(fe,M){return M=M.toLowerCase(),M==="colon"?":":M.charAt(0)==="#"?M.charAt(1)==="x"?String.fromCharCode(parseInt(M.substring(2),16)):String.fromCharCode(+M.substring(1)):""})}var _=/(^|[^\[])\^/g;function y(ve,fe){ve=ve.source||ve,fe=fe||"";var M={replace:function(I,R){return R=R.source||R,R=R.replace(_,"$1"),ve=ve.replace(I,R),M},getRegex:function(){return new RegExp(ve,fe)}};return M}var d=/[^\w:]/g,p=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function E(ve,fe,M){if(ve){var O;try{O=decodeURIComponent(h(M)).replace(d,"").toLowerCase()}catch{return null}if(O.indexOf("javascript:")===0||O.indexOf("vbscript:")===0||O.indexOf("data:")===0)return null}fe&&!p.test(M)&&(M=u(fe,M));try{M=encodeURI(M).replace(/%25/g,"%")}catch{return null}return M}var a={},T=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(ve,fe){a[" "+ve]||(T.test(ve)?a[" "+ve]=ve+"/":a[" "+ve]=f(ve,"/",!0)),ve=a[" "+ve];var M=ve.indexOf(":")===-1;return fe.substring(0,2)==="//"?M?fe:ve.replace(r,"$1")+fe:fe.charAt(0)==="/"?M?fe:ve.replace(i,"$1")+fe:ve+fe}var t={exec:function(){}};function l(ve){for(var fe=1,M,O;fe<arguments.length;fe++){M=arguments[fe];for(O in M)Object.prototype.hasOwnProperty.call(M,O)&&(ve[O]=M[O])}return ve}function m(ve,fe){var M=ve.replace(/\|/g,function(R,x,Q){for(var ne=!1,Ee=x;--Ee>=0&&Q[Ee]==="\\";)ne=!ne;return ne?"|":" |"}),O=M.split(/ \|/),I=0;if(O[0].trim()||O.shift(),O[O.length-1].trim()||O.pop(),O.length>fe)O.splice(fe);else for(;O.length<fe;)O.push("");for(;I<O.length;I++)O[I]=O[I].trim().replace(/\\\|/g,"|");return O}function f(ve,fe,M){var O=ve.length;if(O===0)return"";for(var I=0;I<O;){var R=ve.charAt(O-I-1);if(R===fe&&!M)I++;else if(R!==fe&&M)I++;else break}return ve.substr(0,O-I)}function S(ve,fe){if(ve.indexOf(fe[1])===-1)return-1;for(var M=ve.length,O=0,I=0;I<M;I++)if(ve[I]==="\\")I++;else if(ve[I]===fe[0])O++;else if(ve[I]===fe[1]&&(O--,O<0))return I;return-1}function P(ve){ve&&ve.sanitize&&!ve.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function $(ve,fe){if(fe<1)return"";for(var M="";fe>1;)fe&1&&(M+=ve),fe>>=1,ve+=ve;return M+ve}function L(ve,fe,M,O){var I=fe.href,R=fe.title?s(fe.title):null,x=ve[1].replace(/\\([\[\]])/g,"$1");if(ve[0].charAt(0)!=="!"){O.state.inLink=!0;var Q={type:"link",raw:M,href:I,title:R,text:x,tokens:O.inlineTokens(x,[])};return O.state.inLink=!1,Q}else return{type:"image",raw:M,href:I,title:R,text:s(x)}}function v(ve,fe){var M=ve.match(/^(\s+)(?:```)/);if(M===null)return fe;var O=M[1];return fe.split(`
`).map(function(I){var R=I.match(/^\s+/);if(R===null)return I;var x=R[0];return x.length>=O.length?I.slice(O.length):I}).join(`
`)}var H=function(){function ve(M){this.options=M||Z.defaults}var fe=ve.prototype;return fe.space=function(O){var I=this.rules.block.newline.exec(O);if(I&&I[0].length>0)return{type:"space",raw:I[0]}},fe.code=function(O){var I=this.rules.block.code.exec(O);if(I){var R=I[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:I[0],codeBlockStyle:"indented",text:this.options.pedantic?R:f(R,`
`)}}},fe.fences=function(O){var I=this.rules.block.fences.exec(O);if(I){var R=I[0],x=v(R,I[3]||"");return{type:"code",raw:R,lang:I[2]?I[2].trim():I[2],text:x}}},fe.heading=function(O){var I=this.rules.block.heading.exec(O);if(I){var R=I[2].trim();if(/#$/.test(R)){var x=f(R,"#");(this.options.pedantic||!x||/ $/.test(x))&&(R=x.trim())}var Q={type:"heading",raw:I[0],depth:I[1].length,text:R,tokens:[]};return this.lexer.inline(Q.text,Q.tokens),Q}},fe.hr=function(O){var I=this.rules.block.hr.exec(O);if(I)return{type:"hr",raw:I[0]}},fe.blockquote=function(O){var I=this.rules.block.blockquote.exec(O);if(I){var R=I[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:I[0],tokens:this.lexer.blockTokens(R,[]),text:R}}},fe.list=function(O){var I=this.rules.block.list.exec(O);if(I){var R,x,Q,ne,Ee,Ie,Me,Le,ze,Be,Ae,Qe,tt=I[1].trim(),ke=tt.length>1,it={type:"list",raw:"",ordered:ke,start:ke?+tt.slice(0,-1):"",loose:!1,items:[]};tt=ke?"\\d{1,9}\\"+tt.slice(-1):"\\"+tt,this.options.pedantic&&(tt=ke?tt:"[*+-]");for(var X=new RegExp("^( {0,3}"+tt+")((?: [^\\n]*)?(?:\\n|$))");O&&(Qe=!1,!(!(I=X.exec(O))||this.rules.block.hr.test(O)));){if(R=I[0],O=O.substring(R.length),Le=I[2].split(`
`,1)[0],ze=O.split(`
`,1)[0],this.options.pedantic?(ne=2,Ae=Le.trimLeft()):(ne=I[2].search(/[^ ]/),ne=ne>4?1:ne,Ae=Le.slice(ne),ne+=I[1].length),Ie=!1,!Le&&/^ *$/.test(ze)&&(R+=ze+`
`,O=O.substring(ze.length+1),Qe=!0),!Qe)for(var J=new RegExp("^ {0,"+Math.min(3,ne-1)+"}(?:[*+-]|\\d{1,9}[.)])");O&&(Be=O.split(`
`,1)[0],Le=Be,this.options.pedantic&&(Le=Le.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!J.test(Le));){if(Le.search(/[^ ]/)>=ne||!Le.trim())Ae+=`
`+Le.slice(ne);else if(!Ie)Ae+=`
`+Le;else break;!Ie&&!Le.trim()&&(Ie=!0),R+=Be+`
`,O=O.substring(Be.length+1)}it.loose||(Me?it.loose=!0:/\n *\n *$/.test(R)&&(Me=!0)),this.options.gfm&&(x=/^\[[ xX]\] /.exec(Ae),x&&(Q=x[0]!=="[ ] ",Ae=Ae.replace(/^\[[ xX]\] +/,""))),it.items.push({type:"list_item",raw:R,task:!!x,checked:Q,loose:!1,text:Ae}),it.raw+=R}it.items[it.items.length-1].raw=R.trimRight(),it.items[it.items.length-1].text=Ae.trimRight(),it.raw=it.raw.trimRight();var le=it.items.length;for(Ee=0;Ee<le;Ee++){this.lexer.state.top=!1,it.items[Ee].tokens=this.lexer.blockTokens(it.items[Ee].text,[]);var Oe=it.items[Ee].tokens.filter(function(Ge){return Ge.type==="space"}),$e=Oe.every(function(Ge){for(var Je=Ge.raw.split(""),ht=0,It=B(Je),St;!(St=It()).done;){var kt=St.value;if(kt===`
`&&(ht+=1),ht>1)return!0}return!1});!it.loose&&Oe.length&&$e&&(it.loose=!0,it.items[Ee].loose=!0)}return it}},fe.html=function(O){var I=this.rules.block.html.exec(O);if(I){var R={type:"html",raw:I[0],pre:!this.options.sanitizer&&(I[1]==="pre"||I[1]==="script"||I[1]==="style"),text:I[0]};return this.options.sanitize&&(R.type="paragraph",R.text=this.options.sanitizer?this.options.sanitizer(I[0]):s(I[0]),R.tokens=[],this.lexer.inline(R.text,R.tokens)),R}},fe.def=function(O){var I=this.rules.block.def.exec(O);if(I){I[3]&&(I[3]=I[3].substring(1,I[3].length-1));var R=I[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:R,raw:I[0],href:I[2],title:I[3]}}},fe.table=function(O){var I=this.rules.block.table.exec(O);if(I){var R={type:"table",header:m(I[1]).map(function(Me){return{text:Me}}),align:I[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:I[3]?I[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(R.header.length===R.align.length){R.raw=I[0];var x=R.align.length,Q,ne,Ee,Ie;for(Q=0;Q<x;Q++)/^ *-+: *$/.test(R.align[Q])?R.align[Q]="right":/^ *:-+: *$/.test(R.align[Q])?R.align[Q]="center":/^ *:-+ *$/.test(R.align[Q])?R.align[Q]="left":R.align[Q]=null;for(x=R.rows.length,Q=0;Q<x;Q++)R.rows[Q]=m(R.rows[Q],R.header.length).map(function(Me){return{text:Me}});for(x=R.header.length,ne=0;ne<x;ne++)R.header[ne].tokens=[],this.lexer.inlineTokens(R.header[ne].text,R.header[ne].tokens);for(x=R.rows.length,ne=0;ne<x;ne++)for(Ie=R.rows[ne],Ee=0;Ee<Ie.length;Ee++)Ie[Ee].tokens=[],this.lexer.inlineTokens(Ie[Ee].text,Ie[Ee].tokens);return R}}},fe.lheading=function(O){var I=this.rules.block.lheading.exec(O);if(I){var R={type:"heading",raw:I[0],depth:I[2].charAt(0)==="="?1:2,text:I[1],tokens:[]};return this.lexer.inline(R.text,R.tokens),R}},fe.paragraph=function(O){var I=this.rules.block.paragraph.exec(O);if(I){var R={type:"paragraph",raw:I[0],text:I[1].charAt(I[1].length-1)===`
`?I[1].slice(0,-1):I[1],tokens:[]};return this.lexer.inline(R.text,R.tokens),R}},fe.text=function(O){var I=this.rules.block.text.exec(O);if(I){var R={type:"text",raw:I[0],text:I[0],tokens:[]};return this.lexer.inline(R.text,R.tokens),R}},fe.escape=function(O){var I=this.rules.inline.escape.exec(O);if(I)return{type:"escape",raw:I[0],text:s(I[1])}},fe.tag=function(O){var I=this.rules.inline.tag.exec(O);if(I)return!this.lexer.state.inLink&&/^<a /i.test(I[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(I[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(I[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(I[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:I[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(I[0]):s(I[0]):I[0]}},fe.link=function(O){var I=this.rules.inline.link.exec(O);if(I){var R=I[2].trim();if(!this.options.pedantic&&/^</.test(R)){if(!/>$/.test(R))return;var x=f(R.slice(0,-1),"\\");if((R.length-x.length)%2==0)return}else{var Q=S(I[2],"()");if(Q>-1){var ne=I[0].indexOf("!")===0?5:4,Ee=ne+I[1].length+Q;I[2]=I[2].substring(0,Q),I[0]=I[0].substring(0,Ee).trim(),I[3]=""}}var Ie=I[2],Me="";if(this.options.pedantic){var Le=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ie);Le&&(Ie=Le[1],Me=Le[3])}else Me=I[3]?I[3].slice(1,-1):"";return Ie=Ie.trim(),/^</.test(Ie)&&(this.options.pedantic&&!/>$/.test(R)?Ie=Ie.slice(1):Ie=Ie.slice(1,-1)),L(I,{href:Ie&&Ie.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},I[0],this.lexer)}},fe.reflink=function(O,I){var R;if((R=this.rules.inline.reflink.exec(O))||(R=this.rules.inline.nolink.exec(O))){var x=(R[2]||R[1]).replace(/\s+/g," ");if(x=I[x.toLowerCase()],!x||!x.href){var Q=R[0].charAt(0);return{type:"text",raw:Q,text:Q}}return L(R,x,R[0],this.lexer)}},fe.emStrong=function(O,I,R){R===void 0&&(R="");var x=this.rules.inline.emStrong.lDelim.exec(O);if(!!x&&!(x[3]&&R.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Q=x[1]||x[2]||"";if(!Q||Q&&(R===""||this.rules.inline.punctuation.exec(R))){var ne=x[0].length-1,Ee,Ie,Me=ne,Le=0,ze=x[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ze.lastIndex=0,I=I.slice(-1*O.length+ne);(x=ze.exec(I))!=null;)if(Ee=x[1]||x[2]||x[3]||x[4]||x[5]||x[6],!!Ee){if(Ie=Ee.length,x[3]||x[4]){Me+=Ie;continue}else if((x[5]||x[6])&&ne%3&&!((ne+Ie)%3)){Le+=Ie;continue}if(Me-=Ie,!(Me>0)){if(Ie=Math.min(Ie,Ie+Me+Le),Math.min(ne,Ie)%2){var Be=O.slice(1,ne+x.index+Ie);return{type:"em",raw:O.slice(0,ne+x.index+Ie+1),text:Be,tokens:this.lexer.inlineTokens(Be,[])}}var Ae=O.slice(2,ne+x.index+Ie-1);return{type:"strong",raw:O.slice(0,ne+x.index+Ie+1),text:Ae,tokens:this.lexer.inlineTokens(Ae,[])}}}}}},fe.codespan=function(O){var I=this.rules.inline.code.exec(O);if(I){var R=I[2].replace(/\n/g," "),x=/[^ ]/.test(R),Q=/^ /.test(R)&&/ $/.test(R);return x&&Q&&(R=R.substring(1,R.length-1)),R=s(R,!0),{type:"codespan",raw:I[0],text:R}}},fe.br=function(O){var I=this.rules.inline.br.exec(O);if(I)return{type:"br",raw:I[0]}},fe.del=function(O){var I=this.rules.inline.del.exec(O);if(I)return{type:"del",raw:I[0],text:I[2],tokens:this.lexer.inlineTokens(I[2],[])}},fe.autolink=function(O,I){var R=this.rules.inline.autolink.exec(O);if(R){var x,Q;return R[2]==="@"?(x=s(this.options.mangle?I(R[1]):R[1]),Q="mailto:"+x):(x=s(R[1]),Q=x),{type:"link",raw:R[0],text:x,href:Q,tokens:[{type:"text",raw:x,text:x}]}}},fe.url=function(O,I){var R;if(R=this.rules.inline.url.exec(O)){var x,Q;if(R[2]==="@")x=s(this.options.mangle?I(R[0]):R[0]),Q="mailto:"+x;else{var ne;do ne=R[0],R[0]=this.rules.inline._backpedal.exec(R[0])[0];while(ne!==R[0]);x=s(R[0]),R[1]==="www."?Q="http://"+x:Q=x}return{type:"link",raw:R[0],text:x,href:Q,tokens:[{type:"text",raw:x,text:x}]}}},fe.inlineText=function(O,I){var R=this.rules.inline.text.exec(O);if(R){var x;return this.lexer.state.inRawBlock?x=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(R[0]):s(R[0]):R[0]:x=s(this.options.smartypants?I(R[0]):R[0]),{type:"text",raw:R[0],text:x}}},ve}(),W={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};W._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,W._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,W.def=y(W.def).replace("label",W._label).replace("title",W._title).getRegex(),W.bullet=/(?:[*+-]|\d{1,9}[.)])/,W.listItemStart=y(/^( *)(bull) */).replace("bull",W.bullet).getRegex(),W.list=y(W.list).replace(/bull/g,W.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+W.def.source+")").getRegex(),W._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",W._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,W.html=y(W.html,"i").replace("comment",W._comment).replace("tag",W._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),W.paragraph=y(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.blockquote=y(W.blockquote).replace("paragraph",W.paragraph).getRegex(),W.normal=l({},W),W.gfm=l({},W.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),W.gfm.table=y(W.gfm.table).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.gfm.paragraph=y(W._paragraph).replace("hr",W.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",W.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",W._tag).getRegex(),W.pedantic=l({},W.normal,{html:y(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",W._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:y(W.normal._paragraph).replace("hr",W.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",W.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var q={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};q._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",q.punctuation=y(q.punctuation).replace(/punctuation/g,q._punctuation).getRegex(),q.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,q.escapedEmSt=/\\\*|\\_/g,q._comment=y(W._comment).replace("(?:-->|$)","-->").getRegex(),q.emStrong.lDelim=y(q.emStrong.lDelim).replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimAst=y(q.emStrong.rDelimAst,"g").replace(/punct/g,q._punctuation).getRegex(),q.emStrong.rDelimUnd=y(q.emStrong.rDelimUnd,"g").replace(/punct/g,q._punctuation).getRegex(),q._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,q._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,q._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,q.autolink=y(q.autolink).replace("scheme",q._scheme).replace("email",q._email).getRegex(),q._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,q.tag=y(q.tag).replace("comment",q._comment).replace("attribute",q._attribute).getRegex(),q._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,q._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,q._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,q.link=y(q.link).replace("label",q._label).replace("href",q._href).replace("title",q._title).getRegex(),q.reflink=y(q.reflink).replace("label",q._label).replace("ref",W._label).getRegex(),q.nolink=y(q.nolink).replace("ref",W._label).getRegex(),q.reflinkSearch=y(q.reflinkSearch,"g").replace("reflink",q.reflink).replace("nolink",q.nolink).getRegex(),q.normal=l({},q),q.pedantic=l({},q.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:y(/^!?\[(label)\]\((.*?)\)/).replace("label",q._label).getRegex(),reflink:y(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",q._label).getRegex()}),q.gfm=l({},q.normal,{escape:y(q.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),q.gfm.url=y(q.gfm.url,"i").replace("email",q.gfm._extended_email).getRegex(),q.breaks=l({},q.gfm,{br:y(q.br).replace("{2,}","*").getRegex(),text:y(q.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(ve){return ve.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(ve){var fe="",M,O,I=ve.length;for(M=0;M<I;M++)O=ve.charCodeAt(M),Math.random()>.5&&(O="x"+O.toString(16)),fe+="&#"+O+";";return fe}var z=function(){function ve(M){this.tokens=[],this.tokens.links=Object.create(null),this.options=M||Z.defaults,this.options.tokenizer=this.options.tokenizer||new H,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var O={block:W.normal,inline:q.normal};this.options.pedantic?(O.block=W.pedantic,O.inline=q.pedantic):this.options.gfm&&(O.block=W.gfm,this.options.breaks?O.inline=q.breaks:O.inline=q.gfm),this.tokenizer.rules=O}ve.lex=function(O,I){var R=new ve(I);return R.lex(O)},ve.lexInline=function(O,I){var R=new ve(I);return R.inlineTokens(O)};var fe=ve.prototype;return fe.lex=function(O){O=O.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(O,this.tokens);for(var I;I=this.inlineQueue.shift();)this.inlineTokens(I.src,I.tokens);return this.tokens},fe.blockTokens=function(O,I){var R=this;I===void 0&&(I=[]),this.options.pedantic&&(O=O.replace(/^ +$/gm,""));for(var x,Q,ne,Ee;O;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return(x=Me.call({lexer:R},O,I))?(O=O.substring(x.raw.length),I.push(x),!0):!1}))){if(x=this.tokenizer.space(O)){O=O.substring(x.raw.length),x.raw.length===1&&I.length>0?I[I.length-1].raw+=`
`:I.push(x);continue}if(x=this.tokenizer.code(O)){O=O.substring(x.raw.length),Q=I[I.length-1],Q&&(Q.type==="paragraph"||Q.type==="text")?(Q.raw+=`
`+x.raw,Q.text+=`
`+x.text,this.inlineQueue[this.inlineQueue.length-1].src=Q.text):I.push(x);continue}if(x=this.tokenizer.fences(O)){O=O.substring(x.raw.length),I.push(x);continue}if(x=this.tokenizer.heading(O)){O=O.substring(x.raw.length),I.push(x);continue}if(x=this.tokenizer.hr(O)){O=O.substring(x.raw.length),I.push(x);continue}if(x=this.tokenizer.blockquote(O)){O=O.substring(x.raw.length),I.push(x);continue}if(x=this.tokenizer.list(O)){O=O.substring(x.raw.length),I.push(x);continue}if(x=this.tokenizer.html(O)){O=O.substring(x.raw.length),I.push(x);continue}if(x=this.tokenizer.def(O)){O=O.substring(x.raw.length),Q=I[I.length-1],Q&&(Q.type==="paragraph"||Q.type==="text")?(Q.raw+=`
`+x.raw,Q.text+=`
`+x.raw,this.inlineQueue[this.inlineQueue.length-1].src=Q.text):this.tokens.links[x.tag]||(this.tokens.links[x.tag]={href:x.href,title:x.title});continue}if(x=this.tokenizer.table(O)){O=O.substring(x.raw.length),I.push(x);continue}if(x=this.tokenizer.lheading(O)){O=O.substring(x.raw.length),I.push(x);continue}if(ne=O,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,Le=O.slice(1),ze=void 0;R.options.extensions.startBlock.forEach(function(Be){ze=Be.call({lexer:this},Le),typeof ze=="number"&&ze>=0&&(Me=Math.min(Me,ze))}),Me<1/0&&Me>=0&&(ne=O.substring(0,Me+1))}(),this.state.top&&(x=this.tokenizer.paragraph(ne))){Q=I[I.length-1],Ee&&Q.type==="paragraph"?(Q.raw+=`
`+x.raw,Q.text+=`
`+x.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Q.text):I.push(x),Ee=ne.length!==O.length,O=O.substring(x.raw.length);continue}if(x=this.tokenizer.text(O)){O=O.substring(x.raw.length),Q=I[I.length-1],Q&&Q.type==="text"?(Q.raw+=`
`+x.raw,Q.text+=`
`+x.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Q.text):I.push(x);continue}if(O){var Ie="Infinite loop on byte: "+O.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return this.state.top=!0,I},fe.inline=function(O,I){this.inlineQueue.push({src:O,tokens:I})},fe.inlineTokens=function(O,I){var R=this;I===void 0&&(I=[]);var x,Q,ne,Ee=O,Ie,Me,Le;if(this.tokens.links){var ze=Object.keys(this.tokens.links);if(ze.length>0)for(;(Ie=this.tokenizer.rules.inline.reflinkSearch.exec(Ee))!=null;)ze.includes(Ie[0].slice(Ie[0].lastIndexOf("[")+1,-1))&&(Ee=Ee.slice(0,Ie.index)+"["+$("a",Ie[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ie=this.tokenizer.rules.inline.blockSkip.exec(Ee))!=null;)Ee=Ee.slice(0,Ie.index)+"["+$("a",Ie[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ie=this.tokenizer.rules.inline.escapedEmSt.exec(Ee))!=null;)Ee=Ee.slice(0,Ie.index)+"++"+Ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;O;)if(Me||(Le=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Ae){return(x=Ae.call({lexer:R},O,I))?(O=O.substring(x.raw.length),I.push(x),!0):!1}))){if(x=this.tokenizer.escape(O)){O=O.substring(x.raw.length),I.push(x);continue}if(x=this.tokenizer.tag(O)){O=O.substring(x.raw.length),Q=I[I.length-1],Q&&x.type==="text"&&Q.type==="text"?(Q.raw+=x.raw,Q.text+=x.text):I.push(x);continue}if(x=this.tokenizer.link(O)){O=O.substring(x.raw.length),I.push(x);continue}if(x=this.tokenizer.reflink(O,this.tokens.links)){O=O.substring(x.raw.length),Q=I[I.length-1],Q&&x.type==="text"&&Q.type==="text"?(Q.raw+=x.raw,Q.text+=x.text):I.push(x);continue}if(x=this.tokenizer.emStrong(O,Ee,Le)){O=O.substring(x.raw.length),I.push(x);continue}if(x=this.tokenizer.codespan(O)){O=O.substring(x.raw.length),I.push(x);continue}if(x=this.tokenizer.br(O)){O=O.substring(x.raw.length),I.push(x);continue}if(x=this.tokenizer.del(O)){O=O.substring(x.raw.length),I.push(x);continue}if(x=this.tokenizer.autolink(O,V)){O=O.substring(x.raw.length),I.push(x);continue}if(!this.state.inLink&&(x=this.tokenizer.url(O,V))){O=O.substring(x.raw.length),I.push(x);continue}if(ne=O,this.options.extensions&&this.options.extensions.startInline&&function(){var Ae=1/0,Qe=O.slice(1),tt=void 0;R.options.extensions.startInline.forEach(function(ke){tt=ke.call({lexer:this},Qe),typeof tt=="number"&&tt>=0&&(Ae=Math.min(Ae,tt))}),Ae<1/0&&Ae>=0&&(ne=O.substring(0,Ae+1))}(),x=this.tokenizer.inlineText(ne,K)){O=O.substring(x.raw.length),x.raw.slice(-1)!=="_"&&(Le=x.raw.slice(-1)),Me=!0,Q=I[I.length-1],Q&&Q.type==="text"?(Q.raw+=x.raw,Q.text+=x.text):I.push(x);continue}if(O){var Be="Infinite loop on byte: "+O.charCodeAt(0);if(this.options.silent){console.error(Be);break}else throw new Error(Be)}}return I},o(ve,null,[{key:"rules",get:function(){return{block:W,inline:q}}}]),ve}(),ae=function(){function ve(M){this.options=M||Z.defaults}var fe=ve.prototype;return fe.code=function(O,I,R){var x=(I||"").match(/\S*/)[0];if(this.options.highlight){var Q=this.options.highlight(O,x);Q!=null&&Q!==O&&(R=!0,O=Q)}return O=O.replace(/\n$/,"")+`
`,x?'<pre><code class="'+this.options.langPrefix+s(x,!0)+'">'+(R?O:s(O,!0))+`</code></pre>
`:"<pre><code>"+(R?O:s(O,!0))+`</code></pre>
`},fe.blockquote=function(O){return`<blockquote>
`+O+`</blockquote>
`},fe.html=function(O){return O},fe.heading=function(O,I,R,x){return this.options.headerIds?"<h"+I+' id="'+this.options.headerPrefix+x.slug(R)+'">'+O+"</h"+I+`>
`:"<h"+I+">"+O+"</h"+I+`>
`},fe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},fe.list=function(O,I,R){var x=I?"ol":"ul",Q=I&&R!==1?' start="'+R+'"':"";return"<"+x+Q+`>
`+O+"</"+x+`>
`},fe.listitem=function(O){return"<li>"+O+`</li>
`},fe.checkbox=function(O){return"<input "+(O?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},fe.paragraph=function(O){return"<p>"+O+`</p>
`},fe.table=function(O,I){return I&&(I="<tbody>"+I+"</tbody>"),`<table>
<thead>
`+O+`</thead>
`+I+`</table>
`},fe.tablerow=function(O){return`<tr>
`+O+`</tr>
`},fe.tablecell=function(O,I){var R=I.header?"th":"td",x=I.align?"<"+R+' align="'+I.align+'">':"<"+R+">";return x+O+"</"+R+`>
`},fe.strong=function(O){return"<strong>"+O+"</strong>"},fe.em=function(O){return"<em>"+O+"</em>"},fe.codespan=function(O){return"<code>"+O+"</code>"},fe.br=function(){return this.options.xhtml?"<br/>":"<br>"},fe.del=function(O){return"<del>"+O+"</del>"},fe.link=function(O,I,R){if(O=E(this.options.sanitize,this.options.baseUrl,O),O===null)return R;var x='<a href="'+s(O)+'"';return I&&(x+=' title="'+I+'"'),x+=">"+R+"</a>",x},fe.image=function(O,I,R){if(O=E(this.options.sanitize,this.options.baseUrl,O),O===null)return R;var x='<img src="'+O+'" alt="'+R+'"';return I&&(x+=' title="'+I+'"'),x+=this.options.xhtml?"/>":">",x},fe.text=function(O){return O},ve}(),de=function(){function ve(){}var fe=ve.prototype;return fe.strong=function(O){return O},fe.em=function(O){return O},fe.codespan=function(O){return O},fe.del=function(O){return O},fe.html=function(O){return O},fe.text=function(O){return O},fe.link=function(O,I,R){return""+R},fe.image=function(O,I,R){return""+R},fe.br=function(){return""},ve}(),Y=function(){function ve(){this.seen={}}var fe=ve.prototype;return fe.serialize=function(O){return O.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},fe.getNextSafeSlug=function(O,I){var R=O,x=0;if(this.seen.hasOwnProperty(R)){x=this.seen[O];do x++,R=O+"-"+x;while(this.seen.hasOwnProperty(R))}return I||(this.seen[O]=x,this.seen[R]=0),R},fe.slug=function(O,I){I===void 0&&(I={});var R=this.serialize(O);return this.getNextSafeSlug(R,I.dryrun)},ve}(),ie=function(){function ve(M){this.options=M||Z.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new de,this.slugger=new Y}ve.parse=function(O,I){var R=new ve(I);return R.parse(O)},ve.parseInline=function(O,I){var R=new ve(I);return R.parseInline(O)};var fe=ve.prototype;return fe.parse=function(O,I){I===void 0&&(I=!0);var R="",x,Q,ne,Ee,Ie,Me,Le,ze,Be,Ae,Qe,tt,ke,it,X,J,le,Oe,$e,Ge=O.length;for(x=0;x<Ge;x++){if(Ae=O[x],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ae.type]&&($e=this.options.extensions.renderers[Ae.type].call({parser:this},Ae),$e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Ae.type))){R+=$e||"";continue}switch(Ae.type){case"space":continue;case"hr":{R+=this.renderer.hr();continue}case"heading":{R+=this.renderer.heading(this.parseInline(Ae.tokens),Ae.depth,h(this.parseInline(Ae.tokens,this.textRenderer)),this.slugger);continue}case"code":{R+=this.renderer.code(Ae.text,Ae.lang,Ae.escaped);continue}case"table":{for(ze="",Le="",Ee=Ae.header.length,Q=0;Q<Ee;Q++)Le+=this.renderer.tablecell(this.parseInline(Ae.header[Q].tokens),{header:!0,align:Ae.align[Q]});for(ze+=this.renderer.tablerow(Le),Be="",Ee=Ae.rows.length,Q=0;Q<Ee;Q++){for(Me=Ae.rows[Q],Le="",Ie=Me.length,ne=0;ne<Ie;ne++)Le+=this.renderer.tablecell(this.parseInline(Me[ne].tokens),{header:!1,align:Ae.align[ne]});Be+=this.renderer.tablerow(Le)}R+=this.renderer.table(ze,Be);continue}case"blockquote":{Be=this.parse(Ae.tokens),R+=this.renderer.blockquote(Be);continue}case"list":{for(Qe=Ae.ordered,tt=Ae.start,ke=Ae.loose,Ee=Ae.items.length,Be="",Q=0;Q<Ee;Q++)X=Ae.items[Q],J=X.checked,le=X.task,it="",X.task&&(Oe=this.renderer.checkbox(J),ke?X.tokens.length>0&&X.tokens[0].type==="paragraph"?(X.tokens[0].text=Oe+" "+X.tokens[0].text,X.tokens[0].tokens&&X.tokens[0].tokens.length>0&&X.tokens[0].tokens[0].type==="text"&&(X.tokens[0].tokens[0].text=Oe+" "+X.tokens[0].tokens[0].text)):X.tokens.unshift({type:"text",text:Oe}):it+=Oe),it+=this.parse(X.tokens,ke),Be+=this.renderer.listitem(it,le,J);R+=this.renderer.list(Be,Qe,tt);continue}case"html":{R+=this.renderer.html(Ae.text);continue}case"paragraph":{R+=this.renderer.paragraph(this.parseInline(Ae.tokens));continue}case"text":{for(Be=Ae.tokens?this.parseInline(Ae.tokens):Ae.text;x+1<Ge&&O[x+1].type==="text";)Ae=O[++x],Be+=`
`+(Ae.tokens?this.parseInline(Ae.tokens):Ae.text);R+=I?this.renderer.paragraph(Be):Be;continue}default:{var Je='Token with "'+Ae.type+'" type was not found.';if(this.options.silent){console.error(Je);return}else throw new Error(Je)}}}return R},fe.parseInline=function(O,I){I=I||this.renderer;var R="",x,Q,ne,Ee=O.length;for(x=0;x<Ee;x++){if(Q=O[x],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Q.type]&&(ne=this.options.extensions.renderers[Q.type].call({parser:this},Q),ne!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Q.type))){R+=ne||"";continue}switch(Q.type){case"escape":{R+=I.text(Q.text);break}case"html":{R+=I.html(Q.text);break}case"link":{R+=I.link(Q.href,Q.title,this.parseInline(Q.tokens,I));break}case"image":{R+=I.image(Q.href,Q.title,Q.text);break}case"strong":{R+=I.strong(this.parseInline(Q.tokens,I));break}case"em":{R+=I.em(this.parseInline(Q.tokens,I));break}case"codespan":{R+=I.codespan(Q.text);break}case"br":{R+=I.br();break}case"del":{R+=I.del(this.parseInline(Q.tokens,I));break}case"text":{R+=I.text(Q.text);break}default:{var Ie='Token with "'+Q.type+'" type was not found.';if(this.options.silent){console.error(Ie);return}else throw new Error(Ie)}}}return R},ve}();function ce(ve,fe,M){if(typeof ve=="undefined"||ve===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");if(typeof fe=="function"&&(M=fe,fe=null),fe=l({},ce.defaults,fe||{}),P(fe),M){var O=fe.highlight,I;try{I=z.lex(ve,fe)}catch(ne){return M(ne)}var R=function(Ee){var Ie;if(!Ee)try{fe.walkTokens&&ce.walkTokens(I,fe.walkTokens),Ie=ie.parse(I,fe)}catch(Me){Ee=Me}return fe.highlight=O,Ee?M(Ee):M(null,Ie)};if(!O||O.length<3||(delete fe.highlight,!I.length))return R();var x=0;ce.walkTokens(I,function(ne){ne.type==="code"&&(x++,setTimeout(function(){O(ne.text,ne.lang,function(Ee,Ie){if(Ee)return R(Ee);Ie!=null&&Ie!==ne.text&&(ne.text=Ie,ne.escaped=!0),x--,x===0&&R()})},0))}),x===0&&R();return}try{var Q=z.lex(ve,fe);return fe.walkTokens&&ce.walkTokens(Q,fe.walkTokens),ie.parse(Q,fe)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+s(ne.message+"",!0)+"</pre>";throw ne}}ce.options=ce.setOptions=function(ve){return l(ce.defaults,ve),A(ce.defaults),ce},ce.getDefaults=C,ce.defaults=Z.defaults,ce.use=function(){for(var ve=arguments.length,fe=new Array(ve),M=0;M<ve;M++)fe[M]=arguments[M];var O=l.apply(void 0,[{}].concat(fe)),I=ce.defaults.extensions||{renderers:{},childTokens:{}},R;fe.forEach(function(x){if(x.extensions&&(R=!0,x.extensions.forEach(function(ne){if(!ne.name)throw new Error("extension name required");if(ne.renderer){var Ee=I.renderers?I.renderers[ne.name]:null;Ee?I.renderers[ne.name]=function(){for(var Ie=arguments.length,Me=new Array(Ie),Le=0;Le<Ie;Le++)Me[Le]=arguments[Le];var ze=ne.renderer.apply(this,Me);return ze===!1&&(ze=Ee.apply(this,Me)),ze}:I.renderers[ne.name]=ne.renderer}if(ne.tokenizer){if(!ne.level||ne.level!=="block"&&ne.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");I[ne.level]?I[ne.level].unshift(ne.tokenizer):I[ne.level]=[ne.tokenizer],ne.start&&(ne.level==="block"?I.startBlock?I.startBlock.push(ne.start):I.startBlock=[ne.start]:ne.level==="inline"&&(I.startInline?I.startInline.push(ne.start):I.startInline=[ne.start]))}ne.childTokens&&(I.childTokens[ne.name]=ne.childTokens)})),x.renderer&&function(){var ne=ce.defaults.renderer||new ae,Ee=function(Le){var ze=ne[Le];ne[Le]=function(){for(var Be=arguments.length,Ae=new Array(Be),Qe=0;Qe<Be;Qe++)Ae[Qe]=arguments[Qe];var tt=x.renderer[Le].apply(ne,Ae);return tt===!1&&(tt=ze.apply(ne,Ae)),tt}};for(var Ie in x.renderer)Ee(Ie);O.renderer=ne}(),x.tokenizer&&function(){var ne=ce.defaults.tokenizer||new H,Ee=function(Le){var ze=ne[Le];ne[Le]=function(){for(var Be=arguments.length,Ae=new Array(Be),Qe=0;Qe<Be;Qe++)Ae[Qe]=arguments[Qe];var tt=x.tokenizer[Le].apply(ne,Ae);return tt===!1&&(tt=ze.apply(ne,Ae)),tt}};for(var Ie in x.tokenizer)Ee(Ie);O.tokenizer=ne}(),x.walkTokens){var Q=ce.defaults.walkTokens;O.walkTokens=function(ne){x.walkTokens.call(this,ne),Q&&Q.call(this,ne)}}R&&(O.extensions=I),ce.setOptions(O)})},ce.walkTokens=function(ve,fe){for(var M=function(){var x=I.value;switch(fe.call(ce,x),x.type){case"table":{for(var Q=B(x.header),ne;!(ne=Q()).done;){var Ee=ne.value;ce.walkTokens(Ee.tokens,fe)}for(var Ie=B(x.rows),Me;!(Me=Ie()).done;)for(var Le=Me.value,ze=B(Le),Be;!(Be=ze()).done;){var Ae=Be.value;ce.walkTokens(Ae.tokens,fe)}break}case"list":{ce.walkTokens(x.items,fe);break}default:ce.defaults.extensions&&ce.defaults.extensions.childTokens&&ce.defaults.extensions.childTokens[x.type]?ce.defaults.extensions.childTokens[x.type].forEach(function(Qe){ce.walkTokens(x[Qe],fe)}):x.tokens&&ce.walkTokens(x.tokens,fe)}},O=B(ve),I;!(I=O()).done;)M()},ce.parseInline=function(ve,fe){if(typeof ve=="undefined"||ve===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ve!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ve)+", string expected");fe=l({},ce.defaults,fe||{}),P(fe);try{var M=z.lexInline(ve,fe);return fe.walkTokens&&ce.walkTokens(M,fe.walkTokens),ie.parseInline(M,fe)}catch(O){if(O.message+=`
Please report this to https://github.com/markedjs/marked.`,fe.silent)return"<p>An error occurred:</p><pre>"+s(O.message+"",!0)+"</pre>";throw O}},ce.Parser=ie,ce.parser=ie.parse,ce.Renderer=ae,ce.TextRenderer=de,ce.Lexer=z,ce.lexer=z.lex,ce.Tokenizer=H,ce.Slugger=Y,ce.parse=ce;var he=ce.options,ue=ce.setOptions,se=ce.use,ge=ce.walkTokens,Te=ce.parseInline,Re=ce,He=ie.parse,Xe=z.lex;Z.Lexer=z,Z.Parser=ie,Z.Renderer=ae,Z.Slugger=Y,Z.TextRenderer=de,Z.Tokenizer=H,Z.getDefaults=C,Z.lexer=Xe,Z.marked=ce,Z.options=he,Z.parse=Re,Z.parseInline=Te,Z.parser=He,Z.setOptions=ue,Z.use=se,Z.walkTokens=ge,Object.defineProperty(Z,"__esModule",{value:!0})}),define(we[102],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(A,D,F){return Math.min(Math.max(A,D),F)}e.clamp=o;function k(A,D){return(D+A%D)%D}e.rot=k;class w{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=w;class B{constructor(){this._n=1,this._val=0}update(D){return this._val=this._val+(D-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=B;class C{constructor(D){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(D),this._values.fill(0,0,D)}update(D){const F=this._values[this._index];return this._values[this._index]=D,this._index=(this._index+1)%this._values.length,this._sum-=F,this._sum+=D,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=C}),function(){function Z(w){const B=[];typeof w=="number"&&B.push("code/timeOrigin",w);function C(D){B.push(D,Date.now())}function A(){const D=[];for(let F=0;F<B.length;F+=2)D.push({name:B[F],startTime:B[F+1]});return D}return{mark:C,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?Z():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const B=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const C of performance.getEntriesByType("mark"))B.push({name:C.name,startTime:Math.round(w+C.startTime)});return B}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return Z(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),Z()}function o(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=e()),w.MonacoPerformanceMarks}var k;typeof global=="object"?k=global:typeof self=="object"?k=self:k={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(k)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(k):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),k.perf=o(k))}(),define(we[71],be([1,0,17]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0;var k;(function(b){b.text="text/plain",b.binary="application/octet-stream",b.unknown="application/unknown",b.markdown="text/markdown",b.latex="text/latex",b.uriList="text/uri-list"})(k=e.Mimes||(e.Mimes={}));const w={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(b){const c=(0,o.extname)(b),g=w[c.toLowerCase()];return g!==void 0?g:A(b)}e.getMediaOrTextMime=C;function A(b){const c=(0,o.extname)(b);return B[c.toLowerCase()]}e.getMediaMime=A;function D(b){for(const c in B)if(B[c]===b)return c}e.getExtensionForMimeType=D;const F=/^(.+)\/(.+?)(;.+)?$/;function N(b,c){const g=F.exec(b);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:c?void 0:b}e.normalizeMimeType=N}),define(we[103],be([1,0,15,7]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function w(p){const E=p;return E?typeof E.read=="function":!1}e.isReadable=w;function B(p){const E=p;return E?[E.on,E.pause,E.resume,E.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=B;function C(p){const E=p;return E?B(E.stream)&&Array.isArray(E.buffer)&&typeof E.ended=="boolean":!1}e.isReadableBufferedStream=C;function A(p,E){return new D(p,E)}e.newWriteableStream=A;class D{constructor(E,a){this.reducer=E,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(E){if(!this.state.destroyed){if(this.state.flowing)this.emitData(E);else if(this.buffer.data.push(E),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(E){this.state.destroyed||(this.state.flowing?this.emitError(E):this.buffer.error.push(E))}end(E){this.state.destroyed||(typeof E!="undefined"&&this.write(E),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(E){this.listeners.data.slice(0).forEach(a=>a(E))}emitError(E){this.listeners.error.length===0?(0,o.onUnexpectedError)(E):this.listeners.error.slice(0).forEach(a=>a(E))}emitEnd(){this.listeners.end.slice(0).forEach(E=>E())}on(E,a){if(!this.state.destroyed)switch(E){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(E,a){if(this.state.destroyed)return;let T;switch(E){case"data":T=this.listeners.data;break;case"end":T=this.listeners.end;break;case"error":T=this.listeners.error;break}if(T){const r=T.indexOf(a);r>=0&&T.splice(r,1)}}flowData(){if(this.buffer.data.length>0){const E=this.reducer(this.buffer.data);this.emitData(E),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(T=>T())}}flowErrors(){if(this.listeners.error.length>0){for(const E of this.buffer.error)this.emitError(E);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function F(p,E){const a=[];let T;for(;(T=p.read())!==null;)a.push(T);return E(a)}e.consumeReadable=F;function N(p,E,a){const T=[];let r;for(;(r=p.read())!==null&&T.length<a;)T.push(r);return r===null&&T.length>0?E(T):{read:()=>{if(T.length>0)return T.shift();if(typeof r!="undefined"){const i=r;return r=void 0,i}return p.read()}}}e.peekReadable=N;function b(p,E){return new Promise((a,T)=>{const r=[];c(p,{onData:i=>{E&&r.push(i)},onError:i=>{E?T(i):a(void 0)},onEnd:()=>{a(E?E(r):void 0)}})})}e.consumeStream=b;function c(p,E){let a=!1;return p.on("error",T=>{a||E.onError(T)}),p.on("end",()=>{a||E.onEnd()}),p.on("data",T=>{a||E.onData(T)}),(0,k.toDisposable)(()=>a=!0)}e.listenStream=c;function g(p,E){return new Promise((a,T)=>{const r=new k.DisposableStore,i=[],u=m=>{if(i.push(m),i.length>E)return r.dispose(),p.pause(),a({stream:p,buffer:i,ended:!1})},t=m=>T(m),l=()=>a({stream:p,buffer:i,ended:!0});r.add((0,k.toDisposable)(()=>p.removeListener("error",t))),p.on("error",t),r.add((0,k.toDisposable)(()=>p.removeListener("end",l))),p.on("end",l),r.add((0,k.toDisposable)(()=>p.removeListener("data",u))),p.on("data",u)})}e.peekStream=g;function s(p,E){const a=A(E);return a.end(p),a}e.toStream=s;function n(){const p=A(()=>{throw new Error("not supported")});return p.end(),p}e.emptyStream=n;function h(p){let E=!1;return{read:()=>E?null:(E=!0,p)}}e.toReadable=h;function _(p,E,a){const T=A(a);return c(p,{onData:r=>T.write(E.data(r)),onError:r=>T.error(E.error?E.error(r):r),onEnd:()=>T.end()}),T}e.transform=_;function y(p,E,a){let T=!1;return{read:()=>{const r=E.read();return T?r:(T=!0,r!==null?a([p,r]):p)}}}e.prefixedReadable=y;function d(p,E,a){let T=!1;const r=A(a);return c(E,{onData:i=>T?r.write(i):(T=!0,r.write(a([p,i]))),onError:i=>r.error(i),onEnd:()=>{T||(T=!0,r.write(p)),r.end()}}),r}e.prefixedStream=d}),define(we[21],be([1,0,103]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer!="undefined";let w,B;class C{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return k?new C(Buffer.allocUnsafe(m)):new C(new Uint8Array(m))}static wrap(m){return k&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new C(m)}static fromString(m,f){return!(f?.dontUseNodeBuffer||!1)&&k?new C(Buffer.from(m)):(w||(w=new TextEncoder),new C(w.encode(m)))}static fromByteArray(m){const f=C.alloc(m.length);for(let S=0,P=m.length;S<P;S++)f.buffer[S]=m[S];return f}static concat(m,f){if(typeof f=="undefined"){f=0;for(let $=0,L=m.length;$<L;$++)f+=m[$].byteLength}const S=C.alloc(f);let P=0;for(let $=0,L=m.length;$<L;$++){const v=m[$];S.set(v,P),P+=v.byteLength}return S}clone(){const m=C.alloc(this.byteLength);return m.set(this),m}toString(){return k?this.buffer.toString():(B||(B=new TextDecoder),B.decode(this.buffer))}slice(m,f){return new C(this.buffer.subarray(m,f))}set(m,f){if(m instanceof C)this.buffer.set(m.buffer,f);else if(m instanceof Uint8Array)this.buffer.set(m,f);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),f);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),f);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return F(this.buffer,m)}writeUInt32BE(m,f){N(this.buffer,m,f)}readUInt32LE(m){return b(this.buffer,m)}writeUInt32LE(m,f){c(this.buffer,m,f)}readUInt8(m){return g(this.buffer,m)}writeUInt8(m,f){s(this.buffer,m,f)}}e.VSBuffer=C;function A(l,m){return l[m+0]<<0>>>0|l[m+1]<<8>>>0}e.readUInt16LE=A;function D(l,m,f){l[f+0]=m&255,m=m>>>8,l[f+1]=m&255}e.writeUInt16LE=D;function F(l,m){return l[m]*2**24+l[m+1]*2**16+l[m+2]*2**8+l[m+3]}e.readUInt32BE=F;function N(l,m,f){l[f+3]=m,m=m>>>8,l[f+2]=m,m=m>>>8,l[f+1]=m,m=m>>>8,l[f]=m}e.writeUInt32BE=N;function b(l,m){return l[m+0]<<0>>>0|l[m+1]<<8>>>0|l[m+2]<<16>>>0|l[m+3]<<24>>>0}e.readUInt32LE=b;function c(l,m,f){l[f+0]=m&255,m=m>>>8,l[f+1]=m&255,m=m>>>8,l[f+2]=m&255,m=m>>>8,l[f+3]=m&255}e.writeUInt32LE=c;function g(l,m){return l[m]}e.readUInt8=g;function s(l,m,f){l[f]=m}e.writeUInt8=s;function n(l){return o.consumeReadable(l,m=>C.concat(m))}e.readableToBuffer=n;function h(l){return o.toReadable(l)}e.bufferToReadable=h;function _(l){return o.consumeStream(l,m=>C.concat(m))}e.streamToBuffer=_;async function y(l){return l.ended?C.concat(l.buffer):C.concat([...l.buffer,await _(l.stream)])}e.bufferedStreamToBuffer=y;function d(l){return o.toStream(l,m=>C.concat(m))}e.bufferToStream=d;function p(l){return o.transform(l,{data:m=>typeof m=="string"?C.fromString(m):C.wrap(m)},m=>C.concat(m))}e.streamToBufferReadableStream=p;function E(l){return o.newWriteableStream(m=>C.concat(m),l)}e.newWriteableBufferStream=E;function a(l,m){return o.prefixedReadable(l,m,f=>C.concat(f))}e.prefixedBufferReadable=a;function T(l,m){return o.prefixedStream(l,m,f=>C.concat(f))}e.prefixedBufferStream=T;function r(l){let m=0,f=0,S=0;const P=new Uint8Array(Math.floor(l.length/4*3)),$=v=>{switch(f){case 3:P[S++]=m|v,f=0;break;case 2:P[S++]=m|v>>>2,m=v<<6,f=3;break;case 1:P[S++]=m|v>>>4,m=v<<4,f=2;break;default:m=v<<2,f=1}};for(let v=0;v<l.length;v++){const H=l.charCodeAt(v);if(H>=65&&H<=90)$(H-65);else if(H>=97&&H<=122)$(H-97+26);else if(H>=48&&H<=57)$(H-48+52);else if(H===43||H===45)$(62);else if(H===47||H===95)$(63);else{if(H===61)break;throw new SyntaxError(`Unexpected base64 character ${l[v]}`)}}const L=S;for(;f>0;)$(0);return C.wrap(P).slice(0,L)}e.decodeBase64=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:l},m=!0,f=!1){const S=f?u:i;let P="";const $=l.byteLength%3;let L=0;for(;L<l.byteLength-$;L+=3){const v=l[L+0],H=l[L+1],W=l[L+2];P+=S[v>>>2],P+=S[(v<<4|H>>>4)&63],P+=S[(H<<2|W>>>6)&63],P+=S[W&63]}if($===1){const v=l[L+0];P+=S[v>>>2],P+=S[v<<4&63],m&&(P+="==")}else if($===2){const v=l[L+0],H=l[L+1];P+=S[v>>>2],P+=S[(v<<4|H>>>4)&63],P+=S[H<<2&63],m&&(P+="=")}return P}e.encodeBase64=t});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,o,k,w){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!w:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?w.call(Z,o):w?w.value=o:e.set(Z,o),o},De=this&&this.__classPrivateFieldGet||function(Z,e,o,k){if(o==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?k:o==="a"?k.call(Z):k?k.value:e.get(Z)};define(we[22],be([1,0,16,9]),function(Z,e,o,k){"use strict";var w,B,C;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(r,i,u){let t=r.get(i);return t===void 0&&(t=u,r.set(i,t)),t}e.getOrSet=A;function D(r){const i=[];return r.forEach((u,t)=>{i.push(`${t} => ${u}`)}),`Map(${r.size}) {${i.join(", ")}}`}e.mapToString=D;function F(r){const i=[];return r.forEach(u=>{i.push(u)}),`Set(${r.size}) {${i.join(", ")}}`}e.setToString=F;class N{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const u=i.charCodeAt(0),t=this._value.charCodeAt(this._pos);return u-t}value(){return this._value[this._pos]}}e.StringIterator=N;class b{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class c{constructor(i=!0,u=!0){this._splitOnBackslash=i,this._caseSensitive=u}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let u=i.length-1;u>=0;u--,this._valueLen--){const t=this._value.charCodeAt(u);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,k.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,k.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=c;var g;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(g||(g={}));class s{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new c(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,k.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,k.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,k.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,k.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=s;class n{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var h;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(h||(h={}));class _{constructor(i){this._iter=i}static forUris(i=()=>!1){return new _(new s(i))}static forPaths(i=!1){return new _(new c(void 0,!i))}static forStrings(){return new _(new N)}static forConfigKeys(){return new _(new b)}clear(){this._root=void 0}fill(i,u){if(u){const t=u.slice(0);(0,o.shuffle)(t);for(let l of t)this.set(l,i)}else{const t=i.slice(0);(0,o.shuffle)(t);for(let l of t)this.set(l[0],l[1])}}set(i,u){const t=this._iter.reset(i);let l;this._root||(this._root=new n,this._root.segment=t.value());const m=[];for(l=this._root;;){const S=t.cmp(l.segment);if(S>0)l.left||(l.left=new n,l.left.segment=t.value()),m.push([-1,l]),l=l.left;else if(S<0)l.right||(l.right=new n,l.right.segment=t.value()),m.push([1,l]),l=l.right;else if(t.hasNext())t.next(),l.mid||(l.mid=new n,l.mid.segment=t.value()),m.push([0,l]),l=l.mid;else break}const f=l.value;l.value=u,l.key=i;for(let S=m.length-1;S>=0;S--){const P=m[S][1];P.updateHeight();const $=P.balanceFactor();if($<-1||$>1){const L=m[S][0],v=m[S+1][0];if(L===1&&v===1)m[S][1]=P.rotateLeft();else if(L===-1&&v===-1)m[S][1]=P.rotateRight();else if(L===1&&v===-1)P.right=m[S+1][1]=m[S+1][1].rotateRight(),m[S][1]=P.rotateLeft();else if(L===-1&&v===1)P.left=m[S+1][1]=m[S+1][1].rotateLeft(),m[S][1]=P.rotateRight();else throw new Error;if(S>0)switch(m[S-1][0]){case-1:m[S-1][1].left=m[S][1];break;case 1:m[S-1][1].right=m[S][1];break;case 0:m[S-1][1].mid=m[S][1];break}else this._root=m[0][1]}}return f}get(i){return this._getNode(i)?.value}_getNode(i){const u=this._iter.reset(i);let t=this._root;for(;t;){const l=u.cmp(t.segment);if(l>0)t=t.left;else if(l<0)t=t.right;else if(u.hasNext())u.next(),t=t.mid;else break}return t}has(i){const u=this._getNode(i);return!(u?.value===void 0&&u?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,u){const t=this._iter.reset(i),l=[];let m=this._root;for(;m;){const f=t.cmp(m.segment);if(f>0)l.push([-1,m]),m=m.left;else if(f<0)l.push([1,m]),m=m.right;else if(t.hasNext())t.next(),l.push([0,m]),m=m.mid;else break}if(!!m){if(u?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const f=this._min(m.right),{key:S,value:P,segment:$}=f;this._delete(f.key,!1),m.key=S,m.value=P,m.segment=$}else{const f=m.left??m.right;if(l.length>0){const[S,P]=l[l.length-1];switch(S){case-1:P.left=f;break;case 0:P.mid=f;break;case 1:P.right=f;break}}else this._root=f}for(let f=l.length-1;f>=0;f--){const S=l[f][1];S.updateHeight();const P=S.balanceFactor();if(P>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),l[f][1]=S.rotateLeft()):P<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),l[f][1]=S.rotateRight()),f>0)switch(l[f-1][0]){case-1:l[f-1][1].left=l[f][1];break;case 1:l[f-1][1].right=l[f][1];break;case 0:l[f-1][1].mid=l[f][1];break}else this._root=l[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const u=this._iter.reset(i);let t=this._root,l;for(;t;){const m=u.cmp(t.segment);if(m>0)t=t.left;else if(m<0)t=t.right;else if(u.hasNext())u.next(),l=t.value||l,t=t.mid;else break}return t&&t.value||l}findSuperstr(i){const u=this._iter.reset(i);let t=this._root;for(;t;){const l=u.cmp(t.segment);if(l>0)t=t.left;else if(l<0)t=t.right;else if(u.hasNext())u.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(i){for(const[u,t]of this)i(t,u)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){!i||(i.left&&(yield*this._entries(i.left)),i.value&&(yield[i.key,i.value]),i.mid&&(yield*this._entries(i.mid)),i.right&&(yield*this._entries(i.right)))}_isBalanced(){const i=u=>{if(!u)return!0;const t=u.balanceFactor();return t<-1||t>1?!1:i(u.left)&&i(u.right)};return i(this._root)}}e.TernarySearchTree=_;class y{constructor(i,u){this.uri=i,this.value=u}}class d{constructor(i,u){this[w]="ResourceMap",i instanceof d?(this.map=new Map(i.map),this.toKey=u??d.defaultToKey):(this.map=new Map,this.toKey=i??d.defaultToKey)}set(i,u){return this.map.set(this.toKey(i),new y(i,u)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,u){typeof u!="undefined"&&(i=i.bind(u));for(let[t,l]of this.map)i(l.value,l.uri,this)}*values(){for(let i of this.map.values())yield i.value}*keys(){for(let i of this.map.values())yield i.uri}*entries(){for(let i of this.map.values())yield[i.uri,i.value]}*[(w=Symbol.toStringTag,Symbol.iterator)](){for(let[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=d,d.defaultToKey=r=>r.toString();var p;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(p=e.Touch||(e.Touch={}));class E{constructor(){this[B]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,u=0){const t=this._map.get(i);if(!!t)return u!==0&&this.touch(t,u),t.value}set(i,u,t=0){let l=this._map.get(i);if(l)l.value=u,t!==0&&this.touch(l,t);else{switch(l={key:i,value:u,next:void 0,previous:void 0},t){case 0:this.addItemLast(l);break;case 1:this.addItemFirst(l);break;case 2:this.addItemLast(l);break;default:this.addItemLast(l);break}this._map.set(i,l),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const u=this._map.get(i);if(!!u)return this._map.delete(i),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,u){const t=this._state;let l=this._head;for(;l;){if(u?i.bind(u)(l.value,l.key,this):i(l.value,l.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");l=l.next}}keys(){const i=this,u=this._state;let t=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==u)throw new Error("LinkedMap got modified during iteration.");if(t){const m={value:t.key,done:!1};return t=t.next,m}else return{value:void 0,done:!0}}};return l}values(){const i=this,u=this._state;let t=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==u)throw new Error("LinkedMap got modified during iteration.");if(t){const m={value:t.value,done:!1};return t=t.next,m}else return{value:void 0,done:!0}}};return l}entries(){const i=this,u=this._state;let t=this._head;const l={[Symbol.iterator](){return l},next(){if(i._state!==u)throw new Error("LinkedMap got modified during iteration.");if(t){const m={value:[t.key,t.value],done:!1};return t=t.next,m}else return{value:void 0,done:!0}}};return l}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let u=this._head,t=this.size;for(;u&&t>i;)this._map.delete(u.key),u=u.next,t--;this._head=u,this._size=t,u&&(u.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const u=i.next,t=i.previous;if(!u||!t)throw new Error("Invalid list");u.previous=t,t.next=u}i.next=void 0,i.previous=void 0,this._state++}touch(i,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(i===this._head)return;const t=i.next,l=i.previous;i===this._tail?(l.next=void 0,this._tail=l):(t.previous=l,l.next=t),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(u===2){if(i===this._tail)return;const t=i.next,l=i.previous;i===this._head?(t.previous=void 0,this._head=t):(t.previous=l,l.next=t),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((u,t)=>{i.push([t,u])}),i}fromJSON(i){this.clear();for(const[u,t]of i)this.set(u,t)}}e.LinkedMap=E;class a extends E{constructor(i,u=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,u=2){return super.get(i,u)}peek(i){return super.get(i,0)}set(i,u){return super.set(i,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class T{constructor(i){C.set(this,void 0),Ve(this,C,i,"f")}get size(){return De(this,C,"f").size}forEach(i,u){De(this,C,"f").forEach(i,u)}get(i){return De(this,C,"f").get(i)}has(i){return De(this,C,"f").has(i)}entries(){return De(this,C,"f").entries()}keys(){return De(this,C,"f").keys()}values(){return De(this,C,"f").values()}[(C=new WeakMap,Symbol.iterator)](){return De(this,C,"f").entries()}}e.ReadonlyMapView=T}),define(we[104],be([1,0,22,9]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function w(...I){return function(R,x){for(let Q=0,ne=I.length;Q<ne;Q++){const Ee=I[Q](R,x);if(Ee)return Ee}return null}}e.or=w,e.matchesStrictPrefix=B.bind(void 0,!1),e.matchesPrefix=B.bind(void 0,!0);function B(I,R,x){if(!x||x.length<R.length)return null;let Q;return I?Q=k.startsWithIgnoreCase(x,R):Q=x.indexOf(R)===0,Q?R.length>0?[{start:0,end:R.length}]:[]:null}function C(I,R){const x=R.toLowerCase().indexOf(I.toLowerCase());return x===-1?null:[{start:x,end:x+I.length}]}e.matchesContiguousSubString=C;function A(I,R){return D(I.toLowerCase(),R.toLowerCase(),0,0)}e.matchesSubString=A;function D(I,R,x,Q){if(x===I.length)return[];if(Q===R.length)return null;if(I[x]===R[Q]){let ne=null;return(ne=D(I,R,x+1,Q+1))?_({start:Q,end:Q+1},ne):null}return D(I,R,x,Q+1)}function F(I){return 97<=I&&I<=122}function N(I){return 65<=I&&I<=90}e.isUpper=N;function b(I){return 48<=I&&I<=57}function c(I){return I===32||I===9||I===10||I===13}const g=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(I=>g.add(I.charCodeAt(0)));function s(I){return c(I)||g.has(I)}function n(I,R){return I===R||s(I)&&s(R)}function h(I){return F(I)||N(I)||b(I)}function _(I,R){return R.length===0?R=[I]:I.end===R[0].start?R[0].start=I.start:R.unshift(I),R}function y(I,R){for(let x=R;x<I.length;x++){const Q=I.charCodeAt(x);if(N(Q)||b(Q)||x>0&&!h(I.charCodeAt(x-1)))return x}return I.length}function d(I,R,x,Q){if(x===I.length)return[];if(Q===R.length)return null;if(I[x]!==R[Q].toLowerCase())return null;{let ne=null,Ee=Q+1;for(ne=d(I,R,x+1,Q+1);!ne&&(Ee=y(R,Ee))<R.length;)ne=d(I,R,x+1,Ee),Ee++;return ne===null?null:_({start:Q,end:Q+1},ne)}}function p(I){let R=0,x=0,Q=0,ne=0,Ee=0;for(let Be=0;Be<I.length;Be++)Ee=I.charCodeAt(Be),N(Ee)&&R++,F(Ee)&&x++,h(Ee)&&Q++,b(Ee)&&ne++;const Ie=R/I.length,Me=x/I.length,Le=Q/I.length,ze=ne/I.length;return{upperPercent:Ie,lowerPercent:Me,alphaPercent:Le,numericPercent:ze}}function E(I){const{upperPercent:R,lowerPercent:x}=I;return x===0&&R>.6}function a(I){const{upperPercent:R,lowerPercent:x,alphaPercent:Q,numericPercent:ne}=I;return x>.2&&R<.8&&Q>.6&&ne<.2}function T(I){let R=0,x=0,Q=0,ne=0;for(let Ee=0;Ee<I.length;Ee++)Q=I.charCodeAt(Ee),N(Q)&&R++,F(Q)&&x++,c(Q)&&ne++;return(R===0||x===0)&&ne===0?I.length<=30:R<=5}function r(I,R){if(!R||(R=R.trim(),R.length===0)||!T(I)||R.length>60)return null;const x=p(R);if(!a(x)){if(!E(x))return null;R=R.toLowerCase()}let Q=null,ne=0;for(I=I.toLowerCase();ne<R.length&&(Q=d(I,R,0,ne))===null;)ne=y(R,ne+1);return Q}e.matchesCamelCase=r;function i(I,R,x=!1){if(!R||R.length===0)return null;let Q=null,ne=0;for(I=I.toLowerCase(),R=R.toLowerCase();ne<R.length&&(Q=u(I,R,0,ne,x))===null;)ne=t(R,ne+1);return Q}e.matchesWords=i;function u(I,R,x,Q,ne){if(x===I.length)return[];if(Q===R.length)return null;if(n(I.charCodeAt(x),R.charCodeAt(Q))){let Ee=null,Ie=Q+1;if(Ee=u(I,R,x+1,Q+1,ne),!ne)for(;!Ee&&(Ie=t(R,Ie))<R.length;)Ee=u(I,R,x+1,Ie,ne),Ie++;return Ee===null?null:_({start:Q,end:Q+1},Ee)}else return null}function t(I,R){for(let x=R;x<I.length;x++)if(s(I.charCodeAt(x))||x>0&&s(I.charCodeAt(x-1)))return x;return I.length}const l=w(e.matchesPrefix,r,C),m=w(e.matchesPrefix,r,A),f=new o.LRUCache(1e4);function S(I,R,x=!1){if(typeof I!="string"||typeof R!="string")return null;let Q=f.get(I);Q||(Q=new RegExp(k.convertSimple2RegExpPattern(I),"i"),f.set(I,Q));const ne=Q.exec(R);return ne?[{start:ne.index,end:ne.index+ne[0].length}]:x?m(I,R):l(I,R)}e.matchesFuzzy=S;function P(I,R){const x=Re(I,I.toLowerCase(),0,R,R.toLowerCase(),0,!0);return x?L(x):null}e.matchesFuzzy2=P;function $(I,R,x,Q,ne,Ee){const Ie=Math.min(13,I.length);for(;x<Ie;x++){const Me=Re(I,R,x,Q,ne,Ee,!1);if(Me)return Me}return[0,Ee]}e.anyScore=$;function L(I){if(typeof I=="undefined")return[];const R=[],x=I[1];for(let Q=I.length-1;Q>1;Q--){const ne=I[Q]+x,Ee=R[R.length-1];Ee&&Ee.end===ne?Ee.end=ne+1:R.push({start:ne,end:ne+1})}return R}e.createMatches=L;const v=128;function H(){const I=[],R=[];for(let x=0;x<=v;x++)R[x]=0;for(let x=0;x<=v;x++)I.push(R.slice(0));return I}function W(I){const R=[];for(let x=0;x<=I;x++)R[x]=0;return R}const q=W(2*v),K=W(2*v),V=H(),z=H(),ae=H(),de=!1;function Y(I,R,x,Q,ne){function Ee(Me,Le,ze=" "){for(;Me.length<Le;)Me=ze+Me;return Me}let Ie=` |   |${Q.split("").map(Me=>Ee(Me,3)).join("|")}
`;for(let Me=0;Me<=x;Me++)Me===0?Ie+=" |":Ie+=`${R[Me-1]}|`,Ie+=I[Me].slice(0,ne+1).map(Le=>Ee(Le.toString(),3)).join("|")+`
`;return Ie}function ie(I,R,x,Q){I=I.substr(R),x=x.substr(Q),console.log(Y(z,I,I.length,x,x.length)),console.log(Y(ae,I,I.length,x,x.length)),console.log(Y(V,I,I.length,x,x.length))}function ce(I,R){if(R<0||R>=I.length)return!1;const x=I.codePointAt(R);switch(x){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!k.isEmojiImprecise(x)}}function he(I,R){if(R<0||R>=I.length)return!1;switch(I.charCodeAt(R)){case 32:case 9:return!0;default:return!1}}function ue(I,R,x){return R[I]!==x[I]}function se(I,R,x,Q,ne,Ee,Ie=!1){for(;R<x&&ne<Ee;)I[R]===Q[ne]&&(Ie&&(q[R]=ne),R+=1),ne+=1;return R===x}e.isPatternInWord=se;var ge;(function(I){I[I.Diag=1]="Diag",I[I.Left=2]="Left",I[I.LeftLeft=3]="LeftLeft"})(ge||(ge={}));var Te;(function(I){I.Default=[-100,0];function R(x){return!x||x.length===2&&x[0]===-100&&x[1]===0}I.isDefault=R})(Te=e.FuzzyScore||(e.FuzzyScore={}));function Re(I,R,x,Q,ne,Ee,Ie){const Me=I.length>v?v:I.length,Le=Q.length>v?v:Q.length;if(x>=Me||Ee>=Le||Me-x>Le-Ee||!se(R,x,Me,ne,Ee,Le,!0))return;He(Me,Le,x,Ee,R,ne);let ze=1,Be=1,Ae=x,Qe=Ee;const tt=[!1];for(ze=1,Ae=x;Ae<Me;ze++,Ae++){const le=q[Ae],Oe=K[Ae],$e=Ae+1<Me?K[Ae+1]:Le;for(Be=le-Ee+1,Qe=le;Qe<$e;Be++,Qe++){let Ge=Number.MIN_SAFE_INTEGER,Je=!1;Qe<=Oe&&(Ge=Xe(I,R,Ae,x,Q,ne,Qe,Le,Ee,V[ze-1][Be-1]===0,tt));let ht=0;Ge!==Number.MAX_SAFE_INTEGER&&(Je=!0,ht=Ge+z[ze-1][Be-1]);const It=Qe>le,St=It?z[ze][Be-1]+(V[ze][Be-1]>0?-5:0):0,kt=Qe>le+1&&V[ze][Be-1]>0,qe=kt?z[ze][Be-2]+(V[ze][Be-2]>0?-5:0):0;if(kt&&(!It||qe>=St)&&(!Je||qe>=ht))z[ze][Be]=qe,ae[ze][Be]=3,V[ze][Be]=0;else if(It&&(!Je||St>=ht))z[ze][Be]=St,ae[ze][Be]=2,V[ze][Be]=0;else if(Je)z[ze][Be]=ht,ae[ze][Be]=1,V[ze][Be]=V[ze-1][Be-1]+1;else throw new Error("not possible")}}if(de&&ie(I,x,Q,Ee),!tt[0]&&!Ie)return;ze--,Be--;const ke=[z[ze][Be],Ee];let it=0,X=0;for(;ze>=1;){let le=Be;do{const Oe=ae[ze][le];if(Oe===3)le=le-2;else if(Oe===2)le=le-1;else break}while(le>=1);it>1&&R[x+ze-1]===ne[Ee+Be-1]&&!ue(le+Ee-1,Q,ne)&&it+1>V[ze][le]&&(le=Be),le===Be?it++:it=1,X||(X=le),ze--,Be=le-1,ke.push(Be)}Le===Me&&(ke[0]+=2);const J=X-Me;return ke[0]-=J,ke}e.fuzzyScore=Re;function He(I,R,x,Q,ne,Ee){let Ie=I-1,Me=R-1;for(;Ie>=x&&Me>=Q;)ne[Ie]===Ee[Me]&&(K[Ie]=Me,Ie--),Me--}function Xe(I,R,x,Q,ne,Ee,Ie,Me,Le,ze,Be){if(R[x]!==Ee[Ie])return Number.MIN_SAFE_INTEGER;let Ae=1,Qe=!1;return Ie===x-Q?Ae=I[x]===ne[Ie]?7:5:ue(Ie,ne,Ee)&&(Ie===0||!ue(Ie-1,ne,Ee))?(Ae=I[x]===ne[Ie]?7:5,Qe=!0):ce(Ee,Ie)&&(Ie===0||!ce(Ee,Ie-1))?Ae=5:(ce(Ee,Ie-1)||he(Ee,Ie-1))&&(Ae=5,Qe=!0),Ae>1&&x===Q&&(Be[0]=!0),Qe||(Qe=ue(Ie,ne,Ee)||ce(Ee,Ie-1)||he(Ee,Ie-1)),x===Q?Ie>Le&&(Ae-=Qe?3:5):ze?Ae+=Qe?2:0:Ae+=Qe?0:1,Ie+1===Me&&(Ae-=Qe?3:5),Ae}function ve(I,R,x,Q,ne,Ee,Ie){return M(I,R,x,Q,ne,Ee,!0,Ie)}e.fuzzyScoreGracefulAggressive=ve;function fe(I,R,x,Q,ne,Ee,Ie){return M(I,R,x,Q,ne,Ee,!1,Ie)}e.fuzzyScoreGraceful=fe;function M(I,R,x,Q,ne,Ee,Ie,Me){let Le=Re(I,R,x,Q,ne,Ee,Me);if(Le&&!Ie)return Le;if(I.length>=3){const ze=Math.min(7,I.length-1);for(let Be=x+1;Be<ze;Be++){const Ae=O(I,Be);if(Ae){const Qe=Re(Ae,Ae.toLowerCase(),x,Q,ne,Ee,Me);Qe&&(Qe[0]-=3,(!Le||Qe[0]>Le[0])&&(Le=Qe))}}}return Le}function O(I,R){if(R+1>=I.length)return;const x=I[R],Q=I[R+1];if(x!==Q)return I.slice(0,R)+Q+x+I.slice(R+2)}}),define(we[105],be([1,0,106,104,9]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const B=new RegExp(`\\$\\(${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?\\)`,"g"),C=new RegExp(o.CSSIcon.iconNameCharacter),A=new RegExp(`(\\\\)?${B.source}`,"g");function D(h){return h.replace(A,(_,y)=>y?_:`\\${_}`)}e.escapeIcons=D;const F=new RegExp(`\\\\${B.source}`,"g");function N(h){return h.replace(F,_=>`\\${_}`)}e.markdownEscapeEscapedIcons=N;const b=new RegExp(`(\\s)?(\\\\)?${B.source}(\\s)?`,"g");function c(h){return h.indexOf(e.iconStartMarker)===-1?h:h.replace(b,(_,y,d,p)=>d?_:y||p||"")}e.stripIcons=c;function g(h){const _=h.indexOf(e.iconStartMarker);return _===-1?{text:h}:s(h,_)}e.parseLabelWithIcons=g;function s(h,_){const y=[];let d="";function p(l){if(l){d+=l;for(const m of l)y.push(T)}}let E=-1,a="",T=0,r,i,u=_;const t=h.length;for(p(h.substr(0,_));u<t;)r=h[u],i=h[u+1],r===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(E=u,p(a),a=e.iconStartMarker,u++):r===")"&&E!==-1?(T+=u-E+1,E=-1,a=""):E!==-1?C.test(r)?a+=r:(p(a),E=-1,a=""):p(r),u++;return p(a),{text:d,iconOffsets:y}}function n(h,_,y=!1){const{text:d,iconOffsets:p}=_;if(!p||p.length===0)return(0,k.matchesFuzzy)(h,d,y);const E=(0,w.ltrim)(d," "),a=d.length-E.length,T=(0,k.matchesFuzzy)(h,E,y);if(T)for(const r of T){const i=p[r.start+a]+a;r.start+=i,r.end+=i}return T}e.matchesFuzzyIconAware=n}),define(we[34],be([1,0,9]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var k;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(k||(k={})),function(w){const B="error",C="warning",A="warn",D="info",F="ignore";function N(c){return c?o.equalsIgnoreCase(B,c)?w.Error:o.equalsIgnoreCase(C,c)||o.equalsIgnoreCase(A,c)?w.Warning:o.equalsIgnoreCase(D,c)?w.Info:w.Ignore:w.Ignore}w.fromValue=N;function b(c){switch(c){case w.Error:return B;case w.Warning:return C;case w.Info:return D;default:return F}}w.toString=b}(k||(k={})),e.default=k}),define(we[35],be([1,0,17,23,9,11]),function(Z,e,o,k,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function C(u){return u===47||u===92}e.isPathSeparator=C;function A(u){return u.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=A;function D(u){return u.indexOf("/")===-1&&(u=A(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.toPosixPath=D;function F(u,t=o.posix.sep){if(!u)return"";const l=u.length,m=u.charCodeAt(0);if(C(m)){if(C(u.charCodeAt(1))&&!C(u.charCodeAt(2))){let S=3;const P=S;for(;S<l&&!C(u.charCodeAt(S));S++);if(P!==S&&!C(u.charCodeAt(S+1))){for(S+=1;S<l;S++)if(C(u.charCodeAt(S)))return u.slice(0,S+1).replace(/[\\/]/g,t)}}return t}else if(_(m)&&u.charCodeAt(1)===58)return C(u.charCodeAt(2))?u.slice(0,2)+t:u.slice(0,2);let f=u.indexOf("://");if(f!==-1){for(f+=3;f<l;f++)if(C(u.charCodeAt(f)))return u.slice(0,f+1)}return""}e.getRoot=F;function N(u){if(!k.isWindows||!u||u.length<5)return!1;let t=u.charCodeAt(0);if(t!==92||(t=u.charCodeAt(1),t!==92))return!1;let l=2;const m=l;for(;l<u.length&&(t=u.charCodeAt(l),t!==92);l++);return!(m===l||(t=u.charCodeAt(l+1),isNaN(t)||t===92))}e.isUNC=N;const b=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function s(u,t=k.isWindows){const l=t?b:c;return!(!u||u.length===0||/^\s+$/.test(u)||(l.lastIndex=0,l.test(u))||t&&g.test(u)||u==="."||u===".."||t&&u[u.length-1]==="."||t&&u.length!==u.trim().length||u.length>255)}e.isValidBasename=s;function n(u,t,l){const m=u===t;return!l||m?m:!u||!t?!1:(0,w.equalsIgnoreCase)(u,t)}e.isEqual=n;function h(u,t,l,m=o.sep){if(u===t)return!0;if(!u||!t||t.length>u.length)return!1;if(l){if(!(0,w.startsWithIgnoreCase)(u,t))return!1;if(t.length===u.length)return!0;let S=t.length;return t.charAt(t.length-1)===m&&S--,u.charAt(S)===m}return t.charAt(t.length-1)!==m&&(t+=m),u.indexOf(t)===0}e.isEqualOrParent=h;function _(u){return u>=65&&u<=90||u>=97&&u<=122}e.isWindowsDriveLetter=_;function y(u,t){return k.isWindows&&u.endsWith(":")&&(u+=o.sep),(0,o.isAbsolute)(u)||(u=(0,o.join)(t,u)),u=(0,o.normalize)(u),k.isWindows?(u=(0,w.rtrim)(u,o.sep),u.endsWith(":")&&(u+=o.sep)):(u=(0,w.rtrim)(u,o.sep),u||(u=o.sep)),u}e.sanitizeFilePath=y;function d(u){const t=(0,o.normalize)(u);return k.isWindows?u.length>3?!1:p(t)&&(u.length===2||t.charCodeAt(2)===92):t===o.posix.sep}e.isRootOrDriveLetter=d;function p(u,t){return(t!==void 0?t:k.isWindows)?_(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.hasDriveLetter=p;function E(u){return p(u)?u[0]:void 0}e.getDriveLetter=E;function a(u,t,l){return t.length>u.length?-1:u===t?0:(l&&(u=u.toLowerCase(),t=t.toLowerCase()),u.indexOf(t))}e.indexOfPath=a;function T(u){const t=u.split(":");let l,m,f;for(const S of t){const P=Number(S);(0,B.isNumber)(P)?m===void 0?m=P:f===void 0&&(f=P):l=l?[l,S].join(":"):S}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:m!==void 0?m:void 0,column:f!==void 0?f:m!==void 0?1:void 0}}e.parseLineAndColumnAware=T;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(u,t,l=8){let m="";for(let S=0;S<l;S++)m+=r.charAt(Math.floor(Math.random()*r.length));let f;return t?f=`${t}-${m}`:f=m,u?(0,o.join)(u,f):f}e.randomPath=i}),define(we[54],be([1,0,21,9,2]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function B(F){return JSON.stringify(F,A)}e.stringify=B;function C(F){let N=JSON.parse(F);return N=D(N),N}e.parse=C;function A(F,N){return N instanceof RegExp?{$mid:2,source:N.source,flags:(0,k.regExpFlags)(N)}:N}function D(F,N=0){if(!F||N>200)return F;if(typeof F=="object"){switch(F.$mid){case 1:return w.URI.revive(F);case 2:return new RegExp(F.source,F.flags);case 14:return new Date(F.source)}if(F instanceof o.VSBuffer||F instanceof Uint8Array)return F;if(Array.isArray(F))for(let b=0;b<F.length;++b)F[b]=D(F[b],N+1);else for(const b in F)Object.hasOwnProperty.call(F,b)&&(F[b]=D(F[b],N+1))}return F}e.revive=D}),define(we[10],be([1,0,23,2]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.userData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeNotebookCellOutput="vscode-notebook-cell-output",A.vscodeInteractive="vscode-interactive",A.vscodeInteractiveInput="vscode-interactive-input",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.vscodeTerminal="vscode-terminal",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.extension="extension",A.vscodeFileResource="vscode-file",A.tmp="tmp",A.vsls="vsls"})(w=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class B{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(D){this._preferredWebSchema=D}setDelegate(D){this._delegate=D}set(D,F,N){this._hosts[D]=F,this._ports[D]=N}setConnectionToken(D,F){this._connectionTokens[D]=F}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(D){if(this._delegate)return this._delegate(D);const F=D.authority;let N=this._hosts[F];N&&N.indexOf(":")!==-1&&(N=`[${N}]`);const b=this._ports[F],c=this._connectionTokens[F];let g=`path=${encodeURIComponent(D.path)}`;return typeof c=="string"&&(g+=`&${e.connectionTokenQueryName}=${encodeURIComponent(c)}`),k.URI.from({scheme:o.isWeb?this._preferredWebSchema:w.vscodeRemoteResource,authority:`${N}:${b}`,path:"/vscode-remote-resource",query:g})}}e.RemoteAuthorities=new B;class C{asBrowserUri(D,F){const N=this.toUri(D,F);return N.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(N):N.scheme===w.file&&(o.isNative||o.isWebWorker&&o.globals.origin===`${w.vscodeFileResource}://${C.FALLBACK_AUTHORITY}`)?N.with({scheme:w.vscodeFileResource,authority:N.authority||C.FALLBACK_AUTHORITY,query:null,fragment:null}):N}asFileUri(D,F){const N=this.toUri(D,F);return N.scheme===w.vscodeFileResource?N.with({scheme:w.file,authority:N.authority!==C.FALLBACK_AUTHORITY?N.authority:null,query:null,fragment:null}):N}toUri(D,F){return k.URI.isUri(D)?D:k.URI.parse(F.toUrl(D))}}C.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new C}),define(we[24],be([1,0,35,10,17,23,9,2]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(g){return(0,A.uriToFsPath)(g,!0)}e.originalFSPath=D;class F{constructor(s){this._ignorePathCasing=s}compare(s,n,h=!1){return s===n?0:(0,C.compare)(this.getComparisonKey(s,h),this.getComparisonKey(n,h))}isEqual(s,n,h=!1){return s===n?!0:!s||!n?!1:this.getComparisonKey(s,h)===this.getComparisonKey(n,h)}getComparisonKey(s,n=!1){return s.with({path:this._ignorePathCasing(s)?s.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(s){return this._ignorePathCasing(s)}isEqualOrParent(s,n,h=!1){if(s.scheme===n.scheme){if(s.scheme===k.Schemas.file)return o.isEqualOrParent(D(s),D(n),this._ignorePathCasing(s))&&s.query===n.query&&(h||s.fragment===n.fragment);if((0,e.isEqualAuthority)(s.authority,n.authority))return o.isEqualOrParent(s.path,n.path,this._ignorePathCasing(s),"/")&&s.query===n.query&&(h||s.fragment===n.fragment)}return!1}joinPath(s,...n){return A.URI.joinPath(s,...n)}basenameOrAuthority(s){return(0,e.basename)(s)||s.authority}basename(s){return w.posix.basename(s.path)}extname(s){return w.posix.extname(s.path)}dirname(s){if(s.path.length===0)return s;let n;return s.scheme===k.Schemas.file?n=A.URI.file(w.dirname(D(s))).path:(n=w.posix.dirname(s.path),s.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${s.toString})) resulted in a relative path`),n="/")),s.with({path:n})}normalizePath(s){if(!s.path.length)return s;let n;return s.scheme===k.Schemas.file?n=A.URI.file(w.normalize(D(s))).path:n=w.posix.normalize(s.path),s.with({path:n})}relativePath(s,n){if(s.scheme!==n.scheme||!(0,e.isEqualAuthority)(s.authority,n.authority))return;if(s.scheme===k.Schemas.file){const y=w.relative(D(s),D(n));return B.isWindows?o.toSlashes(y):y}let h=s.path||"/",_=n.path||"/";if(this._ignorePathCasing(s)){let y=0;for(const d=Math.min(h.length,_.length);y<d&&!(h.charCodeAt(y)!==_.charCodeAt(y)&&h.charAt(y).toLowerCase()!==_.charAt(y).toLowerCase());y++);h=_.substr(0,y)+h.substr(y)}return w.posix.relative(h,_)}resolvePath(s,n){if(s.scheme===k.Schemas.file){const h=A.URI.file(w.resolve(D(s),n));return s.with({authority:h.authority,path:h.path})}return n=o.toPosixPath(n),s.with({path:w.posix.resolve(s.path,n)})}isAbsolutePath(s){return!!s.path&&s.path[0]==="/"}isEqualAuthority(s,n){return s===n||s!==void 0&&n!==void 0&&(0,C.equalsIgnoreCase)(s,n)}hasTrailingPathSeparator(s,n=w.sep){if(s.scheme===k.Schemas.file){const h=D(s);return h.length>o.getRoot(h).length&&h[h.length-1]===n}else{const h=s.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(s.fsPath)}}removeTrailingPathSeparator(s,n=w.sep){return(0,e.hasTrailingPathSeparator)(s,n)?s.with({path:s.path.substr(0,s.path.length-1)}):s}addTrailingPathSeparator(s,n=w.sep){let h=!1;if(s.scheme===k.Schemas.file){const _=D(s);h=_!==void 0&&_.length===o.getRoot(_).length&&_[_.length-1]===n}else{n="/";const _=s.path;h=_.length===1&&_.charCodeAt(_.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(s,n)?s.with({path:s.path+"/"}):s}}e.ExtUri=F,e.extUri=new F(()=>!1),e.extUriBiasedIgnorePathCase=new F(g=>g.scheme===k.Schemas.file?!B.isLinux:!0),e.extUriIgnorePathCase=new F(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function N(g,s){const n=[];for(let h=0;h<g.length;h++){const _=s(g[h]);g.some((y,d)=>d===h?!1:(0,e.isEqualOrParent)(_,s(y)))||n.push(g[h])}return n}e.distinctParents=N;var b;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function s(n){const h=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(d=>{const[p,E]=d.split(":");p&&E&&h.set(p,E)});const y=n.path.substring(0,n.path.indexOf(";"));return y&&h.set(g.META_DATA_MIME,y),h}g.parseMetaData=s})(b=e.DataUri||(e.DataUri={}));function c(g,s,n){if(s){let h=g.path;return h&&h[0]!==w.posix.sep&&(h=w.posix.sep+h),g.with({scheme:n,authority:s,path:h})}return g.with({scheme:n})}e.toLocalResource=c}),define(we[13],be([1,0,20,15,5,7,24,23]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function D(ue){return!!ue&&typeof ue.then=="function"}e.isThenable=D;function F(ue){const se=new o.CancellationTokenSource,ge=ue(se.token),Te=new Promise((Re,He)=>{const Xe=se.token.onCancellationRequested(()=>{Xe.dispose(),se.dispose(),He(new k.CancellationError)});Promise.resolve(ge).then(ve=>{Xe.dispose(),se.dispose(),Re(ve)},ve=>{Xe.dispose(),se.dispose(),He(ve)})});return new class{cancel(){se.cancel()}then(Re,He){return Te.then(Re,He)}catch(Re){return this.then(void 0,Re)}finally(Re){return Te.finally(Re)}}}e.createCancelablePromise=F;function N(ue,se,ge){return new Promise((Te,Re)=>{const He=se.onCancellationRequested(()=>{He.dispose(),Te(ge)});ue.then(Te,Re).finally(()=>He.dispose())})}e.raceCancellation=N;function b(ue,se){return new Promise((ge,Te)=>{const Re=se.onCancellationRequested(()=>{Re.dispose(),Te(new k.CancellationError)});ue.then(ge,Te).finally(()=>Re.dispose())})}e.raceCancellationError=b;async function c(ue){let se=-1;const ge=ue.map((Re,He)=>Re.then(Xe=>(se=He,Xe))),Te=await Promise.race(ge);return ue.forEach((Re,He)=>{He!==se&&Re.cancel()}),Te}e.raceCancellablePromises=c;function g(ue,se,ge){let Te;const Re=setTimeout(()=>{Te?.(void 0),ge?.()},se);return Promise.race([ue.finally(()=>clearTimeout(Re)),new Promise(He=>Te=He)])}e.raceTimeout=g;function s(ue){return new Promise((se,ge)=>{const Te=ue();D(Te)?Te.then(se,ge):se(Te)})}e.asPromise=s;class n{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(se){if(this.activePromise){if(this.queuedPromiseFactory=se,!this.queuedPromise){const ge=()=>{this.queuedPromise=null;const Te=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Te};this.queuedPromise=new Promise(Te=>{this.activePromise.then(ge,ge).then(Te)})}return new Promise((ge,Te)=>{this.queuedPromise.then(ge,Te)})}return this.activePromise=se(),new Promise((ge,Te)=>{this.activePromise.then(Re=>{this.activePromise=null,ge(Re)},Re=>{this.activePromise=null,Te(Re)})})}}e.Throttler=n;class h{constructor(){this.current=Promise.resolve(null)}queue(se){return this.current=this.current.then(()=>se(),()=>se())}}e.Sequencer=h;class _{constructor(){this.promiseMap=new Map}queue(se,ge){const Re=(this.promiseMap.get(se)??Promise.resolve()).catch(()=>{}).then(ge).finally(()=>{this.promiseMap.get(se)===Re&&this.promiseMap.delete(se)});return this.promiseMap.set(se,Re),Re}}e.SequencerByKey=_;const y=(ue,se)=>{let ge=!0;const Te=setTimeout(()=>{ge=!1,se()},ue);return{isTriggered:()=>ge,dispose:()=>{clearTimeout(Te),ge=!1}}},d=ue=>{let se=!0;return queueMicrotask(()=>{se&&(se=!1,ue())}),{isTriggered:()=>se,dispose:()=>{se=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class p{constructor(se){this.defaultDelay=se,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(se,ge=this.defaultDelay){this.task=se,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Re,He)=>{this.doResolve=Re,this.doReject=He}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Re=this.task;return this.task=null,Re()}}));const Te=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ge===e.MicrotaskDelay?d(Te):y(ge,Te),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(new k.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=p;class E{constructor(se){this.delayer=new p(se),this.throttler=new n}trigger(se,ge){return this.delayer.trigger(()=>this.throttler.queue(se),ge)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=E;class a{constructor(){this._isOpen=!1,this._promise=new Promise((se,ge)=>{this._completePromise=se})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=a;class T extends a{constructor(se){super();this._timeout=setTimeout(()=>this.open(),se)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=T;function r(ue,se){return se?new Promise((ge,Te)=>{const Re=setTimeout(()=>{He.dispose(),ge()},ue),He=se.onCancellationRequested(()=>{clearTimeout(Re),He.dispose(),Te(new k.CancellationError)})}):F(ge=>r(ue,ge))}e.timeout=r;function i(ue,se=0){const ge=setTimeout(ue,se);return(0,B.toDisposable)(()=>clearTimeout(ge))}e.disposableTimeout=i;function u(ue){const se=[];let ge=0;const Te=ue.length;function Re(){return ge<Te?ue[ge++]():null}function He(Xe){Xe!=null&&se.push(Xe);const ve=Re();return ve?ve.then(He):Promise.resolve(se)}return Promise.resolve(null).then(He)}e.sequence=u;function t(ue,se=Te=>!!Te,ge=null){let Te=0;const Re=ue.length,He=()=>{if(Te>=Re)return Promise.resolve(ge);const Xe=ue[Te++];return Promise.resolve(Xe()).then(fe=>se(fe)?Promise.resolve(fe):He())};return He()}e.first=t;function l(ue,se=Te=>!!Te,ge=null){if(ue.length===0)return Promise.resolve(ge);let Te=ue.length;const Re=()=>{Te=-1;for(const He of ue)He.cancel?.()};return new Promise((He,Xe)=>{for(const ve of ue)ve.then(fe=>{--Te>=0&&se(fe)?(Re(),He(fe)):Te===0&&He(ge)}).catch(fe=>{--Te>=0&&(Re(),Xe(fe))})})}e.firstParallel=l;class m{constructor(se){this._size=0,this.maxDegreeOfParalellism=se,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new w.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(se){return this._size++,new Promise((ge,Te)=>{this.outstandingPromises.push({factory:se,c:ge,e:Te}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const se=this.outstandingPromises.shift();this.runningPromises++;const ge=se.factory();ge.then(se.c,se.e),ge.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=m;class f extends m{constructor(){super(1)}}e.Queue=f;class S{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const se=new ae;return this.drainers.add(se),se.p}isDrained(){for(const[,se]of this.queues)if(se.size>0)return!1;return!0}queueFor(se,ge=C.extUri){const Te=ge.getComparisonKey(se);let Re=this.queues.get(Te);return Re||(Re=new f,w.Event.once(Re.onFinished)(()=>{Re?.dispose(),this.queues.delete(Te),this.onDidQueueFinish()}),this.queues.set(Te,Re)),Re}onDidQueueFinish(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const se of this.drainers)se.complete();this.drainers.clear()}dispose(){for(const[,se]of this.queues)se.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=S;class P{constructor(se,ge){this._token=-1,typeof se=="function"&&typeof ge=="number"&&this.setIfNotSet(se,ge)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(se,ge){this.cancel(),this._token=setTimeout(()=>{this._token=-1,se()},ge)}setIfNotSet(se,ge){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,se()},ge))}}e.TimeoutTimer=P;class ${constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(se,ge){this.cancel(),this._token=setInterval(()=>{se()},ge)}}e.IntervalTimer=$;class L{constructor(se,ge){this.timeoutToken=-1,this.runner=se,this.timeout=ge,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(se=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,se)}get delay(){return this.timeout}set delay(se){this.timeout=se}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=L;class v{constructor(se,ge){ge%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ge}ms is not a multiple of 1000ms.`),this.runner=se,this.timeout=ge,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(se=this.timeout){se%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(se/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=v;class H extends L{constructor(se,ge){super(se,ge);this.units=[]}work(se){this.units.push(se),this.isScheduled()||this.schedule()}doRun(){const se=this.units;this.units=[],this.runner&&this.runner(se)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=H;class W extends B.Disposable{constructor(se,ge){super();this.options=se,this.handler=ge,this.pendingWork=[],this.throttler=this._register(new B.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(se){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+se.length>this.options.maxBufferedWork)return!1}else if(this.pending+se.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...se),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new L(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ue=>{(0,A.setTimeout0)(()=>{if(se)return;const ge=Date.now()+15;ue(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ge-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.runWhenIdle=(ue,se)=>{const ge=requestIdleCallback(ue,typeof se=="number"?{timeout:se}:void 0);let Te=!1;return{dispose(){Te||(Te=!0,cancelIdleCallback(ge))}}}}();class q{constructor(se){this._didRun=!1,this._executor=()=>{try{this._value=se()}catch(ge){this._error=ge}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=q;async function K(ue,se,ge){let Te;for(let Re=0;Re<ge;Re++)try{return await ue()}catch(He){Te=He,await r(se)}throw Te}e.retry=K;class V{hasPending(se){return this._pending?typeof se=="number"?this._pending.taskId===se:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(se,ge,Te){return this._pending={taskId:se,cancel:()=>Te?.(),promise:ge},ge.then(()=>this.donePending(se),()=>this.donePending(se)),ge}donePending(se){this._pending&&se===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const se=this._next;this._next=void 0,se.run().then(se.promiseResolve,se.promiseReject)}}setNext(se){if(this._next)this._next.run=se;else{let ge,Te;const Re=new Promise((He,Xe)=>{ge=He,Te=Xe});this._next={run:se,promise:Re,promiseResolve:ge,promiseReject:Te}}return this._next.promise}}e.TaskSequentializer=V;class z{constructor(se,ge=()=>Date.now()){this.interval=se,this.nowFn=ge,this.lastIncrementTime=0,this.value=0}increment(){const se=this.nowFn();return se-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=se,this.value=0),this.value++,this.value}}e.IntervalCounter=z;class ae{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((se,ge)=>{this.completeCallback=se,this.errorCallback=ge})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(se){return new Promise(ge=>{this.completeCallback(se),this.resolved=!0,ge()})}error(se){return new Promise(ge=>{this.errorCallback(se),this.rejected=!0,ge()})}cancel(){new Promise(se=>{this.errorCallback(new k.CancellationError),this.rejected=!0,se()})}}e.DeferredPromise=ae;var de;(function(ue){async function se(Te){let Re;const He=await Promise.all(Te.map(Xe=>Xe.then(ve=>ve,ve=>{Re||(Re=ve)})));if(typeof Re!="undefined")throw Re;return He}ue.settled=se;function ge(Te){return new Promise(async(Re,He)=>{try{await Te(Re,He)}catch(Xe){He(Xe)}})}ue.withAsyncBody=ge})(de=e.Promises||(e.Promises={}));var Y;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(Y||(Y={}));class ie{constructor(se){this._state=0,this._results=[],this._error=null,this._onStateChanged=new w.Emitter,queueMicrotask(async()=>{const ge={emitOne:Te=>this.emitOne(Te),emitMany:Te=>this.emitMany(Te),reject:Te=>this.reject(Te)};try{await Promise.resolve(se(ge)),this.resolve()}catch(Te){this.reject(Te)}finally{ge.emitOne=void 0,ge.emitMany=void 0,ge.reject=void 0}})}static fromArray(se){return new ie(ge=>{ge.emitMany(se)})}static fromPromise(se){return new ie(async ge=>{ge.emitMany(await se)})}static fromPromises(se){return new ie(async ge=>{await Promise.all(se.map(async Te=>ge.emitOne(await Te)))})}static merge(se){return new ie(async ge=>{await Promise.all(se.map(async Te=>{for await(const Re of Te)ge.emitOne(Re)}))})}[Symbol.asyncIterator](){let se=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(se<this._results.length)return{done:!1,value:this._results[se++]};if(this._state===1)return{done:!0,value:void 0};await w.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(se,ge){return new ie(async Te=>{for await(const Re of se)Te.emitOne(ge(Re))})}map(se){return ie.map(this,se)}static filter(se,ge){return new ie(async Te=>{for await(const Re of se)ge(Re)&&Te.emitOne(Re)})}filter(se){return ie.filter(this,se)}static coalesce(se){return ie.filter(se,ge=>!!ge)}coalesce(){return ie.coalesce(this)}static async toPromise(se){const ge=[];for await(const Te of se)ge.push(Te);return ge}toPromise(){return ie.toPromise(this)}emitOne(se){this._state===0&&(this._results.push(se),this._onStateChanged.fire())}emitMany(se){this._state===0&&(this._results=this._results.concat(se),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(se){this._state===0&&(this._state=2,this._error=se,this._onStateChanged.fire())}}e.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class ce extends ie{constructor(se,ge){super(ge);this._source=se}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function he(ue){const se=new o.CancellationTokenSource,ge=ue(se.token);return new ce(se,async Te=>{const Re=se.token.onCancellationRequested(()=>{Re.dispose(),se.dispose(),Te.reject(new k.CancellationError)});try{for await(const He of ge){if(se.token.isCancellationRequested)return;Te.emitOne(He)}Re.dispose(),se.dispose()}catch(He){Re.dispose(),se.dispose(),Te.reject(He)}})}e.createCancelableAsyncIterable=he}),define(we[107],be([1,0,13,17]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const w=new o.IdleValue(()=>{const f=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:f,collatorIsNumeric:f.resolvedOptions().numeric}}),B=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),C=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(f,S,P=!1){const $=f||"",L=S||"",v=w.value.collator.compare($,L);return w.value.collatorIsNumeric&&v===0&&$!==L?$<L?-1:1:v}e.compareFileNames=A;function D(f,S){const P=B.value.collator;return f=f||"",S=S||"",E(P,f,S)}e.compareFileNamesDefault=D;function F(f,S){const P=B.value.collator;return f=f||"",S=S||"",i(f,S)||E(P,f,S)}e.compareFileNamesUpper=F;function N(f,S){const P=B.value.collator;return f=f||"",S=S||"",r(f,S)||E(P,f,S)}e.compareFileNamesLower=N;function b(f,S){return f=f||"",S=S||"",f===S?0:f<S?-1:1}e.compareFileNamesUnicode=b;function c(f,S,P=!1){P||(f=f&&f.toLowerCase(),S=S&&S.toLowerCase());const[$,L]=d(f),[v,H]=d(S);return $!==v?$<v?-1:1:L===H?0:L<H?-1:1}e.noIntlCompareFileNames=c;function g(f,S){const[P,$]=d(f),[L,v]=d(S);let H=w.value.collator.compare($,v);if(H===0){if(w.value.collatorIsNumeric&&$!==v)return $<v?-1:1;if(H=w.value.collator.compare(P,L),w.value.collatorIsNumeric&&H===0&&P!==L)return P<L?-1:1}return H}e.compareFileExtensions=g;function s(f,S){f=f||"",S=S||"";const P=p(f),$=p(S),L=B.value.collator,v=C.value.collator;return E(v,P,$)||E(L,f,S)}e.compareFileExtensionsDefault=s;function n(f,S){f=f||"",S=S||"";const P=p(f),$=p(S),L=B.value.collator,v=C.value.collator;return E(v,P,$)||i(f,S)||E(L,f,S)}e.compareFileExtensionsUpper=n;function h(f,S){f=f||"",S=S||"";const P=p(f),$=p(S),L=B.value.collator,v=C.value.collator;return E(v,P,$)||r(f,S)||E(L,f,S)}e.compareFileExtensionsLower=h;function _(f,S){f=f||"",S=S||"";const P=p(f).toLowerCase(),$=p(S).toLowerCase();return P!==$?P<$?-1:1:f!==S?f<S?-1:1:0}e.compareFileExtensionsUnicode=_;const y=/^(.*?)(\.([^.]*))?$/;function d(f,S=!1){const P=f?y.exec(f):[];let $=[P&&P[1]||"",P&&P[3]||""];return S&&(!$[0]&&$[1]||$[0]&&$[0].charAt(0)===".")&&($=[$[0]+"."+$[1],""]),$}function p(f){const S=f?y.exec(f):[];return S&&S[1]&&S[1].charAt(0)!=="."&&S[3]||""}function E(f,S,P){let $=f.compare(S,P);return $!==0?$:S.length!==P.length?S.length<P.length?-1:1:0}function a(f){const S=f.charAt(0);return S.toLocaleUpperCase()!==S}function T(f){const S=f.charAt(0);return S.toLocaleLowerCase()!==S}function r(f,S){return a(f)&&T(S)?-1:T(f)&&a(S)?1:0}function i(f,S){return T(f)&&a(S)?-1:a(f)&&T(S)?1:0}function u(f,S,P=!1){return P||(f=f&&f.toLowerCase(),S=S&&S.toLowerCase()),f===S?0:f<S?-1:1}function t(f,S,P=!1){const $=f.split(k.sep),L=S.split(k.sep),v=$.length-1,H=L.length-1;let W,q;for(let K=0;;K++){if(W=v===K,q=H===K,W&&q)return A($[K],L[K],P);if(W)return-1;if(q)return 1;const V=u($[K],L[K],P);if(V!==0)return V}}e.comparePaths=t;function l(f,S,P){const $=f.toLowerCase(),L=S.toLowerCase(),v=m(f,S,P);if(v)return v;const H=$.endsWith(P),W=L.endsWith(P);if(H!==W)return H?-1:1;const q=A($,L);return q!==0?q:$.localeCompare(L)}e.compareAnything=l;function m(f,S,P){const $=f.toLowerCase(),L=S.toLowerCase(),v=$.startsWith(P),H=L.startsWith(P);if(v!==H)return v?-1:1;if(v&&H){if($.length<L.length)return-1;if($.length>L.length)return 1}return 0}e.compareByPrefix=m}),define(we[29],be([1,0,13,35,22,17,23,9]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function D(){return Object.create(null)}e.getEmptyExpression=D,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const F="[/\\\\]",N="[^/\\\\]",b=/\//g;function c(V,z){switch(V){case 0:return"";case 1:return`${N}*?`;default:return`(?:${F}|${N}+${F}${z?`|${F}${N}+`:""})*?`}}function g(V,z){if(!V)return[];const ae=[];let de=!1,Y=!1,ie="";for(const ce of V){switch(ce){case z:if(!de&&!Y){ae.push(ie),ie="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":Y=!0;break;case"]":Y=!1;break}ie+=ce}return ie&&ae.push(ie),ae}e.splitGlobAware=g;function s(V){if(!V)return"";let z="";const ae=g(V,e.GLOB_SPLIT);if(ae.every(de=>de===e.GLOBSTAR))z=".*";else{let de=!1;ae.forEach((Y,ie)=>{if(Y===e.GLOBSTAR){if(de)return;z+=c(2,ie===ae.length-1)}else{let ce=!1,he="",ue=!1,se="";for(const ge of Y){if(ge!=="}"&&ce){he+=ge;continue}if(ue&&(ge!=="]"||!se)){let Te;ge==="-"?Te=ge:(ge==="^"||ge==="!")&&!se?Te="^":ge===e.GLOB_SPLIT?Te="":Te=(0,A.escapeRegExpCharacters)(ge),se+=Te;continue}switch(ge){case"{":ce=!0;continue;case"[":ue=!0;continue;case"}":{z+=`(?:${g(he,",").map(He=>s(He)).join("|")})`,ce=!1,he="";break}case"]":{z+="["+se+"]",ue=!1,se="";break}case"?":z+=N;continue;case"*":z+=c(1);continue;default:z+=(0,A.escapeRegExpCharacters)(ge)}}ie<ae.length-1&&(ae[ie+1]!==e.GLOBSTAR||ie+2<ae.length)&&(z+=F)}de=Y===e.GLOBSTAR})}return z}const n=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,_=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,p=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,E=new w.LRUCache(1e4),a=function(){return!1},T=function(){return null};function r(V,z){if(!V)return T;let ae;typeof V!="string"?ae=V.pattern:ae=V,ae=ae.trim();const de=`${ae}_${!!z.trimForExclusions}`;let Y=E.get(de);if(Y)return i(Y,V);let ie;return n.test(ae)?Y=t(ae.substr(4),ae):(ie=h.exec(u(ae,z)))?Y=l(ie[1],ae):(z.trimForExclusions?y:_).test(ae)?Y=m(ae,z):(ie=d.exec(u(ae,z)))?Y=f(ie[1].substr(1),ae,!0):(ie=p.exec(u(ae,z)))?Y=f(ie[1],ae,!1):Y=S(ae),E.set(de,Y),i(Y,V)}function i(V,z){return typeof z=="string"?V:function(ae,de){return(0,k.isEqualOrParent)(ae,z.base,!C.isLinux)?V(ae.substr(z.base.length+1),de):null}}function u(V,z){return z.trimForExclusions&&V.endsWith("/**")?V.substr(0,V.length-2):V}function t(V,z){return function(ae,de){return typeof ae=="string"&&ae.endsWith(V)?z:null}}function l(V,z){const ae=`/${V}`,de=`\\${V}`,Y=function(ce,he){return typeof ce!="string"?null:he?he===V?z:null:ce===V||ce.endsWith(ae)||ce.endsWith(de)?z:null},ie=[V];return Y.basenames=ie,Y.patterns=[z],Y.allBasenames=ie,Y}function m(V,z){const ae=K(V.slice(1,-1).split(",").map(he=>r(he,z)).filter(he=>he!==T),V),de=ae.length;if(!de)return T;if(de===1)return ae[0];const Y=function(he,ue){for(let se=0,ge=ae.length;se<ge;se++)if(ae[se](he,ue))return V;return null},ie=ae.find(he=>!!he.allBasenames);ie&&(Y.allBasenames=ie.allBasenames);const ce=ae.reduce((he,ue)=>ue.allPaths?he.concat(ue.allPaths):he,[]);return ce.length&&(Y.allPaths=ce),Y}function f(V,z,ae){const de=B.sep===B.posix.sep,Y=de?V:V.replace(b,B.sep),ie=B.sep+Y,ce=B.posix.sep+V;let he;return ae?he=function(ue,se){return typeof ue=="string"&&(ue===Y||ue.endsWith(ie)||!de&&(ue===V||ue.endsWith(ce)))?z:null}:he=function(ue,se){return typeof ue=="string"&&(ue===Y||!de&&ue===V)?z:null},he.allPaths=[(ae?"*/":"./")+V],he}function S(V){try{const z=new RegExp(`^${s(V)}$`);return function(ae){return z.lastIndex=0,typeof ae=="string"&&z.test(ae)?V:null}}catch{return T}}function P(V,z,ae){return!V||typeof z!="string"?!1:$(V)(z,void 0,ae)}e.match=P;function $(V,z={}){if(!V)return a;if(typeof V=="string"||L(V)){const ae=r(V,z);if(ae===T)return a;const de=function(Y,ie){return!!ae(Y,ie)};return ae.allBasenames&&(de.allBasenames=ae.allBasenames),ae.allPaths&&(de.allPaths=ae.allPaths),de}return W(V,z)}e.parse=$;function L(V){const z=V;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=L;function v(V){return V.allBasenames||[]}e.getBasenameTerms=v;function H(V){return V.allPaths||[]}e.getPathTerms=H;function W(V,z){const ae=K(Object.getOwnPropertyNames(V).map(he=>q(he,V[he],z)).filter(he=>he!==T)),de=ae.length;if(!de)return T;if(!ae.some(he=>!!he.requiresSiblings)){if(de===1)return ae[0];const he=function(ge,Te){for(let Re=0,He=ae.length;Re<He;Re++){const Xe=ae[Re](ge,Te);if(Xe)return Xe}return null},ue=ae.find(ge=>!!ge.allBasenames);ue&&(he.allBasenames=ue.allBasenames);const se=ae.reduce((ge,Te)=>Te.allPaths?ge.concat(Te.allPaths):ge,[]);return se.length&&(he.allPaths=se),he}const Y=function(he,ue,se){let ge;for(let Te=0,Re=ae.length;Te<Re;Te++){const He=ae[Te];He.requiresSiblings&&se&&(ue||(ue=(0,B.basename)(he)),ge||(ge=ue.substr(0,ue.length-(0,B.extname)(he).length)));const Xe=He(he,ue,ge,se);if(Xe)return Xe}return null},ie=ae.find(he=>!!he.allBasenames);ie&&(Y.allBasenames=ie.allBasenames);const ce=ae.reduce((he,ue)=>ue.allPaths?he.concat(ue.allPaths):he,[]);return ce.length&&(Y.allPaths=ce),Y}function q(V,z,ae){if(z===!1)return T;const de=r(V,ae);if(de===T)return T;if(typeof z=="boolean")return de;if(z){const Y=z.when;if(typeof Y=="string"){const ie=(ce,he,ue,se)=>{if(!se||!de(ce,he))return null;const ge=Y.replace("$(basename)",ue),Te=se(ge);return(0,o.isThenable)(Te)?Te.then(Re=>Re?V:null):Te?V:null};return ie.requiresSiblings=!0,ie}}return de}function K(V,z){const ae=V.filter(he=>!!he.basenames);if(ae.length<2)return V;const de=ae.reduce((he,ue)=>{const se=ue.basenames;return se?he.concat(se):he},[]);let Y;if(z){Y=[];for(let he=0,ue=de.length;he<ue;he++)Y.push(z)}else Y=ae.reduce((he,ue)=>{const se=ue.patterns;return se?he.concat(se):he},[]);const ie=function(he,ue){if(typeof he!="string")return null;if(!ue){let ge;for(ge=he.length;ge>0;ge--){const Te=he.charCodeAt(ge-1);if(Te===47||Te===92)break}ue=he.substr(ge)}const se=de.indexOf(ue);return se!==-1?Y[se]:null};ie.basenames=de,ie.patterns=Y,ie.allBasenames=de;const ce=V.filter(he=>!he.basenames);return ce.push(ie),ce}}),define(we[72],be([1,0,15,105,24,9,2]),function(Z,e,o,k,w,B,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(h="",_=!1){if(this.value=h,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof _=="boolean"?(this.isTrusted=_,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=_.isTrusted??void 0,this.supportThemeIcons=_.supportThemeIcons??!1,this.supportHtml=_.supportHtml??!1)}appendText(h,_=0){return this.value+=c(this.supportThemeIcons?(0,k.escapeIcons)(h):h).replace(/([ \t]+)/g,(y,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,_===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,_){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=_,this.value+="\n```\n",this}appendLink(h,_,y){return this.value+="[",this.value+=this._escape(_,"]"),this.value+="](",this.value+=this._escape(String(h),")"),y&&(this.value+=` "${this._escape(this._escape(y,'"'),")")}"`),this.value+=")",this}_escape(h,_){const y=new RegExp((0,B.escapeRegExpCharacters)(_),"g");return h.replace(y,(d,p)=>h.charAt(p-1)!=="\\"?`\\${d}`:d)}}e.MarkdownString=D;function F(n){return N(n)?!n.value:Array.isArray(n)?n.every(F):!0}e.isEmptyMarkdownString=F;function N(n){return n instanceof D?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}e.isMarkdownString=N;function b(n,h){return n===h?!0:!n||!h?!1:n.value===h.value&&n.isTrusted===h.isTrusted&&n.supportThemeIcons===h.supportThemeIcons&&n.supportHtml===h.supportHtml&&(n.baseUri===h.baseUri||!!n.baseUri&&!!h.baseUri&&(0,w.isEqual)(C.URI.from(n.baseUri),C.URI.from(h.baseUri)))}e.markdownStringEqual=b;function c(n){return n.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=c;function g(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=g;function s(n){const h=[],_=n.split("|").map(d=>d.trim());n=_[0];const y=_[1];if(y){const d=/height=(\d+)/.exec(y),p=/width=(\d+)/.exec(y),E=d?d[1]:"",a=p?p[1]:"",T=isFinite(parseInt(a)),r=isFinite(parseInt(E));T&&h.push(`width="${a}"`),r&&h.push(`height="${E}"`)}return{href:n,dimensions:h}}e.parseHrefAndDimensions=s}),define(we[73],be([1,0,35,10,17,23,24,9,2]),function(Z,e,o,k,w,B,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function F(i,u,t){if(typeof i=="string"&&(i=D.URI.file(i)),t){const m=t.getWorkspaceFolder(i);if(m){const f=t.getWorkspace().folders.length>1;let S;if((0,C.isEqual)(m.uri,i)?S="":S=(0,C.relativePath)(m.uri,i),f){const P=m.name?m.name:(0,C.basename)(m.uri);S=S?P+" \u2022 "+S:P}return S}}if(i.scheme!==k.Schemas.file&&i.scheme!==k.Schemas.untitled)return i.with({query:null,fragment:null}).toString(!0);if((0,o.hasDriveLetter)(i.fsPath))return(0,w.normalize)(b(i.fsPath));let l=(0,w.normalize)(i.fsPath);return!B.isWindows&&u?.userHome&&(l=g(l,u.userHome.fsPath)),l}e.getPathLabel=F;function N(i){if(!i)return;typeof i=="string"&&(i=D.URI.file(i));const u=(0,C.basename)(i)||(i.scheme===k.Schemas.file?i.fsPath:i.path);return B.isWindows&&(0,o.isRootOrDriveLetter)(u)?b(u):u}e.getBaseLabel=N;function b(i,u){return(0,o.hasDriveLetter)(i,u)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=b;let c=Object.create(null);function g(i,u){if(B.isWindows||!i||!u)return i;let t=c.original===u?c.normalized:void 0;return t||(t=`${(0,A.rtrim)(u,w.posix.sep)}${w.posix.sep}`,c={original:u,normalized:t}),(B.isLinux?i.startsWith(t):(0,A.startsWithIgnoreCase)(i,t))&&(i=`~/${i.substr(t.length)}`),i}e.tildify=g;function s(i,u){return i.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=s;const n="\u2026",h="\\\\",_="~";function y(i,u=w.sep){const t=new Array(i.length);let l=!1;for(let m=0;m<i.length;m++){let f=i[m];if(f===""){t[m]=`.${u}`;continue}if(!f){t[m]=f;continue}l=!0;let S="";f.indexOf(h)===0?(S=f.substr(0,f.indexOf(h)+h.length),f=f.substr(f.indexOf(h)+h.length)):f.indexOf(u)===0?(S=f.substr(0,f.indexOf(u)+u.length),f=f.substr(f.indexOf(u)+u.length)):f.indexOf(_)===0&&(S=f.substr(0,f.indexOf(_)+_.length),f=f.substr(f.indexOf(_)+_.length));const P=f.split(u);for(let $=1;l&&$<=P.length;$++)for(let L=P.length-$;l&&L>=0;L--){l=!1;let v=P.slice(L,L+$).join(u);for(let H=0;!l&&H<i.length;H++)if(H!==m&&i[H]&&i[H].indexOf(v)>-1){const W=L+$===P.length,q=L>0&&i[H].indexOf(u)>-1?u+v:v,K=i[H].endsWith(q);l=!W||K}if(!l){let H="";(P[0].endsWith(":")||S!=="")&&(L===1&&(L=0,$++,v=P[0]+u+v),L>0&&(H=P[0]+u),H=S+H),L>0&&(H=H+n+u),H=H+v,L+$<P.length&&(H=H+u+n),t[m]=H}}l&&(t[m]=f)}return t}e.shorten=y;var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function p(i,u=Object.create(null)){const t=[];let l=!1,m="";for(const f of i)if(f==="$"||l&&f==="{")m&&t.push({value:m,type:d.TEXT}),m="",l=!0;else if(f==="}"&&l){const S=u[m];if(typeof S=="string")S.length&&t.push({value:S,type:d.VARIABLE});else if(S){const P=t[t.length-1];(!P||P.type!==d.SEPARATOR)&&t.push({value:S.label,type:d.SEPARATOR})}m="",l=!1}else m+=f;return m&&!l&&t.push({value:m,type:d.TEXT}),t.filter((f,S)=>{if(f.type===d.SEPARATOR){const P=t[S-1],$=t[S+1];return[P,$].every(L=>L&&(L.type===d.VARIABLE||L.type===d.TEXT)&&L.value.length>0)}return!0}).map(f=>f.value).join("")}e.template=p;function E(i,u){return B.isMacintosh||u?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,B.isMacintosh?"&":"&&"):i.replace(/&&|&/g,t=>t==="&"?"&&":"&")}e.mnemonicMenuLabel=E;function a(i,u){return B.isMacintosh||u?i.replace(/\(&&\w\)|&&/g,""):B.isWindows?i.replace(/&&|&/g,t=>t==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=a;function T(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=T;function r(i){const u=i.indexOf("/")!==-1?w.posix:w.win32,t=u.basename(i),l=u.dirname(i);return t.length?{name:t,parentPath:l}:{name:l,parentPath:""}}e.splitName=r}),define(we[108],be([1,0,2]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function k(N){return N.toJSON()}class w{constructor(b){this._uriTransformer=b}transformIncoming(b){const c=this._uriTransformer.transformIncoming(b);return c===b?b:k(o.URI.from(c))}transformOutgoing(b){const c=this._uriTransformer.transformOutgoing(b);return c===b?b:k(o.URI.from(c))}transformOutgoingURI(b){const c=this._uriTransformer.transformOutgoing(b);return c===b?b:o.URI.from(c)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(N){return N}transformOutgoing(N){return N}transformOutgoingURI(N){return N}transformOutgoingScheme(N){return N}};function B(N,b,c){if(!N||c>200)return null;if(typeof N=="object"){if(N instanceof o.URI)return b.transformOutgoing(N);for(let g in N)if(Object.hasOwnProperty.call(N,g)){const s=B(N[g],b,c+1);s!==null&&(N[g]=s)}}return null}function C(N,b){const c=B(N,b,0);return c===null?N:c}e.transformOutgoingURIs=C;function A(N,b,c,g){if(!N||g>200)return null;if(typeof N=="object"){if(N.$mid===1)return c?o.URI.revive(b.transformIncoming(N)):b.transformIncoming(N);for(let s in N)if(Object.hasOwnProperty.call(N,s)){const n=A(N[s],b,c,g+1);n!==null&&(N[s]=n)}}return null}function D(N,b){const c=A(N,b,!1,0);return c===null?N:c}e.transformIncomingURIs=D;function F(N,b){const c=A(N,b,!0,0);return c===null?N:c}e.transformAndReviveIncomingURIs=F}),define(we[36],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function k(D){return o.test(D)}e.isUUID=k;const w=new Uint8Array(16),B=[];for(let D=0;D<256;D++)B.push(D.toString(16).padStart(2,"0"));let C;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?C=crypto.getRandomValues.bind(crypto):C=function(D){for(let F=0;F<D.length;F++)D[F]=Math.floor(Math.random()*256);return D};function A(){C(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let D=0,F="";return F+=B[w[D++]],F+=B[w[D++]],F+=B[w[D++]],F+=B[w[D++]],F+="-",F+=B[w[D++]],F+=B[w[D++]],F+="-",F+=B[w[D++]],F+=B[w[D++]],F+="-",F+=B[w[D++]],F+=B[w[D++]],F+="-",F+=B[w[D++]],F+=B[w[D++]],F+=B[w[D++]],F+=B[w[D++]],F+=B[w[D++]],F+=B[w[D++]],F}e.generateUuid=A}),define(we[109],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1,useIndependentColorPoolPerBracketType:!1}}}),define(we[74],be([1,0,29,17]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function w(B,C,A,D,F){if(Array.isArray(B)){let N=0;for(const b of B){const c=w(b,C,A,D,F);if(c===10)return c;c>N&&(N=c)}return N}else{if(typeof B=="string")return D?B==="*"?5:B===A?10:0:0;if(B){const{language:N,pattern:b,scheme:c,hasAccessToAllModels:g,notebookType:s}=B;if(!D&&!g)return 0;let n=0;if(c)if(c===C.scheme)n=10;else if(c==="*")n=5;else return 0;if(N)if(N===A)n=10;else if(N==="*")n=Math.max(n,5);else return 0;if(s)if(s===F)n=10;else if(s==="*")n=Math.max(n,5);else return 0;if(b){let h;if(typeof b=="string"?h=b:h={...b,base:(0,k.normalize)(b.base)},h===C.fsPath||(0,o.match)(h,C.fsPath))n=10;else return 0}return n}else return 0}}e.score=w}),define(we[110],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(C){C[C.None=0]="None",C[C.Indent=1]="Indent",C[C.IndentOutdent=2]="IndentOutdent",C[C.Outdent=3]="Outdent"})(o=e.IndentAction||(e.IndentAction={}));class k{constructor(A){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=A.open,this.close=A.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(A.notIn))for(let D=0,F=A.notIn.length;D<F;D++)switch(A.notIn[D]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(A,D){if(A.getTokenCount()===0)return!0;const F=A.findTokenIndexAtOffset(D-2),N=A.getStandardTokenType(F);return this.isOK(N)}_findNeutralCharacterInRange(A,D){for(let F=A;F<=D;F++){const N=String.fromCharCode(F);if(!this.open.includes(N)&&!this.close.includes(N))return N}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=k;class w{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of A)B(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),B(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),B(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),B(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&B(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=w;function B(C,A,D){C.has(A)?C.get(A).push(D):C.set(A,[D])}}),define(we[75],be([1,0,21,23]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var w;(function(b){b[b.Full=1]="Full",b[b.Delta=2]="Delta"})(w||(w={}));function B(b){for(let c=0,g=b.length;c<g;c+=4){const s=b[c+0],n=b[c+1],h=b[c+2],_=b[c+3];b[c+0]=_,b[c+1]=h,b[c+2]=n,b[c+3]=s}}function C(b){const c=new Uint8Array(b.buffer,b.byteOffset,b.length*4);return k.isLittleEndian()||B(c),o.VSBuffer.wrap(c)}function A(b){const c=b.buffer;if(k.isLittleEndian()||B(c),c.byteOffset%4==0)return new Uint32Array(c.buffer,c.byteOffset,c.length/4);{const g=new Uint8Array(c.byteLength);return g.set(c),new Uint32Array(g.buffer,g.byteOffset,g.length/4)}}function D(b){const c=new Uint32Array(F(b));let g=0;if(c[g++]=b.id,b.type==="full")c[g++]=1,c[g++]=b.data.length,c.set(b.data,g),g+=b.data.length;else{c[g++]=2,c[g++]=b.deltas.length;for(const s of b.deltas)c[g++]=s.start,c[g++]=s.deleteCount,s.data?(c[g++]=s.data.length,c.set(s.data,g),g+=s.data.length):c[g++]=0}return C(c)}e.encodeSemanticTokensDto=D;function F(b){let c=0;if(c+=1+1,b.type==="full")c+=1+b.data.length;else{c+=1,c+=(1+1+1)*b.deltas.length;for(const g of b.deltas)g.data&&(c+=g.data.length)}return c}function N(b){const c=A(b);let g=0;const s=c[g++];if(c[g++]===1){const y=c[g++],d=c.subarray(g,g+y);return g+=y,{id:s,type:"full",data:d}}const h=c[g++],_=[];for(let y=0;y<h;y++){const d=c[g++],p=c[g++],E=c[g++];let a;E>0&&(a=c.subarray(g,g+E),g+=E),_[y]={start:d,deleteCount:p,data:a}}return{id:s,type:"delta",deltas:_}}e.decodeSemanticTokensDto=N}),define(we[111],be([18,19]),function(Z,e){return Z.create("vs/base/common/date",e)}),define(we[112],be([1,0,111]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const k=60,w=k*60,B=w*24,C=B*7,A=B*30,D=B*365;function F(b,c,g){typeof b!="number"&&(b=b.getTime());const s=Math.round((new Date().getTime()-b)/1e3);if(s<-30)return(0,o.localize)(0,null,F(new Date().getTime()+s*1e3,!1));if(s<30)return(0,o.localize)(1,null);let n;return s<k?(n=s,c?n===1?g?(0,o.localize)(2,null,n):(0,o.localize)(3,null,n):g?(0,o.localize)(4,null,n):(0,o.localize)(5,null,n):n===1?g?(0,o.localize)(6,null,n):(0,o.localize)(7,null,n):g?(0,o.localize)(8,null,n):(0,o.localize)(9,null,n)):s<w?(n=Math.floor(s/k),c?n===1?g?(0,o.localize)(10,null,n):(0,o.localize)(11,null,n):g?(0,o.localize)(12,null,n):(0,o.localize)(13,null,n):n===1?g?(0,o.localize)(14,null,n):(0,o.localize)(15,null,n):g?(0,o.localize)(16,null,n):(0,o.localize)(17,null,n)):s<B?(n=Math.floor(s/w),c?n===1?g?(0,o.localize)(18,null,n):(0,o.localize)(19,null,n):g?(0,o.localize)(20,null,n):(0,o.localize)(21,null,n):n===1?g?(0,o.localize)(22,null,n):(0,o.localize)(23,null,n):g?(0,o.localize)(24,null,n):(0,o.localize)(25,null,n)):s<C?(n=Math.floor(s/B),c?n===1?(0,o.localize)(26,null,n):(0,o.localize)(27,null,n):n===1?(0,o.localize)(28,null,n):(0,o.localize)(29,null,n)):s<A?(n=Math.floor(s/C),c?n===1?g?(0,o.localize)(30,null,n):(0,o.localize)(31,null,n):g?(0,o.localize)(32,null,n):(0,o.localize)(33,null,n):n===1?g?(0,o.localize)(34,null,n):(0,o.localize)(35,null,n):g?(0,o.localize)(36,null,n):(0,o.localize)(37,null,n)):s<D?(n=Math.floor(s/A),c?n===1?g?(0,o.localize)(38,null,n):(0,o.localize)(39,null,n):g?(0,o.localize)(40,null,n):(0,o.localize)(41,null,n):n===1?g?(0,o.localize)(42,null,n):(0,o.localize)(43,null,n):g?(0,o.localize)(44,null,n):(0,o.localize)(45,null,n)):(n=Math.floor(s/D),c?n===1?g?(0,o.localize)(46,null,n):(0,o.localize)(47,null,n):g?(0,o.localize)(48,null,n):(0,o.localize)(49,null,n):n===1?g?(0,o.localize)(50,null,n):(0,o.localize)(51,null,n):g?(0,o.localize)(52,null,n):(0,o.localize)(53,null,n))}e.fromNow=F;function N(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=N}),define(we[113],be([18,19]),function(Z,e){return Z.create("vs/base/common/errorMessage",e)}),define(we[43],be([1,0,16,11,113]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function B(b,c){return c&&(b.stack||b.stacktrace)?w.localize(0,null,A(b),C(b.stack)||C(b.stacktrace)):A(b)}function C(b){return Array.isArray(b)?b.join(`
`):b}function A(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?w.localize(1,null,b.message):b.message||w.localize(2,null)}function D(b=null,c=!1){if(!b)return w.localize(3,null);if(Array.isArray(b)){const g=o.coalesce(b),s=D(g[0],c);return g.length>1?w.localize(4,null,s,g.length):s}if(k.isString(b))return b;if(b.detail){const g=b.detail;if(g.error)return B(g.error,c);if(g.exception)return B(g.exception,c)}return b.stack?B(b,c):b.message?b.message:w.localize(5,null)}e.toErrorMessage=D;function F(b){const c=b;return c instanceof Error&&Array.isArray(c.actions)}e.isErrorWithActions=F;function N(b,c=Object.create(null)){const g=new Error(b);return c.actions&&(g.actions=c.actions),g}e.createErrorWithActions=N}),define(we[114],be([18,19]),function(Z,e){return Z.create("vs/editor/common/config/editorOptions",e)}),define(we[115],be([1,0,114,23,116,16,25,109]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(X){X[X.None=0]="None",X[X.Keep=1]="Keep",X[X.Brackets=2]="Brackets",X[X.Advanced=3]="Advanced",X[X.Full=4]="Full"})(D=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class F{constructor(J){this._values=J}hasChanged(J){return this._values[J]}}e.ConfigurationChangedEvent=F;class N{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=N;class b{constructor(J,le,Oe,$e){this.id=J,this.name=le,this.defaultValue=Oe,this.schema=$e}applyUpdate(J,le){return g(J,le)}compute(J,le,Oe){return Oe}}class c{constructor(J,le){this.newValue=J,this.didChange=le}}e.ApplyUpdateResult=c;function g(X,J){if(typeof X!="object"||typeof J!="object"||!X||!J)return new c(J,X!==J);if(Array.isArray(X)||Array.isArray(J)){const Oe=Array.isArray(X)&&Array.isArray(J)&&B.equals(X,J);return new c(J,Oe)}let le=!1;for(const Oe in J)if(J.hasOwnProperty(Oe)){const $e=g(X[Oe],J[Oe]);$e.didChange&&(X[Oe]=$e.newValue,le=!0)}return new c(X,le)}class s{constructor(J){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0}applyUpdate(J,le){return g(J,le)}validate(J){return this.defaultValue}}class n{constructor(J,le,Oe,$e){this.id=J,this.name=le,this.defaultValue=Oe,this.schema=$e}applyUpdate(J,le){return g(J,le)}validate(J){return typeof J=="undefined"?this.defaultValue:J}compute(J,le,Oe){return Oe}}function h(X,J){return typeof X=="undefined"?J:X==="false"?!1:Boolean(X)}e.boolean=h;class _ extends n{constructor(J,le,Oe,$e=void 0){typeof $e!="undefined"&&($e.type="boolean",$e.default=Oe);super(J,le,Oe,$e)}validate(J){return h(J,this.defaultValue)}}function y(X,J,le,Oe){if(typeof X=="undefined")return J;let $e=parseInt(X,10);return isNaN($e)?J:($e=Math.max(le,$e),$e=Math.min(Oe,$e),$e|0)}e.clampedInt=y;class d extends n{constructor(J,le,Oe,$e,Ge,Je=void 0){typeof Je!="undefined"&&(Je.type="integer",Je.default=Oe,Je.minimum=$e,Je.maximum=Ge);super(J,le,Oe,Je);this.minimum=$e,this.maximum=Ge}static clampedInt(J,le,Oe,$e){return y(J,le,Oe,$e)}validate(J){return d.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}class p extends n{constructor(J,le,Oe,$e,Ge){typeof Ge!="undefined"&&(Ge.type="number",Ge.default=Oe);super(J,le,Oe,Ge);this.validationFn=$e}static clamp(J,le,Oe){return J<le?le:J>Oe?Oe:J}static float(J,le){if(typeof J=="number")return J;if(typeof J=="undefined")return le;const Oe=parseFloat(J);return isNaN(Oe)?le:Oe}validate(J){return this.validationFn(p.float(J,this.defaultValue))}}class E extends n{static string(J,le){return typeof J!="string"?le:J}constructor(J,le,Oe,$e=void 0){typeof $e!="undefined"&&($e.type="string",$e.default=Oe);super(J,le,Oe,$e)}validate(J){return E.string(J,this.defaultValue)}}function a(X,J,le){return typeof X!="string"||le.indexOf(X)===-1?J:X}e.stringSet=a;class T extends n{constructor(J,le,Oe,$e,Ge=void 0){typeof Ge!="undefined"&&(Ge.type="string",Ge.enum=$e,Ge.default=Oe);super(J,le,Oe,Ge);this._allowedValues=$e}validate(J){return a(J,this.defaultValue,this._allowedValues)}}class r extends b{constructor(J,le,Oe,$e,Ge,Je,ht=void 0){typeof ht!="undefined"&&(ht.type="string",ht.enum=Ge,ht.default=$e);super(J,le,Oe,ht);this._allowedValues=Ge,this._convert=Je}validate(J){return typeof J!="string"?this.defaultValue:this._allowedValues.indexOf(J)===-1?this.defaultValue:this._convert(J)}}function i(X){switch(X){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class u extends b{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",description:o.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,le,Oe){return Oe===0?J.accessibilitySupport:Oe}}class t extends b{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:o.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{insertSpace:h(le.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:h(le.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var l;(function(X){X[X.Hidden=0]="Hidden",X[X.Blink=1]="Blink",X[X.Smooth=2]="Smooth",X[X.Phase=3]="Phase",X[X.Expand=4]="Expand",X[X.Solid=5]="Solid"})(l=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function m(X){switch(X){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(X){X[X.Line=1]="Line",X[X.Block=2]="Block",X[X.Underline=3]="Underline",X[X.LineThin=4]="LineThin",X[X.BlockOutline=5]="BlockOutline",X[X.UnderlineThin=6]="UnderlineThin"})(f=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function S(X){switch(X){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=S;function P(X){switch(X){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class $ extends s{constructor(){super(128)}compute(J,le,Oe){const $e=["monaco-editor"];return le.get(33)&&$e.push(le.get(33)),J.extraEditorClassName&&$e.push(J.extraEditorClassName),le.get(66)==="default"?$e.push("mouse-default"):le.get(66)==="copy"&&$e.push("mouse-copy"),le.get(100)&&$e.push("showUnused"),le.get(126)&&$e.push("showDeprecated"),$e.join(" ")}}class L extends _{constructor(){super(32,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(J,le,Oe){return Oe&&J.emptySelectionClipboard}}class v extends b{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(35,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:o.localize(16,null),included:k.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:o.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{cursorMoveOnType:h(le.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":a(le.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":a(le.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:h(le.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:h(le.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:h(le.loop,this.defaultValue.loop)}}}class H extends b{constructor(){super(45,"fontLigatures",H.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(J){return typeof J=="undefined"?this.defaultValue:typeof J=="string"?J==="false"?H.OFF:J==="true"?H.ON:J:Boolean(J)?H.ON:H.OFF}}e.EditorFontLigatures=H,H.OFF='"liga" off, "calt" off',H.ON='"liga" on, "calt" on';class W extends s{constructor(){super(44)}compute(J,le,Oe){return J.fontInfo}}class q extends n{constructor(){super(46,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(22,null)})}validate(J){const le=p.float(J,this.defaultValue);return le===0?e.EDITOR_FONT_DEFAULTS.fontSize:p.clamp(le,6,100)}compute(J,le,Oe){return J.fontInfo.fontSize}}class K extends b{constructor(){super(47,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:o.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(24,null)})}validate(J){return J==="normal"||J==="bold"?J:String(d.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class V extends b{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},le={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[o.localize(25,null),o.localize(26,null),o.localize(27,null)]},Oe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(51,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(29,null),...le},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(30,null),...le},"editor.gotoLocation.multipleDeclarations":{description:o.localize(31,null),...le},"editor.gotoLocation.multipleImplementations":{description:o.localize(32,null),...le},"editor.gotoLocation.multipleReferences":{description:o.localize(33,null),...le},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Oe,description:o.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Oe,description:o.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Oe,description:o.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Oe,description:o.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Oe,description:o.localize(38,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{multiple:a(le.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:le.multipleDefinitions??a(le.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:le.multipleTypeDefinitions??a(le.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:le.multipleDeclarations??a(le.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:le.multipleImplementations??a(le.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:le.multipleReferences??a(le.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:E.string(le.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:E.string(le.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:E.string(le.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:E.string(le.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:E.string(le.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class z extends b{constructor(){const J={enabled:!0,delay:300,sticky:!0,above:!0};super(53,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:o.localize(39,null)},"editor.hover.delay":{type:"number",default:J.delay,minimum:0,maximum:1e4,description:o.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:o.localize(41,null)},"editor.hover.above":{type:"boolean",default:J.above,description:o.localize(42,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{enabled:h(le.enabled,this.defaultValue.enabled),delay:d.clampedInt(le.delay,this.defaultValue.delay,0,1e4),sticky:h(le.sticky,this.defaultValue.sticky),above:h(le.above,this.defaultValue.above)}}}var ae;(function(X){X[X.None=0]="None",X[X.Text=1]="Text",X[X.Blocks=2]="Blocks"})(ae=e.RenderMinimap||(e.RenderMinimap={}));class de extends s{constructor(){super(131)}compute(J,le,Oe){return de.computeLayout(le,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio})}static computeContainedMinimapLineCount(J){const le=J.height/J.lineHeight,Oe=J.scrollBeyondLastLine?le-1:0,$e=(J.viewLineCount+Oe)/(J.pixelRatio*J.height),Ge=Math.floor(J.viewLineCount/$e);return{typicalViewportLineCount:le,extraLinesBeyondLastLine:Oe,desiredRatio:$e,minimapLineCount:Ge}}static _computeMinimapLayout(J,le){const Oe=J.outerWidth,$e=J.outerHeight,Ge=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ge*$e),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:$e};const Je=le.stableMinimapLayoutInput,ht=Je&&J.outerHeight===Je.outerHeight&&J.lineHeight===Je.lineHeight&&J.typicalHalfwidthCharacterWidth===Je.typicalHalfwidthCharacterWidth&&J.pixelRatio===Je.pixelRatio&&J.scrollBeyondLastLine===Je.scrollBeyondLastLine&&J.minimap.enabled===Je.minimap.enabled&&J.minimap.side===Je.minimap.side&&J.minimap.size===Je.minimap.size&&J.minimap.showSlider===Je.minimap.showSlider&&J.minimap.renderCharacters===Je.minimap.renderCharacters&&J.minimap.maxColumn===Je.minimap.maxColumn&&J.minimap.scale===Je.minimap.scale&&J.verticalScrollbarWidth===Je.verticalScrollbarWidth&&J.isViewportWrapping===Je.isViewportWrapping,It=J.lineHeight,St=J.typicalHalfwidthCharacterWidth,kt=J.scrollBeyondLastLine,qe=J.minimap.renderCharacters;let vt=Ge>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Nt=J.minimap.maxColumn,nt=J.minimap.size,ut=J.minimap.side,At=J.verticalScrollbarWidth,Tt=J.viewLineCount,bt=J.remainingWidth,dt=J.isViewportWrapping,Rt=qe?2:3;let Lt=Math.floor(Ge*$e);const Ft=Lt/Ge;let Ue=!1,me=!1,pe=Rt*vt,oe=vt/Ge,G=1;if(nt==="fill"||nt==="fit"){const{typicalViewportLineCount:Et,extraLinesBeyondLastLine:rt,desiredRatio:at,minimapLineCount:ot}=de.computeContainedMinimapLineCount({viewLineCount:Tt,scrollBeyondLastLine:kt,height:$e,lineHeight:It,pixelRatio:Ge});if(Tt/ot>1)Ue=!0,me=!0,vt=1,pe=1,oe=vt/Ge;else{let ft=!1,Dt=vt+1;if(nt==="fit"){const Ut=Math.ceil((Tt+rt)*pe);dt&&ht&&bt<=le.stableFitRemainingWidth?(ft=!0,Dt=le.stableFitMaxMinimapScale):ft=Ut>Lt}if(nt==="fill"||ft){Ue=!0;const Ut=vt;pe=Math.min(It*Ge,Math.max(1,Math.floor(1/at))),dt&&ht&&bt<=le.stableFitRemainingWidth&&(Dt=le.stableFitMaxMinimapScale),vt=Math.min(Dt,Math.max(1,Math.floor(pe/Rt))),vt>Ut&&(G=Math.min(2,vt/Ut)),oe=vt/Ge/G,Lt=Math.ceil(Math.max(Et,Tt+rt)*pe),dt?(le.stableMinimapLayoutInput=J,le.stableFitRemainingWidth=bt,le.stableFitMaxMinimapScale=vt):(le.stableMinimapLayoutInput=null,le.stableFitRemainingWidth=0)}}}const Se=Math.floor(Nt*oe),Ce=Math.min(Se,Math.max(0,Math.floor((bt-At-2)*oe/(St+oe)))+e.MINIMAP_GUTTER_WIDTH);let xe=Math.floor(Ge*Ce);const je=xe/Ge;xe=Math.floor(xe*G);const lt=qe?1:2,gt=ut==="left"?0:Oe-Ce-At;return{renderMinimap:lt,minimapLeft:gt,minimapWidth:Ce,minimapHeightIsEditorHeight:Ue,minimapIsSampling:me,minimapScale:vt,minimapLineHeight:pe,minimapCanvasInnerWidth:xe,minimapCanvasInnerHeight:Lt,minimapCanvasOuterWidth:je,minimapCanvasOuterHeight:Ft}}static computeLayout(J,le){const Oe=le.outerWidth|0,$e=le.outerHeight|0,Ge=le.lineHeight|0,Je=le.lineNumbersDigitCount|0,ht=le.typicalHalfwidthCharacterWidth,It=le.maxDigitWidth,St=le.pixelRatio,kt=le.viewLineCount,qe=J.get(123),vt=qe==="inherit"?J.get(122):qe,Nt=vt==="inherit"?J.get(118):vt,nt=J.get(121),ut=J.get(2),At=le.isDominatedByLongLines,Tt=J.get(50),bt=J.get(60).renderType!==0,dt=J.get(61),Rt=J.get(94),Lt=J.get(65),Ft=J.get(92),Ue=Ft.verticalScrollbarSize,me=Ft.verticalHasArrows,pe=Ft.arrowSize,oe=Ft.horizontalScrollbarSize,G=J.get(58),Se=J.get(37);let Ce;if(typeof G=="string"&&/^\d+(\.\d+)?ch$/.test(G)){const Wt=parseFloat(G.substr(0,G.length-2));Ce=d.clampedInt(Wt*ht,0,0,1e3)}else Ce=d.clampedInt(G,0,0,1e3);Se&&(Ce+=16);let xe=0;if(bt){const Wt=Math.max(Je,dt);xe=Math.round(Wt*It)}let je=0;Tt&&(je=Ge);let lt=0,gt=lt+je,Et=gt+xe,rt=Et+Ce;const at=Oe-je-xe-Ce;let ot=!1,Mt=!1,ft=-1;ut!==2&&(vt==="inherit"&&At?(ot=!0,Mt=!0):Nt==="on"||Nt==="bounded"?Mt=!0:Nt==="wordWrapColumn"&&(ft=nt));const Dt=de._computeMinimapLayout({outerWidth:Oe,outerHeight:$e,lineHeight:Ge,typicalHalfwidthCharacterWidth:ht,pixelRatio:St,scrollBeyondLastLine:Rt,minimap:Lt,verticalScrollbarWidth:Ue,viewLineCount:kt,remainingWidth:at,isViewportWrapping:Mt},le.memory||new N);Dt.renderMinimap!==0&&Dt.minimapLeft===0&&(lt+=Dt.minimapWidth,gt+=Dt.minimapWidth,Et+=Dt.minimapWidth,rt+=Dt.minimapWidth);const Ut=at-Dt.minimapWidth,wt=Math.max(1,Math.floor((Ut-Ue-2)/ht)),Bt=me?pe:0;return Mt&&(ft=Math.max(1,wt),Nt==="bounded"&&(ft=Math.min(ft,nt))),{width:Oe,height:$e,glyphMarginLeft:lt,glyphMarginWidth:je,lineNumbersLeft:gt,lineNumbersWidth:xe,decorationsLeft:Et,decorationsWidth:Ce,contentLeft:rt,contentWidth:Ut,minimap:Dt,viewportColumn:wt,isWordWrapMinified:ot,isViewportWrapping:Mt,wrappingColumn:ft,verticalScrollbarWidth:Ue,horizontalScrollbarHeight:oe,overviewRuler:{top:Bt,width:Ue,height:$e-2*Bt,right:0}}}}e.EditorLayoutInfoComputer=de;class Y extends b{constructor(){const J={enabled:!0};super(57,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:o.localize(43,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:h(J.enabled,this.defaultValue.enabled)}}}class ie extends b{constructor(){const J={enabled:!0,fontSize:0,fontFamily:""};super(127,"inlayHints",J,{"editor.inlayHints.enabled":{type:"boolean",default:J.enabled,description:o.localize(44,null)},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:o.localize(45,null)},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:o.localize(46,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{enabled:h(le.enabled,this.defaultValue.enabled),fontSize:d.clampedInt(le.fontSize,this.defaultValue.fontSize,0,100),fontFamily:E.string(le.fontFamily,this.defaultValue.fontFamily)}}}class ce extends p{constructor(){super(59,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>p.clamp(J,0,150),{markdownDescription:o.localize(47,null)})}compute(J,le,Oe){return J.fontInfo.lineHeight}}class he extends b{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(65,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:o.localize(48,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(49,null),o.localize(50,null),o.localize(51,null)],default:J.size,description:o.localize(52,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:o.localize(53,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:o.localize(54,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(55,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:o.localize(56,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:o.localize(57,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{enabled:h(le.enabled,this.defaultValue.enabled),size:a(le.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(le.side,this.defaultValue.side,["right","left"]),showSlider:a(le.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:h(le.renderCharacters,this.defaultValue.renderCharacters),scale:d.clampedInt(le.scale,1,1,3),maxColumn:d.clampedInt(le.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ue(X){return X==="ctrlCmd"?k.isMacintosh?"metaKey":"ctrlKey":"altKey"}class se extends b{constructor(){super(75,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(58,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(59,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{top:d.clampedInt(le.top,0,0,1e3),bottom:d.clampedInt(le.bottom,0,0,1e3)}}}class ge extends b{constructor(){const J={enabled:!0,cycle:!1};super(76,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:o.localize(60,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:o.localize(61,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{enabled:h(le.enabled,this.defaultValue.enabled),cycle:h(le.cycle,this.defaultValue.cycle)}}}class Te extends s{constructor(){super(129)}compute(J,le,Oe){return J.pixelRatio}}class Re extends b{constructor(){const J={other:!0,comments:!1,strings:!1};super(79,"quickSuggestions",J,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:J.strings,description:o.localize(62,null)},comments:{type:"boolean",default:J.comments,description:o.localize(63,null)},other:{type:"boolean",default:J.other,description:o.localize(64,null)}}}],default:J,description:o.localize(65,null)});this.defaultValue=J}validate(J){if(typeof J=="boolean")return J;if(J&&typeof J=="object"){const le=J,Oe={other:h(le.other,this.defaultValue.other),comments:h(le.comments,this.defaultValue.comments),strings:h(le.strings,this.defaultValue.strings)};return Oe.other&&Oe.comments&&Oe.strings?!0:!Oe.other&&!Oe.comments&&!Oe.strings?!1:Oe}return this.defaultValue}}var He;(function(X){X[X.Off=0]="Off",X[X.On=1]="On",X[X.Relative=2]="Relative",X[X.Interval=3]="Interval",X[X.Custom=4]="Custom"})(He=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Xe extends b{constructor(){super(60,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(66,null),o.localize(67,null),o.localize(68,null),o.localize(69,null)],default:"on",description:o.localize(70,null)})}validate(J){let le=this.defaultValue.renderType,Oe=this.defaultValue.renderFn;return typeof J!="undefined"&&(typeof J=="function"?(le=4,Oe=J):J==="interval"?le=3:J==="relative"?le=2:J==="on"?le=1:le=0),{renderType:le,renderFn:Oe}}}function ve(X){const J=X.get(87);return J==="editable"?X.get(81):J!=="on"}e.filterValidationDecorations=ve;class fe extends b{constructor(){const J=[],le={type:"number",description:o.localize(71,null)};super(91,"rulers",J,{type:"array",items:{anyOf:[le,{type:["object"],properties:{column:le,color:{type:"string",description:o.localize(72,null),format:"color-hex"}}}]},default:J,description:o.localize(73,null)})}validate(J){if(Array.isArray(J)){const le=[];for(let Oe of J)if(typeof Oe=="number")le.push({column:d.clampedInt(Oe,0,0,1e4),color:null});else if(Oe&&typeof Oe=="object"){const $e=Oe;le.push({column:d.clampedInt($e.column,0,0,1e4),color:$e.color})}return le.sort((Oe,$e)=>Oe.column-$e.column),le}return this.defaultValue}}function M(X,J){if(typeof X!="string")return J;switch(X){case"hidden":return 2;case"visible":return 3;default:return 1}}class O extends b{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(74,null),o.localize(75,null),o.localize(76,null)],default:"auto",description:o.localize(77,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(78,null),o.localize(79,null),o.localize(80,null)],default:"auto",description:o.localize(81,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:o.localize(82,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:o.localize(83,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:o.localize(84,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J,Oe=d.clampedInt(le.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),$e=d.clampedInt(le.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:d.clampedInt(le.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:M(le.vertical,this.defaultValue.vertical),horizontal:M(le.horizontal,this.defaultValue.horizontal),useShadows:h(le.useShadows,this.defaultValue.useShadows),verticalHasArrows:h(le.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:h(le.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:h(le.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:h(le.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Oe,horizontalSliderSize:d.clampedInt(le.horizontalSliderSize,Oe,0,1e3),verticalScrollbarSize:$e,verticalSliderSize:d.clampedInt(le.verticalSliderSize,$e,0,1e3),scrollByPage:h(le.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class I extends b{constructor(){const J={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(113,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.nonBasicASCII,description:o.localize(85,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:J.invisibleCharacters,description:o.localize(86,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:J.ambiguousCharacters,description:o.localize(87,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeComments,description:o.localize(88,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeStrings,description:o.localize(89,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:J.allowedCharacters,description:o.localize(90,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:J.allowedLocales,description:o.localize(91,null)}})}applyUpdate(J,le){let Oe=!1;le.allowedCharacters&&(C.equals(J.allowedCharacters,le.allowedCharacters)||(J={...J,allowedCharacters:le.allowedCharacters},Oe=!0)),le.allowedLocales&&(C.equals(J.allowedLocales,le.allowedLocales)||(J={...J,allowedLocales:le.allowedLocales},Oe=!0));const $e=super.applyUpdate(J,le);return Oe?new c($e.newValue,!0):$e}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{nonBasicASCII:ne(le.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:h(le.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:h(le.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ne(le.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ne(le.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(J.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(J.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(J,le){if(typeof J!="object"||!J)return le;const Oe={};for(const[$e,Ge]of Object.entries(J))Ge===!0&&(Oe[$e]=!0);return Oe}}class R extends b{constructor(){const J={enabled:!0,mode:"subwordSmart"};super(55,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:o.localize(92,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{enabled:h(le.enabled,this.defaultValue.enabled),mode:a(le.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class x extends b{constructor(){const J={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,useIndependentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.useIndependentColorPoolPerBracketType};super(12,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,description:o.localize(93,null)},"editor.bracketPairColorization.useIndependentColorPoolPerBracketType":{type:"boolean",default:J.useIndependentColorPoolPerBracketType,description:o.localize(94,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{enabled:h(le.enabled,this.defaultValue.enabled),useIndependentColorPoolPerBracketType:h(le.useIndependentColorPoolPerBracketType,this.defaultValue.useIndependentColorPoolPerBracketType)}}}class Q extends b{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(95,null),o.localize(96,null),o.localize(97,null)],default:J.bracketPairs,description:o.localize(98,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(99,null),o.localize(100,null),o.localize(101,null)],default:J.bracketPairsHorizontal,description:o.localize(102,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:o.localize(103,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:o.localize(104,null)},"editor.guides.highlightActiveIndentation":{type:"boolean",default:J.highlightActiveIndentation,description:o.localize(105,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{bracketPairs:ne(le.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ne(le.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:h(le.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:h(le.indentation,this.defaultValue.indentation),highlightActiveIndentation:h(le.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation)}}}function ne(X,J,le){const Oe=le.indexOf(X);return Oe===-1?J:le[Oe]}class Ee extends b{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(106,null),o.localize(107,null)],default:J.insertMode,description:o.localize(108,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:o.localize(109,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:o.localize(110,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:o.localize(111,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:o.localize(112,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:o.localize(113,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:o.localize(114,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:o.localize(115,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:o.localize(116,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(117,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(118,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(119,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(120,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(121,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(122,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(123,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(124,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(125,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(126,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(127,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(128,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(129,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(130,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(131,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(132,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(133,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(134,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(135,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(136,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(137,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(138,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(139,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(140,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(141,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(142,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(143,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(144,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(145,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(146,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(147,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const le=J;return{insertMode:a(le.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:h(le.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:h(le.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:h(le.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:h(le.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:h(le.showIcons,this.defaultValue.showIcons),showStatusBar:h(le.showStatusBar,this.defaultValue.showStatusBar),preview:h(le.preview,this.defaultValue.preview),previewMode:a(le.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:h(le.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:h(le.showMethods,this.defaultValue.showMethods),showFunctions:h(le.showFunctions,this.defaultValue.showFunctions),showConstructors:h(le.showConstructors,this.defaultValue.showConstructors),showDeprecated:h(le.showDeprecated,this.defaultValue.showDeprecated),showFields:h(le.showFields,this.defaultValue.showFields),showVariables:h(le.showVariables,this.defaultValue.showVariables),showClasses:h(le.showClasses,this.defaultValue.showClasses),showStructs:h(le.showStructs,this.defaultValue.showStructs),showInterfaces:h(le.showInterfaces,this.defaultValue.showInterfaces),showModules:h(le.showModules,this.defaultValue.showModules),showProperties:h(le.showProperties,this.defaultValue.showProperties),showEvents:h(le.showEvents,this.defaultValue.showEvents),showOperators:h(le.showOperators,this.defaultValue.showOperators),showUnits:h(le.showUnits,this.defaultValue.showUnits),showValues:h(le.showValues,this.defaultValue.showValues),showConstants:h(le.showConstants,this.defaultValue.showConstants),showEnums:h(le.showEnums,this.defaultValue.showEnums),showEnumMembers:h(le.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:h(le.showKeywords,this.defaultValue.showKeywords),showWords:h(le.showWords,this.defaultValue.showWords),showColors:h(le.showColors,this.defaultValue.showColors),showFiles:h(le.showFiles,this.defaultValue.showFiles),showReferences:h(le.showReferences,this.defaultValue.showReferences),showFolders:h(le.showFolders,this.defaultValue.showFolders),showTypeParameters:h(le.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:h(le.showSnippets,this.defaultValue.showSnippets),showUsers:h(le.showUsers,this.defaultValue.showUsers),showIssues:h(le.showIssues,this.defaultValue.showIssues)}}}class Ie extends b{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(148,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:h(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class Me extends s{constructor(){super(130)}compute(J,le,Oe){return le.get(81)?!0:J.tabFocusMode}}var Le;(function(X){X[X.None=0]="None",X[X.Same=1]="Same",X[X.Indent=2]="Indent",X[X.DeepIndent=3]="DeepIndent"})(Le=e.WrappingIndent||(e.WrappingIndent={}));function ze(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class Be extends s{constructor(){super(132)}compute(J,le,Oe){const $e=le.get(131);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:$e.isWordWrapMinified,isViewportWrapping:$e.isViewportWrapping,wrappingColumn:$e.wrappingColumn}}}const Ae="Consolas, 'Courier New', monospace",Qe="Menlo, Monaco, 'Courier New', monospace",tt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:k.isMacintosh?Qe:k.isLinux?tt:Ae,fontWeight:"normal",fontSize:k.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(X){return e.editorOptionsRegistry[X.id]=X,X}var it;(function(X){X[X.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",X[X.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",X[X.accessibilitySupport=2]="accessibilitySupport",X[X.accessibilityPageSize=3]="accessibilityPageSize",X[X.ariaLabel=4]="ariaLabel",X[X.autoClosingBrackets=5]="autoClosingBrackets",X[X.autoClosingDelete=6]="autoClosingDelete",X[X.autoClosingOvertype=7]="autoClosingOvertype",X[X.autoClosingQuotes=8]="autoClosingQuotes",X[X.autoIndent=9]="autoIndent",X[X.automaticLayout=10]="automaticLayout",X[X.autoSurround=11]="autoSurround",X[X.bracketPairColorization=12]="bracketPairColorization",X[X.guides=13]="guides",X[X.codeLens=14]="codeLens",X[X.codeLensFontFamily=15]="codeLensFontFamily",X[X.codeLensFontSize=16]="codeLensFontSize",X[X.colorDecorators=17]="colorDecorators",X[X.columnSelection=18]="columnSelection",X[X.comments=19]="comments",X[X.contextmenu=20]="contextmenu",X[X.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",X[X.cursorBlinking=22]="cursorBlinking",X[X.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",X[X.cursorStyle=24]="cursorStyle",X[X.cursorSurroundingLines=25]="cursorSurroundingLines",X[X.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",X[X.cursorWidth=27]="cursorWidth",X[X.disableLayerHinting=28]="disableLayerHinting",X[X.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",X[X.domReadOnly=30]="domReadOnly",X[X.dragAndDrop=31]="dragAndDrop",X[X.emptySelectionClipboard=32]="emptySelectionClipboard",X[X.extraEditorClassName=33]="extraEditorClassName",X[X.fastScrollSensitivity=34]="fastScrollSensitivity",X[X.find=35]="find",X[X.fixedOverflowWidgets=36]="fixedOverflowWidgets",X[X.folding=37]="folding",X[X.foldingStrategy=38]="foldingStrategy",X[X.foldingHighlight=39]="foldingHighlight",X[X.foldingImportsByDefault=40]="foldingImportsByDefault",X[X.foldingMaximumRegions=41]="foldingMaximumRegions",X[X.unfoldOnClickAfterEndOfLine=42]="unfoldOnClickAfterEndOfLine",X[X.fontFamily=43]="fontFamily",X[X.fontInfo=44]="fontInfo",X[X.fontLigatures=45]="fontLigatures",X[X.fontSize=46]="fontSize",X[X.fontWeight=47]="fontWeight",X[X.formatOnPaste=48]="formatOnPaste",X[X.formatOnType=49]="formatOnType",X[X.glyphMargin=50]="glyphMargin",X[X.gotoLocation=51]="gotoLocation",X[X.hideCursorInOverviewRuler=52]="hideCursorInOverviewRuler",X[X.hover=53]="hover",X[X.inDiffEditor=54]="inDiffEditor",X[X.inlineSuggest=55]="inlineSuggest",X[X.letterSpacing=56]="letterSpacing",X[X.lightbulb=57]="lightbulb",X[X.lineDecorationsWidth=58]="lineDecorationsWidth",X[X.lineHeight=59]="lineHeight",X[X.lineNumbers=60]="lineNumbers",X[X.lineNumbersMinChars=61]="lineNumbersMinChars",X[X.linkedEditing=62]="linkedEditing",X[X.links=63]="links",X[X.matchBrackets=64]="matchBrackets",X[X.minimap=65]="minimap",X[X.mouseStyle=66]="mouseStyle",X[X.mouseWheelScrollSensitivity=67]="mouseWheelScrollSensitivity",X[X.mouseWheelZoom=68]="mouseWheelZoom",X[X.multiCursorMergeOverlapping=69]="multiCursorMergeOverlapping",X[X.multiCursorModifier=70]="multiCursorModifier",X[X.multiCursorPaste=71]="multiCursorPaste",X[X.occurrencesHighlight=72]="occurrencesHighlight",X[X.overviewRulerBorder=73]="overviewRulerBorder",X[X.overviewRulerLanes=74]="overviewRulerLanes",X[X.padding=75]="padding",X[X.parameterHints=76]="parameterHints",X[X.peekWidgetDefaultFocus=77]="peekWidgetDefaultFocus",X[X.definitionLinkOpensInPeek=78]="definitionLinkOpensInPeek",X[X.quickSuggestions=79]="quickSuggestions",X[X.quickSuggestionsDelay=80]="quickSuggestionsDelay",X[X.readOnly=81]="readOnly",X[X.renameOnType=82]="renameOnType",X[X.renderControlCharacters=83]="renderControlCharacters",X[X.renderFinalNewline=84]="renderFinalNewline",X[X.renderLineHighlight=85]="renderLineHighlight",X[X.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",X[X.renderValidationDecorations=87]="renderValidationDecorations",X[X.renderWhitespace=88]="renderWhitespace",X[X.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",X[X.roundedSelection=90]="roundedSelection",X[X.rulers=91]="rulers",X[X.scrollbar=92]="scrollbar",X[X.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",X[X.scrollBeyondLastLine=94]="scrollBeyondLastLine",X[X.scrollPredominantAxis=95]="scrollPredominantAxis",X[X.selectionClipboard=96]="selectionClipboard",X[X.selectionHighlight=97]="selectionHighlight",X[X.selectOnLineNumbers=98]="selectOnLineNumbers",X[X.showFoldingControls=99]="showFoldingControls",X[X.showUnused=100]="showUnused",X[X.snippetSuggestions=101]="snippetSuggestions",X[X.smartSelect=102]="smartSelect",X[X.smoothScrolling=103]="smoothScrolling",X[X.stickyTabStops=104]="stickyTabStops",X[X.stopRenderingLineAfter=105]="stopRenderingLineAfter",X[X.suggest=106]="suggest",X[X.suggestFontSize=107]="suggestFontSize",X[X.suggestLineHeight=108]="suggestLineHeight",X[X.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",X[X.suggestSelection=110]="suggestSelection",X[X.tabCompletion=111]="tabCompletion",X[X.tabIndex=112]="tabIndex",X[X.unicodeHighlighting=113]="unicodeHighlighting",X[X.unusualLineTerminators=114]="unusualLineTerminators",X[X.useShadowDOM=115]="useShadowDOM",X[X.useTabStops=116]="useTabStops",X[X.wordSeparators=117]="wordSeparators",X[X.wordWrap=118]="wordWrap",X[X.wordWrapBreakAfterCharacters=119]="wordWrapBreakAfterCharacters",X[X.wordWrapBreakBeforeCharacters=120]="wordWrapBreakBeforeCharacters",X[X.wordWrapColumn=121]="wordWrapColumn",X[X.wordWrapOverride1=122]="wordWrapOverride1",X[X.wordWrapOverride2=123]="wordWrapOverride2",X[X.wrappingIndent=124]="wrappingIndent",X[X.wrappingStrategy=125]="wrappingStrategy",X[X.showDeprecated=126]="showDeprecated",X[X.inlayHints=127]="inlayHints",X[X.editorClassName=128]="editorClassName",X[X.pixelRatio=129]="pixelRatio",X[X.tabFocusMode=130]="tabFocusMode",X[X.layoutInfo=131]="layoutInfo",X[X.wrappingInfo=132]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new _(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(149,null)})),acceptSuggestionOnEnter:ke(new T(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(150,null),""],markdownDescription:o.localize(151,null)})),accessibilitySupport:ke(new u),accessibilityPageSize:ke(new d(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(152,null)})),ariaLabel:ke(new E(4,"ariaLabel",o.localize(153,null))),autoClosingBrackets:ke(new T(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(154,null),o.localize(155,null),""],description:o.localize(156,null)})),autoClosingDelete:ke(new T(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(157,null),""],description:o.localize(158,null)})),autoClosingOvertype:ke(new T(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(159,null),""],description:o.localize(160,null)})),autoClosingQuotes:ke(new T(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(161,null),o.localize(162,null),""],description:o.localize(163,null)})),autoIndent:ke(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[o.localize(164,null),o.localize(165,null),o.localize(166,null),o.localize(167,null),o.localize(168,null)],description:o.localize(169,null)})),automaticLayout:ke(new _(10,"automaticLayout",!1)),autoSurround:ke(new T(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(170,null),o.localize(171,null),o.localize(172,null),""],description:o.localize(173,null)})),bracketPairColorization:ke(new x),bracketPairGuides:ke(new Q),stickyTabStops:ke(new _(104,"stickyTabStops",!1,{description:o.localize(174,null)})),codeLens:ke(new _(14,"codeLens",!0,{description:o.localize(175,null)})),codeLensFontFamily:ke(new E(15,"codeLensFontFamily","",{description:o.localize(176,null)})),codeLensFontSize:ke(new d(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(177,null)})),colorDecorators:ke(new _(17,"colorDecorators",!0,{description:o.localize(178,null)})),columnSelection:ke(new _(18,"columnSelection",!1,{description:o.localize(179,null)})),comments:ke(new t),contextmenu:ke(new _(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new _(21,"copyWithSyntaxHighlighting",!0,{description:o.localize(180,null)})),cursorBlinking:ke(new r(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:o.localize(181,null)})),cursorSmoothCaretAnimation:ke(new _(23,"cursorSmoothCaretAnimation",!1,{description:o.localize(182,null)})),cursorStyle:ke(new r(24,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:o.localize(183,null)})),cursorSurroundingLines:ke(new d(25,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(184,null)})),cursorSurroundingLinesStyle:ke(new T(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(185,null),o.localize(186,null)],description:o.localize(187,null)})),cursorWidth:ke(new d(27,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(188,null)})),disableLayerHinting:ke(new _(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new _(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new _(30,"domReadOnly",!1)),dragAndDrop:ke(new _(31,"dragAndDrop",!0,{description:o.localize(189,null)})),emptySelectionClipboard:ke(new L),extraEditorClassName:ke(new E(33,"extraEditorClassName","")),fastScrollSensitivity:ke(new p(34,"fastScrollSensitivity",5,X=>X<=0?5:X,{markdownDescription:o.localize(190,null)})),find:ke(new v),fixedOverflowWidgets:ke(new _(36,"fixedOverflowWidgets",!1)),folding:ke(new _(37,"folding",!0,{description:o.localize(191,null)})),foldingStrategy:ke(new T(38,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(192,null),o.localize(193,null)],description:o.localize(194,null)})),foldingHighlight:ke(new _(39,"foldingHighlight",!0,{description:o.localize(195,null)})),foldingImportsByDefault:ke(new _(40,"foldingImportsByDefault",!1,{description:o.localize(196,null)})),foldingMaximumRegions:ke(new d(41,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(197,null)})),unfoldOnClickAfterEndOfLine:ke(new _(42,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(198,null)})),fontFamily:ke(new E(43,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(199,null)})),fontInfo:ke(new W),fontLigatures2:ke(new H),fontSize:ke(new q),fontWeight:ke(new K),formatOnPaste:ke(new _(48,"formatOnPaste",!1,{description:o.localize(200,null)})),formatOnType:ke(new _(49,"formatOnType",!1,{description:o.localize(201,null)})),glyphMargin:ke(new _(50,"glyphMargin",!0,{description:o.localize(202,null)})),gotoLocation:ke(new V),hideCursorInOverviewRuler:ke(new _(52,"hideCursorInOverviewRuler",!1,{description:o.localize(203,null)})),hover:ke(new z),inDiffEditor:ke(new _(54,"inDiffEditor",!1)),letterSpacing:ke(new p(56,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,X=>p.clamp(X,-5,20),{description:o.localize(204,null)})),lightbulb:ke(new Y),lineDecorationsWidth:ke(new n(58,"lineDecorationsWidth",10)),lineHeight:ke(new ce),lineNumbers:ke(new Xe),lineNumbersMinChars:ke(new d(61,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new _(62,"linkedEditing",!1,{description:o.localize(205,null)})),links:ke(new _(63,"links",!0,{description:o.localize(206,null)})),matchBrackets:ke(new T(64,"matchBrackets","always",["always","near","never"],{description:o.localize(207,null)})),minimap:ke(new he),mouseStyle:ke(new T(66,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new p(67,"mouseWheelScrollSensitivity",1,X=>X===0?1:X,{markdownDescription:o.localize(208,null)})),mouseWheelZoom:ke(new _(68,"mouseWheelZoom",!1,{markdownDescription:o.localize(209,null)})),multiCursorMergeOverlapping:ke(new _(69,"multiCursorMergeOverlapping",!0,{description:o.localize(210,null)})),multiCursorModifier:ke(new r(70,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ue,{markdownEnumDescriptions:[o.localize(211,null),o.localize(212,null)],markdownDescription:o.localize(213,null)})),multiCursorPaste:ke(new T(71,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(214,null),o.localize(215,null)],markdownDescription:o.localize(216,null)})),occurrencesHighlight:ke(new _(72,"occurrencesHighlight",!0,{description:o.localize(217,null)})),overviewRulerBorder:ke(new _(73,"overviewRulerBorder",!0,{description:o.localize(218,null)})),overviewRulerLanes:ke(new d(74,"overviewRulerLanes",3,0,3)),padding:ke(new se),parameterHints:ke(new ge),peekWidgetDefaultFocus:ke(new T(77,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(219,null),o.localize(220,null)],description:o.localize(221,null)})),definitionLinkOpensInPeek:ke(new _(78,"definitionLinkOpensInPeek",!1,{description:o.localize(222,null)})),quickSuggestions:ke(new Re),quickSuggestionsDelay:ke(new d(80,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(223,null)})),readOnly:ke(new _(81,"readOnly",!1)),renameOnType:ke(new _(82,"renameOnType",!1,{description:o.localize(224,null),markdownDeprecationMessage:o.localize(225,null)})),renderControlCharacters:ke(new _(83,"renderControlCharacters",!0,{description:o.localize(226,null),restricted:!0})),renderFinalNewline:ke(new _(84,"renderFinalNewline",!0,{description:o.localize(227,null)})),renderLineHighlight:ke(new T(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(228,null)],description:o.localize(229,null)})),renderLineHighlightOnlyWhenFocus:ke(new _(86,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(230,null)})),renderValidationDecorations:ke(new T(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new T(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(231,null),o.localize(232,null),o.localize(233,null),""],description:o.localize(234,null)})),revealHorizontalRightPadding:ke(new d(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new _(90,"roundedSelection",!0,{description:o.localize(235,null)})),rulers:ke(new fe),scrollbar:ke(new O),scrollBeyondLastColumn:ke(new d(93,"scrollBeyondLastColumn",5,0,1073741824,{description:o.localize(236,null)})),scrollBeyondLastLine:ke(new _(94,"scrollBeyondLastLine",!0,{description:o.localize(237,null)})),scrollPredominantAxis:ke(new _(95,"scrollPredominantAxis",!0,{description:o.localize(238,null)})),selectionClipboard:ke(new _(96,"selectionClipboard",!0,{description:o.localize(239,null),included:k.isLinux})),selectionHighlight:ke(new _(97,"selectionHighlight",!0,{description:o.localize(240,null)})),selectOnLineNumbers:ke(new _(98,"selectOnLineNumbers",!0)),showFoldingControls:ke(new T(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[o.localize(241,null),o.localize(242,null)],description:o.localize(243,null)})),showUnused:ke(new _(100,"showUnused",!0,{description:o.localize(244,null)})),showDeprecated:ke(new _(126,"showDeprecated",!0,{description:o.localize(245,null)})),inlayHints:ke(new ie),snippetSuggestions:ke(new T(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(246,null),o.localize(247,null),o.localize(248,null),o.localize(249,null)],description:o.localize(250,null)})),smartSelect:ke(new Ie),smoothScrolling:ke(new _(103,"smoothScrolling",!1,{description:o.localize(251,null)})),stopRenderingLineAfter:ke(new d(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new Ee),inlineSuggest:ke(new R),suggestFontSize:ke(new d(107,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(252,null)})),suggestLineHeight:ke(new d(108,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(253,null)})),suggestOnTriggerCharacters:ke(new _(109,"suggestOnTriggerCharacters",!0,{description:o.localize(254,null)})),suggestSelection:ke(new T(110,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(255,null),o.localize(256,null),o.localize(257,null)],description:o.localize(258,null)})),tabCompletion:ke(new T(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(259,null),o.localize(260,null),o.localize(261,null)],description:o.localize(262,null)})),tabIndex:ke(new d(112,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new I),unusualLineTerminators:ke(new T(114,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(263,null),o.localize(264,null),o.localize(265,null)],description:o.localize(266,null)})),useShadowDOM:ke(new _(115,"useShadowDOM",!0)),useTabStops:ke(new _(116,"useTabStops",!0,{description:o.localize(267,null)})),wordSeparators:ke(new E(117,"wordSeparators",w.USUAL_WORD_SEPARATORS,{description:o.localize(268,null)})),wordWrap:ke(new T(118,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(269,null),o.localize(270,null),o.localize(271,null),o.localize(272,null)],description:o.localize(273,null)})),wordWrapBreakAfterCharacters:ke(new E(119,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new E(120,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new d(121,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(274,null)})),wordWrapOverride1:ke(new T(122,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new T(123,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new r(124,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ze,{enumDescriptions:[o.localize(275,null),o.localize(276,null),o.localize(277,null),o.localize(278,null)],description:o.localize(279,null)})),wrappingStrategy:ke(new T(125,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[o.localize(280,null),o.localize(281,null)],description:o.localize(282,null)})),editorClassName:ke(new $),pixelRatio:ke(new Te),tabFocusMode:ke(new Me),layoutInfo:ke(new de),wrappingInfo:ke(new Be)}}),define(we[117],be([18,19]),function(Z,e){return Z.create("vs/platform/configuration/common/configurationRegistry",e)}),define(we[118],be([18,19]),function(Z,e){return Z.create("vs/platform/extensions/common/extensionValidator",e)}),define(we[119],be([18,19]),function(Z,e){return Z.create("vs/platform/files/common/files",e)}),define(we[120],be([18,19]),function(Z,e){return Z.create("vs/platform/markers/common/markers",e)}),define(we[121],be([18,19]),function(Z,e){return Z.create("vs/platform/workspace/common/workspace",e)}),define(we[122],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(we[123],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostExtensionService",e)}),define(we[124],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostProgress",e)}),define(we[125],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostStatusBar",e)}),define(we[126],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTerminalService",e)}),define(we[127],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostTreeViews",e)}),define(we[128],be([18,19]),function(Z,e){return Z.create("vs/workbench/api/common/extHostWorkspace",e)}),define(we[129],be([18,19]),function(Z,e){return Z.create("vs/workbench/common/editor",e)}),define(we[130],be([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(we[131],be([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/debug/common/debug",e)}),define(we[132],be([18,19]),function(Z,e){return Z.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(we[133],be([18,19]),function(Z,e){return Z.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(we[134],be([18,19]),function(Z,e){return Z.create("vs/workbench/services/search/common/queryBuilder",e)}),define(we[135],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var o;(function(A){A[A.ACTIVATE=1]="ACTIVATE",A[A.RESTORE=2]="RESTORE",A[A.PRESERVE=3]="PRESERVE"})(o=e.EditorActivation||(e.EditorActivation={}));var k;(function(A){A[A.PICK=0]="PICK",A[A.DISABLED=1]="DISABLED",A[A.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(k=e.EditorResolution||(e.EditorResolution={}));var w;(function(A){A[A.API=0]="API",A[A.USER=1]="USER"})(w=e.EditorOpenSource||(e.EditorOpenSource={}));var B;(function(A){A[A.Center=0]="Center",A[A.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",A[A.NearTop=2]="NearTop",A[A.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(B=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var C;(function(A){A.PROGRAMMATIC="api",A.NAVIGATION="code.navigation",A.JUMP="code.jump"})(C=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(we[136],be([1,0,118]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const k=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function B(c){return c=c.trim(),c==="*"||k.test(c)}e.isValidVersionStr=B;function C(c){if(!B(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let g=c.match(k);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=C;function A(c){if(!c)return null;let g=c.majorBase,s=c.majorMustEqual,n=c.minorBase,h=c.minorMustEqual,_=c.patchBase,y=c.patchMustEqual;c.hasCaret&&(g===0||(h=!1),y=!1);let d=0;if(c.preRelease){const p=w.exec(c.preRelease);if(p){const[,E,a,T]=p;d=Date.UTC(Number(E),Number(a)-1,Number(T))}}return{majorBase:g,majorMustEqual:s,minorBase:n,minorMustEqual:h,patchBase:_,patchMustEqual:y,isMinimum:c.hasGreaterEquals,notBefore:d}}e.normalizeVersion=A;function D(c,g,s){let n;typeof c=="string"?n=A(C(c)):n=c;let h;g instanceof Date?h=g.getTime():typeof g=="string"&&(h=new Date(g).getTime());let _;if(typeof s=="string"?_=A(C(s)):_=s,!n||!_)return!1;let y=n.majorBase,d=n.minorBase,p=n.patchBase,E=_.majorBase,a=_.minorBase,T=_.patchBase,r=_.notBefore,i=_.majorMustEqual,u=_.minorMustEqual,t=_.patchMustEqual;return _.isMinimum?y>E?!0:y<E?!1:d>a?!0:d<a||h&&h<r?!1:p>=T:(y===1&&E===0&&(!i||!u||!t)&&(E=1,a=0,T=0,i=!0,u=!1,t=!1),y<E?!1:y>E?!i:d<a?!1:d>a?!u:p<T?!1:p>T?!t:!(h&&h<r))}e.isValidVersion=D;function F(c,g,s,n){return s.isBuiltin||typeof s.main=="undefined"?!0:b(c,g,s.engines.vscode,n)}e.isValidExtensionVersion=F;function N(c,g,s){return c==="*"||b(g,s,c)}e.isEngineValid=N;function b(c,g,s,n=[]){let h=A(C(s));if(!h)return n.push(o.localize(0,null,s)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return n.push(o.localize(1,null,s)),!1}else if(!h.majorMustEqual)return n.push(o.localize(2,null,s)),!1;return D(c,g,h)?!0:(n.push(o.localize(3,null,c,s)),!1)}}),define(we[76],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(w,B=[],C=!1){this.ctor=w,this.staticArguments=B,this.supportsDelayedInstantiation=C}}e.SyncDescriptor=o}),define(we[55],be([1,0,76]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const k=[];function w(C,A,D){A instanceof o.SyncDescriptor||(A=new o.SyncDescriptor(A,[],D)),k.push([C,A])}e.registerSingleton=w;function B(){return k}e.getSingletonServiceDescriptors=B}),define(we[137],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(B){this.incoming=new Map,this.outgoing=new Map,this.data=B}}e.Node=o;class k{constructor(B){this._hashFn=B,this._nodes=new Map}roots(){const B=[];for(let C of this._nodes.values())C.outgoing.size===0&&B.push(C);return B}insertEdge(B,C){const A=this.lookupOrInsertNode(B),D=this.lookupOrInsertNode(C);A.outgoing.set(this._hashFn(C),D),D.incoming.set(this._hashFn(B),A)}removeNode(B){const C=this._hashFn(B);this._nodes.delete(C);for(let A of this._nodes.values())A.outgoing.delete(C),A.incoming.delete(C)}lookupOrInsertNode(B){const C=this._hashFn(B);let A=this._nodes.get(C);return A||(A=new o(B),this._nodes.set(C,A)),A}lookup(B){return this._nodes.get(this._hashFn(B))}isEmpty(){return this._nodes.size===0}toString(){let B=[];for(let[C,A]of this._nodes)B.push(`${C}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return B.join(`
`)}findCycleSlow(){for(let[B,C]of this._nodes){const A=new Set([B]),D=this._findCycle(C,A);if(D)return D}}_findCycle(B,C){for(let[A,D]of B.outgoing){if(C.has(A))return[...C,A].join(" -> ");C.add(A);const F=this._findCycle(D,C);if(F)return F;C.delete(A)}}}e.Graph=k}),define(we[3],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(C){C.serviceIds=new Map,C.DI_TARGET="$di$target",C.DI_DEPENDENCIES="$di$dependencies";function A(D){return D[C.DI_DEPENDENCIES]||[]}C.getServiceDependencies=A})(o=e._util||(e._util={})),e.IInstantiationService=w("instantiationService");function k(C,A,D){A[o.DI_TARGET]===A?A[o.DI_DEPENDENCIES].push({id:C,index:D}):(A[o.DI_DEPENDENCIES]=[{id:C,index:D}],A[o.DI_TARGET]=A)}function w(C){if(o.serviceIds.has(C))return o.serviceIds.get(C);const A=function(D,F,N){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");k(A,D,N)};return A.toString=()=>C,o.serviceIds.set(C,A),A}e.createDecorator=w;function B(C){return C}e.refineServiceDecorator=B}),define(we[77],be([1,0,11,2,3]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,w.createDecorator)("configurationService");function B(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof k.URI)}e.isConfigurationOverrides=B;function C(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||o.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof k.URI)}e.isConfigurationUpdateOverrides=C;var A;(function(h){h[h.USER=1]="USER",h[h.USER_LOCAL=2]="USER_LOCAL",h[h.USER_REMOTE=3]="USER_REMOTE",h[h.WORKSPACE=4]="WORKSPACE",h[h.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",h[h.DEFAULT=6]="DEFAULT",h[h.MEMORY=7]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function D(h){switch(h){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=D;function F(h,_){const y=Object.create(null);for(let d in h)N(y,d,h[d],_);return y}e.toValuesTree=F;function N(h,_,y,d){const p=_.split("."),E=p.pop();let a=h;for(let T=0;T<p.length;T++){let r=p[T],i=a[r];switch(typeof i){case"undefined":i=a[r]=Object.create(null);break;case"object":break;default:d(`Ignoring ${_} as ${p.slice(0,T+1).join(".")} is ${JSON.stringify(i)}`);return}a=i}if(typeof a=="object"&&a!==null)try{a[E]=y}catch{d(`Ignoring ${_} as ${p.join(".")} is ${JSON.stringify(a)}`)}else d(`Ignoring ${_} as ${p.join(".")} is ${JSON.stringify(a)}`)}e.addToValueTree=N;function b(h,_){const y=_.split(".");c(h,y)}e.removeFromValueTree=b;function c(h,_){const y=_.shift();if(_.length===0){delete h[y];return}if(Object.keys(h).indexOf(y)!==-1){const d=h[y];typeof d=="object"&&!Array.isArray(d)&&(c(d,_),Object.keys(d).length===0&&delete h[y])}}function g(h,_,y){function d(a,T){let r=a;for(const i of T){if(typeof r!="object"||r===null)return;r=r[i]}return r}const p=_.split("."),E=d(h,p);return typeof E=="undefined"?y:E}e.getConfigurationValue=g;function s(h,_,y){Object.keys(_).forEach(d=>{d!=="__proto__"&&(d in h?o.isObject(h[d])&&o.isObject(_[d])?s(h[d],_[d],y):y&&(h[d]=_[d]):h[d]=_[d])})}e.merge=s;function n(h,_,y){const d=h.inspect(_),p=h.inspect(y);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:d.defaultValue}e.getMigratedSettingValue=n}),define(we[44],be([1,0,23,9,3]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const B=new Map;B.set("false",!1),B.set("true",!0),B.set("isMac",o.isMacintosh),B.set("isLinux",o.isLinux),B.set("isWindows",o.isWindows),B.set("isWeb",o.isWeb),B.set("isMacNative",o.isMacintosh&&!o.isWeb),B.set("isEdge",o.isEdge),B.set("isFirefox",o.isFirefox),B.set("isChrome",o.isChrome),B.set("isSafari",o.isSafari);const C=Object.prototype.hasOwnProperty;var A;(function(L){L[L.False=0]="False",L[L.True=1]="True",L[L.Defined=2]="Defined",L[L.Not=3]="Not",L[L.Equals=4]="Equals",L[L.NotEquals=5]="NotEquals",L[L.And=6]="And",L[L.Regex=7]="Regex",L[L.NotRegex=8]="NotRegex",L[L.Or=9]="Or",L[L.In=10]="In",L[L.NotIn=11]="NotIn",L[L.Greater=12]="Greater",L[L.GreaterEquals=13]="GreaterEquals",L[L.Smaller=14]="Smaller",L[L.SmallerEquals=15]="SmallerEquals"})(A=e.ContextKeyExprType||(e.ContextKeyExprType={}));class D{static false(){return b.INSTANCE}static true(){return c.INSTANCE}static has(v){return g.create(v)}static equals(v,H){return s.create(v,H)}static notEquals(v,H){return _.create(v,H)}static regex(v,H){return r.create(v,H)}static in(v,H){return n.create(v,H)}static not(v){return y.create(v)}static and(...v){return t.create(v,null)}static or(...v){return l.create(v,null,!0)}static greater(v,H){return p.create(v,H)}static greaterEquals(v,H){return E.create(v,H)}static smaller(v,H){return a.create(v,H)}static smallerEquals(v,H){return T.create(v,H)}static deserialize(v,H=!1){if(!!v)return this._deserializeOrExpression(v,H)}static _deserializeOrExpression(v,H){let W=v.split("||");return l.create(W.map(q=>this._deserializeAndExpression(q,H)),null,!0)}static _deserializeAndExpression(v,H){let W=v.split("&&");return t.create(W.map(q=>this._deserializeOne(q,H)),null)}static _deserializeOne(v,H){if(v=v.trim(),v.indexOf("!=")>=0){let W=v.split("!=");return _.create(W[0].trim(),this._deserializeValue(W[1],H))}if(v.indexOf("==")>=0){let W=v.split("==");return s.create(W[0].trim(),this._deserializeValue(W[1],H))}if(v.indexOf("=~")>=0){let W=v.split("=~");return r.create(W[0].trim(),this._deserializeRegexValue(W[1],H))}if(v.indexOf(" in ")>=0){let W=v.split(" in ");return n.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(v)){const W=v.split(">=");return E.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(v)){const W=v.split(">");return p.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(v)){const W=v.split("<=");return T.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(v)){const W=v.split("<");return a.create(W[0].trim(),W[1].trim())}return/^\!\s*/.test(v)?y.create(v.substr(1).trim()):g.create(v)}static _deserializeValue(v,H){if(v=v.trim(),v==="true")return!0;if(v==="false")return!1;let W=/^'([^']*)'$/.exec(v);return W?W[1].trim():v}static _deserializeRegexValue(v,H){if((0,k.isFalsyOrWhitespace)(v)){if(H)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let W=v.indexOf("/"),q=v.lastIndexOf("/");if(W===q||W<0){if(H)throw new Error(`bad regexp-value '${v}', missing /-enclosure`);return console.warn(`bad regexp-value '${v}', missing /-enclosure`),null}let K=v.slice(W+1,q),V=v[q+1]==="i"?"i":"";try{return new RegExp(K,V)}catch(z){if(H)throw new Error(`bad regexp-value '${v}', parse error: ${z}`);return console.warn(`bad regexp-value '${v}', parse error: ${z}`),null}}}e.ContextKeyExpr=D;function F(L,v){const H=L?L.substituteConstants():void 0,W=v?v.substituteConstants():void 0;return!H&&!W?!0:!H||!W?!1:H.equals(W)}e.expressionsAreEqualWithConstantSubstitution=F;function N(L,v){return L.cmp(v)}class b{constructor(){this.type=0}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}substituteConstants(){return this}evaluate(v){return!1}serialize(){return"false"}keys(){return[]}map(v){return this}negate(){return c.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class c{constructor(){this.type=1}cmp(v){return this.type-v.type}equals(v){return v.type===this.type}substituteConstants(){return this}evaluate(v){return!0}serialize(){return"true"}keys(){return[]}map(v){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=c,c.INSTANCE=new c;class g{constructor(v,H){this.key=v,this.negated=H,this.type=2}static create(v,H=null){const W=B.get(v);return typeof W=="boolean"?W?c.INSTANCE:b.INSTANCE:new g(v,H)}cmp(v){return v.type!==this.type?this.type-v.type:f(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}substituteConstants(){const v=B.get(this.key);return typeof v=="boolean"?v?c.INSTANCE:b.INSTANCE:this}evaluate(v){return!!v.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(v){return v.mapDefined(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=g;class s{constructor(v,H,W){this.key=v,this.value=H,this.negated=W,this.type=4}static create(v,H,W=null){if(typeof H=="boolean")return H?g.create(v,W):y.create(v,W);const q=B.get(v);return typeof q=="boolean"?H===(q?"true":"false")?c.INSTANCE:b.INSTANCE:new s(v,H,W)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){const v=B.get(this.key);if(typeof v=="boolean"){const H=v?"true":"false";return this.value===H?c.INSTANCE:b.INSTANCE}return this}evaluate(v){return v.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(v){return v.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=s;class n{constructor(v,H){this.key=v,this.valueKey=H,this.type=10,this.negated=null}static create(v,H){return new n(v,H)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.valueKey,v.key,v.valueKey)}equals(v){return v.type===this.type?this.key===v.key&&this.valueKey===v.valueKey:!1}substituteConstants(){return this}evaluate(v){const H=v.getValue(this.valueKey),W=v.getValue(this.key);return Array.isArray(H)?H.indexOf(W)>=0:typeof W=="string"&&typeof H=="object"&&H!==null?C.call(H,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(v){return v.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=h.create(this)),this.negated}}e.ContextKeyInExpr=n;class h{constructor(v){this._actual=v,this.type=11}static create(v){return new h(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}substituteConstants(){return this}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new h(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotInExpr=h;class _{constructor(v,H,W){this.key=v,this.value=H,this.negated=W,this.type=5}static create(v,H,W=null){if(typeof H=="boolean")return H?y.create(v,W):g.create(v,W);const q=B.get(v);return typeof q=="boolean"?H===(q?"true":"false")?b.INSTANCE:c.INSTANCE:new _(v,H,W)}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){const v=B.get(this.key);if(typeof v=="boolean"){const H=v?"true":"false";return this.value===H?b.INSTANCE:c.INSTANCE}return this}evaluate(v){return v.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(v){return v.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=_;class y{constructor(v,H){this.key=v,this.negated=H,this.type=3}static create(v,H=null){const W=B.get(v);return typeof W=="boolean"?W?b.INSTANCE:c.INSTANCE:new y(v,H)}cmp(v){return v.type!==this.type?this.type-v.type:f(this.key,v.key)}equals(v){return v.type===this.type?this.key===v.key:!1}substituteConstants(){const v=B.get(this.key);return typeof v=="boolean"?v?b.INSTANCE:c.INSTANCE:this}evaluate(v){return!v.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(v){return v.mapNot(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=y;function d(L,v){if(typeof L=="string"){const H=parseFloat(L);isNaN(H)||(L=H)}return typeof L=="string"||typeof L=="number"?v(L):b.INSTANCE}class p{constructor(v,H,W){this.key=v,this.value=H,this.negated=W,this.type=12}static create(v,H,W=null){return d(H,q=>new p(v,q,W))}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=T.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=p;class E{constructor(v,H,W){this.key=v,this.value=H,this.negated=W,this.type=13}static create(v,H,W=null){return d(H,q=>new E(v,q,W))}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(v){return v.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=E;class a{constructor(v,H,W){this.key=v,this.value=H,this.negated=W,this.type=14}static create(v,H,W=null){return d(H,q=>new a(v,q,W))}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=E.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=a;class T{constructor(v,H,W){this.key=v,this.value=H,this.negated=W,this.type=15}static create(v,H,W=null){return d(H,q=>new T(v,q,W))}cmp(v){return v.type!==this.type?this.type-v.type:S(this.key,this.value,v.key,v.value)}equals(v){return v.type===this.type?this.key===v.key&&this.value===v.value:!1}substituteConstants(){return this}evaluate(v){return typeof this.value=="string"?!1:parseFloat(v.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(v){return v.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=T;class r{constructor(v,H){this.key=v,this.regexp=H,this.type=7,this.negated=null}static create(v,H){return new r(v,H)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.key<v.key)return-1;if(this.key>v.key)return 1;const H=this.regexp?this.regexp.source:"",W=v.regexp?v.regexp.source:"";return H<W?-1:H>W?1:0}equals(v){if(v.type===this.type){const H=this.regexp?this.regexp.source:"",W=v.regexp?v.regexp.source:"";return this.key===v.key&&H===W}return!1}substituteConstants(){return this}evaluate(v){let H=v.getValue(this.key);return this.regexp?this.regexp.test(H):!1}serialize(){const v=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${v}`}keys(){return[this.key]}map(v){return v.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=r;class i{constructor(v){this._actual=v,this.type=8}static create(v){return new i(v)}cmp(v){return v.type!==this.type?this.type-v.type:this._actual.cmp(v._actual)}equals(v){return v.type===this.type?this._actual.equals(v._actual):!1}substituteConstants(){return this}evaluate(v){return!this._actual.evaluate(v)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(v){return new i(this._actual.map(v))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function u(L){let v=null;for(let H=0,W=L.length;H<W;H++){const q=L[H].substituteConstants();if(L[H]!==q&&v===null){v=[];for(let K=0;K<H;K++)v[K]=L[K]}v!==null&&(v[H]=q)}return v===null?L:v}class t{constructor(v,H){this.expr=v,this.negated=H,this.type=6}static create(v,H){return t._normalizeArr(v,H)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let H=0,W=this.expr.length;H<W;H++){const q=N(this.expr[H],v.expr[H]);if(q!==0)return q}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let H=0,W=this.expr.length;H<W;H++)if(!this.expr[H].equals(v.expr[H]))return!1;return!0}return!1}substituteConstants(){const v=u(this.expr);return v===this.expr?this:t.create(v,this.negated)}evaluate(v){for(let H=0,W=this.expr.length;H<W;H++)if(!this.expr[H].evaluate(v))return!1;return!0}static _normalizeArr(v,H){const W=[];let q=!1;for(const K of v)if(!!K){if(K.type===1){q=!0;continue}if(K.type===0)return b.INSTANCE;if(K.type===6){W.push(...K.expr);continue}W.push(K)}if(W.length===0&&q)return c.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(N);for(let K=1;K<W.length;K++)W[K-1].equals(W[K])&&(W.splice(K,1),K--);if(W.length===1)return W[0];for(;W.length>1;){const K=W[W.length-1];if(K.type!==9)break;W.pop();const V=W.pop(),z=W.length===0,ae=l.create(K.expr.map(de=>t.create([de,V],null)),null,z);ae&&(W.push(ae),W.sort(N))}return W.length===1?W[0]:new t(W,H)}}serialize(){return this.expr.map(v=>v.serialize()).join(" && ")}keys(){const v=[];for(let H of this.expr)v.push(...H.keys());return v}map(v){return new t(this.expr.map(H=>H.map(v)),null)}negate(){if(!this.negated){const v=[];for(let H of this.expr)v.push(H.negate());this.negated=l.create(v,this,!0)}return this.negated}}class l{constructor(v,H){this.expr=v,this.negated=H,this.type=9}static create(v,H,W){return l._normalizeArr(v,H,W)}cmp(v){if(v.type!==this.type)return this.type-v.type;if(this.expr.length<v.expr.length)return-1;if(this.expr.length>v.expr.length)return 1;for(let H=0,W=this.expr.length;H<W;H++){const q=N(this.expr[H],v.expr[H]);if(q!==0)return q}return 0}equals(v){if(v.type===this.type){if(this.expr.length!==v.expr.length)return!1;for(let H=0,W=this.expr.length;H<W;H++)if(!this.expr[H].equals(v.expr[H]))return!1;return!0}return!1}substituteConstants(){const v=u(this.expr);return v===this.expr?this:l.create(v,this.negated,!1)}evaluate(v){for(let H=0,W=this.expr.length;H<W;H++)if(this.expr[H].evaluate(v))return!0;return!1}static _normalizeArr(v,H,W){let q=[],K=!1;if(v){for(let V=0,z=v.length;V<z;V++){const ae=v[V];if(!!ae){if(ae.type===0){K=!0;continue}if(ae.type===1)return c.INSTANCE;if(ae.type===9){q=q.concat(ae.expr);continue}q.push(ae)}}if(q.length===0&&K)return b.INSTANCE;q.sort(N)}if(q.length!==0){if(q.length===1)return q[0];for(let V=1;V<q.length;V++)q[V-1].equals(q[V])&&(q.splice(V,1),V--);if(q.length===1)return q[0];if(W){for(let V=0;V<q.length;V++)for(let z=V+1;z<q.length;z++)P(q[V],q[z])&&(q.splice(z,1),z--);if(q.length===1)return q[0]}return new l(q,H)}}serialize(){return this.expr.map(v=>v.serialize()).join(" || ")}keys(){const v=[];for(let H of this.expr)v.push(...H.keys());return v}map(v){return new l(this.expr.map(H=>H.map(v)),null)}negate(){if(!this.negated){let v=[];for(let H of this.expr)v.push(H.negate());for(;v.length>1;){const H=v.shift(),W=v.shift(),q=[];for(const V of $(H))for(const z of $(W))q.push(t.create([V,z],null));const K=v.length===0;v.unshift(l.create(q,null,K))}this.negated=v[0]}return this.negated}}class m extends g{constructor(v,H,W){super(v,null);this._defaultValue=H,typeof W=="object"?m._info.push({...W,key:v}):W!==!0&&m._info.push({key:v,description:W,type:H!=null?typeof H:void 0})}static all(){return m._info.values()}bindTo(v){return v.createKey(this.key,this._defaultValue)}getValue(v){return v.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(v){return s.create(this.key,v)}notEqualsTo(v){return _.create(this.key,v)}}e.RawContextKey=m,m._info=[],e.IContextKeyService=(0,w.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function f(L,v){return L<v?-1:L>v?1:0}function S(L,v,H,W){return L<H?-1:L>H?1:v<W?-1:v>W?1:0}function P(L,v){if(v.type===6&&L.type!==9&&L.type!==6){for(const q of v.expr)if(L.equals(q))return!0}const H=L.negate(),W=$(H).concat($(v));W.sort(N);for(let q=0;q<W.length;q++){const V=W[q].negate();for(let z=q+1;z<W.length;z++){const ae=W[z];if(V.equals(ae))return!0}}return!1}e.implies=P;function $(L){return L.type===9?L.expr:[L]}}),define(we[138],be([1,0,3]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(we[45],be([1,0,15,22,17,9,11,2,119,3]),function(Z,e,o,k,w,B,C,A,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,F.createDecorator)("fileService");function N(V){return V.create===!0}e.isFileOpenForWriteOptions=N;var b;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(b=e.FileType||(e.FileType={}));var c;(function(V){V[V.Readonly=1]="Readonly"})(c=e.FilePermission||(e.FilePermission={}));var g;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead"})(g=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function s(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=s;function n(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=n;function h(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function _(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=_;function y(V){return s(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=y;var d;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(d=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class p extends Error{constructor(z,ae){super(z);this.code=ae}}e.FileSystemProviderError=p;function E(V,z){const ae=new p(V.toString(),z);return T(ae,z),ae}e.createFileSystemProviderError=E;function a(V){return V||E((0,D.localize)(0,null),d.Unknown)}e.ensureFileSystemProviderError=a;function T(V,z){return V.name=z?`${z} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=T;function r(V){if(!V)return d.Unknown;if(V instanceof p)return V.code;const z=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!z)return d.Unknown;switch(z[1]){case d.FileExists:return d.FileExists;case d.FileIsADirectory:return d.FileIsADirectory;case d.FileNotADirectory:return d.FileNotADirectory;case d.FileNotFound:return d.FileNotFound;case d.FileExceedsMemoryLimit:return d.FileExceedsMemoryLimit;case d.FileTooLarge:return d.FileTooLarge;case d.FileWriteLocked:return d.FileWriteLocked;case d.NoPermissions:return d.NoPermissions;case d.Unavailable:return d.Unavailable}return d.Unknown}e.toFileSystemProviderErrorCode=r;function i(V){if(V instanceof S)return V.fileOperationResult;switch(r(V)){case d.FileNotFound:return 1;case d.FileIsADirectory:return 0;case d.FileNotADirectory:return 10;case d.FileWriteLocked:return 5;case d.NoPermissions:return 6;case d.FileExists:return 4;case d.FileExceedsMemoryLimit:return 9;case d.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var u;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(u=e.FileOperation||(e.FileOperation={}));class t{constructor(z,ae,de){this.resource=z,this.operation=ae,this.target=de}isOperation(z){return this.operation===z}}e.FileOperationEvent=t;var l;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(l=e.FileChangeType||(e.FileChangeType={}));class m{constructor(z,ae){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=z;const de=new Map;for(const Y of z){const ie=de.get(Y.type);switch(ie?ie.push([Y.resource,Y]):de.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,ie]of de)switch(Y){case 1:this.added=k.TernarySearchTree.forUris(()=>ae),this.added.fill(ie);break;case 0:this.updated=k.TernarySearchTree.forUris(()=>ae),this.updated.fill(ie);break;case 2:this.deleted=k.TernarySearchTree.forUris(()=>ae),this.deleted.fill(ie);break}}contains(z,...ae){return this.doContains(z,{includeChildren:!1},...ae)}affects(z,...ae){return this.doContains(z,{includeChildren:!0},...ae)}doContains(z,ae,...de){if(!z)return!1;const Y=de.length>0;return!!((!Y||de.includes(1))&&(this.added?.get(z)||ae.includeChildren&&this.added?.findSuperstr(z))||(!Y||de.includes(0))&&(this.updated?.get(z)||ae.includeChildren&&this.updated?.findSuperstr(z))||(!Y||de.includes(2))&&(this.deleted?.findSubstr(z)||ae.includeChildren&&this.deleted?.findSuperstr(z)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=m;function f(V,z,ae){return!V||!z||V===z||z.length>V.length?!1:(z.charAt(z.length-1)!==w.sep&&(z+=w.sep),ae?(0,B.startsWithIgnoreCase)(V,z):V.indexOf(z)===0)}e.isParent=f;class S extends o.ErrorNoTelemetry{constructor(z,ae,de){super(z);this.fileOperationResult=ae,this.options=de}}e.FileOperationError=S;class P extends S{constructor(z,ae,de){super(z,2,de);this.stat=ae}}e.NotModifiedSinceFileOperationError=P;var $;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})($=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var L;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(L=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function v(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=v;async function H(V,z){if(!z.hasProvider(A.URI.from({scheme:V.scheme})))return new Promise(ae=>{const de=z.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===V.scheme&&Y.added&&(de.dispose(),ae())})})}e.whenProviderRegistered=H,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class W{static formatSize(z){return(0,C.isNumber)(z)||(z=0),z<W.KB?(0,D.localize)(1,null,z.toFixed(0)):z<W.MB?(0,D.localize)(2,null,(z/W.KB).toFixed(2)):z<W.GB?(0,D.localize)(3,null,(z/W.MB).toFixed(2)):z<W.TB?(0,D.localize)(4,null,(z/W.GB).toFixed(2)):(0,D.localize)(5,null,(z/W.TB).toFixed(2))}}e.ByteSize=W,W.KB=1024,W.MB=W.KB*W.KB,W.GB=W.MB*W.KB,W.TB=W.GB*W.KB;var q;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function K(V){return{maxFileSize:V===0?300*W.MB:16*W.GB,maxHeapSize:V===0?700*W.MB:2*700*W.MB}}e.getPlatformLimits=K}),define(we[56],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(...w){this._entries=new Map;for(let[B,C]of w)this.set(B,C)}set(w,B){const C=this._entries.get(w);return this._entries.set(w,B),C}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}e.ServiceCollection=o}),define(we[139],be([1,0,13,15,76,137,3,56]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const D=!1;class F extends Error{constructor(s){super("cyclic dependency between services");this.message=s.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${s.toString()}`}}class N{constructor(s=new A.ServiceCollection,n=!1,h){this._activeInstantiations=new Set,this._services=s,this._strict=n,this._parent=h,this._services.set(C.IInstantiationService,this)}createChild(s){return new N(s,this._strict,this)}invokeFunction(s,...n){let h=c.traceInvocation(s),_=!1;try{return s({get:d=>{if(_)throw(0,k.illegalState)("service accessor is only valid during the invocation of its target method");const p=this._getOrCreateServiceInstance(d,h);if(!p)throw new Error(`[invokeFunction] unknown service '${d}'`);return p}},...n)}finally{_=!0,h.stop()}}createInstance(s,...n){let h,_;return s instanceof w.SyncDescriptor?(h=c.traceCreation(s.ctor),_=this._createInstance(s.ctor,s.staticArguments.concat(n),h)):(h=c.traceCreation(s),_=this._createInstance(s,n,h)),h.stop(),_}_createInstance(s,n=[],h){let _=C._util.getServiceDependencies(s).sort((p,E)=>p.index-E.index),y=[];for(const p of _){let E=this._getOrCreateServiceInstance(p.id,h);E||this._throwIfStrict(`[createInstance] ${s.name} depends on UNKNOWN service ${p.id}.`,!1),y.push(E)}let d=_.length>0?_[0].index:n.length;if(n.length!==d){console.warn(`[createInstance] First service dependency of ${s.name} at position ${d+1} conflicts with ${n.length} static arguments`);let p=d-n.length;p>0?n=n.concat(new Array(p)):n=n.slice(0,d)}return new s(...[...n,...y])}_setServiceInstance(s,n){if(this._services.get(s)instanceof w.SyncDescriptor)this._services.set(s,n);else if(this._parent)this._parent._setServiceInstance(s,n);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(s){let n=this._services.get(s);return!n&&this._parent?this._parent._getServiceInstanceOrDescriptor(s):n}_getOrCreateServiceInstance(s,n){let h=this._getServiceInstanceOrDescriptor(s);return h instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(s,h,n.branch(s,!0)):(n.branch(s,!1),h)}_safeCreateAndCacheServiceInstance(s,n,h){if(this._activeInstantiations.has(s))throw new Error(`illegal state - RECURSIVELY instantiating service '${s}'`);this._activeInstantiations.add(s);try{return this._createAndCacheServiceInstance(s,n,h)}finally{this._activeInstantiations.delete(s)}}_createAndCacheServiceInstance(s,n,h){const _=new B.Graph(p=>p.id.toString());let y=0;const d=[{id:s,desc:n,_trace:h}];for(;d.length;){const p=d.pop();if(_.lookupOrInsertNode(p),y++>1e3)throw new F(_);for(let E of C._util.getServiceDependencies(p.desc.ctor)){let a=this._getServiceInstanceOrDescriptor(E.id);if(a||this._throwIfStrict(`[createInstance] ${s} depends on ${E.id} which is NOT registered.`,!0),a instanceof w.SyncDescriptor){const T={id:E.id,desc:a,_trace:p._trace.branch(E.id,!0)};_.insertEdge(p,T),d.push(T)}}}for(;;){const p=_.roots();if(p.length===0){if(!_.isEmpty())throw new F(_);break}for(const{data:E}of p){if(this._getServiceInstanceOrDescriptor(E.id)instanceof w.SyncDescriptor){const T=this._createServiceInstanceWithOwner(E.id,E.desc.ctor,E.desc.staticArguments,E.desc.supportsDelayedInstantiation,E._trace);this._setServiceInstance(E.id,T)}_.removeNode(E)}}return this._getServiceInstanceOrDescriptor(s)}_createServiceInstanceWithOwner(s,n,h=[],_,y){if(this._services.get(s)instanceof w.SyncDescriptor)return this._createServiceInstance(n,h,_,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(s,n,h,_,y);throw new Error(`illegalState - creating UNKNOWN service instance ${n.name}`)}_createServiceInstance(s,n=[],h,_){if(h){const y=new o.IdleValue(()=>this._createInstance(s,n,_));return new Proxy(Object.create(null),{get(d,p){if(p in d)return d[p];let E=y.value,a=E[p];return typeof a!="function"||(a=a.bind(E),d[p]=a),a},set(d,p,E){return y.value[p]=E,!0}})}else return this._createInstance(s,n,_)}_throwIfStrict(s,n){if(n&&console.warn(n),this._strict)throw new Error(s)}}e.InstantiationService=N;var b;(function(g){g[g.Creation=0]="Creation",g[g.Invocation=1]="Invocation",g[g.Branch=2]="Branch"})(b||(b={}));class c{constructor(s,n){this.type=s,this.name=n,this._start=Date.now(),this._dep=[]}static traceInvocation(s){return D?new c(1,s.name||s.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(s){return D?new c(0,s.name):c._None}branch(s,n){let h=new c(2,s.toString());return this._dep.push([s,n,h]),h}stop(){let s=Date.now()-this._start;c._totals+=s;let n=!1;function h(y,d){let p=[],E=new Array(y+1).join("	");for(const[a,T,r]of d._dep)if(T&&r){n=!0,p.push(`${E}CREATES -> ${a}`);let i=h(y+1,r);i&&p.push(i)}else p.push(`${E}uses -> ${a}`);return p.join(`
`)}let _=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${s.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(s>2||n)&&console.log(_.join(`
`))}}e.Trace=c,c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(we[12],be([1,0,43,5,7,23,3]),function(Z,e,o,k,w,B,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,C.createDecorator)("logService"),e.ILoggerService=(0,C.createDecorator)("loggerService");function A(){return new Date().toISOString()}var D;(function(T){T[T.Trace=0]="Trace",T[T.Debug=1]="Debug",T[T.Info=2]="Info",T[T.Warning=3]="Warning",T[T.Error=4]="Error",T[T.Critical=5]="Critical",T[T.Off=6]="Off"})(D=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=D.Info;function F(T,r,i){switch(r){case D.Trace:T.trace(i);break;case D.Debug:T.debug(i);break;case D.Info:T.info(i);break;case D.Warning:T.warn(i);break;case D.Error:T.error(i);break;case D.Critical:T.critical(i);break;default:throw new Error("Invalid log level")}}e.log=F;function N(T){let r="";for(let i=0;i<T.length;i++){let u=T[i];if(typeof u=="object")try{u=JSON.stringify(u)}catch{}r+=(i>0?" ":"")+u}return r}e.format=N;class b extends w.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new k.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(r){this.level!==r&&(this.level=r,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class c extends b{constructor(r){super();this.logAlways=r}checkLogLevel(r){return this.logAlways||this.getLevel()<=r}trace(r,...i){this.checkLogLevel(D.Trace)&&this.log(D.Trace,N([r,...i]))}debug(r,...i){this.checkLogLevel(D.Debug)&&this.log(D.Debug,N([r,...i]))}info(r,...i){this.checkLogLevel(D.Info)&&this.log(D.Info,N([r,...i]))}warn(r,...i){this.checkLogLevel(D.Warning)&&this.log(D.Warning,N([r,...i]))}error(r,...i){if(this.checkLogLevel(D.Error))if(r instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=r.stack,this.log(D.Error,N(u))}else this.log(D.Error,N([r,...i]))}critical(r,...i){this.checkLogLevel(D.Critical)&&this.log(D.Critical,N([r,...i]))}flush(){}}e.AbstractMessageLogger=c;class g extends b{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r),this.useColors=!B.isWindows}trace(r,...i){this.getLevel()<=D.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,r,...i):console.log(`[main ${A()}]`,r,...i))}debug(r,...i){this.getLevel()<=D.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,r,...i):console.log(`[main ${A()}]`,r,...i))}info(r,...i){this.getLevel()<=D.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,r,...i):console.log(`[main ${A()}]`,r,...i))}warn(r,...i){this.getLevel()<=D.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,r,...i):console.warn(`[main ${A()}]`,r,...i))}error(r,...i){this.getLevel()<=D.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,r,...i):console.error(`[main ${A()}]`,r,...i))}critical(r,...i){this.getLevel()<=D.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,r,...i):console.error(`[main ${A()}]`,r,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=g;class s extends b{constructor(r=e.DEFAULT_LOG_LEVEL){super();this.setLevel(r)}trace(r,...i){this.getLevel()<=D.Trace&&console.log("%cTRACE","color: #888",r,...i)}debug(r,...i){this.getLevel()<=D.Debug&&console.log("%cDEBUG","background: #eee; color: #888",r,...i)}info(r,...i){this.getLevel()<=D.Info&&console.log("%c INFO","color: #33f",r,...i)}warn(r,...i){this.getLevel()<=D.Warning&&console.log("%c WARN","color: #993",r,...i)}error(r,...i){this.getLevel()<=D.Error&&console.log("%c  ERR","color: #f33",r,...i)}critical(r,...i){this.getLevel()<=D.Critical&&console.log("%cCRITI","background: #f33; color: white",r,...i)}dispose(){}flush(){}}e.ConsoleLogger=s;class n extends b{constructor(r,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=r,this.setLevel(i)}trace(r,...i){this.getLevel()<=D.Trace&&this.adapter.log(D.Trace,[this.extractMessage(r),...i])}debug(r,...i){this.getLevel()<=D.Debug&&this.adapter.log(D.Debug,[this.extractMessage(r),...i])}info(r,...i){this.getLevel()<=D.Info&&this.adapter.log(D.Info,[this.extractMessage(r),...i])}warn(r,...i){this.getLevel()<=D.Warning&&this.adapter.log(D.Warning,[this.extractMessage(r),...i])}error(r,...i){this.getLevel()<=D.Error&&this.adapter.log(D.Error,[this.extractMessage(r),...i])}critical(r,...i){this.getLevel()<=D.Critical&&this.adapter.log(D.Critical,[this.extractMessage(r),...i])}extractMessage(r){return typeof r=="string"?r:(0,o.toErrorMessage)(r,this.getLevel()<=D.Trace)}dispose(){}flush(){}}e.AdapterLogger=n;class h extends b{constructor(r){super();this.logServices=r,r.length&&this.setLevel(r[0].getLevel())}setLevel(r){for(const i of this.logServices)i.setLevel(r);super.setLevel(r)}trace(r,...i){for(const u of this.logServices)u.trace(r,...i)}debug(r,...i){for(const u of this.logServices)u.debug(r,...i)}info(r,...i){for(const u of this.logServices)u.info(r,...i)}warn(r,...i){for(const u of this.logServices)u.warn(r,...i)}error(r,...i){for(const u of this.logServices)u.error(r,...i)}critical(r,...i){for(const u of this.logServices)u.critical(r,...i)}flush(){for(const r of this.logServices)r.flush()}dispose(){for(const r of this.logServices)r.dispose()}}e.MultiplexLogService=h;class _ extends w.Disposable{constructor(r){super();this.logger=r,this._register(r)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(r){this.logger.setLevel(r)}getLevel(){return this.logger.getLevel()}trace(r,...i){this.logger.trace(r,...i)}debug(r,...i){this.logger.debug(r,...i)}info(r,...i){this.logger.info(r,...i)}warn(r,...i){this.logger.warn(r,...i)}error(r,...i){this.logger.error(r,...i)}critical(r,...i){this.logger.critical(r,...i)}flush(){this.logger.flush()}}e.LogService=_;class y extends w.Disposable{constructor(r,i){super();this.logLevel=r,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(u=>{this.logLevel=u,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(u))}))}getLogger(r){return this.loggers.get(r.toString())}createLogger(r,i){let u=this.loggers.get(r.toString());return u||(u=this.doCreateLogger(r,i?.always?D.Trace:this.logLevel,i),this.loggers.set(r.toString(),u),i?.always||this.logLevelChangeableLoggers.push(u)),u}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(r=>r.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=y;class d{constructor(){this.onDidChangeLogLevel=new k.Emitter().event}setLevel(r){}getLevel(){return D.Info}trace(r,...i){}debug(r,...i){}info(r,...i){}warn(r,...i){}error(r,...i){}critical(r,...i){}dispose(){}flush(){}}e.NullLogService=d;function p(T){if(T.verbose)return D.Trace;if(typeof T.logLevel=="string"){const r=E(T.logLevel.toLowerCase());if(r!==void 0)return r}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=p;function E(T){switch(T){case"trace":return D.Trace;case"debug":return D.Debug;case"info":return D.Info;case"warn":return D.Warning;case"error":return D.Error;case"critical":return D.Critical;case"off":return D.Off}}e.parseLogLevel=E;function a(T){switch(T){case D.Trace:return"trace";case D.Debug:return"debug";case D.Info:return"info";case D.Warning:return"warn";case D.Error:return"error";case D.Critical:return"critical";case D.Off:return"off"}}e.LogLevelToString=a}),define(we[78],be([1,0,34,120,3]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var B;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(B=e.MarkerTag||(e.MarkerTag={}));var C;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(C=e.MarkerSeverity||(e.MarkerSeverity={})),function(D){function F(s,n){return n-s}D.compare=F;const N=Object.create(null);N[D.Error]=(0,k.localize)(0,null),N[D.Warning]=(0,k.localize)(1,null),N[D.Info]=(0,k.localize)(2,null);function b(s){return N[s]||""}D.toString=b;function c(s){switch(s){case o.default.Error:return D.Error;case o.default.Warning:return D.Warning;case o.default.Info:return D.Info;case o.default.Ignore:return D.Hint}}D.fromSeverity=c;function g(s){switch(s){case D.Error:return o.default.Error;case D.Warning:return o.default.Warning;case D.Info:return o.default.Info;case D.Hint:return o.default.Ignore}}D.toSeverity=g}(C=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(D){const F="";function N(c){return b(c,!0)}D.makeKey=N;function b(c,g){let s=[F];return c.source?s.push(c.source.replace("\xA6","\\\xA6")):s.push(F),c.code?typeof c.code=="string"?s.push(c.code.replace("\xA6","\\\xA6")):s.push(c.code.value.replace("\xA6","\\\xA6")):s.push(F),c.severity!==void 0&&c.severity!==null?s.push(C.toString(c.severity)):s.push(F),c.message&&g?s.push(c.message.replace("\xA6","\\\xA6")):s.push(F),c.startLineNumber!==void 0&&c.startLineNumber!==null?s.push(c.startLineNumber.toString()):s.push(F),c.startColumn!==void 0&&c.startColumn!==null?s.push(c.startColumn.toString()):s.push(F),c.endLineNumber!==void 0&&c.endLineNumber!==null?s.push(c.endLineNumber.toString()):s.push(F),c.endColumn!==void 0&&c.endColumn!==null?s.push(c.endColumn.toString()):s.push(F),s.push(F),s.join("\xA6")}D.makeKeyOptionalMessage=b})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,w.createDecorator)("markerService")}),define(we[140],be([1,0,5,34,3]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=k.default,e.INotificationService=(0,w.createDecorator)("notificationService");var B;(function(F){F[F.WORKSPACE=0]="WORKSPACE",F[F.GLOBAL=1]="GLOBAL"})(B=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var C;(function(F){F[F.OFF=0]="OFF",F[F.SILENT=1]="SILENT",F[F.ERROR=2]="ERROR"})(C=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new D,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(N){}updateMessage(N){}updateActions(N){}close(){}}e.NoOpNotification=A;class D{infinite(){}done(){}total(N){}worked(N){}}e.NoOpProgress=D}),define(we[79],be([1,0,7,9,2,3]),function(Z,e,o,k,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,B.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return o.Disposable.None},registerValidator(){return o.Disposable.None},registerExternalUriResolver(){return o.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return o.Disposable.None},async open(){return!1},async resolveExternalUri(N){return{resolved:N,dispose(){}}}});function C(N,b){return w.URI.isUri(N)?(0,k.equalsIgnoreCase)(N.scheme,b):(0,k.startsWithIgnoreCase)(N,b+":")}e.matchesScheme=C;function A(N,...b){return b.some(c=>C(N,c))}e.matchesSomeScheme=A;function D(N,b){return N.with({fragment:`${b.startLineNumber},${b.startColumn}${b.endLineNumber?`-${b.endLineNumber}${b.endColumn?`,${b.endColumn}`:""}`:""}`})}e.withSelection=D;function F(N){let b;const c=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(N.fragment);return c&&(b={startLineNumber:parseInt(c[1]),startColumn:c[2]?parseInt(c[2]):1,endLineNumber:c[4]?parseInt(c[4]):void 0,endColumn:c[4]?c[5]?parseInt(c[5]):1:void 0},N=N.with({fragment:""})),{selection:b,uri:N}}e.extractSelection=F});var Fe=this&&this.__decorate||function(Z,e,o,k){var w=arguments.length,B=w<3?e:k===null?k=Object.getOwnPropertyDescriptor(e,o):k,C;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")B=Reflect.decorate(Z,e,o,k);else for(var A=Z.length-1;A>=0;A--)(C=Z[A])&&(B=(w<3?C(B):w>3?C(e,o,B):C(e,o))||B);return w>3&&B&&Object.defineProperty(e,o,B),B},Ne=this&&this.__param||function(Z,e){return function(o,k){e(o,k,Z)}};define(we[141],be([1,0,13,20,7,3]),function(Z,e,o,k,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,B.createDecorator)("progressService");var C;(function(N){N[N.Explorer=1]="Explorer",N[N.Scm=3]="Scm",N[N.Extensions=5]="Extensions",N[N.Window=10]="Window",N[N.Notification=15]="Notification",N[N.Dialog=20]="Dialog"})(C=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{constructor(b){this.callback=b}get value(){return this._value}report(b){this._value=b,this.callback(this._value)}}e.Progress=A,A.None=Object.freeze({report(){}});let D=class extends w.Disposable{constructor(b,c){super();this.deferred=new o.DeferredPromise,c.withProgress(b,g=>(this.reporter=g,this.lastStep&&g.report(this.lastStep),this.deferred.p)),this._register((0,w.toDisposable)(()=>this.deferred.complete()))}report(b){this.reporter?this.reporter.report(b):this.lastStep=b}};D=Fe([Ne(1,e.IProgressService)],D),e.UnmanagedProgress=D;class F extends w.Disposable{constructor(b){super();this.progressIndicator=b,this.currentOperationId=0,this.currentOperationDisposables=this._register(new w.DisposableStore)}start(b){this.stop();const c=++this.currentOperationId,g=new k.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{c===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},b),this.currentOperationDisposables.add((0,w.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,w.toDisposable)(()=>g.cancel())),this.currentOperationDisposables.add((0,w.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:c,token:g.token,stop:()=>this.doStop(c),isCurrent:()=>this.currentOperationId===c}}stop(){this.doStop(this.currentOperationId)}doStop(b){this.currentOperationId===b&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=F,e.IEditorProgressService=(0,B.createDecorator)("editorProgressService")}),define(we[37],be([1,0,42,11]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class w{constructor(){this.data=new Map}add(C,A){o.ok(k.isString(C)),o.ok(k.isObject(A)),o.ok(!this.data.has(C),"There is already an extension with this id"),this.data.set(C,A)}knows(C){return this.data.has(C)}as(C){return this.data.get(C)||null}}e.Registry=new w}),define(we[142],be([1,0,5,37]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function w(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class B{constructor(){this._onDidChangeSchema=new o.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(D,F){this.schemasById[w(D)]=F,this._onDidChangeSchema.fire(D)}notifySchemaChanged(D){this._onDidChangeSchema.fire(D)}getSchemaContributions(){return{schemas:this.schemasById}}}const C=new B;k.Registry.add(e.Extensions.JSONContribution,C)}),define(we[80],be([1,0,16,5,11,117,142,37]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var D;(function(p){p.Multiline="multilineText",p.Singleline="singlelineText"})(D=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var F;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.MACHINE=2]="MACHINE",p[p.WINDOW=3]="WINDOW",p[p.RESOURCE=4]="RESOURCE",p[p.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",p[p.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(F=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const N=A.Registry.as(C.Extensions.JSONContribution);class b{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new k.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new k.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:B.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(E,a=!0){this.registerConfigurations([E],a)}registerConfigurations(E,a=!0){const T=this.doRegisterConfigurations(E,a);N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:T})}deregisterConfigurations(E){const a=this.doDeregisterConfigurations(E);N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a})}updateConfigurations({add:E,remove:a}){const T=[];T.push(...this.doDeregisterConfigurations(a)),T.push(...this.doRegisterConfigurations(E,!1)),N.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,o.distinct)(T)})}registerDefaultConfigurations(E){const a=[],T=[];for(const{overrides:r,source:i}of E)for(const u in r)if(a.push(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const t={...this.configurationDefaultsOverrides.get(u)?.value||{},...r[u]};this.configurationDefaultsOverrides.set(u,{source:i,value:t});const l=u.replace(/[\[\]]/g,""),m={type:"object",default:t,description:B.localize(1,null,l),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:t,source:w.isString(i)?void 0:i};T.push(...s(u)),this.configurationProperties[u]=m,this.defaultLanguageConfigurationOverridesNode.properties[u]=m}else{this.configurationDefaultsOverrides.set(u,{value:r[u],source:i});const t=this.configurationProperties[u];t&&(this.updatePropertyDefaultValue(u,t),this.updateSchema(u,t))}this.registerOverrideIdentifiers(T),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}deregisterDefaultConfigurations(E){const a=[];for(const{overrides:T,source:r}of E)for(const i in T){const u=this.configurationDefaultsOverrides.get(i),t=w.isString(r)?r:r?.id,l=w.isString(u?.source)?u?.source:u?.source?.id;if(t===l)if(a.push(i),this.configurationDefaultsOverrides.delete(i),e.OVERRIDE_PROPERTY_REGEX.test(i))delete this.configurationProperties[i],delete this.defaultLanguageConfigurationOverridesNode.properties[i];else{const m=this.configurationProperties[i];m&&(this.updatePropertyDefaultValue(i,m),this.updateSchema(i,m))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:a,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const a of E)this.overrideIdentifiers.add(a);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(E,a){const T=[];return E.forEach(r=>{T.push(...this.validateAndRegisterProperties(r,a,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),T}doDeregisterConfigurations(E){const a=[],T=r=>{if(r.properties)for(const i in r.properties)a.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,r.properties[i]);r.allOf&&r.allOf.forEach(i=>T(i))};for(const r of E){T(r);const i=this.configurationContributors.indexOf(r);i!==-1&&this.configurationContributors.splice(i,1)}return a}validateAndRegisterProperties(E,a=!0,T,r,i=3){i=w.isUndefinedOrNull(E.scope)?i:E.scope;let u=[],t=E.properties;if(t)for(let m in t){if(a&&y(m)){delete t[m];continue}const f=t[m];if(f.source=T,f.defaultDefaultValue=t[m].default,this.updatePropertyDefaultValue(m,f),e.OVERRIDE_PROPERTY_REGEX.test(m)?f.scope=void 0:(f.scope=w.isUndefinedOrNull(f.scope)?i:f.scope,f.restricted=w.isUndefinedOrNull(f.restricted)?!!r?.includes(m):f.restricted),t[m].hasOwnProperty("included")&&!t[m].included){this.excludedConfigurationProperties[m]=t[m],delete t[m];continue}else this.configurationProperties[m]=t[m];!t[m].deprecationMessage&&t[m].markdownDeprecationMessage&&(t[m].deprecationMessage=t[m].markdownDeprecationMessage),u.push(m)}let l=E.allOf;if(l)for(let m of l)u.push(...this.validateAndRegisterProperties(m,a,T,r,i));return u}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(E){const a=T=>{let r=T.properties;if(r)for(const u in r)this.updateSchema(u,r[u]);let i=T.allOf;i&&i.forEach(a)};a(E)}updateSchema(E,a){switch(e.allSettings.properties[E]=a,a.scope){case 1:e.applicationSettings.properties[E]=a;break;case 2:e.machineSettings.properties[E]=a;break;case 6:e.machineOverridableSettings.properties[E]=a;break;case 3:e.windowSettings.properties[E]=a;break;case 4:e.resourceSettings.properties[E]=a;break;case 5:e.resourceSettings.properties[E]=a,this.resourceLanguageSettingsSchema.properties[E]=a;break}}removeFromSchema(E,a){switch(delete e.allSettings.properties[E],a.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E],delete this.resourceLanguageSettingsSchema.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const a=`[${E}]`,T={type:"object",description:B.localize(2,null),errorMessage:B.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(a,T),e.allSettings.properties[a]=T,e.applicationSettings.properties[a]=T,e.machineSettings.properties[a]=T,e.machineOverridableSettings.properties[a]=T,e.windowSettings.properties[a]=T,e.resourceSettings.properties[a]=T}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const E={type:"object",description:B.localize(4,null),errorMessage:B.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=E,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=E,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=E,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=E,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=E,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=E,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,a){const T=this.configurationDefaultsOverrides.get(E);let r=T?.value,i=T?.source;w.isUndefined(r)&&(r=a.defaultDefaultValue,i=void 0),w.isUndefined(r)&&(r=h(a.type)),a.default=r,a.defaultValueSource=i}}const c="\\[([^\\]]+)\\]",g=new RegExp(c,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function s(p){const E=[];if(e.OVERRIDE_PROPERTY_REGEX.test(p)){let a=g.exec(p);for(;a?.length;){const T=a[1].trim();T&&E.push(T),a=g.exec(p)}}return(0,o.distinct)(E)}e.overrideIdentifiersFromKey=s;function n(p){return p.reduce((E,a)=>`${E}[${a}]`,"")}e.keyFromOverrideIdentifiers=n;function h(p){switch(Array.isArray(p)?p[0]:p){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const _=new b;A.Registry.add(e.Extensions.Configuration,_);function y(p){return p.trim()?e.OVERRIDE_PROPERTY_REGEX.test(p)?B.localize(7,null,p):_.getConfigurationProperties()[p]!==void 0?B.localize(8,null,p):null:B.localize(6,null)}e.validateProperty=y;function d(){const p=[],E=_.getConfigurationProperties();for(const a of Object.keys(E))p.push([a,E[a].scope]);return p.push(["launch",4]),p.push(["task",4]),p}e.getScopes=d}),define(we[143],be([1,0,16,5,100,7,22,25,11,2,77,80,37]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class g{constructor(r={},i=[],u=[]){this._contents=r,this._keys=i,this._overrides=u,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(r){return r?(0,N.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,i){const u=this.getContentsForOverrideIdentifer(i);return u?r?(0,N.getConfigurationValue)(u,r):u:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const u of this.overrides)u.identifiers.includes(r)&&i.push(...u.keys);return o.distinct(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return o.distinct(r)}override(r){let i=this.overrideConfigurations.get(r);return i||(i=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,i)),i}merge(...r){const i=A.deepClone(this.contents),u=A.deepClone(this.overrides),t=[...this.keys];for(const l of r){this.mergeContents(i,l.contents);for(const m of l.overrides){const[f]=u.filter(S=>o.equals(S.identifiers,m.identifiers));f?(this.mergeContents(f.contents,m.contents),f.keys.push(...m.keys),f.keys=o.distinct(f.keys)):u.push(A.deepClone(m))}for(const m of l.keys)t.indexOf(m)===-1&&t.push(m)}return new g(i,t,u)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(r){const i=this.getContentsForOverrideIdentifer(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let u={};for(const t of o.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[t],m=i[t];m&&(typeof l=="object"&&typeof m=="object"?(l=A.deepClone(l),this.mergeContents(l,m)):l=m),u[t]=l}return new g(u,this.keys,this.overrides)}mergeContents(r,i){for(const u of Object.keys(i)){if(u in r&&D.isObject(r[u])&&D.isObject(i[u])){this.mergeContents(r[u],i[u]);continue}r[u]=A.deepClone(i[u])}}checkAndFreeze(r){return this.isFrozen&&!Object.isFrozen(r)?A.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let i=null,u=null;const t=l=>{l&&(u?this.mergeContents(u,l):u=A.deepClone(l))};for(const l of this.overrides)o.equals(l.identifiers,[r])?i=l.contents:l.identifiers.includes(r)&&t(l.contents);return t(i),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,i){this.addKey(r),(0,N.addToValueTree)(this.contents,r,i,u=>{throw new Error(u)})}removeValue(r){this.removeKey(r)&&(0,N.removeFromValueTree)(this.contents,r)}addKey(r){let i=this.keys.length;for(let u=0;u<i;u++)r.indexOf(this.keys[u])===0&&(i=u);this.keys.splice(i,1,r)}removeKey(r){let i=this.keys.indexOf(r);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=g;class s extends g{constructor(r={}){const i=c.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),u=Object.keys(i),t=Object.create(null),l=[];for(const m in i){const f=r[m],S=f!==void 0?f:i[m].default;(0,N.addToValueTree)(t,m,S,P=>console.error(`Conflict in default settings: ${P}`))}for(const m of Object.keys(t))b.OVERRIDE_PROPERTY_REGEX.test(m)&&l.push({identifiers:(0,b.overrideIdentifiersFromKey)(m),keys:Object.keys(t[m]),contents:(0,N.toValuesTree)(t[m],f=>console.error(`Conflict in default settings file: ${f}`))});super(t,u,l)}}e.DefaultConfigurationModel=s;class n{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new g}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,i){if(!D.isUndefinedOrNull(r)){const u=this.doParseContent(r);this.parseRaw(u,i)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,i){this._raw=r;const{contents:u,keys:t,overrides:l,restricted:m}=this.doParseRaw(r,i);this._configurationModel=new g(u,t,l),this._restrictedConfigurations=m||[]}doParseContent(r){let i={},u=null,t=[],l=[],m=[];function f(P){Array.isArray(t)?t.push(P):u!==null&&(t[u]=P)}let S={onObjectBegin:()=>{let P={};f(P),l.push(t),t=P,u=null},onObjectProperty:P=>{u=P},onObjectEnd:()=>{t=l.pop()},onArrayBegin:()=>{let P=[];f(P),l.push(t),t=P,u=null},onArrayEnd:()=>{t=l.pop()},onLiteralValue:f,onError:(P,$,L)=>{m.push({error:P,offset:$,length:L})}};if(r)try{w.visit(r,S),i=t[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return i}doParseRaw(r,i){const u=c.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),t=this.filter(r,u,!0,i);r=t.raw;const l=(0,N.toValuesTree)(r,S=>console.error(`Conflict in settings file ${this._name}: ${S}`)),m=Object.keys(r),f=this.toOverrides(r,S=>console.error(`Conflict in settings file ${this._name}: ${S}`));return{contents:l,keys:m,overrides:f,restricted:t.restricted}}filter(r,i,u,t){if(!t?.scopes&&!t?.skipRestricted)return{raw:r,restricted:[]};const l={},m=[];for(let f in r)if(b.OVERRIDE_PROPERTY_REGEX.test(f)&&u){const S=this.filter(r[f],i,!1,t);l[f]=S.raw,m.push(...S.restricted)}else{const S=i[f],P=S?typeof S.scope!="undefined"?S.scope:3:void 0;S?.restricted&&m.push(f),(P===void 0||t.scopes===void 0||t.scopes.includes(P))&&(t.skipRestricted&&S?.restricted||(l[f]=r[f]))}return{raw:l,restricted:m}}toOverrides(r,i){const u=[];for(const t of Object.keys(r))if(b.OVERRIDE_PROPERTY_REGEX.test(t)){const l={};for(const m in r[t])l[m]=r[t][m];u.push({identifiers:(0,b.overrideIdentifiersFromKey)(t),keys:Object.keys(l),contents:(0,N.toValuesTree)(l,i)})}return u}}e.ConfigurationModelParser=n;class h extends B.Disposable{constructor(r,i,u,t){super();this.userSettingsResource=r,this.scopes=i,this.fileService=t,this._onDidChange=this._register(new k.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new n(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(k.Event.any(k.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),k.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&u.isEqual(l.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new g}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class _{constructor(r,i,u=new g,t=new g,l=new C.ResourceMap,m=new g,f=new C.ResourceMap,S=!0){this._defaultConfiguration=r,this._localUserConfiguration=i,this._remoteUserConfiguration=u,this._workspaceConfiguration=t,this._folderConfigurations=l,this._memoryConfiguration=m,this._memoryConfigurationByResource=f,this._freeze=S,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new C.ResourceMap,this._userConfiguration=null}getValue(r,i,u){return this.getConsolidateConfigurationModel(i,u).getValue(r)}updateValue(r,i,u={}){let t;u.resource?(t=this._memoryConfigurationByResource.get(u.resource),t||(t=new g,this._memoryConfigurationByResource.set(u.resource,t))):t=this._memoryConfiguration,i===void 0?t.removeValue(r):t.setValue(r,i),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,i,u){const t=this.getConsolidateConfigurationModel(i,u),l=this.getFolderConfigurationModelForResource(i.resource,u),m=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,f=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),S=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),P=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),$=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),L=u?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,v=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(r):l.freeze().getValue(r):void 0,H=i.overrideIdentifier?m.override(i.overrideIdentifier).getValue(r):m.getValue(r),W=t.getValue(r),q=o.distinct(o.flatten(t.overrides.map(K=>K.identifiers))).filter(K=>t.getOverrideValue(r,K)!==void 0);return{defaultValue:f,userValue:S,userLocalValue:P,userRemoteValue:$,workspaceValue:L,workspaceFolderValue:v,memoryValue:H,value:W,default:f!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,user:S!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,userRemote:$!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,workspaceFolder:v!==void 0?{value:l?.freeze().getValue(r),override:i.overrideIdentifier?l?.freeze().getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,memory:H!==void 0?{value:m.getValue(r),override:i.overrideIdentifier?m.getOverrideValue(r,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:q.length?q:void 0}}keys(r){const i=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,i){this._folderConfigurations.set(r,i),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const u=[];if(!i){const{added:t,updated:l,removed:m}=E(this._defaultConfiguration,r);i=[...t,...l,...m]}for(const t of i)for(const l of(0,b.overrideIdentifiersFromKey)(t)){const m=this._defaultConfiguration.getKeysForOverrideIdentifier(l),f=r.getKeysForOverrideIdentifier(l),S=[...f.filter(P=>m.indexOf(P)===-1),...m.filter(P=>f.indexOf(P)===-1),...m.filter(P=>!A.equals(this._defaultConfiguration.override(l).getValue(P),r.override(l).getValue(P)))];u.push([l,S])}return this.updateDefaultConfiguration(r),{keys:i,overrides:u}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:u,removed:t,overrides:l}=E(this.localUserConfiguration,r),m=[...i,...u,...t];return m.length&&this.updateLocalUserConfiguration(r),{keys:m,overrides:l}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:u,removed:t,overrides:l}=E(this.remoteUserConfiguration,r);let m=[...i,...u,...t];return m.length&&this.updateRemoteUserConfiguration(r),{keys:m,overrides:l}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:u,removed:t,overrides:l}=E(this.workspaceConfiguration,r);let m=[...i,...u,...t];return m.length&&this.updateWorkspaceConfiguration(r),{keys:m,overrides:l}}compareAndUpdateFolderConfiguration(r,i){const u=this.folderConfigurations.get(r),{added:t,updated:l,removed:m,overrides:f}=E(u,i);let S=[...t,...l,...m];return(S.length||!u)&&this.updateFolderConfiguration(r,i),{keys:S,overrides:f}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:u,updated:t,removed:l,overrides:m}=E(i,void 0);return{keys:[...u,...t,...l],overrides:m}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(r,i){let u=this.getConsolidatedConfigurationModelForResource(r,i);return r.overrideIdentifier?u.override(r.overrideIdentifier):u}getConsolidatedConfigurationModelForResource({resource:r},i){let u=this.getWorkspaceConsolidatedConfiguration();if(i&&r){const t=i.getFolder(r);t&&(u=this.getFolderConsolidatedConfiguration(t.uri)||u);const l=this._memoryConfigurationByResource.get(r);l&&(u=u.merge(l))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let i=this._foldersConsolidatedConfigurations.get(r);if(!i){const u=this.getWorkspaceConsolidatedConfiguration(),t=this._folderConfigurations.get(r);t?(i=u.merge(t),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(r,i)):i=u}return i}getFolderConfigurationModelForResource(r,i){if(i&&r){const u=i.getFolder(r);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,i)=>{const{contents:u,overrides:t,keys:l}=this._folderConfigurations.get(i);return r.push([i,{contents:u,overrides:t,keys:l}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>r.add(i)),this.userConfiguration.freeze().keys.forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(u=>r.add(u))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i)),this._folderConfigurations.forEach(i=>i.freeze().getAllOverrideIdentifiers().forEach(u=>r.add(u))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(u=>i.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(u=>i.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(u=>i.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(r).forEach(t=>i.add(t))),[...i.values()]}static parse(r){const i=this.parseConfigurationModel(r.defaults),u=this.parseConfigurationModel(r.user),t=this.parseConfigurationModel(r.workspace),l=r.folders.reduce((m,f)=>(m.set(F.URI.revive(f[0]),this.parseConfigurationModel(f[1])),m),new C.ResourceMap);return new _(i,u,new g,t,l,new g,new C.ResourceMap,!1)}static parseConfigurationModel(r){return new g(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=_;function y(...T){if(T.length===0)return{keys:[],overrides:[]};if(T.length===1)return T[0];const r=new Set,i=new Map;for(const t of T)t.keys.forEach(l=>r.add(l)),t.overrides.forEach(([l,m])=>{const f=(0,C.getOrSet)(i,l,new Set);m.forEach(S=>f.add(S))});const u=[];return i.forEach((t,l)=>u.push([l,[...t.values()]])),{keys:[...r.values()],overrides:u}}e.mergeChanges=y;class d{constructor(r,i,u,t){this.change=r,this.previous=i,this.currentConfiguraiton=u,this.currentWorkspace=t,this._previousConfiguration=void 0;const l=new Set;r.keys.forEach(f=>l.add(f)),r.overrides.forEach(([,f])=>f.forEach(S=>l.add(S))),this.affectedKeys=[...l.values()];const m=new g;this.affectedKeys.forEach(f=>m.setValue(f,{})),this.affectedKeysTree=m.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=_.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(i){const u=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.previous?.workspace):void 0,t=this.currentConfiguraiton.getValue(r,i,this.currentWorkspace);return!A.equals(u,t)}return!0}return!1}doesAffectedKeysTreeContains(r,i){let u=(0,N.toValuesTree)({[i]:!0},()=>{}),t;for(;typeof u=="object"&&(t=Object.keys(u)[0]);){if(r=r[t],!r)return!1;u=u[t]}return!0}}e.ConfigurationChangeEvent=d;class p extends d{constructor(r,i,u,t){super({keys:r.allKeys(),overrides:[]},void 0,r,i);this.source=u,this.sourceConfig=t}}e.AllKeysConfigurationChangeEvent=p;function E(T,r){const{added:i,removed:u,updated:t}=a(r,T),l=[],m=T?.getAllOverrideIdentifiers()||[],f=r?.getAllOverrideIdentifiers()||[];if(r){const S=f.filter(P=>!m.includes(P));for(const P of S)l.push([P,r.getKeysForOverrideIdentifier(P)])}if(T){const S=m.filter(P=>!f.includes(P));for(const P of S)l.push([P,T.getKeysForOverrideIdentifier(P)])}if(r&&T){for(const S of m)if(f.includes(S)){const P=a({contents:T.getOverrideValue(void 0,S)||{},keys:T.getKeysForOverrideIdentifier(S)},{contents:r.getOverrideValue(void 0,S)||{},keys:r.getKeysForOverrideIdentifier(S)});l.push([S,[...P.added,...P.removed,...P.updated]])}}return{added:i,removed:u,updated:t,overrides:l}}function a(T,r){const i=T?r?T.keys.filter(l=>r.keys.indexOf(l)===-1):[...T.keys]:[],u=r?T?r.keys.filter(l=>T.keys.indexOf(l)===-1):[...r.keys]:[],t=[];if(T&&r){for(const l of r.keys)if(T.keys.indexOf(l)!==-1){const m=(0,N.getConfigurationValue)(r.contents,l),f=(0,N.getConfigurationValue)(T.contents,l);A.equals(m,f)||t.push(l)}}return{added:i,removed:u,updated:t}}}),define(we[81],be([1,0,3]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,o.createDecorator)("remoteAuthorityResolverService");var k;(function(B){B.Unknown="Unknown",B.NotAvailable="NotAvailable",B.TemporarilyNotAvailable="TemporarilyNotAvailable",B.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class w extends Error{constructor(C,A=k.Unknown,D){super(C);this._message=C,this._code=A,this._detail=D,this.isHandled=A===k.NotAvailable&&D===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,w.prototype)}static isTemporarilyNotAvailable(C){return C instanceof w&&C._code===k.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof w&&C._code===k.NoResolverFound}static isHandled(C){return C instanceof w&&C.isHandled}}e.RemoteAuthorityResolverError=w}),define(we[82],be([1,0,10]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteName=e.getRemoteAuthority=void 0;function k(B){return B.scheme===o.Schemas.vscodeRemote?B.authority:void 0}e.getRemoteAuthority=k;function w(B){if(!B)return;const C=B.indexOf("+");return C<0?B:B.substr(0,C)}e.getRemoteName=w}),define(we[26],be([1,0,9,3,82]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function B(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.getWorkspaceSupportTypeMessage=B;function C(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=C,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(A=e.ExtensionType||(e.ExtensionType={}));class D{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,s){if(typeof g=="undefined"||g===null)return typeof s=="undefined"||s===null;if(typeof s=="undefined"||s===null)return!1;if(typeof g=="string"||typeof s=="string"){let n=typeof g=="string"?g:g.value,h=typeof s=="string"?s:s.value;return o.equalsIgnoreCase(n,h)}return g._lower===s._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.ExtensionIdentifier=D;function F(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.isLanguagePackExtension=F;function N(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=N;function b(c,g){if(g){const s=`onResolveRemoteAuthority:${(0,w.getRemoteName)(g)}`;return c.activationEvents?.indexOf(s)!==-1}return!1}e.isResolverExtension=b,e.IBuiltinExtensionsScannerService=(0,k.createDecorator)("IBuiltinExtensionsScannerService")}),define(we[144],be([1,0,9,26]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function w(s,n){return s.uuid&&n.uuid?s.uuid===n.uuid:s.id===n.id?!0:(0,o.compareIgnoreCase)(s.id,n.id)===0}e.areSameExtensions=w;class B{constructor(n,h){this.version=h,this.id=n.id,this.uuid=n.uuid}key(){return`${this.id}-${this.version}`}equals(n){return n instanceof B?w(this,n)&&this.version===n.version:!1}}e.ExtensionIdentifierWithVersion=B;function C(s,n){return`${s}.${n}`}e.getExtensionId=C;function A(s){return s.toLocaleLowerCase()}e.adoptToGalleryExtensionId=A;function D(s,n){return A(C(s,n))}e.getGalleryExtensionId=D;function F(s,n){const h=[],_=y=>{for(const d of h)if(d.some(p=>w(n(p),n(y))))return d;return null};for(const y of s){const d=_(y);d?d.push(y):h.push([y])}return h}e.groupByExtension=F;function N(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=N;function b(s){return{id:s.identifier.id,name:s.name,galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),...s.telemetryData}}e.getGalleryExtensionTelemetryData=b,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function c(s){const n=new Set;if(s.malicious)for(const h of s.malicious)n.add(h.id);return n}e.getMaliciousExtensionsSet=c;function g(s,n){const h=[],_=n.manifest.extensionDependencies?.slice(0)??[];for(;_.length;){const y=_.shift();if(y&&h.every(d=>!w(d.identifier,{id:y}))){const d=s.filter(p=>w(p.identifier,{id:y}));d.length===1&&(h.push(d[0]),_.push(...d[0].manifest.extensionDependencies?.slice(0)??[]))}}return h}e.getExtensionDependencies=g}),define(we[145],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(w){this._callback=w,this._terminalBufferMap=new Map}dispose(){for(const w of this._terminalBufferMap.values())w.dispose()}startBuffering(w,B,C=5){let A;return A=B(D=>{const F=typeof D=="string"?D:D.data;let N=this._terminalBufferMap.get(w);if(N){N.data.push(F);return}const b=setTimeout(()=>this.flushBuffer(w),C);N={data:[F],timeoutId:b,dispose:()=>{clearTimeout(b),this.flushBuffer(w),A.dispose()}},this._terminalBufferMap.set(w,N)}),A}stopBuffering(w){const B=this._terminalBufferMap.get(w);B&&B.dispose()}flushBuffer(w){const B=this._terminalBufferMap.get(w);B&&(this._terminalBufferMap.delete(w),this._callback(w,B.data.join("")))}}e.TerminalDataBufferer=o}),define(we[146],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var o;(function(k){k.DARK="dark",k.LIGHT="light",k.HIGH_CONTRAST="hc"})(o=e.ColorScheme||(e.ColorScheme={}))}),define(we[57],be([1,0,106,5,7,3,37,146]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,B.createDecorator)("themeService");var D;(function(h){function _(y){return y&&typeof y=="object"&&typeof y.id=="string"}h.isThemeColor=_})(D=e.ThemeColor||(e.ThemeColor={}));function F(h){return{id:h}}e.themeColorFromId=F;var N;(function(h){function _(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||D.isThemeColor(i.color))}h.isThemeIcon=_;const y=new RegExp(`^\\$\\((${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?)\\)$`);function d(i){const u=y.exec(i);if(!u)return;let[,t]=u;return{id:t}}h.fromString=d;function p(i){return{id:i}}h.fromId=p;function E(i,u){let t=i.id;const l=t.lastIndexOf("~");return l!==-1&&(t=t.substring(0,l)),u&&(t=`${t}~${u}`),{id:t}}h.modify=E;function a(i){const u=i.id.lastIndexOf("~");if(u!==-1)return i.id.substring(u+1)}h.getModifier=a;function T(i,u){return i.id===u.id&&i.color?.id===u.color?.id}h.isEqual=T;function r(i,u){return{id:i.id,color:u?F(u):void 0}}h.asThemeIcon=r,h.asClassNameArray=o.CSSIcon.asClassNameArray,h.asClassName=o.CSSIcon.asClassName,h.asCSSSelector=o.CSSIcon.asCSSSelector})(N=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=o.Codicon.file,e.FolderThemeIcon=o.Codicon.folder;function b(h){switch(h){case A.ColorScheme.DARK:return"vs-dark";case A.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class c{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new k.Emitter}onColorThemeChange(_){return this.themingParticipants.push(_),this.onThemingParticipantAddedEmitter.fire(_),(0,w.toDisposable)(()=>{const y=this.themingParticipants.indexOf(_);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let g=new c;C.Registry.add(e.Extensions.ThemingContribution,g);function s(h){return g.onColorThemeChange(h)}e.registerThemingParticipant=s;class n extends w.Disposable{constructor(_){super();this.themeService=_,this.theme=_.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(_){this.theme=_,this.updateStyles()}updateStyles(){}getColor(_,y){let d=this.theme.getColor(_);return d&&y&&(d=y(d,this.theme)),d?d.toString():null}}e.Themable=n}),define(we[147],be([1,0,5,23,3,12]),function(Z,e,o,k,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,w.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,w.createDecorator)("sharedTunnelsService");var C;(function(s){s.Http="http",s.Https="https"})(C=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(s){s.ConstantPrivate="constantPrivate",s.Private="private",s.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var D;(function(s){s[s.Notify=1]="Notify",s[s.OpenBrowser=2]="OpenBrowser",s[s.OpenPreview=3]="OpenPreview",s[s.Silent=4]="Silent",s[s.Ignore=5]="Ignore",s[s.OpenBrowserOnce=6]="OpenBrowserOnce"})(D=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function F(s){if(s.scheme!=="http"&&s.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(s.authority);if(!!n)return{address:n[1],port:+n[2]}}e.extractLocalHostUriMetaDataForPortMapping=F,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function N(s){return e.LOCALHOST_ADDRESSES.indexOf(s)>=0}e.isLocalhost=N,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(s){return e.ALL_INTERFACES_ADDRESSES.indexOf(s)>=0}e.isAllInterfaces=b;function c(s,n){return n?n!==1&&s<1024:!k.isWindows&&s<1024}e.isPortPrivileged=c;let g=class{constructor(n){this.logService=n,this._onTunnelOpened=new o.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new o.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new o.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(n){return this._tunnelProvider=n,n?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this._canElevate=n.elevation,this._privacyOptions=n.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const n=[],h=Array.from(this._tunnels.values());for(let _ of h){const y=Array.from(_.values());for(let d of y){const p=await d.value;p&&n.push(p)}}return n}async dispose(){for(const n of this._tunnels.values()){for(const{value:h}of n.values())await h.then(_=>_?.dispose());n.clear()}this._tunnels.clear()}openTunnel(n,h,_,y,d=!1,p=A.Private,E){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${_} on local port ${y}.`),!n)return;h||(h="localhost");const a=this.retainOrCreateTunnel(n,h,_,y,d,p,E);return a?a.then(T=>{if(!T){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(h,_);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const r=this.makeTunnel(T);return(T.tunnelRemoteHost!==h||T.tunnelRemotePort!==_)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(r),r}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),a)}makeTunnel(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const h=this._tunnels.get(n.tunnelRemoteHost);if(h){const _=h.get(n.tunnelRemotePort);_&&(_.refcount--,await this.tryDisposeTunnel(n.tunnelRemoteHost,n.tunnelRemotePort,_))}}}}async tryDisposeTunnel(n,h,_){if(_.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${h}.`);const y=_.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(n)&&this._tunnels.get(n).delete(h),y}}async closeTunnel(n,h){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${h} `);const _=this._tunnels.get(n);if(_&&_.has(h)){const y=_.get(h);y.refcount=0,await this.tryDisposeTunnel(n,h,y)}}addTunnelToMap(n,h,_){this._tunnels.has(n)||this._tunnels.set(n,new Map),this._tunnels.get(n).set(h,{refcount:1,value:_})}async removeEmptyTunnelFromMap(n,h){const _=this._tunnels.get(n);_&&(await _.get(h)||_.delete(h),_.size===0&&this._tunnels.delete(n))}getTunnelFromMap(n,h){let _=[n];N(n)?(_.push(...e.LOCALHOST_ADDRESSES),_.push(...e.ALL_INTERFACES_ADDRESSES)):b(n)&&_.push(...e.ALL_INTERFACES_ADDRESSES);const y=_.map(d=>this._tunnels.get(d));for(const d of y){const p=d?.get(h);if(p)return p}}canTunnel(n){return!!F(n)}createWithProvider(n,h,_,y,d,p,E){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${_} on local port ${y}.`);const T={elevationRequired:d?c(y===void 0?_:y):!1},r={remoteAddress:{host:h,port:_},localAddressPort:y,privacy:p,public:p!==A.Private,protocol:E},i=n.forwardPort(r,T);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),i&&this.addTunnelToMap(h,_,i),i}};g=Fe([Ne(0,B.ILogService)],g),e.AbstractTunnelService=g}),define(we[148],be([1,0,10]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function k(A){return A.scheme!==o.Schemas.file&&A.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=k;function w(A){if(A.folders.length)return A.folders.every(D=>k(D.uri))?A.folders[0].uri:void 0;if(A.configuration&&k(A.configuration))return A.configuration}e.getVirtualWorkspaceLocation=w;function B(A){return w(A)?.scheme}e.getVirtualWorkspaceScheme=B;function C(A){return w(A)!==void 0}e.isVirtualWorkspace=C}),define(we[46],be([1,0,121,17,22,24,2,3,10]),function(Z,e,o,k,w,B,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function F(r){const i=r;return typeof i?.id=="string"&&C.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=F;function N(r){if(r.configuration)return{id:r.id,configPath:r.configuration};if(r.folders.length===1)return{id:r.id,uri:r.folders[0].uri}}e.toWorkspaceIdentifier=N;function b(r){const i=r;return typeof i?.id=="string"&&C.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=b;function c(r){const i=r;if(i?.uri)return{id:i.id,uri:C.URI.revive(i.uri)};const u=r;if(u?.configPath)return{id:u.id,configPath:C.URI.revive(u.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=c;var g;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(g=e.WorkbenchState||(e.WorkbenchState={}));function s(r){const i=r;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=s;function n(r){const i=r;return!!(i&&typeof i=="object"&&C.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=n;class h{constructor(i,u,t,l,m){this._id=i,this._transient=t,this._configuration=l,this._ignorePathCasing=m,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=u}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i.with({scheme:i.scheme,authority:i.authority,path:i.path}))||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class _{constructor(i,u){this.raw=u,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,B.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=_;function y(r){return new _({uri:r,index:0,name:(0,B.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace";const d=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function p(r,i){return B.extUriBiasedIgnorePathCase.isEqualOrParent(r,i.untitledWorkspacesHome)}e.isUntitledWorkspace=p;function E(r){let i;return C.URI.isUri(r)?i=r:i=r.configuration,i?.scheme===D.Schemas.tmp}e.isTemporaryWorkspace=E;function a(r,i){return!p(r,i)&&!E(r)}e.isSavedWorkspace=a;function T(r){return(typeof r=="string"?(0,k.extname)(r):(0,B.extname)(r))===d}e.hasWorkspaceFileExtension=T}),define(we[58],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(w){this.id=w,this._data=new Map,this._idPool=1}add(w){const B=this._idPool++;return this._data.set(B,w),this.logDebugInfo(),B}get(w,B){return this._data.has(w)?this._data.get(w)[B]:void 0}delete(w){this._data.delete(w),this.logDebugInfo()}logDebugInfo(){!o.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=o,o.enableDebugLogging=!1}),define(we[30],be([1,0,10,24,3]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class B{constructor(){this._systemSchemes=new Set(Object.keys(o.Schemas)),this._providerInfo=new Map,this.extUri=new k.ExtUri(A=>{const D=this._providerInfo.get(A.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(A,D){D===null?this._providerInfo.delete(A.scheme):this._providerInfo.set(A.scheme,D)}isFreeScheme(A){return!this._providerInfo.has(A)&&!this._systemSchemes.has(A)}getCapabilities(A){return this._providerInfo.get(A)}}e.ExtHostFileSystemInfo=B,e.IExtHostFileSystemInfo=(0,w.createDecorator)("IExtHostFileSystemInfo")}),define(we[27],be([1,0,3]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(we[149],be([1,0,13]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class k{constructor(C,A,D){this._deferredPromises=new Map,this._id=C,this._shared=A,this._storage=D,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(F=>(this._value=F,this)),this._storageListener=this._storage.onDidChangeStorage(F=>{F.shared===this._shared&&F.key===this._id&&(this._value=F.value)}),this._scheduler=new o.RunOnceScheduler(()=>{const F=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const N of F.values())N.complete()}catch(N){for(const b of F.values())b.error(N)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,C])=>C!==void 0).map(([C])=>C)}get whenReady(){return this._init}get(C,A){let D=this._value[C];return typeof D=="undefined"&&(D=A),D}update(C,A){this._value[C]=A;let D=this._deferredPromises.get(C);if(D!==void 0)return D.p;const F=new o.DeferredPromise;return this._deferredPromises.set(C,F),this._scheduler.isScheduled()||this._scheduler.schedule(),F.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=k;class w extends k{constructor(C,A){super(C.identifier.value,!0,A);this._extension=C}setKeysForSync(C){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},C)}}e.ExtensionGlobalMemento=w}),define(we[150],be([1,0,5,25,2,12]),function(Z,e,o,k,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let C=class{constructor(D,F){this._logService=D,this._notebooksAndEditors=F,this._onDidChangeNotebookDocumentMetadata=new o.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new o.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new o.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(D,F,N,b){const g=this._notebooksAndEditors.getNotebookDocument(w.URI.revive(D)).acceptModelChanged(F.value,N,b);this._onDidChangeNotebookDocument.fire((0,k.deepFreeze)(g))}$acceptDirtyStateChanged(D,F){this._notebooksAndEditors.getNotebookDocument(w.URI.revive(D)).acceptDirty(F)}$acceptModelSaved(D){const F=this._notebooksAndEditors.getNotebookDocument(w.URI.revive(D));this._onDidSaveNotebookDocument.fire(F.apiNotebook)}$acceptDocumentPropertiesChanged(D,F){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",D.path,F);const N=this._notebooksAndEditors.getNotebookDocument(w.URI.revive(D));N.acceptDocumentPropertiesChanged(F),F.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:N.apiNotebook})}};C=Fe([Ne(0,B.ILogService)],C),e.ExtHostNotebookDocuments=C}),define(we[14],be([1,0,3]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class k{constructor(B){this.getProxy=B.getProxy.bind(B),this.set=B.set.bind(B),this.assertRegistered=B.assertRegistered.bind(B),this.drain=B.drain.bind(B)}}e.ExtHostRpcService=k});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,o,k,w){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!w:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?w.call(Z,o):w?w.value=o:e.set(Z,o),o},De=this&&this.__classPrivateFieldGet||function(Z,e,o,k){if(o==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?k:o==="a"?k.call(Z):k?k.value:e.get(Z)};define(we[151],be([1,0,26,5]),function(Z,e,o,k){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class B{constructor(A,D){w.set(this,void 0),this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._id=o.ExtensionIdentifier.toKey(A.identifier),Ve(this,w,D,"f"),De(this,w,"f").onDidChangePassword(F=>{F.extensionId===this._id&&this._onDidChange.fire({key:F.key})})}get(A){return De(this,w,"f").get(this._id,A)}store(A,D){return De(this,w,"f").store(this._id,A,D)}delete(A){return De(this,w,"f").delete(this._id,A)}}e.ExtensionSecrets=B,w=new WeakMap}),define(we[83],be([1,0,3,5]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class w{constructor(){this._onDidChangeTelemetryEnabled=new k.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new k.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._level>=2,isUsageEnabled:this._level>=3}}$initializeTelemetryLevel(C){this._level=C}$onDidChangeTelemetryLevel(C){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=C,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=w,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(we[47],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var o;(function(y){y[y.Upsert=0]="Upsert",y[y.RemoveChild=1]="RemoveChild",y[y.Invalidated=2]="Invalidated",y[y.SetProp=3]="SetProp",y[y.Bulk=4]="Bulk"})(o=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const k=new WeakMap,w=(y,d)=>{const p={controllerId:d};return k.set(y,p),p};e.createPrivateApiFor=w;const B=y=>k.get(y);e.getPrivateApiFor=B;const C=(y,d,p,E)=>{let a=p;return{enumerable:!0,configurable:!1,get(){return a},set(T){if(!E(a,T)){const r=a;a=T,y.listener?.({op:3,key:d,value:T,previous:r})}}}},A=(y,d)=>y===d,D={range:(y,d)=>y===d?!0:!y||!d?!1:y.isEqual(d),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(y,d)=>!(y.length!==d.length||y.some(p=>!d.find(E=>p.id===E.id)))},F=Object.keys(D),N=(y,d)=>({range:C(y,"range",void 0,D.range),label:C(y,"label",d,D.label),description:C(y,"description",void 0,D.description),sortText:C(y,"sortText",void 0,D.sortText),canResolveChildren:C(y,"canResolveChildren",!1,D.canResolveChildren),busy:C(y,"busy",!1,D.busy),error:C(y,"error",void 0,D.error),tags:C(y,"tags",[],D.tags)}),b=(y,d)=>{const p=new Map;for(const E of F)D[E](y[E],d[E])||p.set(E,d[E]);return p};e.diffTestItems=b;class c extends Error{constructor(d){super(`Attempted to insert a duplicate test item ID ${d}`)}}e.DuplicateTestItemError=c;class g extends Error{constructor(d){super(`TestItem with ID "${d}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=g;class s extends Error{constructor(d,p,E){super(`TestItem with ID "${d}" is from controller "${p}" and cannot be added as a child of an item from controller "${E}".`)}}e.MixedTestItemController=s;const n=y=>{const d=(0,e.getPrivateApiFor)(y);let p=new Map;return{get size(){return p.size},forEach(E,a){for(const T of p.values())E.call(a,T,this)},replace(E){const a=new Map,T=new Set(p.keys()),r={op:4,ops:[]};for(const i of E){if(!(i instanceof h))throw new g(i.id);const u=(0,e.getPrivateApiFor)(i).controllerId;if(u!==d.controllerId)throw new s(i.id,u,d.controllerId);if(a.has(i.id))throw new c(i.id);a.set(i.id,i),T.delete(i.id),r.ops.push({op:0,item:i})}for(const i of T.keys())r.ops.push({op:1,id:i});d.listener?.(r),p=a},add(E){if(!(E instanceof h))throw new g(E.id);p.set(E.id,E),d.listener?.({op:0,item:E})},delete(E){p.delete(E)&&d.listener?.({op:1,id:E})},get(E){return p.get(E)},toJSON(){return Array.from(p.values())},[Symbol.iterator](){return p.values()}}};class h{constructor(d,p,E,a){if(p.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(p)} symbol`);const T=(0,e.createPrivateApiFor)(this,d);Object.defineProperties(this,{id:{value:p,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return T.parent instanceof _?void 0:T.parent}},children:{value:n(this),enumerable:!0,writable:!1},...N(T,E)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=h;class _ extends h{constructor(d,p){super(d,d,p,void 0)}}e.TestItemRootImpl=_}),define(we[59],be([1,0,3,147,5,14]),function(Z,e,o,k,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var C;(function(D){function F(b){return{remoteAddress:b.remoteAddress,localAddress:b.localAddress,public:!!b.public,privacy:b.privacy??(b.public?k.TunnelPrivacyId.Public:k.TunnelPrivacyId.Private),protocol:b.protocol}}D.fromApiTunnel=F;function N(b){return{remoteAddress:{host:b.tunnelRemoteHost,port:b.tunnelRemotePort},localAddress:b.localAddress,public:b.privacy!==k.TunnelPrivacyId.ConstantPrivate&&b.privacy!==k.TunnelPrivacyId.ConstantPrivate,privacy:b.privacy,protocol:b.protocol}}D.fromServiceTunnel=N})(C=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let A=class{constructor(F){this.onDidChangeTunnels=new w.Emitter().event}async $applyCandidateFilter(F){return F}async openTunnel(F,N){}async getTunnels(){return[]}async setTunnelFactory(F){return{dispose:()=>{}}}registerPortsAttributesProvider(F,N){return{dispose:()=>{}}}async $providePortAttributes(F,N,b,c,g){return[]}async $forwardPort(F,N){}async $closeTunnel(F){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=Fe([Ne(0,B.IExtHostRpcService)],A),e.ExtHostTunnelService=A});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,o,k,w){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!w:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?w.call(Z,o):w?w.value=o:e.set(Z,o),o},De=this&&this.__classPrivateFieldGet||function(Z,e,o,k){if(o==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?k:o==="a"?k.call(Z):k?k.value:e.get(Z)};define(we[6],be([1,0,16,15,72,22,71,9,11,2,36,45,81]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c){"use strict";var g,s,n,h,_,y,d,p,E,a,T,r,i,u,t,l,m,f,S,P;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function $(j){function U(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(U,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(U,j),Object.setPrototypeOf(U.prototype,j.prototype),U}let L=_=class{constructor(U){g.set(this,void 0),Ve(this,g,U,"f")}static from(...U){let te=U;return new _(function(){if(te){for(const _e of te)_e&&typeof _e.dispose=="function"&&_e.dispose();te=void 0}})}dispose(){typeof De(this,g,"f")=="function"&&(De(this,g,"f").call(this),Ve(this,g,void 0,"f"))}};g=new WeakMap,L=_=Fe([$],L),e.Disposable=L;let v=y=class{constructor(U,te){if(U<0)throw(0,k.illegalArgument)("line must be non-negative");if(te<0)throw(0,k.illegalArgument)("character must be non-negative");this._line=U,this._character=te}static Min(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let _e=1;_e<U.length;_e++){const We=U[_e];We.isBefore(te)&&(te=We)}return te}static Max(...U){if(U.length===0)throw new TypeError;let te=U[0];for(let _e=1;_e<U.length;_e++){const We=U[_e];We.isAfter(te)&&(te=We)}return te}static isPosition(U){if(!U)return!1;if(U instanceof y)return!0;let{line:te,character:_e}=U;return typeof te=="number"&&typeof _e=="number"}static of(U){if(U instanceof y)return U;if(this.isPosition(U))return new y(U.line,U.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<U._character}isBeforeOrEqual(U){return this._line<U._line?!0:U._line<this._line?!1:this._character<=U._character}isAfter(U){return!this.isBeforeOrEqual(U)}isAfterOrEqual(U){return!this.isBefore(U)}isEqual(U){return this._line===U._line&&this._character===U._character}compareTo(U){return this._line<U._line?-1:this._line>U.line?1:this._character<U._character?-1:this._character>U._character?1:0}translate(U,te=0){if(U===null||te===null)throw(0,k.illegalArgument)();let _e;return typeof U=="undefined"?_e=0:typeof U=="number"?_e=U:(_e=typeof U.lineDelta=="number"?U.lineDelta:0,te=typeof U.characterDelta=="number"?U.characterDelta:0),_e===0&&te===0?this:new y(this.line+_e,this.character+te)}with(U,te=this.character){if(U===null||te===null)throw(0,k.illegalArgument)();let _e;return typeof U=="undefined"?_e=this.line:typeof U=="number"?_e=U:(_e=typeof U.line=="number"?U.line:this.line,te=typeof U.character=="number"?U.character:this.character),_e===this.line&&te===this.character?this:new y(_e,te)}toJSON(){return{line:this.line,character:this.character}}};v=y=Fe([$],v),e.Position=v;let H=d=class{constructor(U,te,_e,We){let Ke,Ye;if(typeof U=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof We=="number"?(Ke=new v(U,te),Ye=new v(_e,We)):v.isPosition(U)&&v.isPosition(te)&&(Ke=v.of(U),Ye=v.of(te)),!Ke||!Ye)throw new Error("Invalid arguments");Ke.isBefore(Ye)?(this._start=Ke,this._end=Ye):(this._start=Ye,this._end=Ke)}static isRange(U){return U instanceof d?!0:U?v.isPosition(U.start)&&v.isPosition(U.end):!1}static of(U){if(U instanceof d)return U;if(this.isRange(U))return new d(U.start,U.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(U){return d.isRange(U)?this.contains(U.start)&&this.contains(U.end):v.isPosition(U)?!(v.of(U).isBefore(this._start)||this._end.isBefore(U)):!1}isEqual(U){return this._start.isEqual(U._start)&&this._end.isEqual(U._end)}intersection(U){const te=v.Max(U.start,this._start),_e=v.Min(U.end,this._end);if(!te.isAfter(_e))return new d(te,_e)}union(U){if(this.contains(U))return this;if(U.contains(this))return U;const te=v.Min(U.start,this._start),_e=v.Max(U.end,this.end);return new d(te,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(U,te=this.end){if(U===null||te===null)throw(0,k.illegalArgument)();let _e;return U?v.isPosition(U)?_e=U:(_e=U.start||this.start,te=U.end||this.end):_e=this.start,_e.isEqual(this._start)&&te.isEqual(this.end)?this:new d(_e,te)}toJSON(){return[this.start,this.end]}};H=d=Fe([$],H),e.Range=H;let W=p=class extends H{constructor(U,te,_e,We){let Ke,Ye;if(typeof U=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof We=="number"?(Ke=new v(U,te),Ye=new v(_e,We)):v.isPosition(U)&&v.isPosition(te)&&(Ke=v.of(U),Ye=v.of(te)),!Ke||!Ye)throw new Error("Invalid arguments");super(Ke,Ye);this._anchor=Ke,this._active=Ye}static isSelection(U){return U instanceof p?!0:U?H.isRange(U)&&v.isPosition(U.anchor)&&v.isPosition(U.active)&&typeof U.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};W=p=Fe([$],W),e.Selection=W;class q{constructor(U,te,_e){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,k.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,k.illegalArgument)("connectionToken");this.host=U,this.port=Math.round(te),this.connectionToken=_e}}e.ResolvedAuthority=q;class K extends Error{constructor(U,te=c.RemoteAuthorityResolverErrorCode.Unknown,_e){super(U);this._message=U,this._code=te,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,K.prototype)}static NotAvailable(U,te){return new K(U,c.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(U){return new K(U,c.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=K;var V;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(V=e.EndOfLine||(e.EndOfLine={}));var z;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(z=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let ae=E=class{constructor(U,te){this._range=U,this._newText=te}static isTextEdit(U){return U instanceof E?!0:U?H.isRange(U)&&typeof U.newText=="string":!1}static replace(U,te){return new E(U,te)}static insert(U,te){return E.replace(new H(U,U),te)}static delete(U){return E.replace(U,"")}static setEndOfLine(U){const te=new E(new H(new v(0,0),new v(0,0)),"");return te.newEol=U,te}get range(){return this._range}set range(U){if(U&&!H.isRange(U))throw(0,k.illegalArgument)("range");this._range=U}get newText(){return this._newText||""}set newText(U){if(U&&typeof U!="string")throw(0,k.illegalArgument)("newText");this._newText=U}get newEol(){return this._newEol}set newEol(U){if(U&&typeof U!="number")throw(0,k.illegalArgument)("newEol");this._newEol=U}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};ae=E=Fe([$],ae),e.TextEdit=ae;var de;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace"})(de=e.FileEditType||(e.FileEditType={}));let Y=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(U,te,_e,We){this._edits.push({_type:1,from:U,to:te,options:_e,metadata:We})}createFile(U,te,_e){this._edits.push({_type:1,from:void 0,to:U,options:te,metadata:_e})}deleteFile(U,te,_e){this._edits.push({_type:1,from:U,to:void 0,options:te,metadata:_e})}replaceNotebookMetadata(U,te,_e){this._edits.push({_type:3,metadata:_e,uri:U,edit:{editType:5,metadata:te},notebookMetadata:te})}replaceNotebookCells(U,te,_e,We,Ke){let Ye,et,_t=[],Pt;if(Xt.isNotebookRange(te)&&Pe.isNotebookCellDataArray(_e)&&!Pe.isNotebookCellDataArray(We)?(Ye=te.start,et=te.end,_t=_e,Pt=We):typeof te=="number"&&typeof _e=="number"&&Pe.isNotebookCellDataArray(We)&&(Ye=te,et=_e,_t=We,Pt=Ke),Ye===void 0||et===void 0)throw new Error("Invalid arguments");(Ye!==et||_t.length>0)&&this._edits.push({_type:5,uri:U,index:Ye,count:et-Ye,cells:_t,metadata:Pt})}replaceNotebookCellMetadata(U,te,_e,We){this._edits.push({_type:3,metadata:We,uri:U,edit:{editType:8,index:te,metadata:_e}})}replace(U,te,_e,We){this._edits.push({_type:2,uri:U,edit:new ae(te,_e),metadata:We})}insert(U,te,_e,We){this.replace(U,new H(te,te),_e,We)}delete(U,te,_e){this.replace(U,te,"",_e)}has(U){return this._edits.some(te=>te._type===2&&te.uri.toString()===U.toString())}set(U,te){if(te)for(const _e of te)_e&&this._edits.push({_type:2,uri:U,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const We=this._edits[_e];We._type===2&&We.uri.toString()===U.toString()&&(this._edits[_e]=void 0)}(0,o.coalesceInPlace)(this._edits)}}get(U){const te=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===U.toString()&&te.push(_e.edit);return te}entries(){const U=new B.ResourceMap;for(let te of this._edits)if(te._type===2){let _e=U.get(te.uri);_e||(_e=[te.uri,[]],U.set(te.uri,_e)),_e[1].push(te.edit)}return[...U.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Y=Fe([$],Y),e.WorkspaceEdit=Y;let ie=a=class{constructor(U){this._tabstop=1,this.value=U||""}static isSnippetString(U){return U instanceof a?!0:U?typeof U.value=="string":!1}static _escape(U){return U.replace(/\$|}|\\/g,"\\$&")}appendText(U){return this.value+=a._escape(U),this}appendTabstop(U=this._tabstop++){return this.value+="$",this.value+=U,this}appendPlaceholder(U,te=this._tabstop++){if(typeof U=="function"){const _e=new a;_e._tabstop=this._tabstop,U(_e),this._tabstop=_e._tabstop,U=_e.value}else U=a._escape(U);return this.value+="${",this.value+=te,this.value+=":",this.value+=U,this.value+="}",this}appendChoice(U,te=this._tabstop++){const _e=U.map(We=>We.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(U,te){if(typeof te=="function"){const _e=new a;_e._tabstop=this._tabstop,te(_e),this._tabstop=_e._tabstop,te=_e.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=U,te&&(this.value+=":",this.value+=te),this.value+="}",this}};ie=a=Fe([$],ie),e.SnippetString=ie;var ce;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(ce=e.DiagnosticTag||(e.DiagnosticTag={}));var he;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(he=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ue=T=class{constructor(U,te){if(this.uri=U,te)if(H.isRange(te))this.range=H.of(te);else if(v.isPosition(te))this.range=new H(te,te);else throw new Error("Illegal argument")}static isLocation(U){return U instanceof T?!0:U?H.isRange(U.range)&&F.URI.isUri(U.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ue=T=Fe([$],ue),e.Location=ue;let se=class{constructor(U,te){this.location=U,this.message=te}static is(U){return U?typeof U.message=="string"&&U.location&&H.isRange(U.location.range)&&F.URI.isUri(U.location.uri):!1}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.location.range.isEqual(te.location.range)&&U.location.uri.toString()===te.location.uri.toString()}};se=Fe([$],se),e.DiagnosticRelatedInformation=se;let ge=class{constructor(U,te,_e=he.Error){if(!H.isRange(U))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=U,this.message=te,this.severity=_e}toJSON(){return{severity:he[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(U,te){return U===te?!0:!U||!te?!1:U.message===te.message&&U.severity===te.severity&&U.code===te.code&&U.severity===te.severity&&U.source===te.source&&U.range.isEqual(te.range)&&(0,o.equals)(U.tags,te.tags)&&(0,o.equals)(U.relatedInformation,te.relatedInformation,se.isEqual)}};ge=Fe([$],ge),e.Diagnostic=ge;let Te=class{constructor(U,te){if(!U)throw new Error("Illegal argument, contents must be defined");Array.isArray(U)?this.contents=U:this.contents=[U],this.range=te}};Te=Fe([$],Te),e.Hover=Te;var Re;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Re=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let He=class{constructor(U,te=Re.Text){this.range=U,this.kind=te}toJSON(){return{range:this.range,kind:Re[this.kind]}}};He=Fe([$],He),e.DocumentHighlight=He;var Xe;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Xe=e.SymbolKind||(e.SymbolKind={}));var ve;(function(j){j[j.Deprecated=1]="Deprecated"})(ve=e.SymbolTag||(e.SymbolTag={}));let fe=r=class{constructor(U,te,_e,We,Ke){this.name=U,this.kind=te,this.containerName=Ke,typeof _e=="string"&&(this.containerName=_e),We instanceof ue?this.location=We:_e instanceof H&&(this.location=new ue(We,_e)),r.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Xe[this.kind],location:this.location,containerName:this.containerName}}};fe=r=Fe([$],fe),e.SymbolInformation=fe;let M=i=class{constructor(U,te,_e,We,Ke){this.name=U,this.detail=te,this.kind=_e,this.range=We,this.selectionRange=Ke,this.children=[],i.validate(this)}static validate(U){if(!U.name)throw new Error("name must not be falsy");if(!U.range.contains(U.selectionRange))throw new Error("selectionRange must be contained in fullRange");U.children&&U.children.forEach(i.validate)}};M=i=Fe([$],M),e.DocumentSymbol=M;var O;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(O=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let I=class{constructor(U,te){this.title=U,this.kind=te}};I=Fe([$],I),e.CodeAction=I;let R=u=class{constructor(U){this.value=U}append(U){return new u(this.value?this.value+u.sep+U:U)}intersects(U){return this.contains(U)||U.contains(this)}contains(U){return this.value===U.value||U.value.startsWith(this.value+u.sep)}};R.sep=".",R=u=Fe([$],R),e.CodeActionKind=R,R.Empty=new R(""),R.QuickFix=R.Empty.append("quickfix"),R.Refactor=R.Empty.append("refactor"),R.RefactorExtract=R.Refactor.append("extract"),R.RefactorInline=R.Refactor.append("inline"),R.RefactorRewrite=R.Refactor.append("rewrite"),R.Source=R.Empty.append("source"),R.SourceOrganizeImports=R.Source.append("organizeImports"),R.SourceFixAll=R.Source.append("fixAll");let x=class{constructor(U,te){if(this.range=U,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};x=Fe([$],x),e.SelectionRange=x;class Q{constructor(U,te,_e,We,Ke,Ye){this.kind=U,this.name=te,this.detail=_e,this.uri=We,this.range=Ke,this.selectionRange=Ye}}e.CallHierarchyItem=Q;class ne{constructor(U,te){this.fromRanges=te,this.from=U}}e.CallHierarchyIncomingCall=ne;class Ee{constructor(U,te){this.fromRanges=te,this.to=U}}e.CallHierarchyOutgoingCall=Ee;var Ie;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Ie=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Me=class{constructor(U,te){this.range=U,this.command=te}get isResolved(){return!!this.command}};Me=Fe([$],Me),e.CodeLens=Me;let Le=t=class{constructor(U,te=!1){s.set(this,void 0),Ve(this,s,new w.MarkdownString(U,{supportThemeIcons:te}),"f")}static isMarkdownString(U){return U instanceof t?!0:U&&U.appendCodeblock&&U.appendMarkdown&&U.appendText&&U.value!==void 0}get value(){return De(this,s,"f").value}set value(U){De(this,s,"f").value=U}get isTrusted(){return De(this,s,"f").isTrusted}set isTrusted(U){De(this,s,"f").isTrusted=U}get supportThemeIcons(){return De(this,s,"f").supportThemeIcons}set supportThemeIcons(U){De(this,s,"f").supportThemeIcons=U}get supportHtml(){return De(this,s,"f").supportHtml}set supportHtml(U){De(this,s,"f").supportHtml=U}get baseUri(){return De(this,s,"f").baseUri}set baseUri(U){De(this,s,"f").baseUri=U}appendText(U){return De(this,s,"f").appendText(U),this}appendMarkdown(U){return De(this,s,"f").appendMarkdown(U),this}appendCodeblock(U,te){return De(this,s,"f").appendCodeblock(te??"",U),this}};s=new WeakMap,Le=t=Fe([$],Le),e.MarkdownString=Le;let ze=class{constructor(U,te){this.label=U,this.documentation=te}};ze=Fe([$],ze),e.ParameterInformation=ze;let Be=class{constructor(U,te){this.label=U,this.documentation=te,this.parameters=[]}};Be=Fe([$],Be),e.SignatureInformation=Be;let Ae=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ae=Fe([$],Ae),e.SignatureHelp=Ae;var Qe;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(Qe=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var tt;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(tt=e.InlayHintKind||(e.InlayHintKind={}));let ke=class{constructor(U){this.value=U}};ke=Fe([$],ke),e.InlayHintLabelPart=ke;let it=class{constructor(U,te,_e){this.position=U,this.label=te,this.kind=_e}};it=Fe([$],it),e.InlayHint=it;var X;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(X=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var J;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(J=e.CompletionItemKind||(e.CompletionItemKind={}));var le;(function(j){j[j.Deprecated=1]="Deprecated"})(le=e.CompletionItemTag||(e.CompletionItemTag={}));let Oe=class{constructor(U,te){this.label=U,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&J[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Oe=Fe([$],Oe),e.CompletionItem=Oe;let $e=class{constructor(U=[],te=!1){this.items=U,this.isIncomplete=te}};$e=Fe([$],$e),e.CompletionList=$e;let Ge=class{constructor(U,te,_e){this.insertText=U,this.range=te,this.command=_e}};Ge=Fe([$],Ge),e.InlineSuggestion=Ge;let Je=class{constructor(U){this.items=U}};Je=Fe([$],Je),e.InlineSuggestions=Je;var ht;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(ht=e.ViewColumn||(e.ViewColumn={}));var It;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(It=e.StatusBarAlignment||(e.StatusBarAlignment={}));var St;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(St=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var kt;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(kt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var qe;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(qe=e.TextEditorRevealType||(e.TextEditorRevealType={}));var vt;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(vt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Nt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Nt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var nt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function U(te){switch(te){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=U}(vt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ut=class{constructor(U,te){if(te&&!F.URI.isUri(te))throw(0,k.illegalArgument)("target");if(!H.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.target=te}};ut=Fe([$],ut),e.DocumentLink=ut;let At=class{constructor(U,te,_e,We){this.red=U,this.green=te,this.blue=_e,this.alpha=We}};At=Fe([$],At),e.Color=At;let Tt=class{constructor(U,te){if(te&&!(te instanceof At))throw(0,k.illegalArgument)("color");if(!H.isRange(U)||U.isEmpty)throw(0,k.illegalArgument)("range");this.range=U,this.color=te}};Tt=Fe([$],Tt),e.ColorInformation=Tt;let bt=class{constructor(U){if(!U||typeof U!="string")throw(0,k.illegalArgument)("label");this.label=U}};bt=Fe([$],bt),e.ColorPresentation=bt;var dt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(dt=e.ColorFormat||(e.ColorFormat={}));var Rt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Rt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Lt{constructor(U,te,_e){if(this.startIndex=U,this.length=te,this.tooltip=_e,typeof U!="number"||U<0)throw(0,k.illegalArgument)("startIndex");if(typeof te!="number"||te<1)throw(0,k.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,k.illegalArgument)("tooltip")}}e.TerminalLink=Lt;var Ft;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Ft=e.TerminalLocation||(e.TerminalLocation={}));class Ue{constructor(U){this.options=U,typeof U!="object"&&(0,k.illegalArgument)("options")}}e.TerminalProfile=Ue;var me;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(me=e.TaskRevealKind||(e.TaskRevealKind={}));var pe;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(pe=e.TaskPanelKind||(e.TaskPanelKind={}));let oe=l=class{constructor(U,te){if(this.label=te,typeof U!="string"||typeof te!="string")throw(0,k.illegalArgument)("name");this._id=U}static from(U){switch(U){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}get id(){return this._id}};oe.Clean=new l("clean","Clean"),oe.Build=new l("build","Build"),oe.Rebuild=new l("rebuild","Rebuild"),oe.Test=new l("test","Test"),oe=l=Fe([$],oe),e.TaskGroup=oe;function G(j){let U="";for(let te=0;te<j.length;te++)U+=j[te].replace(/,/g,",,")+",";return U}let Se=class{constructor(U,te,_e){if(typeof U!="string")throw(0,k.illegalArgument)("process");this._args=[],this._process=U,te!==void 0&&(Array.isArray(te)?(this._args=te,this._options=_e):this._options=te)}get process(){return this._process}set process(U){if(typeof U!="string")throw(0,k.illegalArgument)("process");this._process=U}get args(){return this._args}set args(U){Array.isArray(U)||(U=[]),this._args=U}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("process"),this._process!==void 0&&U.push(this._process),this._args&&this._args.length>0)for(let te of this._args)U.push(te);return G(U)}};Se=Fe([$],Se),e.ProcessExecution=Se;let Ce=class{constructor(U,te,_e){if(this._args=[],Array.isArray(te)){if(!U)throw(0,k.illegalArgument)("command can't be undefined or null");if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this._command=U,this._args=te,this._options=_e}else{if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=U,this._options=te}}get commandLine(){return this._commandLine}set commandLine(U){if(typeof U!="string")throw(0,k.illegalArgument)("commandLine");this._commandLine=U}get command(){return this._command?this._command:""}set command(U){if(typeof U!="string"&&typeof U.value!="string")throw(0,k.illegalArgument)("command");this._command=U}get args(){return this._args}set args(U){this._args=U||[]}get options(){return this._options}set options(U){this._options=U}computeId(){const U=[];if(U.push("shell"),this._commandLine!==void 0&&U.push(this._commandLine),this._command!==void 0&&U.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let te of this._args)U.push(typeof te=="string"?te:te.value);return G(U)}};Ce=Fe([$],Ce),e.ShellExecution=Ce;var xe;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(xe=e.ShellQuoting||(e.ShellQuoting={}));var je;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(je=e.TaskScope||(e.TaskScope={}));class lt{constructor(U){this._callback=U}computeId(){return"customExecution"+(0,N.generateUuid)()}set callback(U){this._callback=U}get callback(){return this._callback}}e.CustomExecution=lt;let gt=m=class{constructor(U,te,_e,We,Ke,Ye){this.__deprecated=!1,this._definition=this.definition=U;let et;typeof te=="string"?(this._name=this.name=te,this._source=this.source=_e,this.execution=We,et=Ke,this.__deprecated=!0):te===je.Global||te===je.Workspace?(this.target=te,this._name=this.name=_e,this._source=this.source=We,this.execution=Ke,et=Ye):(this.target=te,this._name=this.name=_e,this._source=this.source=We,this.execution=Ke,et=Ye),typeof et=="string"?(this._problemMatchers=[et],this._hasDefinedMatchers=!0):Array.isArray(et)?(this._problemMatchers=et,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(U){this.__id=U}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Se?this._definition={type:m.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ce?this._definition={type:m.ShellType,id:this._execution.computeId()}:this._execution instanceof lt?this._definition={type:m.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:m.EmptyType,id:(0,N.generateUuid)()}}get definition(){return this._definition}set definition(U){if(U==null)throw(0,k.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=U}get scope(){return this._scope}set target(U){this.clear(),this._scope=U}get name(){return this._name}set name(U){if(typeof U!="string")throw(0,k.illegalArgument)("name");this.clear(),this._name=U}get execution(){return this._execution}set execution(U){U===null&&(U=void 0),this.clear(),this._execution=U;const te=this._definition.type;(m.EmptyType===te||m.ProcessType===te||m.ShellType===te||m.ExtensionCallbackType===te)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(U){if(Array.isArray(U))this.clear(),this._problemMatchers=U,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(U){U!==!0&&U!==!1&&(U=!1),this.clear(),this._isBackground=U}get source(){return this._source}set source(U){if(typeof U!="string"||U.length===0)throw(0,k.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=U}get group(){return this._group}set group(U){U===null&&(U=void 0),this.clear(),this._group=U}get detail(){return this._detail}set detail(U){U===null&&(U=void 0),this._detail=U}get presentationOptions(){return this._presentationOptions}set presentationOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._presentationOptions=U}get runOptions(){return this._runOptions}set runOptions(U){U==null&&(U=Object.create(null)),this.clear(),this._runOptions=U}};gt.ExtensionCallbackType="customExecution",gt.ProcessType="process",gt.ShellType="shell",gt.EmptyType="$empty",gt=m=Fe([$],gt),e.Task=gt;var Et;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(Et=e.ProgressLocation||(e.ProgressLocation={}));let rt=class{constructor(U,te=at.None){this.collapsibleState=te,F.URI.isUri(U)?this.resourceUri=U:this.label=U}};rt=Fe([$],rt),e.TreeItem=rt;var at;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(at=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let ot=class{constructor(U){this.value=U}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}};ot=Fe([$],ot),e.DataTransferItem=ot;let Mt=class{constructor(){this._items=new Map}get(U){return this._items.get(U)}set(U,te){this._items.set(U,te)}forEach(U){this._items.forEach(U)}};Mt=Fe([$],Mt),e.DataTransfer=Mt;let ft=class{constructor(U,te){this.id=U,this.color=te}};ft=Fe([$],ft),e.ThemeIcon=ft,ft.File=new ft("file"),ft.Folder=new ft("folder");let Dt=class{constructor(U){this.id=U}};Dt=Fe([$],Dt),e.ThemeColor=Dt;var Ut;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Ut=e.ConfigurationTarget||(e.ConfigurationTarget={}));let wt=class{constructor(U,te){if(typeof U!="string"&&(!U||!F.URI.isUri(U)&&!F.URI.isUri(U.uri)))throw(0,k.illegalArgument)("base");if(typeof te!="string")throw(0,k.illegalArgument)("pattern");typeof U=="string"?this.baseUri=F.URI.file(U):F.URI.isUri(U)?this.baseUri=U:this.baseUri=U.uri,this.pattern=te}get base(){return this._base}set base(U){this._base=U,this._baseUri=F.URI.file(U)}get baseUri(){return this._baseUri}set baseUri(U){this._baseUri=U,this._base=U.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};wt=Fe([$],wt),e.RelativePattern=wt;let Bt=class{constructor(U,te,_e,We){this.enabled=typeof U=="boolean"?U:!0,typeof te=="string"&&(this.condition=te),typeof _e=="string"&&(this.hitCondition=_e),typeof We=="string"&&(this.logMessage=We)}get id(){return this._id||(this._id=(0,N.generateUuid)()),this._id}};Bt=Fe([$],Bt),e.Breakpoint=Bt;let Wt=class extends Bt{constructor(U,te,_e,We,Ke){super(te,_e,We,Ke);if(U===null)throw(0,k.illegalArgument)("location");this.location=U}};Wt=Fe([$],Wt),e.SourceBreakpoint=Wt;let pt=class extends Bt{constructor(U,te,_e,We,Ke){super(te,_e,We,Ke);this.functionName=U}};pt=Fe([$],pt),e.FunctionBreakpoint=pt;let qt=class extends Bt{constructor(U,te,_e,We,Ke,Ye,et){super(We,Ke,Ye,et);if(!te)throw(0,k.illegalArgument)("dataId");this.label=U,this.dataId=te,this.canPersist=_e}};qt=Fe([$],qt),e.DataBreakpoint=qt;let Qt=class{constructor(U,te,_e){this.command=U,this.args=te||[],this.options=_e}};Qt=Fe([$],Qt),e.DebugAdapterExecutable=Qt;let ti=class{constructor(U,te){this.port=U,this.host=te}};ti=Fe([$],ti),e.DebugAdapterServer=ti;let ai=class{constructor(U){this.path=U}};ai=Fe([$],ai),e.DebugAdapterNamedPipeServer=ai;let Ct=class{constructor(U){this.implementation=U}};Ct=Fe([$],Ct),e.DebugAdapterInlineImplementation=Ct;let ii=class{constructor(U,te){this.range=U,this.expression=te}};ii=Fe([$],ii),e.EvaluatableExpression=ii;var bi;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(bi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Kt=class{constructor(U,te){this.range=U,this.text=te}};Kt=Fe([$],Kt),e.InlineValueText=Kt;let Gt=class{constructor(U,te,_e=!0){this.range=U,this.variableName=te,this.caseSensitiveLookup=_e}};Gt=Fe([$],Gt),e.InlineValueVariableLookup=Gt;let st=class{constructor(U,te){this.range=U,this.expression=te}};st=Fe([$],st),e.InlineValueEvaluatableExpression=st;let li=class{constructor(U,te){this.frameId=U,this.stoppedLocation=te}};li=Fe([$],li),e.InlineValueContext=li;var Ht;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Ht=e.FileChangeType||(e.FileChangeType={}));let zt=f=class extends Error{constructor(U,te=b.FileSystemProviderErrorCode.Unknown,_e){super(F.URI.isUri(U)?U.toString(!0):U);this.code=_e?.name??"Unknown",(0,b.markAsFileSystemProviderError)(this,te),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(U){return new f(U,b.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(U){return new f(U,b.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(U){return new f(U,b.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(U){return new f(U,b.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(U){return new f(U,b.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(U){return new f(U,b.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}};zt=f=Fe([$],zt),e.FileSystemError=zt;let ni=class{constructor(U,te,_e){this.start=U,this.end=te,this.kind=_e}};ni=Fe([$],ni),e.FoldingRange=ni;var _i;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(_i=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Si;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Si=e.CommentMode||(e.CommentMode={}));var mi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(mi=e.CommentThreadState||(e.CommentThreadState={}));class ri{constructor(U,te=[]){this.tokenTypes=U,this.tokenModifiers=te}}e.SemanticTokensLegend=ri;function yi(j){return typeof j=="undefined"||(0,D.isStringArray)(j)}class Yt{constructor(U){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,U){this._hasLegend=!0;for(let te=0,_e=U.tokenTypes.length;te<_e;te++)this._tokenTypeStrToInt.set(U.tokenTypes[te],te);for(let te=0,_e=U.tokenModifiers.length;te<_e;te++)this._tokenModifierStrToInt.set(U.tokenModifiers[te],te)}}push(U,te,_e,We,Ke){if(typeof U=="number"&&typeof te=="number"&&typeof _e=="number"&&typeof We=="number"&&(typeof Ke=="number"||typeof Ke=="undefined"))return typeof Ke=="undefined"&&(Ke=0),this._pushEncoded(U,te,_e,We,Ke);if(H.isRange(U)&&typeof te=="string"&&yi(_e))return this._push(U,te,_e);throw(0,k.illegalArgument)()}_push(U,te,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(U.start.line!==U.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(te))throw new Error("`tokenType` is not in the provided legend");const We=U.start.line,Ke=U.start.character,Ye=U.end.character-U.start.character,et=this._tokenTypeStrToInt.get(te);let _t=0;if(_e)for(const Pt of _e){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const xt=this._tokenModifierStrToInt.get(Pt);_t|=1<<xt>>>0}this._pushEncoded(We,Ke,Ye,et,_t)}_pushEncoded(U,te,_e,We,Ke){if(this._dataIsSortedAndDeltaEncoded&&(U<this._prevLine||U===this._prevLine&&te<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const _t=this._data.length/5|0;let Pt=0,xt=0;for(let $t=0;$t<_t;$t++){let Vt=this._data[5*$t],di=this._data[5*$t+1];Vt===0?(Vt=Pt,di+=xt):Vt+=Pt,this._data[5*$t]=Vt,this._data[5*$t+1]=di,Pt=Vt,xt=di}}let Ye=U,et=te;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Ye-=this._prevLine,Ye===0&&(et-=this._prevChar)),this._data[this._dataLen++]=Ye,this._data[this._dataLen++]=et,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=We,this._data[this._dataLen++]=Ke,this._prevLine=U,this._prevChar=te}static _sortAndDeltaEncode(U){let te=[];const _e=U.length/5|0;for(let et=0;et<_e;et++)te[et]=et;te.sort((et,_t)=>{const Pt=U[5*et],xt=U[5*_t];if(Pt===xt){const $t=U[5*et+1],Vt=U[5*_t+1];return $t-Vt}return Pt-xt});const We=new Uint32Array(U.length);let Ke=0,Ye=0;for(let et=0;et<_e;et++){const _t=5*te[et],Pt=U[_t+0],xt=U[_t+1],$t=U[_t+2],Vt=U[_t+3],di=U[_t+4],zi=Pt-Ke,Ji=zi===0?xt-Ye:xt,hi=5*et;We[hi+0]=zi,We[hi+1]=Ji,We[hi+2]=$t,We[hi+3]=Vt,We[hi+4]=di,Ke=Pt,Ye=xt}return We}build(U){return this._dataIsSortedAndDeltaEncoded?new Jt(new Uint32Array(this._data),U):new Jt(Yt._sortAndDeltaEncode(this._data),U)}}e.SemanticTokensBuilder=Yt;class Jt{constructor(U,te){this.resultId=te,this.data=U}}e.SemanticTokens=Jt;class Di{constructor(U,te,_e){this.start=U,this.deleteCount=te,this.data=_e}}e.SemanticTokensEdit=Di;class Ci{constructor(U,te){this.resultId=te,this.edits=U}}e.SemanticTokensEdits=Ci;var Zt;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(Zt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let si=class{constructor(){}};si.Back={iconPath:new ft("arrow-left")},si=Fe([$],si),e.QuickInputButtons=si;var Ii;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(Ii=e.QuickPickItemKind||(e.QuickPickItemKind={}));var ki;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(ki=e.ExtensionKind||(e.ExtensionKind={}));class Ti{constructor(U,te,_e){this.badge=U,this.tooltip=te,this.color=_e}static validate(U){if(U.badge){let te=(0,A.nextCharLength)(U.badge,0);if(te<U.badge.length&&(te+=(0,A.nextCharLength)(U.badge,te)),U.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}if(!U.color&&!U.badge&&!U.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=Ti;let ei=class{constructor(U){this.kind=U}};ei=Fe([$],ei),e.ColorTheme=ei;var gi;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(gi=e.ColorThemeKind||(e.ColorThemeKind={}));class Xt{constructor(U,te){if(U<0)throw(0,k.illegalArgument)("start must be positive");if(te<0)throw(0,k.illegalArgument)("end must be positive");U<=te?(this._start=U,this._end=te):(this._start=te,this._end=U)}static isNotebookRange(U){return U instanceof Xt?!0:U?typeof U.start=="number"&&typeof U.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(U){let te=this._start,_e=this._end;return U.start!==void 0&&(te=U.start),U.end!==void 0&&(_e=U.end),te===this._start&&_e===this._end?this:new Xt(te,_e)}}e.NotebookRange=Xt;class Pe{constructor(U,te,_e,We,Ke,Ye,et){this.kind=U,this.value=te,this.languageId=_e,this.mime=We,this.outputs=Ke??[],this.metadata=Ye,this.executionSummary=et,Pe.validate(this)}static validate(U){if(typeof U.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof U.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof U.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(U){return Array.isArray(U)&&U.every(te=>Pe.isNotebookCellData(te))}static isNotebookCellData(U){return!0}}e.NotebookCellData=Pe;class ci{constructor(U){this.cells=U}}e.NotebookData=ci;class Ot{constructor(U,te){this.data=U,this.mime=te;const _e=(0,C.normalizeMimeType)(te,!0);if(!_e)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(U){return U instanceof Ot?!0:U?typeof U.mime=="string"&&U.data instanceof Uint8Array:!1}static error(U){const te={name:U.name,message:U.message,stack:U.stack};return Ot.json(te,"application/vnd.code.notebook.error")}static stdout(U){return Ot.text(U,"application/vnd.code.notebook.stdout")}static stderr(U){return Ot.text(U,"application/vnd.code.notebook.stderr")}static bytes(U,te="application/octet-stream"){return new Ot(U,te)}static text(U,te=C.Mimes.text){const _e=De(Ot,n,"f",h).encode(String(U));return new Ot(_e,te)}static json(U,te="text/x-json"){const _e=JSON.stringify(U,void 0,"	");return Ot.text(_e,te)}}e.NotebookCellOutputItem=Ot,n=Ot,h={value:new TextEncoder};class ct{constructor(U,te,_e){this.items=ct.ensureUniqueMimeTypes(U,!0),typeof te=="string"?(this.id=te,this.metadata=_e):(this.id=(0,N.generateUuid)(),this.metadata=te??_e)}static isNotebookCellOutput(U){return U instanceof ct?!0:!U||typeof U!="object"?!1:typeof U.id=="string"&&(0,D.isArray)(U.items)}static ensureUniqueMimeTypes(U,te=!1){const _e=new Set,We=new Set;for(let Ke=0;Ke<U.length;Ke++){const Ye=U[Ke],et=(0,C.normalizeMimeType)(Ye.mime);if(!_e.has(et)){_e.add(et);continue}We.add(Ke),te&&console.warn(`DUPLICATED mime type '${Ye.mime}' will be dropped`)}return We.size===0?U:U.filter((Ke,Ye)=>!We.has(Ye))}}e.NotebookCellOutput=ct;var Pi;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(Pi=e.NotebookCellKind||(e.NotebookCellKind={}));var Ai;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(Ai=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pi;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(pi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var vi;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(vi=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Ri{constructor(U,te){this.text=U,this.alignment=te}}e.NotebookCellStatusBarItem=Ri;var Oi;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Oi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Fi{constructor(U,te=[]){this.uri=U,this.provides=(0,o.asArray)(te)}}e.NotebookRendererScript=Fi;let ui=class{constructor(U,te){this.label=U,this.timestamp=te}};ui=Fe([$],ui),e.TimelineItem=ui;var Ei;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Ei=e.ExtensionMode||(e.ExtensionMode={}));var Mi;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(Mi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Ni;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ni=e.StandardTokenType||(e.StandardTokenType={}));class Li{constructor(U,te){this.ranges=U,this.wordPattern=te}}e.LinkedEditingRanges=Li;class Ui{constructor(U,te){this._port=U,this._autoForwardAction=te}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Ui;var Bi;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Bi=e.TestResultState||(e.TestResultState={}));var ee;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(ee=e.TestRunProfileKind||(e.TestRunProfileKind={}));let re=class{constructor(U=void 0,te=void 0,_e=void 0){this.include=U,this.exclude=te,this.profile=_e}};re=Fe([$],re),e.TestRunRequest=re;let ye=S=class{constructor(U){this.message=U}static diff(U,te,_e){const We=new S(U);return We.expectedOutput=te,We.actualOutput=_e,We}};ye=S=Fe([$],ye),e.TestMessage=ye;let Ze=class{constructor(U){this.id=U}};Ze=Fe([$],Ze),e.TestTag=Ze;let mt=class{constructor(U,te){this.covered=U,this.total=te}};mt=Fe([$],mt),e.CoveredCount=mt;let yt=P=class{constructor(U,te,_e,We){this.uri=U,this.statementCoverage=te,this.branchCoverage=_e,this.functionCoverage=We}static fromDetails(U,te){const _e=new mt(0,0),We=new mt(0,0),Ke=new mt(0,0);for(const et of te)if("branches"in et){_e.total+=1,_e.covered+=et.executionCount>0?1:0;for(const _t of et.branches)We.total+=1,We.covered+=_t.executionCount>0?1:0}else Ke.total+=1,Ke.covered+=et.executionCount>0?1:0;const Ye=new P(U,_e,We.total>0?We:void 0,Ke.total>0?Ke:void 0);return Ye.detailedCoverage=te,Ye}};yt=P=Fe([$],yt),e.FileCoverage=yt;let xi=class{constructor(U,te,_e=[]){this.executionCount=U,this.location=te,this.branches=_e}};xi=Fe([$],xi),e.StatementCoverage=xi;let $i=class{constructor(U,te){this.executionCount=U,this.location=te}};$i=Fe([$],$i),e.BranchCoverage=$i;let Wi=class{constructor(U,te){this.executionCount=U,this.location=te}};Wi=Fe([$],Wi),e.FunctionCoverage=Wi;var Gi;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Gi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Xi;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Xi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Qi;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Qi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Yi{constructor(U,te,_e,We,Ke,Ye){this.kind=U,this.name=te,this.detail=_e,this.uri=We,this.range=Ke,this.selectionRange=Ye}}e.TypeHierarchyItem=Yi}),define(we[84],be([1,0,42,10,9,226,116,6,16]),function(Z,e,o,k,w,B,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const F=new Map;function N(s,n){n?F.set(s,n):F.delete(s)}e.setWordDefinitionFor=N;function b(s){return F.get(s)}e.getWordDefinitionFor=b;class c extends B.MirrorTextModel{constructor(n,h,_,y,d,p,E,a){super(h,_,y,d);this._proxy=n,this._languageId=p,this._isDirty=E,this._notebook=a,this._isDisposed=!1}dispose(){(0,o.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(n){return(0,D.equals)(this._lines,n)}get document(){if(!this._document){const n=this;this._document={get uri(){return n._uri},get fileName(){return n._uri.fsPath},get isUntitled(){return n._uri.scheme===k.Schemas.untitled},get languageId(){return n._languageId},get version(){return n._versionId},get isClosed(){return n._isDisposed},get isDirty(){return n._isDirty},get notebook(){return n._notebook},save(){return n._save()},getText(h){return h?n._getTextInRange(h):n.getText()},get eol(){return n._eol===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return n._lines.length},lineAt(h){return n._lineAt(h)},offsetAt(h){return n._offsetAt(h)},positionAt(h){return n._positionAt(h)},validateRange(h){return n._validateRange(h)},validatePosition(h){return n._validatePosition(h)},getWordRangeAtPosition(h,_){return n._getWordRangeAtPosition(h,_)}}}return Object.freeze(this._document)}_acceptLanguageId(n){(0,o.ok)(!this._isDisposed),this._languageId=n}_acceptIsDirty(n){(0,o.ok)(!this._isDisposed),this._isDirty=n}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(n){const h=this._validateRange(n);if(h.isEmpty)return"";if(h.isSingleLine)return this._lines[h.start.line].substring(h.start.character,h.end.character);const _=this._eol,y=h.start.line,d=h.end.line,p=[];p.push(this._lines[y].substring(h.start.character));for(let E=y+1;E<d;E++)p.push(this._lines[E]);return p.push(this._lines[d].substring(0,h.end.character)),p.join(_)}_lineAt(n){let h;if(n instanceof A.Position?h=n.line:typeof n=="number"&&(h=n),typeof h!="number"||h<0||h>=this._lines.length||Math.floor(h)!==h)throw new Error("Illegal value for `line`");return new g(h,this._lines[h],h===this._lines.length-1)}_offsetAt(n){return n=this._validatePosition(n),this._ensureLineStarts(),this._lineStarts.getPrefixSum(n.line-1)+n.character}_positionAt(n){n=Math.floor(n),n=Math.max(0,n),this._ensureLineStarts();const h=this._lineStarts.getIndexOf(n),_=this._lines[h.index].length;return new A.Position(h.index,Math.min(h.remainder,_))}_validateRange(n){if(!(n instanceof A.Range))throw new Error("Invalid argument");const h=this._validatePosition(n.start),_=this._validatePosition(n.end);return h===n.start&&_===n.end?n:new A.Range(h.line,h.character,_.line,_.character)}_validatePosition(n){if(!(n instanceof A.Position))throw new Error("Invalid argument");if(this._lines.length===0)return n.with(0,0);let{line:h,character:_}=n,y=!1;if(h<0)h=0,_=0,y=!0;else if(h>=this._lines.length)h=this._lines.length-1,_=this._lines[h].length,y=!0;else{const d=this._lines[h].length;_<0?(_=0,y=!0):_>d&&(_=d,y=!0)}return y?new A.Position(h,_):n}_getWordRangeAtPosition(n,h){const _=this._validatePosition(n);if(!h)h=b(this._languageId);else if((0,w.regExpLeadsToEndlessLoop)(h))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${h.source}' because it matches the empty string.`);const y=(0,C.getWordAtText)(_.character+1,(0,C.ensureValidWordDefinition)(h),this._lines[_.line],0);if(y)return new A.Range(_.line,y.startColumn-1,_.line,y.endColumn-1)}}e.ExtHostDocumentData=c;class g{constructor(n,h,_){this._line=n,this._text=h,this._isLastLine=_}get lineNumber(){return this._line}get text(){return this._text}get range(){return new A.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new A.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=g}),define(we[152],be([1,0,6,5,227,7,74,22,2,36]),function(Z,e,o,k,w,B,C,A,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class N{constructor(c,g,s,n){this._notebook=s,this._selector=n,this._disposables=new B.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this.uri=D.URI.from({scheme:"vscode-concat-doc",path:(0,F.generateUuid)()}),this._init(),this._disposables.add(g.onDidChangeDocument(_=>{const y=this._cellUris.get(_.document.uri);y!==void 0&&(this._cellLengths.setValue(y,this._cells[y].document.getText().length+1),this._cellLines.setValue(y,this._cells[y].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const h=_=>{_===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(c.onDidChangeNotebookCells(_=>h(_.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new A.ResourceMap;const c=[],g=[];for(const s of this._notebook.getCells())s.kind===o.NotebookCellKind.Code&&(!this._selector||(0,C.score)(this._selector,s.document.uri,s.document.languageId,!0,void 0))&&(this._cellUris.set(s.document.uri,this._cells.length),this._cells.push(s),c.push(s.document.getText().length+1),g.push(s.document.lineCount));this._cellLengths=new w.PrefixSumComputer(new Uint32Array(c)),this._cellLines=new w.PrefixSumComputer(new Uint32Array(g))}get version(){return this._versionId}getText(c){if(!c){let y="";for(const d of this._cells)y+=d.document.getText()+`
`;return y=y.slice(0,-1),y}if(c.isEmpty)return"";const g=this.locationAt(c.start),s=this.locationAt(c.end),n=this._cellUris.get(g.uri),h=this._cellUris.get(s.uri);if(n===void 0||h===void 0)return"";if(n===h)return this._cells[n].document.getText(new o.Range(g.range.start,s.range.end));const _=[this._cells[n].document.getText(new o.Range(g.range.start,new o.Position(this._cells[n].document.lineCount,0)))];for(let y=n+1;y<h;y++)_.push(this._cells[y].document.getText());return _.push(this._cells[h].document.getText(new o.Range(new o.Position(0,0),s.range.end))),_.join(`
`)}offsetAt(c){const g=this._cellLines.getIndexOf(c.line),s=this._cellLengths.getPrefixSum(g.index-1),n=this._cells[g.index].document.offsetAt(c.with(g.remainder));return s+n}positionAt(c){if(typeof c=="number"){const s=this._cellLengths.getIndexOf(c),n=this._cellLines.getPrefixSum(s.index-1);return this._cells[s.index].document.positionAt(s.remainder).translate(n)}const g=this._cellUris.get(c.uri);if(g!==void 0){const s=this._cellLines.getPrefixSum(g-1);return new o.Position(s+c.range.start.line,c.range.start.character)}return new o.Position(0,0)}locationAt(c){o.Range.isRange(c)||(c=new o.Range(c,c));const g=this._cellLines.getIndexOf(c.start.line);let s=g;c.isEmpty||(s=this._cellLines.getIndexOf(c.end.line));const n=new o.Position(g.remainder,c.start.character),h=new o.Position(s.remainder,c.end.character),_=new o.Range(n,h),y=this._cells[g.index];return new o.Location(y.document.uri,y.document.validateRange(_))}contains(c){return this._cellUris.has(c)}validateRange(c){const g=this.validatePosition(c.start),s=this.validatePosition(c.end);return c.with(g,s)}validatePosition(c){const g=this._cellLines.getIndexOf(c.line),s=new o.Position(g.remainder,c.character),n=this._cells[g.index].document.validatePosition(s),h=this._cellLines.getPrefixSum(g.index-1);return new o.Position(h+n.line,n.character)}}e.ExtHostNotebookConcatDocument=N}),define(we[153],be([1,0,6,14,5]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let B=class{constructor(A){this._actual=new o.ColorTheme(o.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new w.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(A){let D=A==="light"?o.ColorThemeKind.Light:A==="dark"?o.ColorThemeKind.Dark:o.ColorThemeKind.HighContrast;this._actual=new o.ColorTheme(D),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};B=Fe([Ne(0,k.IExtHostRpcService)],B),e.ExtHostTheming=B}),define(we[60],be([1,0,3]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class k{constructor(B){B?(this.transformIncoming=B.transformIncoming.bind(B),this.transformOutgoing=B.transformOutgoing.bind(B),this.transformOutgoingURI=B.transformOutgoingURI.bind(B),this.transformOutgoingScheme=B.transformOutgoingScheme.bind(B)):(this.transformIncoming=C=>C,this.transformOutgoing=C=>C,this.transformOutgoingURI=C=>C,this.transformOutgoingScheme=C=>C)}}e.URITransformerService=k}),define(we[154],be([1,0,21]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class k{constructor(){this.buffers=[]}add(D){let F=this.buffers.indexOf(D);return F<0&&(F=this.buffers.length,this.buffers.push(D)),F}}function w(A,D){if(D.serializeBuffersForPostMessage){const F=new k,N=(g,s)=>{if(s instanceof ArrayBuffer){const n=F.add(s);return{$$vscode_array_buffer_reference$$:!0,index:n}}else if(ArrayBuffer.isView(s)){const n=B(s);if(n){const h=F.add(s.buffer);return{$$vscode_array_buffer_reference$$:!0,index:h,view:{type:n,byteLength:s.byteLength,byteOffset:s.byteOffset}}}}return s},b=JSON.stringify(A,N),c=F.buffers.map(g=>{const s=new Uint8Array(g);return o.VSBuffer.wrap(s)});return{message:b,buffers:c}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=w;function B(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function C(A,D){const F=D.map(c=>{const g=new ArrayBuffer(c.byteLength);return new Uint8Array(g).set(c.buffer),g}),N=D.length?(c,g)=>{if(g&&typeof g=="object"&&g.$$vscode_array_buffer_reference$$){const s=g,{index:n}=s,h=F[n];if(s.view)switch(s.view.type){case 1:return new Int8Array(h,s.view.byteOffset,s.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(h,s.view.byteOffset,s.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(h,s.view.byteOffset,s.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(h,s.view.byteOffset,s.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(h,s.view.byteOffset,s.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(h,s.view.byteOffset,s.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(h,s.view.byteOffset,s.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(h,s.view.byteOffset,s.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(h,s.view.byteOffset,s.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(h,s.view.byteOffset,s.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(h,s.view.byteOffset,s.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return h}return g}:void 0;return{message:JSON.parse(A,N),arrayBuffers:F}}e.deserializeWebviewMessage=C}),define(we[155],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var o;(function(k){function w(C){const A=new Map;return C.types.forEach((D,F)=>{A.set(D,{asString:async()=>C.items[F].asString,value:void 0})}),A}k.toITreeDataTransfer=w;async function B(C){const A={types:[],items:[]},D=Array.from(C.entries());for(const F of D)A.types.push(F[0]),A.items.push({asString:await F[1].asString()});return A}k.toTreeDataTransferDTO=B})(o=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(we[156],be([1,0,129,11,2,7,3,37,45,16,10]),function(Z,e,o,k,w,B,C,A,D,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var b;(function(K){K[K.PROGRAMMATIC=1]="PROGRAMMATIC",K[K.USER=2]="USER",K[K.EDIT=3]="EDIT",K[K.NAVIGATION=4]="NAVIGATION",K[K.JUMP=5]="JUMP"})(b=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var c;(function(K){K[K.IDENTICAL=1]="IDENTICAL",K[K.SIMILAR=2]="SIMILAR",K[K.DIFFERENT=3]="DIFFERENT"})(c=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function g(K){const V=K;return!!V&&typeof V.getSelection=="function"&&!!V.onDidChangeSelection}e.isEditorPaneWithSelection=g;function s(K,V,z){for(const ae of z.visibleEditorPanes)if(ae.group.id===V&&K.matches(ae.input))return ae.getViewState()}e.findViewStateForEditor=s;function n(K){if(T(K))return!1;const V=K;return w.URI.isUri(V?.resource)}e.isResourceEditorInput=n;function h(K){if(T(K))return!1;const V=K;return V?.original!==void 0&&V.modified!==void 0}e.isResourceDiffEditorInput=h;function _(K){if(T(K)||h(K))return!1;const V=K;return V?.primary!==void 0&&V.secondary!==void 0}e.isResourceSideBySideEditorInput=_;function y(K){if(T(K))return!1;const V=K;return V?V.resource===void 0||V.resource.scheme===N.Schemas.untitled||V.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=y;var d;(function(K){K[K.SHORT=0]="SHORT",K[K.MEDIUM=1]="MEDIUM",K[K.LONG=2]="LONG"})(d=e.Verbosity||(e.Verbosity={}));var p;(function(K){K[K.EXPLICIT=1]="EXPLICIT",K[K.AUTO=2]="AUTO",K[K.FOCUS_CHANGE=3]="FOCUS_CHANGE",K[K.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(p=e.SaveReason||(e.SaveReason={}));var E;(function(K){K[K.None=0]="None",K[K.Readonly=2]="Readonly",K[K.Untitled=4]="Untitled",K[K.Singleton=8]="Singleton",K[K.RequiresTrust=16]="RequiresTrust",K[K.CanSplitInGroup=32]="CanSplitInGroup",K[K.ForceDescription=64]="ForceDescription"})(E=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends B.Disposable{}e.AbstractEditorInput=a;function T(K){return K instanceof a}e.isEditorInput=T;function r(K){const V=K;return w.URI.isUri(V?.preferredResource)}function i(K){const V=K;return T(V?.primary)&&T(V?.secondary)}e.isSideBySideEditorInput=i;function u(K){const V=K;return T(V?.modified)&&T(V?.original)}e.isDiffEditorInput=u;function t(K){return T(K?.editor)}e.isEditorInputWithOptions=t;function l(K){const V=K;return t(K)&&V?.group!==void 0}e.isEditorInputWithOptionsAndGroup=l;function m(K){const V=K;return typeof V?.groupId=="number"&&T(V.editor)}e.isEditorIdentifier=m;var f;(function(K){K[K.UNKNOWN=0]="UNKNOWN",K[K.REPLACE=1]="REPLACE",K[K.MOVE=2]="MOVE",K[K.UNPIN=3]="UNPIN"})(f=e.EditorCloseContext||(e.EditorCloseContext={}));var S;(function(K){K[K.GROUP_ACTIVE=0]="GROUP_ACTIVE",K[K.GROUP_INDEX=1]="GROUP_INDEX",K[K.GROUP_LOCKED=2]="GROUP_LOCKED",K[K.EDITOR_OPEN=3]="EDITOR_OPEN",K[K.EDITOR_CLOSE=4]="EDITOR_CLOSE",K[K.EDITOR_MOVE=5]="EDITOR_MOVE",K[K.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",K[K.EDITOR_LABEL=7]="EDITOR_LABEL",K[K.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",K[K.EDITOR_PIN=9]="EDITOR_PIN",K[K.EDITOR_STICKY=10]="EDITOR_STICKY",K[K.EDITOR_DIRTY=11]="EDITOR_DIRTY",K[K.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(S=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var P;(function(K){K[K.PRIMARY=1]="PRIMARY",K[K.SECONDARY=2]="SECONDARY",K[K.BOTH=3]="BOTH",K[K.ANY=4]="ANY"})(P=e.SideBySideEditor||(e.SideBySideEditor={}));class ${getOriginalUri(V,z){if(!V)return;if(z?.supportSideBySide){const{primary:de,secondary:Y}=this.getSideEditors(V);if(de&&Y){if(z?.supportSideBySide===P.BOTH)return{primary:this.getOriginalUri(de,{filterByScheme:z.filterByScheme}),secondary:this.getOriginalUri(Y,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===P.ANY)return this.getOriginalUri(de,{filterByScheme:z.filterByScheme})??this.getOriginalUri(Y,{filterByScheme:z.filterByScheme});V=z.supportSideBySide===P.PRIMARY?de:Y}}if(h(V)||_(V))return;const ae=r(V)?V.preferredResource:V.resource;return!ae||!z||!z.filterByScheme?ae:this.filterUri(ae,z.filterByScheme)}getSideEditors(V){return i(V)||_(V)?{primary:V.primary,secondary:V.secondary}:u(V)||h(V)?{primary:V.modified,secondary:V.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(V,z){if(!V)return;if(z?.supportSideBySide){const{primary:de,secondary:Y}=this.getSideEditors(V);if(de&&Y){if(z?.supportSideBySide===P.BOTH)return{primary:this.getCanonicalUri(de,{filterByScheme:z.filterByScheme}),secondary:this.getCanonicalUri(Y,{filterByScheme:z.filterByScheme})};if(z?.supportSideBySide===P.ANY)return this.getCanonicalUri(de,{filterByScheme:z.filterByScheme})??this.getCanonicalUri(Y,{filterByScheme:z.filterByScheme});V=z.supportSideBySide===P.PRIMARY?de:Y}}if(h(V)||_(V))return;const ae=V.resource;return!ae||!z||!z.filterByScheme?ae:this.filterUri(ae,z.filterByScheme)}filterUri(V,z){if(Array.isArray(z)){if(z.some(ae=>V.scheme===ae))return V}else if(z===V.scheme)return V}}e.EditorResourceAccessor=new $;var L;(function(K){K[K.LEFT=0]="LEFT",K[K.RIGHT=1]="RIGHT"})(L=e.CloseDirection||(e.CloseDirection={}));class v{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(V){const z=this.instantiationService=V.get(C.IInstantiationService);for(const[ae,de]of this.editorSerializerConstructors)this.createEditorSerializer(ae,de,z);this.editorSerializerConstructors.clear()}createEditorSerializer(V,z,ae){const de=ae.createInstance(z);this.editorSerializerInstances.set(V,de)}registerFileEditorFactory(V){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=V}getFileEditorFactory(){return(0,k.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(V,z){if(this.editorSerializerConstructors.has(V)||this.editorSerializerInstances.has(V))throw new Error(`A editor serializer with type ID '${V}' was already registered.`);return this.instantiationService?this.createEditorSerializer(V,z,this.instantiationService):this.editorSerializerConstructors.set(V,z),(0,B.toDisposable)(()=>{this.editorSerializerConstructors.delete(V),this.editorSerializerInstances.delete(V)})}getEditorSerializer(V){return this.editorSerializerInstances.get(typeof V=="string"?V:V.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new v);async function H(K,V){if(!K||!K.length)return[];const z=await Promise.all(K.map(async ae=>{const de=w.URI.revive(ae.fileUri);if(!de||!await V.canHandleResource(de))return;let ie=ae.exists,ce=ae.type;if(typeof ie!="boolean"||typeof ce!="number")try{ce=(await V.stat(de)).isDirectory?D.FileType.Directory:D.FileType.Unknown,ie=!0}catch{ie=!1}if(!ie&&ae.openOnlyIfExists||ce===D.FileType.Directory)return;const he={selection:ie?ae.selection:void 0,pinned:!0,override:ae.editorOverrideId};let ue;return ie?ue={resource:de,options:he}:ue={resource:de,options:he,forceUntitled:!0},ue}));return(0,F.coalesce)(z)}e.pathsToEditors=H;var W;(function(K){K[K.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",K[K.SEQUENTIAL=1]="SEQUENTIAL"})(W=e.EditorsOrder||(e.EditorsOrder={}));function q(K){const V=K;if(!V)return!1;const z=V;if(z.modified)return q(z.modified);const ae=V;return!!(ae.contributionsState&&ae.viewState&&Array.isArray(ae.cursorState))}e.isTextEditorViewState=q}),define(we[61],be([1,0,10,2]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function w(A,D){return A.scheme===o.Schemas.http||A.scheme===o.Schemas.https?A:(D&&D.authority&&D.isRemote&&A.scheme===o.Schemas.file&&(A=k.URI.from({scheme:o.Schemas.vscodeRemote,authority:D.authority,path:A.path})),k.URI.from({scheme:o.Schemas.https,authority:`${A.scheme}+${B(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=w;function B(A){return A.replace(/./g,D=>{const F=D.charCodeAt(0);return F>=97&&F<=122||F>=65&&F<=90||F>=48&&F<=57?D:"-"+F.toString(16).padStart(4,"0")})}function C(A){return A.replace(/-([0-9a-f]{4})/g,(D,F)=>String.fromCharCode(parseInt(F,16)))}e.decodeAuthority=C}),define(we[157],be([1,0,5,7,61]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class B{constructor(A,D,F){this._proxy=A,this._editors=D,this._initData=F,this._handlePool=0,this._disposables=new k.DisposableStore,this._insets=new Map,this._disposables.add(D.onDidChangeVisibleTextEditors(()=>{const N=D.getVisibleTextEditors();for(const b of this._insets.values())N.indexOf(b.editor)<0&&b.inset.dispose()}))}dispose(){this._insets.forEach(A=>A.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(A,D,F,N,b){let c;for(const d of this._editors.getVisibleTextEditors(!0))if(d.value===A){c=d;break}if(!c)throw new Error("not a visible editor");const g=this,s=this._handlePool++,n=new o.Emitter,h=new o.Emitter,_=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(d){return(0,w.asWebviewUri)(d,g._initData.remote)}get cspSource(){return w.webviewGenericCspSource}set options(d){this._options=d,g._proxy.$setOptions(s,d)}get options(){return this._options}set html(d){this._html=d,g._proxy.$setHtml(s,d)}get html(){return this._html}get onDidReceiveMessage(){return n.event}postMessage(d){return g._proxy.$postMessage(s,d)}},y=new class{constructor(){this.editor=A,this.line=D,this.height=F,this.webview=_,this.onDidDispose=h.event}dispose(){g._insets.has(s)&&(g._insets.delete(s),g._proxy.$disposeEditorInset(s),h.fire(),h.dispose(),n.dispose())}};return this._proxy.$createEditorInset(s,c.id,c.value.document.uri,D+1,F,N||{},b.identifier,b.extensionLocation),this._insets.set(s,{editor:A,inset:y,onDidReceiveMessage:n}),y}$onDidDispose(A){const D=this._insets.get(A);D&&D.inset.dispose()}$onDidReceiveMessage(A,D){const F=this._insets.get(A);F&&F.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=B}),define(we[158],be([1,0,5,13,130]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class B{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new o.Emitter,this._onExit=new o.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(A){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=A}onEvent(A){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=A}onRequest(A){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=A}sendResponse(A){A.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.internalSend("response",A)}sendRequest(A,D,F,N){const b={command:A};if(D&&Object.keys(D).length>0&&(b.arguments=D),this.internalSend("request",b),typeof N=="number"){const c=setTimeout(()=>{clearTimeout(c);const g=this.pendingRequests.get(b.seq);if(g){this.pendingRequests.delete(b.seq);const s={type:"response",seq:0,request_seq:b.seq,success:!1,command:A,message:(0,w.localize)(0,null,N,A)};g(s)}},N)}return F&&this.pendingRequests.set(b.seq,F),b.seq}acceptMessage(A){this.messageCallback?this.messageCallback(A):(this.queue.push(A),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(A,D){return A.type!=="event"||D.type!=="event"}async processQueue(){let A;for(;this.queue.length;){if((!A||this.needsTaskBoundaryBetween(this.queue[0],A))&&await(0,k.timeout)(0),A=this.queue.shift(),!A)return;switch(A.type){case"event":this.eventCallback&&this.eventCallback(A);break;case"request":this.requestCallback&&this.requestCallback(A);break;case"response":{const D=A,F=this.pendingRequests.get(D.request_seq);F&&(this.pendingRequests.delete(D.request_seq),F(D));break}}}}internalSend(A,D){D.type=A,D.seq=this.sequence++,this.sendMessage(D)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const A=new Map;this.pendingRequests.forEach((D,F)=>A.set(F,D)),await(0,k.timeout)(500),A.forEach((D,F)=>{D({type:"response",seq:0,request_seq:F,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(F)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=B}),define(we[159],be([1,0,131,44,3]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new k.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new k.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new k.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new k.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new k.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new k.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new k.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new k.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new k.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new k.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new k.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new k.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new k.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new k.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new k.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new k.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new k.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new k.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new k.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new k.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new k.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new k.RawContextKey("breakpointAccessType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new k.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new k.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new k.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new k.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new k.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new k.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new k.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new k.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new k.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new k.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new k.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new k.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new k.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new k.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new k.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new k.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new k.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new k.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new k.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new k.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new k.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new k.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_MULTI_SESSION_REPL=new k.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new k.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new k.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new k.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new k.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new k.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(49,null)});const B=b=>o.localize(50,null,b);e.debuggerDisabledMessage=B,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(51,null)};var C;(function(b){b[b.Inactive=0]="Inactive",b[b.Initializing=1]="Initializing",b[b.Stopped=2]="Stopped",b[b.Running=3]="Running"})(C=e.State||(e.State={}));function A(b){switch(b){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var D;(function(b){b[b.Valid=0]="Valid",b[b.Unreadable=1]="Unreadable",b[b.Error=2]="Error"})(D=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var F;(function(b){b[b.Initial=1]="Initial",b[b.Dynamic=2]="Dynamic"})(F=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={})),e.IDebugService=(0,w.createDecorator)(e.DEBUG_SERVICE_ID);var N;(function(b){b[b.CONDITION=0]="CONDITION",b[b.HIT_COUNT=1]="HIT_COUNT",b[b.LOG_MESSAGE=2]="LOG_MESSAGE"})(N=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(we[160],be([1,0,9,2,17,25,10]),function(Z,e,o,k,w,B,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const A=/{([^}]+)}/g;function D(r,i,u){return r.replace(A,function(t,l){return i&&l.length>0&&l[0]!=="_"?t:u&&u.hasOwnProperty(l)?u[l]:t})}e.formatPII=D;function F(r){const i={};for(const u of Object.keys(r))u.startsWith("!")||(i[u]=r[u]);return i}e.filterExceptionsFromTelemetry=F;function N(r){return r.configuration.request==="attach"&&!b(r)&&(!r.parentSession||N(r.parentSession))}e.isSessionAttach=N;function b(r){let i=r.configuration.type;if(!!i)return i==="vslsShare"&&(i=r.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(i,"extensionhost")||(0,o.equalsIgnoreCase)(i,"pwa-extensionhost")?r:r.parentSession?b(r.parentSession):void 0}e.getExtensionHostDebugSession=b;function c(r){return r.type&&(r.label||r.program||r.runtime)}e.isDebuggerMainContribution=c;function g(r,i,u){let t,l=0;const m=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let f=null;for(;f=m.exec(r);){const S=f.index+1,P=S+f[0].length;if(S<=i&&P>=u){t=f[0],l=S;break}}if(t){const S=/\w+/g;let P=null;for(;(P=S.exec(t))&&!(P.index+1+l+P[0].length>=u););P&&(t=t.substring(0,S.lastIndex))}return t?{start:l,end:l+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=g;const s=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(r){return!!(r&&r.match(s))}e.isUri=n;function h(r){if(typeof r.path=="string"&&!(typeof r.sourceReference=="number"&&r.sourceReference>0)){if(n(r.path))return k.URI.parse(r.path);if((0,w.isAbsolute)(r.path))return k.URI.file(r.path)}return r.path}function _(r){if(typeof r.path=="object"){const i=k.URI.revive(r.path);if(i)return i.scheme===C.Schemas.file?i.fsPath:i.toString()}return r.path}function y(r,i){const u=i?h:_,t=(0,B.deepClone)(r);return p(t,(l,m)=>{l&&m&&(m.path=u(m))}),t}e.convertToDAPaths=y;function d(r,i){const u=i?h:_,t=(0,B.deepClone)(r);return p(t,(l,m)=>{!l&&m&&(m.path=u(m))}),t}e.convertToVSCPaths=d;function p(r,i){switch(r.type){case"event":{const u=r;switch(u.event){case"output":i(!1,u.body.source);break;case"loadedSource":i(!1,u.body.source);break;case"breakpoint":i(!1,u.body.breakpoint.source);break;default:break}break}case"request":{const u=r;switch(u.command){case"setBreakpoints":i(!0,u.arguments.source);break;case"breakpointLocations":i(!0,u.arguments.source);break;case"source":i(!0,u.arguments.source);break;case"gotoTargets":i(!0,u.arguments.source);break;case"launchVSCode":u.arguments.args.forEach(t=>i(!1,t));break;default:break}break}case"response":{const u=r;if(u.success&&u.body)switch(u.command){case"stackTrace":u.body.stackFrames.forEach(t=>i(!1,t.source));break;case"loadedSources":u.body.sources.forEach(t=>i(!1,t));break;case"scopes":u.body.scopes.forEach(t=>i(!1,t.source));break;case"setFunctionBreakpoints":u.body.breakpoints.forEach(t=>i(!1,t.source));break;case"setBreakpoints":u.body.breakpoints.forEach(t=>i(!1,t.source));break;case"disassemble":{const t=u;t.body&&t.body.instructions.forEach(l=>i(!1,l.location))}break;default:break}break}}}function E(r){return r.filter(i=>!i.presentation?.hidden).sort((i,u)=>i.presentation?u.presentation?i.presentation.group?u.presentation.group?i.presentation.group!==u.presentation.group?i.presentation.group.localeCompare(u.presentation.group):a(i.presentation.order,u.presentation.order):-1:u.presentation.group?1:a(i.presentation.order,u.presentation.order):-1:u.presentation?1:0)}e.getVisibleAndSorted=E;function a(r,i){return typeof r!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:r-i}async function T(r,i){const u=r.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(u!=="none"&&(await i.saveAll(),u==="allEditorsInActiveGroup")){const t=i.activeEditorPane;t&&t.input.resource?.scheme===C.Schemas.untitled&&await i.save({editor:t.input,groupId:t.group.id})}await r.reloadConfiguration()}e.saveAllBeforeDebugStart=T}),define(we[85],be([1,0,29,161,71,10,17,23,44]),function(Z,e,o,k,w,B,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var F;(function(t){t[t.Markup=1]="Markup",t[t.Code=2]="Code"})(F=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var N;(function(t){t[t.Running=1]="Running",t[t.Idle=2]="Idle"})(N=e.NotebookRunState||(e.NotebookRunState={}));var b;(function(t){t[t.Unconfirmed=1]="Unconfirmed",t[t.Pending=2]="Pending",t[t.Executing=3]="Executing"})(b=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var c;(function(t){t[t.WithHardKernelDependency=0]="WithHardKernelDependency",t[t.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",t[t.Pure=2]="Pure",t[t.Never=3]="Never"})(c=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var g;(function(t){t.Always="always",t.Never="never",t.Optional="optional"})(g=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var s;(function(t){t[t.ModelChange=1]="ModelChange",t[t.Move=2]="Move",t[t.ChangeLanguage=5]="ChangeLanguage",t[t.Initialize=6]="Initialize",t[t.ChangeCellMetadata=7]="ChangeCellMetadata",t[t.Output=8]="Output",t[t.OutputItem=9]="OutputItem",t[t.ChangeCellContent=10]="ChangeCellContent",t[t.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",t[t.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",t[t.ChangeCellMime=13]="ChangeCellMime",t[t.Unknown=100]="Unknown"})(s=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var n;(function(t){t[t.Handle=0]="Handle",t[t.Index=1]="Index"})(n=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(t){t[t.Replace=1]="Replace",t[t.Output=2]="Output",t[t.Metadata=3]="Metadata",t[t.CellLanguage=4]="CellLanguage",t[t.DocumentMetadata=5]="DocumentMetadata",t[t.Move=6]="Move",t[t.OutputItems=7]="OutputItems",t[t.PartialMetadata=8]="PartialMetadata",t[t.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var _;(function(t){t.scheme=B.Schemas.vscodeNotebookCell;const l=/^ch(\d{7,})/;function m(v,H){return v.with({scheme:t.scheme,fragment:`ch${H.toString().padStart(7,"0")}${v.scheme!==B.Schemas.file?v.scheme:""}`})}t.generate=m;function f(v){if(v.scheme!==t.scheme)return;const H=l.exec(v.fragment);return H?{handle:Number(H[1]),notebook:v.with({scheme:v.fragment.substring(H[0].length)||B.Schemas.file,fragment:null})}:void 0}t.parse=f;function S(v,H){return v.with({scheme:B.Schemas.vscodeNotebookCellOutput,fragment:`op${H??""},${v.scheme!==B.Schemas.file?v.scheme:""}`})}t.generateCellOutputUri=S;function P(v){if(v.scheme!==B.Schemas.vscodeNotebookCellOutput)return;const H=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(v.fragment);if(!H)return;const W=H[1]&&H[1]!==""?H[1]:void 0,q=H[2];return{outputId:W,notebook:v.with({scheme:q||B.Schemas.file,fragment:null})}}t.parseCellOutputUri=P;function $(v,H,W){return v.with({scheme:W,fragment:`ch${H.toString().padStart(7,"0")}${v.scheme!==B.Schemas.file?v.scheme:""}`})}t.generateCellUri=$;function L(v,H){if(v.scheme!==H)return;const W=l.exec(v.fragment);return W?{handle:Number(W[1]),notebook:v.with({scheme:v.fragment.substring(W[0].length)||B.Schemas.file,fragment:null})}:void 0}t.parseCellUri=L})(_=e.CellUri||(e.CellUri={}));const y=t=>A.isWindows?t.replace(/\//g,"\\"):t;class d{constructor(l=[],m=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=m,this.order=[...new Set(l)].map(f=>({pattern:f,matches:o.parse(y(f))}))}sort(l){const m=new Map(k.Iterable.map(l,S=>[S,y(S)]));let f=[];for(const{matches:S}of this.order)for(const[P,$]of m)if(S($)){f.push(P),m.delete(P);break}return m.size&&(f=f.concat([...m.keys()].sort((S,P)=>this.defaultOrder.indexOf(S)-this.defaultOrder.indexOf(P)))),f}prioritize(l,m){const f=this.findIndex(l);if(f===-1){this.order.unshift({pattern:l,matches:o.parse(y(l))});return}const S=new Set(m.map($=>this.findIndex($,f)));S.delete(-1);const P=Array.from(S).sort();this.order.splice(f+1,0,...P.map($=>this.order[$]));for(let $=P.length-1;$>=0;$--)this.order.splice(P[$],1)}toArray(){return this.order.map(l=>l.pattern)}findIndex(l,m=this.order.length){const f=y(l);for(let S=0;S<m;S++)if(this.order[S].matches(f))return S;return-1}}e.MimeTypeDisplayOrder=d;function p(t,l,m,f=(S,P)=>S===P){const S=[];function P(v,H,W){if(H===0&&W.length===0)return;const q=S[S.length-1];q&&q.start+q.deleteCount===v?(q.deleteCount+=H,q.toInsert.push(...W)):S.push({start:v,deleteCount:H,toInsert:W})}let $=0,L=0;for(;;){if($===t.length){P($,0,l.slice(L));break}if(L===l.length){P($,t.length-$,[]);break}const v=t[$],H=l[L];if(f(v,H)){$+=1,L+=1;continue}m(H)?(P($,1,[]),$+=1):(P($,0,[H]),L+=1)}return S}e.diff=p,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new D.RawContextKey("notebookEditorCursorAtBoundary","none");var E;(function(t){t.default="default",t.option="option"})(E=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function a(t){const l=t;return!!((typeof l.include=="string"||o.isRelativePattern(l.include))&&(typeof l.exclude=="string"||o.isRelativePattern(l.exclude)))}e.isDocumentExcludePattern=a;function T(t,l,m){if(Array.isArray(t.viewType)&&t.viewType.indexOf(l)>=0||t.viewType===l)return!0;if(t.filenamePattern){const f=a(t.filenamePattern)?t.filenamePattern.include:t.filenamePattern,S=a(t.filenamePattern)?t.filenamePattern.exclude:void 0;if(o.match(f,(0,C.basename)(m.fsPath).toLowerCase()))return!(S&&o.match(S,(0,C.basename)(m.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=T;class r{constructor(l){this.textModel=l}getElements(){const l=new Int32Array(this.textModel.cells.length);for(let m=0;m<this.textModel.cells.length;m++)l[m]=this.textModel.cells[m].getHashValue();return l}}e.CellSequence=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode"};var i;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class u{static create(l){return`${u._prefix}${l}`}static parse(l){if(l.startsWith(u._prefix))return l.substring(u._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=u,u._prefix="notebook/"}),define(we[162],be([1,0,3]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var k;(function(w){w[w.Output=1]="Output",w[w.OutputItems=2]="OutputItems",w[w.ExecutionState=3]="ExecutionState"})(k=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(we[163],be([1,0,3,44]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new k.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new k.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new k.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,o.createDecorator)(e.OUTPUT_SERVICE_ID);var w;(function(B){B[B.Append=1]="Append",B[B.Replace=2]="Replace",B[B.Clear=3]="Clear"})(w=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={}))}),define(we[164],be([1,0,132,3,44]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new w.RawContextKey("customExecutionSupported",!0,o.localize(0,null)),e.ShellExecutionSupportedContext=new w.RawContextKey("shellExecutionSupported",!1,o.localize(1,null)),e.ProcessExecutionSupportedContext=new w.RawContextKey("processExecutionSupported",!1,o.localize(2,null)),e.ITaskService=(0,k.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(we[165],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function o(w){return[...w.entries()]}e.serializeEnvironmentVariableCollection=o;function k(w){return new Map(w)}e.deserializeEnvironmentVariableCollection=k}),define(we[62],be([1,0,2,48]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var w;(function(u){u[u.Unset=0]="Unset",u[u.Queued=1]="Queued",u[u.Running=2]="Running",u[u.Passed=3]="Passed",u[u.Failed=4]="Failed",u[u.Skipped=5]="Skipped",u[u.Errored=6]="Errored"})(w=e.TestResultState||(e.TestResultState={}));var B;(function(u){u[u.Run=2]="Run",u[u.Debug=4]="Debug",u[u.Coverage=8]="Coverage",u[u.HasNonDefaultProfile=16]="HasNonDefaultProfile",u[u.HasConfigurable=32]="HasConfigurable"})(B=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var C;(function(u){u.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),u.deserialize=t=>({range:k.Range.lift(t.range),uri:o.URI.revive(t.uri)})})(C=e.IRichLocation||(e.IRichLocation={}));var A;(function(u){u[u.Error=0]="Error",u[u.Info=1]="Info"})(A=e.TestMessageType||(e.TestMessageType={}));var D;(function(u){u.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&C.serialize(t.location)}),u.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&C.deserialize(t.location)})})(D=e.ITestErrorMessage||(e.ITestErrorMessage={}));var F;(function(u){u.serialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&C.serialize(t.location)}),u.deserialize=t=>({message:t.message,type:1,offset:t.offset,location:t.location&&C.deserialize(t.location)})})(F=e.ITestOutputMessage||(e.ITestOutputMessage={}));var N;(function(u){u.serialize=t=>t.type===0?D.serialize(t):F.serialize(t),u.deserialize=t=>t.type===0?D.deserialize(t):F.deserialize(t)})(N=e.ITestMessage||(e.ITestMessage={}));var b;(function(u){u.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(N.serialize)}),u.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(N.deserialize)})})(b=e.ITestTaskState||(e.ITestTaskState={}));const c="\0",g=(u,t)=>u+c+t;e.namespaceTestTag=g;const s=u=>{const t=u.indexOf(c);return{ctrlId:u.slice(0,t),tagId:u.slice(t+1)}};e.denamespaceTestTag=s;var n;(function(u){u.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),u.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?o.URI.revive(t.uri):void 0,range:t.range?k.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(n=e.ITestItem||(e.ITestItem={}));var h;(function(u){u[u.NotExpandable=0]="NotExpandable",u[u.Expandable=1]="Expandable",u[u.BusyExpanding=2]="BusyExpanding",u[u.Expanded=3]="Expanded"})(h=e.TestItemExpandState||(e.TestItemExpandState={}));var _;(function(u){u.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:n.serialize(t.item)}),u.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:n.deserialize(t.item)})})(_=e.InternalTestItem||(e.InternalTestItem={}));var y;(function(u){u.serialize=t=>{let l;return t.item&&(l={},t.item.label!==void 0&&(l.label=t.item.label),t.item.tags!==void 0&&(l.tags=t.item.tags),t.item.busy!==void 0&&(l.busy=t.item.busy),t.item.uri!==void 0&&(l.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(l.range=t.item.range?.toJSON()),t.item.description!==void 0&&(l.description=t.item.description),t.item.error!==void 0&&(l.error=t.item.error),t.item.sortText!==void 0&&(l.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:l}},u.deserialize=t=>{let l;return t.item&&(l={},t.item.label!==void 0&&(l.label=t.item.label),t.item.tags!==void 0&&(l.tags=t.item.tags),t.item.busy!==void 0&&(l.busy=t.item.busy),t.item.range!==void 0&&(l.range=t.item.range?k.Range.lift(t.item.range):null),t.item.description!==void 0&&(l.description=t.item.description),t.item.error!==void 0&&(l.error=t.item.error),t.item.sortText!==void 0&&(l.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:l}}})(y=e.ITestItemUpdate||(e.ITestItemUpdate={}));const d=(u,t)=>{t.expand!==void 0&&(u.expand=t.expand),t.item!==void 0&&(u.item=u.item?Object.assign(u.item,t.item):t.item)};e.applyTestItemUpdate=d;var p;(function(u){u.serialize=(t,l)=>({..._.serialize(t),children:l,ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(b.serialize)})})(p=e.TestResultItem||(e.TestResultItem={}));var E;(function(u){u[u.Function=0]="Function",u[u.Statement=1]="Statement"})(E=e.DetailType||(e.DetailType={}));var a;(function(u){u[u.Add=0]="Add",u[u.Update=1]="Update",u[u.Remove=2]="Remove",u[u.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",u[u.Retire=4]="Retire",u[u.AddTag=5]="AddTag",u[u.RemoveTag=6]="RemoveTag"})(a=e.TestDiffOpType||(e.TestDiffOpType={}));var T;(function(u){u.deserialize=t=>t.op===0?{op:t.op,item:_.deserialize(t.item)}:t.op===1?{op:t.op,item:y.deserialize(t.item)}:t,u.serialize=t=>t.op===0?{op:t.op,item:_.serialize(t.item)}:t.op===1?{op:t.op,item:y.serialize(t.item)}:t})(T=e.TestsDiffOp||(e.TestsDiffOp={}));class r{add(t){}update(t){}remove(t,l){}complete(){}}e.IncrementalChangeCollector=r;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const l=this.createChangeCollector();for(const m of t)switch(m.op){case 0:{const f=_.deserialize(m.item);if(f.parent){if(this.items.has(f.parent)){const S=this.items.get(f.parent);S.children.add(f.item.extId);const P=this.createItem(f,S);this.items.set(f.item.extId,P),l.add(P)}}else{const S=this.createItem(f);this.roots.add(S),this.items.set(f.item.extId,S),l.add(S)}f.expand===2&&this.busyControllerCount++;break}case 1:{const f=y.deserialize(m.item),S=this.items.get(f.extId);if(!S)break;f.expand!==void 0&&(S.expand===2&&this.busyControllerCount--,f.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(S,f),l.update(S);break}case 2:{const f=this.items.get(m.itemId);if(!f)break;f.parent?this.items.get(f.parent).children.delete(f.item.extId):this.roots.delete(f);const S=[[m.itemId]];for(;S.length;)for(const P of S.pop()){const $=this.items.get(P);$&&(S.push($.children),this.items.delete(P),l.remove($,$!==f),$.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(m.itemId);break;case 3:this.updatePendingRoots(m.amount);break;case 5:this._tags.set(m.tag.id,m.tag);break;case 6:this._tags.delete(m.id);break}l.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new r}}e.AbstractIncrementalTestCollection=i}),define(we[63],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(B){B.Delimiter="\0"})(o=e.TestIdPathParts||(e.TestIdPathParts={}));var k;(function(B){B[B.IsSame=0]="IsSame",B[B.Disconnected=1]="Disconnected",B[B.IsChild=2]="IsChild",B[B.IsParent=3]="IsParent"})(k=e.TestPosition||(e.TestPosition={}));class w{constructor(C,A=C.length){if(this.path=C,this.viewEnd=A,C.length===0||A<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(C,A,D=C.parent){if(C.id===A)return new w([A]);let F=[C.id];for(let N=D;N&&N.id!==A;N=N.parent)F.push(N.id);return F.push(A),new w(F.reverse())}static isRoot(C){return!C.includes("\0")}static root(C){const A=C.indexOf("\0");return A===-1?C:C.slice(0,A)}static fromString(C){return new w(C.split("\0"))}static join(C,A){return new w([...C.path,A])}static joinToString(C,A){return C.toString()+"\0"+A}static compare(C,A){return C===A?0:A.startsWith(C+"\0")?2:C.startsWith(A+"\0")?3:1}get parentId(){return this.viewEnd>1?new w(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let C=1;C<=this.viewEnd;C++)yield new w(this.path,C)}compare(C){if(typeof C=="string")return w.compare(this.toString(),C);for(let A=0;A<C.viewEnd&&A<this.viewEnd;A++)if(C.path[A]!==this.path[A])return 1;return C.viewEnd>this.viewEnd?2:C.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let C=1;C<this.viewEnd;C++)this.stringifed+="\0",this.stringifed+=this.path[C]}return this.stringifed}}e.TestId=w}),define(we[166],be([1,0,17,86,11,25,23,73,133]),function(Z,e,o,k,w,B,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class F{constructor(b,c,g,s){this._contributedVariables=new Map,this._context=b,this._labelService=c,this._userHomePromise=g,s&&(this._envVariablesPromise=s.then(n=>this.prepareEnv(n)))}prepareEnv(b){if(C.isWindows){const c=Object.create(null);return Object.keys(b).forEach(g=>{c[g.toLowerCase()]=b[g]}),c}return b}resolveWithEnvironment(b,c,g){return this.recursiveResolve({env:this.prepareEnv(b),userHome:void 0},c?c.uri:void 0,g)}async resolveAsync(b,c){const g={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(g,b?b.uri:void 0,c)}async resolveAnyBase(b,c,g,s){const n=B.deepClone(c);C.isWindows&&n.windows?Object.keys(n.windows).forEach(_=>n[_]=n.windows[_]):C.isMacintosh&&n.osx?Object.keys(n.osx).forEach(_=>n[_]=n.osx[_]):C.isLinux&&n.linux&&Object.keys(n.linux).forEach(_=>n[_]=n.linux[_]),delete n.windows,delete n.osx,delete n.linux;const h={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(h,b?b.uri:void 0,n,g,s)}async resolveAnyAsync(b,c,g){return this.resolveAnyBase(b,c,g)}async resolveAnyMap(b,c,g){const s=new Map;return{newConfig:await this.resolveAnyBase(b,c,g,s),resolvedVariables:s}}resolveWithInteractionReplace(b,c,g,s){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(b,c,g,s){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(b,c){if(this._contributedVariables.has(b))throw new Error("Variable "+b+" is contributed twice.");this._contributedVariables.set(b,c)}recursiveResolve(b,c,g,s,n){if(w.isString(g))return this.resolveString(b,c,g,s,n);if(w.isArray(g))return g.map(h=>this.recursiveResolve(b,c,h,s,n));if(w.isObject(g)){let h=Object.create(null);return Object.keys(g).forEach(_=>{const y=this.resolveString(b,c,_,s,n);h[y]=this.recursiveResolve(b,c,g[_],s,n)}),h}return g}resolveString(b,c,g,s,n){return g.replace(F.VARIABLE_REGEXP,(_,y)=>{if(y.includes(F.VARIABLE_LHS))return _;let d=this.evaluateSingleVariable(b,_,y,c,s);return n&&n.set(y,d),d!==_&&w.isString(d)&&d.match(F.VARIABLE_REGEXP)&&(d=this.resolveString(b,c,d,s,n)),d})}fsPath(b){return this._labelService?this._labelService.getUriLabel(b,{noPrefix:!0}):b.fsPath}evaluateSingleVariable(b,c,g,s,n){let h;const _=g.split(":");_.length>1&&(g=_[0],h=_[1]);const y=()=>{const E=this._context.getFilePath();if(E)return E;throw new Error((0,D.localize)(0,null,c))},d=()=>{const E=y();if(this._context.getWorkspaceFolderPathForFile){const a=this._context.getWorkspaceFolderPathForFile();if(a)return a}throw new Error((0,D.localize)(1,null,c,o.basename(E)))},p=()=>{if(h){const E=this._context.getFolderUri(h);if(E)return E;throw new Error((0,D.localize)(2,null,c,h))}if(s)return s;throw this._context.getWorkspaceFolderCount()>1?new Error((0,D.localize)(3,null,c)):new Error((0,D.localize)(4,null,c))};switch(g){case"env":if(h){if(b.env){const E=b.env[C.isWindows?h.toLowerCase():h];if(w.isString(E))return E}return""}throw new Error((0,D.localize)(5,null,c));case"config":if(h){const E=this._context.getConfigurationValue(s,h);if(w.isUndefinedOrNull(E))throw new Error((0,D.localize)(6,null,c,h));if(w.isObject(E))throw new Error((0,D.localize)(7,null,c,h));return E}throw new Error((0,D.localize)(8,null,c));case"command":return this.resolveFromMap(c,h,n,"command");case"input":return this.resolveFromMap(c,h,n,"input");default:switch(g){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.fsPath(p()));case"cwd":return s||h?(0,A.normalizeDriveLetter)(this.fsPath(p())):k.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return o.basename(this.fsPath(p()));case"userHome":{if(b.userHome)return b.userHome;throw new Error((0,D.localize)(9,null,c))}case"lineNumber":{const E=this._context.getLineNumber();if(E)return E;throw new Error((0,D.localize)(10,null,c))}case"selectedText":{const E=this._context.getSelectedText();if(E)return E;throw new Error((0,D.localize)(11,null,c))}case"file":return y();case"fileWorkspaceFolder":return d();case"relativeFile":return s||h?o.relative(this.fsPath(p()),y()):y();case"relativeFileDirname":{const E=o.dirname(y());if(s||h){const a=o.relative(this.fsPath(p()),E);return a.length===0?".":a}return E}case"fileDirname":return o.dirname(y());case"fileExtname":return o.extname(y());case"fileBasename":return o.basename(y());case"fileBasenameNoExtension":{const E=o.basename(y());return E.slice(0,E.length-o.extname(E).length)}case"fileDirnameBasename":return o.basename(o.dirname(y()));case"execPath":{const E=this._context.getExecPath();return E||c}case"execInstallFolder":{const E=this._context.getAppRoot();return E||c}case"pathSeparator":return o.sep;default:try{const E=h?`${g}:${h}`:g;return this.resolveFromMap(c,E,n,void 0)}catch{return c}}}}resolveFromMap(b,c,g,s){if(c&&g){const n=s===void 0?g[c]:g[s+":"+c];if(typeof n=="string")return n;throw new Error((0,D.localize)(12,null,b))}return b}}e.AbstractVariableResolverService=F,F.VARIABLE_LHS="${",F.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(we[87],be([1,0,3,156]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var w;(function(s){s[s.UP=0]="UP",s[s.DOWN=1]="DOWN",s[s.LEFT=2]="LEFT",s[s.RIGHT=3]="RIGHT"})(w=e.GroupDirection||(e.GroupDirection={}));var B;(function(s){s[s.HORIZONTAL=0]="HORIZONTAL",s[s.VERTICAL=1]="VERTICAL"})(B=e.GroupOrientation||(e.GroupOrientation={}));var C;(function(s){s[s.FIRST=0]="FIRST",s[s.LAST=1]="LAST",s[s.NEXT=2]="NEXT",s[s.PREVIOUS=3]="PREVIOUS"})(C=e.GroupLocation||(e.GroupLocation={}));var A;(function(s){s[s.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",s[s.EVEN=1]="EVEN",s[s.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var D;(function(s){s[s.COPY_EDITORS=0]="COPY_EDITORS",s[s.MOVE_EDITORS=1]="MOVE_EDITORS"})(D=e.MergeGroupMode||(e.MergeGroupMode={}));function F(s){const n=s;return(0,k.isEditorInput)(n?.editor)&&(0,k.isEditorInput)(n?.replacement)}e.isEditorReplacement=F;var N;(function(s){s[s.CREATION_TIME=0]="CREATION_TIME",s[s.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",s[s.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(N=e.GroupsOrder||(e.GroupsOrder={}));var b;(function(s){s[s.NEW_EDITOR=1]="NEW_EDITOR",s[s.MOVE_EDITOR=2]="MOVE_EDITOR",s[s.COPY_EDITOR=3]="COPY_EDITOR"})(b=e.OpenEditorContext||(e.OpenEditorContext={}));function c(s){const n=s;return!!n&&typeof n.id=="number"&&Array.isArray(n.editors)}e.isEditorGroup=c;function g(s){return s.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=g}),define(we[167],be([1,0,3,87]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function w(B){const C=B;return typeof B=="number"||(0,k.isEditorGroup)(C)}e.isPreferredGroup=w}),define(we[8],be([1,0,16,21,72,101,54,25,11,2,48,88,135,78,47,85,62,63,167,6]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var p;(function(me){function pe(G){const{selectionStartLineNumber:Se,selectionStartColumn:Ce,positionLineNumber:xe,positionColumn:je}=G,lt=new d.Position(Se-1,Ce-1),gt=new d.Position(xe-1,je-1);return new d.Selection(lt,gt)}me.to=pe;function oe(G){const{anchor:Se,active:Ce}=G;return{selectionStartLineNumber:Se.line+1,selectionStartColumn:Se.character+1,positionLineNumber:Ce.line+1,positionColumn:Ce.character+1}}me.from=oe})(p=e.Selection||(e.Selection={}));var E;(function(me){function pe(G){if(!G)return;const{start:Se,end:Ce}=G;return{startLineNumber:Se.line+1,startColumn:Se.character+1,endLineNumber:Ce.line+1,endColumn:Ce.character+1}}me.from=pe;function oe(G){if(!G)return;const{startLineNumber:Se,startColumn:Ce,endLineNumber:xe,endColumn:je}=G;return new d.Range(Se-1,Ce-1,xe-1,je-1)}me.to=oe})(E=e.Range||(e.Range={}));var a;(function(me){function pe(oe){switch(oe){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}me.to=pe})(a=e.TokenType||(e.TokenType={}));var T;(function(me){function pe(G){return new d.Position(G.lineNumber-1,G.column-1)}me.to=pe;function oe(G){return{lineNumber:G.line+1,column:G.character+1}}me.from=oe})(T=e.Position||(e.Position={}));var r;(function(me){function pe(Se,Ce){return(0,o.coalesce)((0,o.asArray)(Se).map(xe=>oe(xe,Ce)))}me.from=pe;function oe(Se,Ce){if(typeof Se=="string")return{$serialized:!0,language:Se};if(Se)return{$serialized:!0,language:Se.language,scheme:G(Se.scheme,Ce),pattern:le.from(Se.pattern)??void 0,exclusive:Se.exclusive,notebookType:Se.notebookType}}function G(Se,Ce){return Ce&&typeof Se=="string"?Ce.transformOutgoingScheme(Se):Se}})(r=e.DocumentSelector||(e.DocumentSelector={}));var i;(function(me){function pe(G){switch(G){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}me.from=pe;function oe(G){switch(G){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}me.to=oe})(i=e.DiagnosticTag||(e.DiagnosticTag={}));var u;(function(me){function pe(G){let Se;return G.code&&((0,D.isString)(G.code)||(0,D.isNumber)(G.code)?Se=String(G.code):Se={value:String(G.code.value),target:G.code.target}),{...E.from(G.range),message:G.message,source:G.source,code:Se,severity:l.from(G.severity),relatedInformation:G.relatedInformation&&G.relatedInformation.map(t.from),tags:Array.isArray(G.tags)?(0,o.coalesce)(G.tags.map(i.from)):void 0}}me.from=pe;function oe(G){const Se=new d.Diagnostic(E.to(G),G.message,l.to(G.severity));return Se.source=G.source,Se.code=(0,D.isString)(G.code)?G.code:G.code?.value,Se.relatedInformation=G.relatedInformation&&G.relatedInformation.map(t.to),Se.tags=G.tags&&(0,o.coalesce)(G.tags.map(i.to)),Se}me.to=oe})(u=e.Diagnostic||(e.Diagnostic={}));var t;(function(me){function pe(G){return{...E.from(G.location.range),message:G.message,resource:G.location.uri}}me.from=pe;function oe(G){return new d.DiagnosticRelatedInformation(new d.Location(G.resource,E.to(G)),G.message)}me.to=oe})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var l;(function(me){function pe(G){switch(G){case d.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}me.from=pe;function oe(G){switch(G){case g.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}me.to=oe})(l=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var m;(function(me){function pe(G){return typeof G=="number"&&G>=d.ViewColumn.One?G-1:G===d.ViewColumn.Beside?y.SIDE_GROUP:y.ACTIVE_GROUP}me.from=pe;function oe(G){if(typeof G=="number"&&G>=0)return G+1;throw new Error("invalid 'EditorGroupColumn'")}me.to=oe})(m=e.ViewColumn||(e.ViewColumn={}));function f(me){return typeof me.range!="undefined"}function S(me){return me.length===0?!0:!!f(me[0])}e.isDecorationOptionsArr=S;var P;(function(me){function pe(je){return je.map(me.from)}me.fromMany=pe;function oe(je){return je&&typeof je=="object"&&typeof je.language=="string"&&typeof je.value=="string"}function G(je){let lt;if(oe(je)){const{language:at,value:ot}=je;lt={value:"```"+at+`
`+ot+"\n```\n"}}else d.MarkdownString.isMarkdownString(je)?lt={value:je.value,isTrusted:je.isTrusted,supportThemeIcons:je.supportThemeIcons,supportHtml:je.supportHtml,baseUri:je.baseUri}:typeof je=="string"?lt={value:je}:lt={value:""};const gt=Object.create(null);lt.uris=gt;const Et=at=>{try{let ot=F.URI.parse(at,!0);ot=ot.with({query:Se(ot.query,gt)}),gt[at]=ot}catch{}return""},rt=new B.marked.Renderer;return rt.link=Et,rt.image=at=>typeof at=="string"?Et(w.parseHrefAndDimensions(at).href):"",(0,B.marked)(lt.value,{renderer:rt}),lt}me.from=G;function Se(je,lt){if(!je)return je;let gt;try{gt=(0,C.parse)(je)}catch{}if(!gt)return je;let Et=!1;return gt=(0,A.cloneAndChange)(gt,rt=>{if(F.URI.isUri(rt)){const at=`__uri_${Math.random().toString(16).slice(2,8)}`;return lt[at]=rt,Et=!0,at}else return}),Et?JSON.stringify(gt):je}function Ce(je){const lt=new d.MarkdownString(je.value,je.supportThemeIcons);return lt.isTrusted=je.isTrusted,lt.supportHtml=je.supportHtml,lt.baseUri=je.baseUri?F.URI.from(je.baseUri):void 0,lt}me.to=Ce;function xe(je){if(!!je)return typeof je=="string"?je:me.from(je)}me.fromStrict=xe})(P=e.MarkdownString||(e.MarkdownString={}));function $(me){return S(me)?me.map(pe=>({range:E.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?P.fromMany(pe.hoverMessage):pe.hoverMessage?P.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):me.map(pe=>({range:E.from(pe)}))}e.fromRangeOrRangeWithMessage=$;function L(me){return typeof me=="undefined"?me:typeof me=="string"?F.URI.file(me):me}e.pathOrURIToURI=L;var v;(function(me){function pe(oe){return typeof oe=="undefined"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?L(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}me.from=pe})(v=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var H;(function(me){function pe(oe){return typeof oe=="undefined"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?L(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?v.from(oe.before):void 0,after:oe.after?v.from(oe.after):void 0}}me.from=pe})(H=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var W;(function(me){function pe(oe){if(typeof oe=="undefined")return oe;switch(oe){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}me.from=pe})(W=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var q;(function(me){function pe(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?W.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?H.from(oe.light):void 0,dark:oe.dark?H.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?L(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?v.from(oe.before):void 0,after:oe.after?v.from(oe.after):void 0}}me.from=pe})(q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var K;(function(me){function pe(G){return{text:G.newText,eol:G.newEol&&tt.from(G.newEol),range:E.from(G.range)}}me.from=pe;function oe(G){const Se=new d.TextEdit(E.to(G.range),G.text);return Se.newEol=typeof G.eol=="undefined"?void 0:tt.to(G.eol),Se}me.to=oe})(K=e.TextEdit||(e.TextEdit={}));var V;(function(me){function pe(G,Se){const Ce={edits:[]};if(G instanceof d.WorkspaceEdit)for(let xe of G._allEntries())xe._type===1?Ce.edits.push({_type:1,oldUri:xe.from,newUri:xe.to,options:xe.options,metadata:xe.metadata}):xe._type===2?Ce.edits.push({_type:2,resource:xe.uri,edit:K.from(xe.edit),modelVersionId:Se?.getTextDocumentVersion(xe.uri),metadata:xe.metadata}):xe._type===3?Ce.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,edit:xe.edit,notebookMetadata:xe.notebookMetadata,notebookVersionId:Se?.getNotebookDocumentVersion(xe.uri)}):xe._type===5&&Ce.edits.push({_type:3,metadata:xe.metadata,resource:xe.uri,notebookVersionId:Se?.getNotebookDocumentVersion(xe.uri),edit:{editType:1,index:xe.index,count:xe.count,cells:xe.cells.map(St.from)}});return Ce}me.from=pe;function oe(G){const Se=new d.WorkspaceEdit;for(const Ce of G.edits)Ce.edit?Se.replace(F.URI.revive(Ce.resource),E.to(Ce.edit.range),Ce.edit.text):Se.renameFile(F.URI.revive(Ce.oldUri),F.URI.revive(Ce.newUri),Ce.options);return Se}me.to=oe})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var z;(function(me){const pe=Object.create(null);pe[d.SymbolKind.File]=0,pe[d.SymbolKind.Module]=1,pe[d.SymbolKind.Namespace]=2,pe[d.SymbolKind.Package]=3,pe[d.SymbolKind.Class]=4,pe[d.SymbolKind.Method]=5,pe[d.SymbolKind.Property]=6,pe[d.SymbolKind.Field]=7,pe[d.SymbolKind.Constructor]=8,pe[d.SymbolKind.Enum]=9,pe[d.SymbolKind.Interface]=10,pe[d.SymbolKind.Function]=11,pe[d.SymbolKind.Variable]=12,pe[d.SymbolKind.Constant]=13,pe[d.SymbolKind.String]=14,pe[d.SymbolKind.Number]=15,pe[d.SymbolKind.Boolean]=16,pe[d.SymbolKind.Array]=17,pe[d.SymbolKind.Object]=18,pe[d.SymbolKind.Key]=19,pe[d.SymbolKind.Null]=20,pe[d.SymbolKind.EnumMember]=21,pe[d.SymbolKind.Struct]=22,pe[d.SymbolKind.Event]=23,pe[d.SymbolKind.Operator]=24,pe[d.SymbolKind.TypeParameter]=25;function oe(Se){return typeof pe[Se]=="number"?pe[Se]:6}me.from=oe;function G(Se){for(const Ce in pe)if(pe[Ce]===Se)return Number(Ce);return d.SymbolKind.Property}me.to=G})(z=e.SymbolKind||(e.SymbolKind={}));var ae;(function(me){function pe(G){switch(G){case d.SymbolTag.Deprecated:return 1}}me.from=pe;function oe(G){switch(G){case 1:return d.SymbolTag.Deprecated}}me.to=oe})(ae=e.SymbolTag||(e.SymbolTag={}));var de;(function(me){function pe(G){return{name:G.name,kind:z.from(G.kind),tags:G.tags&&G.tags.map(ae.from),containerName:G.containerName,location:ue.from(G.location)}}me.from=pe;function oe(G){const Se=new d.SymbolInformation(G.name,z.to(G.kind),G.containerName,ue.to(G.location));return Se.tags=G.tags&&G.tags.map(ae.to),Se}me.to=oe})(de=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var Y;(function(me){function pe(G){const Se={name:G.name||"!!MISSING: name!!",detail:G.detail,range:E.from(G.range),selectionRange:E.from(G.selectionRange),kind:z.from(G.kind),tags:G.tags?.map(ae.from)??[]};return G.children&&(Se.children=G.children.map(pe)),Se}me.from=pe;function oe(G){const Se=new d.DocumentSymbol(G.name,G.detail,z.to(G.kind),E.to(G.range),E.to(G.selectionRange));return(0,o.isNonEmptyArray)(G.tags)&&(Se.tags=G.tags.map(ae.to)),G.children&&(Se.children=G.children.map(oe)),Se}me.to=oe})(Y=e.DocumentSymbol||(e.DocumentSymbol={}));var ie;(function(me){function pe(G){const Se=new d.CallHierarchyItem(z.to(G.kind),G.name,G.detail||"",F.URI.revive(G.uri),E.to(G.range),E.to(G.selectionRange));return Se._sessionId=G._sessionId,Se._itemId=G._itemId,Se}me.to=pe;function oe(G,Se,Ce){if(Se=Se??G._sessionId,Ce=Ce??G._itemId,Se===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Ce,name:G.name,detail:G.detail,kind:z.from(G.kind),uri:G.uri,range:E.from(G.range),selectionRange:E.from(G.selectionRange),tags:G.tags?.map(ae.from)}}me.from=oe})(ie=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ce;(function(me){function pe(oe){return new d.CallHierarchyIncomingCall(ie.to(oe.from),oe.fromRanges.map(G=>E.to(G)))}me.to=pe})(ce=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var he;(function(me){function pe(oe){return new d.CallHierarchyOutgoingCall(ie.to(oe.to),oe.fromRanges.map(G=>E.to(G)))}me.to=pe})(he=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ue;(function(me){function pe(G){return{range:G.range&&E.from(G.range),uri:G.uri}}me.from=pe;function oe(G){return new d.Location(F.URI.revive(G.uri),E.to(G.range))}me.to=oe})(ue=e.location||(e.location={}));var se;(function(me){function pe(G){const Se=G,Ce=G;return{originSelectionRange:Se.originSelectionRange?E.from(Se.originSelectionRange):void 0,uri:Se.targetUri?Se.targetUri:Ce.uri,range:E.from(Se.targetRange?Se.targetRange:Ce.range),targetSelectionRange:Se.targetSelectionRange?E.from(Se.targetSelectionRange):void 0}}me.from=pe;function oe(G){return{targetUri:F.URI.revive(G.uri),targetRange:E.to(G.range),targetSelectionRange:G.targetSelectionRange?E.to(G.targetSelectionRange):void 0,originSelectionRange:G.originSelectionRange?E.to(G.originSelectionRange):void 0}}me.to=oe})(se=e.DefinitionLink||(e.DefinitionLink={}));var ge;(function(me){function pe(G){return{range:E.from(G.range),contents:P.fromMany(G.contents)}}me.from=pe;function oe(G){return new d.Hover(G.contents.map(P.to),E.to(G.range))}me.to=oe})(ge=e.Hover||(e.Hover={}));var Te;(function(me){function pe(G){return{range:E.from(G.range),expression:G.expression}}me.from=pe;function oe(G){return new d.EvaluatableExpression(E.to(G.range),G.expression)}me.to=oe})(Te=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Re;(function(me){function pe(G){if(G instanceof d.InlineValueText)return{type:"text",range:E.from(G.range),text:G.text};if(G instanceof d.InlineValueVariableLookup)return{type:"variable",range:E.from(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};if(G instanceof d.InlineValueEvaluatableExpression)return{type:"expression",range:E.from(G.range),expression:G.expression};throw new Error("Unknown 'InlineValue' type")}me.from=pe;function oe(G){switch(G.type){case"text":return{range:E.to(G.range),text:G.text};case"variable":return{range:E.to(G.range),variableName:G.variableName,caseSensitiveLookup:G.caseSensitiveLookup};case"expression":return{range:E.to(G.range),expression:G.expression}}}me.to=oe})(Re=e.InlineValue||(e.InlineValue={}));var He;(function(me){function pe(G){return{frameId:G.frameId,stoppedLocation:E.from(G.stoppedLocation)}}me.from=pe;function oe(G){return new d.InlineValueContext(G.frameId,E.to(G.stoppedLocation))}me.to=oe})(He=e.InlineValueContext||(e.InlineValueContext={}));var Xe;(function(me){function pe(G){return{range:E.from(G.range),kind:G.kind}}me.from=pe;function oe(G){return new d.DocumentHighlight(E.to(G.range),G.kind)}me.to=oe})(Xe=e.DocumentHighlight||(e.DocumentHighlight={}));var ve;(function(me){function pe(oe){switch(oe){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}me.to=pe})(ve=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var fe;(function(me){function pe(oe){return{triggerKind:ve.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}me.to=pe})(fe=e.CompletionContext||(e.CompletionContext={}));var M;(function(me){function pe(G){switch(G){case d.CompletionItemTag.Deprecated:return 1}}me.from=pe;function oe(G){switch(G){case 1:return d.CompletionItemTag.Deprecated}}me.to=oe})(M=e.CompletionItemTag||(e.CompletionItemTag={}));var O;(function(me){const pe=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function oe(Ce){return pe.get(Ce)??9}me.from=oe;const G=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function Se(Ce){return G.get(Ce)??d.CompletionItemKind.Property}me.to=Se})(O=e.CompletionItemKind||(e.CompletionItemKind={}));var I;(function(me){function pe(oe,G){const Se=new d.CompletionItem(oe.label);return Se.insertText=oe.insertText,Se.kind=O.to(oe.kind),Se.tags=oe.tags?.map(M.to),Se.detail=oe.detail,Se.documentation=w.isMarkdownString(oe.documentation)?P.to(oe.documentation):oe.documentation,Se.sortText=oe.sortText,Se.filterText=oe.filterText,Se.preselect=oe.preselect,Se.commitCharacters=oe.commitCharacters,N.Range.isIRange(oe.range)?Se.range=E.to(oe.range):typeof oe.range=="object"&&(Se.range={inserting:E.to(oe.range.insert),replacing:E.to(oe.range.replace)}),Se.keepWhitespace=typeof oe.insertTextRules=="undefined"?!1:Boolean(oe.insertTextRules&1),typeof oe.insertTextRules!="undefined"&&oe.insertTextRules&4?Se.insertText=new d.SnippetString(oe.insertText):(Se.insertText=oe.insertText,Se.textEdit=Se.range instanceof d.Range?new d.TextEdit(Se.range,Se.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(Se.additionalTextEdits=oe.additionalTextEdits.map(Ce=>K.to(Ce))),Se.command=G&&oe.command?G.fromInternal(oe.command):void 0,Se}me.to=pe})(I=e.CompletionItem||(e.CompletionItem={}));var R;(function(me){function pe(G){return{label:G.label,documentation:P.fromStrict(G.documentation)}}me.from=pe;function oe(G){return{label:G.label,documentation:w.isMarkdownString(G.documentation)?P.to(G.documentation):G.documentation}}me.to=oe})(R=e.ParameterInformation||(e.ParameterInformation={}));var x;(function(me){function pe(G){return{label:G.label,documentation:P.fromStrict(G.documentation),parameters:Array.isArray(G.parameters)?G.parameters.map(R.from):[],activeParameter:G.activeParameter}}me.from=pe;function oe(G){return{label:G.label,documentation:w.isMarkdownString(G.documentation)?P.to(G.documentation):G.documentation,parameters:Array.isArray(G.parameters)?G.parameters.map(R.to):[],activeParameter:G.activeParameter}}me.to=oe})(x=e.SignatureInformation||(e.SignatureInformation={}));var Q;(function(me){function pe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(x.from):[]}}me.from=pe;function oe(G){return{activeSignature:G.activeSignature,activeParameter:G.activeParameter,signatures:Array.isArray(G.signatures)?G.signatures.map(x.to):[]}}me.to=oe})(Q=e.SignatureHelp||(e.SignatureHelp={}));var ne;(function(me){function pe(oe,G){const Se=new d.InlayHint(T.to(G.position),typeof G.label=="string"?G.label:G.label.map(Ee.to.bind(void 0,oe)),G.kind&&Ie.to(G.kind));return Se.textEdits=G.textEdits&&G.textEdits.map(K.to),Se.tooltip=w.isMarkdownString(G.tooltip)?P.to(G.tooltip):G.tooltip,Se.paddingLeft=G.paddingLeft,Se.paddingRight=G.paddingRight,Se}me.to=pe})(ne=e.InlayHint||(e.InlayHint={}));var Ee;(function(me){function pe(oe,G){const Se=new d.InlayHintLabelPart(G.label);return Se.tooltip=w.isMarkdownString(G.tooltip)?P.to(G.tooltip):G.tooltip,b.Command.is(G.command)&&(Se.command=oe.fromInternal(G.command)),G.location&&(Se.location=ue.to(G.location)),Se}me.to=pe})(Ee=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ie;(function(me){function pe(G){return G}me.from=pe;function oe(G){return G}me.to=oe})(Ie=e.InlayHintKind||(e.InlayHintKind={}));var Me;(function(me){function pe(G){return{range:E.from(G.range),url:G.target,tooltip:G.tooltip}}me.from=pe;function oe(G){let Se;if(G.url)try{Se=typeof G.url=="string"?F.URI.parse(G.url,!0):F.URI.revive(G.url)}catch{}return new d.DocumentLink(E.to(G.range),Se)}me.to=oe})(Me=e.DocumentLink||(e.DocumentLink={}));var Le;(function(me){function pe(G){const Se=new d.ColorPresentation(G.label);return G.textEdit&&(Se.textEdit=K.to(G.textEdit)),G.additionalTextEdits&&(Se.additionalTextEdits=G.additionalTextEdits.map(Ce=>K.to(Ce))),Se}me.to=pe;function oe(G){return{label:G.label,textEdit:G.textEdit?K.from(G.textEdit):void 0,additionalTextEdits:G.additionalTextEdits?G.additionalTextEdits.map(Se=>K.from(Se)):void 0}}me.from=oe})(Le=e.ColorPresentation||(e.ColorPresentation={}));var ze;(function(me){function pe(G){return new d.Color(G[0],G[1],G[2],G[3])}me.to=pe;function oe(G){return[G.red,G.green,G.blue,G.alpha]}me.from=oe})(ze=e.Color||(e.Color={}));var Be;(function(me){function pe(G){return{range:E.from(G.range)}}me.from=pe;function oe(G){return new d.SelectionRange(E.to(G.range))}me.to=oe})(Be=e.SelectionRange||(e.SelectionRange={}));var Ae;(function(me){function pe(oe){switch(oe){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}me.to=pe})(Ae=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Qe;(function(me){function pe(G){switch(G){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.On:default:return 1}}me.from=pe;function oe(G){switch(G){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 1:default:return d.TextEditorLineNumbersStyle.On}}me.to=oe})(Qe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var tt;(function(me){function pe(G){if(G===d.EndOfLine.CRLF)return 1;if(G===d.EndOfLine.LF)return 0}me.from=pe;function oe(G){if(G===1)return d.EndOfLine.CRLF;if(G===0)return d.EndOfLine.LF}me.to=oe})(tt=e.EndOfLine||(e.EndOfLine={}));var ke;(function(me){function pe(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}me.from=pe})(ke=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(me){function pe(oe){const G={start:oe.start+1,end:oe.end+1};return oe.kind&&(G.kind=X.from(oe.kind)),G}me.from=pe})(it=e.FoldingRange||(e.FoldingRange={}));var X;(function(me){function pe(oe){if(oe)switch(oe){case d.FoldingRangeKind.Comment:return b.FoldingRangeKind.Comment;case d.FoldingRangeKind.Imports:return b.FoldingRangeKind.Imports;case d.FoldingRangeKind.Region:return b.FoldingRangeKind.Region}}me.from=pe})(X=e.FoldingRangeKind||(e.FoldingRangeKind={}));var J;(function(me){function pe(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?E.from(oe.selection):void 0,override:typeof oe.override=="boolean"?c.EditorResolution.DISABLED:void 0}}me.from=pe})(J=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var le;(function(me){function pe(Ce){return Ce instanceof d.RelativePattern?Ce.toJSON():typeof Ce=="string"?Ce:oe(Ce)||G(Ce)?new d.RelativePattern(Ce.baseUri??Ce.base,Ce.pattern).toJSON():Ce}me.from=pe;function oe(Ce){const xe=Ce;return xe?F.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function G(Ce){const xe=Ce;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Se(Ce){return typeof Ce=="string"?Ce:new d.RelativePattern(F.URI.revive(Ce.baseUri),Ce.pattern)}me.to=Se})(le=e.GlobPattern||(e.GlobPattern={}));var Oe;(function(me){function pe(oe){if(oe){if(Array.isArray(oe))return oe.map(pe);if(typeof oe=="string")return oe;{const G=oe;return{language:G.language,scheme:G.scheme,pattern:le.from(G.pattern),exclusive:G.exclusive}}}else return}me.from=pe})(Oe=e.LanguageSelector||(e.LanguageSelector={}));var $e;(function(me){function pe(G){return{start:G.start,end:G.end}}me.from=pe;function oe(G){return new d.NotebookRange(G.start,G.end)}me.to=oe})($e=e.NotebookRange||(e.NotebookRange={}));var Ge;(function(me){function pe(G){return{timing:typeof G.runStartTime=="number"&&typeof G.runEndTime=="number"?{startTime:G.runStartTime,endTime:G.runEndTime}:void 0,executionOrder:G.executionOrder,success:G.lastRunSuccess}}me.to=pe;function oe(G){return{lastRunSuccess:G.success,runStartTime:G.timing?.startTime,runEndTime:G.timing?.endTime,executionOrder:G.executionOrder}}me.from=oe})(Ge=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var Je;(function(me){function pe(oe){if(oe===n.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;if(oe===n.NotebookCellExecutionState.Pending)return d.NotebookCellExecutionState.Pending;if(oe===n.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${oe}`)}me.to=pe})(Je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ht;(function(me){function pe(G){switch(G){case d.NotebookCellKind.Markup:return n.CellKind.Markup;case d.NotebookCellKind.Code:default:return n.CellKind.Code}}me.from=pe;function oe(G){switch(G){case n.CellKind.Markup:return d.NotebookCellKind.Markup;case n.CellKind.Code:default:return d.NotebookCellKind.Code}}me.to=oe})(ht=e.NotebookCellKind||(e.NotebookCellKind={}));var It;(function(me){function pe(G){const Se={metadata:G.metadata??Object.create(null),cells:[]};for(let Ce of G.cells)d.NotebookCellData.validate(Ce),Se.cells.push(St.from(Ce));return Se}me.from=pe;function oe(G){const Se=new d.NotebookData(G.cells.map(St.to));return(0,D.isEmptyObject)(G.metadata)||(Se.metadata=G.metadata),Se}me.to=oe})(It=e.NotebookData||(e.NotebookData={}));var St;(function(me){function pe(G){return{cellKind:ht.from(G.kind),language:G.languageId,mime:G.mime,source:G.value,metadata:G.metadata,internalMetadata:Ge.from(G.executionSummary??{}),outputs:G.outputs?G.outputs.map(qe.from):[]}}me.from=pe;function oe(G){return new d.NotebookCellData(ht.to(G.cellKind),G.source,G.language,G.mime,G.outputs?G.outputs.map(qe.to):void 0,G.metadata,G.internalMetadata?Ge.to(G.internalMetadata):void 0)}me.to=oe})(St=e.NotebookCellData||(e.NotebookCellData={}));var kt;(function(me){function pe(G){return{mime:G.mime,valueBytes:k.VSBuffer.wrap(G.data)}}me.from=pe;function oe(G){return new d.NotebookCellOutputItem(G.valueBytes.buffer,G.mime)}me.to=oe})(kt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var qe;(function(me){function pe(G){return{outputId:G.id,items:G.items.map(kt.from),metadata:G.metadata}}me.from=pe;function oe(G){const Se=G.items.map(kt.to);return new d.NotebookCellOutput(Se,G.outputId,G.metadata)}me.to=oe})(qe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var vt;(function(me){function pe(Se){return G(Se)?{include:(0,D.withNullAsUndefined)(le.from(Se.include)),exclude:(0,D.withNullAsUndefined)(le.from(Se.exclude))}:(0,D.withNullAsUndefined)(le.from(Se))}me.from=pe;function oe(Se){return G(Se)?{include:le.to(Se.include),exclude:le.to(Se.exclude)}:le.to(Se)}me.to=oe;function G(Se){const Ce=Se;return Ce?!!Ce.include&&!!Ce.exclude:!1}})(vt=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Nt;(function(me){function pe(oe){return{backgroundColor:oe.backgroundColor,borderColor:oe.borderColor,top:oe.top?v.from(oe.top):void 0}}me.from=pe})(Nt=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var nt;(function(me){function pe(oe,G,Se){const Ce=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:G.toInternal(Ce,Se),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}me.from=pe})(nt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ut;(function(me){function pe(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{}}}me.from=pe})(ut=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var At;(function(me){function pe(G){return{uri:G.uri,provides:G.provides}}me.from=pe;function oe(G){return new d.NotebookRendererScript(F.URI.revive(G.uri),G.provides)}me.to=oe})(At=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Tt;(function(me){function pe(G){return{message:P.fromStrict(G.message)||"",type:0,expected:G.expectedOutput,actual:G.actualOutput,location:G.location&&{range:E.from(G.location.range),uri:G.location.uri}}}me.from=pe;function oe(G){const Se=new d.TestMessage(typeof G.message=="string"?G.message:P.to(G.message));return Se.actualOutput=G.actual,Se.expectedOutput=G.expected,Se.location=G.location?ue.to(G.location):void 0,Se}me.to=oe})(Tt=e.TestMessage||(e.TestMessage={}));var bt;(function(me){me.namespace=h.namespaceTestTag,me.denamespace=h.denamespaceTestTag})(bt=e.TestTag||(e.TestTag={}));var dt;(function(me){function pe(Ce){const xe=(0,s.getPrivateApiFor)(Ce).controllerId;return{extId:_.TestId.fromExtHostTestItem(Ce,xe).toString(),label:Ce.label,uri:F.URI.revive(Ce.uri),busy:!1,tags:Ce.tags.map(je=>bt.namespace(xe,je.id)),range:N.Range.lift(E.from(Ce.range)),description:Ce.description||null,sortText:Ce.sortText||null,error:Ce.error&&P.fromStrict(Ce.error)||null}}me.from=pe;function oe(Ce){return{parent:void 0,error:void 0,id:_.TestId.fromString(Ce.extId).localId,label:Ce.label,uri:F.URI.revive(Ce.uri),tags:(Ce.tags||[]).map(xe=>{const{tagId:je}=bt.denamespace(xe);return new d.TestTag(je)}),range:E.to(Ce.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Ce.description||void 0,sortText:Ce.sortText||void 0}}me.toPlain=oe;function G(Ce){const xe=_.TestId.fromString(Ce.extId),je=new s.TestItemImpl(xe.controllerId,xe.localId,Ce.label,F.URI.revive(Ce.uri)||void 0);return je.range=E.to(Ce.range||void 0),je.description=Ce.description||void 0,je.sortText=Ce.sortText||void 0,je}function Se(Ce){let xe;for(const je of Ce.tests){const lt=G(je.item);(0,s.getPrivateApiFor)(lt).parent=xe,xe=lt}return xe}me.toItemFromContext=Se})(dt=e.TestItem||(e.TestItem={})),function(me){function pe(G){return{id:G.id}}me.from=pe;function oe(G){return new d.TestTag(G.id)}me.to=oe}(bt=e.TestTag||(e.TestTag={}));var Rt;(function(me){const pe=(G,Se)=>{const Ce={...dt.toPlain(G.item),parent:void 0,taskStates:G.tasks.map(xe=>({state:xe.state,duration:xe.duration,messages:xe.messages.filter(je=>je.type===0).map(Tt.to)})),children:G.children.map(xe=>Se.get(xe)).filter(D.isDefined).map(xe=>pe(xe,Se))};for(const xe of Ce.children)xe.parent=Ce;return Ce};function oe(G){const Se=[],Ce=new Map;for(const xe of G.items)Ce.set(xe.item.extId,xe),G.request.targets.some(je=>je.controllerId===xe.controllerId&&je.testIds.includes(xe.item.extId))&&Se.push(xe);return{completedAt:G.completedAt,results:Se.map(xe=>pe(xe,Ce))}}me.to=oe})(Rt=e.TestResults||(e.TestResults={}));var Lt;(function(me){function pe(Ce){return{covered:Ce.covered,total:Ce.covered}}function oe(Ce){return"line"in Ce?T.from(Ce):E.from(Ce)}function G(Ce){return"branches"in Ce?{count:Ce.executionCount,location:oe(Ce.location),type:1,branches:Ce.branches.length?Ce.branches.map(xe=>({count:xe.executionCount,location:xe.location&&oe(xe.location)})):void 0}:{type:0,count:Ce.executionCount,location:oe(Ce.location)}}me.fromDetailed=G;function Se(Ce){return{uri:Ce.uri,statement:pe(Ce.statementCoverage),branch:Ce.branchCoverage&&pe(Ce.branchCoverage),function:Ce.functionCoverage&&pe(Ce.functionCoverage),details:Ce.detailedCoverage?.map(G)}}me.fromFile=Se})(Lt=e.TestCoverage||(e.TestCoverage={}));var Ft;(function(me){function pe(oe){switch(oe){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}me.to=pe})(Ft=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Ue;(function(me){function pe(G){const Se=new d.TypeHierarchyItem(z.to(G.kind),G.name,G.detail||"",F.URI.revive(G.uri),E.to(G.range),E.to(G.selectionRange));return Se._sessionId=G._sessionId,Se._itemId=G._itemId,Se}me.to=pe;function oe(G,Se,Ce){if(Se=Se??G._sessionId,Ce=Ce??G._itemId,Se===void 0||Ce===void 0)throw new Error("invalid item");return{_sessionId:Se,_itemId:Ce,kind:z.from(G.kind),name:G.name,detail:G.detail??"",uri:G.uri,range:E.from(G.range),selectionRange:E.from(G.selectionRange),tags:G.tags?.map(ae.from)}}me.from=oe})(Ue=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(we[168],be([1,0,2,15,6,8,228]),function(Z,e,o,k,w,B,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(F,N,b,c={timeout:1500,errors:3}){this._logService=F,this._documents=N,this._mainThreadBulkEdits=b,this._thresholds=c,this._callbacks=new C.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(F){return(N,b,c)=>{const s={dispose:this._callbacks.push([N,b,F])};return Array.isArray(c)&&c.push(s),s}}async $participateInSave(F,N){const b=o.URI.revive(F);let c=!1;const g=setTimeout(()=>c=!0,this._thresholds.timeout),s=[];try{for(let n of[...this._callbacks]){if(c)break;const h=this._documents.getDocument(b),_=await this._deliverEventAsyncAndBlameBadListeners(n,{document:h,reason:B.TextDocumentSaveReason.to(N)});s.push(_)}}finally{clearTimeout(g)}return s}_deliverEventAsyncAndBlameBadListeners([F,N,b],c){const g=this._badListeners.get(F);return typeof g=="number"&&g>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(b,F,N,c).then(()=>!0,s=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' threw ERROR`),this._logService.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const n=this._badListeners.get(F);this._badListeners.set(F,n?n+1:1),typeof n=="number"&&n>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${b.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(F,N,b,c){const g=[],s=Date.now(),{document:n,reason:h}=c,{version:_}=n,y=Object.freeze({document:n,reason:h,waitUntil(d){if(Object.isFrozen(g))throw(0,k.illegalState)("waitUntil can not be called async");g.push(Promise.resolve(d))}});try{N.apply(b,[y])}catch(d){return Promise.reject(d)}return Object.freeze(g),new Promise((d,p)=>{const E=setTimeout(()=>p(new Error("timeout")),this._thresholds.timeout);return Promise.all(g).then(a=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${F.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(E),d(a)}).catch(a=>{clearTimeout(E),p(a)})}).then(d=>{const p={edits:[]};for(const E of d)if(Array.isArray(E)&&E.every(a=>a instanceof w.TextEdit))for(const{newText:a,newEol:T,range:r}of E)p.edits.push({_type:2,resource:n.uri,edit:{range:r&&B.Range.from(r),text:a,eol:T&&B.EndOfLine.from(T)}});if(p.edits.length!==0)return _===n.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(p):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(we[169],be([1,0,10,25,2,8,6,85]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class D{constructor(c,g,s,n){this.start=c,this.deletedCount=g,this.deletedItems=s,this.items=n}asApiEvent(){return{range:new C.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(c=>c.apiCell),removedCells:this.deletedItems}}static asApiEvents(c){return c.map(g=>({start:g.start,deletedCount:g.deletedCount,deletedItems:g.deletedItems,items:g.items.map(s=>s.apiCell)}))}}class F{constructor(c,g,s){this.notebook=c,this._extHostDocument=g,this._cellData=s,this.handle=s.handle,this.uri=w.URI.revive(s.uri),this.cellKind=s.cellKind,this._outputs=s.outputs.map(B.NotebookCellOutput.to),this._internalMetadata=s.internalMetadata??{},this._metadata=Object.freeze(s.metadata??{}),this._previousResult=Object.freeze(B.NotebookCellExecutionSummary.to(s.internalMetadata??{}))}static asModelAddData(c,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:c}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const c=this,g=this._extHostDocument.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return c.notebook.getCellIndex(c)},notebook:c.notebook.apiNotebook,kind:B.NotebookCellKind.to(this._cellData.cellKind),document:g.document,get mime(){return c._mime},set mime(s){c._mime=s},get outputs(){return c._outputs.slice(0)},get metadata(){return c._metadata},get executionSummary(){return c._previousResult}})}return this._apiCell}setOutputs(c){this._outputs=c.map(B.NotebookCellOutput.to)}setOutputItems(c,g,s){const n=s.map(B.NotebookCellOutputItem.to),h=this._outputs.find(_=>_.id===c);h&&(g||(h.items.length=0),h.items.push(...n))}setMetadata(c){this._metadata=Object.freeze(c)}setInternalMetadata(c){this._internalMetadata=c,this._previousResult=Object.freeze(B.NotebookCellExecutionSummary.to(c))}setMime(c){}}e.ExtHostCell=F;class N{constructor(c,g,s,n,h,_){this._proxy=c,this._textDocumentsAndEditors=g,this._textDocuments=s,this._emitter=n,this.uri=h,this.handle=N._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=_.viewType,this._metadata=Object.freeze(_.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,_.cells]],!0,void 0),this._versionId=_.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const c=this;this._notebook={get uri(){return c.uri},get version(){return c._versionId},get notebookType(){return c._notebookType},get isDirty(){return c._isDirty},get isUntitled(){return c.uri.scheme===o.Schemas.untitled},get isClosed(){return c._disposed},get metadata(){return c._metadata},get cellCount(){return c._cells.length},cellAt(g){return g=c._validateIndex(g),c._cells[g].apiCell},getCells(g){return(g?c._getCells(g):c._cells).map(n=>n.apiCell)},save(){return c._save()}}}return this._notebook}updateBackup(c){this._backup?.delete(),this._backup=c}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(c){c.metadata&&(this._metadata=Object.freeze({...this._metadata,...c.metadata}))}acceptDirty(c){this._isDirty=c}acceptModelChanged(c,g,s){this._versionId=c.versionId,this._isDirty=g,this.acceptDocumentPropertiesChanged({metadata:s});const n={notebook:this.apiNotebook,metadata:s,cellChanges:[],contentChanges:[]},h=[];for(const y of c.rawEvents)y.kind===A.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(y.changes,!1,n.contentChanges):y.kind===A.NotebookCellsChangeType.Move?this._moveCell(y.index,y.newIdx,n.contentChanges):y.kind===A.NotebookCellsChangeType.Output?(this._setCellOutputs(y.index,y.outputs),h.push({cell:this._cells[y.index].apiCell,outputs:this._cells[y.index].apiCell.outputs})):y.kind===A.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(y.index,y.outputId,y.append,y.outputItems),h.push({cell:this._cells[y.index].apiCell,outputs:this._cells[y.index].apiCell.outputs})):y.kind===A.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(y.index,y.language):y.kind===A.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(y.index,y.mime):y.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(y.index,y.metadata),h.push({cell:this._cells[y.index].apiCell,metadata:this._cells[y.index].apiCell.metadata})):y.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(y.index,y.internalMetadata),h.push({cell:this._cells[y.index].apiCell,executionSummary:this._cells[y.index].apiCell.executionSummary}));const _=new Map;for(let y=0;y<h.length;y++){const d=h[y],p=_.get(d.cell);if(p===void 0){const E=n.cellChanges.push({executionSummary:void 0,metadata:void 0,outputs:void 0,...d});_.set(d.cell,E-1)}else n.cellChanges[p]={...n.cellChanges[p],...d}}return n}_validateIndex(c){return c=c|0,c<0?0:c>=this._cells.length?this._cells.length-1:c}_validateRange(c){let g=c.start|0,s=c.end|0;return g<0&&(g=0),s>this._cells.length&&(s=this._cells.length),c.with({start:g,end:s})}_getCells(c){c=this._validateRange(c);const g=[];for(let s=c.start;s<c.end;s++)g.push(this._cells[s]);return g}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(c,g,s){if(this._disposed)return;const n=[],h=[],_=[];if(c.reverse().forEach(y=>{const p=y[2].map(T=>{const r=new F(this,this._textDocumentsAndEditors,T);return g||h.push(F.asModelAddData(this.apiNotebook,T)),r}),E=new D(y[0],y[1],[],p),a=this._cells.splice(y[0],y[1],...p);for(const T of a)_.push(T.uri),E.deletedItems.push(T.apiCell);n.push(E)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:_}),s)for(let y of n)s.push(y.asApiEvent());g||this._emitter.emitModelChange((0,k.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(n)}))}_moveCell(c,g,s){const n=this._cells.splice(c,1);this._cells.splice(g,0,...n);const h=[new D(c,1,n.map(_=>_.apiCell),[]),new D(g,0,[],n)];for(const _ of h)s.push(_.asApiEvent());this._emitter.emitModelChange((0,k.deepFreeze)({document:this.apiNotebook,changes:D.asApiEvents(h)}))}_setCellOutputs(c,g){const s=this._cells[c];s.setOutputs(g),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.apiNotebook,cells:[s.apiCell]}))}_setCellOutputItems(c,g,s,n){const h=this._cells[c];h.setOutputItems(g,s,n),this._emitter.emitCellOutputsChange((0,k.deepFreeze)({document:this.apiNotebook,cells:[h.apiCell]}))}_changeCellLanguage(c,g){const s=this._cells[c];s.apiCell.document.languageId!==g&&this._textDocuments.$acceptModelLanguageChanged(s.uri,g)}_changeCellMime(c,g){const s=this._cells[c];s.apiCell.mime=g}_changeCellMetadata(c,g){const s=this._cells[c],n=s.apiCell.metadata;s.setMetadata(g);const h=s.apiCell.metadata;(0,k.equals)(n,h)||this._emitter.emitCellMetadataChange((0,k.deepFreeze)({document:this.apiNotebook,cell:s.apiCell}))}_changeCellInternalMetadata(c,g){this._cells[c].setInternalMetadata(g)}getCellFromApiCell(c){return this._cells.find(g=>g.apiCell===c)}getCellFromIndex(c){return this._cells[c]}getCell(c){return this._cells.find(g=>g.handle===c)}getCellIndex(c){return this._cells.indexOf(c)}}e.ExtHostNotebookDocument=N,N._handlePool=0}),define(we[89],be([1,0,6,8,15]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class B{constructor(D){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=D}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(D){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:D})}replaceCellMetadata(D,F){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:D,metadata:F})}replaceCells(D,F,N){this._throwIfFinalized(),!(D===F&&N.length===0)&&this._collectedEdits.push({editType:1,index:D,count:F-D,cells:N.map(k.NotebookCellData.from)})}}class C{constructor(D,F,N,b,c,g){this.id=D,this._proxy=F,this.notebookData=N,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=c,this._visibleRanges=b,this._viewColumn=g}get apiEditor(){if(!this._editor){const D=this;this._editor={get document(){return D.notebookData.apiNotebook},get selections(){return D._selections},set selections(F){if(!Array.isArray(F)||!F.every(o.NotebookRange.isNotebookRange))throw(0,w.illegalArgument)("selections");D._selections=F,D._trySetSelections(F)},get visibleRanges(){return D._visibleRanges},revealRange(F,N){D._proxy.$tryRevealRange(D.id,k.NotebookRange.from(F),N??o.NotebookEditorRevealType.Default)},get viewColumn(){return D._viewColumn},edit(F){const N=new B(this.document.version);return F(N),D._applyEdit(N.finalize())},setDecorations(F,N){return D.setDecorations(F,N)}},C.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(D){this._visible=D}_acceptVisibleRanges(D){this._visibleRanges=D}_acceptSelections(D){this._selections=D}_trySetSelections(D){this._proxy.$trySetSelections(this.id,D.map(k.NotebookRange.from))}_acceptViewColumn(D){this._viewColumn=D}_applyEdit(D){if(D.cellEdits.length===0)return Promise.resolve(!0);const F=[];let N=-1;for(let b=0;b<D.cellEdits.length;b++){if(N<0){F.push(D.cellEdits[b]),N++;continue}const g=F[N],s=D.cellEdits[b];if(g.editType===1&&s.editType===1&&g.index===s.index){g.cells.push(...D.cellEdits[b].cells),g.count+=D.cellEdits[b].count;continue}F.push(D.cellEdits[b]),N++}return this._proxy.$tryApplyEdits(this.id,D.documentVersionId,F)}setDecorations(D,F){if(!(F.isEmpty&&!this._hasDecorationsForKey.has(D.key)))return F.isEmpty?this._hasDecorationsForKey.delete(D.key):this._hasDecorationsForKey.add(D.key),this._proxy.$trySetDecorations(this.id,k.NotebookRange.from(F),D.key)}}e.ExtHostNotebookEditor=C,C.apiEditorsToExtHost=new WeakMap}),define(we[170],be([1,0,8,141,124,20,52,15]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(c){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=c}async withProgress(c,g,s){const n=this._handles++,{title:h,location:_,cancellable:y}=g,d={label:(0,w.localize)(0,null,c.displayName||c.name),id:c.identifier.value};return this._proxy.$startProgress(n,{location:o.ProgressLocation.from(_),title:h,source:d,cancellable:y},c.isUnderDevelopment?void 0:c.identifier.value).catch(A.onUnexpectedExternalError),this._withProgress(n,s,!!y)}_withProgress(c,g,s){let n;s&&(n=new B.CancellationTokenSource,this._mapHandleToCancellationSource.set(c,n));const h=y=>{this._proxy.$progressEnd(y),this._mapHandleToCancellationSource.delete(y),n&&n.dispose()};let _;try{_=g(new N(this._proxy,c),s&&n?n.token:B.CancellationToken.None)}catch(y){throw h(c),y}return _.then(y=>h(c),y=>h(c)),_}$acceptProgressCanceled(c){const g=this._mapHandleToCancellationSource.get(c);g&&(g.cancel(),this._mapHandleToCancellationSource.delete(c))}}e.ExtHostProgress=D;function F(b,c){return b.message=c.message,typeof c.increment=="number"&&(typeof b.increment=="number"?b.increment+=c.increment:b.increment=c.increment),b}class N extends k.Progress{constructor(c,g){super(s=>this.throttledReport(s));this._proxy=c,this._handle=g}throttledReport(c){this._proxy.$progressReport(this._handle,c)}}Fe([(0,C.throttle)(100,(b,c)=>F(b,c),()=>Object.create(null))],N.prototype,"throttledReport",null)}),define(we[90],be([1,0,42,15,53,8,6]),function(Z,e,o,k,w,B,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class A{constructor(c,g,s){const n=A._Keys.nextId();c.$registerTextEditorDecorationType(g.identifier,n,B.DecorationRenderOptions.from(s)),this.value=Object.freeze({key:n,dispose(){c.$removeTextEditorDecorationType(n)}})}}e.TextEditorDecorationType=A,A._Keys=new w.IdGenerator("TextEditorDecorationType");class D{constructor(c,g){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=c,this._documentVersionId=c.version,this._undoStopBefore=g.undoStopBefore,this._undoStopAfter=g.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(c,g){this._throwIfFinalized();let s=null;if(c instanceof C.Position)s=new C.Range(c,c);else if(c instanceof C.Range)s=c;else throw new Error("Unrecognized location");this._pushEdit(s,g,!1)}insert(c,g){this._throwIfFinalized(),this._pushEdit(new C.Range(c,c),g,!0)}delete(c){this._throwIfFinalized();let g=null;if(c instanceof C.Range)g=c;else throw new Error("Unrecognized location");this._pushEdit(g,null,!0)}_pushEdit(c,g,s){const n=this._document.validateRange(c);this._collectedEdits.push({range:n,text:g,forceMoveMarkers:s})}setEndOfLine(c){if(this._throwIfFinalized(),c!==C.EndOfLine.LF&&c!==C.EndOfLine.CRLF)throw(0,k.illegalArgument)("endOfLine");this._setEndOfLine=c}}e.TextEditorEdit=D;class F{constructor(c,g,s,n){this._proxy=c,this._id=g,this._accept(s),this._logService=n;const h=this;this.value={get tabSize(){return h._tabSize},set tabSize(_){h._setTabSize(_)},get insertSpaces(){return h._insertSpaces},set insertSpaces(_){h._setInsertSpaces(_)},get cursorStyle(){return h._cursorStyle},set cursorStyle(_){h._setCursorStyle(_)},get lineNumbers(){return h._lineNumbers},set lineNumbers(_){h._setLineNumbers(_)}}}_accept(c){this._tabSize=c.tabSize,this._insertSpaces=c.insertSpaces,this._cursorStyle=c.cursorStyle,this._lineNumbers=B.TextEditorLineNumbersStyle.to(c.lineNumbers)}_validateTabSize(c){if(c==="auto")return"auto";if(typeof c=="number"){const g=Math.floor(c);return g>0?g:null}if(typeof c=="string"){const g=parseInt(c,10);return isNaN(g)?null:g>0?g:null}return null}_setTabSize(c){const g=this._validateTabSize(c);if(g!==null){if(typeof g=="number"){if(this._tabSize===g)return;this._tabSize=g}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:g}))}}_validateInsertSpaces(c){return c==="auto"?"auto":c==="false"?!1:Boolean(c)}_setInsertSpaces(c){const g=this._validateInsertSpaces(c);if(typeof g=="boolean"){if(this._insertSpaces===g)return;this._insertSpaces=g}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:g}))}_setCursorStyle(c){this._cursorStyle!==c&&(this._cursorStyle=c,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:c})))}_setLineNumbers(c){this._lineNumbers!==c&&(this._lineNumbers=c,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:B.TextEditorLineNumbersStyle.from(c)})))}assign(c){const g={};let s=!1;if(typeof c.tabSize!="undefined"){const n=this._validateTabSize(c.tabSize);n==="auto"?(s=!0,g.tabSize=n):typeof n=="number"&&this._tabSize!==n&&(this._tabSize=n,s=!0,g.tabSize=n)}if(typeof c.insertSpaces!="undefined"){const n=this._validateInsertSpaces(c.insertSpaces);n==="auto"?(s=!0,g.insertSpaces=n):this._insertSpaces!==n&&(this._insertSpaces=n,s=!0,g.insertSpaces=n)}typeof c.cursorStyle!="undefined"&&this._cursorStyle!==c.cursorStyle&&(this._cursorStyle=c.cursorStyle,s=!0,g.cursorStyle=c.cursorStyle),typeof c.lineNumbers!="undefined"&&this._lineNumbers!==c.lineNumbers&&(this._lineNumbers=c.lineNumbers,s=!0,g.lineNumbers=B.TextEditorLineNumbersStyle.from(c.lineNumbers)),s&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,g))}_warnOnError(c,g){g.catch(s=>{this._logService.warn(`ExtHostTextEditorOptions '${c}' failed:'`),this._logService.warn(s)})}}e.ExtHostTextEditorOptions=F;class N{constructor(c,g,s,n,h,_,y,d){this.id=c,this._proxy=g,this._logService=s,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=h,this._options=new F(this._proxy,this.id,_,s),this._visibleRanges=y,this._viewColumn=d;const p=this;this.value=Object.freeze({get document(){return n.getValue()},set document(E){throw(0,k.readonly)("document")},get selection(){return p._selections&&p._selections[0]},set selection(E){if(!(E instanceof C.Selection))throw(0,k.illegalArgument)("selection");p._selections=[E],p._trySetSelection()},get selections(){return p._selections},set selections(E){if(!Array.isArray(E)||E.some(a=>!(a instanceof C.Selection)))throw(0,k.illegalArgument)("selections");p._selections=E,p._trySetSelection()},get visibleRanges(){return p._visibleRanges},set visibleRanges(E){throw(0,k.readonly)("visibleRanges")},get options(){return p._options.value},set options(E){p._disposed||p._options.assign(E)},get viewColumn(){return p._viewColumn},set viewColumn(E){throw(0,k.readonly)("viewColumn")},edit(E,a={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const T=new D(n.getValue(),a);return E(T),p._applyEdit(T)},insertSnippet(E,a,T={undoStopBefore:!0,undoStopAfter:!0}){if(p._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!a||Array.isArray(a)&&a.length===0)r=p._selections.map(i=>B.Range.from(i));else if(a instanceof C.Position){const{lineNumber:i,column:u}=B.Position.from(a);r=[{startLineNumber:i,startColumn:u,endLineNumber:i,endColumn:u}]}else if(a instanceof C.Range)r=[B.Range.from(a)];else{r=[];for(const i of a)if(i instanceof C.Range)r.push(B.Range.from(i));else{const{lineNumber:u,column:t}=B.Position.from(i);r.push({startLineNumber:u,startColumn:t,endLineNumber:u,endColumn:t})}}return g.$tryInsertSnippet(c,E.value,r,T)},setDecorations(E,a){const T=a.length===0;T&&!p._hasDecorationsForKey.has(E.key)||(T?p._hasDecorationsForKey.delete(E.key):p._hasDecorationsForKey.add(E.key),p._runOnProxy(()=>{if(B.isDecorationOptionsArr(a))return g.$trySetDecorations(c,E.key,B.fromRangeOrRangeWithMessage(a));{const r=new Array(4*a.length);for(let i=0,u=a.length;i<u;i++){const t=a[i];r[4*i]=t.start.line+1,r[4*i+1]=t.start.character+1,r[4*i+2]=t.end.line+1,r[4*i+3]=t.end.character+1}return g.$trySetDecorationsFast(c,E.key,r)}}))},revealRange(E,a){p._runOnProxy(()=>g.$tryRevealRange(c,B.Range.from(E),a||C.TextEditorRevealType.Default))},show(E){g.$tryShowEditor(c,B.ViewColumn.from(E))},hide(){g.$tryHideEditor(c)}})}dispose(){(0,o.ok)(!this._disposed),this._disposed=!0}_acceptOptions(c){(0,o.ok)(!this._disposed),this._options._accept(c)}_acceptVisibleRanges(c){(0,o.ok)(!this._disposed),this._visibleRanges=c}_acceptViewColumn(c){(0,o.ok)(!this._disposed),this._viewColumn=c}_acceptSelections(c){(0,o.ok)(!this._disposed),this._selections=c}async _trySetSelection(){const c=this._selections.map(B.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,c)),this.value}_applyEdit(c){const g=c.finalize();if(g.edits.length===0&&!g.setEndOfLine)return Promise.resolve(!0);const s=g.edits.map(h=>h.range);s.sort((h,_)=>h.end.line===_.end.line?h.end.character===_.end.character?h.start.line===_.start.line?h.start.character-_.start.character:h.start.line-_.start.line:h.end.character-_.end.character:h.end.line-_.end.line);for(let h=0,_=s.length-1;h<_;h++){const y=s[h].end;if(s[h+1].start.isBefore(y))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=g.edits.map(h=>({range:B.Range.from(h.range),text:h.text,forceMoveMarkers:h.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,g.documentVersionId,n,{setEndOfLine:typeof g.setEndOfLine=="number"?B.EndOfLine.from(g.setEndOfLine):void 0,undoStopBefore:g.undoStopBefore,undoStopAfter:g.undoStopAfter})}_runOnProxy(c){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):c().then(()=>this,g=>(g instanceof Error&&g.name==="DISPOSED"||this._logService.warn(g),null))}}e.ExtHostTextEditor=N}),define(we[171],be([1,0,13,5,7,11,47,8,62,63,48]),function(Z,e,o,k,w,B,C,A,D,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class b extends w.Disposable{constructor(g){super();this.controllerId=g,this.debounceSendDiff=this._register(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new k.Emitter),this.root=new C.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(g){this._resolveHandler=g;for(const s of this.tree.values())this.updateExpandability(s)}collectDiff(){const g=this.diff;return this.diff=[],g}pushDiff(g){const s=this.diff[this.diff.length-1];if(s&&g.op===1){if(s.op===1&&s.item.extId===g.item.extId){(0,D.applyTestItemUpdate)(s.item,g.item);return}if(s.op===0&&s.item.item.extId===g.item.extId){(0,D.applyTestItemUpdate)(s.item,g.item);return}}this.diff.push(g),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(g,s){const n=this.tree.get(g);if(!!n){if((n.expandLevels===void 0||s>n.expandLevels)&&(n.expandLevels=s),n.expand===1){const h=this.resolveChildren(n);return h.isOpen()?this.expandChildren(n,s-1):h.wait().then(()=>this.expandChildren(n,s-1))}else if(n.expand===3)return n.resolveBarrier?.isOpen()===!1?n.resolveBarrier.wait().then(()=>this.expandChildren(n,s-1)):this.expandChildren(n,s-1)}}dispose(){for(const g of this.tree.values())(0,C.getPrivateApiFor)(g.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(g,s){switch(s.op){case 2:this.pushDiff({op:4,itemId:g.fullId.toString()});break;case 1:this.removeItem(F.TestId.joinToString(g.fullId,s.id));break;case 0:this.upsertItem(s.item,g);break;case 4:for(const n of s.ops)this.onTestItemEvent(g,n);break;case 3:{const{key:n,value:h,previous:_}=s,y=g.fullId.toString();switch(n){case"canResolveChildren":this.updateExpandability(g);break;case"tags":this.diffTagRefs(h,_,y);break;case"range":this.pushDiff({op:1,item:{extId:y,item:{range:N.Range.lift(A.Range.from(h))}}});break;case"error":this.pushDiff({op:1,item:{extId:y,item:{error:A.MarkdownString.fromStrict(h)||null}}});break;default:this.pushDiff({op:1,item:{extId:y,item:{[n]:h??null}}});break}break}default:(0,B.assertNever)(s)}}upsertItem(g,s){if(!(g instanceof C.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${g.id} did not`);const n=F.TestId.fromExtHostTestItem(g,this.root.id,s?.actual),h=(0,C.getPrivateApiFor)(g);h.parent&&h.parent!==s?.actual&&h.parent.children.delete(g.id);let _=this.tree.get(n.toString());if(!_){_={fullId:n,actual:g,parent:s?n.parentId:null,expandLevels:s?.expandLevels?s.expandLevels-1:void 0,expand:0},g.tags.forEach(this.incrementTagRefs,this),this.tree.set(_.fullId.toString(),_),this.setItemParent(g,s),this.pushDiff({op:0,item:{parent:_.parent&&_.parent.toString(),controllerId:this.controllerId,expand:_.expand,item:A.TestItem.from(g)}}),this.connectItemAndChildren(g,_,s);return}if(_.actual===g){this.connectItem(g,_,s);return}const y=_.actual.children,d=_.actual,p=(0,C.diffTestItems)(d,g);(0,C.getPrivateApiFor)(d).listener=void 0,_.actual=g,_.expand=0;for(const[E,a]of p)this.onTestItemEvent(_,{op:3,key:E,value:a,previous:d[E]});this.connectItemAndChildren(g,_,s);for(const E of y)g.children.get(E.id)||this.removeItem(F.TestId.joinToString(n,E.id))}diffTagRefs(g,s,n){const h=new Set(s.map(_=>_.id));for(const _ of g)h.delete(_.id)||this.incrementTagRefs(_);this.pushDiff({op:1,item:{extId:n,item:{tags:g.map(_=>A.TestTag.namespace(this.controllerId,_.id))}}}),h.forEach(this.decrementTagRefs,this)}incrementTagRefs(g){const s=this.tags.get(g.id);s?s.refCount++:(this.tags.set(g.id,{refCount:1}),this.pushDiff({op:5,tag:{id:A.TestTag.namespace(this.controllerId,g.id),ctrlLabel:this.root.label}}))}decrementTagRefs(g){const s=this.tags.get(g);s&&!--s.refCount&&(this.tags.delete(g),this.pushDiff({op:6,id:(0,D.namespaceTestTag)(this.controllerId,g)}))}setItemParent(g,s){(0,C.getPrivateApiFor)(g).parent=s&&s.actual!==this.root?s.actual:void 0}connectItem(g,s,n){this.setItemParent(g,n);const h=(0,C.getPrivateApiFor)(g);h.parent=n?.actual,h.listener=_=>this.onTestItemEvent(s,_),this.updateExpandability(s)}connectItemAndChildren(g,s,n){this.connectItem(g,s,n);for(const h of g.children)this.upsertItem(h,s)}updateExpandability(g){let s;this._resolveHandler?g.resolveBarrier?s=g.resolveBarrier.isOpen()?3:2:s=g.actual.canResolveChildren?1:0:s=0,s!==g.expand&&(g.expand=s,this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:s}}),s===1&&g.expandLevels!==void 0&&this.resolveChildren(g))}expandChildren(g,s){if(s<0)return;const n=[];for(const h of g.actual.children){const _=this.expand(F.TestId.joinToString(g.fullId,h.id),s);(0,o.isThenable)(_)&&n.push(_)}if(n.length)return Promise.all(n).then(()=>{})}resolveChildren(g){if(g.resolveBarrier)return g.resolveBarrier;if(!this._resolveHandler){const _=new o.Barrier;return _.open(),_}g.expand=2,this.pushExpandStateUpdate(g);const s=g.resolveBarrier=new o.Barrier,n=_=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),g.actual!==this.root&&(g.actual.error=_.stack||_.message||String(_))};let h;try{h=this._resolveHandler(g.actual===this.root?void 0:g.actual)}catch(_){n(_)}return(0,o.isThenable)(h)?h.catch(n).then(()=>{s.open(),this.updateExpandability(g)}):(s.open(),this.updateExpandability(g)),g.resolveBarrier}pushExpandStateUpdate(g){this.pushDiff({op:1,item:{extId:g.fullId.toString(),expand:g.expand}})}removeItem(g){const s=this.tree.get(g);if(!s)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:g});const n=[s];for(;n.length;){const h=n.pop();if(!!h){(0,C.getPrivateApiFor)(h.actual).listener=void 0;for(const _ of h.actual.tags)this.decrementTagRefs(_.id);this.tree.delete(h.fullId.toString());for(const _ of h.actual.children)n.push(this.tree.get(F.TestId.joinToString(h.fullId,_.id)))}}}flushDiff(){const g=this.collectDiff();g.length&&this.diffOpEmitter.fire(g)}}e.SingleUseTestCollection=b}),define(we[172],be([1,0,3,138]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(k.IEnvironmentService)}),define(we[173],be([1,0,26,5,17]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class B{constructor(N){this.removedDueToLooping=N}}e.DeltaExtensionsResult=B;class C{constructor(N){this._onDidChange=new k.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=N,this._initialize()}_initialize(){this._extensionDescriptions.sort(D),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const N of this._extensionDescriptions){if(this._extensionsMap.has(o.ExtensionIdentifier.toKey(N.identifier))){console.error("Extension `"+N.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(o.ExtensionIdentifier.toKey(N.identifier),N),this._extensionsArr.push(N),Array.isArray(N.activationEvents))for(let b of N.activationEvents)b==="onUri"&&(b=`onUri:${o.ExtensionIdentifier.toKey(N.identifier)}`),this._activationMap.has(b)||this._activationMap.set(b,[]),this._activationMap.get(b).push(N)}}keepOnly(N){const b=new Set;N.forEach(c=>b.add(o.ExtensionIdentifier.toKey(c))),this._extensionDescriptions=this._extensionDescriptions.filter(c=>b.has(o.ExtensionIdentifier.toKey(c.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(N,b){N.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(N));const c=C._findLoopingExtensions(this._extensionDescriptions);if(b=b.concat(c.map(g=>g.identifier)),b.length>0){const g=new Set;b.forEach(s=>g.add(o.ExtensionIdentifier.toKey(s))),this._extensionDescriptions=this._extensionDescriptions.filter(s=>!g.has(o.ExtensionIdentifier.toKey(s.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new B(c)}static _findLoopingExtensions(N){const b=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(h){this._nodesSet.has(h)||(this._nodesSet.add(h),this._nodesArr.push(h))}addArc(h,_){this.addNode(h),this.addNode(_),this._arcs.has(h)?this._arcs.get(h).push(_):this._arcs.set(h,[_])}getArcs(h){return this._arcs.has(h)?this._arcs.get(h):[]}hasOnlyGoodArcs(h,_){const y=b.getArcs(h);for(let d=0;d<y.length;d++)if(!_.has(y[d]))return!1;return!0}getNodes(){return this._nodesArr}};let c=new Map;for(let h of N){const _=o.ExtensionIdentifier.toKey(h.identifier);if(c.set(_,h),h.extensionDependencies)for(let y of h.extensionDependencies){const d=o.ExtensionIdentifier.toKey(y);b.addArc(_,d)}}let g=new Set;b.getNodes().filter(h=>b.getArcs(h).length===0).forEach(h=>g.add(h));let s=b.getNodes().filter(h=>!g.has(h)),n;do{n=!1;for(let h=0;h<s.length;h++){const _=s[h];b.hasOnlyGoodArcs(_,g)&&(s.splice(h,1),h--,g.add(_),n=!0)}}while(n);return s.map(h=>c.get(h))}containsActivationEvent(N){return this._activationMap.has(N)}containsExtension(N){return this._extensionsMap.has(o.ExtensionIdentifier.toKey(N))}getExtensionDescriptionsForActivationEvent(N){const b=this._activationMap.get(N);return b?b.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(N){const b=this._extensionsMap.get(o.ExtensionIdentifier.toKey(N));return b||void 0}}e.ExtensionDescriptionRegistry=C;var A;(function(F){F[F.Builtin=0]="Builtin",F[F.User=1]="User",F[F.Dev=2]="Dev"})(A||(A={}));function D(F,N){const b=F.isBuiltin?0:F.isUnderDevelopment?2:1,c=N.isBuiltin?0:N.isUnderDevelopment?2:1;if(b!==c)return b-c;const g=w.posix.basename(F.extensionLocation.path),s=w.posix.basename(N.extensionLocation.path);return g<s?-1:g>s?1:0}}),define(we[91],be([1,0,21]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var k;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(k=e.UIKind||(e.UIKind={}));var w;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(w=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var B;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(B=e.MessageType||(e.MessageType={}));function C(D){const F=o.VSBuffer.alloc(1);switch(D){case 0:F.writeUInt8(1,0);break;case 1:F.writeUInt8(2,0);break;case 2:F.writeUInt8(3,0);break}return F}e.createMessageOfType=C;function A(D,F){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return F===0;case 2:return F===1;case 3:return F===2;default:return!1}}e.isMessageOfType=A}),define(we[28],be([1,0,5,2,3,26,144]),function(Z,e,o,k,w,B,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.extensionRunningLocationToString=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new B.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:k.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,w.createDecorator)("extensionService");var A;(function(p){p[p.None=0]="None",p[p.LocalProcess=1]="LocalProcess",p[p.LocalWebWorker=2]="LocalWebWorker",p[p.Remote=3]="Remote"})(A=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));function D(p){switch(p){case 0:return"None";case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionRunningLocationToString=D;class F{constructor(E){this.dependency=E}}e.MissingExtensionDependency=F;var N;(function(p){p[p.LocalProcess=0]="LocalProcess",p[p.LocalWebWorker=1]="LocalWebWorker",p[p.Remote=2]="Remote"})(N=e.ExtensionHostKind||(e.ExtensionHostKind={}));function b(p){switch(p){case 0:return"LocalProcess";case 1:return"LocalWebWorker";case 2:return"Remote"}}e.extensionHostKindToString=b;function c(p,E){return p.enabledApiProposals?p.enabledApiProposals.includes(E):!1}e.isProposedApiEnabled=c;function g(p,E){if(!c(p,E))throw new Error(`Extension '${p.identifier.value}' CANNOT use API proposal: ${E}.
Its package.json#enabledApiProposals-property declares: ${p.enabledApiProposals?.join(", ")??"[]"} but NOT ${E}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${p.identifier.value}`)}e.checkProposedApiEnabled=g;class s{constructor(E,a,T,r){this.codeLoadingTime=E,this.activateCallTime=a,this.activateResolvedTime=T,this.activationReason=r}}e.ActivationTimes=s;class n{constructor(E,a){this.description=E,this.value=a}}e.ExtensionPointContribution=n,e.ExtensionHostLogFileName="exthost";var h;(function(p){p[p.Normal=0]="Normal",p[p.Immediate=1]="Immediate"})(h=e.ActivationKind||(e.ActivationKind={}));function _(p){return{type:p.isBuiltin?0:1,isBuiltin:p.isBuiltin||p.isUserBuiltin,identifier:{id:(0,C.getGalleryExtensionId)(p.publisher,p.name),uuid:p.uuid},manifest:p,location:p.extensionLocation}}e.toExtension=_;function y(p,E){return{identifier:new B.ExtensionIdentifier((0,C.getExtensionId)(p.manifest.publisher,p.manifest.name)),isBuiltin:p.type===0,isUserBuiltin:p.type===1&&p.isBuiltin,isUnderDevelopment:!!E,extensionLocation:p.location,...p.manifest,uuid:p.identifier.uuid}}e.toExtensionDescription=y;class d{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None}activateByEvent(E){return Promise.resolve(void 0)}activationEventIsDone(E){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(E){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(E){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(E){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(E,a){return Promise.resolve()}}e.NullExtensionService=d}),define(we[174],be([1,0,15,26,28,12]),function(Z,e,o,k,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const C=Promise.resolve(void 0);class A{constructor(n,h,_,y){this.startup=n,this.codeLoadingTime=h,this.activateCallTime=_,this.activateResolvedTime=y}}e.ExtensionActivationTimes=A,A.NONE=new A(!1,-1,-1,-1);class D{constructor(n){this._startup=n,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(n,h){return n===-1||h===-1?-1:h-n}build(){return new A(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=D;class F{constructor(n,h,_,y,d,p){this.activationFailed=n,this.activationFailedError=h,this.activationTimes=_,this.module=y,this.exports=d,this.subscriptions=p}}e.ActivatedExtension=F;class N extends F{constructor(n){super(!1,null,n,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=N;class b extends F{constructor(){super(!1,null,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=b;class c extends F{constructor(n){super(!0,n,A.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=c;let g=class{constructor(n,h,_,y,d){this._logService=d,this._isDisposed=!1,this._registry=n,this._resolvedExtensionsSet=new Set,h.forEach(p=>this._resolvedExtensionsSet.add(k.ExtensionIdentifier.toKey(p))),this._externalExtensionsMap=new Map,_.forEach(p=>this._externalExtensionsMap.set(k.ExtensionIdentifier.toKey(p),p)),this._host=y,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){this._isDisposed=!0}isActivated(n){const h=k.ExtensionIdentifier.toKey(n);return this._activatedExtensions.has(h)}getActivatedExtension(n){const h=k.ExtensionIdentifier.toKey(n),_=this._activatedExtensions.get(h);if(!_)throw new Error("Extension `"+n.value+"` is not known or not activated");return _}activateByEvent(n,h){if(this._alreadyActivatedEvents[n])return C;const _=this._registry.getExtensionDescriptionsForActivationEvent(n);return this._activateExtensions(_.map(y=>({id:y.identifier,reason:{startup:h,extensionId:y.identifier,activationEvent:n}}))).then(()=>{this._alreadyActivatedEvents[n]=!0})}activateById(n,h){const _=this._registry.getExtensionDescription(n);if(!_)throw new Error("Extension `"+n+"` is not known");return this._activateExtensions([{id:_.identifier,reason:h}])}_handleActivateRequest(n,h,_){if(this._externalExtensionsMap.has(k.ExtensionIdentifier.toKey(n.id))){h[k.ExtensionIdentifier.toKey(n.id)]=n;return}const y=this._registry.getExtensionDescription(n.id);if(!y){const E=new Error(`Cannot activate unknown extension '${n.id.value}'`);this._host.onExtensionActivationError(n.id,E,new w.MissingExtensionDependency(n.id.value)),this._activatedExtensions.set(k.ExtensionIdentifier.toKey(n.id),new c(E));return}const d=typeof y.extensionDependencies=="undefined"?[]:y.extensionDependencies;let p=!0;for(let E=0,a=d.length;E<a;E++){const T=d[E];if(this._resolvedExtensionsSet.has(k.ExtensionIdentifier.toKey(T)))continue;const r=this._activatedExtensions.get(k.ExtensionIdentifier.toKey(T));if(r&&!r.activationFailed)continue;if(r&&r.activationFailed){const l=y.displayName||y.identifier.value,m=this._registry.getExtensionDescription(T),f=m&&m.displayName||T,S=new Error(`Cannot activate the '${l}' extension because its dependency '${f}' failed to activate`);S.detail=r.activationFailedError,this._host.onExtensionActivationError(y.identifier,S,null),this._activatedExtensions.set(k.ExtensionIdentifier.toKey(y.identifier),new c(S));return}if(this._externalExtensionsMap.has(k.ExtensionIdentifier.toKey(T))){p=!1,h[k.ExtensionIdentifier.toKey(T)]={id:this._externalExtensionsMap.get(k.ExtensionIdentifier.toKey(T)),reason:n.reason};continue}const i=this._registry.getExtensionDescription(T);if(i){if(!i.main&&!i.browser)continue;p=!1,h[k.ExtensionIdentifier.toKey(T)]={id:i.identifier,reason:n.reason};continue}const u=y.displayName||y.identifier.value,t=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${T}'`);this._host.onExtensionActivationError(y.identifier,t,new w.MissingExtensionDependency(T)),this._activatedExtensions.set(k.ExtensionIdentifier.toKey(y.identifier),new c(t));return}p?h[k.ExtensionIdentifier.toKey(y.identifier)]=n:_.push(n)}_activateExtensions(n){if(n.length===0||(n=n.filter(d=>!this._activatedExtensions.has(k.ExtensionIdentifier.toKey(d.id))),n.length===0))return Promise.resolve(void 0);const h=Object.create(null),_=[];for(let d=0,p=n.length;d<p;d++)this._handleActivateRequest(n[d],h,_);for(let d=0,p=_.length;d<p;d++){const E=k.ExtensionIdentifier.toKey(_[d].id);h[E]&&delete h[E]}const y=Object.keys(h).map(d=>h[d]);return _.length===0?Promise.all(y.map(d=>this._activateExtension(d.id,d.reason))).then(d=>{}):this._activateExtensions(y).then(d=>this._activateExtensions(_))}_activateExtension(n,h){const _=k.ExtensionIdentifier.toKey(n);if(this._activatedExtensions.has(_))return Promise.resolve(void 0);const y=this._activatingExtensions.get(_);if(y)return y;const d=this._host.actualActivateExtension(n,h).then(void 0,p=>{const E=new Error;return p&&p.name&&(E.name=p.name),p&&p.message?E.message=`Activating extension '${n.value}' failed: ${p.message}.`:E.message=`Activating extension '${n.value}' failed: ${p}.`,p&&p.stack&&(E.stack=p.stack),this._isDisposed&&o.isCancellationError(p)?new c(p):(this._host.onExtensionActivationError(n,E,null),this._logService.error(`Activating extension ${n.value} failed due to an error:`),this._logService.error(p),new c(p))}).then(p=>{this._activatedExtensions.set(_,p),this._activatingExtensions.delete(_)});return this._activatingExtensions.set(_,d),d}};g=Fe([Ne(4,B.ILogService)],g),e.ExtensionsActivator=g}),define(we[175],be([1,0,12,27,28]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let B=class extends o.LogService{constructor(A,D){super(A.createLogger(D.logFile,{name:w.ExtensionHostLogFileName}))}};B=Fe([Ne(0,o.ILoggerService),Ne(1,k.IExtHostInitDataService)],B),e.ExtHostLogService=B}),define(we[176],be([1,0,15]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class k{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((B,C)=>{this._actualOk=B,this._actualErr=C,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(B){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=B,this._actual&&this._actualOk(B))}resolveErr(B){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=B,this._actual?this._actualErr(B):(0,o.onUnexpectedError)(B))}then(B,C){return this._ensureActual().then(B,C)}catch(B){return this._ensureActual().then(void 0,B)}finally(B){return this._ensureActual().finally(B)}}e.LazyPromise=k}),define(we[38],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++o.count}}e.ProxyIdentifier=o,o.count=0;const k=[];function w(A){const D=new o(A);return k[D.nid]=D,D}e.createProxyIdentifier=w;function B(A){return k[A].sid}e.getStringIdentifierForProxy=B;class C{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=C}),define(we[4],be([1,0,54,2,38]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabKind=e.TextEditorRevealType=void 0;var B;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(B=e.TextEditorRevealType||(e.TextEditorRevealType={}));var C;(function(y){y[y.Singular=0]="Singular",y[y.Diff=1]="Diff",y[y.SidebySide=2]="SidebySide",y[y.Other=3]="Other"})(C=e.TabKind||(e.TabKind={}));var A;(function(y){y[y.Editable=0]="Editable",y[y.SupportsHotExit=1]="SupportsHotExit"})(A=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var D;(function(y){y[y.Int8Array=1]="Int8Array",y[y.Uint8Array=2]="Uint8Array",y[y.Uint8ClampedArray=3]="Uint8ClampedArray",y[y.Int16Array=4]="Int16Array",y[y.Uint16Array=5]="Uint16Array",y[y.Int32Array=6]="Int32Array",y[y.Uint32Array=7]="Uint32Array",y[y.Float32Array=8]="Float32Array",y[y.Float64Array=9]="Float64Array",y[y.BigInt64Array=10]="BigInt64Array",y[y.BigUint64Array=11]="BigUint64Array"})(D=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var F;(function(y){y[y.Text=1]="Text",y[y.Error=2]="Error",y[y.Rich=3]="Rich"})(F=e.CellOutputKind||(e.CellOutputKind={}));var N;(function(y){y[y.Default=0]="Default",y[y.InCenter=1]="InCenter",y[y.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",y[y.AtTop=3]="AtTop"})(N=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var b;(function(y){y[y.None=0]="None",y[y.Process=1]="Process",y[y.Output=2]="Output"})(b=e.CandidatePortSource||(e.CandidatePortSource={}));class c{static mixin(d){return d._id=c._n++,d}}e.IdObject=c,c._n=0;var g;(function(y){y.label="a",y.kind="b",y.detail="c",y.documentation="d",y.sortText="e",y.filterText="f",y.preselect="g",y.insertText="h",y.insertTextRules="i",y.range="j",y.commitCharacters="k",y.additionalTextEdits="l",y.command="m",y.kindModifier="n"})(g=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var s;(function(y){y.defaultRanges="a",y.completions="b",y.isIncomplete="c",y.duration="d"})(s=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var n;(function(y){y[y.File=1]="File",y[y.Text=2]="Text",y[y.Cell=3]="Cell"})(n=e.WorkspaceEditType||(e.WorkspaceEditType={}));function h(y){if(y&&y.edits)for(const d of y.edits)typeof d.resource=="object"?d.resource=k.URI.revive(d.resource):(d.newUri=k.URI.revive(d.newUri),d.oldUri=k.URI.revive(d.oldUri)),d.metadata&&d.metadata.iconPath&&(d.metadata=(0,o.revive)(d.metadata));return y}e.reviveWorkspaceEditDto=h;var _;(function(y){y[y.Workspace=0]="Workspace",y[y.TextDocument=1]="TextDocument"})(_=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,w.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,w.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,w.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,w.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,w.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,w.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,w.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,w.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,w.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,w.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,w.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,w.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,w.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,w.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,w.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,w.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,w.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,w.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,w.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,w.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,w.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,w.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,w.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,w.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,w.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,w.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,w.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,w.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,w.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,w.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,w.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,w.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,w.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,w.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,w.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,w.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,w.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,w.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,w.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,w.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,w.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,w.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,w.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,w.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,w.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,w.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,w.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,w.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,w.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,w.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,w.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,w.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,w.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,w.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,w.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,w.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,w.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,w.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,w.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,w.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,w.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,w.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,w.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,w.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,w.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,w.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,w.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,w.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,w.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,w.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,w.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,w.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,w.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,w.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,w.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,w.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,w.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,w.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,w.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,w.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,w.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,w.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,w.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,w.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,w.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,w.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,w.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,w.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,w.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,w.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,w.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,w.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,w.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,w.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,w.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,w.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,w.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,w.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,w.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,w.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,w.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,w.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,w.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,w.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,w.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,w.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,w.createProxyIdentifier)("ExtHostTelemetry")}}),define(we[64],be([1,0,4,5,3]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class B{constructor(A){this._onDidChangePassword=new k.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=A.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this._onDidChangePassword.fire(A)}get(A,D){return this._proxy.$getPassword(A,D)}store(A,D,F){return this._proxy.$setPassword(A,D,F)}delete(A,D){return this._proxy.$deletePassword(A,D)}}e.ExtHostSecretState=B,e.IExtHostSecretState=(0,w.createDecorator)("IExtHostSecretState")}),define(we[65],be([1,0,3,12,4,14]),function(Z,e,o,k,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let C=class{constructor(D,F){this._extHostLogService=F,this._reportedUsages=new Set,this._telemetryShape=D.getProxy(w.MainContext.MainThreadTelemetry)}report(D,F,N){const b=this.getUsageKey(D,F);this._reportedUsages.has(b)||(this._reportedUsages.add(b),F.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${D}' is deprecated. ${N}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:F.identifier.value,apiId:D}))}getUsageKey(D,F){return`${D}-${F.identifier.value}`}};C=Fe([Ne(0,B.IExtHostRpcService),Ne(1,k.ILogService)],C),e.ExtHostApiDeprecationService=C,e.NullApiDeprecationService=Object.freeze(new class{report(A,D,F){}})}),define(we[177],be([1,0,5,4,6,26]),function(Z,e,o,k,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class C{constructor(D){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new o.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=D.getProxy(k.MainContext.MainThreadAuthentication)}$setProviders(D){return this._providers=D,Promise.resolve()}async getSession(D,F,N,b={}){const c=B.ExtensionIdentifier.toKey(D.identifier),g=this._inFlightRequests.get(c)||[],s=[...N].sort().join(" ");let n=g.find(h=>h.scopes===s);if(n)return n.result;{const h=this._getSession(D,c,F,N,b);n={scopes:s,result:h},g.push(n),this._inFlightRequests.set(c,g);try{await h}finally{const _=g.findIndex(y=>y.scopes===s);_>-1&&(g.splice(_),this._inFlightRequests.set(c,g))}return h}}async _getSession(D,F,N,b,c={}){await this._proxy.$ensureProvider(N);const g=D.displayName||D.name;return this._proxy.$getSession(N,b,F,g,c)}async removeSession(D,F){const N=this._authenticationProviders.get(D);return N?N.provider.removeSession(F):this._proxy.$removeSession(D,F)}registerAuthenticationProvider(D,F,N,b){if(this._authenticationProviders.get(D))throw new Error(`An authentication provider with id '${D}' is already registered.`);this._authenticationProviders.set(D,{label:F,provider:N,options:b??{supportsMultipleAccounts:!1}}),this._providers.find(g=>g.id===D)||this._providers.push({id:D,label:F});const c=N.onDidChangeSessions(g=>{this._proxy.$sendDidChangeSessions(D,{added:g.added??[],changed:g.changed??[],removed:g.removed??[]})});return this._proxy.$registerAuthenticationProvider(D,F,b?.supportsMultipleAccounts??!1),new w.Disposable(()=>{c.dispose(),this._authenticationProviders.delete(D);const g=this._providers.findIndex(s=>s.id===D);g>-1&&this._providers.splice(g),this._proxy.$unregisterAuthenticationProvider(D)})}$createSession(D,F){const N=this._authenticationProviders.get(D);if(N)return Promise.resolve(N.provider.createSession(F));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$removeSession(D,F){const N=this._authenticationProviders.get(D);if(N)return Promise.resolve(N.provider.removeSession(F));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$getSessions(D,F){const N=this._authenticationProviders.get(D);if(N)return Promise.resolve(N.provider.getSessions(F));throw new Error(`Unable to find authentication provider with handle: ${D}`)}$onDidChangeAuthenticationSessions(D,F){return this._onDidChangeSessions.fire({provider:{id:D,label:F}}),Promise.resolve()}}e.ExtHostAuthentication=C}),define(we[178],be([1,0,4,14,8]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let B=class{constructor(A,D){this._proxy=A.getProxy(o.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:F=>D.getDocument(F)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A){const D=w.WorkspaceEdit.from(A,this._versionInformationProvider);return this._proxy.$tryApplyWorkspaceEdit(D)}};B=Fe([Ne(0,k.IExtHostRpcService)],B),e.ExtHostBulkEdits=B}),define(we[179],be([1,0,4]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class k{constructor(B){const C=B.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return C.$readText()},writeText(A){return C.$writeText(A)}})}}e.ExtHostClipboard=k});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,o,k,w){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!w:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?w.call(Z,o):w?w.value=o:e.set(Z,o),o},De=this&&this.__classPrivateFieldGet||function(Z,e,o,k){if(o==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?k:o==="a"?k.call(Z):k?k.value:e.get(Z)};define(we[39],be([1,0,11,6,8,25,4,16,12,54,48,229,2,7,3,14,47,21,38,43]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_,y,d){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=class{constructor(t,l){p.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,Ve(this,p,t.getProxy(C.MainContext.MainThreadCommands),"f"),this._logService=l,this.converter=new a(this,m=>{const f=this._apiCommands.get(m);return f?.result===r.Void?f:void 0},l),this._argumentProcessors=[{processArgument(m){return(0,F.revive)(m)}},{processArgument(m){return(0,B.cloneAndChange)(m,function(f){if(N.Range.isIRange(f))return w.Range.to(f);if(b.Position.isIPosition(f))return w.Position.to(f);if(N.Range.isIRange(f.range)&&c.URI.isUri(f.uri))return w.location.to(f);if(f instanceof _.VSBuffer)return f.buffer.buffer;if(!Array.isArray(f))return f})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const l=this.registerCommand(!1,t.id,async(...m)=>{const f=t.args.map((P,$)=>{if(!P.validate(m[$]))throw new Error(`Invalid argument '${P.name}' when running '${t.id}', received: ${m[$]}`);return P.convert(m[$])}),S=await this.executeCommand(t.internalId,...f);return t.result.convert(S,m,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new k.Disposable(()=>{l.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,l,m,f,S,P){if(this._logService.trace("ExtHostCommands#registerCommand",l),!l.trim().length)throw new Error("invalid id");if(this._commands.has(l))throw new Error(`command '${l}' already exists`);return this._commands.set(l,{callback:m,thisArg:f,description:S,extension:P}),t&&De(this,p,"f").$registerCommand(l),new k.Disposable(()=>{this._commands.delete(l)&&t&&De(this,p,"f").$unregisterCommand(l)})}executeCommand(t,...l){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,l,!0)}async _doExecuteCommand(t,l,m){if(this._commands.has(t))return this._executeContributedCommand(t,l,!1);{let f=!1;const S=(0,B.cloneAndChange)(l,function(P){if(P instanceof k.Position)return w.Position.from(P);if(P instanceof k.Range)return w.Range.from(P);if(P instanceof k.Location)return w.location.from(P);if(k.NotebookRange.isNotebookRange(P))return w.NotebookRange.from(P);if(P instanceof ArrayBuffer)return f=!0,_.VSBuffer.wrap(new Uint8Array(P));if(P instanceof Uint8Array)return f=!0,_.VSBuffer.wrap(P);if(!Array.isArray(P))return P});try{const P=await De(this,p,"f").$executeCommand(t,f?new y.SerializableObjectWithBuffers(S):S,m);return(0,F.revive)(P)}catch(P){if(P instanceof Error&&P.message==="$executeCommand:retry")return this._doExecuteCommand(t,l,!1);throw P}}}async _executeContributedCommand(t,l,m){const f=this._commands.get(t);if(!f)throw new Error("Unknown command");let{callback:S,thisArg:P,description:$}=f;if($)for(let L=0;L<$.args.length;L++)try{(0,o.validateConstraint)(l[L],$.args[L].constraint)}catch{throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${$.args[L].name}' - ${$.args[L].description}`)}try{return await S.apply(P,l)}catch(L){if(t===this.converter.delegatingCommandId){const v=this.converter.getActualCommand(...l);v&&(t=v.command)}throw this._logService.error(L,t,f.extension?.identifier),m?new class extends Error{constructor(){super((0,d.toErrorMessage)(L));this.id=t,this.source=f.extension?.displayName??f.extension?.name}}:L}}$executeContributedCommand(t,...l){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(l=l.map(m=>this._argumentProcessors.reduce((f,S)=>S.processArgument(f),m)),this._executeContributedCommand(t,l,!0)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),De(this,p,"f").$getCommands().then(l=>(t&&(l=l.filter(m=>m[0]!=="_")),l))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[l,m]of this._commands){let{description:f}=m;f&&(t[l]=f)}return Promise.resolve(t)}};p=new WeakMap,E=Fe([Ne(0,n.IExtHostRpcService),Ne(1,D.ILogService)],E),e.ExtHostCommands=E,e.IExtHostCommands=(0,s.createDecorator)("IExtHostCommands");class a{constructor(t,l,m){this._commands=t,this._lookupApiCommand=l,this._logService=m,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,l){if(!t)return;const m={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return m;const f=this._lookupApiCommand(t.command);if(f)m.id=f.internalId,m.arguments=f.args.map((S,P)=>S.convert(t.arguments&&t.arguments[P]));else if((0,A.isNonEmptyArray)(t.arguments)){const S=++this._cachIdPool;this._cache.set(S,t),l.add((0,g.toDisposable)(()=>{this._cache.delete(S),this._logService.trace("CommandsConverter#DISPOSE",S)})),m.$ident=S,m.id=this.delegatingCommandId,m.arguments=[S],this._logService.trace("CommandsConverter#CREATE",t.command,S)}return m}fromInternal(t){return typeof t.$ident=="number"?this._cache.get(t.$ident):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const l=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],l?l.command:"MISSING"),l?this._commands.executeCommand(l.command,...l.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=a;class T{constructor(t,l,m,f){this.name=t,this.description=l,this.validate=m,this.convert=f}optional(){return new T(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,l){return new T(t??this.name,l??this.description,this.validate,this.convert)}}e.ApiCommandArgument=T,T.Uri=new T("uri","Uri of a text document",u=>c.URI.isUri(u),u=>u),T.Position=new T("position","A position in a text document",u=>k.Position.isPosition(u),w.Position.from),T.Range=new T("range","A range in a text document",u=>k.Range.isRange(u),w.Range.from),T.Selection=new T("selection","A selection in a text document",u=>k.Selection.isSelection(u),w.Selection.from),T.Number=new T("number","",u=>typeof u=="number",u=>u),T.String=new T("string","",u=>typeof u=="string",u=>u),T.CallHierarchyItem=new T("item","A call hierarchy item",u=>u instanceof k.CallHierarchyItem,w.CallHierarchyItem.from),T.TypeHierarchyItem=new T("item","A type hierarchy item",u=>u instanceof k.TypeHierarchyItem,w.TypeHierarchyItem.from),T.TestItem=new T("testItem","A VS Code TestItem",u=>u instanceof h.TestItemImpl,w.TestItem.from);class r{constructor(t,l){this.description=t,this.convert=l}}e.ApiCommandResult=r,r.Void=new r("no result",u=>u);class i{constructor(t,l,m,f,S){this.id=t,this.internalId=l,this.description=m,this.args=f,this.result=S}}e.ApiCommand=i}),define(we[180],be([1,0,2,8,6,88,39,16,75,79,10]),function(Z,e,o,k,w,B,C,A,D,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const b=[new C.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",g(k.DocumentHighlight.to))),new C.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(n,h)=>{if((0,A.isFalsyOrEmpty)(n))return;class _ extends w.SymbolInformation{static to(d){const p=new _(d.name,k.SymbolKind.to(d.kind),d.containerName||"",new w.Location(h[0],k.Range.to(d.range)));return p.detail=d.detail,p.range=p.location.range,p.selectionRange=k.Range.to(d.selectionRange),p.children=d.children?d.children.map(_.to):[],p}}return n.map(_.to)})),new C.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(k.TextEdit.to))),new C.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range,new C.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(k.TextEdit.to))),new C.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,new C.ApiCommandArgument("ch","Trigger character",n=>typeof n=="string",n=>n),new C.ApiCommandArgument("options","Formatting options",n=>!0,n=>n)],new C.ApiCommandResult("A promise that resolves to an array of TextEdits.",g(k.TextEdit.to))),new C.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",s)),new C.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",s)),new C.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",s)),new C.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",s)),new C.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Location-instances.",g(k.location.to))),new C.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to an array of Hover-instances.",g(k.Hover.to))),new C.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("position","A position in a text document",n=>Array.isArray(n)&&n.every(h=>w.Position.isPosition(h)),n=>n.map(k.Position.from))],new C.ApiCommandResult("A promise that resolves to an array of ranges.",n=>n.map(h=>{let _;for(const y of h.reverse())_=new w.SelectionRange(k.Range.to(y),_);return _}))),new C.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[C.ApiCommandArgument.String.with("query","Search string")],new C.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",n=>n.map(k.WorkspaceSymbol.to))),new C.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(k.CallHierarchyItem.to))),new C.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(k.CallHierarchyIncomingCall.to))),new C.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[C.ApiCommandArgument.CallHierarchyItem],new C.ApiCommandResult("A CallHierarchyItem or undefined",n=>n.map(k.CallHierarchyOutgoingCall.to))),new C.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A promise that resolves to a range and placeholder text.",n=>{if(!!n)return{range:k.Range.to(n.range),placeholder:n.text}})),new C.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("newName","The new symbol name")],new C.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",n=>{if(!!n){if(n.rejectReason)throw new Error(n.rejectReason);return k.WorkspaceEdit.to(n)}})),new C.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new C.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",n=>n.map(k.DocumentLink.to))),new C.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new w.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,D.decodeSemanticTokensDto)(n);if(h.type==="full")return new w.SemanticTokens(h.data,void 0)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range.optional()],new C.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",n=>{if(!!n)return new w.SemanticTokensLegend(n.tokenTypes,n.tokenModifiers)})),new C.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to SemanticTokens.",n=>{if(!n)return;const h=(0,D.decodeSemanticTokensDto)(n);if(h.type==="full")return new w.SemanticTokens(h.data,void 0)})),new C.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new C.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(n,h,_)=>{if(!n)return new w.CompletionList([]);const y=n.suggestions.map(d=>k.CompletionItem.to(d,_));return new w.CompletionList(y,n.incomplete)})),new C.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position,C.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new C.ApiCommandResult("A promise that resolves to SignatureHelp.",n=>{if(n)return k.SignatureHelp.to(n)})),new C.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new C.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(n,h,_)=>g(y=>new w.CodeLens(k.Range.to(y.range),y.command&&_.fromInternal(y.command)))(n))),new C.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[C.ApiCommandArgument.Uri,new C.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",n=>w.Range.isRange(n),n=>w.Selection.isSelection(n)?k.Selection.from(n):k.Range.from(n)),C.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),C.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new C.ApiCommandResult("A promise that resolves to an array of Command-instances.",(n,h,_)=>g(y=>{if(y._isSynthetic){if(!y.command)throw new Error("Synthetic code actions must have a command");return _.fromInternal(y.command)}else{const d=new w.CodeAction(y.title,y.kind?new w.CodeActionKind(y.kind):void 0);return y.edit&&(d.edit=k.WorkspaceEdit.to(y.edit)),y.command&&(d.command=_.fromInternal(y.command)),d.isPreferred=y.isPreferred,d}})(n))),new C.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[C.ApiCommandArgument.Uri],new C.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",n=>n?n.map(h=>new w.ColorInformation(k.Range.to(h.range),k.Color.to(h.color))):[])),new C.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new C.ApiCommandArgument("color","The color to show and insert",n=>n instanceof w.Color,k.Color.from),new C.ApiCommandArgument("context","Context object with uri and range",n=>!0,n=>({uri:n.uri,range:k.Range.from(n.range)}))],new C.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",n=>n?n.map(k.ColorPresentation.to):[])),new C.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of Inlay objects",(n,h,_)=>n.map(k.InlayHint.to.bind(void 0,_)))),new C.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new C.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",g(n=>({viewType:n.viewType,displayName:n.displayName,options:{transientOutputs:n.options.transientOutputs,transientCellMetadata:n.options.transientCellMetadata,transientDocumentMetadata:n.options.transientDocumentMetadata},filenamePattern:n.filenamePattern.map(h=>k.NotebookExclusiveDocumentPattern.to(h))})))),new C.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Range],new C.ApiCommandResult("A promise that resolves to an array of InlineValue objects",n=>n.map(k.InlineValue.to))),new C.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new C.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",n=>o.URI.isUri(n)||typeof n=="string"&&(0,F.matchesSomeScheme)(n,N.Schemas.http,N.Schemas.https),n=>n),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[k.ViewColumn.from(n),void 0]:[k.ViewColumn.from(n.viewColumn),k.TextEditorOpenOptions.from(n)])).optional(),C.ApiCommandArgument.String.with("label","").optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[C.ApiCommandArgument.Uri.with("resource","Resource to open"),C.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="number"||typeof n=="object",n=>n&&(typeof n=="number"?[k.ViewColumn.from(n),void 0]:[k.ViewColumn.from(n.viewColumn),k.TextEditorOpenOptions.from(n)])).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[C.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),C.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),C.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new C.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",n=>n===void 0||typeof n=="object",n=>n&&[k.ViewColumn.from(n.viewColumn),k.TextEditorOpenOptions.from(n)]).optional()],C.ApiCommandResult.Void),new C.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[C.ApiCommandArgument.Uri,C.ApiCommandArgument.Position],new C.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(k.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(k.TypeHierarchyItem.to))),new C.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[C.ApiCommandArgument.TypeHierarchyItem],new C.ApiCommandResult("A TypeHierarchyItem or undefined",n=>n.map(k.TypeHierarchyItem.to))),new C.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[C.ApiCommandArgument.TestItem],C.ApiCommandResult.Void)];class c{static register(h){b.forEach(h.registerApiCommand,h)}}e.ExtHostApiCommands=c;function g(n){return h=>{if(Array.isArray(h))return h.map(n)}}function s(n){if(!Array.isArray(n))return;const h=[];for(const _ of n)B.isLocationLink(_)?h.push(k.DefinitionLink.to(_)):h.push(k.location.to(_));return h}}),define(we[181],be([1,0,13,52,5,7,2,88,26,8,6,4]),function(Z,e,o,k,w,B,C,A,D,F,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function c(g,s,n){const h=g.getProxy(b.MainContext.MainThreadComments);class _{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,s.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===6){const u=this._commentControllers.get(i.handle);return u||i}else if(i&&i.$mid===7){const u=this._commentControllers.get(i.commentControlHandle);if(!u)return i;const t=u.getCommentThread(i.commentThreadHandle);return t||i}else if(i&&i.$mid===8){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const t=u.getCommentThread(i.thread.commentThreadHandle);return t?{thread:t,text:i.text}:i}else if(i&&i.$mid===9){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const t=u.getCommentThread(i.thread.commentThreadHandle);if(!t)return i;let l=i.commentUniqueId,m=t.getCommentByUniqueId(l);return m||i}else if(i&&i.$mid===10){const u=this._commentControllers.get(i.thread.commentControlHandle);if(!u)return i;const t=u.getCommentThread(i.thread.commentThreadHandle);if(!t)return i;let l=i.text,m=i.commentUniqueId,f=t.getCommentByUniqueId(m);return f?(f.body=l,f):i}return i}})}createCommentController(i,u,t){const l=_.handlePool++,m=new d(i,l,u,t);this._commentControllers.set(m.handle,m);const f=this._commentControllersByExtension.get(D.ExtensionIdentifier.toKey(i.identifier))||[];return f.push(m),this._commentControllersByExtension.set(D.ExtensionIdentifier.toKey(i.identifier),f),m.value}$createCommentThreadTemplate(i,u,t){const l=this._commentControllers.get(i);!l||l.$createCommentThreadTemplate(u,t)}async $updateCommentThreadTemplate(i,u,t){const l=this._commentControllers.get(i);!l||l.$updateCommentThreadTemplate(u,t)}$deleteCommentThread(i,u){const t=this._commentControllers.get(i);t&&t.$deleteCommentThread(u)}$provideCommentingRanges(i,u,t){const l=this._commentControllers.get(i);if(!l||!l.commentingRangeProvider)return Promise.resolve(void 0);const m=n.getDocument(C.URI.revive(u));return(0,o.asPromise)(()=>l.commentingRangeProvider.provideCommentingRanges(m,t)).then(f=>f?f.map(S=>F.Range.from(S)):void 0)}$toggleReaction(i,u,t,l,m){const f=this._commentControllers.get(i);return!f||!f.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const S=f.getCommentThread(u);if(S){const P=S.getCommentByUniqueId(l.uniqueIdInThread);if(f!==void 0&&P&&f.reactionHandler)return f.reactionHandler(P,a(m))}return Promise.resolve(void 0)})}dispose(){}}_.handlePool=0;class y{constructor(i,u,t,l,m,f,S){this._commentControllerHandle=u,this._id=t,this._uri=l,this._range=m,this._comments=f,this.extensionDescription=S,this.handle=y._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new w.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new B.MutableDisposable,this._acceptInputDisposables.value=new B.DisposableStore,this._id===void 0&&(this._id=`${i}.${this.handle}`),h.$createCommentThread(u,this.handle,this._id,this._uri,F.Range.from(this._range),S.identifier),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=f,this._localDisposables.push({dispose:()=>{h.$deleteCommentThread(u,this.handle)}});const P=this;this.value={get uri(){return P.uri},get range(){return P.range},set range($){P.range=$},get comments(){return P.comments},set comments($){P.comments=$},get collapsibleState(){return P.collapsibleState},set collapsibleState($){P.collapsibleState=$},get canReply(){return P.canReply},set canReply($){P.canReply=$},get contextValue(){return P.contextValue},set contextValue($){P.contextValue=$},get label(){return P.label},set label($){P.label=$},dispose:()=>{P.dispose()}}}set threadId(i){this._id=i}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(i){i.isEqual(this._range)||(this._range=i,this.modifications.range=i,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(i){this._canReply!==i&&(this._canReply=i,this.modifications.canReply=i,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(i){this._label=i,this.modifications.label=i,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(i){this._contextValue=i,this.modifications.contextValue=i,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(i){this._comments=i,this.modifications.comments=i,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(i){this._collapseState=i,this.modifications.collapsibleState=i,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new B.DisposableStore);const i=t=>Object.prototype.hasOwnProperty.call(this.modifications,t),u={};i("range")&&(u.range=F.Range.from(this._range)),i("label")&&(u.label=this.label),i("contextValue")&&(u.contextValue=this.contextValue??null),i("comments")&&(u.comments=this._comments.map(t=>p(this,t,this._commentsMap))),i("collapsibleState")&&(u.collapseState=T(this._collapseState)),i("canReply")&&(u.canReply=this.canReply),this.modifications={},h.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,u)}getCommentByUniqueId(i){for(let u of this._commentsMap){let t=u[0],l=u[1];if(i===l)return t}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(i=>i.dispose())}}y._handlePool=0,Fe([(0,k.debounce)(100)],y.prototype,"eventuallyUpdateCommentThread",null);class d{constructor(i,u,t,l){this._extension=i,this._handle=u,this._id=t,this._label=l,this._threads=new Map,h.$registerCommentController(this.handle,t,l);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(f){m.options=f},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(f){m.commentingRangeProvider=f},get reactionHandler(){return m.reactionHandler},set reactionHandler(f){m.reactionHandler=f},createCommentThread(f,S,P){return m.createCommentThread(f,S,P).value},dispose:()=>{m.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(i){this._commentingRangeProvider=i,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(i){this._reactionHandler=i,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!i})}get options(){return this._options}set options(i){this._options=i,h.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(i,u,t,l){if(typeof i=="string"){const m=new y(this.id,this.handle,i,u,t,l,this._extension);return this._threads.set(m.handle,m),m}else{const m=new y(this.id,this.handle,void 0,i,u,t,this._extension);return this._threads.set(m.handle,m),m}}$createCommentThreadTemplate(i,u){const t=new y(this.id,this.handle,void 0,C.URI.revive(i),F.Range.to(u),[],this._extension);return t.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this._threads.set(t.handle,t),t}$updateCommentThreadTemplate(i,u){let t=this._threads.get(i);t&&(t.range=F.Range.to(u))}$deleteCommentThread(i){let u=this._threads.get(i);u&&u.dispose(),this._threads.delete(i)}getCommentThread(i){return this._threads.get(i)}dispose(){this._threads.forEach(i=>{i.dispose()}),this._localDisposables.forEach(i=>i.dispose())}}function p(r,i,u){let t=u.get(i);t||(t=++r.commentHandle,u.set(i,t));const l=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:t,body:typeof i.body=="string"?i.body:F.MarkdownString.from(i.body),userName:i.author.name,userIconPath:l,label:i.label,commentReactions:i.reactions?i.reactions.map(m=>E(m)):void 0,timestamp:i.timestamp?.toJSON()}}function E(r){return{label:r.label,iconPath:r.iconPath?F.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function a(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?C.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function T(r){if(r!==void 0)switch(r){case N.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case N.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}return new _}e.createExtHostComments=c}),define(we[92],be([1,0,2,4,6,3,14,12,16,9,17]),function(Z,e,o,k,w,B,C,A,D,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let b=class wi{constructor(g,s){this._logService=s,this._provider=new Map,this._proxy=g.getProxy(k.MainContext.MainThreadDecorations)}registerFileDecorationProvider(g,s){const n=wi._handlePool++;this._provider.set(n,{provider:g,extensionId:s}),this._proxy.$registerDecorationProvider(n,s.value);const h=g.onDidChangeFileDecorations&&g.onDidChangeFileDecorations(_=>{if(!_){this._proxy.$onDidChange(n,null);return}let y=(0,D.asArray)(_);if(y.length<=wi._maxEventSize){this._proxy.$onDidChange(n,y);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",s.value,y.length);const d=y.map(a=>({uri:a,rank:(0,F.count)(a.path,"/")})),p=(0,D.groupBy)(d,(a,T)=>a.rank-T.rank||(0,F.compare)(a.uri.path,T.uri.path));let E=[];e:for(let a of p){let T;for(let r of a){let i=(0,N.dirname)(r.uri.path);if(T!==i&&(T=i,E.push(r.uri)>=wi._maxEventSize))break e}}this._proxy.$onDidChange(n,E)});return new w.Disposable(()=>{h?.dispose(),this._proxy.$unregisterDecorationProvider(n),this._provider.delete(n)})}async $provideDecorations(g,s,n){if(!this._provider.has(g))return Object.create(null);const h=Object.create(null),{provider:_,extensionId:y}=this._provider.get(g);return await Promise.all(s.map(async d=>{try{const{uri:p,id:E}=d,a=await Promise.resolve(_.provideFileDecoration(o.URI.revive(p),n));if(!a)return;try{w.FileDecoration.validate(a),h[E]=[a.propagate,a.tooltip,a.badge,a.color]}catch(T){this._logService.warn(`INVALID decoration from extension '${y.value}': ${T}`)}}catch(p){this._logService.error(p)}})),h}};b._handlePool=0,b._maxEventSize=250,b=Fe([Ne(0,C.IExtHostRpcService),Ne(1,A.ILogService)],b),e.ExtHostDecorations=b,e.IExtHostDecorations=(0,B.createDecorator)("IExtHostDecorations")});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,o,k,w){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!w:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?w.call(Z,o):w?w.value=o:e.set(Z,o),o},De=this&&this.__classPrivateFieldGet||function(Z,e,o,k){if(o==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?k:o==="a"?k.call(Z):k?k.value:e.get(Z)};define(we[182],be([1,0,122,78,2,4,6,8,5,12,22,30]),function(Z,e,o,k,w,B,C,A,D,F,N,b){"use strict";var c,g,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class n{constructor(y,d,p,E,a,T){this._name=y,this._owner=d,this._maxDiagnosticsPerFile=p,c.set(this,void 0),g.set(this,void 0),s.set(this,void 0),this._isDisposed=!1,Ve(this,s,new N.ResourceMap(r=>E.getComparisonKey(r)),"f"),Ve(this,c,a,"f"),Ve(this,g,T,"f")}dispose(){this._isDisposed||(De(this,g,"f").fire([...De(this,s,"f").keys()]),De(this,c,"f")&&De(this,c,"f").$clear(this._owner),De(this,s,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(y,d){if(!y){this.clear();return}this._checkDisposed();let p=[];if(w.URI.isUri(y)){if(!d){this.delete(y);return}De(this,s,"f").set(y,d.slice()),p=[y]}else if(Array.isArray(y)){p=[];let a;y=[...y].sort(n._compareIndexedTuplesByUri);for(const T of y){const[r,i]=T;if((!a||r.toString()!==a.toString())&&(a&&De(this,s,"f").get(a).length===0&&De(this,s,"f").delete(a),a=r,p.push(r),De(this,s,"f").set(r,[])),i){const u=De(this,s,"f").get(r);u&&u.push(...i)}else{const u=De(this,s,"f").get(r);u&&(u.length=0)}}}if(De(this,g,"f").fire(p),!De(this,c,"f"))return;const E=[];for(let a of p){let T=[];const r=De(this,s,"f").get(a);if(r)if(r.length>this._maxDiagnosticsPerFile){T=[];const i=[C.DiagnosticSeverity.Error,C.DiagnosticSeverity.Warning,C.DiagnosticSeverity.Information,C.DiagnosticSeverity.Hint];e:for(let u=0;u<4;u++)for(let t of r)if(t.severity===i[u]&&T.push(A.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;T.push({severity:k.MarkerSeverity.Info,message:(0,o.localize)(0,null,r.length-this._maxDiagnosticsPerFile),startLineNumber:T[T.length-1].startLineNumber,startColumn:T[T.length-1].startColumn,endLineNumber:T[T.length-1].endLineNumber,endColumn:T[T.length-1].endColumn})}else T=r.map(i=>A.Diagnostic.from(i));E.push([a,T])}De(this,c,"f").$changeMany(this._owner,E)}delete(y){this._checkDisposed(),De(this,g,"f").fire([y]),De(this,s,"f").delete(y),De(this,c,"f")&&De(this,c,"f").$changeMany(this._owner,[[y,void 0]])}clear(){this._checkDisposed(),De(this,g,"f").fire([...De(this,s,"f").keys()]),De(this,s,"f").clear(),De(this,c,"f")&&De(this,c,"f").$clear(this._owner)}forEach(y,d){this._checkDisposed();for(let p of De(this,s,"f").keys())y.apply(d,[p,this.get(p),this])}get(y){this._checkDisposed();const d=De(this,s,"f").get(y);return Array.isArray(d)?Object.freeze(d.slice(0)):[]}has(y){return this._checkDisposed(),Array.isArray(De(this,s,"f").get(y))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(y,d){return y[0].toString()<d[0].toString()?-1:y[0].toString()>d[0].toString()?1:0}}e.DiagnosticCollection=n,c=new WeakMap,g=new WeakMap,s=new WeakMap;let h=class oi{constructor(y,d,p){this._logService=d,this._fileSystemInfoService=p,this._collections=new Map,this._onDidChangeDiagnostics=new D.DebounceEmitter({merge:E=>E.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this._onDidChangeDiagnostics.event,oi._mapper),this._proxy=y.getProxy(B.MainContext.MainThreadDiagnostics)}static _mapper(y){const d=new N.ResourceMap;for(const p of y)d.set(p,p);return{uris:Object.freeze(Array.from(d.values()))}}createDiagnosticCollection(y,d){const{_collections:p,_proxy:E,_onDidChangeDiagnostics:a,_logService:T,_fileSystemInfoService:r}=this,i=new class{$changeMany(l,m){E.$changeMany(l,m),T.trace("[DiagnosticCollection] change many (extension, owner, uris)",y.value,l,m.length===0?"CLEARING":m)}$clear(l){E.$clear(l),T.trace("[DiagnosticCollection] remove all (extension, owner)",y.value,l)}dispose(){E.dispose()}};let u;if(!d)d="_generated_diagnostic_collection_name_#"+oi._idPool++,u=d;else if(!p.has(d))u=d;else{this._logService.warn(`DiagnosticCollection with name '${d}' does already exist.`);do u=d+oi._idPool++;while(p.has(u))}return new class extends n{constructor(){super(d,u,oi._maxDiagnosticsPerFile,r.extUri,i,a);p.set(u,this)}dispose(){super.dispose(),p.delete(u)}}}getDiagnostics(y){if(y)return this._getDiagnostics(y);{const d=new Map,p=[];for(const E of this._collections.values())E.forEach((a,T)=>{let r=d.get(a.toString());typeof r=="undefined"&&(r=p.length,d.set(a.toString(),r),p.push([a,[]])),p[r][1]=p[r][1].concat(...T)});return p}}_getDiagnostics(y){let d=[];for(let p of this._collections.values())p.has(y)&&(d=d.concat(p.get(y)));return d}$acceptMarkersChange(y){if(!this._mirrorCollection){const d="_generated_mirror",p=new n(d,d,oi._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(d,p),this._mirrorCollection=p}for(const[d,p]of y)this._mirrorCollection.set(w.URI.revive(d),p.map(A.Diagnostic.to))}};h._idPool=0,h._maxDiagnosticsPerFile=1e3,h=Fe([Ne(1,F.ILogService),Ne(2,b.IExtHostFileSystemInfo)],h),e.ExtHostDiagnostics=h}),define(we[183],be([1,0,2,4]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class w{constructor(C){this._proxy=C.getProxy(k.MainContext.MainThreadDialogs)}showOpenDialog(C){return this._proxy.$showOpenDialog(C).then(A=>A?A.map(D=>o.URI.revive(D)):void 0)}showSaveDialog(C){return this._proxy.$showSaveDialog(C).then(A=>A?o.URI.revive(A):void 0)}}e.ExtHostDialogs=w}),define(we[184],be([1,0,15,2,6,4,10,20,9]),function(Z,e,o,k,w,B,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class F{constructor(b,c,g){this._documentsAndEditors=c,this._logService=g,this._documentContentProviders=new Map,this._proxy=b.getProxy(B.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(b,c){if(Object.keys(C.Schemas).indexOf(b)>=0)throw new Error(`scheme '${b}' already registered`);const g=F._handlePool++;this._documentContentProviders.set(g,c),this._proxy.$registerTextContentProvider(g,b);let s;return typeof c.onDidChange=="function"&&(s=c.onDidChange(n=>{if(n.scheme!==b){this._logService.warn(`Provider for scheme '${b}' is firing event for schema '${n.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(n)&&this.$provideTextDocumentContent(g,n).then(h=>{if(!h&&typeof h!="string")return;const _=this._documentsAndEditors.getDocument(n);if(!_)return;const y=(0,D.splitLines)(h);if(!_.equalLines(y))return this._proxy.$onVirtualDocumentChange(n,h)},o.onUnexpectedError)})),new w.Disposable(()=>{this._documentContentProviders.delete(g)&&this._proxy.$unregisterTextContentProvider(g),s&&(s.dispose(),s=void 0)})}$provideTextDocumentContent(b,c){const g=this._documentContentProviders.get(b);return g?Promise.resolve(g.provideTextDocumentContent(k.URI.revive(c),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${c.scheme}`))}}e.ExtHostDocumentContentProvider=F,F._handlePool=0}),define(we[185],be([1,0,5,7,2,4,84,8,11,25,6]),function(Z,e,o,k,w,B,C,A,D,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class b{constructor(g,s){this._onDidAddDocument=new o.Emitter,this._onDidRemoveDocument=new o.Emitter,this._onDidChangeDocument=new o.Emitter,this._onDidSaveDocument=new o.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new k.DisposableStore,this._documentLoader=new Map,this._proxy=g.getProxy(B.MainContext.MainThreadDocuments),this._documentsAndEditors=s,this._documentsAndEditors.onDidRemoveDocuments(n=>{for(const h of n)this._onDidRemoveDocument.fire(h.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(n=>{for(const h of n)this._onDidAddDocument.fire(h.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(g){if(!g)return;const s=this._documentsAndEditors.getDocument(g);if(s)return s}getDocument(g){const s=this.getDocumentData(g);if(!s?.document)throw new Error(`Unable to retrieve document from URI '${g}'`);return s.document}ensureDocumentData(g){const s=this._documentsAndEditors.getDocument(g);if(s)return Promise.resolve(s);let n=this._documentLoader.get(g.toString());return n||(n=this._proxy.$tryOpenDocument(g).then(h=>{this._documentLoader.delete(g.toString());const _=w.URI.revive(h);return(0,D.assertIsDefined)(this._documentsAndEditors.getDocument(_))},h=>(this._documentLoader.delete(g.toString()),Promise.reject(h))),this._documentLoader.set(g.toString(),n)),n}createDocumentData(g){return this._proxy.$tryCreateDocument(g).then(s=>w.URI.revive(s))}$acceptModelLanguageChanged(g,s){const n=w.URI.revive(g),h=this._documentsAndEditors.getDocument(n);if(!h)throw new Error("unknown document");this._onDidRemoveDocument.fire(h.document),h._acceptLanguageId(s),this._onDidAddDocument.fire(h.document)}$acceptModelSaved(g){const s=w.URI.revive(g),n=this._documentsAndEditors.getDocument(s);if(!n)throw new Error("unknown document");this.$acceptDirtyStateChanged(g,!1),this._onDidSaveDocument.fire(n.document)}$acceptDirtyStateChanged(g,s){const n=w.URI.revive(g),h=this._documentsAndEditors.getDocument(n);if(!h)throw new Error("unknown document");h._acceptIsDirty(s),this._onDidChangeDocument.fire({document:h.document,contentChanges:[],reason:void 0})}$acceptModelChanged(g,s,n){const h=w.URI.revive(g),_=this._documentsAndEditors.getDocument(h);if(!_)throw new Error("unknown document");_._acceptIsDirty(n),_.onEvents(s);let y;s.isUndoing?y=N.TextDocumentChangeReason.Undo:s.isRedoing&&(y=N.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,F.deepFreeze)({document:_.document,contentChanges:s.changes.map(d=>({range:A.Range.to(d.range),rangeOffset:d.rangeOffset,rangeLength:d.rangeLength,text:d.text})),reason:y}))}setWordDefinitionFor(g,s){(0,C.setWordDefinitionFor)(g,s)}}e.ExtHostDocuments=b}),define(we[49],be([1,0,42,5,7,2,3,4,84,14,90,8,12,22,10,161,230]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class _{constructor(p){this.value=p,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let y=class{constructor(p,E){this._extHostRpc=p,this._logService=E,this._activeEditorId=null,this._editors=new Map,this._documents=new g.ResourceMap,this._onDidAddDocuments=new k.Emitter,this._onDidRemoveDocuments=new k.Emitter,this._onDidChangeVisibleTextEditors=new k.Emitter,this._onDidChangeActiveTextEditor=new k.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(p){this.acceptDocumentsAndEditorsDelta(p)}acceptDocumentsAndEditorsDelta(p){const E=[],a=[],T=[];if(p.removedDocuments)for(const r of p.removedDocuments){const i=B.URI.revive(r),u=this._documents.get(i);u?.unref()&&(this._documents.delete(i),E.push(u.value))}if(p.addedDocuments)for(const r of p.addedDocuments){const i=B.URI.revive(r.uri);let u=this._documents.get(i);if(u&&i.scheme!==s.Schemas.vscodeNotebookCell&&i.scheme!==s.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);u||(u=new _(new D.ExtHostDocumentData(this._extHostRpc.getProxy(A.MainContext.MainThreadDocuments),i,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this._documents.set(i,u),a.push(u.value)),u.ref()}if(p.removedEditors)for(const r of p.removedEditors){const i=this._editors.get(r);this._editors.delete(r),i&&T.push(i)}if(p.addedEditors)for(const r of p.addedEditors){const i=B.URI.revive(r.documentUri);o.ok(this._documents.has(i),`document '${i}' does not exist`),o.ok(!this._editors.has(r.id),`editor '${r.id}' already exists!`);const u=this._documents.get(i).value,t=new N.ExtHostTextEditor(r.id,this._extHostRpc.getProxy(A.MainContext.MainThreadTextEditors),this._logService,new h.Lazy(()=>u.document),r.selections.map(b.Selection.to),r.options,r.visibleRanges.map(l=>b.Range.to(l)),typeof r.editorPosition=="number"?b.ViewColumn.to(r.editorPosition):void 0);this._editors.set(r.id,t)}p.newActiveEditor!==void 0&&(o.ok(p.newActiveEditor===null||this._editors.has(p.newActiveEditor),`active editor '${p.newActiveEditor}' does not exist`),this._activeEditorId=p.newActiveEditor),(0,w.dispose)(E),(0,w.dispose)(T),p.removedDocuments&&this._onDidRemoveDocuments.fire(E),p.addedDocuments&&this._onDidAddDocuments.fire(a),(p.removedEditors||p.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(r=>r.value)),p.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(p){return this._documents.get(p)?.value}allDocuments(){return n.Iterable.map(this._documents.values(),p=>p.value)}getEditor(p){return this._editors.get(p)}activeEditor(p){if(!this._activeEditorId)return;const E=this._editors.get(this._activeEditorId);return p?E:E?.value}allEditors(){return[...this._editors.values()]}};y=Fe([Ne(0,F.IExtHostRpcService),Ne(1,c.ILogService)],y),e.ExtHostDocumentsAndEditors=y,e.IExtHostDocumentsAndEditors=(0,C.createDecorator)("IExtHostDocumentsAndEditors")}),define(we[66],be([1,0,8,4,2,5,3,14]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,C.createDecorator)("IExtHostEditorTabs");let D=class{constructor(N){this._onDidChangeTabGroup=new B.Emitter,this._onDidChangeActiveTabGroup=new B.Emitter,this._tabGroups={all:[],activeTabGroup:void 0,onDidChangeTabGroup:this._onDidChangeTabGroup.event,onDidChangeActiveTabGroup:this._onDidChangeActiveTabGroup.event},this._proxy=N.getProxy(k.MainContext.MainThreadEditorTabs)}get tabGroups(){return this._tabGroups}$acceptEditorTabModel(N){this._tabGroups.all.length=0;let b=!1;for(const c of N){let g;const s=c.tabs.map(n=>{const h=this.createExtHostTabObject(n);return n.isActive&&(g=h),h});if(this._tabGroups.all.push(Object.freeze({isActive:c.isActive,viewColumn:o.ViewColumn.to(c.viewColumn),activeTab:g,tabs:s})),c.isActive){b=!0;const n=this._tabGroups.activeTabGroup;this._tabGroups.activeTabGroup=this._tabGroups.all[this._tabGroups.all.length-1],this.groupDiff(n,this._tabGroups.activeTabGroup)&&this._onDidChangeActiveTabGroup.fire(this._tabGroups.activeTabGroup)}}b||(this._tabGroups.activeTabGroup=void 0,this._onDidChangeActiveTabGroup.fire(void 0)),this._onDidChangeTabGroup.fire()}createExtHostTabObject(N){return Object.freeze({label:N.label,viewColumn:o.ViewColumn.to(N.viewColumn),resource:w.URI.revive(N.resource),additionalResourcesAndViewTypes:N.additionalResourcesAndViewTypes.map(({resource:b,viewId:c})=>({resource:w.URI.revive(b),viewType:c})),viewType:N.editorId,isActive:N.isActive,kind:N.kind,isDirty:N.isDirty,isPinned:N.isPinned,move:async(b,c)=>{this._proxy.$moveTab(N,b,o.ViewColumn.from(c))},close:async()=>{await this._proxy.$closeTab(N)}})}groupDiff(N,b){if(N===b)return!1;if(!N||!b||N.isActive!==b.isActive||N.viewColumn!==b.viewColumn||N.tabs.length!==b.tabs.length)return!0;for(let c=0;c<N.tabs.length;c++)if(this.tabDiff(N.tabs[c],b.tabs[c]))return!0;return!1}tabDiff(N,b){if(N===b)return!1;if(!N||!b||N.label!==b.label||N.viewColumn!==b.viewColumn||N.resource?.toString()!==b.resource?.toString()||N.viewType!==b.viewType||N.isActive!==b.isActive||N.isPinned!==b.isPinned||N.isDirty!==b.isDirty||N.additionalResourcesAndViewTypes.length!==b.additionalResourcesAndViewTypes.length)return!0;for(let c=0;c<N.additionalResourcesAndViewTypes.length;c++){const g=N.additionalResourcesAndViewTypes[c].resource,s=b.additionalResourcesAndViewTypes[c].resource,n=N.additionalResourcesAndViewTypes[c].viewType,h=b.additionalResourcesAndViewTypes[c].viewType;if(g?.toString()!==s?.toString()||n!==h)return!0}return!1}};D=Fe([Ne(0,A.IExtHostRpcService)],D),e.ExtHostEditorTabs=D}),define(we[186],be([1,0,2,4,7,6,8,231,9,21,28]),function(Z,e,o,k,w,B,C,A,D,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class b{constructor(){this._schemes=[]}add(s){this._stateMachine=void 0,this._schemes.push(s)}delete(s){const n=this._schemes.indexOf(s);n>=0&&(this._schemes.splice(n,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const s=this._schemes.sort(),n=[];let h,_,y=14,d=14;for(const p of s){let E=h?(0,D.commonPrefixLength)(h,p):0;for(E===0?_=1:_=d;E<p.length;E++)E+1===p.length?(y=d,d=9):d+=1,n.push([_,p.toUpperCase().charCodeAt(E),d]),n.push([_,p.toLowerCase().charCodeAt(E),d]),_=d;h=p,d=y}n.push([9,58,10]),n.push([10,47,12]),this._stateMachine=new A.StateMachine(n)}}provideDocumentLinks(s){this._initStateMachine();const n=[],h=A.LinkComputer.computeLinks({getLineContent(_){return s.lineAt(_-1).text},getLineCount(){return s.lineCount}},this._stateMachine);for(const _ of h){const y=C.DocumentLink.to(_);y.target&&n.push(y)}return n}}class c{constructor(s,n){this._extHostLanguageFeatures=n,this._linkProvider=new b,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=s.getProxy(k.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(s,n,h,_={}){if(this._registeredSchemes.has(n))throw new Error(`a provider for the scheme '${n}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(s,"*",this._linkProvider));const y=this._handlePool++;this._linkProvider.add(n),this._registeredSchemes.add(n),this._fsProvider.set(y,h);let d=2;_.isCaseSensitive&&(d+=1024),_.isReadonly&&(d+=2048),typeof h.copy=="function"&&(d+=8),typeof h.open=="function"&&typeof h.close=="function"&&typeof h.read=="function"&&typeof h.write=="function"&&((0,N.checkProposedApiEnabled)(s,"fsChunks"),d+=4),this._proxy.$registerFileSystemProvider(y,n,d).catch(E=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${n}`),console.error(E)});const p=h.onDidChangeFile(E=>{const a=[];for(const T of E){let{uri:r,type:i}=T;if(r.scheme!==n)continue;let u;switch(i){case B.FileChangeType.Changed:u=0;break;case B.FileChangeType.Created:u=1;break;case B.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:r,type:u})}this._proxy.$onFileSystemChange(y,a)});return(0,w.toDisposable)(()=>{p.dispose(),this._linkProvider.delete(n),this._registeredSchemes.delete(n),this._fsProvider.delete(y),this._proxy.$unregisterProvider(y)})}static _asIStat(s){const{type:n,ctime:h,mtime:_,size:y,permissions:d}=s;return{type:n,ctime:h,mtime:_,size:y,permissions:d}}$stat(s,n){return Promise.resolve(this._getFsProvider(s).stat(o.URI.revive(n))).then(h=>c._asIStat(h))}$readdir(s,n){return Promise.resolve(this._getFsProvider(s).readDirectory(o.URI.revive(n)))}$readFile(s,n){return Promise.resolve(this._getFsProvider(s).readFile(o.URI.revive(n))).then(h=>F.VSBuffer.wrap(h))}$writeFile(s,n,h,_){return Promise.resolve(this._getFsProvider(s).writeFile(o.URI.revive(n),h.buffer,_))}$delete(s,n,h){return Promise.resolve(this._getFsProvider(s).delete(o.URI.revive(n),h))}$rename(s,n,h,_){return Promise.resolve(this._getFsProvider(s).rename(o.URI.revive(n),o.URI.revive(h),_))}$copy(s,n,h,_){const y=this._getFsProvider(s);if(!y.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(y.copy(o.URI.revive(n),o.URI.revive(h),_))}$mkdir(s,n){return Promise.resolve(this._getFsProvider(s).createDirectory(o.URI.revive(n)))}$watch(s,n,h,_){const y=this._getFsProvider(s).watch(o.URI.revive(h),_);this._watches.set(n,y)}$unwatch(s,n){const h=this._watches.get(n);h&&(h.dispose(),this._watches.delete(n))}$open(s,n,h){const _=this._getFsProvider(s);if(!_.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(_.open(o.URI.revive(n),h))}$close(s,n){const h=this._getFsProvider(s);if(!h.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(h.close(n))}$read(s,n,h,_){const y=this._getFsProvider(s);if(!y.read)throw new Error('FileSystemProvider does not implement "read"');const d=F.VSBuffer.alloc(_);return Promise.resolve(y.read(n,h,d.buffer,0,_)).then(p=>d.slice(0,p))}$write(s,n,h,_){const y=this._getFsProvider(s);if(!y.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(y.write(n,h,_.buffer,0,_.byteLength))}_getFsProvider(s){const n=this._fsProvider.get(s);if(!n){const h=new Error;throw h.name="ENOPRO",h.message="no provider",h}return n}}e.ExtHostFileSystem=c}),define(we[50],be([1,0,4,45,6,21,3,14,30,7]),function(Z,e,o,k,w,B,C,A,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let N=class jt{constructor(c,g){this._fileSystemProvider=new Map,this._proxy=c.getProxy(o.MainContext.MainThreadFileSystem);const s=this;this.value=Object.freeze({async stat(n){try{const h=s._fileSystemProvider.get(n.scheme);if(!h)return await s._proxy.$stat(n);await s._proxy.$ensureActivation(n.scheme);const _=await h.stat(n);return{type:_.type,ctime:_.ctime,mtime:_.mtime,size:_.size,permissions:_.permissions}}catch(h){jt._handleError(h)}},async readDirectory(n){try{const h=s._fileSystemProvider.get(n.scheme);return h?(await s._proxy.$ensureActivation(n.scheme),(await h.readDirectory(n)).slice()):await s._proxy.$readdir(n)}catch(h){return jt._handleError(h)}},async createDirectory(n){try{return await s._proxy.$mkdir(n)}catch(h){return jt._handleError(h)}},async readFile(n){try{const h=s._fileSystemProvider.get(n.scheme);return h?(await s._proxy.$ensureActivation(n.scheme),(await h.readFile(n)).slice()):(await s._proxy.$readFile(n)).buffer}catch(h){return jt._handleError(h)}},async writeFile(n,h){try{return await s._proxy.$writeFile(n,B.VSBuffer.wrap(h))}catch(_){return jt._handleError(_)}},async delete(n,h){try{const _=s._fileSystemProvider.get(n.scheme);return _?(await s._proxy.$ensureActivation(n.scheme),await _.delete(n,{recursive:!1,...h})):await s._proxy.$delete(n,{recursive:!1,useTrash:!1,...h})}catch(_){return jt._handleError(_)}},async rename(n,h,_){try{return await s._proxy.$rename(n,h,{overwrite:!1,..._})}catch(y){return jt._handleError(y)}},async copy(n,h,_){try{return await s._proxy.$copy(n,h,{overwrite:!1,..._})}catch(y){return jt._handleError(y)}},isWritableFileSystem(n){const h=g.getCapabilities(n);if(typeof h=="number")return!(h&2048)}})}static _handleError(c){if(c instanceof w.FileSystemError)throw c;if(!(c instanceof Error))throw new w.FileSystemError(String(c));if(c.name==="ENOPRO")throw w.FileSystemError.Unavailable(c.message);switch(c.name){case k.FileSystemProviderErrorCode.FileExists:throw w.FileSystemError.FileExists(c.message);case k.FileSystemProviderErrorCode.FileNotFound:throw w.FileSystemError.FileNotFound(c.message);case k.FileSystemProviderErrorCode.FileNotADirectory:throw w.FileSystemError.FileNotADirectory(c.message);case k.FileSystemProviderErrorCode.FileIsADirectory:throw w.FileSystemError.FileIsADirectory(c.message);case k.FileSystemProviderErrorCode.NoPermissions:throw w.FileSystemError.NoPermissions(c.message);case k.FileSystemProviderErrorCode.Unavailable:throw w.FileSystemError.Unavailable(c.message);default:throw new w.FileSystemError(c.message,c.name)}}addFileSystemProvider(c,g){return this._fileSystemProvider.set(c,g),(0,F.toDisposable)(()=>this._fileSystemProvider.delete(c))}};N=Fe([Ne(0,A.IExtHostRpcService),Ne(1,D.IExtHostFileSystemInfo)],N),e.ExtHostConsumerFileSystem=N,e.IExtHostConsumerFileSystem=(0,C.createDecorator)("IExtHostConsumerFileSystem")}),define(we[187],be([1,0,5,29,2,4,8,6]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{constructor(b,c,g,s,n,h,_,y){this._onDidCreate=new o.Emitter,this._onDidChange=new o.Emitter,this._onDidDelete=new o.Emitter;const d=this.ensureWatching(b,g,n);this._config=0,h&&(this._config+=1),_&&(this._config+=2),y&&(this._config+=4);const p=(0,k.parse)(n),E=typeof n=="string",a=s(T=>{if(!h)for(let r of T.created){const i=w.URI.revive(r);p(i.fsPath)&&(!E||c.getWorkspaceFolder(i))&&this._onDidCreate.fire(i)}if(!_)for(let r of T.changed){const i=w.URI.revive(r);p(i.fsPath)&&(!E||c.getWorkspaceFolder(i))&&this._onDidChange.fire(i)}if(!y)for(let r of T.deleted){const i=w.URI.revive(r);p(i.fsPath)&&(!E||c.getWorkspaceFolder(i))&&this._onDidDelete.fire(i)}});this._disposable=A.Disposable.from(d,this._onDidCreate,this._onDidChange,this._onDidDelete,a)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(b,c,g){let s=A.Disposable.from();if(typeof g=="string")return s;const n=b.getProxy(B.MainContext.MainThreadFileSystem);let h=!1;(g.pattern.includes(k.GLOBSTAR)||g.pattern.includes(k.GLOB_SPLIT))&&(h=!0);const _=Math.random();return n.$watch(c.identifier.value,_,g.baseUri,{recursive:h,excludes:[]}),A.Disposable.from({dispose:()=>n.$unwatch(_)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class F{constructor(b,c,g){this._mainContext=b,this._logService=c,this._extHostDocumentsAndEditors=g,this._onFileSystemEvent=new o.Emitter,this._onDidRenameFile=new o.Emitter,this._onDidCreateFile=new o.Emitter,this._onDidDeleteFile=new o.Emitter,this._onWillRenameFile=new o.AsyncEmitter,this._onWillCreateFile=new o.AsyncEmitter,this._onWillDeleteFile=new o.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(b,c,g,s,n,h){return new D(this._mainContext,b,c,this._onFileSystemEvent.event,C.GlobPattern.from(g),s,n,h)}$onFileEvent(b){this._onFileSystemEvent.fire(b)}$onDidRunFileOperation(b,c){switch(b){case 2:this._onDidRenameFile.fire(Object.freeze({files:c.map(g=>({oldUri:w.URI.revive(g.source),newUri:w.URI.revive(g.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:c.map(g=>w.URI.revive(g.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:c.map(g=>w.URI.revive(g.target))}));break;default:}}getOnWillRenameFileEvent(b){return this._createWillExecuteEvent(b,this._onWillRenameFile)}getOnWillCreateFileEvent(b){return this._createWillExecuteEvent(b,this._onWillCreateFile)}getOnWillDeleteFileEvent(b){return this._createWillExecuteEvent(b,this._onWillDeleteFile)}_createWillExecuteEvent(b,c){return(g,s,n)=>{const h=function(y){g.call(s,y)};return h.extension=b,c.event(h,void 0,n)}}async $onWillRunFileOperation(b,c,g,s){switch(b){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:c.map(n=>({oldUri:w.URI.revive(n.source),newUri:w.URI.revive(n.target)}))},g,s);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:c.map(n=>w.URI.revive(n.target))},g,s);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:c.map(n=>w.URI.revive(n.target))},g,s)}}async _fireWillEvent(b,c,g,s){const n=new Set,h=[];if(await b.fireAsync(c,s,async(y,d)=>{const p=Date.now(),E=await Promise.resolve(y);E instanceof A.WorkspaceEdit&&(h.push(E),n.add(d.extension.displayName??d.extension.identifier.value)),Date.now()-p>g&&this._logService.warn("SLOW file-participant",d.extension.identifier)}),s.isCancellationRequested||h.length===0)return;const _={edits:[]};for(let y of h){let{edits:d}=C.WorkspaceEdit.from(y,{getTextDocumentVersion:p=>this._extHostDocumentsAndEditors.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}});_.edits=_.edits.concat(d)}return{edit:_,extensionNames:Array.from(n)}}}e.ExtHostFileSystemEventService=F}),define(we[188],be([1,0,2,39]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class w{constructor(C,A,D,F){this._extHostNotebooks=A,this._textDocumentsAndEditors=D,this._commands=F;const N=new k.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new k.ApiCommandArgument("showOptions","Show Options",b=>!0,b=>b),new k.ApiCommandArgument("resource","Interactive resource Uri",b=>!0,b=>b),new k.ApiCommandArgument("controllerId","Notebook controller Id",b=>!0,b=>b),new k.ApiCommandArgument("title","Interactive editor title",b=>!0,b=>b)],new k.ApiCommandResult("Notebook and input URI",b=>{if(b.notebookEditorId!==void 0){const c=this._extHostNotebooks.getEditorById(b.notebookEditorId);return{notebookUri:o.URI.revive(b.notebookUri),inputUri:o.URI.revive(b.inputUri),notebookEditor:c.apiEditor}}return{notebookUri:o.URI.revive(b.notebookUri),inputUri:o.URI.revive(b.inputUri)}}));this._commands.registerApiCommand(N)}$willAddInteractiveDocument(C,A,D,F){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:D,uri:C,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(o.URI.revive(F))?.apiNotebook}]})}$willRemoveInteractiveDocument(C,A){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[C]})}}e.ExtHostInteractive=w}),define(we[189],be([1,0,7,4]),function(Z,e,o,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class w{constructor(C){this._handlePool=0,this._proxy=C.getProxy(k.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(C){const A=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(A,C),(0,o.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=w}),define(we[190],be([1,0,2,25,8,6,4,9,48,16,11,232,20,7,75,53,58,191,15,5,13]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_,y,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class E{constructor(M,O){this._documents=M,this._provider=O}async provideDocumentSymbols(M,O){const I=this._documents.getDocument(M),R=await this._provider.provideDocumentSymbols(I,O);if(!(0,F.isFalsyOrEmpty)(R))return R[0]instanceof B.DocumentSymbol?R.map(w.DocumentSymbol.from):E._asDocumentSymbolTree(R)}static _asDocumentSymbolTree(M){M=M.slice(0).sort((R,x)=>{let Q=R.location.range.start.compareTo(x.location.range.start);return Q===0&&(Q=x.location.range.end.compareTo(R.location.range.end)),Q});const O=[],I=[];for(const R of M){const x={name:R.name||"!!MISSING: name!!",kind:w.SymbolKind.from(R.kind),tags:R.tags?.map(w.SymbolTag.from)||[],detail:"",containerName:R.containerName,range:w.Range.from(R.location.range),selectionRange:w.Range.from(R.location.range),children:[]};for(;;){if(I.length===0){I.push(x),O.push(x);break}const Q=I[I.length-1];if(D.Range.containsRange(Q.range,x.range)&&!D.Range.equalsRange(Q.range,x.range)){Q.children&&Q.children.push(x),I.push(x);break}I.pop()}}return O}}class a{constructor(M,O,I){this._documents=M,this._commands=O,this._provider=I,this._cache=new h.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(M,O){const I=this._documents.getDocument(M),R=await this._provider.provideCodeLenses(I,O);if(!R||O.isCancellationRequested)return;const x=this._cache.add(R),Q=new g.DisposableStore;this._disposables.set(x,Q);const ne={cacheId:x,lenses:[]};for(let Ee=0;Ee<R.length;Ee++)ne.lenses.push({cacheId:[x,Ee],range:w.Range.from(R[Ee].range),command:this._commands.toInternal(R[Ee].command,Q)});return ne}async resolveCodeLens(M,O){const I=M.cacheId&&this._cache.get(...M.cacheId);if(!I)return;let R;if(typeof this._provider.resolveCodeLens!="function"||I.isResolved?R=I:R=await this._provider.resolveCodeLens(I,O),R||(R=I),O.isCancellationRequested)return;const x=M.cacheId&&this._disposables.get(M.cacheId[0]);if(!!x)return M.command=this._commands.toInternal(R.command??a._badCmd,x),M}releaseCodeLenses(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}}a._badCmd={command:"missing",title:"!!MISSING: command!!"};function T(fe){return Array.isArray(fe)?fe.map(w.DefinitionLink.from):fe?[w.DefinitionLink.from(fe)]:[]}class r{constructor(M,O){this._documents=M,this._provider=O}async provideDefinition(M,O,I){const R=this._documents.getDocument(M),x=w.Position.to(O),Q=await this._provider.provideDefinition(R,x,I);return T(Q)}}class i{constructor(M,O){this._documents=M,this._provider=O}async provideDeclaration(M,O,I){const R=this._documents.getDocument(M),x=w.Position.to(O),Q=await this._provider.provideDeclaration(R,x,I);return T(Q)}}class u{constructor(M,O){this._documents=M,this._provider=O}async provideImplementation(M,O,I){const R=this._documents.getDocument(M),x=w.Position.to(O),Q=await this._provider.provideImplementation(R,x,I);return T(Q)}}class t{constructor(M,O){this._documents=M,this._provider=O}async provideTypeDefinition(M,O,I){const R=this._documents.getDocument(M),x=w.Position.to(O),Q=await this._provider.provideTypeDefinition(R,x,I);return T(Q)}}class l{constructor(M,O){this._documents=M,this._provider=O}async provideHover(M,O,I){const R=this._documents.getDocument(M),x=w.Position.to(O),Q=await this._provider.provideHover(R,x,I);if(!(!Q||(0,F.isFalsyOrEmpty)(Q.contents)))return Q.range||(Q.range=R.getWordRangeAtPosition(x)),Q.range||(Q.range=new B.Range(x,x)),w.Hover.from(Q)}}class m{constructor(M,O){this._documents=M,this._provider=O}async provideEvaluatableExpression(M,O,I){const R=this._documents.getDocument(M),x=w.Position.to(O),Q=await this._provider.provideEvaluatableExpression(R,x,I);if(Q)return w.EvaluatableExpression.from(Q)}}class f{constructor(M,O){this._documents=M,this._provider=O}async provideInlineValues(M,O,I,R){const x=this._documents.getDocument(M),Q=await this._provider.provideInlineValues(x,w.Range.to(O),w.InlineValueContext.to(I),R);if(Array.isArray(Q))return Q.map(ne=>w.InlineValue.from(ne))}}class S{constructor(M,O){this._documents=M,this._provider=O}async provideDocumentHighlights(M,O,I){const R=this._documents.getDocument(M),x=w.Position.to(O),Q=await this._provider.provideDocumentHighlights(R,x,I);if(Array.isArray(Q))return Q.map(w.DocumentHighlight.from)}}class P{constructor(M,O){this._documents=M,this._provider=O}async provideLinkedEditingRanges(M,O,I){const R=this._documents.getDocument(M),x=w.Position.to(O),Q=await this._provider.provideLinkedEditingRanges(R,x,I);if(Q&&Array.isArray(Q.ranges))return{ranges:(0,F.coalesce)(Q.ranges.map(w.Range.from)),wordPattern:Q.wordPattern}}}class ${constructor(M,O){this._documents=M,this._provider=O}async provideReferences(M,O,I,R){const x=this._documents.getDocument(M),Q=w.Position.to(O),ne=await this._provider.provideReferences(x,Q,I,R);if(Array.isArray(ne))return ne.map(w.location.from)}}class L{constructor(M,O,I,R,x,Q,ne){this._documents=M,this._commands=O,this._diagnostics=I,this._provider=R,this._logService=x,this._extension=Q,this._apiDeprecation=ne,this._cache=new h.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(M,O,I,R){const x=this._documents.getDocument(M),Q=b.Selection.isISelection(O)?w.Selection.to(O):w.Range.to(O),ne=[];for(const Be of this._diagnostics.getDiagnostics(M))if(Q.intersection(Be.range)&&ne.push(Be)>L._maxCodeActionsPerFile)break;const Ee={diagnostics:ne,only:I.only?new B.CodeActionKind(I.only):void 0,triggerKind:w.CodeActionTriggerKind.to(I.trigger)},Ie=await this._provider.provideCodeActions(x,Q,Ee,R);if(!(0,F.isNonEmptyArray)(Ie)||R.isCancellationRequested)return;const Me=this._cache.add(Ie),Le=new g.DisposableStore;this._disposables.set(Me,Le);const ze=[];for(let Be=0;Be<Ie.length;Be++){const Ae=Ie[Be];!Ae||(L._isCommand(Ae)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),ze.push({_isSynthetic:!0,title:Ae.title,command:this._commands.toInternal(Ae,Le)})):(Ee.only&&(Ae.kind?Ee.only.contains(Ae.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action is of kind '${Ae.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Ee.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),ze.push({cacheId:[Me,Be],title:Ae.title,command:Ae.command&&this._commands.toInternal(Ae.command,Le),diagnostics:Ae.diagnostics&&Ae.diagnostics.map(w.Diagnostic.from),edit:Ae.edit&&w.WorkspaceEdit.from(Ae.edit),kind:Ae.kind&&Ae.kind.value,isPreferred:Ae.isPreferred,disabled:Ae.disabled?.reason})))}return{cacheId:Me,actions:ze}}async resolveCodeAction(M,O){const[I,R]=M,x=this._cache.get(I,R);if(!x||L._isCommand(x)||!this._provider.resolveCodeAction)return;const Q=await this._provider.resolveCodeAction(x,O)??x;return Q?.edit?w.WorkspaceEdit.from(Q.edit):void 0}releaseCodeActions(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}static _isCommand(M){return typeof M.command=="string"&&typeof M.title=="string"}}L._maxCodeActionsPerFile=1e3;class v{constructor(M,O){this._documents=M,this._provider=O}async provideDocumentFormattingEdits(M,O,I){const R=this._documents.getDocument(M),x=await this._provider.provideDocumentFormattingEdits(R,O,I);if(Array.isArray(x))return x.map(w.TextEdit.from)}}class H{constructor(M,O){this._documents=M,this._provider=O}async provideDocumentRangeFormattingEdits(M,O,I,R){const x=this._documents.getDocument(M),Q=w.Range.to(O),ne=await this._provider.provideDocumentRangeFormattingEdits(x,Q,I,R);if(Array.isArray(ne))return ne.map(w.TextEdit.from)}}class W{constructor(M,O){this._documents=M,this._provider=O,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,O,I,R,x){const Q=this._documents.getDocument(M),ne=w.Position.to(O),Ee=await this._provider.provideOnTypeFormattingEdits(Q,ne,I,R,x);if(Array.isArray(Ee))return Ee.map(w.TextEdit.from)}}class q{constructor(M,O){this._provider=M,this._logService=O,this._cache=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(M,O){const I=await this._provider.provideWorkspaceSymbols(M,O);if(!(0,F.isNonEmptyArray)(I))return{symbols:[]};const R=this._cache.add(I),x={cacheId:R,symbols:[]};for(let Q=0;Q<I.length;Q++){const ne=I[Q];if(!ne||!ne.name){this._logService.warn("INVALID SymbolInformation",ne);continue}x.symbols.push({...w.WorkspaceSymbol.from(ne),cacheId:[R,Q]})}return x}async resolveWorkspaceSymbol(M,O){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const I=this._cache.get(...M.cacheId);if(I){const R=await this._provider.resolveWorkspaceSymbol(I,O);return R&&(0,k.mixin)(M,w.WorkspaceSymbol.from(R),!0)}}releaseWorkspaceSymbols(M){this._cache.delete(M)}}class K{constructor(M,O,I){this._documents=M,this._provider=O,this._logService=I}static supportsResolving(M){return typeof M.prepareRename=="function"}async provideRenameEdits(M,O,I,R){const x=this._documents.getDocument(M),Q=w.Position.to(O);try{const ne=await this._provider.provideRenameEdits(x,Q,I,R);return ne?w.WorkspaceEdit.from(ne):void 0}catch(ne){const Ee=K._asMessage(ne);return Ee?{rejectReason:Ee,edits:void 0}:Promise.reject(ne)}}async resolveRenameLocation(M,O,I){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const R=this._documents.getDocument(M),x=w.Position.to(O);try{const Q=await this._provider.prepareRename(R,x,I);let ne,Ee;if(B.Range.isRange(Q)?(ne=Q,Ee=R.getText(Q)):(0,N.isObject)(Q)&&(ne=Q.range,Ee=Q.placeholder),!ne||!Ee)return;if(ne.start.line>x.line||ne.end.line<x.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:w.Range.from(ne),text:Ee}}catch(Q){const ne=K._asMessage(Q);return ne?{rejectReason:ne,range:void 0,text:void 0}:Promise.reject(Q)}}static _asMessage(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class V{constructor(M,O){this.resultId=M,this.tokens=O}}class z{constructor(M,O){this._documents=M,this._provider=O,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(M,O,I){const R=this._documents.getDocument(M),x=O!==0?this._previousResults.get(O):null;let Q=typeof x?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(R,x.resultId,I):await this._provider.provideDocumentSemanticTokens(R,I);return x&&this._previousResults.delete(O),Q?(Q=z._fixProvidedSemanticTokens(Q),this._send(z._convertToEdits(x,Q),Q)):null}async releaseDocumentSemanticColoring(M){this._previousResults.delete(M)}static _fixProvidedSemanticTokens(M){return z._isSemanticTokens(M)?z._isCorrectSemanticTokens(M)?M:new B.SemanticTokens(new Uint32Array(M.data),M.resultId):z._isSemanticTokensEdits(M)?z._isCorrectSemanticTokensEdits(M)?M:new B.SemanticTokensEdits(M.edits.map(O=>new B.SemanticTokensEdit(O.start,O.deleteCount,O.data?new Uint32Array(O.data):O.data)),M.resultId):M}static _isSemanticTokens(M){return M&&!!M.data}static _isCorrectSemanticTokens(M){return M.data instanceof Uint32Array}static _isSemanticTokensEdits(M){return M&&Array.isArray(M.edits)}static _isCorrectSemanticTokensEdits(M){for(const O of M.edits)if(!(O.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(M,O){if(!z._isSemanticTokens(O)||!M||!M.tokens)return O;const I=M.tokens,R=I.length,x=O.data,Q=x.length;let ne=0;const Ee=Math.min(R,Q);for(;ne<Ee&&I[ne]===x[ne];)ne++;if(ne===R&&ne===Q)return new B.SemanticTokensEdits([],O.resultId);let Ie=0;const Me=Ee-ne;for(;Ie<Me&&I[R-Ie-1]===x[Q-Ie-1];)Ie++;return new B.SemanticTokensEdits([{start:ne,deleteCount:R-ne-Ie,data:x.subarray(ne,Q-Ie)}],O.resultId)}_send(M,O){if(z._isSemanticTokens(M)){const I=this._nextResultId++;return this._previousResults.set(I,new V(M.resultId,M.data)),(0,s.encodeSemanticTokensDto)({id:I,type:"full",data:M.data})}if(z._isSemanticTokensEdits(M)){const I=this._nextResultId++;return z._isSemanticTokens(O)?this._previousResults.set(I,new V(O.resultId,O.data)):this._previousResults.set(I,new V(M.resultId)),(0,s.encodeSemanticTokensDto)({id:I,type:"delta",deltas:(M.edits||[]).map(R=>({start:R.start,deleteCount:R.deleteCount,data:R.data}))})}return null}}e.DocumentSemanticTokensAdapter=z;class ae{constructor(M,O){this._documents=M,this._provider=O}async provideDocumentRangeSemanticTokens(M,O,I){const R=this._documents.getDocument(M),x=await this._provider.provideDocumentRangeSemanticTokens(R,w.Range.to(O),I);return x?this._send(x):null}_send(M){return(0,s.encodeSemanticTokensDto)({id:0,type:"full",data:M.data})}}e.DocumentRangeSemanticTokensAdapter=ae;class de{constructor(M,O,I,R,x){this._documents=M,this._commands=O,this._provider=I,this._apiDeprecation=R,this._extension=x,this._cache=new h.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}async provideCompletionItems(M,O,I,R){const x=this._documents.getDocument(M),Q=w.Position.to(O),ne=x.getWordRangeAtPosition(Q)||new B.Range(Q,Q),Ee=ne.with({end:Q}),Ie=new _.StopWatch(!0),Me=await this._provider.provideCompletionItems(x,Q,R,w.CompletionContext.to(I));if(!Me||R.isCancellationRequested)return;const Le=Array.isArray(Me)?new B.CompletionList(Me):Me,ze=de.supportsResolving(this._provider)?this._cache.add(Le.items):this._cache.add([]),Be=new g.DisposableStore;this._disposables.set(ze,Be);const Ae=[],Qe={x:ze,b:Ae,a:{replace:w.Range.from(ne),insert:w.Range.from(Ee)},c:Le.isIncomplete||void 0,d:Ie.elapsed()};for(let tt=0;tt<Le.items.length;tt++){const ke=Le.items[tt],it=this._convertCompletionItem(ke,[ze,tt],Ee,ne);Ae.push(it)}return Qe}async resolveCompletionItem(M,O){if(typeof this._provider.resolveCompletionItem!="function")return;const I=this._cache.get(...M);if(!I)return;const R=await this._provider.resolveCompletionItem(I,O);if(!!R)return this._convertCompletionItem(R,M)}releaseCompletionItems(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_convertCompletionItem(M,O,I,R){const x=this._disposables.get(O[0]);if(!x)throw Error("DisposableStore is missing...");const Q={x:O,a:M.label,b:M.kind!==void 0?w.CompletionItemKind.from(M.kind):void 0,n:M.tags&&M.tags.map(w.CompletionItemTag.from),c:M.detail,d:typeof M.documentation=="undefined"?void 0:w.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters,l:M.additionalTextEdits&&M.additionalTextEdits.map(w.TextEdit.from),m:this._commands.toInternal(M.command,x)};M.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Q.h=M.textEdit.newText):typeof M.insertText=="string"?Q.h=M.insertText:M.insertText instanceof B.SnippetString&&(Q.h=M.insertText.value,Q.i|=4);let ne;return M.textEdit?ne=M.textEdit.range:M.range&&(ne=M.range),B.Range.isRange(ne)?Q.j=w.Range.from(ne):ne&&(!I?.isEqual(ne.inserting)||!R?.isEqual(ne.replacing))&&(Q.j={insert:w.Range.from(ne.inserting),replace:w.Range.from(ne.replacing)}),Q}}class Y{constructor(M,O,I){this._documents=M,this._provider=O,this._commands=I,this._cache=new h.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(M,O,I,R){const x=this._documents.getDocument(M),Q=w.Position.to(O),ne=await this._provider.provideInlineCompletionItems(x,Q,{selectedCompletionInfo:I.selectedSuggestionInfo?{range:w.Range.to(I.selectedSuggestionInfo.range),text:I.selectedSuggestionInfo.text,isSnippetText:I.selectedSuggestionInfo.isSnippetText,completionKind:w.CompletionItemKind.to(I.selectedSuggestionInfo.completionKind)}:void 0,triggerKind:I.triggerKind},R);if(!ne||R.isCancellationRequested)return;const Ee=(0,N.isArray)(ne)?ne:ne.items,Ie=this._cache.add(Ee);let Me;return{pid:Ie,items:Ee.map((Le,ze)=>{let Be;Le.command&&(Me||(Me=new g.DisposableStore,this._disposables.set(Ie,Me)),Be=this._commands.toInternal(Le.command,Me));const Ae=Le.insertText??Le.text;if(Ae===void 0)throw new Error("text or insertText must be defined");return{text:typeof Ae=="string"?Ae:{snippet:Ae.value},range:Le.range?w.Range.from(Le.range):void 0,command:Be,idx:ze,completeBracketPairs:Le.completeBracketPairs}})}}disposeCompletions(M){this._cache.delete(M);const O=this._disposables.get(M);O&&O.clear(),this._disposables.delete(M)}handleDidShowCompletionItem(M,O){const I=this._cache.get(M,O);I&&ie.get(this._provider).fireOnDidShowCompletionItem({completionItem:I})}}class ie{constructor(){this._onDidShowCompletionItemEmitter=new d.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(M){let O=ie.map.get(M);return O||(O=new ie,ie.map.set(M,O)),O}fireOnDidShowCompletionItem(M){this._onDidShowCompletionItemEmitter.fire(M)}}e.InlineCompletionController=ie,ie.map=new WeakMap;class ce{constructor(M,O){this._documents=M,this._provider=O,this._cache=new h.Cache("SignatureHelp")}async provideSignatureHelp(M,O,I,R){const x=this._documents.getDocument(M),Q=w.Position.to(O),ne=this.reviveContext(I),Ee=await this._provider.provideSignatureHelp(x,Q,R,ne);if(Ee){const Ie=this._cache.add([Ee]);return{...w.SignatureHelp.from(Ee),id:Ie}}}reviveContext(M){let O;if(M.activeSignatureHelp){const I=w.SignatureHelp.to(M.activeSignatureHelp),R=this._cache.get(M.activeSignatureHelp.id,0);R?(O=R,O.activeSignature=I.activeSignature,O.activeParameter=I.activeParameter):O=I}return{...M,activeSignatureHelp:O}}releaseSignatureHelp(M){this._cache.delete(M)}}class he{constructor(M,O,I,R,x){this._documents=M,this._commands=O,this._provider=I,this._logService=R,this._extension=x,this._cache=new h.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(M,O,I){const R=this._documents.getDocument(M),x=w.Range.to(O),Q=await this._provider.provideInlayHints(R,x,I);if(!Array.isArray(Q)||Q.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${O}`);return}if(I.isCancellationRequested)return;const ne=this._cache.add(Q);this._disposables.set(ne,new g.DisposableStore);const Ee={hints:[],cacheId:ne};for(let Ie=0;Ie<Q.length;Ie++)this._isValidInlayHint(Q[Ie],x)&&Ee.hints.push(this._convertInlayHint(Q[Ie],[ne,Ie]));return this._logService.trace(`[InlayHints] ${Ee.hints.length} inlay hints from '${this._extension.identifier.value}' for ${O}`),Ee}async resolveInlayHint(M,O){if(typeof this._provider.resolveInlayHint!="function")return;const I=this._cache.get(...M);if(!I)return;const R=await this._provider.resolveInlayHint(I,O);if(!!R&&!!this._isValidInlayHint(R))return this._convertInlayHint(R,M)}releaseHints(M){this._disposables.get(M)?.dispose(),this._disposables.delete(M),this._cache.delete(M)}_isValidInlayHint(M,O){return M.label.length===0||Array.isArray(M.label)&&M.label.every(I=>I.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(O&&!O.contains(M.position))}_convertInlayHint(M,O){const I=this._disposables.get(O[0]);if(!I)throw Error("DisposableStore is missing...");const R={label:"",cacheId:O,tooltip:w.MarkdownString.fromStrict(M.tooltip),position:w.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(w.TextEdit.from),kind:M.kind&&w.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?R.label=M.label:R.label=M.label.map(x=>{let Q={label:x.value};return Q.tooltip=w.MarkdownString.fromStrict(x.tooltip),B.Location.isLocation(x.location)&&(Q.location=w.location.from(x.location)),x.command&&(Q.command=this._commands.toInternal(x.command,I)),Q}),R}}class ue{constructor(M,O){this._documents=M,this._provider=O,this._cache=new h.Cache("DocumentLink")}async provideLinks(M,O){const I=this._documents.getDocument(M),R=await this._provider.provideDocumentLinks(I,O);if(!(!Array.isArray(R)||R.length===0)&&!O.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:R.filter(ue._validateLink).map(w.DocumentLink.from)};{const x=this._cache.add(R),Q={links:[],cacheId:x};for(let ne=0;ne<R.length;ne++){if(!ue._validateLink(R[ne]))continue;const Ee=w.DocumentLink.from(R[ne]);Ee.cacheId=[x,ne],Q.links.push(Ee)}return Q}}}static _validateLink(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,O){if(typeof this._provider.resolveDocumentLink!="function")return;const I=this._cache.get(...M);if(!I)return;const R=await this._provider.resolveDocumentLink(I,O);if(!(!R||!ue._validateLink(R)))return w.DocumentLink.from(R)}releaseLinks(M){this._cache.delete(M)}}class se{constructor(M,O){this._documents=M,this._provider=O}async provideColors(M,O){const I=this._documents.getDocument(M),R=await this._provider.provideDocumentColors(I,O);return Array.isArray(R)?R.map(Q=>({color:w.Color.from(Q.color),range:w.Range.from(Q.range)})):[]}async provideColorPresentations(M,O,I){const R=this._documents.getDocument(M),x=w.Range.to(O.range),Q=w.Color.to(O.color),ne=await this._provider.provideColorPresentations(Q,{document:R,range:x},I);if(!!Array.isArray(ne))return ne.map(w.ColorPresentation.from)}}class ge{constructor(M,O){this._documents=M,this._provider=O}async provideFoldingRanges(M,O,I){const R=this._documents.getDocument(M),x=await this._provider.provideFoldingRanges(R,O,I);if(!!Array.isArray(x))return x.map(w.FoldingRange.from)}}class Te{constructor(M,O,I){this._documents=M,this._provider=O,this._logService=I}async provideSelectionRanges(M,O,I){const R=this._documents.getDocument(M),x=O.map(w.Position.to),Q=await this._provider.provideSelectionRanges(R,x,I);if(!(0,F.isNonEmptyArray)(Q))return[];if(Q.length!==x.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const ne=[];for(let Ee=0;Ee<x.length;Ee++){const Ie=[];ne.push(Ie);let Me=x[Ee],Le=Q[Ee];for(;;){if(!Le.range.contains(Me))throw new Error("INVALID selection range, must contain the previous range");if(Ie.push(w.SelectionRange.from(Le)),!Le.parent)break;Me=Le.range,Le=Le.parent}}return ne}}class Re{constructor(M,O){this._documents=M,this._provider=O,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(M,O,I){const R=this._documents.getDocument(M),x=w.Position.to(O),Q=await this._provider.prepareCallHierarchy(R,x,I);if(!Q)return;const ne=this._idPool.nextId();return this._cache.set(ne,new Map),Array.isArray(Q)?Q.map(Ee=>this._cacheAndConvertItem(ne,Ee)):[this._cacheAndConvertItem(ne,Q)]}async provideCallsTo(M,O,I){const R=this._itemFromCache(M,O);if(!R)throw new Error("missing call hierarchy item");const x=await this._provider.provideCallHierarchyIncomingCalls(R,I);if(!!x)return x.map(Q=>({from:this._cacheAndConvertItem(M,Q.from),fromRanges:Q.fromRanges.map(ne=>w.Range.from(ne))}))}async provideCallsFrom(M,O,I){const R=this._itemFromCache(M,O);if(!R)throw new Error("missing call hierarchy item");const x=await this._provider.provideCallHierarchyOutgoingCalls(R,I);if(!!x)return x.map(Q=>({to:this._cacheAndConvertItem(M,Q.to),fromRanges:Q.fromRanges.map(ne=>w.Range.from(ne))}))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,O){const I=this._cache.get(M),R=w.CallHierarchyItem.from(O,M,I.size.toString(36));return I.set(R._itemId,O),R}_itemFromCache(M,O){return this._cache.get(M)?.get(O)}}class He{constructor(M,O){this._documents=M,this._provider=O,this._idPool=new n.IdGenerator(""),this._cache=new Map}async prepareSession(M,O,I){const R=this._documents.getDocument(M),x=w.Position.to(O),Q=await this._provider.prepareTypeHierarchy(R,x,I);if(!Q)return;const ne=this._idPool.nextId();return this._cache.set(ne,new Map),Array.isArray(Q)?Q.map(Ee=>this._cacheAndConvertItem(ne,Ee)):[this._cacheAndConvertItem(ne,Q)]}async provideSupertypes(M,O,I){const R=this._itemFromCache(M,O);if(!R)throw new Error("missing type hierarchy item");const x=await this._provider.provideTypeHierarchySupertypes(R,I);if(!!x)return x.map(Q=>this._cacheAndConvertItem(M,Q))}async provideSubtypes(M,O,I){const R=this._itemFromCache(M,O);if(!R)throw new Error("missing type hierarchy item");const x=await this._provider.provideTypeHierarchySubtypes(R,I);if(!!x)return x.map(Q=>this._cacheAndConvertItem(M,Q))}releaseSession(M){this._cache.delete(M)}_cacheAndConvertItem(M,O){const I=this._cache.get(M),R=w.TypeHierarchyItem.from(O,M,I.size.toString(36));return I.set(R._itemId,O),R}_itemFromCache(M,O){return this._cache.get(M)?.get(O)}}class Xe{constructor(M,O){this.adapter=M,this.extension=O}}class ve{constructor(M,O,I,R,x,Q,ne){this._adapter=new Map,this._uriTransformer=O,this._proxy=M.getProxy(C.MainContext.MainThreadLanguageFeatures),this._documents=I,this._commands=R,this._diagnostics=x,this._logService=Q,this._apiDeprecation=ne}_transformDocumentSelector(M){return w.DocumentSelector.from(M,this._uriTransformer)}_createDisposable(M){return new B.Disposable(()=>{this._adapter.delete(M),this._proxy.$unregister(M)})}_nextHandle(){return ve._handlePool++}async _withAdapter(M,O,I,R,x){const Q=this._adapter.get(M);if(!Q||!(Q.adapter instanceof O))return R;const ne=Date.now();this._logService.trace(`[${Q.extension.identifier.value}] INVOKE provider '${I.toString().replace(/[\r\n]/g,"")}'`);const Ee=I(Q.adapter,Q.extension);return Promise.resolve(Ee).catch(Ie=>{(0,y.isCancellationError)(Ie)||(this._logService.error(`[${Q.extension.identifier.value}] provider FAILED`),this._logService.error(Ie))}).finally(()=>{this._logService.trace(`[${Q.extension.identifier.value}] provider DONE after ${Date.now()-ne}ms`)}),c.CancellationToken.isCancellationToken(x)?(0,p.raceCancellationError)(Ee,x):Ee}_addNewAdapter(M,O){const I=this._nextHandle();return this._adapter.set(I,new Xe(M,O)),I}static _extLabel(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,O,I,R){const x=this._addNewAdapter(new E(this._documents,I),M),Q=R&&R.label||ve._extLabel(M);return this._proxy.$registerDocumentSymbolProvider(x,this._transformDocumentSelector(O),Q),this._createDisposable(x)}$provideDocumentSymbols(M,O,I){return this._withAdapter(M,E,R=>R.provideDocumentSymbols(o.URI.revive(O),I),void 0,I)}registerCodeLensProvider(M,O,I){const R=this._nextHandle(),x=typeof I.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(R,new Xe(new a(this._documents,this._commands.converter,I),M)),this._proxy.$registerCodeLensSupport(R,this._transformDocumentSelector(O),x);let Q=this._createDisposable(R);if(x!==void 0){const ne=I.onDidChangeCodeLenses(Ee=>this._proxy.$emitCodeLensEvent(x));Q=B.Disposable.from(Q,ne)}return Q}$provideCodeLenses(M,O,I){return this._withAdapter(M,a,R=>R.provideCodeLenses(o.URI.revive(O),I),void 0,I)}$resolveCodeLens(M,O,I){return this._withAdapter(M,a,R=>R.resolveCodeLens(O,I),void 0,void 0)}$releaseCodeLenses(M,O){this._withAdapter(M,a,I=>Promise.resolve(I.releaseCodeLenses(O)),void 0,void 0)}registerDefinitionProvider(M,O,I){const R=this._addNewAdapter(new r(this._documents,I),M);return this._proxy.$registerDefinitionSupport(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideDefinition(M,O,I,R){return this._withAdapter(M,r,x=>x.provideDefinition(o.URI.revive(O),I,R),[],R)}registerDeclarationProvider(M,O,I){const R=this._addNewAdapter(new i(this._documents,I),M);return this._proxy.$registerDeclarationSupport(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideDeclaration(M,O,I,R){return this._withAdapter(M,i,x=>x.provideDeclaration(o.URI.revive(O),I,R),[],R)}registerImplementationProvider(M,O,I){const R=this._addNewAdapter(new u(this._documents,I),M);return this._proxy.$registerImplementationSupport(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideImplementation(M,O,I,R){return this._withAdapter(M,u,x=>x.provideImplementation(o.URI.revive(O),I,R),[],R)}registerTypeDefinitionProvider(M,O,I){const R=this._addNewAdapter(new t(this._documents,I),M);return this._proxy.$registerTypeDefinitionSupport(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideTypeDefinition(M,O,I,R){return this._withAdapter(M,t,x=>x.provideTypeDefinition(o.URI.revive(O),I,R),[],R)}registerHoverProvider(M,O,I,R){const x=this._addNewAdapter(new l(this._documents,I),M);return this._proxy.$registerHoverProvider(x,this._transformDocumentSelector(O)),this._createDisposable(x)}$provideHover(M,O,I,R){return this._withAdapter(M,l,x=>x.provideHover(o.URI.revive(O),I,R),void 0,R)}registerEvaluatableExpressionProvider(M,O,I,R){const x=this._addNewAdapter(new m(this._documents,I),M);return this._proxy.$registerEvaluatableExpressionProvider(x,this._transformDocumentSelector(O)),this._createDisposable(x)}$provideEvaluatableExpression(M,O,I,R){return this._withAdapter(M,m,x=>x.provideEvaluatableExpression(o.URI.revive(O),I,R),void 0,R)}registerInlineValuesProvider(M,O,I,R){const x=typeof I.onDidChangeInlineValues=="function"?this._nextHandle():void 0,Q=this._addNewAdapter(new f(this._documents,I),M);this._proxy.$registerInlineValuesProvider(Q,this._transformDocumentSelector(O),x);let ne=this._createDisposable(Q);if(x!==void 0){const Ee=I.onDidChangeInlineValues(Ie=>this._proxy.$emitInlineValuesEvent(x));ne=B.Disposable.from(ne,Ee)}return ne}$provideInlineValues(M,O,I,R,x){return this._withAdapter(M,f,Q=>Q.provideInlineValues(o.URI.revive(O),I,R,x),void 0,x)}registerDocumentHighlightProvider(M,O,I){const R=this._addNewAdapter(new S(this._documents,I),M);return this._proxy.$registerDocumentHighlightProvider(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideDocumentHighlights(M,O,I,R){return this._withAdapter(M,S,x=>x.provideDocumentHighlights(o.URI.revive(O),I,R),void 0,R)}registerLinkedEditingRangeProvider(M,O,I){const R=this._addNewAdapter(new P(this._documents,I),M);return this._proxy.$registerLinkedEditingRangeProvider(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideLinkedEditingRanges(M,O,I,R){return this._withAdapter(M,P,async x=>{const Q=await x.provideLinkedEditingRanges(o.URI.revive(O),I,R);if(Q)return{ranges:Q.ranges,wordPattern:Q.wordPattern?ve._serializeRegExp(Q.wordPattern):void 0}},void 0,R)}registerReferenceProvider(M,O,I){const R=this._addNewAdapter(new $(this._documents,I),M);return this._proxy.$registerReferenceSupport(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideReferences(M,O,I,R,x){return this._withAdapter(M,$,Q=>Q.provideReferences(o.URI.revive(O),I,R,x),void 0,x)}registerCodeActionProvider(M,O,I,R){const x=new g.DisposableStore,Q=this._addNewAdapter(new L(this._documents,this._commands.converter,this._diagnostics,I,this._logService,M,this._apiDeprecation),M);return this._proxy.$registerQuickFixSupport(Q,this._transformDocumentSelector(O),{providedKinds:R?.providedCodeActionKinds?.map(ne=>ne.value),documentation:R?.documentation?.map(ne=>({kind:ne.kind.value,command:this._commands.converter.toInternal(ne.command,x)}))},ve._extLabel(M),Boolean(I.resolveCodeAction)),x.add(this._createDisposable(Q)),x}$provideCodeActions(M,O,I,R,x){return this._withAdapter(M,L,Q=>Q.provideCodeActions(o.URI.revive(O),I,R,x),void 0,x)}$resolveCodeAction(M,O,I){return this._withAdapter(M,L,R=>R.resolveCodeAction(O,I),void 0,void 0)}$releaseCodeActions(M,O){this._withAdapter(M,L,I=>Promise.resolve(I.releaseCodeActions(O)),void 0,void 0)}registerDocumentFormattingEditProvider(M,O,I){const R=this._addNewAdapter(new v(this._documents,I),M);return this._proxy.$registerDocumentFormattingSupport(R,this._transformDocumentSelector(O),M.identifier,M.displayName||M.name),this._createDisposable(R)}$provideDocumentFormattingEdits(M,O,I,R){return this._withAdapter(M,v,x=>x.provideDocumentFormattingEdits(o.URI.revive(O),I,R),void 0,R)}registerDocumentRangeFormattingEditProvider(M,O,I){const R=this._addNewAdapter(new H(this._documents,I),M);return this._proxy.$registerRangeFormattingSupport(R,this._transformDocumentSelector(O),M.identifier,M.displayName||M.name),this._createDisposable(R)}$provideDocumentRangeFormattingEdits(M,O,I,R,x){return this._withAdapter(M,H,Q=>Q.provideDocumentRangeFormattingEdits(o.URI.revive(O),I,R,x),void 0,x)}registerOnTypeFormattingEditProvider(M,O,I,R){const x=this._addNewAdapter(new W(this._documents,I),M);return this._proxy.$registerOnTypeFormattingSupport(x,this._transformDocumentSelector(O),R,M.identifier),this._createDisposable(x)}$provideOnTypeFormattingEdits(M,O,I,R,x,Q){return this._withAdapter(M,W,ne=>ne.provideOnTypeFormattingEdits(o.URI.revive(O),I,R,x,Q),void 0,Q)}registerWorkspaceSymbolProvider(M,O){const I=this._addNewAdapter(new q(O,this._logService),M);return this._proxy.$registerNavigateTypeSupport(I,typeof O.resolveWorkspaceSymbol=="function"),this._createDisposable(I)}$provideWorkspaceSymbols(M,O,I){return this._withAdapter(M,q,R=>R.provideWorkspaceSymbols(O,I),{symbols:[]},I)}$resolveWorkspaceSymbol(M,O,I){return this._withAdapter(M,q,R=>R.resolveWorkspaceSymbol(O,I),void 0,void 0)}$releaseWorkspaceSymbols(M,O){this._withAdapter(M,q,I=>I.releaseWorkspaceSymbols(O),void 0,void 0)}registerRenameProvider(M,O,I){const R=this._addNewAdapter(new K(this._documents,I,this._logService),M);return this._proxy.$registerRenameSupport(R,this._transformDocumentSelector(O),K.supportsResolving(I)),this._createDisposable(R)}$provideRenameEdits(M,O,I,R,x){return this._withAdapter(M,K,Q=>Q.provideRenameEdits(o.URI.revive(O),I,R,x),void 0,x)}$resolveRenameLocation(M,O,I,R){return this._withAdapter(M,K,x=>x.resolveRenameLocation(o.URI.revive(O),I,R),void 0,R)}registerDocumentSemanticTokensProvider(M,O,I,R){const x=this._addNewAdapter(new z(this._documents,I),M),Q=typeof I.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(x,this._transformDocumentSelector(O),R,Q);let ne=this._createDisposable(x);if(Q){const Ee=I.onDidChangeSemanticTokens(Ie=>this._proxy.$emitDocumentSemanticTokensEvent(Q));ne=B.Disposable.from(ne,Ee)}return ne}$provideDocumentSemanticTokens(M,O,I,R){return this._withAdapter(M,z,x=>x.provideDocumentSemanticTokens(o.URI.revive(O),I,R),null,R)}$releaseDocumentSemanticTokens(M,O){this._withAdapter(M,z,I=>I.releaseDocumentSemanticColoring(O),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,O,I,R){const x=this._addNewAdapter(new ae(this._documents,I),M);return this._proxy.$registerDocumentRangeSemanticTokensProvider(x,this._transformDocumentSelector(O),R),this._createDisposable(x)}$provideDocumentRangeSemanticTokens(M,O,I,R){return this._withAdapter(M,ae,x=>x.provideDocumentRangeSemanticTokens(o.URI.revive(O),I,R),null,R)}registerCompletionItemProvider(M,O,I,R){const x=this._addNewAdapter(new de(this._documents,this._commands.converter,I,this._apiDeprecation,M),M);return this._proxy.$registerSuggestSupport(x,this._transformDocumentSelector(O),R,de.supportsResolving(I),`${M.identifier.value}(${R.join("")})`),this._createDisposable(x)}$provideCompletionItems(M,O,I,R,x){return this._withAdapter(M,de,Q=>Q.provideCompletionItems(o.URI.revive(O),I,R,x),void 0,x)}$resolveCompletionItem(M,O,I){return this._withAdapter(M,de,R=>R.resolveCompletionItem(O,I),void 0,I)}$releaseCompletionItems(M,O){this._withAdapter(M,de,I=>I.releaseCompletionItems(O),void 0,void 0)}registerInlineCompletionsProvider(M,O,I){const R=this._addNewAdapter(new Y(this._documents,I,this._commands.converter),M);return this._proxy.$registerInlineCompletionsSupport(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideInlineCompletions(M,O,I,R,x){return this._withAdapter(M,Y,Q=>Q.provideInlineCompletions(o.URI.revive(O),I,R,x),void 0,x)}$handleInlineCompletionDidShow(M,O,I){this._withAdapter(M,Y,async R=>{R.handleDidShowCompletionItem(O,I)},void 0,void 0)}$freeInlineCompletionsList(M,O){this._withAdapter(M,Y,async I=>{I.disposeCompletions(O)},void 0,void 0)}registerSignatureHelpProvider(M,O,I,R){const x=Array.isArray(R)?{triggerCharacters:R,retriggerCharacters:[]}:R,Q=this._addNewAdapter(new ce(this._documents,I),M);return this._proxy.$registerSignatureHelpProvider(Q,this._transformDocumentSelector(O),x),this._createDisposable(Q)}$provideSignatureHelp(M,O,I,R,x){return this._withAdapter(M,ce,Q=>Q.provideSignatureHelp(o.URI.revive(O),I,R,x),void 0,x)}$releaseSignatureHelp(M,O){this._withAdapter(M,ce,I=>I.releaseSignatureHelp(O),void 0,void 0)}registerInlayHintsProvider(M,O,I){const R=typeof I.onDidChangeInlayHints=="function"?this._nextHandle():void 0,x=this._addNewAdapter(new he(this._documents,this._commands.converter,I,this._logService,M),M);this._proxy.$registerInlayHintsProvider(x,this._transformDocumentSelector(O),typeof I.resolveInlayHint=="function",R,ve._extLabel(M));let Q=this._createDisposable(x);if(R!==void 0){const ne=I.onDidChangeInlayHints(Ee=>this._proxy.$emitInlayHintsEvent(R));Q=B.Disposable.from(Q,ne)}return Q}$provideInlayHints(M,O,I,R){return this._withAdapter(M,he,x=>x.provideInlayHints(o.URI.revive(O),I,R),void 0,R)}$resolveInlayHint(M,O,I){return this._withAdapter(M,he,R=>R.resolveInlayHint(O,I),void 0,I)}$releaseInlayHints(M,O){this._withAdapter(M,he,I=>I.releaseHints(O),void 0,void 0)}registerDocumentLinkProvider(M,O,I){const R=this._addNewAdapter(new ue(this._documents,I),M);return this._proxy.$registerDocumentLinkProvider(R,this._transformDocumentSelector(O),typeof I.resolveDocumentLink=="function"),this._createDisposable(R)}$provideDocumentLinks(M,O,I){return this._withAdapter(M,ue,R=>R.provideLinks(o.URI.revive(O),I),void 0,I)}$resolveDocumentLink(M,O,I){return this._withAdapter(M,ue,R=>R.resolveLink(O,I),void 0,void 0)}$releaseDocumentLinks(M,O){this._withAdapter(M,ue,I=>I.releaseLinks(O),void 0,void 0)}registerColorProvider(M,O,I){const R=this._addNewAdapter(new se(this._documents,I),M);return this._proxy.$registerDocumentColorProvider(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideDocumentColors(M,O,I){return this._withAdapter(M,se,R=>R.provideColors(o.URI.revive(O),I),[],I)}$provideColorPresentations(M,O,I,R){return this._withAdapter(M,se,x=>x.provideColorPresentations(o.URI.revive(O),I,R),void 0,R)}registerFoldingRangeProvider(M,O,I){const R=this._nextHandle(),x=typeof I.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(R,new Xe(new ge(this._documents,I),M)),this._proxy.$registerFoldingRangeProvider(R,this._transformDocumentSelector(O),x);let Q=this._createDisposable(R);if(x!==void 0){const ne=I.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(x));Q=B.Disposable.from(Q,ne)}return Q}$provideFoldingRanges(M,O,I,R){return this._withAdapter(M,ge,x=>x.provideFoldingRanges(o.URI.revive(O),I,R),void 0,R)}registerSelectionRangeProvider(M,O,I){const R=this._addNewAdapter(new Te(this._documents,I,this._logService),M);return this._proxy.$registerSelectionRangeProvider(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$provideSelectionRanges(M,O,I,R){return this._withAdapter(M,Te,x=>x.provideSelectionRanges(o.URI.revive(O),I,R),[],R)}registerCallHierarchyProvider(M,O,I){const R=this._addNewAdapter(new Re(this._documents,I),M);return this._proxy.$registerCallHierarchyProvider(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$prepareCallHierarchy(M,O,I,R){return this._withAdapter(M,Re,x=>Promise.resolve(x.prepareSession(o.URI.revive(O),I,R)),void 0,R)}$provideCallHierarchyIncomingCalls(M,O,I,R){return this._withAdapter(M,Re,x=>x.provideCallsTo(O,I,R),void 0,R)}$provideCallHierarchyOutgoingCalls(M,O,I,R){return this._withAdapter(M,Re,x=>x.provideCallsFrom(O,I,R),void 0,R)}$releaseCallHierarchy(M,O){this._withAdapter(M,Re,I=>Promise.resolve(I.releaseSession(O)),void 0,void 0)}registerTypeHierarchyProvider(M,O,I){const R=this._addNewAdapter(new He(this._documents,I),M);return this._proxy.$registerTypeHierarchyProvider(R,this._transformDocumentSelector(O)),this._createDisposable(R)}$prepareTypeHierarchy(M,O,I,R){return this._withAdapter(M,He,x=>Promise.resolve(x.prepareSession(o.URI.revive(O),I,R)),void 0,R)}$provideTypeHierarchySupertypes(M,O,I,R){return this._withAdapter(M,He,x=>x.provideSupertypes(O,I,R),void 0,R)}$provideTypeHierarchySubtypes(M,O,I,R){return this._withAdapter(M,He,x=>x.provideSubtypes(O,I,R),void 0,R)}$releaseTypeHierarchy(M,O){this._withAdapter(M,He,I=>Promise.resolve(I.releaseSession(O)),void 0,void 0)}static _serializeRegExp(M){return{pattern:M.source,flags:(0,A.regExpFlags)(M)}}static _serializeIndentationRule(M){return{decreaseIndentPattern:ve._serializeRegExp(M.decreaseIndentPattern),increaseIndentPattern:ve._serializeRegExp(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?ve._serializeRegExp(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?ve._serializeRegExp(M.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(M){return{beforeText:ve._serializeRegExp(M.beforeText),afterText:M.afterText?ve._serializeRegExp(M.afterText):void 0,previousLineText:M.previousLineText?ve._serializeRegExp(M.previousLineText):void 0,action:M.action}}static _serializeOnEnterRules(M){return M.map(ve._serializeOnEnterRule)}setLanguageConfiguration(M,O,I){let{wordPattern:R}=I;if(R&&(0,A.regExpLeadsToEndlessLoop)(R))throw new Error(`Invalid language configuration: wordPattern '${R}' is not allowed to match the empty string.`);R?this._documents.setWordDefinitionFor(O,R):this._documents.setWordDefinitionFor(O,void 0),I.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),I.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",M,"Do not use.");const x=this._nextHandle(),Q={comments:I.comments,brackets:I.brackets,wordPattern:I.wordPattern?ve._serializeRegExp(I.wordPattern):void 0,indentationRules:I.indentationRules?ve._serializeIndentationRule(I.indentationRules):void 0,onEnterRules:I.onEnterRules?ve._serializeOnEnterRules(I.onEnterRules):void 0,__electricCharacterSupport:I.__electricCharacterSupport,__characterPairSupport:I.__characterPairSupport};return this._proxy.$setLanguageConfiguration(x,O,Q),this._createDisposable(x)}$setWordDefinitions(M){for(const O of M)this._documents.setWordDefinitionFor(O.languageId,new RegExp(O.regexSource,O.regexFlags))}}e.ExtHostLanguageFeatures=ve,ve._handlePool=0}),define(we[192],be([1,0,4,8,6,34,13,7]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(N,b,c,g){this._documents=b,this._commands=c,this._uriTransformer=g,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=N.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(N){this._languageIds=N}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(N,b){await this._proxy.$changeLanguage(N,b);const c=this._documents.getDocumentData(N);if(!c)throw new Error(`document '${N.toString()}' NOT found`);return c.document}async tokenAtPosition(N,b){const c=N.version,g=k.Position.from(b),s=await this._proxy.$tokensAtPosition(N.uri,g),n={type:w.StandardTokenType.Other,range:N.getWordRangeAtPosition(b)??new w.Range(b.line,b.character,b.line,b.character)};if(!s)return n;const h={range:k.Range.to(s.range),type:k.TokenType.to(s.type)};return!h.range.contains(b)||c!==N.version?n:h}createLanguageStatusItem(N,b,c){const g=this._handlePool++,s=this._proxy,n=this._ids,h=`${N.identifier.value}/${b}`;if(n.has(h))throw new Error(`LanguageStatusItem with id '${b}' ALREADY exists`);n.add(h);const _={selector:c,id:b,name:N.displayName??N.name,severity:w.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let y,d=new A.DisposableStore;const p=()=>{y?.dispose(),y=(0,C.disposableTimeout)(()=>{d.clear(),this._proxy.$setLanguageStatus(g,{id:h,name:_.name??N.displayName??N.name,source:N.displayName??N.name,selector:k.DocumentSelector.from(_.selector,this._uriTransformer),label:_.text,detail:_.detail??"",severity:_.severity===w.LanguageStatusSeverity.Error?B.default.Error:_.severity===w.LanguageStatusSeverity.Warning?B.default.Warning:B.default.Info,command:_.command&&this._commands.toInternal(_.command,d),accessibilityInfo:_.accessibilityInformation,busy:_.busy})},0)},E={dispose(){d.dispose(),y?.dispose(),s.$removeLanguageStatus(g),n.delete(h)},get id(){return _.id},get name(){return _.name},set name(a){_.name=a,p()},get selector(){return _.selector},set selector(a){_.selector=a,p()},get text(){return _.text},set text(a){_.text=a,p()},get detail(){return _.detail},set detail(a){_.detail=a,p()},get severity(){return _.severity},set severity(a){_.severity=a,p()},get accessibilityInformation(){return _.accessibilityInformation},set accessibilityInformation(a){_.accessibilityInformation=a,p()},get command(){return _.command},set command(a){_.command=a,p()},get busy(){return _.busy},set busy(a){_.busy=a,p()}};return p(),E}}e.ExtHostLanguages=D}),define(we[193],be([1,0,12,4,27,14,5]),function(Z,e,o,k,w,B,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let A=class extends o.AbstractLoggerService{constructor(N,b){const c=new C.Emitter;super(b.logLevel,c.event);this._proxy=N.getProxy(k.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(c)}$setLevel(N){this._onDidChangeLogLevel.fire(N)}doCreateLogger(N,b,c){return new D(this._proxy,N,b,c)}};A=Fe([Ne(0,B.IExtHostRpcService),Ne(1,w.IExtHostInitDataService)],A),e.ExtHostLoggerService=A;class D extends o.AbstractMessageLogger{constructor(N,b,c,g){super(g?.always);this.proxy=N,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(c),this.proxy.$createLogger(b,g).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(N,b){const c=[[N,b]];this.isLoggerCreated?this.doLog(c):this.buffer.push(...c)}doLog(N){this.proxy.$log(this.file,N)}}}),define(we[194],be([1,0,4,12,28]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function B(A){return A&&A.title}let C=class{constructor(D,F){this._logService=F,this._proxy=D.getProxy(o.MainContext.MainThreadMessageService)}showMessage(D,F,N,b,c){const g={source:{identifier:D.identifier,label:D.displayName||D.name}};let s;typeof b=="string"||B(b)?s=[b,...c]:(g.modal=b?.modal,g.useCustom=b?.useCustom,g.detail=b?.detail,s=c),g.useCustom&&(0,w.checkProposedApiEnabled)(D,"resolvers");const n=[];for(let h=0;h<s.length;h++){const _=s[h];if(typeof _=="string")n.push({title:_,handle:h,isCloseAffordance:!1});else if(typeof _=="object"){let{title:y,isCloseAffordance:d}=_;n.push({title:y,isCloseAffordance:!!d,handle:h})}else this._logService.warn("Invalid message item:",_)}return this._proxy.$showMessage(F,N,g,n).then(h=>{if(typeof h=="number")return s[h]})}};C=Fe([Ne(1,k.ILogService)],C),e.ExtHostMessageService=C}),define(we[195],be([1,0,21,5,93,7,22,9,11,2,58,4,8,6,38,169,89]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class _{constructor(d,p,E,a,T){this._textDocumentsAndEditors=E,this._textDocuments=a,this._extensionStoragePaths=T,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new C.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new k.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new k.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new k.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new k.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new k.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new k.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new k.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new N.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=d.getProxy(b.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=d.getProxy(b.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=d.getProxy(b.MainContext.MainThreadNotebookEditors),this._commandsConverter=p.converter,p.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===12){const i=r.notebookEditor?.notebookUri,u=r.cell.handle,l=this._documents.get(i)?.getCell(u);if(l)return l.apiCell}return r}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(d=>d.apiEditor)}getEditorById(d){const p=this._editors.get(d);if(!p)throw new Error(`unknown text editor: ${d}. known editors: ${[...this._editors.keys()]} `);return p}getIdByEditor(d){for(const[p,E]of this._editors)if(E.apiEditor===d)return p}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(d,p){const E=this._documents.get(d);if(!E&&!p)throw new Error(`NO notebook document for '${d}'`);return E}_getProviderData(d){const p=this._notebookContentProviders.get(d);if(!p)throw new Error(`NO provider for '${d}'`);return p}registerNotebookContentProvider(d,p,E,a,T){if((0,A.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(p))throw new Error(`Notebook provider for '${p}' already registered`);this._notebookContentProviders.set(p,{extension:d,provider:E});let r;return E.onDidChangeNotebookContentOptions&&(r=E.onDidChangeNotebookContentOptions(()=>{const i=c.NotebookDocumentContentOptions.from(E.options);this._notebookProxy.$updateNotebookProviderOptions(p,i)})),this._notebookProxy.$registerNotebookProvider({id:d.identifier,location:d.extensionLocation},p,c.NotebookDocumentContentOptions.from(a),_._convertNotebookRegistrationData(d,T)),new g.Disposable(()=>{r?.dispose(),this._notebookContentProviders.delete(p),this._notebookProxy.$unregisterNotebookProvider(p)})}static _convertNotebookRegistrationData(d,p){if(!p)return;const E=p.filenamePattern.map(a=>c.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(p.filenamePattern&&!E){console.warn(`Notebook content provider view options file name pattern is invalid ${p.filenamePattern}`);return}return{extension:d.identifier,providerDisplayName:d.displayName||d.name,displayName:p.displayName,filenamePattern:E,exclusive:p.exclusive||!1}}registerNotebookCellStatusBarItemProvider(d,p,E){const a=_._notebookStatusBarItemProviderHandlePool++,T=typeof E.onDidChangeCellStatusBarItems=="function"?_._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(a,E),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(a,T,p);let r;return T!==void 0&&(r=E.onDidChangeCellStatusBarItems(i=>this._notebookProxy.$emitCellStatusBarEvent(T))),new g.Disposable(()=>{this._notebookStatusBarItemProviders.delete(a),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(a,T),r&&r.dispose()})}async createNotebookDocument(d){const p=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:d.viewType,content:d.content&&c.NotebookData.from(d.content)});return F.URI.revive(p)}async openNotebookDocument(d){const p=this._documents.get(d);if(p)return p.apiNotebook;const E=await this._notebookDocumentsProxy.$tryOpenNotebook(d),a=this._documents.get(F.URI.revive(E));return(0,D.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(d,p){F.URI.isUri(d)&&(d=await this.openNotebookDocument(d));let E;typeof p=="object"?E={position:c.ViewColumn.from(p.viewColumn),preserveFocus:p.preserveFocus,selections:p.selections&&p.selections.map(c.NotebookRange.from),pinned:typeof p.preview=="boolean"?!p.preview:void 0}:E={preserveFocus:!1};const a=await this._notebookEditorsProxy.$tryShowNotebookDocument(d.uri,d.notebookType,E),T=a&&this._editors.get(a)?.apiEditor;if(T)return T;throw a?new Error(`Could NOT open editor for "${d.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${d.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(d,p,E,a){const T=this._notebookStatusBarItemProviders.get(d),r=F.URI.revive(p),i=this._documents.get(r);if(!i||!T)return;const u=i.getCellFromIndex(E);if(!u)return;const t=await T.provideCellStatusBarItems(u.apiCell,a);if(!t)return;const l=new B.DisposableStore,m=this._statusBarCache.add([l]),S=(Array.isArray(t)?t:[t]).map(P=>c.NotebookStatusBarItem.from(P,this._commandsConverter,l));return{cacheId:m,items:S}}$releaseNotebookCellStatusBarItems(d){this._statusBarCache.delete(d)}registerNotebookSerializer(d,p,E,a,T){if((0,A.isFalsyOrWhitespace)(p))throw new Error("viewType cannot be empty or just whitespace");const r=this._handlePool++;return this._notebookSerializer.set(r,E),this._notebookProxy.$registerNotebookSerializer(r,{id:d.identifier,location:d.extensionLocation},p,c.NotebookDocumentContentOptions.from(a),_._convertNotebookRegistrationData(d,T)),(0,B.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(r)})}async $dataToNotebook(d,p,E){const a=this._notebookSerializer.get(d);if(!a)throw new Error("NO serializer found");const T=await a.deserializeNotebook(p.buffer,E);return new s.SerializableObjectWithBuffers(c.NotebookData.from(T))}async $notebookToData(d,p,E){const a=this._notebookSerializer.get(d);if(!a)throw new Error("NO serializer found");const T=await a.serializeNotebook(c.NotebookData.to(p.value),E);return o.VSBuffer.wrap(T)}async $openNotebook(d,p,E,a,T){const{provider:r}=this._getProviderData(d),i=await r.openNotebook(F.URI.revive(p),{backupId:E,untitledDocumentData:a?.buffer},T);return new s.SerializableObjectWithBuffers({metadata:i.metadata??Object.create(null),cells:i.cells.map(c.NotebookCellData.from)})}async $saveNotebook(d,p,E){const a=this.getNotebookDocument(F.URI.revive(p)),{provider:T}=this._getProviderData(d);return await T.saveNotebook(a.apiNotebook,E),!0}async $saveNotebookAs(d,p,E,a){const T=this.getNotebookDocument(F.URI.revive(p)),{provider:r}=this._getProviderData(d);return await r.saveNotebookAs(F.URI.revive(E),T.apiNotebook,a),!0}async $backupNotebook(d,p,E){const a=this.getNotebookDocument(F.URI.revive(p)),T=this._getProviderData(d),r=this._extensionStoragePaths.workspaceValue(T.extension)??this._extensionStoragePaths.globalValue(T.extension),i=String((0,w.hash)([a.uri.toString(),this._backupIdPool++])),u=F.URI.joinPath(r,i),t=await T.provider.backupNotebook(a.apiNotebook,{destination:u},E);return a.updateBackup(t),t.id}_createExtHostEditor(d,p,E){if(this._editors.has(p))throw new Error(`editor with id ALREADY EXSIST: ${p}`);const a=new h.ExtHostNotebookEditor(p,this._notebookEditorsProxy,d,E.visibleRanges.map(c.NotebookRange.to),E.selections.map(c.NotebookRange.to),typeof E.viewColumn=="number"?c.ViewColumn.to(E.viewColumn):void 0);this._editors.set(p,a)}$acceptDocumentAndEditorsDelta(d){if(d.value.removedDocuments)for(const E of d.value.removedDocuments){const a=F.URI.revive(E),T=this._documents.get(a);T&&(T.dispose(),this._documents.delete(a),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:T.apiNotebook.getCells().map(r=>r.document.uri)}),this._onDidCloseNotebookDocument.fire(T.apiNotebook));for(const r of this._editors.values())r.notebookData.uri.toString()===a.toString()&&this._editors.delete(r.id)}if(d.value.addedDocuments){const E=[];for(const a of d.value.addedDocuments){const T=F.URI.revive(a.uri);if(this._documents.has(T))throw new Error(`adding EXISTING notebook ${T} `);const r=this,i=new n.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(u){r._onDidChangeNotebookCells.fire(u)},emitCellOutputsChange(u){r._onDidChangeCellOutputs.fire(u)},emitCellMetadataChange(u){r._onDidChangeCellMetadata.fire(u)}},T,a);E.push(...a.cells.map(u=>n.ExtHostCell.asModelAddData(i.apiNotebook,u))),this._documents.get(T)?.dispose(),this._documents.set(T,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:E}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(d.value.addedEditors)for(const E of d.value.addedEditors){if(this._editors.has(E.id))return;const a=F.URI.revive(E.documentUri),T=this._documents.get(a);T&&this._createExtHostEditor(T,E.id,E)}const p=[];if(d.value.removedEditors)for(const E of d.value.removedEditors){const a=this._editors.get(E);a&&(this._editors.delete(E),this._activeNotebookEditor?.id===a.id&&(this._activeNotebookEditor=void 0),p.push(a))}if(d.value.visibleEditors){this._visibleNotebookEditors=d.value.visibleEditors.map(a=>this._editors.get(a)).filter(a=>!!a);const E=new Set;this._visibleNotebookEditors.forEach(a=>E.add(a.id));for(const a of this._editors.values()){const T=E.has(a.id);a._acceptVisibility(T)}this._visibleNotebookEditors=[...this._editors.values()].map(a=>a).filter(a=>a.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}d.value.newActiveEditor===null?this._activeNotebookEditor=void 0:d.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(d.value.newActiveEditor)),d.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=_,_._notebookStatusBarItemProviderHandlePool=0}),define(we[196],be([1,0,5,53,12,4,14,8]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class D{constructor(b,c){const g=D._Keys.nextId();b.$registerNotebookEditorDecorationType(g,A.NotebookDecorationRenderOptions.from(c)),this.value={key:g,dispose(){b.$removeNotebookEditorDecorationType(g)}}}}D._Keys=new k.IdGenerator("NotebookEditorDecorationType");let F=class{constructor(b,c,g){this._logService=b,this._extHostRpc=c,this._notebooksAndEditors=g,this._onDidChangeNotebookEditorSelection=new o.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new o.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(b){return new D(this._extHostRpc.getProxy(B.MainContext.MainThreadNotebookEditors),b).value}$acceptEditorPropertiesChanged(b,c){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",b,c);const g=this._notebooksAndEditors.getEditorById(b);c.visibleRanges&&g._acceptVisibleRanges(c.visibleRanges.ranges.map(A.NotebookRange.to)),c.selections&&g._acceptSelections(c.selections.selections.map(A.NotebookRange.to)),c.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:g.apiEditor,visibleRanges:g.apiEditor.visibleRanges}),c.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:g.apiEditor,selections:g.apiEditor.selections}))}$acceptEditorViewColumns(b){for(const c in b)this._notebooksAndEditors.getEditorById(c)._acceptViewColumn(A.ViewColumn.to(b[c]))}};F=Fe([Ne(0,w.ILogService),Ne(1,C.IExtHostRpcService)],F),e.ExtHostNotebookEditors=F}),define(we[197],be([1,0,16,13,20,5,7,22,2,26,12,4,39,8,6,61,162,28,38]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let d=class{constructor(i,u,t,l,m){this._initData=u,this._extHostNotebook=t,this._commands=l,this._logService=m,this._activeExecutions=new A.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new B.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(b.MainContext.MainThreadNotebookKernels);const f=new c.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new c.ApiCommandArgument("options","Select kernel options",S=>!0,S=>{if(S&&"notebookEditor"in S&&"id"in S){const P=this._extHostNotebook.getIdByEditor(S.notebookEditor);return{id:S.id,extension:S.extension,notebookEditorId:P}}else if(S&&"notebookEditor"in S){const P=this._extHostNotebook.getIdByEditor(S.notebookEditor);if(P===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${S.notebookEditor.document.uri.toString()}`);return{notebookEditorId:P}}return S})],c.ApiCommandResult.Void);this._commands.registerApiCommand(f)}createNotebookController(i,u,t,l,m,f){for(const ie of this._kernelData.values())if(ie.controller.id===u&&F.ExtensionIdentifier.equals(i.identifier,ie.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const S=this._handlePool++,P=this;this._logService.trace(`NotebookController[${S}], CREATED by ${i.identifier.value}, ${u}`);const $=()=>console.warn(`NO execute handler from notebook controller '${q.id}' of extension: '${i.identifier}'`);let L=!1;const v=new C.DisposableStore,H=new B.Emitter,W=new B.Emitter,q={id:T(i,u),notebookType:t,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:l||i.identifier.value,preloads:f?f.map(g.NotebookRendererScript.from):[]};let K=m??$,V;this._proxy.$addKernel(S,q).catch(ie=>{console.log(ie),L=!0});let z=0;const ae=()=>{if(L)return;const ie=++z;Promise.resolve().then(()=>{ie===z&&this._proxy.$updateKernel(S,q)})},de=new A.ResourceMap,Y={get id(){return u},get notebookType(){return q.notebookType},onDidChangeSelectedNotebooks:H.event,get label(){return q.label},set label(ie){q.label=ie??i.displayName??i.name,ae()},get detail(){return q.detail??""},set detail(ie){q.detail=ie,ae()},get description(){return q.description??""},set description(ie){q.description=ie,ae()},get kind(){return(0,_.checkProposedApiEnabled)(i,"notebookControllerKind"),q.kind??""},set kind(ie){(0,_.checkProposedApiEnabled)(i,"notebookControllerKind"),q.kind=ie,ae()},get supportedLanguages(){return q.supportedLanguages},set supportedLanguages(ie){q.supportedLanguages=ie,ae()},get supportsExecutionOrder(){return q.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){q.supportsExecutionOrder=ie,ae()},get rendererScripts(){return q.preloads?q.preloads.map(g.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(ie){K=ie??$},get interruptHandler(){return V},set interruptHandler(ie){V=ie,q.supportsInterrupt=Boolean(ie),ae()},createNotebookCellExecution(ie){if(L)throw new Error("notebook controller is DISPOSED");if(!de.has(ie.notebook.uri))throw P._logService.trace(`NotebookController[${S}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(ce=>ce.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return P._createNotebookCellExecution(ie,T(i,this.id))},dispose:()=>{L||(this._logService.trace(`NotebookController[${S}], DISPOSED`),L=!0,this._kernelData.delete(S),v.dispose(),H.dispose(),W.dispose(),this._proxy.$removeKernel(S))},updateNotebookAffinity(ie,ce){P._proxy.$updateNotebookPriority(S,ie.uri,ce)},onDidReceiveMessage:W.event,postMessage(ie,ce){return(0,_.checkProposedApiEnabled)(i,"notebookMessaging"),P._proxy.$postMessage(S,ce&&P._extHostNotebook.getIdByEditor(ce),ie)},asWebviewUri(ie){return(0,_.checkProposedApiEnabled)(i,"notebookMessaging"),(0,n.asWebviewUri)(ie,P._initData.remote)}};return this._kernelData.set(S,{extensionId:i.identifier,controller:Y,onDidReceiveMessage:W,onDidChangeSelection:H,associatedNotebooks:de}),Y}$acceptNotebookAssociation(i,u,t){const l=this._kernelData.get(i);if(l){const m=this._extHostNotebook.getNotebookDocument(D.URI.revive(u));t?l.associatedNotebooks.set(m.uri,!0):l.associatedNotebooks.delete(m.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,m.uri.toString(),t),l.onDidChangeSelection.fire({selected:t,notebook:m.apiNotebook})}}async $executeCells(i,u,t){const l=this._kernelData.get(i);if(!l)return;const m=this._extHostNotebook.getNotebookDocument(D.URI.revive(u)),f=[];for(const S of t){const P=m.getCell(S);P&&f.push(P.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,m.uri.toString(),f.length),await l.controller.executeHandler.call(l.controller,f,m.apiNotebook,l.controller)}catch(S){this._logService.error(`NotebookController[${i}] execute cells FAILED`,S),console.error(S)}}async $cancelCells(i,u,t){const l=this._kernelData.get(i);if(!l)return;const m=this._extHostNotebook.getNotebookDocument(D.URI.revive(u));if(l.controller.interruptHandler)await l.controller.interruptHandler.call(l.controller,m.apiNotebook);else for(const f of t){const S=m.getCell(f);S&&this._activeExecutions.get(S.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,u,t){const l=this._kernelData.get(i);if(!l)return;const m=this._extHostNotebook.getEditorById(u);l.onDidReceiveMessage.fire(Object.freeze({editor:m.apiEditor,message:t}))}$cellExecutionChanged(i,u,t){const m=this._extHostNotebook.getNotebookDocument(D.URI.revive(i)).getCell(u);m&&this._onDidChangeCellExecutionState.fire({cell:m.apiCell,state:t?g.NotebookCellExecutionState.to(t):s.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,u){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const l=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!l)throw new Error("invalid cell");if(this._activeExecutions.has(l.uri))throw new Error(`duplicate execution for ${l.uri}`);const m=new E(u,l,this._proxy);this._activeExecutions.set(l.uri,m);const f=m.onDidChangeState(()=>{m.state===p.Resolved&&(m.dispose(),f.dispose(),this._activeExecutions.delete(l.uri))});return m.asApiObject()}};d=Fe([Ne(4,N.ILogService)],d),e.ExtHostNotebookKernels=d;var p;(function(r){r[r.Init=0]="Init",r[r.Started=1]="Started",r[r.Resolved=2]="Resolved"})(p||(p={}));class E extends C.Disposable{constructor(i,u,t){super();this._cell=u,this._proxy=t,this._handle=E.HANDLE++,this._onDidChangeState=new B.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=p.Init,this._tokenSource=this._register(new w.CancellationTokenSource),this._collector=new a(10,l=>this.update(l)),this._executionOrder=u.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const u=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new y.SerializableObjectWithBuffers(u))}verifyStateForOutput(){if(this._state===p.Init)throw new Error("Must call start before modifying cell output");if(this._state===p.Resolved)throw new Error("Cannot modify cell output after calling resolve")}validateAndConvertOutputs(i){return i.map(u=>{const t=s.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return t===u.items?g.NotebookCellOutput.from(u):g.NotebookCellOutput.from({items:t,id:u.id,metadata:u.metadata})})}async updateOutputs(i,u,t){const l=this.validateAndConvertOutputs((0,o.asArray)(i));return this.updateSoon({editType:h.CellExecutionUpdateType.Output,append:t,outputs:l})}async updateOutputItems(i,u,t){return i=s.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(i),!0),this.updateSoon({editType:h.CellExecutionUpdateType.OutputItems,items:i.map(g.NotebookCellOutputItem.from),outputId:u.id,append:t})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(t){i._executionOrder=t,i.update([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(t){if(i._state===p.Resolved||i._state===p.Started)throw new Error("Cannot call start again");i._state=p.Started,i._onDidChangeState.fire(),i.update({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,l){if(i._state===p.Resolved)throw new Error("Cannot call resolve twice");i._state=p.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new y.SerializableObjectWithBuffers({runEndTime:l,lastRunSuccess:t}))},clearOutput(t){return i.verifyStateForOutput(),i.updateOutputs([],t,!1)},appendOutput(t,l){return i.verifyStateForOutput(),i.updateOutputs(t,l,!0)},replaceOutput(t,l){return i.verifyStateForOutput(),i.updateOutputs(t,l,!1)},appendOutputItems(t,l){return i.verifyStateForOutput(),i.updateOutputItems(t,l,!0)},replaceOutputItems(t,l){return i.verifyStateForOutput(),i.updateOutputItems(t,l,!1)}})}}E.HANDLE=0;class a{constructor(i,u){this.delay=i,this.callback=u,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new k.DeferredPromise,this.startedTimer=Date.now(),(0,k.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const u=this.batch;return this.batch=[],this.callback(u).finally(()=>i.complete())}}function T(r,i){return`${r.identifier.value}/${i}`}}),define(we[198],be([1,0,5,4,89,28]),function(Z,e,o,k,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class C{constructor(D,F){this._extHostNotebook=F,this._rendererMessageEmitters=new Map,this.proxy=D.getProxy(k.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(D,F,N){const b=this._extHostNotebook.getEditorById(D);this._rendererMessageEmitters.get(F)?.fire({editor:b.apiEditor,message:N})}createRendererMessaging(D,F){if(!D.contributes?.notebookRenderer?.some(g=>g.id===F))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${F})`);const N=(0,B.isProposedApiEnabled)(D,"notebookEditor"),b=new WeakMap;return{onDidReceiveMessage:(g,s,n)=>{const h=N?g:_=>{const y={};b.set(y,_.editor),g({editor:y,message:_.message})};return this.getOrCreateEmitterFor(F).event(h,s,n)},postMessage:(g,s)=>{w.ExtHostNotebookEditor.apiEditorsToExtHost.has(g)&&([g,s]=[s,g]);const n=N?s:b.get(s),h=n&&w.ExtHostNotebookEditor.apiEditorsToExtHost.get(n);return this.proxy.$postMessage(h?.id,F,g)}}}getOrCreateEmitterFor(D){let F=this._rendererMessageEmitters.get(D);return F||(F=new o.Emitter({onLastListenerRemove:()=>{F?.dispose(),this._rendererMessageEmitters.delete(D)}}),this._rendererMessageEmitters.set(D,F),F)}}e.ExtHostNotebookRenderers=C}),define(we[94],be([1,0,4,7,3,14,12,163,50,27,30,112,21,11]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class s extends k.Disposable{constructor(_,y,d,p){super();this.id=_,this.name=y,this.logger=d,this.proxy=p,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(_){this.append(_+`
`)}append(_){this.write(_),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Append))}clear(){const _=this.offset;this.logger.flush(),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Clear,_)}replace(_){const y=this.offset;this.write(_),this.proxy.$update(this.id,A.OutputChannelUpdateMode.Replace,y),this.visible&&this.logger.flush()}show(_,y){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof _=="boolean"?_:y))}hide(){this.proxy.$close(this.id)}write(_){this.offset+=c.VSBuffer.fromString(_).byteLength,this.logger.info(_)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=s;let n=class{constructor(_,y,d,p,E){this.extHostFileSystem=d,this.extHostFileSystemInfo=p,this.loggerService=E,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=_.getProxy(o.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(y.logsLocation,`output_logging_${(0,b.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(_){this.visibleChannelId=_;for(const[y,d]of this.channels)d.visible=y===this.visibleChannelId}createOutputChannel(_,y,d){if(_=_.trim(),!_)throw new Error("illegal argument `name`. must not be falsy");if((0,g.isString)(y)&&!y.trim())throw new Error("illegal argument `languageId`. must not be empty");const p=this.doCreateOutputChannel(_,y,d);return p.then(E=>{this.channels.set(E.id,E),E.visible=E.id===this.visibleChannelId}),this.createExtHostOutputChannel(_,p)}async doCreateOutputChannel(_,y,d){const p=await this.createOutputDirectory(),E=this.extHostFileSystemInfo.extUri.joinPath(p,`${this.namePool++}-${_.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),a=this.loggerService.createLogger(E,{always:!0,donotRotate:!0,donotUseFormatters:!0}),T=await this.proxy.$register(_,!1,E,y,d.identifier.value);return new s(T,_,a,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(_,y){let d=!1;const p=()=>{if(d)throw new Error("Channel has been closed")};return{get name(){return _},append(E){p(),y.then(a=>a.append(E))},appendLine(E){p(),y.then(a=>a.appendLine(E))},clear(){p(),y.then(E=>E.clear())},replace(E){p(),y.then(a=>a.replace(E))},show(E,a){p(),y.then(T=>T.show(E,a))},hide(){p(),y.then(E=>E.hide())},dispose(){d=!0,y.then(E=>E.dispose())}}}};n=Fe([Ne(0,B.IExtHostRpcService),Ne(1,F.IExtHostInitDataService),Ne(2,D.IExtHostConsumerFileSystem),Ne(3,N.IExtHostFileSystemInfo),Ne(4,C.ILoggerService)],n),e.ExtHostOutputService=n,e.IExtHostOutputService=(0,w.createDecorator)("IExtHostOutputService")}),define(we[199],be([1,0,13,20,5,7,4,2,6,15,16,34,57]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function g(s,n,h){const _=s.getProxy(C.MainContext.MainThreadQuickOpen);class y{constructor(t,l){this._sessions=new Map,this._instances=0,this._workspace=t,this._commands=l}showQuickPick(t,l,m=k.CancellationToken.None){this._onDidSelectItem=void 0;const f=Promise.resolve(t),S=++this._instances,P=_.$show(S,{title:l?.title,placeHolder:l?.placeHolder,matchOnDescription:l?.matchOnDescription,matchOnDetail:l?.matchOnDetail,ignoreFocusLost:l?.ignoreFocusOut,canPickMany:l?.canPickMany},m),$={},L=P.then(()=>$);return Promise.race([L,f]).then(v=>{if(v!==$)return f.then(H=>{const W=[];for(let q=0;q<H.length;q++){const K=H[q];typeof K=="string"?W.push({label:K,handle:q}):K.kind===D.QuickPickItemKind.Separator?W.push({type:"separator",label:K.label}):W.push({label:K.label,description:K.description,detail:K.detail,picked:K.picked,alwaysShow:K.alwaysShow,handle:q})}return l&&typeof l.onDidSelectItem=="function"&&(this._onDidSelectItem=q=>{l.onDidSelectItem(H[q])}),_.$setItems(S,W),P.then(q=>{if(typeof q=="number")return H[q];if(Array.isArray(q))return q.map(K=>H[K])})})}).then(void 0,v=>{if(!(0,F.isCancellationError)(v))return _.$setError(S,v),Promise.reject(v)})}$onItemSelected(t){this._onDidSelectItem&&this._onDidSelectItem(t)}showInput(t,l=k.CancellationToken.None){return this._validateInput=t?t.validateInput:void 0,_.$input(t,typeof this._validateInput=="function",l).then(void 0,m=>{if(!(0,F.isCancellationError)(m))return Promise.reject(m)})}$validateInput(t){return this._validateInput?(0,o.asPromise)(()=>this._validateInput(t)):Promise.resolve(void 0)}async showWorkspaceFolderPick(t,l=k.CancellationToken.None){const m=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[t]);if(!m)return;const f=await this._workspace.getWorkspaceFolders2();if(!!f)return f.find(S=>S.uri.toString()===m.uri.toString())}createQuickPick(t){const l=new r(t,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}createInputBox(t){const l=new i(t,()=>this._sessions.delete(l._id));return this._sessions.set(l._id,l),l}$onDidChangeValue(t,l){const m=this._sessions.get(t);m&&m._fireDidChangeValue(l)}$onDidAccept(t){const l=this._sessions.get(t);l&&l._fireDidAccept()}$onDidChangeActive(t,l){const m=this._sessions.get(t);m instanceof r&&m._fireDidChangeActive(l)}$onDidChangeSelection(t,l){const m=this._sessions.get(t);m instanceof r&&m._fireDidChangeSelection(l)}$onDidTriggerButton(t,l){const m=this._sessions.get(t);m&&m._fireDidTriggerButton(l)}$onDidTriggerItemButton(t,l,m){const f=this._sessions.get(t);f instanceof r&&f._fireDidTriggerItemButton(l,m)}$onDidHide(t){const l=this._sessions.get(t);l&&l._fireDidHide()}}class d{constructor(t,l){this._extensionId=t,this._onDidDispose=l,this._id=r._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new w.Emitter,this._onDidChangeValueEmitter=new w.Emitter,this._onDidTriggerButtonEmitter=new w.Emitter,this._onDidHideEmitter=new w.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(t){this._title=t,this.update({title:t})}get step(){return this._steps}set step(t){this._steps=t,this.update({step:t})}get totalSteps(){return this._totalSteps}set totalSteps(t){this._totalSteps=t,this.update({totalSteps:t})}get enabled(){return this._enabled}set enabled(t){this._enabled=t,this.update({enabled:t})}get busy(){return this._busy}set busy(t){this._busy=t,this.update({busy:t})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(t){this._ignoreFocusOut=t,this.update({ignoreFocusOut:t})}get value(){return this._value}set value(t){this._value=t,this.update({value:t})}get placeholder(){return this._placeholder}set placeholder(t){this._placeholder=t,this.update({placeholder:t})}get buttons(){return this._buttons}set buttons(t){this._buttons=t.slice(),this._handlesToButtons.clear(),t.forEach((l,m)=>{const f=l===D.QuickInputButtons.Back?-1:m;this._handlesToButtons.set(f,l)}),this.update({buttons:t.map((l,m)=>({...T(l),tooltip:l.tooltip,handle:l===D.QuickInputButtons.Back?-1:m}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(t){this._value=t,this._onDidChangeValueEmitter.fire(t)}_fireDidTriggerButton(t){const l=this._handlesToButtons.get(t);l&&this._onDidTriggerButtonEmitter.fire(l)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,B.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),_.$dispose(this._id))}update(t){if(!this._disposed){for(const l of Object.keys(t)){const m=t[l];this._pendingUpdate[l]=m===void 0?null:m}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){_.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}d._nextId=1;function p(u){if(u instanceof D.ThemeIcon)return{id:u.id};const t=a(u),l=E(u);return{dark:typeof t=="string"?A.URI.file(t):t,light:typeof l=="string"?A.URI.file(l):l}}function E(u){return typeof u=="object"&&"light"in u?u.light:u}function a(u){return typeof u=="object"&&"dark"in u?u.dark:u}function T(u){const t=p(u.iconPath);let l,m;return"id"in t?m=c.ThemeIcon.asClassName(t):l=t,{iconPath:l,iconClass:m}}class r extends d{constructor(t,l){super(t.identifier,l);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new w.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new w.Emitter,this._onDidTriggerItemButtonEmitter=new w.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(t){this._items=t.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),t.forEach((m,f)=>{this._handlesToItems.set(f,m),this._itemsToHandles.set(m,f)});const l=[];for(let m=0;m<t.length;m++){const f=t[m];f.kind===D.QuickPickItemKind.Separator?l.push({type:"separator",label:f.label}):l.push({handle:m,label:f.label,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,buttons:f.buttons?.map((S,P)=>({...T(S),tooltip:S.tooltip,handle:P}))})}this.update({items:l})}get canSelectMany(){return this._canSelectMany}set canSelectMany(t){this._canSelectMany=t,this.update({canSelectMany:t})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(t){this._matchOnDescription=t,this.update({matchOnDescription:t})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(t){this._matchOnDetail=t,this.update({matchOnDetail:t})}get sortByLabel(){return this._sortByLabel}set sortByLabel(t){this._sortByLabel=t,this.update({sortByLabel:t})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(t){this._keepScrollPosition=t,this.update({keepScrollPosition:t})}get activeItems(){return this._activeItems}set activeItems(t){this._activeItems=t.filter(l=>this._itemsToHandles.has(l)),this.update({activeItems:this._activeItems.map(l=>this._itemsToHandles.get(l))})}get selectedItems(){return this._selectedItems}set selectedItems(t){this._selectedItems=t.filter(l=>this._itemsToHandles.has(l)),this.update({selectedItems:this._selectedItems.map(l=>this._itemsToHandles.get(l))})}_fireDidChangeActive(t){const l=(0,N.coalesce)(t.map(m=>this._handlesToItems.get(m)));this._activeItems=l,this._onDidChangeActiveEmitter.fire(l)}_fireDidChangeSelection(t){const l=(0,N.coalesce)(t.map(m=>this._handlesToItems.get(m)));this._selectedItems=l,this._onDidChangeSelectionEmitter.fire(l)}_fireDidTriggerItemButton(t,l){const m=this._handlesToItems.get(t);if(!m||!m.buttons||!m.buttons.length)return;const f=m.buttons[l];f&&this._onDidTriggerItemButtonEmitter.fire({button:f,item:m})}}class i extends d{constructor(t,l){super(t,l);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(t){this._password=t,this.update({password:t})}get prompt(){return this._prompt}set prompt(t){this._prompt=t,this.update({prompt:t})}get validationMessage(){return this._validationMessage}set validationMessage(t){this._validationMessage=t,this.update({validationMessage:t,severity:t?b.default.Error:b.default.Ignore})}}return new y(n,h)}e.createExtHostQuickOpen=g});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,o,k,w){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!w:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?w.call(Z,o):w?w.value=o:e.set(Z,o),o},De=this&&this.__classPrivateFieldGet||function(Z,e,o,k){if(o==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?k:o==="a"?k.call(Z):k?k.value:e.get(Z)};define(we[200],be([1,0,2,5,52,7,13,4,16,107,12,26,57,8,28]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s){"use strict";var n,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function _(m){if(m)return typeof m.iconPath=="string"?o.URI.file(m.iconPath):o.URI.isUri(m.iconPath)||c.ThemeIcon.isThemeIcon(m.iconPath)?m.iconPath:void 0}function y(m,f){if(!m.iconPath&&!f.iconPath)return 0;if(m.iconPath){if(!f.iconPath)return 1}else return-1;const S=typeof m.iconPath=="string"?m.iconPath:o.URI.isUri(m.iconPath)?m.iconPath.fsPath:m.iconPath.id,P=typeof f.iconPath=="string"?f.iconPath:o.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,F.comparePaths)(S,P)}function d(m,f){let S=0;if(m.strikeThrough!==f.strikeThrough)return m.strikeThrough?1:-1;if(m.faded!==f.faded)return m.faded?1:-1;if(m.tooltip!==f.tooltip)return(m.tooltip||"").localeCompare(f.tooltip||"");if(S=y(m,f),S!==0)return S;if(m.light&&f.light)S=y(m.light,f.light);else{if(m.light)return 1;if(f.light)return-1}if(S!==0)return S;if(m.dark&&f.dark)S=y(m.dark,f.dark);else{if(m.dark)return 1;if(f.dark)return-1}return S}function p(m,f){if(m.command!==f.command)return m.command<f.command?-1:1;if(m.title!==f.title)return m.title<f.title?-1:1;if(m.tooltip!==f.tooltip){if(m.tooltip!==void 0&&f.tooltip!==void 0)return m.tooltip<f.tooltip?-1:1;if(m.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(m.arguments===f.arguments)return 0;if(m.arguments)if(f.arguments){if(m.arguments.length!==f.arguments.length)return m.arguments.length-f.arguments.length}else return 1;else return-1;for(let S=0;S<m.arguments.length;S++){const P=m.arguments[S],$=f.arguments[S];if(P!==$)return P<$?-1:1}return 0}function E(m,f){let S=(0,F.comparePaths)(m.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(S!==0)return S;if(m.command&&f.command)S=p(m.command,f.command);else{if(m.command)return 1;if(f.command)return-1}if(S!==0)return S;if(m.decorations&&f.decorations)S=d(m.decorations,f.decorations);else{if(m.decorations)return 1;if(f.decorations)return-1}return S}function a(m,f){for(let S=0;S<m.length;S++)if(m[S]!==f[S])return!1;return!0}function T(m,f){return m.command===f.command&&m.title===f.title&&m.tooltip===f.tooltip&&(m.arguments&&f.arguments?a(m.arguments,f.arguments):m.arguments===f.arguments)}function r(m,f){return(0,D.equals)(m,f,T)}class i{constructor(f,S,P){this._extension=f,this._sourceControlHandle=P,n.set(this,void 0),this._value="",this._onDidChange=new k.Emitter,this._placeholder="",this._visible=!0,Ve(this,n,S,"f")}get value(){return this._value}set value(f){f=f??"",De(this,n,"f").$setInputBoxValue(this._sourceControlHandle,f),this.updateValue(f)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(f){De(this,n,"f").$setInputBoxPlaceholder(this._sourceControlHandle,f),this._placeholder=f}get validateInput(){return(0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(f){if((0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=f,De(this,n,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!f)}get visible(){return this._visible}set visible(f){f=!!f,this._visible!==f&&(this._visible=f,De(this,n,"f").$setInputBoxVisibility(this._sourceControlHandle,f))}showValidationMessage(f,S){(0,s.checkProposedApiEnabled)(this._extension,"scmValidation"),De(this,n,"f").$showValidationMessage(this._sourceControlHandle,f,S)}$onInputBoxValueChange(f){this.updateValue(f)}updateValue(f){this._value=f,this._onDidChange.fire(f)}}e.ExtHostSCMInputBox=i,n=new WeakMap;class u{constructor(f,S,P,$,L){this._proxy=f,this._commands=S,this._sourceControlHandle=P,this._id=$,this._label=L,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new k.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new k.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=u._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(f){this._label=f,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,f)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(f){this._hideWhenEmpty=f,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(f){this._resourceStates=[...f],this._onDidUpdateResourceStates.fire()}getResourceState(f){return this._resourceStatesMap.get(f)}$executeResourceCommand(f,S){const P=this._resourceStatesCommandsMap.get(f);return P?(0,C.asPromise)(()=>this._commands.executeCommand(P.command,...P.arguments||[],S)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this._resourceStates].sort(E),P=(0,D.sortedDiff)(this._resourceSnapshot,f,E).map(v=>{const H=v.toInsert.map(W=>{const q=this._resourceHandlePool++;this._resourceStatesMap.set(q,W);const K=W.resourceUri;let V;if(W.command)if(W.command.command==="vscode.open"||W.command.command==="vscode.diff"){const ge=new B.DisposableStore;V=this._commands.converter.toInternal(W.command,ge),this._resourceStatesDisposablesMap.set(q,ge)}else this._resourceStatesCommandsMap.set(q,W.command);const z=_(W.decorations),ae=W.decorations&&_(W.decorations.light)||z,de=W.decorations&&_(W.decorations.dark)||z,Y=[ae,de],ie=W.decorations&&W.decorations.tooltip||"",ce=W.decorations&&!!W.decorations.strikeThrough,he=W.decorations&&!!W.decorations.faded,ue=W.contextValue||"";return{rawResource:[q,K,Y,ie,ce,he,ue,V],handle:q}});return{start:v.start,deleteCount:v.deleteCount,toInsert:H}}),$=P.map(({start:v,deleteCount:H,toInsert:W})=>[v,H,W.map(q=>q.rawResource)]),L=P.reverse();for(const{start:v,deleteCount:H,toInsert:W}of L){const q=W.map(V=>V.handle),K=this._handlesSnapshot.splice(v,H,...q);for(const V of K)this._resourceStatesMap.delete(V),this._resourceStatesCommandsMap.delete(V),this._resourceStatesDisposablesMap.get(V)?.dispose(),this._resourceStatesDisposablesMap.delete(V)}return this._resourceSnapshot=f,$}dispose(){this._disposed=!0,this._onDidDispose.fire()}}u._handlePool=0;class t{constructor(f,S,P,$,L,v){this._extension=f,this._commands=P,this._id=$,this._label=L,this._rootUri=v,h.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new B.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new B.MutableDisposable,this._statusBarDisposables=new B.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new k.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Ve(this,h,S,"f"),this._inputBox=new i(f,De(this,h,"f"),this.handle),De(this,h,"f").$registerSourceControl(this.handle,$,L,v)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(f){this._count!==f&&(this._count=f,De(this,h,"f").$updateSourceControl(this.handle,{count:f}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(f){this._quickDiffProvider=f,De(this,h,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!f})}get commitTemplate(){return this._commitTemplate}set commitTemplate(f){f!==this._commitTemplate&&(this._commitTemplate=f,De(this,h,"f").$updateSourceControl(this.handle,{commitTemplate:f}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(f){this._acceptInputDisposables.value=new B.DisposableStore,this._acceptInputCommand=f;const S=this._commands.converter.toInternal(f,this._acceptInputDisposables.value);De(this,h,"f").$updateSourceControl(this.handle,{acceptInputCommand:S})}get actionButton(){return(0,s.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(f){(0,s.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new B.DisposableStore,this._actionButton=f;const S=f!==void 0?{command:this._commands.converter.toInternal(f.command,this._actionButtonDisposables.value),description:f.description}:void 0;De(this,h,"f").$updateSourceControl(this.handle,{actionButton:S??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(f){if(this._statusBarCommands&&f&&r(this._statusBarCommands,f))return;this._statusBarDisposables.value=new B.DisposableStore,this._statusBarCommands=f;const S=(f||[]).map(P=>this._commands.converter.toInternal(P,this._statusBarDisposables.value));De(this,h,"f").$updateSourceControl(this.handle,{statusBarCommands:S})}get selected(){return this._selected}createResourceGroup(f,S){const P=new u(De(this,h,"f"),this._commands,this.handle,f,S),$=k.Event.once(P.onDidDispose)(()=>this.createdResourceGroups.delete(P));return this.createdResourceGroups.set(P,$),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const f=[],S=[];for(const[P,$]of this.createdResourceGroups){$.dispose();const L=P.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(P),this.eventuallyUpdateResourceStates()});k.Event.once(P.onDidDispose)(()=>{this.updatedResourceGroups.delete(P),L.dispose(),this._groups.delete(P.handle),De(this,h,"f").$unregisterGroup(this.handle,P.handle)}),f.push([P.handle,P.id,P.label,P.features]);const v=P._takeResourceStateSnapshot();v.length>0&&S.push([P.handle,v]),this._groups.set(P.handle,P)}De(this,h,"f").$registerGroups(this.handle,f,S),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const f=[];this.updatedResourceGroups.forEach(S=>{const P=S._takeResourceStateSnapshot();P.length!==0&&f.push([S.handle,P])}),f.length>0&&De(this,h,"f").$spliceResourceStates(this.handle,f),this.updatedResourceGroups.clear()}getResourceGroup(f){return this._groups.get(f)}setSelectionState(f){this._selected=f,this._onDidChangeSelection.fire(f)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(f=>f.dispose()),De(this,h,"f").$unregisterSourceControl(this.handle)}}h=new WeakMap,t._handlePool=0,Fe([(0,w.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),Fe([(0,w.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let l=class Vi{constructor(f,S,P){this._commands=S,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new k.Emitter,this._proxy=f.getProxy(A.MainContext.MainThreadSCM),this._telemetry=f.getProxy(A.MainContext.MainThreadTelemetry),S.registerArgumentProcessor({processArgument:$=>{if($&&$.$mid===3){const L=this._sourceControls.get($.sourceControlHandle);if(!L)return $;const v=L.getResourceGroup($.groupHandle);return v?v.getResourceState($.handle):$}else if($&&$.$mid===4){const L=this._sourceControls.get($.sourceControlHandle);return L?L.getResourceGroup($.groupHandle):$}else if($&&$.$mid===5){const L=this._sourceControls.get($.handle);return L||$}return $}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(f,S,P,$){this.logService.trace("ExtHostSCM#createSourceControl",f.identifier.value,S,P,$),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const L=Vi._handlePool++,v=new t(f,this._proxy,this._commands,S,P,$);this._sourceControls.set(L,v);const H=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(f.identifier))||[];return H.push(v),this._sourceControlsByExtension.set(b.ExtensionIdentifier.toKey(f.identifier),H),v}getLastInputBox(f){this.logService.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const S=this._sourceControlsByExtension.get(b.ExtensionIdentifier.toKey(f.identifier)),P=S&&S[S.length-1];return P&&P.inputBox}$provideOriginalResource(f,S,P){const $=o.URI.revive(S);this.logService.trace("ExtHostSCM#$provideOriginalResource",f,$.toString());const L=this._sourceControls.get(f);return!L||!L.quickDiffProvider||!L.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,C.asPromise)(()=>L.quickDiffProvider.provideOriginalResource($,P)).then(v=>v||null)}$onInputBoxValueChange(f,S){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",f);const P=this._sourceControls.get(f);return P&&P.inputBox.$onInputBoxValueChange(S),Promise.resolve(void 0)}$executeResourceCommand(f,S,P,$){this.logService.trace("ExtHostSCM#$executeResourceCommand",f,S,P);const L=this._sourceControls.get(f);if(!L)return Promise.resolve(void 0);const v=L.getResourceGroup(S);return v?v.$executeResourceCommand(P,$):Promise.resolve(void 0)}$validateInput(f,S,P){this.logService.trace("ExtHostSCM#$validateInput",f);const $=this._sourceControls.get(f);return!$||!$.inputBox.validateInput?Promise.resolve(void 0):(0,C.asPromise)(()=>$.inputBox.validateInput(S,P)).then(L=>{if(!L)return Promise.resolve(void 0);const v=g.MarkdownString.fromStrict(L.message);return v?Promise.resolve([v,L.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this._sourceControls.get(f)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=f,Promise.resolve(void 0)}};l._handlePool=0,l=Fe([Ne(2,N.ILogService)],l),e.ExtHostSCM=l});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,o,k,w){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!w:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?w.call(Z,o):w?w.value=o:e.set(Z,o),o},De=this&&this.__classPrivateFieldGet||function(Z,e,o,k){if(o==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?k:o==="a"?k.call(Z):k?k.value:e.get(Z)};define(we[201],be([1,0,6,4,125,7,8,11]),function(Z,e,o,k,w,B,C,A){"use strict";var D,F;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class N{constructor(s,n,h,_,y=o.StatusBarAlignment.Left,d){D.set(this,void 0),F.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new B.DisposableStore,Ve(this,D,s,"f"),Ve(this,F,n,"f"),this._entryId=N.ID_GEN++,this._extension=h,this._id=_,this._alignment=y,this._priority=this.validatePriority(d)}validatePriority(s){if(!!(0,A.isNumber)(s))return s===Number.POSITIVE_INFINITY?Number.MAX_VALUE:s===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:s}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(s){this._text=s,this.update()}set name(s){this._name=s,this.update()}set tooltip(s){this._tooltip=s,this.update()}set color(s){this._color=s,this.update()}set backgroundColor(s){s&&!N.ALLOWED_BACKGROUND_COLORS.has(s.id)&&(s=void 0),this._backgroundColor=s,this.update()}set command(s){this._command?.fromApi!==s&&(this._internalCommandRegistration.clear(),typeof s=="string"?this._command={fromApi:s,internal:De(this,F,"f").toInternal({title:"",command:s},this._internalCommandRegistration)}:s?this._command={fromApi:s,internal:De(this,F,"f").toInternal(s,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(s){this._accessibilityInformation=s,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,De(this,D,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let s;this._extension?this._id?s=`${this._extension.identifier.value}.${this._id}`:s=this._extension.identifier.value:s=this._id;let n;this._name?n=this._name:n=(0,w.localize)(0,null,this._extension.displayName||this._extension.name);let h=this._color;this._backgroundColor&&(h=N.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const _=C.MarkdownString.fromStrict(this._tooltip);De(this,D,"f").$setEntry(this._entryId,s,n,this._text,_,this._command?.internal,h,this._backgroundColor,this._alignment===o.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=N,D=new WeakMap,F=new WeakMap,N.ID_GEN=0,N.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]);class b{constructor(s){this._messages=[],this._item=s.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,w.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(s){const n={message:s};return this._messages.unshift(n),this._update(),new o.Disposable(()=>{const h=this._messages.indexOf(n);h>=0&&(this._messages.splice(h,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class c{constructor(s,n){this._proxy=s.getProxy(k.MainContext.MainThreadStatusBar),this._commands=n,this._statusMessage=new b(this)}createStatusBarEntry(s,n,h,_){return new N(this._proxy,this._commands,s,n,h,_)}setStatusBarMessage(s,n){const h=this._statusMessage.setMessage(s);let _;return typeof n=="number"?_=setTimeout(()=>h.dispose(),n):typeof n!="undefined"&&n.then(()=>h.dispose(),()=>h.dispose()),new o.Disposable(()=>{h.dispose(),clearTimeout(_)})}}e.ExtHostStatusBar=c}),define(we[67],be([1,0,4,5,3]),function(Z,e,o,k,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class B{constructor(A){this._onDidChangeStorage=new k.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=A.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,D){this._proxy.$registerExtensionStorageKeysToSync(A,D)}initializeExtensionStorage(A,D,F){return this._proxy.$initializeExtensionStorage(A,D).then(N=>N||F)}setValue(A,D,F){return this._proxy.$setValue(A,D,F)}$acceptValue(A,D,F){this._onDidChangeStorage.fire({shared:A,key:D,value:F})}}e.ExtHostStorage=B,e.IExtHostStorage=(0,w.createDecorator)("IExtHostStorage")}),define(we[68],be([1,0,3,27,12,50,2]),function(Z,e,o,k,w,B,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let A=class{constructor(F,N,b){this._logService=N,this._extHostFileSystem=b,this._workspace=F.workspace??void 0,this._environment=F.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(c=>this._value=c)}async _getWorkspaceStorageURI(F){return C.URI.joinPath(this._environment.workspaceStorageHome,F)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const F=this._workspace.id,N=await this._getWorkspaceStorageURI(F);try{return await this._extHostFileSystem.value.stat(N),this._logService.trace("[ExtHostStorage] storage dir already exists",N),N}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",N),await this._extHostFileSystem.value.createDirectory(N),await this._extHostFileSystem.value.writeFile(C.URI.joinPath(N,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:C.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),N}catch(b){this._logService.error("[ExtHostStorage]",b);return}}workspaceValue(F){if(this._value)return C.URI.joinPath(this._value,F.identifier.value)}globalValue(F){return C.URI.joinPath(this._environment.globalStorageHome,F.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=Fe([Ne(0,k.IExtHostInitDataService),Ne(1,w.ILogService),Ne(2,B.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(we[40],be([1,0,5,4,3,2,14,7,6,126,15,165,20,36,145,57,11,13]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,w.createDecorator)("IExtHostTerminalService");class y{constructor(t,l,m,f){this._proxy=t,this._id=l,this._creationOptions=m,this._name=f,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(P=>this._pidPromiseComplete=P);const S=this;this.value={get name(){return S._name||""},get processId(){return S._pidPromise},get creationOptions(){return S._creationOptions},get exitStatus(){return S._exitStatus},get state(){return S._state},sendText(P,$=!0){S._checkDisposed(),S._proxy.$sendText(S._id,P,$)},show(P){S._checkDisposed(),S._proxy.$show(S._id,P)},hide(){S._checkDisposed(),S._proxy.$hide(S._id)},dispose(){S._disposed||(S._disposed=!0,S._proxy.$dispose(S._id))},get dimensions(){if(!(S._cols===void 0||S._rows===void 0))return{columns:S._cols,rows:S._rows}}}}async create(t,l){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,h.withNullAsUndefined)(t.shellPath),shellArgs:(0,h.withNullAsUndefined)(t.shellArgs),cwd:(0,h.withNullAsUndefined)(t.cwd),env:(0,h.withNullAsUndefined)(t.env),icon:(0,h.withNullAsUndefined)(r(t.iconPath)),color:n.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,h.withNullAsUndefined)(t.message),strictEnv:(0,h.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,h.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,h.withNullAsUndefined)(l?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,h.withNullAsUndefined)(l?.useShellEnvironment),location:l?.location||this._serializeParentTerminal(t.location,l?.resolvedExtHostIdentifier),isTransient:(0,h.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,l,m,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:m,color:n.ThemeColor.isThemeColor(f)?f.id:void 0,location:this._serializeParentTerminal(t,l),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,l){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&l?{parentTerminal:l}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitCode(t){this._exitStatus=Object.freeze({code:t})}setDimensions(t,l){return t===this._cols&&l===this._rows||t===0||l===0?!1:(this._cols=t,this._rows=l,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(l=>{l!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=y;class d{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new o.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new o.Emitter,this._onDidChangeProperty=new o.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new o.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,l){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${l}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,l){this._pty.setDimensions?.({columns:t,rows:l})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(l=>this._onProcessData.fire(l)),this._pty.onDidClose?.((l=void 0)=>{this._onProcessExit.fire(l===void 0?void 0:l)}),this._pty.onDidOverrideDimensions?.(l=>{l&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:l.columns,rows:l.rows}})}),this._pty.onDidChangeName?.(l=>{this._onDidChangeProperty.fire({type:"title",value:l})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=d;let p=1,E=class extends A.Disposable{constructor(t,l){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new o.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new o.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new o.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new o.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new o.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=l.getProxy(k.MainContext.MainThreadTerminalService),this._bufferer=new s.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new o.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[m,f]of this._terminalProcesses)f.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,l){const m=new y(this._proxy,(0,g.generateUuid)(),t,t.name),f=new d(t.pty);return m.createExtensionTerminal(t.location,this._serializeParentTerminal(t,l).resolvedExtHostIdentifier,r(t.iconPath),i(t.color)).then(S=>{const P=this._setupExtHostProcessListeners(S,f);this._terminalProcessDisposables[S]=P}),this._terminals.push(m),m.value}_serializeParentTerminal(t,l){if(l=l||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const m=t.location.parentTerminal;if(m){const f=this._terminals.find(S=>S.value===m);f&&(l.resolvedExtHostIdentifier=f._id)}}else t.location&&typeof t.location!="object"?l.location=t.location:l.location&&typeof l.location=="object"&&"splitActiveTerminal"in l.location&&(l.location={splitActiveTerminal:!0});return l}attachPtyToTerminal(t,l){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const f=new d(l),S=this._setupExtHostProcessListeners(t,f);this._terminalProcessDisposables[t]=S}async $acceptActiveTerminalChanged(t){const l=this._activeTerminal;if(t===null){this._activeTerminal=void 0,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const m=this._getTerminalById(t);m&&(this._activeTerminal=m,l!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,l){const m=this._getTerminalById(t);m&&this._onDidWriteTerminalData.fire({terminal:m.value,data:l})}async $acceptTerminalDimensions(t,l,m){const f=this._getTerminalById(t);f&&f.setDimensions(l,m)&&this._onDidChangeTerminalDimensions.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(t,l,m){this._terminalProcesses.get(t)?.resize(l,m)}async $acceptTerminalTitleChange(t,l){const m=this._getTerminalById(t);m&&(m.name=l)}async $acceptTerminalClosed(t,l){const m=this._getTerminalObjectIndexById(this._terminals,t);if(m!==null){const f=this._terminals.splice(m,1)[0];f.setExitCode(l),this._onDidCloseTerminal.fire(f.value)}}$acceptTerminalOpened(t,l,m,f){if(l){const $=this._getTerminalObjectIndexById(this._terminals,l);if($!==null){this._terminals[$]._id=t,this._onDidOpenTerminal.fire(this.terminals[$]),this._terminals[$].isOpen=!0;return}}const S={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:B.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},P=new y(this._proxy,t,S,m);this._terminals.push(P),this._onDidOpenTerminal.fire(P.value),P.isOpen=!0}async $acceptTerminalProcessId(t,l){const m=this._getTerminalById(t);m&&m._setProcessId(l)}async $startExtensionTerminal(t,l){const m=this._getTerminalById(t);if(!m)return{message:(0,F.localize)(0,null,t)};m.isOpen||await new Promise(S=>{const P=this.onDidOpenTerminal(async $=>{$===m.value&&(P.dispose(),S())})});const f=this._terminalProcesses.get(t);f?f.startSendingEvents(l):this._extensionTerminalAwaitingStart[t]={initialDimensions:l}}_setupExtHostProcessListeners(t,l){const m=new A.DisposableStore;m.add(l.onProcessReady(S=>this._proxy.$sendProcessReady(t,S.pid,S.cwd))),m.add(l.onDidChangeProperty(S=>this._proxy.$sendProcessProperty(t,S))),this._bufferer.startBuffering(t,l.onProcessData),m.add(l.onProcessExit(S=>this._onProcessExit(t,S))),this._terminalProcesses.set(t,l);const f=this._extensionTerminalAwaitingStart[t];return f&&l instanceof d&&(l.startSendingEvents(f.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),m}$acceptProcessAckDataEvent(t,l){this._terminalProcesses.get(t)?.acknowledgeDataEvent(l)}$acceptProcessInput(t,l){this._terminalProcesses.get(t)?.input(l)}$acceptTerminalInteraction(t){const l=this._getTerminalById(t);l?.setInteractedWith()&&this._onDidChangeTerminalState.fire(l.value)}$acceptProcessResize(t,l,m){try{this._terminalProcesses.get(t)?.resize(l,m)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(t,l){this._terminalProcesses.get(t)?.shutdown(l)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(l=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:l}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(l=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:l}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new D.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,l,m){if(this._profileProviders.has(l))throw new Error(`Terminal profile provider "${l}" already registered`);return this._profileProviders.set(l,m),this._proxy.$registerProfileProvider(l,t.identifier.value),new D.Disposable(()=>{this._profileProviders.delete(l),this._proxy.$unregisterProfileProvider(l)})}async $createContributedProfileTerminal(t,l){const m=new c.CancellationTokenSource().token;let f=await this._profileProviders.get(t)?.provideTerminalProfile(m);if(!m.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,l);return}this.createTerminalFromOptions(f.options,l)}}async $provideLinks(t,l){const m=this._getTerminalById(t);if(!m)return[];this._terminalLinkCache.delete(t);const f=this._terminalLinkCancellationSource.get(t);f&&f.dispose(!0);const S=new c.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,S);const P=[],$={terminal:m.value,line:l},L=[];for(const W of this._linkProviders)L.push(_.Promises.withAsyncBody(async q=>{S.token.onCancellationRequested(()=>q({provider:W,links:[]}));const K=await W.provideTerminalLinks($,S.token)||[];S.token.isCancellationRequested||q({provider:W,links:K})}));const v=await Promise.all(L);if(S.token.isCancellationRequested)return[];const H=new Map;for(const W of v)W&&W.links.length>0&&P.push(...W.links.map(q=>{const K={id:p++,startIndex:q.startIndex,length:q.length,label:q.tooltip};return H.set(K.id,{provider:W.provider,link:q}),K}));return this._terminalLinkCache.set(t,H),P}$activateLink(t,l){const m=this._terminalLinkCache.get(t)?.get(l);!m||m.provider.handleTerminalLink(m.link)}_onProcessExit(t,l){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const m=this._terminalProcessDisposables[t];m&&(m.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,l)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,l){const m=this._getTerminalObjectIndexById(t,l);return m!==null?t[m]:null}_getTerminalObjectIndexById(t,l){let m=null;return t.some((f,S)=>f._id===l?(m=S,!0):!1),m}getEnvironmentVariableCollection(t){let l=this._environmentVariableCollections.get(t.identifier.value);return l||(l=new a,this._setEnvironmentVariableCollection(t.identifier.value,l)),l}_syncEnvironmentVariableCollection(t,l){const m=(0,b.serializeEnvironmentVariableCollection)(l.map);this._proxy.$setEnvironmentVariableCollection(t,l.persistent,m.length===0?void 0:m)}$initEnvironmentVariableCollections(t){t.forEach(l=>{const m=l[0],f=new a(l[1]);this._setEnvironmentVariableCollection(m,f)})}$acceptDefaultProfile(t,l){this._defaultProfile=t,this._defaultAutomationProfile=l}_setEnvironmentVariableCollection(t,l){this._environmentVariableCollections.set(t,l),l.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,l)})}};E=Fe([Ne(1,C.IExtHostRpcService)],E),e.BaseExtHostTerminalService=E;class a{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new o.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,l){this._setIfDiffers(t,{value:l,type:D.EnvironmentVariableMutatorType.Replace})}append(t,l){this._setIfDiffers(t,{value:l,type:D.EnvironmentVariableMutatorType.Append})}prepend(t,l){this._setIfDiffers(t,{value:l,type:D.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,l){const m=this.map.get(t);(!m||m.value!==l.value||m.type!==l.type)&&(this.map.set(t,l),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,l){this.map.forEach((m,f)=>t.call(l,f,m,this))}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=a;let T=class extends E{constructor(t){super(!1,t)}createTerminal(t,l,m){throw new N.NotSupportedError}createTerminalFromOptions(t,l){throw new N.NotSupportedError}};T=Fe([Ne(0,C.IExtHostRpcService)],T),e.WorkerExtHostTerminalService=T;function r(u){if(!(!u||typeof u=="string"))return"id"in u?{id:u.id,color:u.color}:u}function i(u){return n.ThemeColor.isThemeColor(u)?u:void 0}});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,o,k,w){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!w:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?w.call(Z,o):w?w.value=o:e.set(Z,o),o},De=this&&this.__classPrivateFieldGet||function(Z,e,o,k){if(o==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?k:o==="a"?k.call(Z):k?k.value:e.get(Z)};define(we[202],be([1,0,16,21,20,5,233,93,7,25,11,36,4,14,47,8,6,171,62,63]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_,y,d){"use strict";var p,E;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=class{constructor(L,v){this.resultsChangedEmitter=new B.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=L.getProxy(c.MainContext.MainThreadTesting),this.observer=new f(this.proxy),this.runTracker=new r(this.proxy),v.registerArgumentProcessor({processArgument:H=>H?.$mid===13?n.TestItem.toItemFromContext(H):H})}createTestController(L,v,H){if(this.controllers.has(L))throw new Error(`Attempt to insert a duplicate controller with ID "${L}"`);const W=new D.DisposableStore,q=W.add(new _.SingleUseTestCollection(L));q.root.label=v;const K=new Map,V=this.proxy,z={items:q.root.children,get label(){return v},set label(de){v=de,q.root.label=de,V.$updateController(L,{label:v})},get refreshHandler(){return H},set refreshHandler(de){H=de,V.$updateController(L,{canRefresh:!!de})},get id(){return L},createRunProfile:(de,Y,ie,ce,he)=>{let ue=(0,A.hash)(de);for(;K.has(ue);)ue++;return new S(this.proxy,K,L,ue,de,Y,ie,ce,he)},createTestItem(de,Y,ie){return new s.TestItemImpl(L,de,Y,ie)},createTestRun:(de,Y,ie=!0)=>this.runTracker.createTestRun(L,q,de,Y,ie),set resolveHandler(de){q.resolveHandler=de},get resolveHandler(){return q.resolveHandler},dispose:()=>{W.dispose()}};V.$registerTestController(L,v,!!H),W.add((0,D.toDisposable)(()=>V.$unregisterTestController(L)));const ae={controller:z,collection:q,profiles:K};return this.controllers.set(L,ae),W.add((0,D.toDisposable)(()=>this.controllers.delete(L))),W.add(q.onDidGenerateDiff(de=>V.$publishDiff(L,de.map(y.TestsDiffOp.serialize)))),z}createTestObserver(){return this.observer.checkout()}async runTests(L,v=w.CancellationToken.None){const H=i(L);if(!H)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const W=this.controllers.get(H.controllerId);if(!W)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:L.include?.map(q=>d.TestId.fromExtHostTestItem(q,W.collection.root.id).toString())??[W.collection.root.id],profileGroup:P[H.kind],profileId:H.profileId,controllerId:H.controllerId}],exclude:L.exclude?.map(q=>q.id)},v)}$provideFileCoverage(L,v,H){return(0,o.mapFind)(this.runTracker.trackers,q=>q.id===L?q.getCoverage(v):void 0)?.provideFileCoverage(H)??Promise.resolve([])}$resolveFileCoverage(L,v,H,W){return(0,o.mapFind)(this.runTracker.trackers,K=>K.id===L?K.getCoverage(v):void 0)?.resolveFileCoverage(H,W)??Promise.resolve([])}$configureRunProfile(L,v){this.controllers.get(L)?.profiles.get(v)?.configureHandler?.()}async $refreshTests(L,v){await this.controllers.get(L)?.controller.refreshHandler?.(v)}$publishTestResults(L){this.results=Object.freeze(L.map(v=>(0,F.deepFreeze)(n.TestResults.to(v))).concat(this.results).sort((v,H)=>H.completedAt-v.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(L,v){const H=this.controllers.get(d.TestId.fromString(L).controllerId)?.collection;H&&(await H.expand(L,v<0?1/0:v),H.flushDiff())}$acceptDiff(L){this.observer.applyDiff(L.map(y.TestsDiffOp.deserialize))}async $runControllerTests(L,v){const H=this.controllers.get(L.controllerId);if(!H)return;const{collection:W,profiles:q}=H,K=q.get(L.profileId);if(!K)return;const V=L.testIds.map(Y=>W.tree.get(Y)).filter(N.isDefined),z=L.excludeExtIds.map(Y=>H.collection.tree.get(Y)).filter(N.isDefined).filter(Y=>V.some(ie=>ie.fullId.compare(Y.fullId)===2));if(!V.length)return;const ae=new h.TestRunRequest(V.some(Y=>Y.actual instanceof s.TestItemRootImpl)?void 0:V.map(Y=>Y.actual),z.map(Y=>Y.actual),K),de=this.runTracker.prepareForMainThreadTestRun(ae,u.fromInternal(L,H.collection),v);try{await K.runHandler(ae,v)}finally{de.isRunning&&!v.isCancellationRequested&&await B.Event.toPromise(de.onEnd),de.dispose()}}$cancelExtensionTestRun(L){L===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(L)}};a=Fe([Ne(0,g.IExtHostRpcService)],a),e.ExtHostTesting=a;class T extends D.Disposable{constructor(L,v,H){super();this.dto=L,this.proxy=v,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new B.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new w.CancellationTokenSource(H)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:W}of this.tasks.values())W.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(L){return this.tasks.get(L)?.coverage}createRun(L){const v=this.dto.id,H=this.dto.controllerId,W=(0,b.generateUuid)(),q=new t(this.proxy,v,W),K=de=>(Y,...ie)=>{if(z){console.warn(`Setting the state of test "${Y.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(Y)||(this.ensureTestIsKnown(Y),de(Y,...ie))},V=(de,Y)=>{const ie=Y instanceof Array?Y.map(n.TestMessage.from):[n.TestMessage.from(Y)];if(de.uri&&de.range){const ce={range:n.Range.from(de.range),uri:de.uri};for(const he of ie)he.location=he.location||ce}this.proxy.$appendTestMessagesInRun(v,W,d.TestId.fromExtHostTestItem(de,H).toString(),ie)};let z=!1;const ae={isPersisted:this.dto.isPersisted,token:this.cts.token,name:L,get coverageProvider(){return q.coverageProvider},set coverageProvider(de){q.coverageProvider=de},enqueued:K(de=>{this.proxy.$updateTestStateInRun(v,W,d.TestId.fromExtHostTestItem(de,H).toString(),1)}),skipped:K(de=>{this.proxy.$updateTestStateInRun(v,W,d.TestId.fromExtHostTestItem(de,H).toString(),5)}),started:K(de=>{this.proxy.$updateTestStateInRun(v,W,d.TestId.fromExtHostTestItem(de,H).toString(),2)}),errored:K((de,Y,ie)=>{V(de,Y),this.proxy.$updateTestStateInRun(v,W,d.TestId.fromExtHostTestItem(de,H).toString(),6,ie)}),failed:K((de,Y,ie)=>{V(de,Y),this.proxy.$updateTestStateInRun(v,W,d.TestId.fromExtHostTestItem(de,H).toString(),4,ie)}),passed:K((de,Y)=>{this.proxy.$updateTestStateInRun(v,W,d.TestId.fromExtHostTestItem(de,this.dto.controllerId).toString(),3,Y)}),appendOutput:(de,Y,ie)=>{z||(ie&&(this.dto.isIncluded(ie)?this.ensureTestIsKnown(ie):ie=void 0),this.proxy.$appendOutputToRun(v,W,k.VSBuffer.fromString(de),Y&&n.location.from(Y),ie&&d.TestId.fromExtHostTestItem(ie,H).toString()))},end:()=>{z||(z=!0,this.proxy.$finishedTestRunTask(v,W),this.tasks.delete(W),this.isRunning||this.dispose())}};return this.tasks.set(W,{run:ae,coverage:q}),this.proxy.$startedTestRunTask(v,{id:W,name:L,running:!0}),ae}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(L){if(!(L instanceof s.TestItemImpl))throw new s.InvalidTestItemError(L.id);if(this.sharedTestIds.has(d.TestId.fromExtHostTestItem(L,this.dto.controllerId).toString()))return;const v=[],H=this.dto.colllection.root;for(;;){const W=n.TestItem.from(L);if(v.unshift(W),this.sharedTestIds.has(W.extId)||(this.sharedTestIds.add(W.extId),L===H))break;L=L.parent||H}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,v)}}class r{constructor(L){this.proxy=L,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(L,v,H){return this.getTracker(L,v,H)}cancelRunById(L){for(const v of this.tracked.values())if(v.id===L){v.dispose();return}}cancelAllRuns(){for(const L of this.tracked.values())L.dispose()}createTestRun(L,v,H,W,q){const K=this.tracked.get(H);if(K)return K.createRun(W);const V=u.fromPublic(L,v,H,q),z=i(H);this.proxy.$startedExtensionTestRun({controllerId:L,profile:z&&{group:P[z.kind],id:z.profileId},exclude:H.exclude?.map(de=>d.TestId.fromExtHostTestItem(de,v.root.id).toString())??[],id:V.id,include:H.include?.map(de=>d.TestId.fromExtHostTestItem(de,v.root.id).toString())??[v.root.id],persist:q});const ae=this.getTracker(H,V);return ae.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),ae.createRun(W)}getTracker(L,v,H){const W=new T(v,this.proxy,H);return this.tracked.set(L,W),W.onEnd(()=>this.tracked.delete(L)),W}}e.TestRunCoordinator=r;const i=$=>{if(!!$.profile){if(!($.profile instanceof S))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return $.profile}};class u{constructor(L,v,H,W,q,K){this.controllerId=L,this.id=v,this.isPersisted=q,this.colllection=K,this.includePrefix=H.map(V=>V+"\0"),this.excludePrefix=W.map(V=>V+"\0")}static fromPublic(L,v,H,W){return new u(L,(0,b.generateUuid)(),H.include?.map(q=>d.TestId.fromExtHostTestItem(q,L).toString())??[L],H.exclude?.map(q=>d.TestId.fromExtHostTestItem(q,L).toString())??[],W,v)}static fromInternal(L,v){return new u(L.controllerId,L.runId,L.testIds,L.excludeExtIds,!0,v)}isIncluded(L){const v=d.TestId.fromExtHostTestItem(L,this.controllerId).toString()+"\0";for(const H of this.excludePrefix)if(v===H||v.startsWith(H))return!1;for(const H of this.includePrefix)if(v===H||v.startsWith(H))return!0;return!1}}e.TestRunDto=u;class t{constructor(L,v,H){this.proxy=L,this.runId=v,this.taskId=H}set coverageProvider(L){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!L||(this._coverageProvider=L,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(L){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(L))());try{return(await this.fileCoverage)?.map(n.TestCoverage.fromFile)??[]}catch(v){throw this.fileCoverage=void 0,v}}async resolveFileCoverage(L,v){const H=await this.fileCoverage;let W=H?.[L];return!this._coverageProvider||!H||!W?[]:(W.detailedCoverage||(W=H[L]=await this._coverageProvider.resolveFileCoverage?.(W,v)??W),W.detailedCoverage?.map(n.TestCoverage.fromDetailed)??[])}}class l extends y.IncrementalChangeCollector{constructor(L){super();this.emitter=L,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(L){this.added.add(L)}update(L){Object.assign(L.revived,n.TestItem.toPlain(L.item)),this.added.has(L)||this.updated.add(L)}remove(L){if(this.added.has(L)){this.added.delete(L);return}if(this.updated.delete(L),L.parent&&this.alreadyRemoved.has(L.parent)){this.alreadyRemoved.add(L.item.extId);return}this.removed.add(L)}getChangeEvent(){const{added:L,updated:v,removed:H}=this;return{get added(){return[...L].map(W=>W.revived)},get updated(){return[...v].map(W=>W.revived)},get removed(){return[...H].map(W=>W.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class m extends y.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new B.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(L){return this.items.get(L)}getMirroredTestDataByReference(L){return this.items.get(L.id)}createItem(L,v){return{...L,revived:n.TestItem.toPlain(L.item),depth:v?v.depth+1:0,children:new Set}}createChangeCollector(){return new l(this.changeEmitter)}}e.MirroredTestCollection=m;class f{constructor(L){this.proxy=L}checkout(){this.current||(this.current=this.createObserverData());const L=this.current;return L.observers++,{onDidChangeTest:L.tests.onDidChangeTests,get tests(){return[...L.tests.rootTests].map(v=>v.revived)},dispose:(0,C.once)(()=>{--L.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(L){return this.current?.tests.getMirroredTestDataByReference(L)}applyDiff(L){this.current?.tests.apply(L)}createObserverData(){const L=new m;return this.proxy.$subscribeToDiffs(),{observers:0,tests:L}}}class S{constructor(L,v,H,W,q,K,V,z=!1,ae=void 0){this.controllerId=H,this.profileId=W,this._label=q,this.kind=K,this.runHandler=V,this._isDefault=z,this._tag=ae,p.set(this,void 0),E.set(this,void 0),Ve(this,p,L,"f"),Ve(this,E,v,"f"),v.set(W,this);const de=P[K];if(typeof de!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);De(this,p,"f").$publishTestRunProfile({profileId:W,controllerId:H,tag:ae?n.TestTag.namespace(this.controllerId,ae.id):null,label:q,group:de,isDefault:z,hasConfigurationHandler:!1})}get label(){return this._label}set label(L){L!==this._label&&(this._label=L,De(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:L}))}get isDefault(){return this._isDefault}set isDefault(L){L!==this._isDefault&&(this._isDefault=L,De(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:L}))}get tag(){return this._tag}set tag(L){L?.id!==this._tag?.id&&(this._tag=L,De(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:L?n.TestTag.namespace(this.controllerId,L.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(L){L!==this._configureHandler&&(this._configureHandler=L,De(this,p,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!L}))}dispose(){De(this,E,"f")?.delete(this.profileId)&&(Ve(this,E,void 0,"f"),De(this,p,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=S,p=new WeakMap,E=new WeakMap;const P={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(we[203],be([1,0,5,16,4,90,8,6]),function(Z,e,o,k,w,B,C,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class D{constructor(N,b){this._extHostDocumentsAndEditors=b,this._onDidChangeTextEditorSelection=new o.Emitter,this._onDidChangeTextEditorOptions=new o.Emitter,this._onDidChangeTextEditorVisibleRanges=new o.Emitter,this._onDidChangeTextEditorViewColumn=new o.Emitter,this._onDidChangeActiveTextEditor=new o.Emitter,this._onDidChangeVisibleTextEditors=new o.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=N.getProxy(w.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(c=>this._onDidChangeVisibleTextEditors.fire(c)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(c=>this._onDidChangeActiveTextEditor.fire(c))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(N){const b=this._extHostDocumentsAndEditors.allEditors();return N?b:b.map(c=>c.value)}async showTextDocument(N,b,c){let g;typeof b=="number"?g={position:C.ViewColumn.from(b),preserveFocus:c}:typeof b=="object"?g={position:C.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus,selection:typeof b.selection=="object"?C.Range.from(b.selection):void 0,pinned:typeof b.preview=="boolean"?!b.preview:void 0}:g={preserveFocus:!1};const s=await this._proxy.$tryShowTextDocument(N.uri,g),n=s&&this._extHostDocumentsAndEditors.getEditor(s);if(n)return n.value;throw s?new Error(`Could NOT open editor for "${N.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${N.uri.toString()}".`)}createTextEditorDecorationType(N,b){return new B.TextEditorDecorationType(this._proxy,N,b).value}$acceptEditorPropertiesChanged(N,b){const c=this._extHostDocumentsAndEditors.getEditor(N);if(!c)throw new Error("unknown text editor");if(b.options&&c._acceptOptions(b.options),b.selections){const g=b.selections.selections.map(C.Selection.to);c._acceptSelections(g)}if(b.visibleRanges){const g=k.coalesce(b.visibleRanges.map(C.Range.to));c._acceptVisibleRanges(g)}if(b.options&&this._onDidChangeTextEditorOptions.fire({textEditor:c.value,options:{...b.options,lineNumbers:C.TextEditorLineNumbersStyle.to(b.options.lineNumbers)}}),b.selections){const g=A.TextEditorSelectionChangeKind.fromValue(b.selections.source),s=b.selections.selections.map(C.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:c.value,selections:s,kind:g})}if(b.visibleRanges){const g=k.coalesce(b.visibleRanges.map(C.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:c.value,visibleRanges:g})}}$acceptEditorPositionData(N){for(const b in N){const c=this._extHostDocumentsAndEditors.getEditor(b);if(!c)throw new Error("Unknown text editor");const g=C.ViewColumn.to(N[b]);c.value.viewColumn!==g&&(c._acceptViewColumn(g),this._onDidChangeTextEditorViewColumn.fire({textEditor:c.value,viewColumn:g}))}}getDiffInformation(N){return Promise.resolve(this._proxy.$getDiffInformation(N))}}e.ExtHostEditors=D}),define(we[204],be([1,0,2,3,4,7,6,8,11]),function(Z,e,o,k,w,B,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,k.createDecorator)("IExtHostTimeline");class F{constructor(c,g){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=c.getProxy(w.MainContext.MainThreadTimeline),g.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===11){const n=s.uri===void 0?void 0:o.URI.revive(s.uri);return this._itemsBySourceAndUriMap.get(s.source)?.get(N(n))?.get(s.handle)}return s}})}async $getTimeline(c,g,s,n,h){return this._providers.get(c)?.provideTimeline(o.URI.revive(g),s,n,h)}registerTimelineProvider(c,g,s,n){const h=new B.DisposableStore,_=this.convertTimelineItem(g.id,n,h).bind(this);let y;g.onDidChange&&(y=g.onDidChange(p=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...p,id:g.id}),this));const d=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...g,scheme:c,onDidChange:void 0,async provideTimeline(p,E,a,T){T?.resetCache&&(h.clear(),d.get(g.id)?.clear());const r=await g.provideTimeline(p,E,a);if(r==null)return;const i=_(p,T);return{...r,source:g.id,items:r.items.map(i)}},dispose(){for(const p of d.values())p.get(g.id)?.clear();y?.dispose(),h.dispose()}})}convertTimelineItem(c,g,s){return(n,h)=>{let _;if(h?.cacheResults){let y=this._itemsBySourceAndUriMap.get(c);y===void 0&&(y=new Map,this._itemsBySourceAndUriMap.set(c,y));const d=N(n);_=y.get(d),_===void 0&&(_=new Map,y.set(d,_))}return y=>{const{iconPath:d,...p}=y,E=`${c}|${y.id??y.timestamp}`;_?.set(E,y);let a,T,r;y.iconPath&&(d instanceof C.ThemeIcon?r={id:d.id,color:d.color}:o.URI.isUri(d)?(a=d,T=d):{light:a,dark:T}=d);let i;return C.MarkdownString.isMarkdownString(p.detail)?i=A.MarkdownString.from(p.detail):(0,D.isString)(p.detail)&&(i=p.detail),{...p,id:p.id??void 0,handle:E,source:c,command:y.command?g.toInternal(y.command,s):void 0,icon:a,iconDark:T,themeIcon:r,detail:i,accessibilityInformation:y.accessibilityInformation}}}}registerTimelineProviderCore(c){if(this._providers.get(c.id))throw new Error(`Timeline Provider ${c.id} already exists.`);return this._proxy.$registerTimelineProvider({id:c.id,label:c.label,scheme:c.scheme}),this._providers.set(c.id,c),(0,B.toDisposable)(()=>{for(const s of this._itemsBySourceAndUriMap.values())s.get(c.id)?.clear();this._providers.delete(c.id),this._proxy.$unregisterTimelineProvider(c.id),c.dispose()})}}e.ExtHostTimeline=F;function N(b){return b?.toString()}}),define(we[205],be([1,0,7,10,2,4]),function(Z,e,o,k,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class C{constructor(D){this._openers=new Map,this._proxy=D.getProxy(B.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,F,N,b){if(this._openers.has(F))throw new Error(`Opener with id '${F}' already registered`);const c=b.schemes.find(g=>!C.supportedSchemes.has(g));if(c)throw new Error(`Scheme '${c}' is not supported. Only http and https are currently supported.`);return this._openers.set(F,N),this._proxy.$registerUriOpener(F,b.schemes,D,b.label),(0,o.toDisposable)(()=>{this._openers.delete(F),this._proxy.$unregisterUriOpener(F)})}async $canOpenUri(D,F,N){const b=this._openers.get(D);if(!b)throw new Error(`Unknown opener with id: ${D}`);const c=w.URI.revive(F);return b.canOpenExternalUri(c,N)}async $openUri(D,F,N){const b=this._openers.get(D);if(!b)throw new Error(`Unknown opener id: '${D}'`);return b.openExternalUri(w.URI.revive(F.resolvedUri),{sourceUri:w.URI.revive(F.sourceUri)},N)}}e.ExtHostUriOpeners=C,C.supportedSchemes=new Set([k.Schemas.http,k.Schemas.https])}),define(we[206],be([1,0,4,2,7,15,26]),function(Z,e,o,k,w,B,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(F){this.handles=new Set,this.handlers=new Map,this._proxy=F.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(F,N){if(this.handles.has(C.ExtensionIdentifier.toKey(F)))throw new Error(`Protocol handler already registered for extension ${F}`);const b=A.HandlePool++;return this.handles.add(C.ExtensionIdentifier.toKey(F)),this.handlers.set(b,N),this._proxy.$registerUriHandler(b,F),(0,w.toDisposable)(()=>{this.handles.delete(C.ExtensionIdentifier.toKey(F)),this.handlers.delete(b),this._proxy.$unregisterUriHandler(b)})}$handleExternalUri(F,N){const b=this.handlers.get(F);if(!b)return Promise.resolve(void 0);try{b.handleUri(k.URI.revive(N))}catch(c){(0,B.onUnexpectedError)(c)}return Promise.resolve(void 0)}async createAppUri(F){return k.URI.revive(await this._proxy.$createAppUri(F))}}e.ExtHostUrls=A,A.HandlePool=0});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,o,k,w){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!w:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?w.call(Z,o):w?w.value=o:e.set(Z,o),o},De=this&&this.__classPrivateFieldGet||function(Z,e,o,k){if(o==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?k:o==="a"?k.call(Z):k?k.value:e.get(Z)};define(we[51],be([1,0,5,10,2,136,154,61,4]),function(Z,e,o,k,w,B,C,A,D){"use strict";var F,N,b,c,g,s,n,h,_,y,d,p;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class E{constructor(m,f,S,P,$,L,v){F.set(this,void 0),N.set(this,void 0),b.set(this,void 0),c.set(this,void 0),g.set(this,void 0),s.set(this,void 0),n.set(this,""),h.set(this,void 0),_.set(this,!1),y.set(this,!1),d.set(this,!1),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,p.set(this,new o.Emitter),this._onDidDispose=De(this,p,"f").event,Ve(this,F,m,"f"),Ve(this,N,f,"f"),Ve(this,h,S,"f"),Ve(this,c,P,"f"),Ve(this,g,$,"f"),Ve(this,s,L,"f"),Ve(this,d,a(L),"f"),Ve(this,b,v,"f")}dispose(){Ve(this,_,!0,"f"),De(this,p,"f").fire(),De(this,p,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(m){return Ve(this,y,!0,"f"),(0,A.asWebviewUri)(m,De(this,c,"f").remote)}get cspSource(){const m=De(this,s,"f").extensionLocation;if(m.scheme===k.Schemas.https||m.scheme===k.Schemas.http){let f=m.toString();return f.endsWith("/")||(f+="/"),f+" "+A.webviewGenericCspSource}return A.webviewGenericCspSource}get html(){return this.assertNotDisposed(),De(this,n,"f")}set html(m){this.assertNotDisposed(),De(this,n,"f")!==m&&(Ve(this,n,m,"f"),!De(this,y,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(m)&&(Ve(this,y,!0,"f"),De(this,b,"f").report("Webview vscode-resource: uris",De(this,s,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),De(this,N,"f").$setHtml(De(this,F,"f"),m))}get options(){return this.assertNotDisposed(),De(this,h,"f")}set options(m){this.assertNotDisposed(),De(this,N,"f").$setOptions(De(this,F,"f"),i(De(this,s,"f"),De(this,g,"f"),m)),Ve(this,h,m,"f")}async postMessage(m){if(De(this,_,"f"))return!1;const f=(0,C.serializeWebviewMessage)(m,{serializeBuffersForPostMessage:De(this,d,"f")});return De(this,N,"f").$postMessage(De(this,F,"f"),f.message,...f.buffers)}assertNotDisposed(){if(De(this,_,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=E,F=new WeakMap,N=new WeakMap,b=new WeakMap,c=new WeakMap,g=new WeakMap,s=new WeakMap,n=new WeakMap,h=new WeakMap,_=new WeakMap,y=new WeakMap,d=new WeakMap,p=new WeakMap;function a(l){try{const m=(0,B.normalizeVersion)((0,B.parseVersion)(l.engines.vscode));return!!m&&m.majorBase>=1&&m.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=a;class T{constructor(m,f,S,P,$){this.initData=f,this.workspace=S,this._logService=P,this._deprecationService=$,this._webviews=new Map,this._webviewProxy=m.getProxy(D.MainContext.MainThreadWebviews)}$onMessage(m,f,S){const P=this.getWebview(m);if(P){const{message:$}=(0,C.deserializeWebviewMessage)(f,S.value);P._onMessageEmitter.fire($)}}$onMissingCsp(m,f){this._logService.warn(`${f} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(m,f,S){const P=new E(m,this._webviewProxy,u(f),this.initData,this.workspace,S,this._deprecationService);return this._webviews.set(m,P),P._onDidDispose(()=>{this._webviews.delete(m)}),P}deleteWebview(m){this._webviews.delete(m)}getWebview(m){return this._webviews.get(m)}}e.ExtHostWebviews=T;function r(l){return{id:l.identifier,location:l.extensionLocation}}e.toExtensionData=r;function i(l,m,f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots||t(l,m)}}e.serializeWebviewOptions=i;function u(l){return{enableCommandUris:l.enableCommandUris,enableScripts:l.enableScripts,enableForms:l.enableForms,portMapping:l.portMapping,localResourceRoots:l.localResourceRoots?.map(m=>w.URI.from(m))}}e.reviveOptions=u;function t(l,m){return[...(m?.getWorkspaceFolders()||[]).map(f=>f.uri),l.extensionLocation]}}),define(we[207],be([1,0,20,93,7,10,24,2,8,51,58,4,6]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class g{constructor(a,T){this.document=a,this._storagePath=T,this._backupCounter=1,this._edits=new N.Cache("custom documents")}addEdit(a){return this._edits.add([a])}async undo(a,T){await this.getEdit(a).undo(),T||this.disposeBackup()}async redo(a,T){await this.getEdit(a).redo(),T||this.disposeBackup()}disposeEdits(a){for(const T of a)this._edits.delete(T)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const a=p(this.document.uri)+this._backupCounter++;return(0,C.joinPath)(this._storagePath,a)}updateBackup(a){this._backup?.delete(),this._backup=a}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(a){const T=this._edits.get(a,0);if(!T)throw new Error("No edit found");return T}}class s{constructor(){this._documents=new Map}get(a,T){return this._documents.get(this.key(a,T))}add(a,T,r){const i=this.key(a,T.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${a} resource:${T.uri}`);const u=new g(T,r);return this._documents.set(i,u),u}delete(a,T){const r=this.key(a,T.uri);this._documents.delete(r)}key(a,T){return`${a}@@@${T}`}}var n;(function(E){E[E.Text=0]="Text",E[E.Custom=1]="Custom"})(n||(n={}));class h{constructor(){this._providers=new Map}addTextProvider(a,T,r){return this.add(0,a,T,r)}addCustomProvider(a,T,r){return this.add(1,a,T,r)}get(a){return this._providers.get(a)}add(a,T,r,i){if(this._providers.has(T))throw new Error(`Provider for viewType:${T} already registered`);return this._providers.set(T,{type:a,extension:r,provider:i}),new c.Disposable(()=>this._providers.delete(T))}}class _{constructor(a,T,r,i,u){this._extHostDocuments=T,this._extensionStoragePaths=r,this._extHostWebview=i,this._extHostWebviewPanels=u,this._editorProviders=new h,this._documents=new s,this._proxy=a.getProxy(b.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,T,r,i){const u=new w.DisposableStore;return y(r)?(u.add(this._editorProviders.addTextProvider(T,a,r)),this._proxy.$registerTextEditorProvider((0,F.toExtensionData)(a),T,i.webviewOptions||{},{supportsMove:!!r.moveCustomTextEditor},(0,F.shouldSerializeBuffersForPostMessage)(a))):(u.add(this._editorProviders.addCustomProvider(T,a,r)),this.supportEditing(r)&&u.add(r.onDidChangeCustomDocument(t=>{const l=this.getCustomDocumentEntry(T,t.document.uri);if(d(t)){const m=l.addEdit(t);this._proxy.$onDidEdit(t.document.uri,T,m,t.label)}else this._proxy.$onContentChange(t.document.uri,T)})),this._proxy.$registerCustomEditorProvider((0,F.toExtensionData)(a),T,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,F.shouldSerializeBuffersForPostMessage)(a))),c.Disposable.from(u,new c.Disposable(()=>{this._proxy.$unregisterEditorProvider(T)}))}async $createCustomDocument(a,T,r,i,u){const t=this._editorProviders.get(T);if(!t)throw new Error(`No provider found for '${T}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${T}'`);const l=A.URI.revive(a),m=await t.provider.openCustomDocument(l,{backupId:r,untitledDocumentData:i?.buffer},u);let f;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(f=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(T,m,f),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(a,T){const r=this._editorProviders.get(T);if(!r)throw new Error(`No provider found for '${T}'`);if(r.type!==1)throw new Error(`Invalid provider type for '${T}'`);const i=A.URI.revive(a),{document:u}=this.getCustomDocumentEntry(T,i);this._documents.delete(T,u),u.dispose()}async $resolveWebviewEditor(a,T,r,i,u,t){const l=this._editorProviders.get(r);if(!l)throw new Error(`No provider found for '${r}'`);const m=D.ViewColumn.to(u),f=this._extHostWebview.createNewWebview(T,i.webviewOptions,l.extension),S=this._extHostWebviewPanels.createNewWebviewPanel(T,r,i.title,m,i.panelOptions,f),P=A.URI.revive(a);switch(l.type){case 1:{const{document:$}=this.getCustomDocumentEntry(r,P);return l.provider.resolveCustomEditor($,S,t)}case 0:{const $=this._extHostDocuments.getDocument(P);return l.provider.resolveCustomTextEditor($,S,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,T,r){this.getCustomDocumentEntry(T,a).disposeEdits(r)}async $onMoveCustomEditor(a,T,r){const i=this._editorProviders.get(r);if(!i)throw new Error(`No provider found for '${r}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${r}'`);const u=this._extHostWebviewPanels.getWebviewPanel(a);if(!u)throw new Error("No webview found");const t=A.URI.revive(T),l=this._extHostDocuments.getDocument(t);await i.provider.moveCustomTextEditor(l,u,o.CancellationToken.None)}async $undo(a,T,r,i){return this.getCustomDocumentEntry(T,a).undo(r,i)}async $redo(a,T,r,i){return this.getCustomDocumentEntry(T,a).redo(r,i)}async $revert(a,T,r){const i=this.getCustomDocumentEntry(T,a);await this.getCustomEditorProvider(T).revertCustomDocument(i.document,r),i.disposeBackup()}async $onSave(a,T,r){const i=this.getCustomDocumentEntry(T,a);await this.getCustomEditorProvider(T).saveCustomDocument(i.document,r),i.disposeBackup()}async $onSaveAs(a,T,r,i){const u=this.getCustomDocumentEntry(T,a);return this.getCustomEditorProvider(T).saveCustomDocumentAs(u.document,A.URI.revive(r),i)}async $backup(a,T,r){const i=this.getCustomDocumentEntry(T,a),t=await this.getCustomEditorProvider(T).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},r);return i.updateBackup(t),t.id}getCustomDocumentEntry(a,T){const r=this._documents.get(a,A.URI.revive(T));if(!r)throw new Error("No custom document found");return r}getCustomEditorProvider(a){const r=this._editorProviders.get(a)?.provider;if(!r||!this.supportEditing(r))throw new Error("Custom document is not editable");return r}supportEditing(a){return!!a.onDidChangeCustomDocument}}e.ExtHostCustomEditors=_;function y(E){return typeof E.resolveCustomTextEditor=="function"}function d(E){return typeof E.undo=="function"&&typeof E.redo=="function"}function p(E){const a=E.scheme===B.Schemas.file||E.scheme===B.Schemas.untitled?E.fsPath:E.toString();return(0,k.hash)(a)+""}});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,o,k,w){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!w:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?w.call(Z,o):w?w.value=o:e.set(Z,o),o},De=this&&this.__classPrivateFieldGet||function(Z,e,o,k){if(o==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?k:o==="a"?k.call(Z):k?k.value:e.get(Z)};define(we[208],be([1,0,5,7,2,36,8,51,4,6]),function(Z,e,o,k,w,B,C,A,D,F){"use strict";var N,b,c,g,s,n,h,_,y,d,p,E,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class T extends k.Disposable{constructor(t,l,m,f,S,P,$){super();N.set(this,void 0),b.set(this,void 0),c.set(this,void 0),g.set(this,void 0),s.set(this,void 0),n.set(this,void 0),h.set(this,void 0),_.set(this,void 0),y.set(this,!0),d.set(this,!0),p.set(this,!1),E.set(this,this._register(new o.Emitter)),this.onDidDispose=De(this,E,"f").event,a.set(this,this._register(new o.Emitter)),this.onDidChangeViewState=De(this,a,"f").event,Ve(this,N,t,"f"),Ve(this,b,l,"f"),Ve(this,c,m,"f"),Ve(this,s,P,"f"),Ve(this,_,S,"f"),Ve(this,n,f,"f"),Ve(this,g,$,"f")}dispose(){De(this,p,"f")||(Ve(this,p,!0,"f"),De(this,E,"f").fire(),De(this,b,"f").$disposeWebview(De(this,N,"f")),De(this,g,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),De(this,g,"f")}get viewType(){return this.assertNotDisposed(),De(this,c,"f")}get title(){return this.assertNotDisposed(),De(this,n,"f")}set title(t){this.assertNotDisposed(),De(this,n,"f")!==t&&(Ve(this,n,t,"f"),De(this,b,"f").$setTitle(De(this,N,"f"),t))}get iconPath(){return this.assertNotDisposed(),De(this,h,"f")}set iconPath(t){this.assertNotDisposed(),De(this,h,"f")!==t&&(Ve(this,h,t,"f"),De(this,b,"f").$setIconPath(De(this,N,"f"),w.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return De(this,s,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof De(this,_,"f")=="number"&&De(this,_,"f")<0))return De(this,_,"f")}get active(){return this.assertNotDisposed(),De(this,d,"f")}get visible(){return this.assertNotDisposed(),De(this,y,"f")}_updateViewState(t){De(this,p,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Ve(this,d,t.active,"f"),Ve(this,y,t.visible,"f"),Ve(this,_,t.viewColumn,"f"),De(this,a,"f").fire({webviewPanel:this}))}reveal(t,l){this.assertNotDisposed(),De(this,b,"f").$reveal(De(this,N,"f"),{viewColumn:typeof t=="undefined"?void 0:C.ViewColumn.from(t),preserveFocus:!!l})}assertNotDisposed(){if(De(this,p,"f"))throw new Error("Webview is disposed")}}N=new WeakMap,b=new WeakMap,c=new WeakMap,g=new WeakMap,s=new WeakMap,n=new WeakMap,h=new WeakMap,_=new WeakMap,y=new WeakMap,d=new WeakMap,p=new WeakMap,E=new WeakMap,a=new WeakMap;class r{constructor(t,l,m){this.webviews=l,this.workspace=m,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(D.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,B.generateUuid)()}createWebviewPanel(t,l,m,f,S={}){const P=typeof f=="object"?f.viewColumn:f,$={viewColumn:C.ViewColumn.from(P),preserveFocus:typeof f=="object"&&!!f.preserveFocus},L=(0,A.shouldSerializeBuffersForPostMessage)(t),v=r.newHandle();this._proxy.$createWebviewPanel((0,A.toExtensionData)(t),v,l,{title:m,panelOptions:i(S),webviewOptions:(0,A.serializeWebviewOptions)(t,this.workspace,S),serializeBuffersForPostMessage:L},$);const H=this.webviews.createNewWebview(v,S,t);return this.createNewWebviewPanel(v,l,m,P,S,H)}$onDidChangeWebviewPanelViewStates(t){const l=Object.keys(t);l.sort((m,f)=>{const S=t[m],P=t[f];return S.active?1:P.active?-1:+S.visible-+P.visible});for(const m of l){const f=this.getWebviewPanel(m);if(!f)continue;const S=t[m];f._updateViewState({active:S.active,visible:S.visible,viewColumn:C.ViewColumn.to(S.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,l,m){if(this._serializers.has(l))throw new Error(`Serializer for '${l}' already registered`);return this._serializers.set(l,{serializer:m,extension:t}),this._proxy.$registerSerializer(l,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(t)}),new F.Disposable(()=>{this._serializers.delete(l),this._proxy.$unregisterSerializer(l)})}async $deserializeWebviewPanel(t,l,m,f){const S=this._serializers.get(l);if(!S)throw new Error(`No serializer found for '${l}'`);const{serializer:P,extension:$}=S,L=this.webviews.createNewWebview(t,m.webviewOptions,$),v=this.createNewWebviewPanel(t,l,m.title,f,m.panelOptions,L);await P.deserializeWebviewPanel(v,m.state)}createNewWebviewPanel(t,l,m,f,S,P){const $=new T(t,this._proxy,l,m,f,S,P);return this._webviewPanels.set(t,$),$}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=r;function i(u){return{enableFindWidget:u.enableFindWidget,retainContextWhenHidden:u.retainContextWhenHidden}}});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,o,k,w){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!w:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?w.call(Z,o):w?w.value=o:e.set(Z,o),o},De=this&&this.__classPrivateFieldGet||function(Z,e,o,k){if(o==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?k:o==="a"?k.call(Z):k?k.value:e.get(Z)};define(we[209],be([1,0,5,7,51,4,6]),function(Z,e,o,k,w,B,C){"use strict";var A,D,F,N,b,c,g,s,n,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class _ extends k.Disposable{constructor(p,E,a,T,r,i){super();A.set(this,void 0),D.set(this,void 0),F.set(this,void 0),N.set(this,void 0),b.set(this,!1),c.set(this,void 0),g.set(this,void 0),s.set(this,void 0),n.set(this,this._register(new o.Emitter)),this.onDidChangeVisibility=De(this,n,"f").event,h.set(this,this._register(new o.Emitter)),this.onDidDispose=De(this,h,"f").event,Ve(this,F,a,"f"),Ve(this,g,T,"f"),Ve(this,A,p,"f"),Ve(this,D,E,"f"),Ve(this,N,r,"f"),Ve(this,c,i,"f")}dispose(){De(this,b,"f")||(Ve(this,b,!0,"f"),De(this,h,"f").fire(),De(this,N,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),De(this,g,"f")}set title(p){this.assertNotDisposed(),De(this,g,"f")!==p&&(Ve(this,g,p,"f"),De(this,D,"f").$setWebviewViewTitle(De(this,A,"f"),p))}get description(){return this.assertNotDisposed(),De(this,s,"f")}set description(p){this.assertNotDisposed(),De(this,s,"f")!==p&&(Ve(this,s,p,"f"),De(this,D,"f").$setWebviewViewDescription(De(this,A,"f"),p))}get visible(){return De(this,c,"f")}get webview(){return De(this,N,"f")}get viewType(){return De(this,F,"f")}_setVisible(p){p===De(this,c,"f")||De(this,b,"f")||(Ve(this,c,p,"f"),De(this,n,"f").fire())}show(p){this.assertNotDisposed(),De(this,D,"f").$show(De(this,A,"f"),!!p)}assertNotDisposed(){if(De(this,b,"f"))throw new Error("Webview is disposed")}}A=new WeakMap,D=new WeakMap,F=new WeakMap,N=new WeakMap,b=new WeakMap,c=new WeakMap,g=new WeakMap,s=new WeakMap,n=new WeakMap,h=new WeakMap;class y{constructor(p,E){this._extHostWebview=E,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=p.getProxy(B.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(p,E,a,T){if(this._viewProviders.has(E))throw new Error(`View provider for '${E}' already registered`);return this._viewProviders.set(E,{provider:a,extension:p}),this._proxy.$registerWebviewViewProvider((0,w.toExtensionData)(p),E,{retainContextWhenHidden:T?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new C.Disposable(()=>{this._viewProviders.delete(E),this._proxy.$unregisterWebviewViewProvider(E)})}async $resolveWebviewView(p,E,a,T,r){const i=this._viewProviders.get(E);if(!i)throw new Error(`No view provider found for '${E}'`);const{provider:u,extension:t}=i,l=this._extHostWebview.createNewWebview(p,{},t),m=new _(p,this._proxy,E,a,l,!0);this._webviewViews.set(p,m),await u.resolveWebviewView(m,{state:T},r)}async $onDidChangeWebviewViewVisibility(p,E){this.getWebviewView(p)._setVisible(E)}async $disposeWebviewView(p){const E=this.getWebviewView(p);this._webviewViews.delete(p),E.dispose(),this._extHostWebview.deleteWebview(p)}getWebviewView(p){const E=this._webviewViews.get(p);if(!E)throw new Error("No webview found");return E}}e.ExtHostWebviewViews=y}),define(we[95],be([1,0,5,4,2,10,9,3,14]),function(Z,e,o,k,w,B,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let F=class ji{constructor(b){this._onDidChangeWindowState=new o.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=ji.InitialState,this._proxy=b.getProxy(k.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(c=>this.$onDidChangeWindowFocus(c))}get state(){return this._state}$onDidChangeWindowFocus(b){b!==this._state.focused&&(this._state={...this._state,focused:b},this._onDidChangeWindowState.fire(this._state))}openUri(b,c){let g;if(typeof b=="string"){g=b;try{b=w.URI.parse(b)}catch{return Promise.reject(`Invalid uri - '${b}'`)}}return(0,C.isFalsyOrWhitespace)(b.scheme)?Promise.reject("Invalid scheme - cannot be empty"):b.scheme===B.Schemas.command?Promise.reject(`Invalid scheme '${b.scheme}'`):this._proxy.$openUri(b,g,c)}async asExternalUri(b,c){if((0,C.isFalsyOrWhitespace)(b.scheme))return Promise.reject("Invalid scheme - cannot be empty");const g=await this._proxy.$asExternalUri(b,c);return w.URI.from(g)}};F.InitialState={focused:!0},F=Fe([Ne(0,D.IExtHostRpcService)],F),e.ExtHostWindow=F,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(we[210],be([1,0,13,21,20,15,5,7,108,176,38]),function(Z,e,o,k,w,B,C,A,D,F,N){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function c(S,P){try{return JSON.stringify(S,P)}catch{return"null"}}const g="$$ref$$",s={[g]:-1};class n{constructor(P,$){this.jsonString=P,this.referencedBuffers=$}}function h(S,P=null,$=!1){const L=[];return{jsonString:($?c:JSON.stringify)(S,(H,W)=>{if(typeof W=="undefined")return s;if(typeof W=="object"){if(W instanceof k.VSBuffer){const q=L.push(W)-1;return{[g]:q}}if(P)return P(H,W)}return W}),referencedBuffers:L}}e.stringifyJsonWithBufferRefs=h;function _(S,P,$){return JSON.parse(S,(L,v)=>{if(v){const H=v[g];if(typeof H=="number")return P[H];if($&&v.$mid===1)return $.transformIncoming(v)}return v})}e.parseJsonAndRestoreBufferRefs=_;function y(S,P){return JSON.stringify(S,P)}function d(S){return S?(P,$)=>$&&$.$mid===1?S.transformOutgoing($):$:null}var p;(function(S){S[S.LocalSide=0]="LocalSide",S[S.OtherSide=1]="OtherSide"})(p=e.RequestInitiator||(e.RequestInitiator={}));var E;(function(S){S[S.Responsive=0]="Responsive",S[S.Unresponsive=1]="Unresponsive"})(E=e.ResponsiveState||(e.ResponsiveState={}));const a=()=>{},T=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class i extends A.Disposable{constructor(P,$=null,L=null){super();this[b]=!0,this._onDidChangeResponsiveState=this._register(new C.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=P,this._logger=$,this._uriTransformer=L,this._uriReplacer=d(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let v=0,H=N.ProxyIdentifier.count;v<H;v++)this._locals[v]=null,this._proxies[v]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new o.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(v=>this._receiveOneMessage(v))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(P=>{this._pendingRPCReplies[P].resolveErr(B.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(P){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(P){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(P){this._responsiveState!==P&&(this._responsiveState=P,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(P){return this._uriTransformer?(0,D.transformIncomingURIs)(P,this._uriTransformer):P}getProxy(P){const{nid:$,sid:L}=P;return this._proxies[$]||(this._proxies[$]=this._createProxy($,L)),this._proxies[$]}_createProxy(P,$){let L={get:(v,H)=>(typeof H=="string"&&!v[H]&&H.charCodeAt(0)===36&&(v[H]=(...W)=>this._remoteCall(P,H,W)),H===r?$:v[H])};return new Proxy(Object.create(null),L)}set(P,$){return this._locals[P.nid]=$,$}assertRegistered(P){for(let $=0,L=P.length;$<L;$++){const v=P[$];if(!this._locals[v.nid])throw new Error(`Missing proxy instance ${v.sid}`)}}_receiveOneMessage(P){if(this._isDisposed)return;const $=P.byteLength,L=u.read(P,0),v=L.readUInt8(),H=L.readUInt32();switch(v){case 1:case 2:{let{rpcId:W,method:q,args:K}=l.deserializeRequestJSONArgs(L);this._uriTransformer&&(K=(0,D.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest($,H,W,q,K,v===2);break}case 3:case 4:{let{rpcId:W,method:q,args:K}=l.deserializeRequestMixedArgs(L);this._uriTransformer&&(K=(0,D.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest($,H,W,q,K,v===4);break}case 5:{this._logger&&this._logger.logIncoming($,H,0,"ack"),this._onDidReceiveAcknowledge(H);break}case 6:{this._receiveCancel($,H);break}case 7:{this._receiveReply($,H,void 0);break}case 9:{let W=l.deserializeReplyOKJSON(L);this._uriTransformer&&(W=(0,D.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReply($,H,W);break}case 10:{const W=l.deserializeReplyOKJSONWithBuffers(L,this._uriTransformer);this._receiveReply($,H,W);break}case 8:{let W=l.deserializeReplyOKVSBuffer(L);this._receiveReply($,H,W);break}case 11:{let W=l.deserializeReplyErrError(L);this._uriTransformer&&(W=(0,D.transformIncomingURIs)(W,this._uriTransformer)),this._receiveReplyErr($,H,W);break}case 12:{this._receiveReplyErr($,H,void 0);break}default:console.error("received unexpected message"),console.error(P)}}_receiveRequest(P,$,L,v,H,W){this._logger&&this._logger.logIncoming(P,$,1,`receiveRequest ${(0,N.getStringIdentifierForProxy)(L)}.${v}(`,H);const q=String($);let K,V;if(W){const ae=new w.CancellationTokenSource;H.push(ae.token),K=this._invokeHandler(L,v,H),V=()=>ae.cancel()}else K=this._invokeHandler(L,v,H),V=a;this._cancelInvokedHandlers[q]=V;const z=l.serializeAcknowledged($);this._logger&&this._logger.logOutgoing(z.byteLength,$,1,"ack"),this._protocol.send(z),K.then(ae=>{delete this._cancelInvokedHandlers[q];const de=l.serializeReplyOK($,ae,this._uriReplacer);this._logger&&this._logger.logOutgoing(de.byteLength,$,1,"reply:",ae),this._protocol.send(de)},ae=>{delete this._cancelInvokedHandlers[q];const de=l.serializeReplyErr($,ae);this._logger&&this._logger.logOutgoing(de.byteLength,$,1,"replyErr:",ae),this._protocol.send(de)})}_receiveCancel(P,$){this._logger&&this._logger.logIncoming(P,$,1,"receiveCancel");const L=String($);this._cancelInvokedHandlers[L]&&this._cancelInvokedHandlers[L]()}_receiveReply(P,$,L){this._logger&&this._logger.logIncoming(P,$,0,"receiveReply:",L);const v=String($);if(!this._pendingRPCReplies.hasOwnProperty(v))return;const H=this._pendingRPCReplies[v];delete this._pendingRPCReplies[v],H.resolveOk(L)}_receiveReplyErr(P,$,L){this._logger&&this._logger.logIncoming(P,$,0,"receiveReplyErr:",L);const v=String($);if(!this._pendingRPCReplies.hasOwnProperty(v))return;const H=this._pendingRPCReplies[v];delete this._pendingRPCReplies[v];let W;L&&(L.$isError?(W=new Error,W.name=L.name,W.message=L.message,W.stack=L.stack):W=L),H.resolveErr(W)}_invokeHandler(P,$,L){try{return Promise.resolve(this._doInvokeHandler(P,$,L))}catch(v){return Promise.reject(v)}}_doInvokeHandler(P,$,L){const v=this._locals[P];if(!v)throw new Error("Unknown actor "+(0,N.getStringIdentifierForProxy)(P));let H=v[$];if(typeof H!="function")throw new Error("Unknown method "+$+" on actor "+(0,N.getStringIdentifierForProxy)(P));return H.apply(v,L)}_remoteCall(P,$,L){if(this._isDisposed)return Promise.reject(B.canceled());let v=null;if(L.length>0&&w.CancellationToken.isCancellationToken(L[L.length-1])&&(v=L.pop()),v&&v.isCancellationRequested)return Promise.reject(B.canceled());const H=l.serializeRequestArguments(L,this._uriReplacer),W=++this._lastMessageId,q=String(W),K=new F.LazyPromise;v&&v.onCancellationRequested(()=>{const z=l.serializeCancel(W);this._logger&&this._logger.logOutgoing(z.byteLength,W,0,"cancel"),this._protocol.send(l.serializeCancel(W))}),this._pendingRPCReplies[q]=K,this._onWillSendRequest(W);const V=l.serializeRequest(W,P,$,H,!!v);return this._logger&&this._logger.logOutgoing(V.byteLength,W,0,`request: ${(0,N.getStringIdentifierForProxy)(P)}.${$}(`,L),this._protocol.send(V),K}}e.RPCProtocol=i,b=T,i.UNRESPONSIVE_TIME=3*1e3;class u{constructor(P,$){this._buff=P,this._offset=$}static alloc(P,$,L){let v=new u(k.VSBuffer.alloc(L+1+4),0);return v.writeUInt8(P),v.writeUInt32($),v}static read(P,$){return new u(P,$)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(P){this._buff.writeUInt8(P,this._offset),this._offset+=1}readUInt8(){const P=this._buff.readUInt8(this._offset);return this._offset+=1,P}writeUInt32(P){this._buff.writeUInt32BE(P,this._offset),this._offset+=4}readUInt32(){const P=this._buff.readUInt32BE(this._offset);return this._offset+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this._buff.writeUInt8(P.byteLength,this._offset),this._offset+=1,this._buff.set(P,this._offset),this._offset+=P.byteLength}readShortString(){const P=this._buff.readUInt8(this._offset);this._offset+=1;const L=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,L}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readLongString(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const L=this._buff.slice(this._offset,this._offset+P).toString();return this._offset+=P,L}writeBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this._buff.writeUInt32BE(P.byteLength,this._offset),this._offset+=4,this._buff.set(P,this._offset),this._offset+=P.byteLength}readVSBuffer(){const P=this._buff.readUInt32BE(this._offset);this._offset+=4;const $=this._buff.slice(this._offset,this._offset+P);return this._offset+=P,$}static sizeMixedArray(P){let $=0;$+=1;for(let L=0,v=P.length;L<v;L++){const H=P[L];switch($+=1,H.type){case 1:$+=this.sizeLongString(H.value);break;case 2:$+=this.sizeVSBuffer(H.value);break;case 3:$+=this.sizeUInt32,$+=this.sizeLongString(H.value);for(let W=0;W<H.buffers.length;++W)$+=this.sizeVSBuffer(H.buffers[W]);break;case 4:break}}return $}writeMixedArray(P){this._buff.writeUInt8(P.length,this._offset),this._offset+=1;for(let $=0,L=P.length;$<L;$++){const v=P[$];switch(v.type){case 1:this.writeUInt8(1),this.writeLongString(v.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(v.value);break;case 3:this.writeUInt8(3),this.writeUInt32(v.buffers.length),this.writeLongString(v.value);for(let H=0;H<v.buffers.length;++H)this.writeBuffer(v.buffers[H]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this._buff.readUInt8(this._offset);this._offset+=1;let $=new Array(P);for(let L=0;L<P;L++)switch(this.readUInt8()){case 1:$[L]=this.readLongString();break;case 2:$[L]=this.readVSBuffer();break;case 3:{const H=this.readUInt32(),W=this.readLongString(),q=[];for(let K=0;K<H;++K)q.push(this.readVSBuffer());$[L]=new N.SerializableObjectWithBuffers(_(W,q,null));break}case 4:$[L]=void 0;break}return $}}u.sizeUInt32=4;var t;(function(S){S[S.Simple=0]="Simple",S[S.Mixed=1]="Mixed"})(t||(t={}));class l{static _useMixedArgSerialization(P){for(let $=0,L=P.length;$<L;$++)if(P[$]instanceof k.VSBuffer||P[$]instanceof N.SerializableObjectWithBuffers||typeof P[$]=="undefined")return!0;return!1}static serializeRequestArguments(P,$){if(this._useMixedArgSerialization(P)){const L=[];for(let v=0,H=P.length;v<H;v++){const W=P[v];if(W instanceof k.VSBuffer)L[v]={type:2,value:W};else if(typeof W=="undefined")L[v]={type:4};else if(W instanceof N.SerializableObjectWithBuffers){const{jsonString:q,referencedBuffers:K}=h(W.value,$);L[v]={type:3,value:k.VSBuffer.fromString(q),buffers:K}}else L[v]={type:1,value:k.VSBuffer.fromString(y(W,$))}}return{type:1,args:L}}return{type:0,args:y(P,$)}}static serializeRequest(P,$,L,v,H){switch(v.type){case 0:return this._requestJSONArgs(P,$,L,v.args,H);case 1:return this._requestMixedArgs(P,$,L,v.args,H)}}static _requestJSONArgs(P,$,L,v,H){const W=k.VSBuffer.fromString(L),q=k.VSBuffer.fromString(v);let K=0;K+=u.sizeUInt8(),K+=u.sizeShortString(W),K+=u.sizeLongString(q);let V=u.alloc(H?2:1,P,K);return V.writeUInt8($),V.writeShortString(W),V.writeLongString(q),V.buffer}static deserializeRequestJSONArgs(P){const $=P.readUInt8(),L=P.readShortString(),v=P.readLongString();return{rpcId:$,method:L,args:JSON.parse(v)}}static _requestMixedArgs(P,$,L,v,H){const W=k.VSBuffer.fromString(L);let q=0;q+=u.sizeUInt8(),q+=u.sizeShortString(W),q+=u.sizeMixedArray(v);let K=u.alloc(H?4:3,P,q);return K.writeUInt8($),K.writeShortString(W),K.writeMixedArray(v),K.buffer}static deserializeRequestMixedArgs(P){const $=P.readUInt8(),L=P.readShortString(),v=P.readMixedArray(),H=new Array(v.length);for(let W=0,q=v.length;W<q;W++){const K=v[W];typeof K=="string"?H[W]=JSON.parse(K):H[W]=K}return{rpcId:$,method:L,args:H}}static serializeAcknowledged(P){return u.alloc(5,P,0).buffer}static serializeCancel(P){return u.alloc(6,P,0).buffer}static serializeReplyOK(P,$,L){if(typeof $=="undefined")return this._serializeReplyOKEmpty(P);if($ instanceof k.VSBuffer)return this._serializeReplyOKVSBuffer(P,$);if($ instanceof N.SerializableObjectWithBuffers){const{jsonString:v,referencedBuffers:H}=h($.value,L,!0);return this._serializeReplyOKJSONWithBuffers(P,v,H)}else return this._serializeReplyOKJSON(P,c($,L))}static _serializeReplyOKEmpty(P){return u.alloc(7,P,0).buffer}static _serializeReplyOKVSBuffer(P,$){let L=0;L+=u.sizeVSBuffer($);let v=u.alloc(8,P,L);return v.writeVSBuffer($),v.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static _serializeReplyOKJSON(P,$){const L=k.VSBuffer.fromString($);let v=0;v+=u.sizeLongString(L);let H=u.alloc(9,P,v);return H.writeLongString(L),H.buffer}static _serializeReplyOKJSONWithBuffers(P,$,L){const v=k.VSBuffer.fromString($);let H=0;H+=u.sizeUInt32,H+=u.sizeLongString(v);for(const q of L)H+=u.sizeVSBuffer(q);let W=u.alloc(10,P,H);W.writeUInt32(L.length),W.writeLongString(v);for(const q of L)W.writeBuffer(q);return W.buffer}static deserializeReplyOKJSON(P){const $=P.readLongString();return JSON.parse($)}static deserializeReplyOKJSONWithBuffers(P,$){const L=P.readUInt32(),v=P.readLongString(),H=[];for(let W=0;W<L;++W)H.push(P.readVSBuffer());return new N.SerializableObjectWithBuffers(_(v,H,$))}static serializeReplyErr(P,$){const L=$?c(B.transformErrorForSerialization($),null):void 0;if(typeof L!="string")return this._serializeReplyErrEmpty(P);const v=k.VSBuffer.fromString(L);let H=0;H+=u.sizeLongString(v);let W=u.alloc(11,P,H);return W.writeLongString(v),W.buffer}static deserializeReplyErrError(P){const $=P.readLongString();return JSON.parse($)}static _serializeReplyErrEmpty(P){return u.alloc(12,P,0).buffer}}var m;(function(S){S[S.RequestJSONArgs=1]="RequestJSONArgs",S[S.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",S[S.RequestMixedArgs=3]="RequestMixedArgs",S[S.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",S[S.Acknowledged=5]="Acknowledged",S[S.Cancel=6]="Cancel",S[S.ReplyOKEmpty=7]="ReplyOKEmpty",S[S.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",S[S.ReplyOKJSON=9]="ReplyOKJSON",S[S.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",S[S.ReplyErrError=11]="ReplyErrError",S[S.ReplyErrEmpty=12]="ReplyErrEmpty"})(m||(m={}));var f;(function(S){S[S.String=1]="String",S[S.VSBuffer=2]="VSBuffer",S[S.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",S[S.Undefined=4]="Undefined"})(f||(f={}))}),define(we[211],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const o=function(B){const C=A=>{self.removeEventListener("message",C);const D=A.data;Object.defineProperties(self,{postMessage:{value(F,N){D.postMessage(F,N)}},onmessage:{get(){return D.onmessage},set(F){D.onmessage=F}}}),D.addEventListener("message",F=>{self.dispatchEvent(new MessageEvent("message",{data:F.data}))}),D.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(B)};self.addEventListener("message",C)}.toString();class k extends EventTarget{constructor(B,C,A){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const D=`((${o})('${C}'))`,F=new Blob([D],{type:"application/javascript"}),N=URL.createObjectURL(F),b=new MessageChannel,c=N,g={type:"_newWorker",id:c,port:b.port2,url:N,options:A};B(g,[b.port2]),this.postMessage=b.port1.postMessage.bind(b.port1),this.terminate=()=>{B({type:"_terminateWorker",id:c}),URL.revokeObjectURL(N),b.port1.close(),b.port2.close()},Object.defineProperties(this,{onmessage:{get(){return b.port1.onmessage},set(s){b.port1.onmessage=s}},onmessageerror:{get(){return b.port1.onmessageerror},set(s){b.port1.onmessageerror=s}}}),b.port1.addEventListener("messageerror",s=>{const n=new MessageEvent("messageerror",{data:s.data});this.dispatchEvent(n)}),b.port1.addEventListener("message",s=>{const n=new MessageEvent("message",{data:s.data});this.dispatchEvent(n)}),b.port1.start()}}e.NestedWorker=k}),define(we[212],be([1,0,3]),function(Z,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(we[213],be([1,0,35,10,17,23,24,2,3,148,46,172,212]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let g=class qi{constructor(n,h,_,y){this.localUserHome=n,this.remoteAgentService=h,this.environmentService=_,this.contextService=y,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||B.OS)(),this.resolveUserHome=(async()=>{const d=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=d?.userHome||n})()}hasValidBasename(n,h,_){return typeof h=="string"||typeof h=="undefined"?this.resolveOS.then(y=>this.doHasValidBasename(n,y,h)):this.doHasValidBasename(n,h,_)}doHasValidBasename(n,h,_){return n.scheme===k.Schemas.file||n.scheme===k.Schemas.vscodeRemote?(0,o.isValidBasename)(_??(0,C.basename)(n),h===1):!0}get defaultUriScheme(){return qi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(n,h){if(n.remoteAuthority)return k.Schemas.vscodeRemote;const _=(0,F.getVirtualWorkspaceScheme)(h.getWorkspace());if(_)return _;const y=h.getWorkspace().folders[0];if(y)return y.uri.scheme;const d=h.getWorkspace().configuration;return d?d.scheme:k.Schemas.file}async userHome(n){return n?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(n=>n===1?w.win32:w.posix)}async fileURI(n){let h="";if(await this.resolveOS===1&&(n=n.replace(/\\/g,"/")),n[0]==="/"&&n[1]==="/"){const y=n.indexOf("/",2);y===-1?(h=n.substring(2),n="/"):(h=n.substring(2,y),n=n.substring(y)||"/")}return A.URI.from({scheme:k.Schemas.file,authority:h,path:n,query:"",fragment:""})}};g=Fe([Ne(1,c.IRemoteAgentService),Ne(2,b.IWorkbenchEnvironmentService),Ne(3,N.IWorkspaceContextService)],g),e.AbstractPathService=g}),define(we[96],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(C,A){this.line=C,this.character=A}isBefore(C){return!1}isBeforeOrEqual(C){return!1}isAfter(C){return!1}isAfterOrEqual(C){return!1}isEqual(C){return!1}compareTo(C){return 0}translate(C,A){return new o(0,0)}with(C){return new o(0,0)}}e.Position=o;class k{constructor(C,A,D,F){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(C,A),this.end=new o(D,F)}contains(C){return!1}isEqual(C){return!1}intersection(C){}union(C){return new k(0,0,0,0)}with(C){return new k(0,0,0,0)}}e.Range=k;var w;(function(B){B[B.Information=1]="Information",B[B.Warning=2]="Warning"})(w=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(we[41],be([1,0,16,29,25,35,9,3,17,15,96,13]),function(Z,e,o,k,w,B,C,A,D,F,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return N.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const c="\u27EA ",g=" characters skipped \u27EB",s=(c.length+g.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var n;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(n=e.SearchProviderType||(e.SearchProviderType={}));var h;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(h=e.QueryType||(e.QueryType={}));function _(Y){return!!Y.preview}e.resultIsMatch=_;function y(Y){return!!Y.resource}e.isFileMatch=y;function d(Y){return!!Y.message}e.isProgressMessage=d;var p;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(p=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class E{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=E;class a{constructor(ie,ce,he){this.ranges=ce;const ue=Array.isArray(ce)?ce:[ce];if(he&&he.matchLines===1&&T(ue)){ie=(0,C.getNLines)(ie,he.matchLines);let se="",ge=0,Te=0;const Re=Math.floor(he.charsPerLine/5),He=[];for(const Xe of ue){const ve=Math.max(Xe.startColumn-Re,0),fe=Xe.startColumn+he.charsPerLine;if(ve>Te+Re+s){const M=c+(ve-Te)+g;se+=M+ie.slice(ve,fe),ge+=ve-(Te+M.length)}else se+=ie.slice(Te,fe);He.push(new i(0,Xe.startColumn-ge,Xe.endColumn-ge)),Te=fe}this.preview={text:se,matches:Array.isArray(this.ranges)?He:He[0]}}else{const se=Array.isArray(ce)?ce[0].startLineNumber:ce.startLineNumber;this.preview={text:ie,matches:(0,o.mapArrayOrNot)(ce,ge=>new r(ge.startLineNumber-se,ge.startColumn,ge.endLineNumber-se,ge.endColumn))}}}}e.TextSearchMatch=a;function T(Y){const ie=Y[0].startLineNumber;for(const ce of Y)if(ce.startLineNumber!==ie||ce.endLineNumber!==ie)return!1;return!0}class r{constructor(ie,ce,he,ue){this.startLineNumber=ie,this.startColumn=ce,this.endLineNumber=he,this.endColumn=ue}}e.SearchRange=r;class i extends r{constructor(ie,ce,he){super(ie,ce,ie,he)}}e.OneLineRange=i;var u;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(u=e.SearchSortOrder||(e.SearchSortOrder={}));function t(Y,ie=!0){const ce=Y&&Y.files&&Y.files.exclude,he=ie&&Y&&Y.search&&Y.search.exclude;if(!ce&&!he)return;if(!ce||!he)return ce||he;let ue=Object.create(null);return ue=w.mixin(ue,w.deepClone(ce)),ue=w.mixin(ue,w.deepClone(he),!0),ue}e.getExcludes=t;function l(Y,ie){return Y.excludePattern&&k.match(Y.excludePattern,ie)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&k.match(Y.includePattern,ie)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(ce=>{const he=ce.folder.fsPath;if(B.isEqualOrParent(ie,he)){const ue=D.relative(he,ie);return!ce.includePattern||!!k.match(ce.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=l;var m;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(m=e.SearchErrorCode||(e.SearchErrorCode={}));class f extends Error{constructor(ie,ce){super(ie);this.code=ce}}e.SearchError=f;function S(Y){const ie=Y.message;if((0,F.isCancellationError)(Y))return new f(ie,m.canceled);try{const ce=JSON.parse(ie);return new f(ce.message,ce.code)}catch{return new f(ie,m.other)}}e.deserializeSearchError=S;function P(Y){const ie={message:Y.message,code:Y.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=P;function $(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=$;function L(Y){return Y.type==="success"}e.isSerializedSearchSuccess=L;function v(Y){return!!Y.path}e.isSerializedFileMatch=v;function H(Y,ie){const ce=Y.searchPath?Y.searchPath:Y.relativePath;return(0,C.fuzzyContains)(ce,ie)}e.isFilePatternMatch=H;class W{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=W;function q(Y,ie){const ce={...Y||{},...ie||{}};return Object.keys(ce).filter(he=>{const ue=ce[he];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=q;class K{constructor(ie,ce){this._parsedIncludeExpression=null,this._excludeExpression={...ie.excludePattern||{},...ce.excludePattern||{}},this._parsedExcludeExpression=k.parse(this._excludeExpression);let he=ie.includePattern;ce.includePattern&&(he?he={...he,...ce.includePattern}:he=ce.includePattern),he&&(this._parsedIncludeExpression=k.parse(he))}matchesExcludesSync(ie,ce,he){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,ce,he))}includedInQuerySync(ie,ce,he){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(ie,ce,he)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(ie,ce,he))}includedInQuery(ie,ce,he){const ue=this._parsedExcludeExpression(ie,ce,he),se=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(ie,ce,he):!0;return(0,b.isThenable)(ue)?ue.then(ge=>ge?!1:se()):se()}hasSiblingExcludeClauses(){return V(this._excludeExpression)}}e.QueryGlobTester=K;function V(Y){for(const ie in Y)if(typeof Y[ie]!="boolean")return!0;return!1}function z(Y){if(!Y)return;let ie;return ce=>(ie||(ie=(Y()||Promise.resolve([])).then(he=>he?de(he):{})),ie.then(he=>!!he[ce]))}e.hasSiblingPromiseFn=z;function ae(Y){if(!Y)return;let ie;return ce=>{if(!ie){const he=Y();ie=he?de(he):{}}return!!ie[ce]}}e.hasSiblingFn=ae;function de(Y){const ie={};for(const ce of Y)ie[ce]=!0;return ie}}),define(we[31],be([1,0,16,13,20,5,22,10,102,24,9,11,2,128,3,12,140,46,30,27,14,8,6,41,4]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_,y,d,p,E,a,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i($,L,v){return new F.ExtUri(H=>m(H,v)).isEqual($,L)}function u($,L,v){return i($.uri,L.uri,v)?0:(0,N.compare)($.uri.toString(),L.uri.toString())}function t($,L,v){return $.index!==L.index?$.index<L.index?-1:1:i($.uri,L.uri,v)?(0,N.compare)($.name,L.name):(0,N.compare)($.uri.toString(),L.uri.toString())}function l($,L,v,H){const W=$.slice(0).sort((K,V)=>v(K,V,H)),q=L.slice(0).sort((K,V)=>v(K,V,H));return(0,o.delta)(W,q,(K,V)=>v(K,V,H))}function m($,L){const v=L.getCapabilities($.scheme);return!(v&&v&1024)}class f extends _.Workspace{constructor(L,v,H,W,q,K,V){super(L,H.map(z=>new _.WorkspaceFolder(z)),W,q,V);this._name=v,this._isUntitled=K,this._workspaceFolders=[],this._structure=C.TernarySearchTree.forUris(V),H.forEach(z=>{this._workspaceFolders.push(z),this._structure.set(z.uri,z)})}static toExtHostWorkspace(L,v,H,W){if(!L)return{workspace:null,added:[],removed:[]};const{id:q,name:K,folders:V,configuration:z,transient:ae,isUntitled:de}=L,Y=[],ie=v;v?V.forEach((se,ge)=>{const Te=c.URI.revive(se.uri),Re=f._findFolder(H||v,Te,W);Re?(Re.name=se.name,Re.index=se.index,Y.push(Re)):Y.push({uri:Te,name:se.name,index:ge})}):Y.push(...V.map(({uri:se,name:ge,index:Te})=>({uri:c.URI.revive(se),name:ge,index:Te}))),Y.sort((se,ge)=>se.index<ge.index?-1:1);const ce=new f(q,K,Y,!!ae,z?c.URI.revive(z):null,!!de,se=>m(se,W)),{added:he,removed:ue}=l(ie?ie.workspaceFolders:[],ce.workspaceFolders,u,W);return{workspace:ce,added:he,removed:ue}}static _findFolder(L,v,H){for(let W=0;W<L.folders.length;W++){const q=L.workspaceFolders[W];if(i(q.uri,v,H))return q}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(L,v){return v&&this._structure.get(L)&&(L=(0,F.dirname)(L)),this._structure.findSubstr(L)}resolveWorkspaceFolder(L){return this._structure.get(L)}}let S=class{constructor(L,v,H,W){this._onDidChangeWorkspace=new B.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new B.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=W,this._extHostFileSystemInfo=H,this._requestIdProvider=new D.Counter,this._barrier=new k.Barrier,this._proxy=L.getProxy(r.MainContext.MainThreadWorkspace),this._messageService=L.getProxy(r.MainContext.MainThreadMessageService);const q=v.workspace;this._confirmedWorkspace=q?new f(q.id,q.name,[],!!q.transient,q.configuration?c.URI.revive(q.configuration):null,!!q.isUntitled,K=>m(K,H)):void 0}$initializeWorkspace(L,v){this._trusted=v,this.$acceptWorkspaceData(L),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?c.URI.from({scheme:A.Schemas.untitled,path:(0,F.basename)((0,F.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(L,v,H,...W){const q=[];if(Array.isArray(W)&&W.forEach(de=>{c.URI.isUri(de.uri)&&!q.some(Y=>i(Y.uri,de.uri,this._extHostFileSystemInfo))&&q.push({uri:de.uri,name:de.name||(0,F.basenameOrAuthority)(de.uri)})}),this._unconfirmedWorkspace||[v,H].some(de=>typeof de!="number"||de<0)||H===0&&q.length===0)return!1;const K=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(v+H>K.length)return!1;const V=K.slice(0);V.splice(v,H,...q.map(de=>({uri:de.uri,name:de.name||(0,F.basenameOrAuthority)(de.uri),index:void 0})));for(let de=0;de<V.length;de++){const Y=V[de];if(V.some((ie,ce)=>ce!==de&&i(Y.uri,ie.uri,this._extHostFileSystemInfo)))return!1}V.forEach((de,Y)=>de.index=Y);const{added:z,removed:ae}=l(K,V,t,this._extHostFileSystemInfo);if(z.length===0&&ae.length===0)return!1;if(this._proxy){const de=L.displayName||L.name;this._proxy.$updateWorkspaceFolders(de,v,H,q).then(void 0,Y=>{this._unconfirmedWorkspace=void 0;const ie={source:{identifier:L.identifier,label:L.displayName||L.name}};this._messageService.$showMessage(h.Severity.Error,(0,g.localize)(0,null,de,Y.toString()),ie,[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(L,v){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,v)}async getWorkspaceFolder2(L,v){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(L,v)}async resolveWorkspaceFolder(L){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(L)}getPath(){if(!this._actualWorkspace)return;const{folders:L}=this._actualWorkspace;if(L.length!==0)return L[0].uri.fsPath}getRelativePath(L,v){let H,W="";if(typeof L=="string"?(H=c.URI.file(L),W=L):typeof L!="undefined"&&(H=L,W=L.fsPath),!H)return W;const q=this.getWorkspaceFolder(H,!0);if(!q)return W;typeof v=="undefined"&&this._actualWorkspace&&(v=this._actualWorkspace.folders.length>1);let K=(0,F.relativePath)(q.uri,H);return v&&q.name&&(K=`${q.name}/${K}`),K}trySetWorkspaceFolders(L){this._actualWorkspace&&(this._unconfirmedWorkspace=f.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:L,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(L){const{workspace:v,added:H,removed:W}=f.toExtHostWorkspace(L,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=v||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:H,removed:W}))}findFiles(L,v,H,W,q=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${W.value}, entryPoint: findFiles`);let K;if(v===null?K=!1:v&&(typeof v=="string"?K=v:K=v.pattern),q&&q.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:z}=P(E.GlobPattern.from(L));return this._proxy.$startFileSearch((0,b.withUndefinedAsNull)(V),(0,b.withUndefinedAsNull)(z),(0,b.withUndefinedAsNull)(K),(0,b.withUndefinedAsNull)(H),q).then(ae=>Array.isArray(ae)?ae.map(de=>c.URI.revive(de)):[])}async findTextInFiles(L,v,H,W,q=w.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${W.value}, entryPoint: findTextInFiles`);const K=this._requestIdProvider.getNext(),V=typeof v.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:v.previewOptions,{includePattern:z,folder:ae}=P(E.GlobPattern.from(v.include)),de=typeof v.exclude=="string"?v.exclude:v.exclude?v.exclude.pattern:void 0,Y={ignoreSymlinks:typeof v.followSymlinks=="boolean"?!v.followSymlinks:void 0,disregardIgnoreFiles:typeof v.useIgnoreFiles=="boolean"?!v.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof v.useGlobalIgnoreFiles=="boolean"?!v.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof v.useParentIgnoreFiles=="boolean"?!v.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof v.useDefaultExcludes=="boolean"?!v.useDefaultExcludes:!0,fileEncoding:v.encoding,maxResults:v.maxResults,previewOptions:V,afterContext:v.afterContext,beforeContext:v.beforeContext,includePattern:z,excludePattern:de},ie=!1;if(this._activeSearchCallbacks[K]=ce=>{if(ie)return;const he=c.URI.revive(ce.resource);ce.results.forEach(ue=>{(0,T.resultIsMatch)(ue)?H({uri:he,preview:{text:ue.preview.text,matches:(0,o.mapArrayOrNot)(ue.preview.matches,se=>new a.Range(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))},ranges:(0,o.mapArrayOrNot)(ue.ranges,se=>new a.Range(se.startLineNumber,se.startColumn,se.endLineNumber,se.endColumn))}):H({uri:he,text:ue.text,lineNumber:ue.lineNumber})})},q.isCancellationRequested)return{};try{const ce=await this._proxy.$startTextSearch(L,(0,b.withUndefinedAsNull)(ae),Y,K,q);return delete this._activeSearchCallbacks[K],ce||{}}catch(ce){throw delete this._activeSearchCallbacks[K],ce}}$handleTextSearchResult(L,v){this._activeSearchCallbacks[v]&&this._activeSearchCallbacks[v](L)}saveAll(L){return this._proxy.$saveAll(L)}resolveProxy(L){return this._proxy.$resolveProxy(L)}get trusted(){return this._trusted}requestWorkspaceTrust(L){return this._proxy.$requestWorkspaceTrust(L)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};S=Fe([Ne(0,p.IExtHostRpcService),Ne(1,d.IExtHostInitDataService),Ne(2,y.IExtHostFileSystemInfo),Ne(3,n.ILogService)],S),e.ExtHostWorkspace=S,e.IExtHostWorkspace=(0,s.createDecorator)("IExtHostWorkspace");function P($){let L,v;return $&&(typeof $=="string"?L=$:(L=$.pattern,v=c.URI.revive($.baseUri))),{includePattern:L,folder:v}}}),define(we[32],be([1,0,25,5,31,4,6,143,80,11,13,3,14,12,2]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function n(T,r){if(r){const i=r.split(".");let u=T;for(let t=0;u&&t<i.length;t++)u=u[i[t]];return u}}function h(T){return T instanceof s.URI}function _(T){return T&&T.uri instanceof s.URI&&T.languageId&&typeof T.languageId=="string"}function y(T){return T&&!T.uri&&T.languageId&&typeof T.languageId=="string"}function d(T){return T&&T.uri instanceof s.URI&&(!T.name||typeof T.name=="string")&&(!T.index||typeof T.index=="number")}function p(T){if(h(T))return{resource:T};if(_(T))return{resource:T.uri,overrideIdentifier:T.languageId};if(y(T))return{overrideIdentifier:T.languageId};if(d(T))return{resource:T.uri};if(T===null)return{resource:null}}let E=class{constructor(r,i,u){this._proxy=r.getProxy(B.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=u,this._barrier=new N.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(r=>this._actual)}$initializeConfiguration(r){this._actual=new a(this._proxy,this._extHostWorkspace,r,this._logService),this._barrier.open()}$acceptConfigurationChanged(r,i){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(r,i))}};E=Fe([Ne(0,c.IExtHostRpcService),Ne(1,w.IExtHostWorkspace),Ne(2,g.ILogService)],E),e.ExtHostConfiguration=E;class a{constructor(r,i,u,t){this._onDidChangeConfiguration=new k.Emitter,this._proxy=r,this._logService=t,this._extHostWorkspace=i,this._configuration=A.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(r,i){const u={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=A.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,u))}getConfiguration(r,i,u){const t=p(i)||{},l=this._toReadonlyValue(r?n(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),r):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));r&&this._validateConfigurationAccess(r,t,u?.identifier);function m(S){if(S==null)return null;if(typeof S=="boolean")return S?1:4;switch(S){case C.ConfigurationTarget.Global:return 1;case C.ConfigurationTarget.Workspace:return 4;case C.ConfigurationTarget.WorkspaceFolder:return 5}}const f={has(S){return typeof n(l,S)!="undefined"},get:(S,P)=>{this._validateConfigurationAccess(r?`${r}.${S}`:S,t,u?.identifier);let $=n(l,S);if(typeof $=="undefined")$=P;else{let L;const v=(H,W)=>{let q;const K=()=>{L=L||(0,o.deepClone)(l),q=q||n(L,W)};return(0,F.isObject)(H)?new Proxy(H,{get:(V,z)=>{if(typeof z=="string"&&z.toLowerCase()==="tojson")return K(),()=>q;if(L)return q=q||n(L,W),q[z];const ae=V[z];return typeof z=="string"?v(ae,`${W}.${z}`):ae},set:(V,z,ae)=>(K(),q&&(q[z]=ae),!0),deleteProperty:(V,z)=>(K(),q&&delete q[z],!0),defineProperty:(V,z,ae)=>(K(),q&&Object.defineProperty(q,z,ae),!0)}):H};$=v($,S)}return $},update:(S,P,$,L)=>{S=r?`${r}.${S}`:S;const v=m($);return P!==void 0?this._proxy.$updateConfigurationOption(v,S,P,t,L):this._proxy.$removeConfigurationOption(v,S,t,L)},inspect:S=>{S=r?`${r}.${S}`:S;const P=(0,o.deepClone)(this._configuration.inspect(S,t,this._extHostWorkspace.workspace));if(P)return{key:S,defaultValue:P.default?.value,globalValue:P.user?.value,workspaceValue:P.workspace?.value,workspaceFolderValue:P.workspaceFolder?.value,defaultLanguageValue:P.default?.override,globalLanguageValue:P.user?.override,workspaceLanguageValue:P.workspace?.override,workspaceFolderLanguageValue:P.workspaceFolder?.override,languageIds:P.overrideIdentifiers}}};return typeof l=="object"&&(0,o.mixin)(f,l,!1),Object.freeze(f)}_toReadonlyValue(r){const i=u=>(0,F.isObject)(u)?new Proxy(u,{get:(t,l)=>i(t[l]),set:(t,l,m)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(l)}' of object`)},deleteProperty:(t,l)=>{throw new Error(`TypeError: Cannot delete read only property '${String(l)}' of object`)},defineProperty:(t,l)=>{throw new Error(`TypeError: Cannot define property '${String(l)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return i(r)}_validateConfigurationAccess(r,i,u){const t=D.OVERRIDE_PROPERTY_REGEX.test(r)?4:this._configurationScopes.get(r),l=u?`[${u.value}] `:"";if(t===4){typeof i?.resource=="undefined"&&this._logService.warn(`${l}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){i?.resource&&this._logService.warn(`${l}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(r,i){const u=new A.ConfigurationChangeEvent(r,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,l)=>u.affectsConfiguration(t,p(l))})}_toMap(r){return r.reduce((i,u)=>(i.set(u[0],u[1]),i),new Map)}}e.ExtHostConfigProvider=a,e.IExtHostConfiguration=(0,b.createDecorator)("IExtHostConfiguration")});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,o,k,w){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!w:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?w.call(Z,o):w?w.value=o:e.set(Z,o),o},De=this&&this.__classPrivateFieldGet||function(Z,e,o,k){if(o==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?k:o==="a"?k.call(Z):k?k.value:e.get(Z)};define(we[97],be([1,0,2,13,5,4,6,31,49,32,20,40,14,27,3,10,23,12,65,164,15]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_,y,d,p){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var a;(function(W){function q(V){if(V!=null)return V}W.from=q;function K(V){if(V!=null)return V}W.to=K})(a=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var T;(function(W){function q(V){if(V!=null)return V}W.from=q;function K(V){if(V!=null)return V}W.to=K})(T=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var r;(function(W){function q(V){if(V!=null)return V}W.from=q;function K(V){if(V!=null)return V}W.to=K})(r=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function(W){function q(z){if(z){const ae=z;return ae&&!!ae.process}else return!1}W.is=q;function K(z){if(z==null)return;const ae={process:z.process,args:z.args};return z.options&&(ae.options=r.from(z.options)),ae}W.from=K;function V(z){if(z!=null)return new C.ProcessExecution(z.process,z.args,z.options)}W.to=V})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var u;(function(W){function q(V){if(V!=null)return V}W.from=q;function K(V){if(V!=null)return V}W.to=K})(u=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function(W){function q(z){if(z){const ae=z;return ae&&(!!ae.commandLine||!!ae.command)}else return!1}W.is=q;function K(z){if(z==null)return;const ae={};return z.commandLine!==void 0?ae.commandLine=z.commandLine:(ae.command=z.command,ae.args=z.args),z.options&&(ae.options=u.from(z.options)),ae}W.from=K;function V(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new C.ShellExecution(z.commandLine,z.options):new C.ShellExecution(z.command,z.args?z.args:[],z.options)}W.to=V})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var l;(function(W){function q(z){if(z){let ae=z;return ae&&ae.customExecution==="customExecution"}else return!1}W.is=q;function K(z){return{customExecution:"customExecution"}}W.from=K;function V(z,ae){return ae.get(z)}W.to=V})(l=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var m;(function(W){function q(K,V){let z;return K.scope!==void 0&&typeof K.scope!="number"?z=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===C.TaskScope.Workspace&&V&&V.workspaceFile?z=V.workspaceFile:z=d.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:z}}W.from=q})(m=e.TaskHandleDTO||(e.TaskHandleDTO={}));var f;(function(W){function q(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}W.from=q})(f=e.TaskGroupDTO||(e.TaskGroupDTO={}));var S;(function(W){function q(z,ae){if(z==null)return[];const de=[];for(let Y of z){const ie=K(Y,ae);ie&&de.push(ie)}return de}W.fromMany=q;function K(z,ae){if(z==null)return;let de;z.execution instanceof C.ProcessExecution?de=i.from(z.execution):z.execution instanceof C.ShellExecution?de=t.from(z.execution):z.execution&&z.execution instanceof C.CustomExecution&&(de=l.from(z.execution));const Y=a.from(z.definition);let ie;return z.scope?typeof z.scope=="number"?ie=z.scope:ie=z.scope.uri:ie=C.TaskScope.Workspace,!Y||!ie?void 0:{_id:z._id,definition:Y,name:z.name,source:{extensionId:ae.identifier.value,label:z.source,scope:ie},execution:de,isBackground:z.isBackground,group:f.from(z.group),presentationOptions:T.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}W.from=K;async function V(z,ae,de){if(z==null)return;let Y;i.is(z.execution)?Y=i.to(z.execution):t.is(z.execution)?Y=t.to(z.execution):l.is(z.execution)&&(Y=l.to(z._id,de));const ie=a.to(z.definition);let ce;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?ce=z.source.scope:ce=await ae.resolveWorkspaceFolder(o.URI.revive(z.source.scope)):ce=C.TaskScope.Workspace),!ie||!ce)return;const he=new C.Task(ie,ce,z.name,z.source.label,Y,z.problemMatchers);return z.isBackground!==void 0&&(he.isBackground=z.isBackground),z.group!==void 0&&(he.group=C.TaskGroup.from(z.group._id),he.group&&z.group.isDefault&&(he.group=new C.TaskGroup(he.group.id,he.group.label),z.group.isDefault&&(he.group.isDefault=z.group.isDefault))),z.presentationOptions&&(he.presentationOptions=T.to(z.presentationOptions)),z._id&&(he._id=z._id),z.detail&&(he.detail=z.detail),he}W.to=V})(S=e.TaskDTO||(e.TaskDTO={}));var P;(function(W){function q(V){return V}W.from=q;function K(V){if(!!V)return Object.assign(Object.create(null),V)}W.to=K})(P=e.TaskFilterDTO||(e.TaskFilterDTO={}));class ${constructor(q,K,V){this._id=K,this._task=V,E.set(this,void 0),Ve(this,E,q,"f")}get task(){return this._task}terminate(){De(this,E,"f").terminateTask(this)}fireDidStartProcess(q){}fireDidEndProcess(q){}}E=new WeakMap;var L;(function(W){function q(K){return{id:K._id,task:void 0}}W.from=q})(L=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let v=class{constructor(q,K,V,z,ae,de,Y,ie){this._onDidExecuteTask=new w.Emitter,this._onDidTerminateTask=new w.Emitter,this._onDidTaskProcessStarted=new w.Emitter,this._onDidTaskProcessEnded=new w.Emitter,this._proxy=q.getProxy(B.MainContext.MainThreadTask),this._workspaceProvider=V,this._editorService=z,this._configurationService=ae,this._terminalService=de,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=Y,this._deprecationService=ie,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(q,K,V){if(!V)return new C.Disposable(()=>{});const z=this.nextHandle();return this._handlers.set(z,{type:K,provider:V,extension:q}),this._proxy.$registerTaskProvider(z,K),new C.Disposable(()=>{this._handlers.delete(z),this._proxy.$unregisterTaskProvider(z)})}registerTaskSystem(q,K){this._proxy.$registerTaskSystem(q,K)}fetchTasks(q){return this._proxy.$fetchTasks(P.from(q)).then(async K=>{const V=[];for(let z of K){const ae=await S.to(z,this._workspaceProvider,this._providedCustomExecutions2);ae&&V.push(ae)}return V})}get taskExecutions(){const q=[];return this._taskExecutions.forEach(K=>q.push(K)),q}terminateTask(q){if(!(q instanceof $))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(q._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(q,K,V){const z=this._providedCustomExecutions2.get(q.id);z&&(this._activeCustomExecutions2.set(q.id,z),this._terminalService.attachPtyToTerminal(K,await z.callback(V))),this._lastStartedTask=q.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(q)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(q){const K=await this.getTaskExecution(q);this._taskExecutionPromises.delete(q.id),this._taskExecutions.delete(q.id),this.customExecutionComplete(q),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(q){const K=await this.getTaskExecution(q.id);this._onDidTaskProcessStarted.fire({execution:K,processId:q.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(q){const K=await this.getTaskExecution(q.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:q.exitCode})}$provideTasks(q,K){const V=this._handlers.get(q);if(!V)return Promise.reject(new Error("no handler found"));const z=[],ae=(0,k.asPromise)(()=>V.provider.provideTasks(N.CancellationToken.None)).then(de=>this.provideTasksInternal(K,z,V,de));return new Promise(de=>{ae.then(Y=>{Promise.all(z).then(()=>{de(Y)})})})}async $resolveTask(q,K){const V=this._handlers.get(q);if(!V)return Promise.reject(new Error("no handler found"));if(K.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${V.type}].`);const z=await S.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const ae=await V.provider.resolveTask(z,N.CancellationToken.None);if(!ae)return;this.checkDeprecation(ae,V);const de=S.from(ae,V.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(ae.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(de.execution)&&await this.addCustomExecution(de,ae,!0),await this.resolveTaskInternal(de)}nextHandle(){return this._handleCounter++}async addCustomExecution(q,K,V){const z=await this._proxy.$createTaskId(q);!V&&!this._providedCustomExecutions2.has(z)&&(this._notProvidedCustomExecutions.add(z),this._activeCustomExecutions2.set(z,K.execution)),this._providedCustomExecutions2.set(z,K.execution)}async getTaskExecution(q,K){if(typeof q=="string"){const ae=this._taskExecutionPromises.get(q);if(!ae)throw new Error("Unexpected: The specified task is missing an execution");return ae}let V=this._taskExecutionPromises.get(q.id);if(V)return V;const z=new Promise((ae,de)=>{function Y(ie,ce,he){he?ae(new $(ie,ce.id,he)):de("Unexpected: Task does not exist.")}K?Y(this,q,K):S.to(q.task,this._workspaceProvider,this._providedCustomExecutions2).then(ie=>Y(this,q,ie))});return this._taskExecutionPromises.set(q.id,z),z.then(ae=>(this._taskExecutions.set(q.id,ae),ae),ae=>Promise.reject(ae))}checkDeprecation(q,K){q._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(q){this._activeCustomExecutions2.get(q.id)&&this._activeCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.has(q.id)&&this._lastStartedTask!==q.id&&(this._providedCustomExecutions2.delete(q.id),this._notProvidedCustomExecutions.delete(q.id));let V=this._notProvidedCustomExecutions.values(),z=V.next();for(;!z.done;)!this._activeCustomExecutions2.has(z.value)&&this._lastStartedTask!==z.value&&(this._providedCustomExecutions2.delete(z.value),this._notProvidedCustomExecutions.delete(z.value)),z=V.next()}};v=Fe([Ne(0,c.IExtHostRpcService),Ne(1,g.IExtHostInitDataService),Ne(2,A.IExtHostWorkspace),Ne(3,D.IExtHostDocumentsAndEditors),Ne(4,F.IExtHostConfiguration),Ne(5,b.IExtHostTerminalService),Ne(6,_.ILogService),Ne(7,y.IExtHostApiDeprecationService)],v),e.ExtHostTaskBase=v;let H=class extends v{constructor(q,K,V,z,ae,de,Y,ie){super(q,K,V,z,ae,de,Y,ie);this.registerTaskSystem(n.Schemas.vscodeRemote,{scheme:n.Schemas.vscodeRemote,authority:"",platform:h.PlatformToString(0)})}async executeTask(q,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const V=S.from(K,q);if(V===void 0)throw new Error("Task is not valid");if(l.is(V.execution))await this.addCustomExecution(V,K,!1);else throw new p.NotSupportedError;const z=await this.getTaskExecution(await this._proxy.$getTaskExecution(V),K);return this._proxy.$executeTask(V).catch(ae=>{throw new Error(ae)}),z}provideTasksInternal(q,K,V,z){const ae=[];if(z)for(let de of z){this.checkDeprecation(de,V),(!de.definition||!q[de.definition.type])&&this._logService.warn(`The task [${de.source}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`);const Y=S.from(de,V.extension);Y&&l.is(Y.execution)?(ae.push(Y),K.push(this.addCustomExecution(Y,de,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ae,extension:V.extension}}async resolveTaskInternal(q){if(l.is(q.execution))return q;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(q,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(q,K,V){}};H=Fe([Ne(0,c.IExtHostRpcService),Ne(1,g.IExtHostInitDataService),Ne(2,A.IExtHostWorkspace),Ne(3,D.IExtHostDocumentsAndEditors),Ne(4,F.IExtHostConfiguration),Ne(5,b.IExtHostTerminalService),Ne(6,_.ILogService),Ne(7,y.IExtHostApiDeprecationService)],H),e.WorkerExtHostTask=H,e.IExtHostTask=(0,s.createDecorator)("IExtHostTask")}),define(we[214],be([1,0,17,20,43,29,24,191,41]),function(Z,e,o,k,w,B,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class F{constructor(c,g,s){this.config=c,this.provider=g,this.sessionToken=s,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=c.filePattern,this.includePattern=c.includePattern&&B.parse(c.includePattern),this.maxResults=c.maxResults||void 0,this.exists=c.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=c.excludePattern&&B.parse(c.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(c=>c.cancel()),this.activeCancellationTokens=new Set}search(c){const g=this.config.folderQueries||[];return new Promise((s,n)=>{const h=_=>{this.resultCount++,c(_)};if(this.isCanceled)return s({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(_=>{const y=_.toString(),d=o.basename(y);this.globalExcludePattern&&this.globalExcludePattern(y,d)||this.matchFile(h,{base:_,basename:d})}),Promise.all(g.map(_=>this.searchInFolder(_,h))).then(_=>{s({limitHit:this.isLimitHit,stats:_[0]||void 0})},_=>{n(new Error((0,w.toErrorMessage)(_)))})})}async searchInFolder(c,g){const s=new k.CancellationTokenSource,n=this.getSearchOptionsForFolder(c),h=this.initDirectoryTree(),_=new D.QueryGlobTester(this.config,c),y=!_.hasSiblingExcludeClauses();let d;try{this.activeCancellationTokens.add(s),d=A.StopWatch.create();const p=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},n,s.token),E=d.elapsed(),a=A.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(p&&p.forEach(T=>{const r=o.posix.relative(c.folder.path,T.path);if(y){const i=o.basename(T.path);this.matchFile(g,{base:c.folder,relativePath:r,basename:i});return}this.addDirectoryEntries(h,c.folder,r,g)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(h,_,g),{providerTime:E,postProcessTime:a.elapsed()})}finally{s.dispose(),this.activeCancellationTokens.delete(s)}}getSearchOptionsForFolder(c){const g=(0,D.resolvePatternsForProvider)(this.config.includePattern,c.includePattern),s=(0,D.resolvePatternsForProvider)(this.config.excludePattern,c.excludePattern);return{folder:c.folder,excludes:s,includes:g,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!c.disregardParentIgnoreFiles,followSymlinks:!c.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const c={rootEntries:[],pathToEntries:Object.create(null)};return c.pathToEntries["."]=c.rootEntries,c}addDirectoryEntries({pathToEntries:c},g,s,n){if(s===this.filePattern){const _=o.basename(this.filePattern);this.matchFile(n,{base:g,relativePath:this.filePattern,basename:_})}function h(_){const y=o.basename(_),d=o.dirname(_);let p=c[d];p||(p=c[d]=[],h(d)),p.push({base:g,relativePath:_,basename:y})}h(s)}matchDirectoryTree({rootEntries:c,pathToEntries:g},s,n){const h=this,_=this.filePattern;function y(d){const p=(0,D.hasSiblingFn)(()=>d.map(E=>E.basename));for(let E=0,a=d.length;E<a;E++){const T=d[E],{relativePath:r,basename:i}=T;if(s.matchesExcludesSync(r,i,_!==i?p:void 0))continue;const u=g[r];if(u)y(u);else{if(r===_)continue;h.matchFile(n,T)}if(h.isLimitHit)break}}y(c)}matchFile(c,g){(!this.includePattern||g.relativePath&&this.includePattern(g.relativePath,g.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||c(g))}}class N{constructor(){this.sessions=new Map}fileSearch(c,g,s,n){const h=this.getSessionTokenSource(c.cacheKey),_=new F(c,g,h&&h.token);let y=0;const d=p=>{y+=p.length,s(p.map(E=>this.rawMatchToSearchItem(E)))};return this.doSearch(_,N.BATCH_SIZE,d,n).then(p=>({limitHit:p.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:y,detailStats:p.stats}}))}clearCache(c){const g=this.getSessionTokenSource(c);g&&g.cancel()}getSessionTokenSource(c){if(!!c)return this.sessions.has(c)||this.sessions.set(c,new k.CancellationTokenSource),this.sessions.get(c)}rawMatchToSearchItem(c){return c.relativePath?{resource:C.joinPath(c.base,c.relativePath)}:{resource:c.base}}doSearch(c,g,s,n){n.onCancellationRequested(()=>{c.cancel()});const h=y=>{y&&(_.push(y),g>0&&_.length>=g&&(s(_),_=[]))};let _=[];return c.search(h).then(y=>(_.length&&s(_),y),y=>(_.length&&s(_),Promise.reject(y)))}}e.FileSearchManager=N,N.BATCH_SIZE=512}),define(we[215],be([1,0,16,70,29,73,22,10,17,24,9,11,2,234,134,77,12,46,87,213,41]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_,y,d,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let E=class{constructor(f,S,P,$,L){this.configurationService=f,this.workspaceContextService=S,this.editorGroupsService=P,this.logService=$,this.pathService=L}text(f,S,P={}){f=this.getContentPattern(f,P);const $=this.configurationService.getValue(),L=S&&S.some(H=>!this.configurationService.getValue({resource:H}).search.useRipgrep);return{...this.commonQuery(S?.map(_.toWorkspaceFolder),P),type:2,contentPattern:f,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:$.search.usePCRE2||L||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}getContentPattern(f,S){const P=this.configurationService.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const $={...f,wordSeparators:P.editor.wordSeparators};return this.isCaseSensitive(f,S)&&($.isCaseSensitive=!0),this.isMultiline(f)&&($.isMultiline=!0),$}file(f,S={}){return{...this.commonQuery(f,S),type:1,filePattern:S.filePattern?S.filePattern.trim():S.filePattern,exists:S.exists,sortByScore:S.sortByScore,cacheKey:S.cacheKey}}handleIncludeExclude(f,S){return f?(f=Array.isArray(f)?f.map(u):u(f),S?this.parseSearchPaths(f):{pattern:T(...Array.isArray(f)?f:[f])}):{}}commonQuery(f=[],S={}){const P=this.handleIncludeExclude(S.includePattern,S.expandPatterns),$=this.handleIncludeExclude(S.excludePattern,S.expandPatterns),L=f.length>1,v=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(q=>this.getFolderQueryForSearchPath(q,S,$)):f.map(q=>this.getFolderQueryForRoot(q,S,$,L))).filter(q=>!!q),H={_reason:S._reason,folderQueries:v,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:S.extraFileResources,excludePattern:$.pattern,includePattern:P.pattern,onlyOpenEditors:S.onlyOpenEditors,maxResults:S.maxResults};if(S.onlyOpenEditors){const q=o.coalesce(o.flatten(this.editorGroupsService.groups.map(z=>z.editors.map(ae=>ae.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(q));const K=q.filter(z=>(0,p.pathIncludedInQuery)(H,z.fsPath)),V=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...H,...V}}const W=S.extraFileResources&&S.extraFileResources.filter(q=>(0,p.pathIncludedInQuery)(H,q.fsPath));return H.extraFileResources=W&&W.length?W:void 0,H}commonQueryFromFileList(f){const S=[],P=new C.ResourceMap,$={};let L=!1;return f.forEach(v=>{if(v.scheme===A.Schemas.walkThrough)return;if((0,F.isAbsolutePath)(v)){const W=this.workspaceContextService.getWorkspaceFolder(v)?.uri??v.with({path:D.dirname(v.fsPath)});let q=P.get(W);q||(L=!0,q={folder:W,includePattern:{}},S.push(q),P.set(W,q));const K=D.relative(W.fsPath,v.fsPath);(0,b.assertIsDefined)(q.includePattern)[K.replace(/\\/g,"/")]=!0}else v.fsPath&&(L=!0,$[v.fsPath]=!0)}),{folderQueries:S,includePattern:$,usingSearchPaths:!0,excludePattern:L?void 0:{"**/*":!0}}}isCaseSensitive(f,S){if(S.isSmartCase){if(f.isRegExp){if(N.containsUppercaseCharacter(f.pattern,!0))return!0}else if(N.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}isMultiline(f){return f.isMultiline||f.isRegExp&&(0,g.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const S=V=>D.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),$=(Array.isArray(f)?f:r(f)).map(V=>{const z=this.pathService.resolvedUserHome;return z?(0,B.untildify)(V,z.scheme===A.Schemas.file?z.fsPath:z.path):V}),L=k.groupBy($,V=>S(V)?"searchPaths":"exprSegments"),v=(L.exprSegments||[]).map(V=>N.rtrim(V,"/")).map(V=>N.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),i(V))),H={},W=this.expandSearchPathPatterns(L.searchPaths||[]);W&&W.length&&(H.searchPaths=W);const q=o.flatten(v),K=T(...q);return K&&(H.pattern=K),H}getExcludesForFolder(f,S){return S.disregardExcludeSettings?void 0:(0,p.getExcludes)(f,!S.disregardSearchExcludeSettings)}expandSearchPathPatterns(f){if(!f||!f.length)return[];const S=o.flatten(f.map($=>{let{pathPortion:L,globPortion:v}=a($);v&&(v=t(v));const H=this.expandOneSearchPath(L);return o.flatten(H.map(W=>this.resolveOneSearchPathPattern(W,v)))})),P=new Map;return S.forEach($=>{const L=$.searchPath.toString(),v=P.get(L);v?$.pattern&&(v.pattern=v.pattern||{},v.pattern[$.pattern]=!0):P.set(L,{searchPath:$.searchPath,pattern:$.pattern?T($.pattern):void 0})}),Array.from(P.values())}expandOneSearchPath(f){if(D.isAbsolute(f)){const S=this.workspaceContextService.getWorkspace().folders;return S[0]&&S[0].uri.scheme!==A.Schemas.file?[{searchPath:S[0].uri.with({path:f})}]:[{searchPath:c.URI.file(D.normalize(f))}]}if(this.workspaceContextService.getWorkbenchState()===2){const S=this.workspaceContextService.getWorkspace().folders[0].uri;if(f=u(f),f.startsWith("../")||f===".."){const $=D.posix.resolve(S.path,f);return[{searchPath:S.with({path:$})}]}const P=t(f);return[{searchPath:S,pattern:P}]}else{if(f==="./"||f===".\\")return[];{const S=f.replace(/^\.[\/\\]/,""),$=this.workspaceContextService.getWorkspace().folders.map(L=>{const v=S.match(new RegExp(`^${N.escapeRegExpCharacters(L.name)}(?:/(.*)|$)`));return v?{match:v,folder:L}:null}).filter(b.isDefined);if($.length)return $.map(L=>{const v=L.match[1];return{searchPath:L.folder.uri,pattern:v&&t(v)}});{const L=f.match(/\.[\/\\](.+)[\/\\]?/),v=L?L[1]:f,H=s.localize(0,null,v);throw new Error(H)}}}}resolveOneSearchPathPattern(f,S){const P=f.pattern&&S?`${f.pattern}/${S}`:f.pattern||S,$=[{searchPath:f.searchPath,pattern:P}];return P&&!P.endsWith("**")&&$.push({searchPath:f.searchPath,pattern:P+"/**"}),$}getFolderQueryForSearchPath(f,S,P){const $=this.getFolderQueryForRoot((0,_.toWorkspaceFolder)(f.searchPath),S,P,!1);return $?{...$,includePattern:f.pattern}:null}getFolderQueryForRoot(f,S,P,$){let L;const v=c.URI.isUri(f)?f:f.uri;if(P.searchPaths){const V=P.searchPaths.filter(z=>(0,F.isEqual)(z.searchPath,v))[0];if(V&&!V.pattern)return null;V&&(L=V.pattern)}const H=this.configurationService.getValue({resource:v}),q={...this.getExcludesForFolder(H,S)||{},...L||{}},K=c.URI.isUri(f)?(0,F.basename)(f):f.name;return{folder:v,folderName:$?K:void 0,excludePattern:Object.keys(q).length>0?q:void 0,fileEncoding:H.files&&H.files.encoding,disregardIgnoreFiles:typeof S.disregardIgnoreFiles=="boolean"?S.disregardIgnoreFiles:!H.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof S.disregardGlobalIgnoreFiles=="boolean"?S.disregardGlobalIgnoreFiles:!H.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof S.disregardParentIgnoreFiles=="boolean"?S.disregardParentIgnoreFiles:!H.search.useParentIgnoreFiles,ignoreSymlinks:typeof S.ignoreSymlinks=="boolean"?S.ignoreSymlinks:!H.search.followSymlinks}}};E=Fe([Ne(0,n.IConfigurationService),Ne(1,_.IWorkspaceContextService),Ne(2,y.IEditorGroupsService),Ne(3,h.ILogService),Ne(4,d.IPathService)],E),e.QueryBuilder=E;function a(m){const f=m.match(/[\*\{\}\(\)\[\]\?]/);if(f){const S=f.index,P=m.substr(0,S).match(/[/|\\][^/\\]*$/);if(P){let $=m.substr(0,P.index);return $.match(/[/\\]/)||($+="/"),{pathPortion:$,globPortion:m.substr((P.index||0)+1)}}}return{pathPortion:m}}function T(...m){return m.length?m.reduce((f,S)=>(f[S]=!0,f),Object.create(null)):void 0}function r(m){return w.splitGlobAware(m,",").map(f=>f.trim()).filter(f=>!!f.length)}function i(m){return[`**/${m}/**`,`**/${m}`].map(S=>S.replace(/\*\*\/\*\*/g,"**"))}function u(m){return m.replace(/\\/g,"/")}function t(m){return u(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function l(m,f){m=o.distinct(m,$=>$.toString());const S=[],P=f.getWorkspace();return m&&m.forEach($=>{let L;if(f.getWorkbenchState()===2)L=(0,F.relativePath)(P.folders[0].uri,$),L&&L!=="."&&(L="./"+L);else{const v=f.getWorkspaceFolder($);if(v){const H=v.name;if(P.folders.filter(q=>q.name===H).length===1){const q=(0,F.relativePath)(v.uri,$);q===""?L=`./${v.name}`:L=`./${v.name}/${q}`}else L=$.fsPath}}L&&S.push(L)}),S}e.resolveResourcesForSearchIncludes=l}),define(we[216],be([1,0,24,2,20,15,3,215,41,46]),function(Z,e,o,k,w,B,C,A,D,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const N=7e3;function b(n,h){const _=h.activationEvents;if(!_)return Promise.resolve(void 0);const y=[],d=[];for(const i of _)if(/^workspaceContains:/.test(i)){const u=i.substr("workspaceContains:".length);u.indexOf("*")>=0||u.indexOf("?")>=0||n.forceUsingSearch?d.push(u):y.push(u)}if(y.length===0&&d.length===0)return Promise.resolve(void 0);let p;const E=new Promise((i,u)=>{p=i}),a=i=>p({activationEvent:i}),T=Promise.all(y.map(i=>c(n,i,a))).then(()=>{}),r=g(n,h.identifier,d,a);return Promise.all([T,r]).then(()=>{p(void 0)}),E}e.checkActivateWorkspaceContainsExtension=b;async function c(n,h,_){for(const y of n.folders)if(await n.exists(o.joinPath(k.URI.revive(y),h))){_(`workspaceContains:${h}`);return}}async function g(n,h,_,y){if(_.length===0)return Promise.resolve(void 0);const d=new w.CancellationTokenSource,p=n.checkExists(n.folders,_,d.token),E=setTimeout(async()=>{d.cancel(),n.logService.info(`Not activating extension '${h.value}': Timed out while searching for 'workspaceContains' pattern ${_.join(",")}`)},N);let a=!1;try{a=await p}catch(T){B.isCancellationError(T)||B.onUnexpectedError(T)}d.dispose(),clearTimeout(E),a&&y(`workspaceContains:${_.join(",")}`)}function s(n,h,_,y){const d=n.get(C.IInstantiationService),p=n.get(D.ISearchService),a=d.createInstance(A.QueryBuilder).file(h.map(T=>(0,F.toWorkspaceFolder)(k.URI.revive(T))),{_reason:"checkExists",includePattern:_,exists:!0});return p.fileSearch(a,y).then(T=>!!T.limitHit,T=>B.isCancellationError(T)?!1:Promise.reject(T))}e.checkGlobFileExists=s});var Ve=this&&this.__classPrivateFieldSet||function(Z,e,o,k,w){if(k==="m")throw new TypeError("Private method is not writable");if(k==="a"&&!w)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?Z!==e||!w:!e.has(Z))throw new TypeError("Cannot write private member to an object whose class did not declare it");return k==="a"?w.call(Z,o):w?w.value=o:e.set(Z,o),o},De=this&&this.__classPrivateFieldGet||function(Z,e,o,k){if(o==="a"&&!k)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?Z!==e||!k:!e.has(Z))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?k:o==="a"?k.call(Z):k?k.value:e.get(Z)};define(we[33],be([1,0,123,17,69,24,13,7,22,2,12,4,32,174,67,31,28,173,15,26,21,149,6,81,3,27,68,14,56,59,40,5,216,64,151,10]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_,y,d,p,E,a,T,r,i,u,t,l,m,f,S,P,$,L,v){"use strict";var H,W,q;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let K=class Ki extends A.Disposable{constructor(Y,ie,ce,he,ue,se,ge,Te,Re,He){super();this._onDidChangeRemoteConnectionData=this._register(new S.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=ie,this._extHostContext=ce,this._initData=ge,this._extHostWorkspace=he,this._extHostConfiguration=ue,this._logService=se,this._extHostTunnelService=Re,this._extHostTerminalService=He,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(b.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(b.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(b.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new C.Barrier,this._readyToStartExtensionHost=new C.Barrier,this._readyToRunExtensions=new C.Barrier,this._eagerExtensionsActivated=new C.Barrier,this._registry=new _.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new s.ExtHostStorage(this._extHostContext),this._secretState=new $.ExtHostSecretState(this._extHostContext),this._storagePath=Te,this._instaService=Y.createChild(new l.ServiceCollection([s.IExtHostStorage,this._storage],[$.IExtHostSecretState,this._secretState]));const Xe=new Set;this._initData.hostExtensions.forEach(ve=>Xe.add(d.ExtensionIdentifier.toKey(ve))),this._activator=this._register(new g.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(ve,fe,M)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(ve,y.transformErrorForSerialization(fe),M)},actualActivateExtension:async(ve,fe)=>{if(Xe.has(d.ExtensionIdentifier.toKey(ve)))return await this._mainThreadExtensionsProxy.$activateExtension(ve,fe),new g.HostExtension;const M=this._registry.getExtensionDescription(ve);return this._activateExtension(M,fe)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),w.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(Y){y.onUnexpectedError(Y)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let Y=[];try{Y=this._registry.getAllExtensionDescriptions().map(ue=>ue.identifier).filter(ue=>this.isActivated(ue)).map(ue=>this._deactivate(ue))}catch{}await Promise.all(Y)}isActivated(Y){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(Y):!1}_activateByEvent(Y,ie){return this._activator.activateByEvent(Y,ie)}_activateById(Y,ie){return this._activator.activateById(Y,ie)}activateByIdWithErrors(Y,ie){return this._activateById(Y,ie).then(()=>{const ce=this._activator.getActivatedExtension(Y);if(ce.activationFailed)return Promise.reject(ce.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(Y=>this._registry)}getExtensionExports(Y){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(Y).exports:null}async _realPathExtensionUri(Y){if(Y.scheme!==v.Schemas.file)return Y;const ie=await this._hostUtils.realpath(Y.fsPath);return F.URI.file(ie)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=(async()=>{const Y=D.TernarySearchTree.forUris(ie=>B.extUriBiasedIgnorePathCase.ignorePathCasing(ie));for(const ie of this._registry.getAllExtensionDescriptions())if(this._getEntryPoint(ie)){const ce=await this._realPathExtensionUri(ie.extensionLocation);Y.set(ce,ie)}return Y})()),this._extensionPathIndex}_deactivate(Y){let ie=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(Y))return ie;const ce=this._activator.getActivatedExtension(Y);if(!ce)return ie;try{typeof ce.module.deactivate=="function"&&(ie=Promise.resolve(ce.module.deactivate()).then(void 0,he=>(this._logService.error(he),Promise.resolve(void 0))))}catch(he){this._logService.error(`An error occurred when deactivating the extension '${Y.value}':`),this._logService.error(he)}try{(0,A.dispose)(ce.subscriptions)}catch(he){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${Y.value}':`),this._logService.error(he)}return ie}async _activateExtension(Y,ie){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(Y.identifier),this._doActivateExtension(Y,ie).then(ce=>{const he=ce.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(Y.identifier,he.codeLoadingTime,he.activateCallTime,he.activateResolvedTime,ie),this._logExtensionActivationTimes(Y,ie,"success",he),ce},ce=>{throw this._logExtensionActivationTimes(Y,ie,"failure"),ce})}_logExtensionActivationTimes(Y,ie,ce,he){const ue=V(Y,ie);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ue,...he||{},outcome:ce})}_doActivateExtension(Y,ie){const ce=V(Y,ie);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",ce);const he=this._getEntryPoint(Y);if(!he)return Promise.resolve(new g.EmptyExtension(g.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${Y.identifier.value}, startup: ${ie.startup}, activationEvent: '${ie.activationEvent}'${Y.identifier.value!==ie.extensionId.value?`, root cause: ${ie.extensionId.value}`:""}`),this._logService.flush();const ue=new g.ExtensionActivationTimesBuilder(ie.startup);return Promise.all([this._loadCommonJSModule(Y.identifier,(0,B.joinPath)(Y.extensionLocation,he),ue),this._loadExtensionContext(Y)]).then(se=>(w.mark(`code/extHost/willActivateExtension/${Y.identifier.value}`),Ki._callActivate(this._logService,Y.identifier,se[0],se[1],ue))).then(se=>(w.mark(`code/extHost/didActivateExtension/${Y.identifier.value}`),se))}_loadExtensionContext(Y){const ie=new E.ExtensionGlobalMemento(Y,this._storage),ce=new E.ExtensionMemento(Y.identifier.value,!1,this._storage),he=new L.ExtensionSecrets(Y,this._secretState),ue=Y.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?a.ExtensionMode.Test:a.ExtensionMode.Development:a.ExtensionMode.Production,se=this._initData.remote.isRemote?a.ExtensionKind.Workspace:a.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${Y.identifier.value}`),Promise.all([ie.whenReady,ce.whenReady,this._storagePath.whenReady]).then(()=>{const ge=this;let Te,Re;const He=(0,h.isProposedApiEnabled)(Y,"ipc")?this._initData.messagePorts?.get(d.ExtensionIdentifier.toKey(Y.identifier)):void 0;return Object.freeze({globalState:ie,workspaceState:ce,secrets:he,subscriptions:[],get extensionUri(){return Y.extensionLocation},get extensionPath(){return Y.extensionLocation.fsPath},asAbsolutePath(Xe){return k.join(Y.extensionLocation.fsPath,Xe)},get storagePath(){return ge._storagePath.workspaceValue(Y)?.fsPath},get globalStoragePath(){return ge._storagePath.globalValue(Y).fsPath},get logPath(){return k.join(ge._initData.logsLocation.fsPath,Y.identifier.value)},get logUri(){return F.URI.joinPath(ge._initData.logsLocation,Y.identifier.value)},get storageUri(){return ge._storagePath.workspaceValue(Y)},get globalStorageUri(){return ge._storagePath.globalValue(Y)},get extensionMode(){return ue},get extension(){return Te===void 0&&(Te=new z(ge,Y.identifier,Y,se)),Te},get extensionRuntime(){return(0,h.checkProposedApiEnabled)(Y,"extensionRuntime"),ge.extensionRuntime},get environmentVariableCollection(){return ge._extHostTerminalService.getEnvironmentVariableCollection(Y)},get messagePassingProtocol(){if(!Re){if(!He)return;const Xe=S.Event.buffer(S.Event.fromDOMEventEmitter(He,"message",ve=>ve.data));He.start(),Re={onDidReceiveMessage:Xe,postMessage:He.postMessage.bind(He)}}return Re}})})}static _callActivate(Y,ie,ce,he,ue){return ce=ce||{activate:void 0,deactivate:void 0},this._callActivateOptional(Y,ie,ce,he,ue).then(se=>new g.ActivatedExtension(!1,null,ue.build(),ce,se,he.subscriptions))}static _callActivateOptional(Y,ie,ce,he,ue){if(typeof ce.activate=="function")try{ue.activateCallStart(),Y.trace(`ExtensionService#_callActivateOptional ${ie.value}`);const se=typeof global=="object"?global:self,ge=ce.activate.apply(se,[he]);return ue.activateCallStop(),ue.activateResolveStart(),Promise.resolve(ge).then(Te=>(ue.activateResolveStop(),Te))}catch(se){return Promise.reject(se)}else return Promise.resolve(ce)}_activateOneStartupFinished(Y,ie){this._activateById(Y.identifier,{startup:!1,extensionId:Y.identifier,activationEvent:ie}).then(void 0,ce=>{this._logService.error(ce)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(w.getMarks());for(const Y of this._registry.getAllExtensionDescriptions())if(Y.activationEvents)for(const ie of Y.activationEvents)ie==="onStartupFinished"&&this._activateOneStartupFinished(Y,ie)}_handleEagerExtensions(){const Y=this._activateByEvent("*",!0).then(void 0,ue=>{this._logService.error(ue)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ue=>this._handleWorkspaceContainsEagerExtensions(ue.added)));const ie=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],ce=this._handleWorkspaceContainsEagerExtensions(ie),he=Promise.all([Y,ce]).then(()=>{});return Promise.race([he,(0,C.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),he}_handleWorkspaceContainsEagerExtensions(Y){return Y.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(ie=>this._handleWorkspaceContainsEagerExtension(Y,ie))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(Y,ie){if(this.isActivated(ie.identifier))return;const ce=!this._initData.remote.isRemote&&!!this._initData.remote.authority,he={logService:this._logService,folders:Y.map(se=>se.uri),forceUsingSearch:ce,exists:se=>this._hostUtils.exists(se.fsPath),checkExists:(se,ge,Te)=>this._mainThreadWorkspaceProxy.$checkExists(se,ge,Te)},ue=await(0,P.checkActivateWorkspaceContainsExtension)(he,ie);if(!!ue)return this._activateById(ie.identifier,{startup:!0,extensionId:ie.identifier,activationEvent:ue.activationEvent}).then(void 0,se=>this._logService.error(se))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(Y){throw console.error(Y),Y}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:Y,extensionTestsLocationURI:ie}=this._initData.environment;if(!Y||!ie)throw new Error(o.localize(0,null));const ce=await this._loadCommonJSModule(null,ie,new g.ExtensionActivationTimesBuilder(!1));if(!ce||typeof ce.run!="function")throw new Error(o.localize(1,null,ie.toString()));return new Promise((he,ue)=>{const se=(Re,He)=>{Re?ue(Re):he(typeof He=="number"&&He>0?1:0)},ge=(0,B.originalFSPath)(ie),Te=ce.run(ge,se);Te&&Te.then&&Te.then(()=>{he(0)}).catch(Re=>{ue(Re instanceof Error&&Re.stack?Re.stack:String(Re))})})}async $extensionTestsExit(Y){this._logService.info(`Extension host terminating: test runner requested exit with code ${Y}`),this._hostUtils.pid&&this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Y}`),this._logService.flush(),this._hostUtils.exit(Y)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(Y,ie){return this._resolvers[Y]=ie,(0,A.toDisposable)(()=>{delete this._resolvers[Y]})}async _activateAndGetResolver(Y){const ie=Y.indexOf("+");if(ie===-1)throw new Error("Not an authority that can be resolved!");const ce=Y.substr(0,ie);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${ce}`,!1),{authorityPrefix:ce,resolver:this._resolvers[ce]}}async $resolveAuthority(Y,ie){this._logService.info(`$resolveAuthority invoked for authority (${ae(Y)})`);const{authorityPrefix:ce,resolver:he}=await this._activateAndGetResolver(Y);if(!he)return{type:"error",error:{code:T.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ce}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(he)),w.mark(`code/extHost/willResolveAuthority/${ce}`);const ue=await he.resolve(Y,{resolveAttempt:ie});w.mark(`code/extHost/didResolveAuthorityOK/${ce}`);const se={authority:Y,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},ge={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:se,options:ge,tunnelInformation:{environmentTunnels:ue.environmentTunnels,features:ue.tunnelFeatures}}}}catch(ue){if(w.mark(`code/extHost/didResolveAuthorityError/${ce}`),ue instanceof a.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(Y,ie){this._logService.info(`$getCanonicalURI invoked for authority (${ae(Y)})`);const{authorityPrefix:ce,resolver:he}=await this._activateAndGetResolver(Y);if(!he)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${ce}`);const ue=F.URI.revive(ie);if(typeof he.getCanonicalURI=="undefined")return ue;const se=await(0,C.asPromise)(()=>he.getCanonicalURI(ue));return se||ue}$startExtensionHost(Y){return this._registry.keepOnly(Y),this._startExtensionHost()}$activateByEvent(Y,ie){return ie===1?this._activateByEvent(Y,!1):this._readyToRunExtensions.wait().then(ce=>this._activateByEvent(Y,!1))}async $activate(Y,ie){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(Y)?(await this._activateById(Y,ie),!0):!1}async $deltaExtensions(Y,ie){Y.forEach(he=>he.extensionLocation=F.URI.revive(he.extensionLocation));const ce=await this.getExtensionPathIndex();return await Promise.all(ie.map(async he=>{const ue=this._registry.getExtensionDescription(he);ue&&ce.delete(await this._realPathExtensionUri(ue.extensionLocation))})),await Promise.all(Y.map(async he=>{const ue=await this._realPathExtensionUri(he.extensionLocation);ce.set(ue,he)})),this._registry.deltaExtensions(Y,ie),Promise.resolve(void 0)}async $test_latency(Y){return Y}async $test_up(Y){return Y.byteLength}async $test_down(Y){let ie=p.VSBuffer.alloc(Y),ce=Math.random()%256;for(let he=0;he<Y;he++)ie.writeUInt8(ce,he);return ie}async $updateRemoteConnectionData(Y){this._remoteConnectionData=Y,this._onDidChangeRemoteConnectionData.fire()}};K=Fe([Ne(0,r.IInstantiationService),Ne(1,e.IHostUtils),Ne(2,t.IExtHostRpcService),Ne(3,n.IExtHostWorkspace),Ne(4,c.IExtHostConfiguration),Ne(5,N.ILogService),Ne(6,i.IExtHostInitDataService),Ne(7,u.IExtensionStoragePaths),Ne(8,m.IExtHostTunnelService),Ne(9,f.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function V(de,Y){return{id:de.identifier.value,name:de.name,extensionVersion:de.version,publisherDisplayName:de.publisher,activationEvents:de.activationEvents?de.activationEvents.join(","):null,isBuiltin:de.isBuiltin,reason:Y.activationEvent,reasonId:Y.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class z{constructor(Y,ie,ce,he){H.set(this,void 0),W.set(this,void 0),q.set(this,void 0),Ve(this,H,Y,"f"),Ve(this,W,ie,"f"),Ve(this,q,ce.identifier,"f"),this.id=ce.identifier.value,this.extensionUri=ce.extensionLocation,this.extensionPath=k.normalize((0,B.originalFSPath)(ce.extensionLocation)),this.packageJSON=ce,this.extensionKind=he}get isActive(){return De(this,H,"f").isActivated(De(this,q,"f"))}get exports(){if(this.packageJSON.api!=="none")return De(this,H,"f").getExtensionExports(De(this,q,"f"))}activate(){return De(this,H,"f").activateByIdWithErrors(De(this,q,"f"),{startup:!1,extensionId:De(this,W,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=z,H=new WeakMap,W=new WeakMap,q=new WeakMap;function ae(de){const Y=de.indexOf("+");return Y===-1?de:de.substring(0,Y)}}),define(we[98],be([1,0,17,2,5,13,4,6,158,31,33,49,166,32,160,14,3,11,86,66]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,h.createDecorator)("IExtHostDebugService");let p=class{constructor(l,m,f,S,P,$){this._workspaceService=m,this._extensionService=f,this._editorsService=S,this._configurationService=P,this._editorTabs=$,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new w.Emitter,this._onDidTerminateDebugSession=new w.Emitter,this._onDidChangeActiveDebugSession=new w.Emitter,this._onDidReceiveDebugSessionCustomEvent=new w.Emitter,this._debugServiceProxy=l.getProxy(C.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new w.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new a(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(L=>{L.onDidChange(v=>{this.registerAllDebugTypes(L)}),this.registerAllDebugTypes(L)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(l,m){const f=l;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let S=`debug:${encodeURIComponent(f.path||"")}`,P="?";return m&&(S+=`${P}session=${encodeURIComponent(m.id)}`,P="&"),S+=`${P}ref=${f.sourceReference}`,k.URI.parse(S)}else{if(f.path)return k.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(l){const m=[];for(const f of l.getAllExtensionDescriptions())if(f.contributes){const S=f.contributes.debuggers;if(S&&S.length>0)for(const P of S)(0,s.isDebuggerMainContribution)(P)&&m.push(P.type)}this._debugServiceProxy.$registerDebugTypes(m)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const l=[];return this._breakpoints.forEach(m=>l.push(m)),l}addBreakpoints(l){this.startBreakpoints();const m=l.filter(P=>{const $=P.id;return this._breakpoints.has($)?!1:(this._breakpoints.set($,P),!0)});this.fireBreakpointChanges(m,[],[]);const f=[],S=new Map;for(const P of m)if(P instanceof A.SourceBreakpoint){let $=S.get(P.location.uri.toString());$||($={type:"sourceMulti",uri:P.location.uri,lines:[]},S.set(P.location.uri.toString(),$),f.push($)),$.lines.push({id:P.id,enabled:P.enabled,condition:P.condition,hitCondition:P.hitCondition,logMessage:P.logMessage,line:P.location.range.start.line,character:P.location.range.start.character})}else P instanceof A.FunctionBreakpoint&&f.push({type:"function",id:P.id,enabled:P.enabled,hitCondition:P.hitCondition,logMessage:P.logMessage,condition:P.condition,functionName:P.functionName});return this._debugServiceProxy.$registerBreakpoints(f)}removeBreakpoints(l){this.startBreakpoints();const m=l.filter($=>this._breakpoints.delete($.id));this.fireBreakpointChanges([],m,[]);const f=m.filter($=>$ instanceof A.SourceBreakpoint).map($=>$.id),S=m.filter($=>$ instanceof A.FunctionBreakpoint).map($=>$.id),P=m.filter($=>$ instanceof A.DataBreakpoint).map($=>$.id);return this._debugServiceProxy.$unregisterBreakpoints(f,S,P)}startDebugging(l,m,f){return this._debugServiceProxy.$startDebugging(l?l.uri:void 0,m,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===A.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,debugUI:f.debugUI,suppressSaveBeforeStart:f.suppressSaveBeforeStart})}stopDebugging(l){return this._debugServiceProxy.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,m,f){if(!m)return new A.Disposable(()=>{});const S=this._configProviderHandleCounter++;return this._configProviders.push({type:l,handle:S,provider:m}),this._debugServiceProxy.$registerDebugConfigurationProvider(l,f,!!m.provideDebugConfigurations,!!m.resolveDebugConfiguration,!!m.resolveDebugConfigurationWithSubstitutedVariables,S),new A.Disposable(()=>{this._configProviders=this._configProviders.filter(P=>P.provider!==m),this._debugServiceProxy.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(l,m,f){if(!f)return new A.Disposable(()=>{});if(!this.definesDebugType(l,m))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${m}' debugger.`);if(this.getAdapterDescriptorFactoryByType(m))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:m,handle:S,factory:f}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(m,S),new A.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(P=>P.factory!==f),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(l,m){if(!m)return new A.Disposable(()=>{});const f=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:l,handle:f,factory:m}),new A.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(S=>S.factory!==m)})}async $runInTerminal(l,m){return Promise.resolve(void 0)}async $substituteVariables(l,m){if(!this._variableResolver){const[P,$]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(P||[],this._editorsService,$)}let f;const S=await this.getFolder(l);return S&&(f={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(f,m)}createDebugAdapter(l,m){if(l.type==="implementation")return new i(l.implementation)}createSignService(){}async $startDASession(l,m){const f=this,S=await this.getSession(m);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(S.type),S).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const $=this.convertToDto(P),L=this.createDebugAdapter($,S);if(!L)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const v=L;return this._debugAdapters.set(l,v),this.getDebugAdapterTrackers(S).then(H=>(H&&this._debugAdaptersTrackers.set(l,H),v.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const q=W,K={type:"response",seq:0,command:q.command,request_seq:q.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const V=await this._signService.sign(q.arguments.value);K.body={signature:V},v.sendResponse(K)}else throw new Error("no signer")}catch(V){K.success=!1,K.message=V.message,v.sendResponse(K)}}else H&&H.onDidSendMessage&&H.onDidSendMessage(W),W=(0,s.convertToVSCPaths)(W,!0),f._debugServiceProxy.$acceptDAMessage(l,W)}),v.onError(W=>{H&&H.onError&&H.onError(W),this._debugServiceProxy.$acceptDAError(l,W.name,W.message,W.stack)}),v.onExit(W=>{H&&H.onExit&&H.onExit((0,_.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(l,(0,_.withNullAsUndefined)(W),void 0)}),H&&H.onWillStartSession&&H.onWillStartSession(),v.startSession()))})}$sendDAMessage(l,m){m=(0,s.convertToDAPaths)(m,!1);const f=this._debugAdaptersTrackers.get(l);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(m);const S=this._debugAdapters.get(l);S&&S.sendMessage(m)}$stopDASession(l){const m=this._debugAdaptersTrackers.get(l);this._debugAdaptersTrackers.delete(l),m&&m.onWillStopSession&&m.onWillStopSession();const f=this._debugAdapters.get(l);return this._debugAdapters.delete(l),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const m=[],f=[],S=[];if(l.added)for(const P of l.added){const $=P.id;if($&&!this._breakpoints.has($)){let L;if(P.type==="function")L=new A.FunctionBreakpoint(P.functionName,P.enabled,P.condition,P.hitCondition,P.logMessage);else if(P.type==="data")L=new A.DataBreakpoint(P.label,P.dataId,P.canPersist,P.enabled,P.hitCondition,P.condition,P.logMessage);else{const v=k.URI.revive(P.uri);L=new A.SourceBreakpoint(new A.Location(v,new A.Position(P.line,P.character)),P.enabled,P.condition,P.hitCondition,P.logMessage)}L._id=$,this._breakpoints.set($,L),m.push(L)}}if(l.removed)for(const P of l.removed){const $=this._breakpoints.get(P);$&&(this._breakpoints.delete(P),f.push($))}if(l.changed){for(const P of l.changed)if(P.id){const $=this._breakpoints.get(P.id);if($){if($ instanceof A.FunctionBreakpoint&&P.type==="function"){const L=$;L.enabled=P.enabled,L.condition=P.condition,L.hitCondition=P.hitCondition,L.logMessage=P.logMessage,L.functionName=P.functionName}else if($ instanceof A.SourceBreakpoint&&P.type==="source"){const L=$;L.enabled=P.enabled,L.condition=P.condition,L.hitCondition=P.hitCondition,L.logMessage=P.logMessage,L.location=new A.Location(k.URI.revive(P.uri),new A.Position(P.line,P.character))}S.push($)}}}this.fireBreakpointChanges(m,f,S)}$provideDebugConfigurations(l,m,f){return(0,B.asPromise)(async()=>{const S=this.getConfigProviderByHandle(l);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const P=await this.getFolder(m);return S.provideDebugConfigurations(P,f)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(l,m,f,S){return(0,B.asPromise)(async()=>{const P=this.getConfigProviderByHandle(l);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const $=await this.getFolder(m);return P.resolveDebugConfiguration($,f,S)})}$resolveDebugConfigurationWithSubstitutedVariables(l,m,f,S){return(0,B.asPromise)(async()=>{const P=this.getConfigProviderByHandle(l);if(!P)throw new Error("no DebugConfigurationProvider found");if(!P.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const $=await this.getFolder(m);return P.resolveDebugConfigurationWithSubstitutedVariables($,f,S)})}async $provideDebugAdapter(l,m){const f=this.getAdapterDescriptorFactoryByHandle(l);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.getSession(m);return this.getAdapterDescriptor(f,S).then(P=>{if(!P)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.convertToDto(P)})}async $acceptDebugSessionStarted(l){const m=await this.getSession(l);this._onDidStartDebugSession.fire(m)}async $acceptDebugSessionTerminated(l){const m=await this.getSession(l);m&&(this._onDidTerminateDebugSession.fire(m),this._debugSessions.delete(m.id))}async $acceptDebugSessionActiveChanged(l){this._activeDebugSession=l?await this.getSession(l):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(l,m){const f=await this.getSession(l);f&&f._acceptNameChanged(m)}async $acceptDebugSessionCustomEvent(l,m){const S={session:await this.getSession(l),event:m.event,body:m.body};this._onDidReceiveDebugSessionCustomEvent.fire(S)}convertToDto(l){if(l instanceof A.DebugAdapterExecutable)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof A.DebugAdapterServer)return{type:"server",port:l.port,host:l.host};if(l instanceof A.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:l.path};if(l instanceof A.DebugAdapterInlineImplementation)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(l){const m=this._adapterFactories.filter(f=>f.type===l);if(m.length>0)return m[0].factory}getAdapterDescriptorFactoryByHandle(l){const m=this._adapterFactories.filter(f=>f.handle===l);if(m.length>0)return m[0].factory}getConfigProviderByHandle(l){const m=this._configProviders.filter(f=>f.handle===l);if(m.length>0)return m[0].provider}definesDebugType(l,m){if(l.contributes){const f=l.contributes.debuggers;if(f&&f.length>0){for(const S of f)if(S.label&&S.type&&S.type===m)return!0}}return!1}getDebugAdapterTrackers(l){const f=l.configuration.type,S=this._trackerFactories.filter(P=>P.type===f||P.type==="*").map(P=>(0,B.asPromise)(()=>P.factory.createDebugAdapterTracker(l)).then($=>$,$=>null));return Promise.race([Promise.all(S).then(P=>{const $=P.filter(L=>!!L);if($.length>0)return new r($)}),new Promise((P,$)=>{const L=setTimeout(()=>{clearTimeout(L),$(new Error("timeout"))},1e3)})]).catch(P=>{})}async getAdapterDescriptor(l,m){const f=m.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new A.DebugAdapterServer(f));if(l){const P=await this._extensionService.getExtensionRegistry();return(0,B.asPromise)(()=>l.createDebugAdapterDescriptor(m,this.daExecutableFromPackage(m,P))).then($=>{if($)return $})}const S=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(m,S))}daExecutableFromPackage(l,m){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(l,m,f){(l.length>0||m.length>0||f.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:l,removed:m,changed:f}))}async getSession(l){if(l)if(typeof l=="string"){const m=this._debugSessions.get(l);if(m)return m}else{let m=this._debugSessions.get(l.id);if(!m){const f=await this.getFolder(l.folderUri),S=l.parent?this._debugSessions.get(l.parent):void 0;m=new E(this._debugServiceProxy,l.id,l.type,l.name,f,l.configuration,S),this._debugSessions.set(m.id,m),this._debugServiceProxy.$sessionCached(m.id)}return m}throw new Error("cannot find session")}getFolder(l){if(l){const m=k.URI.revive(l);return this._workspaceService.resolveWorkspaceFolder(m)}return Promise.resolve(void 0)}};p=Fe([Ne(0,n.IExtHostRpcService),Ne(1,F.IExtHostWorkspace),Ne(2,N.IExtHostExtensionService),Ne(3,b.IExtHostDocumentsAndEditors),Ne(4,g.IExtHostConfiguration),Ne(5,d.IExtHostEditorTabs)],p),e.ExtHostDebugServiceBase=p;class E{constructor(l,m,f,S,P,$,L){this._debugServiceProxy=l,this._id=m,this._type=f,this._name=S,this._workspaceFolder=P,this._configuration=$,this._parentSession=L}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(l){this._name=l,this._debugServiceProxy.$setDebugSessionName(this._id,l)}get parentSession(){return this._parentSession}_acceptNameChanged(l){this._name=l}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(l,m){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,l,m)}getDebugProtocolBreakpoint(l){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,l.id)}}e.ExtHostDebugSession=E;class a{constructor(l){this.value=Object.freeze({append(m){l.$appendDebugConsole(m)},appendLine(m){this.append(m+`
`)}})}}e.ExtHostDebugConsole=a;class T extends c.AbstractVariableResolverService{constructor(l,m,f,S,P,$){function L(){if(m){const v=m.activeEditor();if(v)return v.document.uri;const H=S.tabGroups.all.find(W=>W.isActive)?.activeTab;if(H!==void 0){const W=H.resource;return W&&(W.primary||W.secondary)?W.primary??W.secondary:H.resource}}}super({getFolderUri:v=>{const H=l.filter(W=>W.name===v);if(H&&H.length>0)return H[0].uri},getWorkspaceFolderCount:()=>l.length,getConfigurationValue:(v,H)=>f.getConfiguration(void 0,v).get(H),getAppRoot:()=>y.cwd(),getExecPath:()=>y.env.VSCODE_EXEC_PATH,getFilePath:()=>{const v=L();if(v)return o.normalize(v.fsPath)},getWorkspaceFolderPathForFile:()=>{if(P){const v=L();if(v){const H=P.getWorkspaceFolder(v);if(H)return o.normalize(H.uri.fsPath)}}},getSelectedText:()=>{if(m){const v=m.activeEditor();if(v&&!v.selection.isEmpty)return v.document.getText(v.selection)}},getLineNumber:()=>{if(m){const v=m.activeEditor();if(v)return String(v.selection.end.line+1)}}},void 0,$?Promise.resolve($):void 0,Promise.resolve(y.env))}}e.ExtHostVariableResolverService=T;class r{constructor(l){this.trackers=l}onWillStartSession(){this.trackers.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.trackers.forEach(m=>m.onWillReceiveMessage?m.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.trackers.forEach(m=>m.onDidSendMessage?m.onDidSendMessage(l):void 0)}onWillStopSession(){this.trackers.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.trackers.forEach(m=>m.onError?m.onError(l):void 0)}onExit(l,m){this.trackers.forEach(f=>f.onExit?f.onExit(l,m):void 0)}}class i extends D.AbstractDebugAdapter{constructor(l){super();this.implementation=l,l.onDidSendMessage(m=>{this.acceptMessage(m)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.implementation.handleMessage(l)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let u=class extends p{constructor(l,m,f,S,P,$){super(l,m,f,S,P,$)}createVariableResolver(l,m,f){return new T(l,m,f,this._editorTabs)}};u=Fe([Ne(0,n.IExtHostRpcService),Ne(1,F.IExtHostWorkspace),Ne(2,N.IExtHostExtensionService),Ne(3,b.IExtHostDocumentsAndEditors),Ne(4,g.IExtHostConfiguration),Ne(5,d.IExtHostEditorTabs)],u),e.WorkerExtHostDebugService=u}),define(we[217],be([1,0,69,2,4,32,28,26,14,27,3,33,86,12,9]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let n=class{constructor(E,a,T,r,i,u,t){this._apiFactory=E,this._extensionRegistry=a,this._instaService=T,this._extHostConfiguration=r,this._extHostExtensionService=i,this._initData=u,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),o.mark("code/extHost/willWaitForConfig");const E=await this._extHostConfiguration.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const a=await this._extHostExtensionService.getExtensionPathIndex();this.register(new _(this._apiFactory,a,this._extensionRegistry,E,this._logService)),this.register(this._instaService.createInstance(y,a)),this.register(this._instaService.createInstance(h)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(d,a,this._initData.environment.appUriScheme))}register(E){if("nodeModuleName"in E)if(Array.isArray(E.nodeModuleName))for(let a of E.nodeModuleName)this._factories.set(a,E);else this._factories.set(E.nodeModuleName,E);typeof E.alternativeModuleName=="function"&&this._alternatives.push(a=>E.alternativeModuleName(a))}};n=Fe([Ne(2,N.IInstantiationService),Ne(3,B.IExtHostConfiguration),Ne(4,b.IExtHostExtensionService),Ne(5,F.IExtHostInitDataService),Ne(6,g.ILogService)],n),e.RequireInterceptor=n;let h=class Hi{constructor(E){if(E.environment.appRoot&&Hi.aliased.size){const a=(0,s.escapeRegExpCharacters)(this.forceForwardSlashes(E.environment.appRoot.fsPath)),T="[a-z0-9_.-]",r=`@${T}+\\/${T}+|${T}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${a}/${i}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(E){if(!this.re)return;const a=this.re.exec(this.forceForwardSlashes(E));if(!a)return;const[,T,r,i]=a,u=Hi.aliased.get(r);if(u!==void 0)return console.warn(`${r} as been renamed to ${u}, please update your imports`),T+u+i}forceForwardSlashes(E){return E.replace(/\\/g,"/")}};h.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),h=Fe([Ne(0,F.IExtHostInitDataService)],h);class _{constructor(E,a,T,r,i){this._apiFactory=E,this._extensionPaths=a,this._extensionRegistry=T,this._configProvider=r,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(E,a){const T=this._extensionPaths.findSubstr(a);if(T){let r=this._extApiImpl.get(A.ExtensionIdentifier.toKey(T.identifier));return r||(r=this._apiFactory(T,this._extensionRegistry,this._configProvider),this._extApiImpl.set(A.ExtensionIdentifier.toKey(T.identifier),r)),r}if(!this._defaultApiImpl){let r="";this._extensionPaths.forEach((i,u)=>r+=`	${u} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${r}`),this._defaultApiImpl=this._apiFactory(C.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let y=class{constructor(E,a,T){this._extensionPaths=E,this.nodeModuleName="keytar",this._mainThreadTelemetry=a.getProxy(w.MainContext.MainThreadTelemetry);const{environment:r}=T,i=a.getProxy(w.MainContext.MainThreadKeytar);if(r.appRoot){let u=r.appRoot.fsPath;c.platform==="win32"&&(u=u.replace(/\\/g,"/")),u[u.length-1]==="/"&&(u=u.substr(0,u.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${u}/node_modules.asar/keytar`),this.alternativeNames.add(`${u}/node_modules/keytar`)}this._impl={getPassword:(u,t)=>i.$getPassword(u,t),setPassword:(u,t,l)=>i.$setPassword(u,t,l),deletePassword:(u,t)=>i.$deletePassword(u,t),findPassword:u=>i.$findPassword(u),findCredentials(u){return i.$findCredentials(u)}}}load(E,a){const T=this._extensionPaths.findSubstr(a);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:T?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(E){const a=E.length;if(a<=7||!this.alternativeNames)return;const T=a-7;if((E.charAt(T)==="/"||E.charAt(T)==="\\")&&E.endsWith("keytar")&&(E=E.replace(/\\/g,"/"),this.alternativeNames.has(E)))return"keytar"}};y=Fe([Ne(1,D.IExtHostRpcService),Ne(2,F.IExtHostInitDataService)],y);let d=class{constructor(E,a,T){this._extensionPaths=E,this._appUriScheme=a,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=T.getProxy(w.MainContext.MainThreadTelemetry);const r=T.getProxy(w.MainContext.MainThreadWindow);this._impl=(i,u)=>{const t=k.URI.parse(i);return u?this.callOriginal(i,u):t.scheme==="http"||t.scheme==="https"?r.$openUri(t,i,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?r.$openUri(t,i,{}):this.callOriginal(i,u)}}load(E,a,T){const r=this._extensionPaths.findSubstr(a);return r&&(this._extensionId=r.identifier.value,this.sendShimmingTelemetry()),this._original=T(E),this._impl}callOriginal(E,a){return this.sendNoForwardTelemetry(),this._original(E,a)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};d=Fe([Ne(2,D.IExtHostRpcService)],d)}),define(we[218],be([1,0,13,15,69,7,2,4,210,12,55,56,27,139,14,60,33,40]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class y{constructor(p,E,a,T,r){this._disposables=new B.DisposableStore,this._isTerminating=!1,this._hostUtils=a,this._rpcProtocol=new D.RPCProtocol(p,null,T),E=y._transform(E,this._rpcProtocol);const i=new b.ServiceCollection(...(0,N.getSingletonServiceDescriptors)());i.set(c.IExtHostInitDataService,{_serviceBrand:void 0,...E,messagePorts:r}),i.set(s.IExtHostRpcService,new s.ExtHostRpcService(this._rpcProtocol)),i.set(n.IURITransformerService,new n.URITransformerService(T)),i.set(h.IHostUtils,a);const u=new g.InstantiationService(i,!0);this._disposables.add(u.invokeFunction(f=>f.get(_.IExtHostTerminalService))),this._disposables.add(u.invokeFunction(f=>f.get(h.IExtHostExtensionService))),this._logService=u.invokeFunction(f=>f.get(F.ILogService)),w.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",E),this._extensionService=u.invokeFunction(f=>f.get(h.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const t=new WeakMap;this._extensionService.getExtensionPathIndex().then(f=>{Error.prepareStackTrace=(S,P)=>{let $="",L,v;for(const H of P)$+=`
	at ${H.toString()}`,v=H.getFileName(),!L&&v&&(L=f.findSubstr(C.URI.file(v)));return t.set(S,L),`${S.name||"Error"}: ${S.message||""}${$}`}});const l=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService),m=this._rpcProtocol.getProxy(A.MainContext.MainThreadErrors);k.setUnexpectedErrorHandler(f=>{const S=k.transformErrorForSerialization(f),P=t.get(f);P?l.$onExtensionRuntimeError(P.identifier,S):m.$onUnexpectedError(S)})}async asBrowserUri(p){const E=this._rpcProtocol.getProxy(A.MainContext.MainThreadExtensionService);return C.URI.revive(await E.$asBrowserUri(p))}terminate(p){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${p}`),this._logService.flush(),this._disposables.dispose(),k.setUnexpectedErrorHandler(a=>{this._logService.error(a)}),this._rpcProtocol.dispose();const E=this._extensionService.deactivateAll();Promise.race([(0,o.timeout)(5e3),E]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code 0`):this._logService.info("Extension host exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})}static _transform(p,E){p.extensions.forEach(T=>T.extensionLocation=C.URI.revive(E.transformIncomingURIs(T.extensionLocation))),p.environment.appRoot=C.URI.revive(E.transformIncomingURIs(p.environment.appRoot));const a=p.environment.extensionDevelopmentLocationURI;return a&&(p.environment.extensionDevelopmentLocationURI=a.map(T=>C.URI.revive(E.transformIncomingURIs(T)))),p.environment.extensionTestsLocationURI=C.URI.revive(E.transformIncomingURIs(p.environment.extensionTestsLocationURI)),p.environment.globalStorageHome=C.URI.revive(E.transformIncomingURIs(p.environment.globalStorageHome)),p.environment.workspaceStorageHome=C.URI.revive(E.transformIncomingURIs(p.environment.workspaceStorageHome)),p.logsLocation=C.URI.revive(E.transformIncomingURIs(p.logsLocation)),p.logFile=C.URI.revive(E.transformIncomingURIs(p.logFile)),p.workspace=E.transformIncomingURIs(p.workspace),p}}e.ExtensionHostMain=y}),define(we[219],be([1,0,16,13,20,43,10,17,24,11,2,41]),function(Z,e,o,k,w,B,C,A,D,F,N,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class c{constructor(d,p,E,a){this.query=d,this.provider=p,this.fileUtils=E,this.processType=a,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(d,p){const E=this.query.folderQueries||[],a=new w.CancellationTokenSource;return p.onCancellationRequested(()=>a.cancel()),new Promise((T,r)=>{this.collector=new s(d);let i=!1;const u=(t,l)=>{if(!i&&!this.isLimitHit){const m=this.resultSize(t);h(t)&&typeof this.query.maxResults=="number"&&this.resultCount+m>this.query.maxResults&&(this.isLimitHit=!0,i=!0,a.cancel(),t=this.trimResultToSize(t,this.query.maxResults-this.resultCount));const f=this.resultSize(t);this.resultCount+=f,(f>0||!h(t))&&this.collector.add(t,l)}};Promise.all(E.map((t,l)=>this.searchInFolder(t,m=>u(m,l),a.token))).then(t=>{a.dispose(),this.collector.flush();const l=t.some(m=>!!m&&!!m.limitHit);T({limitHit:this.isLimitHit||l,messages:(0,o.flatten)(t.map(m=>m?.message?(0,F.isArray)(m.message)?m.message:[m.message]:[])),stats:{type:this.processType}})},t=>{a.dispose();const l=(0,B.toErrorMessage)(t);r(new Error(l))})})}resultSize(d){return h(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}trimResultToSize(d,p){const E=Array.isArray(d.ranges)?d.ranges:[d.ranges],a=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:E.slice(0,p),preview:{matches:a.slice(0,p),text:d.preview.text},uri:d.uri}}async searchInFolder(d,p,E){const a=new b.QueryGlobTester(this.query,d),T=[],r={report:t=>{if(!this.validateProviderResult(t))return;const l=d.folder.scheme===C.Schemas.file?(0,b.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(D.dirname(t.uri))):void 0,m=D.relativePath(d.folder,t.uri);if(m){const f=a.includedInQuery(m,A.basename(m),l);(0,k.isThenable)(f)?T.push(f.then(S=>{S&&p(t)})):f&&p(t)}}},i=this.getSearchOptionsForFolder(d),u=await this.provider.provideTextSearchResults(g(this.query.contentPattern),i,r,E);return T.length&&await Promise.all(T),u}validateProviderResult(d){if(h(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(d){const p=(0,b.resolvePatternsForProvider)(this.query.includePattern,d.includePattern),E=(0,b.resolvePatternsForProvider)(this.query.excludePattern,d.excludePattern),a={folder:N.URI.from(d.folder),excludes:E,includes:p,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.fileUtils.toCanonicalName(d.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return a.usePCRE2=this.query.usePCRE2,a}}e.TextSearchManager=c;function g(y){return{isCaseSensitive:y.isCaseSensitive||!1,isRegExp:y.isRegExp||!1,isWordMatch:y.isWordMatch||!1,isMultiline:y.isMultiline||!1,pattern:y.pattern}}class s{constructor(d){this._onResult=d,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new _(512,p=>this.sendItems(p))}add(d,p){this._currentFileMatch&&(this._currentFolderIdx!==p||!D.isEqual(this._currentUri,d.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=p,this._currentFileMatch={resource:d.uri,results:[]}),this._currentFileMatch.results.push(n(d))}pushToCollector(){const d=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,d)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(d){this._onResult(d)}}e.TextSearchResultsCollector=s;function n(y){return h(y)?{preview:{matches:(0,o.mapArrayOrNot)(y.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:y.preview.text},ranges:(0,o.mapArrayOrNot)(y.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:y.text,lineNumber:y.lineNumber}}function h(y){return!!y.preview}e.extensionResultIsMatch=h;class _{constructor(d,p){this.maxBatchSize=d,this.cb=p,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(d,p){!d||this.addItemToBatch(d,p)}addItems(d,p){!d||this.addItemsToBatch(d,p)}addItemToBatch(d,p){this.batch.push(d),this.batchSize+=p,this.onUpdate()}addItemsToBatch(d,p){this.batch=this.batch.concat(d),this.batchSize+=p,this.onUpdate()}onUpdate(){this.totalNumberCompleted<_.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},_.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=_,_.TIMEOUT=4e3,_.START_BATCH_AFTER_COUNT=50}),define(we[99],be([1,0,7,4,3,214,14,60,12,2,219]),function(Z,e,o,k,w,B,C,A,D,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,w.createDecorator)("IExtHostSearch");let b=class{constructor(n,h,_){this.extHostRpc=n,this._uriTransformer=h,this._logService=_,this._proxy=this.extHostRpc.getProxy(k.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new B.FileSearchManager}_transformScheme(n){return this._uriTransformer.transformOutgoingScheme(n)}registerTextSearchProvider(n,h){if(this._textSearchUsedSchemes.has(n))throw new Error(`a text search provider for the scheme '${n}' is already registered`);this._textSearchUsedSchemes.add(n);const _=this._handlePool++;return this._textSearchProvider.set(_,h),this._proxy.$registerTextSearchProvider(_,this._transformScheme(n)),(0,o.toDisposable)(()=>{this._textSearchUsedSchemes.delete(n),this._textSearchProvider.delete(_),this._proxy.$unregisterProvider(_)})}registerFileSearchProvider(n,h){if(this._fileSearchUsedSchemes.has(n))throw new Error(`a file search provider for the scheme '${n}' is already registered`);this._fileSearchUsedSchemes.add(n);const _=this._handlePool++;return this._fileSearchProvider.set(_,h),this._proxy.$registerFileSearchProvider(_,this._transformScheme(n)),(0,o.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(n),this._fileSearchProvider.delete(_),this._proxy.$unregisterProvider(_)})}$provideFileSearchResults(n,h,_,y){const d=c(_),p=this._fileSearchProvider.get(n);if(p)return this._fileSearchManager.fileSearch(d,p,E=>{this._proxy.$handleFileMatch(n,h,E.map(a=>a.resource))},y);throw new Error("unknown provider: "+n)}$clearCache(n){return this._fileSearchManager.clearCache(n),Promise.resolve(void 0)}$provideTextSearchResults(n,h,_,y){const d=this._textSearchProvider.get(n);if(!d||!d.provideTextSearchResults)throw new Error(`Unknown provider ${n}`);const p=c(_);return this.createTextSearchManager(p,d).search(a=>this._proxy.$handleTextMatch(n,h,a),y)}$enableExtensionHostSearch(){}createTextSearchManager(n,h){return new N.TextSearchManager(n,h,{readdir:_=>Promise.resolve([]),toCanonicalName:_=>_},"textSearchProvider")}};b=Fe([Ne(0,C.IExtHostRpcService),Ne(1,A.IURITransformerService),Ne(2,D.ILogService)],b),e.ExtHostSearch=b;function c(s){return{...s,folderQueries:s.folderQueries&&s.folderQueries.map(g),extraFileResources:s.extraFileResources&&s.extraFileResources.map(n=>F.URI.revive(n))}}e.reviveQuery=c;function g(s){return{...s,folder:F.URI.revive(s.folder)}}}),define(we[220],be([1,0,55,94,31,92,32,39,49,40,97,98,99,67,59,65,95,50,30,64,83,66,193,12,175]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_,y,d,p,E,a,T,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(T.ILoggerService,a.ExtHostLoggerService),(0,o.registerSingleton)(T.ILogService,r.ExtHostLogService),(0,o.registerSingleton)(n.IExtHostApiDeprecationService,n.ExtHostApiDeprecationService),(0,o.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands),(0,o.registerSingleton)(C.IExtHostConfiguration,C.ExtHostConfiguration),(0,o.registerSingleton)(_.IExtHostConsumerFileSystem,_.ExtHostConsumerFileSystem),(0,o.registerSingleton)(b.IExtHostDebugService,b.WorkerExtHostDebugService),(0,o.registerSingleton)(B.IExtHostDecorations,B.ExtHostDecorations),(0,o.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors),(0,o.registerSingleton)(y.IExtHostFileSystemInfo,y.ExtHostFileSystemInfo),(0,o.registerSingleton)(k.IExtHostOutputService,k.ExtHostOutputService),(0,o.registerSingleton)(c.IExtHostSearch,c.ExtHostSearch),(0,o.registerSingleton)(g.IExtHostStorage,g.ExtHostStorage),(0,o.registerSingleton)(N.IExtHostTask,N.WorkerExtHostTask),(0,o.registerSingleton)(F.IExtHostTerminalService,F.WorkerExtHostTerminalService),(0,o.registerSingleton)(s.IExtHostTunnelService,s.ExtHostTunnelService),(0,o.registerSingleton)(h.IExtHostWindow,h.ExtHostWindow),(0,o.registerSingleton)(w.IExtHostWorkspace,w.ExtHostWorkspace),(0,o.registerSingleton)(d.IExtHostSecretState,d.ExtHostSecretState),(0,o.registerSingleton)(p.IExtHostTelemetry,p.ExtHostTelemetry),(0,o.registerSingleton)(E.IExtHostEditorTabs,E.ExtHostEditorTabs)}),define(we[221],be([1,0]),function(Z,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class o{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(w){if(w&&this._dragOperations.has(w)){const B=this._dragOperations.get(w);return this._dragOperations.delete(w),B}}addDragOperationTransfer(w,B){this._dragOperations.set(w,B)}getRenderedTreeElement(w){if(this._renderedElements.has(w))return this._renderedElements.get(w)}addRenderedTreeItemElement(w,B){this._renderedElements.set(w,B)}removeRenderedTreeItemElement(w){this._renderedElements.has(w)&&this._renderedElements.delete(w)}}e.TreeviewsService=o}),define(we[222],be([1,0,127,24,2,5,7,13,6,11,16,8,20,155,221]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function n(y,d){if((0,F.isString)(y))return{label:y};if(y&&typeof y=="object"&&typeof y.label=="string"){let p;return Array.isArray(y.highlights)&&(p=y.highlights.filter(E=>E.length===2&&typeof E[0]=="number"&&typeof E[1]=="number"),p=p.length?p:void 0),{label:y.label,highlights:p}}}class h{constructor(d,p,E){this._proxy=d,this.commands=p,this.logService=E,this.treeViews=new Map,this.treeDragAndDropService=new s.TreeviewsService;function a(T){return T&&T.$treeViewId&&T.$treeItemHandle}p.registerArgumentProcessor({processArgument:T=>a(T)?this.convertArgument(T):Array.isArray(T)&&T.length>0?T.map(r=>a(r)?this.convertArgument(r):r):T})}registerTreeDataProvider(d,p,E){const a=this.createTreeView(d,{treeDataProvider:p},E);return{dispose:()=>a.dispose()}}createTreeView(d,p,E){if(!p||!p.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=p.dragAndDropController?.dropMimeTypes??[],T=p.dragAndDropController?.dragMimeTypes??[],r=!!p.dragAndDropController?.handleDrag,i=!!p.dragAndDropController?.handleDrop,u=this._proxy.$registerTreeViewDataProvider(d,{showCollapseAll:!!p.showCollapseAll,canSelectMany:!!p.canSelectMany,dropMimeTypes:a,dragMimeTypes:T,hasHandleDrag:r,hasHandleDrop:i}),t=this.createExtHostTreeView(d,p,E);return{get onDidCollapseElement(){return t.onDidCollapseElement},get onDidExpandElement(){return t.onDidExpandElement},get selection(){return t.selectedElements},get onDidChangeSelection(){return t.onDidChangeSelection},get visible(){return t.visible},get onDidChangeVisibility(){return t.onDidChangeVisibility},get message(){return t.message},set message(l){t.message=l},get title(){return t.title},set title(l){t.title=l},get description(){return t.description},set description(l){t.description=l},reveal:(l,m)=>t.reveal(l,m),dispose:async()=>{await u,this.treeViews.delete(d),t.dispose()}}}$getChildren(d,p){const E=this.treeViews.get(d);return E?E.getChildren(p):Promise.reject(new Error((0,o.localize)(0,null,d)))}async $handleDrop(d,p,E,a,T,r,i){const u=this.treeViews.get(d);if(!u)return Promise.reject(new Error((0,o.localize)(1,null,d)));const t=g.TreeDataTransferConverter.toITreeDataTransfer(p);return r===d&&i&&await this.addAdditionalTransferItems(t,u,i,a,T),u.onDrop(t,E,a)}async addAdditionalTransferItems(d,p,E,a,T){const r=this.treeDragAndDropService.removeDragOperationTransfer(T);if(r)(await r)?.forEach((i,u)=>{i&&d.set(u,i)});else if(T&&p.handleDrag){const i=p.handleDrag(E,d,a);this.treeDragAndDropService.addDragOperationTransfer(T,i),await i}return d}async $handleDrag(d,p,E,a){const T=this.treeViews.get(d);if(!T)return Promise.reject(new Error((0,o.localize)(2,null,d)));const r=await this.addAdditionalTransferItems(new Map,T,p,a,E);if(!!r)return g.TreeDataTransferConverter.toTreeDataTransferDTO(r)}async $hasResolve(d){const p=this.treeViews.get(d);if(!p)throw new Error((0,o.localize)(3,null,d));return p.hasResolve}$resolve(d,p,E){const a=this.treeViews.get(d);if(!a)throw new Error((0,o.localize)(4,null,d));return a.resolveTreeItem(p,E)}$setExpanded(d,p,E){const a=this.treeViews.get(d);if(!a)throw new Error((0,o.localize)(5,null,d));a.setExpanded(p,E)}$setSelection(d,p){const E=this.treeViews.get(d);if(!E)throw new Error((0,o.localize)(6,null,d));E.setSelection(p)}$setVisible(d,p){const E=this.treeViews.get(d);if(!E)throw new Error((0,o.localize)(7,null,d));E.setVisible(p)}createExtHostTreeView(d,p,E){const a=new _(d,p,this._proxy,this.commands.converter,this.logService,E);return this.treeViews.set(d,a),a}convertArgument(d){const p=this.treeViews.get(d.$treeViewId);return p?p.getExtensionElement(d.$treeItemHandle):null}}e.ExtHostTreeViews=h;class _ extends C.Disposable{constructor(d,p,E,a,T,r){super();if(this.viewId=d,this.proxy=E,this.commands=a,this.logService=T,this.extension=r,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new B.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new B.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new B.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new B.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new B.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new c.CancellationTokenSource,r.contributes&&r.contributes.views)for(const t in r.contributes.views)for(const l of r.contributes.views[t])l.id===d&&(this._title=l.name);this.dataProvider=p.treeDataProvider,this.dndController=p.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(t=>this._onDidChangeData.fire({message:!1,element:t})));let i,u;this._register(B.Event.debounce(this._onDidChangeData.event,(t,l)=>(t||(t={message:!1,elements:[]}),l.element!==!1&&(i||(i=new Promise(m=>u=m),this.refreshPromise=this.refreshPromise.then(()=>i)),Array.isArray(l.element)?t.elements.push(...l.element):t.elements.push(l.element)),l.message&&(t.message=!0),t),200,!0)(({message:t,elements:l})=>{l.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const m=u;return i=null,this.refresh(l).then(()=>m())})),t&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(d=>this.getExtensionElement(d)).filter(d=>!(0,F.isUndefinedOrNull)(d))}async getChildren(d){const p=d?this.getExtensionElement(d):void 0;if(d&&!p)return this.logService.error(`No tree item with id '${d}' found.`),Promise.resolve([]);let E=this.getChildrenNodes(d);return E||(E=await this.fetchChildrenNodes(p)),E?E.map(a=>a.item):void 0}getExtensionElement(d){return this.elements.get(d)}reveal(d,p){p=p||{select:!0,focus:!1};const E=(0,F.isUndefinedOrNull)(p.select)?!0:p.select,a=(0,F.isUndefinedOrNull)(p.focus)?!1:p.focus,T=(0,F.isUndefinedOrNull)(p.expand)?!1:p.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):d?this.refreshPromise.then(()=>this.resolveUnknownParentChain(d)).then(r=>this.resolveTreeNode(d,r[r.length-1]).then(i=>this.proxy.$reveal(this.viewId,{item:i.item,parentChain:r.map(u=>u.item)},{select:E,focus:a,expand:T})),r=>this.logService.error(r)):this.proxy.$reveal(this.viewId,void 0,{select:E,focus:a,expand:T})}get message(){return this._message}set message(d){this._message=d,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(d){this._title=d,this.proxy.$setTitle(this.viewId,d,this._description)}get description(){return this._description}set description(d){this._description=d,this.proxy.$setTitle(this.viewId,this._title,d)}setExpanded(d,p){const E=this.getExtensionElement(d);E&&(p?this._onDidExpandElement.fire(Object.freeze({element:E})):this._onDidCollapseElement.fire(Object.freeze({element:E})))}setSelection(d){(0,N.equals)(this._selectedHandles,d)||(this._selectedHandles=d,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(d){d!==this._visible&&(this._visible=d,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(d,p,E){const a=[];for(const T of d){const r=this.getExtensionElement(T);r&&a.push(r)}if(!(!this.dndController?.handleDrag||a.length===0))return await this.dndController.handleDrag(a,p,E),p}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(d,p,E){const a=this.getExtensionElement(p);if(!(!a||!this.dndController?.handleDrop))return(0,A.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(a,d,E):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(d,p){if(!this.dataProvider.resolveTreeItem)return;const E=this.elements.get(d);if(E){const a=this.nodes.get(E);if(a){const T=await this.dataProvider.resolveTreeItem(a.extensionItem,E,p)??a.extensionItem;return a.item.tooltip=this.getTooltip(T.tooltip),a.item.command=this.getCommand(a.disposableStore,T.command),a.item}}}resolveUnknownParentChain(d){return this.resolveParent(d).then(p=>p?this.resolveUnknownParentChain(p).then(E=>this.resolveTreeNode(p,E[E.length-1]).then(a=>(E.push(a),E))):Promise.resolve([]))}resolveParent(d){const p=this.nodes.get(d);return p?Promise.resolve(p.parent?this.elements.get(p.parent.item.handle):void 0):(0,A.asPromise)(()=>this.dataProvider.getParent(d))}resolveTreeNode(d,p){const E=this.nodes.get(d);return E?Promise.resolve(E):(0,A.asPromise)(()=>this.dataProvider.getTreeItem(d)).then(a=>this.createHandle(d,a,p,!0)).then(a=>this.getChildren(p?p.item.handle:void 0).then(()=>{const T=this.getExtensionElement(a);if(T){const r=this.nodes.get(T);if(r)return Promise.resolve(r)}throw new Error(`Cannot resolve tree item for element ${a}`)}))}getChildrenNodes(d){if(d){let p;if(typeof d=="string"){const E=this.getExtensionElement(d);p=E?this.nodes.get(E):void 0}else p=d;return p&&p.children||void 0}return this.roots}async fetchChildrenNodes(d){this.clearChildren(d);const p=new c.CancellationTokenSource(this._refreshCancellationSource.token);try{const E=d?this.nodes.get(d):void 0,a=await this.dataProvider.getChildren(d);if(p.token.isCancellationRequested)return;const T=await Promise.all((0,N.coalesce)(a||[]).map(async r=>{const i=await this.dataProvider.getTreeItem(r);return i&&!p.token.isCancellationRequested?this.createAndRegisterTreeNode(r,i,E):null}));return p.token.isCancellationRequested?void 0:(0,N.coalesce)(T)}finally{p.dispose()}}refresh(d){if(d.some(E=>!E))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new c.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const E=this.getHandlesToRefresh(d);if(E.length)return this.refreshHandles(E)}return Promise.resolve(void 0)}getHandlesToRefresh(d){const p=new Set,E=d.map(T=>this.nodes.get(T));for(const T of E)if(T&&!p.has(T.item.handle)){let r=T;for(;r&&r.parent&&E.findIndex(i=>r&&r.parent&&i&&i.item.handle===r.parent.item.handle)===-1;){const i=this.elements.get(r.parent.item.handle);r=i?this.nodes.get(i):void 0}r&&!r.parent&&p.add(T.item.handle)}const a=[];return p.forEach(T=>{const r=this.elements.get(T);if(r){const i=this.nodes.get(r);i&&(!i.parent||!p.has(i.parent.item.handle))&&a.push(T)}}),a}refreshHandles(d){const p={};return Promise.all(d.map(E=>this.refreshNode(E).then(a=>{a&&(p[E]=a.item)}))).then(()=>Object.keys(p).length?this.proxy.$refresh(this.viewId,p):void 0)}refreshNode(d){const p=this.getExtensionElement(d);if(p){const E=this.nodes.get(p);if(E)return this.clearChildren(p),(0,A.asPromise)(()=>this.dataProvider.getTreeItem(p)).then(a=>{if(a){const T=this.createTreeNode(p,a,E.parent);return this.updateNodeCache(p,T,E,E.parent),E.dispose(),T}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(d,p,E){const a=this.createTreeNode(d,p,E);if(p.id&&this.elements.has(a.item.handle))throw new Error((0,o.localize)(8,null,p.id));return this.addNodeToCache(d,a),this.addNodeToParentCache(a,E),a}getTooltip(d){return D.MarkdownString.isMarkdownString(d)?b.MarkdownString.from(d):d}getCommand(d,p){return p?this.commands.toInternal(p,d):void 0}createTreeNode(d,p,E){const a=new C.DisposableStore,T=this.createHandle(d,p,E),r=this.getLightIconPath(p);return{item:{handle:T,parentHandle:E?E.item.handle:void 0,label:n(p.label,this.extension),description:p.description,resourceUri:p.resourceUri,tooltip:this.getTooltip(p.tooltip),command:this.getCommand(a,p.command),contextValue:p.contextValue,icon:r,iconDark:this.getDarkIconPath(p)||r,themeIcon:this.getThemeIcon(p),collapsibleState:(0,F.isUndefinedOrNull)(p.collapsibleState)?D.TreeItemCollapsibleState.None:p.collapsibleState,accessibilityInformation:p.accessibilityInformation},extensionItem:p,parent:E,children:void 0,disposableStore:a,dispose(){a.dispose()}}}getThemeIcon(d){return d.iconPath instanceof D.ThemeIcon?d.iconPath:void 0}createHandle(d,{id:p,label:E,resourceUri:a},T,r){if(p)return`${_.ID_HANDLE_PREFIX}/${p}`;const i=n(E,this.extension),u=T?T.item.handle:_.LABEL_HANDLE_PREFIX;let t=i?i.label:a?(0,k.basename)(a):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const l=this.nodes.has(d)?this.nodes.get(d).item.handle:void 0,m=this.getChildrenNodes(T)||[];let f,S=0;do{if(f=`${u}/${S}:${t}`,r||!this.elements.has(f)||l===f)break;S++}while(S<=m.length);return f}getLightIconPath(d){if(d.iconPath&&!(d.iconPath instanceof D.ThemeIcon))return typeof d.iconPath=="string"||w.URI.isUri(d.iconPath)?this.getIconPath(d.iconPath):this.getIconPath(d.iconPath.light)}getDarkIconPath(d){if(d.iconPath&&!(d.iconPath instanceof D.ThemeIcon)&&d.iconPath.dark)return this.getIconPath(d.iconPath.dark)}getIconPath(d){return w.URI.isUri(d)?d:w.URI.file(d)}addNodeToCache(d,p){this.elements.set(p.item.handle,d),this.nodes.set(d,p)}updateNodeCache(d,p,E,a){this.elements.delete(p.item.handle),this.nodes.delete(d),p.item.handle!==E.item.handle&&this.elements.delete(E.item.handle),this.addNodeToCache(d,p);const T=this.getChildrenNodes(a)||[],r=T.filter(i=>i.item.handle===E.item.handle)[0];r&&T.splice(T.indexOf(r),1,p)}addNodeToParentCache(d,p){p?(p.children||(p.children=[]),p.children.push(d)):(this.roots||(this.roots=[]),this.roots.push(d))}clearChildren(d){if(d){const p=this.nodes.get(d);if(p){if(p.children)for(const E of p.children){const a=this.elements.get(E.item.handle);a&&this.clear(a)}p.children=void 0}}else this.clearAll()}clear(d){const p=this.nodes.get(d);if(p){if(p.children)for(const E of p.children){const a=this.elements.get(E.item.handle);a&&this.clear(a)}this.nodes.delete(d),this.elements.delete(p.item.handle),p.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(d=>d.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}_.LABEL_HANDLE_PREFIX="0",_.ID_HANDLE_PREFIX="1"}),define(we[223],be([1,0,20,15,5,34,2,115,235,110,74,45,4,91,180,179,39,181,32,182,183,184,168,185,49,33,186,187,190,192,194,94,170,199,200,201,67,40,203,222,8,6,206,51,95,31,70,157,189,82,92,97,98,99,12,60,14,27,195,153,59,65,177,204,152,68,50,209,207,208,178,30,202,205,64,66,83,197,96,198,10,79,196,150,188,7,28,159]),function(Z,e,o,k,w,B,C,A,D,F,N,b,c,g,s,n,h,_,y,d,p,E,a,T,r,i,u,t,l,m,f,S,P,$,L,v,H,W,q,K,V,z,ae,de,Y,ie,ce,he,ue,se,ge,Te,Re,He,Xe,ve,fe,M,O,I,R,x,Q,ne,Ee,Ie,Me,Le,ze,Be,Ae,Qe,tt,ke,it,X,J,le,Oe,$e,Ge,Je,ht,It,St,kt,qe,vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Nt(nt){const ut=nt.get(M.IExtHostInitDataService),At=nt.get(Qe.IExtHostFileSystemInfo),Tt=nt.get(Me.IExtHostConsumerFileSystem),bt=nt.get(i.IExtHostExtensionService),dt=nt.get(ie.IExtHostWorkspace),Rt=nt.get(J.IExtHostTelemetry),Lt=nt.get(y.IExtHostConfiguration),Ft=nt.get(ve.IURITransformerService),Ue=nt.get(fe.IExtHostRpcService),me=nt.get(H.IExtHostStorage),pe=nt.get(Ie.IExtensionStoragePaths),oe=nt.get(Xe.ILoggerService),G=nt.get(Xe.ILogService),Se=nt.get(R.IExtHostTunnelService),Ce=nt.get(x.IExtHostApiDeprecationService),xe=nt.get(Y.IExtHostWindow),je=nt.get(it.IExtHostSecretState),lt=nt.get(X.IExtHostEditorTabs);Ue.set(c.ExtHostContext.ExtHostFileSystemInfo,At),Ue.set(c.ExtHostContext.ExtHostLogLevelServiceShape,oe),Ue.set(c.ExtHostContext.ExtHostWorkspace,dt),Ue.set(c.ExtHostContext.ExtHostConfiguration,Lt),Ue.set(c.ExtHostContext.ExtHostExtensionService,bt),Ue.set(c.ExtHostContext.ExtHostStorage,me),Ue.set(c.ExtHostContext.ExtHostTunnelService,Se),Ue.set(c.ExtHostContext.ExtHostWindow,xe),Ue.set(c.ExtHostContext.ExtHostSecretState,je),Ue.set(c.ExtHostContext.ExtHostTelemetry,Rt),Ue.set(c.ExtHostContext.ExtHostEditorTabs,lt);const gt=Ue.set(c.ExtHostContext.ExtHostDecorations,nt.get(ge.IExtHostDecorations)),Et=Ue.set(c.ExtHostContext.ExtHostDocumentsAndEditors,nt.get(r.IExtHostDocumentsAndEditors)),rt=Ue.set(c.ExtHostContext.ExtHostCommands,nt.get(h.IExtHostCommands)),at=Ue.set(c.ExtHostContext.ExtHostTerminalService,nt.get(W.IExtHostTerminalService)),ot=Ue.set(c.ExtHostContext.ExtHostDebugService,nt.get(Re.IExtHostDebugService)),Mt=Ue.set(c.ExtHostContext.ExtHostSearch,nt.get(He.IExtHostSearch)),ft=Ue.set(c.ExtHostContext.ExtHostTask,nt.get(Te.IExtHostTask)),Dt=Ue.set(c.ExtHostContext.ExtHostOutputService,nt.get(S.IExtHostOutputService)),Ut=Ue.set(c.ExtHostContext.ExtHostUrls,new ae.ExtHostUrls(Ue)),wt=Ue.set(c.ExtHostContext.ExtHostDocuments,new T.ExtHostDocuments(Ue,Et)),Bt=Ue.set(c.ExtHostContext.ExtHostDocumentContentProviders,new E.ExtHostDocumentContentProvider(Ue,Et,G)),Wt=Ue.set(c.ExtHostContext.ExtHostDocumentSaveParticipant,new a.ExtHostDocumentSaveParticipant(G,wt,Ue.getProxy(c.MainContext.MainThreadBulkEdits))),pt=Ue.set(c.ExtHostContext.ExtHostNotebook,new O.ExtHostNotebookController(Ue,rt,Et,wt,pe)),qt=Ue.set(c.ExtHostContext.ExtHostNotebookDocuments,new It.ExtHostNotebookDocuments(G,pt)),Qt=Ue.set(c.ExtHostContext.ExtHostNotebookEditors,new ht.ExtHostNotebookEditors(G,Ue,pt)),ti=Ue.set(c.ExtHostContext.ExtHostNotebookKernels,new le.ExtHostNotebookKernels(Ue,ut,pt,rt,G)),ai=Ue.set(c.ExtHostContext.ExtHostNotebookRenderers,new $e.ExtHostNotebookRenderers(Ue,pt)),Ct=Ue.set(c.ExtHostContext.ExtHostEditors,new q.ExtHostEditors(Ue,Et)),ii=Ue.set(c.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(Ue.getProxy(c.MainContext.MainThreadTreeViews),rt,G)),bi=Ue.set(c.ExtHostContext.ExtHostEditorInsets,new he.ExtHostEditorInsets(Ue.getProxy(c.MainContext.MainThreadEditorInsets),Ct,ut)),Kt=Ue.set(c.ExtHostContext.ExtHostDiagnostics,new d.ExtHostDiagnostics(Ue,G,At)),Gt=Ue.set(c.ExtHostContext.ExtHostLanguages,new m.ExtHostLanguages(Ue,wt,rt.converter,Ft)),st=Ue.set(c.ExtHostContext.ExtHostLanguageFeatures,new l.ExtHostLanguageFeatures(Ue,Ft,wt,rt,Kt,G,Ce)),li=Ue.set(c.ExtHostContext.ExtHostFileSystem,new u.ExtHostFileSystem(Ue,st)),Ht=Ue.set(c.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ue,G,Et)),zt=Ue.set(c.ExtHostContext.ExtHostQuickOpen,(0,$.createExtHostQuickOpen)(Ue,dt,rt)),ni=Ue.set(c.ExtHostContext.ExtHostSCM,new L.ExtHostSCM(Ue,rt,G)),_i=Ue.set(c.ExtHostContext.ExtHostComments,(0,_.createExtHostComments)(Ue,rt,wt)),fi=Ue.set(c.ExtHostContext.ExtHostProgress,new P.ExtHostProgress(Ue.getProxy(c.MainContext.MainThreadProgress))),Si=Ue.set(c.ExtHostContext.ExtHosLabelService,new ue.ExtHostLabelService(Ue)),mi=Ue.set(c.ExtHostContext.ExtHostTheming,new I.ExtHostTheming(Ue)),ri=Ue.set(c.ExtHostContext.ExtHostAuthentication,new Q.ExtHostAuthentication(Ue)),yi=Ue.set(c.ExtHostContext.ExtHostTimeline,new ne.ExtHostTimeline(Ue,rt)),Yt=Ue.set(c.ExtHostContext.ExtHostWebviews,new de.ExtHostWebviews(Ue,{remote:ut.remote},dt,G,Ce)),Jt=Ue.set(c.ExtHostContext.ExtHostWebviewPanels,new Be.ExtHostWebviewPanels(Ue,Yt,dt)),Di=Ue.set(c.ExtHostContext.ExtHostCustomEditors,new ze.ExtHostCustomEditors(Ue,wt,pe,Yt,Jt)),Ci=Ue.set(c.ExtHostContext.ExtHostWebviewViews,new Le.ExtHostWebviewViews(Ue,Yt)),Zt=Ue.set(c.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(Ue,rt)),si=Ue.set(c.ExtHostContext.ExtHostUriOpeners,new ke.ExtHostUriOpeners(Ue));Ue.set(c.ExtHostContext.ExtHostInteractive,new St.ExtHostInteractive(Ue,pt,Et,rt));const Ii=(0,ce.values)(c.ExtHostContext);Ue.assertRegistered(Ii);const ki=new Ae.ExtHostBulkEdits(Ue,Et),Ti=new n.ExtHostClipboard(Ue),ei=new f.ExtHostMessageService(Ue,G),gi=new p.ExtHostDialogs(Ue),Xt=new v.ExtHostStatusBar(Ue,rt.converter);return s.ExtHostApiCommands.register(rt),function(Pe,ci,Ot){const ct=function(){let ee=!Pe.isUnderDevelopment;function re(){ee||(G.info(`Extension '${Pe.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),ee=!0)}return function ye(Ze){if(Array.isArray(Ze))Ze.forEach(ye);else if(typeof Ze=="string")re();else{const mt=Ze;typeof mt.scheme=="undefined"&&re(),typeof mt.exclusive=="boolean"&&(0,qe.checkProposedApiEnabled)(Pe,"documentFiltersExclusive")}return Ze}}(),Pi={getSession(ee,re,ye){return ri.getSession(Pe,ee,re,ye)},async hasSession(ee,re){return(0,qe.checkProposedApiEnabled)(Pe,"authSession"),!!await ri.getSession(Pe,ee,re,{silent:!0})},get onDidChangeSessions(){return ri.onDidChangeSessions},registerAuthenticationProvider(ee,re,ye,Ze){return ri.registerAuthenticationProvider(ee,re,ye,Ze)}},Ai={registerCommand(ee,re,ye){return rt.registerCommand(!0,ee,re,ye,void 0,Pe)},registerTextEditorCommand(ee,re,ye){return rt.registerCommand(!0,ee,(...Ze)=>{const mt=Ct.getActiveTextEditor();if(!mt){G.warn("Cannot execute "+ee+" because there is no active text editor.");return}return mt.edit(yt=>{re.apply(ye,[mt,yt,...Ze])}).then(yt=>{yt||G.warn("Edits from command "+ee+" were not applied.")},yt=>{G.warn("An error occurred while running command "+ee,yt)})},void 0,void 0,Pe)},registerDiffInformationCommand:(ee,re,ye)=>((0,qe.checkProposedApiEnabled)(Pe,"diffCommand"),rt.registerCommand(!0,ee,async(...Ze)=>{const mt=Et.activeEditor(!0);if(!mt){G.warn("Cannot execute "+ee+" because there is no active text editor.");return}const yt=await Ct.getDiffInformation(mt.id);re.apply(ye,[yt,...Ze])},void 0,void 0,Pe)),executeCommand(ee,...re){return rt.executeCommand(ee,...re)},getCommands(ee=!1){return rt.getCommands(ee)}},pi={get machineId(){return ut.telemetryInfo.machineId},get sessionId(){return ut.telemetryInfo.sessionId},get language(){return ut.environment.appLanguage},get appName(){return ut.environment.appName},get appRoot(){return ut.environment.appRoot?.fsPath??""},get appHost(){return ut.environment.appHost},get uriScheme(){return ut.environment.appUriScheme},get clipboard(){return Ti.value},get shell(){return at.getDefaultShell(!1)},get isTelemetryEnabled(){return Rt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Rt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Pe,"telemetry"),Rt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,qe.checkProposedApiEnabled)(Pe,"telemetry"),Rt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const ee=Date.now()-new Date(ut.telemetryInfo.firstSessionDate).getTime();return isNaN(ee)?!1:ee<1e3*60*60*24},openExternal(ee,re){return xe.openUri(ee,{allowTunneling:!!ut.remote.authority,allowContributedOpeners:re?.allowContributedOpeners})},async asExternalUri(ee){if(ee.scheme===ut.environment.appUriScheme)return Ut.createAppUri(ee);try{return await xe.asExternalUri(ee,{allowTunneling:!!ut.remote.authority})}catch(re){if((0,Je.matchesScheme)(ee,Ge.Schemas.http)||(0,Je.matchesScheme)(ee,Ge.Schemas.https))return ee;throw re}},get remoteName(){return(0,se.getRemoteName)(ut.remote.authority)},get remoteAuthority(){return(0,qe.checkProposedApiEnabled)(Pe,"resolvers"),ut.remote.authority},get uiKind(){return ut.uiKind}};ut.environment.extensionTestsLocationURI||Object.freeze(pi);const vi=ut.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,Ri={createTestController(ee,re,ye){return Zt.createTestController(ee,re,ye)},createTestObserver(){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Zt.createTestObserver()},runTests(ee){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Zt.runTests(ee)},get onDidChangeTestResults(){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Zt.onResultsChanged},get testResults(){return(0,qe.checkProposedApiEnabled)(Pe,"testObserver"),Zt.results}},Oi={getExtension(ee){const re=ci.getExtensionDescription(ee);if(re)return new i.Extension(bt,Pe.identifier,re,vi)},get all(){return ci.getAllExtensionDescriptions().map(ee=>new i.Extension(bt,Pe.identifier,ee,vi))},get onDidChange(){return ci.onDidChange}},Fi={createDiagnosticCollection(ee){return Kt.createDiagnosticCollection(Pe.identifier,ee)},get onDidChangeDiagnostics(){return Kt.onDidChangeDiagnostics},getDiagnostics:ee=>Kt.getDiagnostics(ee),getLanguages(){return Gt.getLanguages()},setTextDocumentLanguage(ee,re){return Gt.changeLanguage(ee.uri,re)},match(ee,re){return(0,N.score)(V.LanguageSelector.from(ee),re.uri,re.languageId,!0,re.notebook?.notebookType)},registerCodeActionsProvider(ee,re,ye){return st.registerCodeActionProvider(Pe,ct(ee),re,ye)},registerCodeLensProvider(ee,re){return st.registerCodeLensProvider(Pe,ct(ee),re)},registerDefinitionProvider(ee,re){return st.registerDefinitionProvider(Pe,ct(ee),re)},registerDeclarationProvider(ee,re){return st.registerDeclarationProvider(Pe,ct(ee),re)},registerImplementationProvider(ee,re){return st.registerImplementationProvider(Pe,ct(ee),re)},registerTypeDefinitionProvider(ee,re){return st.registerTypeDefinitionProvider(Pe,ct(ee),re)},registerHoverProvider(ee,re){return st.registerHoverProvider(Pe,ct(ee),re,Pe.identifier)},registerEvaluatableExpressionProvider(ee,re){return st.registerEvaluatableExpressionProvider(Pe,ct(ee),re,Pe.identifier)},registerInlineValuesProvider(ee,re){return st.registerInlineValuesProvider(Pe,ct(ee),re,Pe.identifier)},registerDocumentHighlightProvider(ee,re){return st.registerDocumentHighlightProvider(Pe,ct(ee),re)},registerLinkedEditingRangeProvider(ee,re){return st.registerLinkedEditingRangeProvider(Pe,ct(ee),re)},registerReferenceProvider(ee,re){return st.registerReferenceProvider(Pe,ct(ee),re)},registerRenameProvider(ee,re){return st.registerRenameProvider(Pe,ct(ee),re)},registerDocumentSymbolProvider(ee,re,ye){return st.registerDocumentSymbolProvider(Pe,ct(ee),re,ye)},registerWorkspaceSymbolProvider(ee){return st.registerWorkspaceSymbolProvider(Pe,ee)},registerDocumentFormattingEditProvider(ee,re){return st.registerDocumentFormattingEditProvider(Pe,ct(ee),re)},registerDocumentRangeFormattingEditProvider(ee,re){return st.registerDocumentRangeFormattingEditProvider(Pe,ct(ee),re)},registerOnTypeFormattingEditProvider(ee,re,ye,...Ze){return st.registerOnTypeFormattingEditProvider(Pe,ct(ee),re,[ye].concat(Ze))},registerDocumentSemanticTokensProvider(ee,re,ye){return st.registerDocumentSemanticTokensProvider(Pe,ct(ee),re,ye)},registerDocumentRangeSemanticTokensProvider(ee,re,ye){return st.registerDocumentRangeSemanticTokensProvider(Pe,ct(ee),re,ye)},registerSignatureHelpProvider(ee,re,ye,...Ze){return typeof ye=="object"?st.registerSignatureHelpProvider(Pe,ct(ee),re,ye):st.registerSignatureHelpProvider(Pe,ct(ee),re,typeof ye=="undefined"?[]:[ye,...Ze])},registerCompletionItemProvider(ee,re,...ye){return st.registerCompletionItemProvider(Pe,ct(ee),re,ye)},registerInlineCompletionItemProvider(ee,re){return(0,qe.checkProposedApiEnabled)(Pe,"inlineCompletions"),st.registerInlineCompletionsProvider(Pe,ct(ee),re)},registerDocumentLinkProvider(ee,re){return st.registerDocumentLinkProvider(Pe,ct(ee),re)},registerColorProvider(ee,re){return st.registerColorProvider(Pe,ct(ee),re)},registerFoldingRangeProvider(ee,re){return st.registerFoldingRangeProvider(Pe,ct(ee),re)},registerSelectionRangeProvider(ee,re){return st.registerSelectionRangeProvider(Pe,ee,re)},registerCallHierarchyProvider(ee,re){return st.registerCallHierarchyProvider(Pe,ee,re)},registerTypeHierarchyProvider(ee,re){return st.registerTypeHierarchyProvider(Pe,ee,re)},setLanguageConfiguration:(ee,re)=>st.setLanguageConfiguration(Pe,ee,re),getTokenInformationAtPosition(ee,re){return(0,qe.checkProposedApiEnabled)(Pe,"tokenInformation"),Gt.tokenAtPosition(ee,re)},registerInlayHintsProvider(ee,re){return st.registerInlayHintsProvider(Pe,ee,re)},createLanguageStatusItem(ee,re){return Gt.createLanguageStatusItem(Pe,ee,re)}},ui={get activeTextEditor(){return Ct.getActiveTextEditor()},get visibleTextEditors(){return Ct.getVisibleTextEditors()},get activeTerminal(){return at.activeTerminal},get terminals(){return at.terminals},async showTextDocument(ee,re,ye){const Ze=await(C.URI.isUri(ee)?Promise.resolve(Ei.openTextDocument(ee)):Promise.resolve(ee));return Ct.showTextDocument(Ze,re,ye)},createTextEditorDecorationType(ee){return Ct.createTextEditorDecorationType(Pe,ee)},onDidChangeActiveTextEditor(ee,re,ye){return Ct.onDidChangeActiveTextEditor(ee,re,ye)},onDidChangeVisibleTextEditors(ee,re,ye){return Ct.onDidChangeVisibleTextEditors(ee,re,ye)},onDidChangeTextEditorSelection(ee,re,ye){return Ct.onDidChangeTextEditorSelection(ee,re,ye)},onDidChangeTextEditorOptions(ee,re,ye){return Ct.onDidChangeTextEditorOptions(ee,re,ye)},onDidChangeTextEditorVisibleRanges(ee,re,ye){return Ct.onDidChangeTextEditorVisibleRanges(ee,re,ye)},onDidChangeTextEditorViewColumn(ee,re,ye){return Ct.onDidChangeTextEditorViewColumn(ee,re,ye)},onDidCloseTerminal(ee,re,ye){return at.onDidCloseTerminal(ee,re,ye)},onDidOpenTerminal(ee,re,ye){return at.onDidOpenTerminal(ee,re,ye)},onDidChangeActiveTerminal(ee,re,ye){return at.onDidChangeActiveTerminal(ee,re,ye)},onDidChangeTerminalDimensions(ee,re,ye){return(0,qe.checkProposedApiEnabled)(Pe,"terminalDimensions"),at.onDidChangeTerminalDimensions(ee,re,ye)},onDidChangeTerminalState(ee,re,ye){return at.onDidChangeTerminalState(ee,re,ye)},onDidWriteTerminalData(ee,re,ye){return(0,qe.checkProposedApiEnabled)(Pe,"terminalDataWriteEvent"),at.onDidWriteTerminalData(ee,re,ye)},get state(){return xe.state},onDidChangeWindowState(ee,re,ye){return xe.onDidChangeWindowState(ee,re,ye)},showInformationMessage(ee,...re){return ei.showMessage(Pe,B.default.Info,ee,re[0],re.slice(1))},showWarningMessage(ee,...re){return ei.showMessage(Pe,B.default.Warning,ee,re[0],re.slice(1))},showErrorMessage(ee,...re){return ei.showMessage(Pe,B.default.Error,ee,re[0],re.slice(1))},showQuickPick(ee,re,ye){return zt.showQuickPick(ee,re,ye)},showWorkspaceFolderPick(ee){return zt.showWorkspaceFolderPick(ee)},showInputBox(ee,re){return zt.showInput(ee,re)},showOpenDialog(ee){return gi.showOpenDialog(ee)},showSaveDialog(ee){return gi.showSaveDialog(ee)},createStatusBarItem(ee,re,ye){let Ze,mt,yt;return typeof ee=="string"?(Ze=ee,mt=re,yt=ye):(mt=ee,yt=re),Xt.createStatusBarEntry(Pe,Ze,mt,yt)},setStatusBarMessage(ee,re){return Xt.setStatusBarMessage(ee,re)},withScmProgress(ee){return Ce.report("window.withScmProgress",Pe,"Use 'withProgress' instead."),fi.withProgress(Pe,{location:z.ProgressLocation.SourceControl},(re,ye)=>ee({report(Ze){}}))},withProgress(ee,re){return fi.withProgress(Pe,ee,re)},createOutputChannel(ee,re){return Dt.createOutputChannel(ee,re,Pe)},createWebviewPanel(ee,re,ye,Ze){return Jt.createWebviewPanel(Pe,ee,re,ye,Ze)},createWebviewTextEditorInset(ee,re,ye,Ze){return(0,qe.checkProposedApiEnabled)(Pe,"editorInsets"),bi.createWebviewEditorInset(ee,re,ye,Ze,Pe)},createTerminal(ee,re,ye){return typeof ee=="object"?"pty"in ee?at.createExtensionTerminal(ee):at.createTerminalFromOptions(ee):at.createTerminal(ee,re,ye)},registerTerminalLinkProvider(ee){return at.registerLinkProvider(ee)},registerTerminalProfileProvider(ee,re){return at.registerProfileProvider(Pe,ee,re)},registerTreeDataProvider(ee,re){return ii.registerTreeDataProvider(ee,re,Pe)},createTreeView(ee,re){return ii.createTreeView(ee,re,Pe)},registerWebviewPanelSerializer:(ee,re)=>Jt.registerWebviewPanelSerializer(Pe,ee,re),registerCustomEditorProvider:(ee,re,ye={})=>Di.registerCustomEditorProvider(Pe,ee,re,ye),registerFileDecorationProvider(ee){return gt.registerFileDecorationProvider(ee,Pe.identifier)},registerUriHandler(ee){return Ut.registerUriHandler(Pe.identifier,ee)},createQuickPick(){return zt.createQuickPick(Pe)},createInputBox(){return zt.createInputBox(Pe.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(ee,re,ye){return mi.onDidChangeActiveColorTheme(ee,re,ye)},registerWebviewViewProvider(ee,re,ye){return Ci.registerWebviewViewProvider(Pe,ee,re,ye?.webviewOptions)},get activeNotebookEditor(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(ee,re,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeActiveNotebookEditor(ee,re,ye)},get visibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(ee,re,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),Qt.onDidChangeNotebookEditorSelection(ee,re,ye)},onDidChangeNotebookEditorVisibleRanges(ee,re,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),Qt.onDidChangeNotebookEditorVisibleRanges(ee,re,ye)},showNotebookDocument(ee,re){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.showNotebookDocument(ee,re)},registerExternalUriOpener(ee,re,ye){return(0,qe.checkProposedApiEnabled)(Pe,"externalUriOpener"),si.registerExternalUriOpener(Pe.identifier,ee,re,ye)},get tabGroups(){return(0,qe.checkProposedApiEnabled)(Pe,"tabs"),lt.tabGroups},getInlineCompletionItemController(ee){return(0,qe.checkProposedApiEnabled)(Pe,"inlineCompletions"),l.InlineCompletionController.get(ee)}},Ei={get rootPath(){return Ce.report("workspace.rootPath",Pe,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),dt.getPath()},set rootPath(ee){throw k.readonly()},getWorkspaceFolder(ee){return dt.getWorkspaceFolder(ee)},get workspaceFolders(){return dt.getWorkspaceFolders()},get name(){return dt.name},set name(ee){throw k.readonly()},get workspaceFile(){return dt.workspaceFile},set workspaceFile(ee){throw k.readonly()},updateWorkspaceFolders:(ee,re,...ye)=>dt.updateWorkspaceFolders(Pe,ee,re||0,...ye),onDidChangeWorkspaceFolders:function(ee,re,ye){return dt.onDidChangeWorkspace(ee,re,ye)},asRelativePath:(ee,re)=>dt.getRelativePath(ee,re),findFiles:(ee,re,ye,Ze)=>dt.findFiles(ee,re,ye,Pe.identifier,Ze),findTextInFiles:(ee,re,ye,Ze)=>{(0,qe.checkProposedApiEnabled)(Pe,"findTextInFiles");let mt,yt;return typeof re=="object"?(mt=re,yt=ye):(mt={},yt=re,Ze=ye),dt.findTextInFiles(ee,mt||{},yt,Pe.identifier,Ze)},saveAll:ee=>dt.saveAll(ee),applyEdit(ee){return ki.applyWorkspaceEdit(ee)},createFileSystemWatcher:(ee,re,ye,Ze)=>Ht.createFileSystemWatcher(dt,Pe,ee,re,ye,Ze),get textDocuments(){return wt.getAllDocumentData().map(ee=>ee.document)},set textDocuments(ee){throw k.readonly()},openTextDocument(ee){let re;const ye=ee;if(typeof ee=="string")re=Promise.resolve(C.URI.file(ee));else if(C.URI.isUri(ee))re=Promise.resolve(ee);else if(!ye||typeof ye=="object")re=wt.createDocumentData(ye);else throw new Error("illegal argument - uriOrFileNameOrOptions");return re.then(Ze=>wt.ensureDocumentData(Ze).then(mt=>mt.document))},onDidOpenTextDocument:(ee,re,ye)=>wt.onDidAddDocument(ee,re,ye),onDidCloseTextDocument:(ee,re,ye)=>wt.onDidRemoveDocument(ee,re,ye),onDidChangeTextDocument:(ee,re,ye)=>wt.onDidChangeDocument(ee,re,ye),onDidSaveTextDocument:(ee,re,ye)=>wt.onDidSaveDocument(ee,re,ye),onWillSaveTextDocument:(ee,re,ye)=>Wt.getOnWillSaveTextDocumentEvent(Pe)(ee,re,ye),get notebookDocuments(){return pt.notebookDocuments.map(ee=>ee.apiNotebook)},async openNotebookDocument(ee,re){let ye;if(C.URI.isUri(ee))ye=ee,await pt.openNotebookDocument(ee);else if(typeof ee=="string")ye=C.URI.revive(await pt.createNotebookDocument({viewType:ee,content:re}));else throw new Error("Invalid arguments");return pt.getNotebookDocument(ye).apiNotebook},onDidSaveNotebookDocument(ee,re,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookDocumentEvents"),qt.onDidSaveNotebookDocument(ee,re,ye)},onDidChangeNotebookDocument(ee,re,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookDocumentEvents"),qt.onDidChangeNotebookDocument(ee,re,ye)},get onDidOpenNotebookDocument(){return pt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return pt.onDidCloseNotebookDocument},registerNotebookSerializer(ee,re,ye,Ze){return pt.registerNotebookSerializer(Pe,ee,re,ye,(0,qe.isProposedApiEnabled)(Pe,"notebookLiveShare")?Ze:void 0)},registerNotebookContentProvider:(ee,re,ye,Ze)=>((0,qe.checkProposedApiEnabled)(Pe,"notebookContentProvider"),pt.registerNotebookContentProvider(Pe,ee,re,ye,(0,qe.isProposedApiEnabled)(Pe,"notebookLiveShare")?Ze:void 0)),onDidChangeConfiguration:(ee,re,ye)=>Ot.onDidChangeConfiguration(ee,re,ye),getConfiguration(ee,re){return re=arguments.length===1?void 0:re,Ot.getConfiguration(ee,re,Pe)},registerTextDocumentContentProvider(ee,re){return Bt.registerTextDocumentContentProvider(ee,re)},registerTaskProvider:(ee,re)=>(Ce.report("window.registerTaskProvider",Pe,"Use the corresponding function on the 'tasks' namespace instead"),ft.registerTaskProvider(Pe,ee,re)),registerFileSystemProvider(ee,re,ye){return(0,kt.combinedDisposable)(li.registerFileSystemProvider(Pe,ee,re,ye),Tt.addFileSystemProvider(ee,re))},get fs(){return Tt.value},registerFileSearchProvider:(ee,re)=>((0,qe.checkProposedApiEnabled)(Pe,"fileSearchProvider"),Mt.registerFileSearchProvider(ee,re)),registerTextSearchProvider:(ee,re)=>((0,qe.checkProposedApiEnabled)(Pe,"textSearchProvider"),Mt.registerTextSearchProvider(ee,re)),registerRemoteAuthorityResolver:(ee,re)=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),bt.registerRemoteAuthorityResolver(ee,re)),registerResourceLabelFormatter:ee=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),Si.$registerResourceLabelFormatter(ee)),onDidCreateFiles:(ee,re,ye)=>Ht.onDidCreateFile(ee,re,ye),onDidDeleteFiles:(ee,re,ye)=>Ht.onDidDeleteFile(ee,re,ye),onDidRenameFiles:(ee,re,ye)=>Ht.onDidRenameFile(ee,re,ye),onWillCreateFiles:(ee,re,ye)=>Ht.getOnWillCreateFileEvent(Pe)(ee,re,ye),onWillDeleteFiles:(ee,re,ye)=>Ht.getOnWillDeleteFileEvent(Pe)(ee,re,ye),onWillRenameFiles:(ee,re,ye)=>Ht.getOnWillRenameFileEvent(Pe)(ee,re,ye),openTunnel:ee=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),Se.openTunnel(Pe,ee).then(re=>{if(!re)throw new Error("cannot open tunnel");return re})),get tunnels(){return(0,qe.checkProposedApiEnabled)(Pe,"resolvers"),Se.getTunnels()},onDidChangeTunnels:(ee,re,ye)=>((0,qe.checkProposedApiEnabled)(Pe,"resolvers"),Se.onDidChangeTunnels(ee,re,ye)),registerPortAttributesProvider:(ee,re)=>((0,qe.checkProposedApiEnabled)(Pe,"portsAttributes"),Se.registerPortsAttributesProvider(ee,re)),registerTimelineProvider:(ee,re)=>((0,qe.checkProposedApiEnabled)(Pe,"timeline"),yi.registerTimelineProvider(ee,re,Pe.identifier,rt.converter)),get isTrusted(){return dt.trusted},requestWorkspaceTrust:ee=>((0,qe.checkProposedApiEnabled)(Pe,"workspaceTrust"),dt.requestWorkspaceTrust(ee)),onDidGrantWorkspaceTrust:(ee,re,ye)=>dt.onDidGrantWorkspaceTrust(ee,re,ye)},Mi={get inputBox(){return Ce.report("scm.inputBox",Pe,"Use 'SourceControl.inputBox' instead"),ni.getLastInputBox(Pe)},createSourceControl(ee,re,ye){return ni.createSourceControl(Pe,ee,re,ye)}},Ni={createCommentController(ee,re){return _i.createCommentController(Pe,ee,re)}},Li={get activeDebugSession(){return ot.activeDebugSession},get activeDebugConsole(){return ot.activeDebugConsole},get breakpoints(){return ot.breakpoints},onDidStartDebugSession(ee,re,ye){return ot.onDidStartDebugSession(ee,re,ye)},onDidTerminateDebugSession(ee,re,ye){return ot.onDidTerminateDebugSession(ee,re,ye)},onDidChangeActiveDebugSession(ee,re,ye){return ot.onDidChangeActiveDebugSession(ee,re,ye)},onDidReceiveDebugSessionCustomEvent(ee,re,ye){return ot.onDidReceiveDebugSessionCustomEvent(ee,re,ye)},onDidChangeBreakpoints(ee,re,ye){return ot.onDidChangeBreakpoints(ee,re,ye)},registerDebugConfigurationProvider(ee,re,ye){return ot.registerDebugConfigurationProvider(ee,re,ye||vt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(ee,re){return ot.registerDebugAdapterDescriptorFactory(Pe,ee,re)},registerDebugAdapterTrackerFactory(ee,re){return ot.registerDebugAdapterTrackerFactory(ee,re)},startDebugging(ee,re,ye){return!ye||typeof ye=="object"&&"configuration"in ye?ot.startDebugging(ee,re,{parentSession:ye}):ot.startDebugging(ee,re,ye||{})},stopDebugging(ee){return ot.stopDebugging(ee)},addBreakpoints(ee){return ot.addBreakpoints(ee)},removeBreakpoints(ee){return ot.removeBreakpoints(ee)},asDebugSourceUri(ee,re){return ot.asDebugSourceUri(ee,re)}},Ui={registerTaskProvider:(ee,re)=>ft.registerTaskProvider(Pe,ee,re),fetchTasks:ee=>ft.fetchTasks(ee),executeTask:ee=>ft.executeTask(Pe,ee),get taskExecutions(){return ft.taskExecutions},onDidStartTask:(ee,re,ye)=>ft.onDidStartTask(ee,re,ye),onDidEndTask:(ee,re,ye)=>ft.onDidEndTask(ee,re,ye),onDidStartTaskProcess:(ee,re,ye)=>ft.onDidStartTaskProcess(ee,re,ye),onDidEndTaskProcess:(ee,re,ye)=>ft.onDidEndTaskProcess(ee,re,ye)},Bi={createNotebookController(ee,re,ye,Ze,mt){return ti.createNotebookController(Pe,ee,re,ye,Ze,(0,qe.isProposedApiEnabled)(Pe,"notebookMessaging")?mt:void 0)},registerNotebookCellStatusBarItemProvider:(ee,re)=>pt.registerNotebookCellStatusBarItemProvider(Pe,ee,re),get onDidSaveNotebookDocument(){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(ee){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditorDecorationType"),Qt.createNotebookEditorDecorationType(ee)},createRendererMessaging(ee){return ai.createRendererMessaging(Pe,ee)},onDidChangeNotebookDocumentMetadata(ee,re,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),qt.onDidChangeNotebookDocumentMetadata(ee,re,ye)},onDidChangeNotebookCells(ee,re,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeNotebookCells(ee,re,ye)},onDidChangeNotebookCellExecutionState(ee,re,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookCellExecutionState"),ti.onDidChangeNotebookCellExecutionState(ee,re,ye)},onDidChangeCellOutputs(ee,re,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeCellOutputs(ee,re,ye)},onDidChangeCellMetadata(ee,re,ye){return(0,qe.checkProposedApiEnabled)(Pe,"notebookEditor"),pt.onDidChangeCellMetadata(ee,re,ye)},createConcatTextDocument(ee,re){return(0,qe.checkProposedApiEnabled)(Pe,"notebookConcatTextDocument"),new Ee.ExtHostNotebookConcatDocument(pt,wt,ee,re)}};return{version:ut.version,authentication:Pi,commands:Ai,comments:Ni,debug:Li,env:pi,extensions:Oi,languages:Fi,notebooks:Bi,scm:Mi,tasks:Ui,tests:Ri,window:ui,workspace:Ei,Breakpoint:z.Breakpoint,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,CallHierarchyItem:z.CallHierarchyItem,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CancellationError:k.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:c.CandidatePortSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTriggerKind:z.CodeActionTriggerKind,CodeLens:z.CodeLens,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,ColorThemeKind:z.ColorThemeKind,CommentMode:z.CommentMode,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentThreadState:z.CommentThreadState,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,CustomExecution:z.CustomExecution,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:z.DebugAdapterNamedPipeServer,DebugAdapterServer:z.DebugAdapterServer,DebugConfigurationProviderTriggerKind:vt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:z.DebugConsoleMode,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,InlineValueText:z.InlineValueText,InlineValueVariableLookup:z.InlineValueVariableLookup,InlineValueEvaluatableExpression:z.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:z.InlineCompletionTriggerKind,EventEmitter:w.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,ExternalUriOpenerPriority:z.ExternalUriOpenerPriority,FileChangeType:z.FileChangeType,FileDecoration:z.FileDecoration,FileSystemError:z.FileSystemError,FileType:b.FileType,FilePermission:b.FilePermission,FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,InlineCompletionItem:z.InlineSuggestion,InlineCompletionList:z.InlineSuggestions,Hover:z.Hover,IndentAction:F.IndentAction,Location:z.Location,MarkdownString:z.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:z.ParameterInformation,PortAutoForwardAction:z.PortAutoForwardAction,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,Selection:z.Selection,SelectionRange:z.SelectionRange,SemanticTokens:z.SemanticTokens,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokensEdit:z.SemanticTokensEdit,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensLegend:z.SemanticTokensLegend,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelp:z.SignatureHelp,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureInformation:z.SignatureInformation,SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,TabKind:c.TabKind,Task:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TerminalLink:z.TerminalLink,TerminalLocation:z.TerminalLocation,TerminalProfile:z.TerminalProfile,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,TextDocumentChangeReason:z.TextDocumentChangeReason,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItemCollapsibleState:z.TreeItemCollapsibleState,TypeHierarchyItem:z.TypeHierarchyItem,UIKind:g.UIKind,Uri:C.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,InlayHint:z.InlayHint,InlayHintLabelPart:z.InlayHintLabelPart,InlayHintKind:z.InlayHintKind,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,ResolvedAuthority:z.ResolvedAuthority,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,ExtensionRuntime:z.ExtensionRuntime,TimelineItem:z.TimelineItem,NotebookRange:z.NotebookRange,NotebookCellKind:z.NotebookCellKind,NotebookCellExecutionState:z.NotebookCellExecutionState,NotebookCellData:z.NotebookCellData,NotebookData:z.NotebookData,NotebookRendererScript:z.NotebookRendererScript,NotebookCellStatusBarAlignment:z.NotebookCellStatusBarAlignment,NotebookEditorRevealType:z.NotebookEditorRevealType,NotebookCellOutput:z.NotebookCellOutput,NotebookCellOutputItem:z.NotebookCellOutputItem,NotebookCellStatusBarItem:z.NotebookCellStatusBarItem,NotebookControllerAffinity:z.NotebookControllerAffinity,PortAttributes:z.PortAttributes,LinkedEditingRanges:z.LinkedEditingRanges,TestResultState:z.TestResultState,TestRunRequest:z.TestRunRequest,TestMessage:z.TestMessage,TestTag:z.TestTag,TestRunProfileKind:z.TestRunProfileKind,TextSearchCompleteMessageType:Oe.TextSearchCompleteMessageType,DataTransfer:z.DataTransfer,DataTransferItem:z.DataTransferItem,CoveredCount:z.CoveredCount,FileCoverage:z.FileCoverage,StatementCoverage:z.StatementCoverage,BranchCoverage:z.BranchCoverage,FunctionCoverage:z.FunctionCoverage,WorkspaceTrustState:z.WorkspaceTrustState,LanguageStatusSeverity:z.LanguageStatusSeverity,QuickPickItemKind:z.QuickPickItemKind}}}e.createApiFactoryAndRegisterActors=Nt}),define(we[224],be([1,0,223,33,2,217,6,13,4]),function(Z,e,o,k,w,B,C,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class F extends B.RequireInterceptor{_installInterceptor(){}getModule(s,n){for(let h of this._alternatives){let _=h(s);if(_){s=_;break}}if(this._factories.has(s))return this._factories.get(s).load(s,n,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class N extends k.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=C.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const s=this._extHostContext.getProxy(D.MainContext.MainThreadConsole);c(s,this._initData.environment.isExtensionDevelopmentDebug);const n=this._instaService.invokeFunction(o.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(F,n,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(s){return s.browser}async _loadCommonJSModule(s,n,h){n=n.with({path:b(n.path,".js")}),s&&performance.mark(`code/extHost/willFetchExtensionCode/${s.value}`);const _=w.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(n)),y=await fetch(_.toString(!0));if(s&&performance.mark(`code/extHost/didFetchExtensionCode/${s.value}`),y.status!==200)throw new Error(y.statusText);const d=await y.text(),p=`${n.toString(!0)}#vscode-extension`,E=`${d}
//# sourceURL=${p}`;let a;try{a=new Function("module","exports","require",E)}catch(u){throw console.error(s?`Loading code for extension ${s.value} failed: ${u.message}`:`Loading code failed: ${u.message}`),console.error(`${n.toString(!0)}${typeof u.line=="number"?` line ${u.line}`:""}${typeof u.column=="number"?` column ${u.column}`:""}`),console.error(u),u}const T={},r={exports:T},i=u=>{const t=this._fakeModules.getModule(u,n);if(t===void 0)throw new Error(`Cannot load module '${u}'`);return t};try{return h.codeLoadingStart(),s&&performance.mark(`code/extHost/willLoadExtensionCode/${s.value}`),a(r,T,i),r.exports!==T?r.exports:T}finally{s&&performance.mark(`code/extHost/didLoadExtensionCode/${s.value}`),h.codeLoadingStop()}}async $setRemoteEnvironment(s){}async _waitForDebuggerAttachment(s=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const n=Date.now()+s;for(;Date.now()<n&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=N;function b(g,s){return g.endsWith(s)?g:g+s}function c(g,s){n("info","log"),n("log","log"),n("warn","warn"),n("error","error");function n(y,d){const p=console[y];console[y]=function(){g.$logExtensionHostMessage({type:"__$console",severity:d,arguments:_(arguments)}),s&&p.apply(console,arguments)}}const h=1e5;function _(y){const d=[],p=[];if(y.length)for(let E=0;E<y.length;E++){if(typeof y[E]=="undefined")y[E]="undefined";else if(y[E]instanceof Error){const a=y[E];a.stack?y[E]=a.stack:y[E]=a.toString()}p.push(y[E])}try{const E=JSON.stringify(p,function(a,T){if(T&&typeof T=="object"){if(d.indexOf(T)!==-1)return"[Circular]";d.push(T)}return T});return E.length>h?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}}),define(we[225],be([1,0,55,33,68,224]),function(Z,e,o,k,w,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(k.IExtHostExtensionService,B.ExtHostExtensionService),(0,o.registerSingleton)(w.IExtensionStoragePaths,w.ExtensionStoragePaths)}),define(we[236],be([1,0,21,5,91,218,211,17,69,10,2,220,225]),function(Z,e,o,k,w,B,C,A,D,F,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const b=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const c=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function g(a){return/^(file|vscode-remote):/i.test(a)}const s=fetch.bind(self);function n(a){self.fetch=async function(T,r){return T instanceof Request||g(String(T))&&(T=(await a(N.URI.parse(String(T)))).toString(!0)),s(T,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(T,r,i,u,t){(async()=>{g(r.toString())&&(r=(await a(N.URI.parse(r.toString()))).toString(!0)),super.open(T,r,i??!0,u,t)})()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const a=self.Worker;Worker=function(T,r){if(/^file:/i.test(T.toString()))T=F.FileAccess.asBrowserUri(N.URI.parse(T.toString())).toString(!0);else if(/^vscode-remote:/i.test(T.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const u=`(${function(f){function S(L){return typeof L=="string"||L instanceof URL?String(L).replace(/^file:\/\//i,"vscode-file://vscode-app"):L}const P=fetch.bind(self);self.fetch=function(L,v){return L instanceof Request?P(L,v):P(S(L),v)},self.XMLHttpRequest=class extends XMLHttpRequest{open(L,v,H,W,q){return super.open(L,S(v),H??!0,W,q)}};const $=importScripts.bind(self);self.importScripts=(...L)=>{$(...L.map(S))},$(f)}.toString()}('${T}'))`;r=r||{},r.name=r.name||A.basename(T.toString());const t=new Blob([u],{type:"application/javascript"}),l=URL.createObjectURL(t);return new a(l,r)}}else self.Worker=class extends C.NestedWorker{constructor(a,T){super(c,a,{name:A.basename(a.toString()),...T})}};const h=new class{constructor(){this.pid=void 0}exit(a){b()}async exists(a){return!0}async realpath(a){return a}};class _{constructor(){const T=new MessageChannel,r=new k.Emitter;let i=!1;c(T.port2,[T.port2]),T.port1.onmessage=u=>{const{data:t}=u;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const l=o.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,w.isMessageOfType)(l,2)){i=!0,d("received terminate message from renderer");return}r.fire(l)},this.protocol={onMessage:r.event,send:u=>{if(!i){const t=u.buffer.buffer.slice(u.buffer.byteOffset,u.buffer.byteOffset+u.buffer.byteLength);T.port1.postMessage(t,[t])}}}}}function y(a){return new Promise(T=>{const r=a.onMessage(i=>{r.dispose();const u=JSON.parse(i.toString());a.send((0,w.createMessageOfType)(0)),T({protocol:a,initData:u})});a.send((0,w.createMessageOfType)(1))})}let d=a=>b();function p(a){return!!a&&typeof a=="object"&&a.type==="vscode.init"&&a.data instanceof Map}function E(){D.mark("code/extHost/willConnectToRenderer");const a=new _;return{onmessage(T){!p(T)||y(a.protocol).then(r=>{D.mark("code/extHost/didWaitForInitData");const i=new B.ExtensionHostMain(r.protocol,r.initData,h,null,T.data);n(u=>i.asBrowserUri(u)),d=u=>i.terminate(u)})}}}e.create=E})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/b056e68d8ddb4036ac8453a67c63f559589850fc/core/vs/workbench/api/worker/extensionHostWorker.js.map
